#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 3193
#define SYMBOL_COUNT 137
#define ALIAS_COUNT 5
#define TOKEN_COUNT 87
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_while = 12,
  anon_sym_do = 13,
  anon_sym_done = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_fi = 17,
  anon_sym_elif = 18,
  anon_sym_else = 19,
  anon_sym_case = 20,
  anon_sym_esac = 21,
  anon_sym_PIPE = 22,
  anon_sym_RPAREN = 23,
  anon_sym_SEMI_SEMI = 24,
  anon_sym_function = 25,
  anon_sym_LPAREN = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym_PIPE_AMP = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_EQ_TILDE = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_LBRACK = 34,
  anon_sym_RBRACK = 35,
  anon_sym_LBRACK_LBRACK = 36,
  anon_sym_RBRACK_RBRACK = 37,
  anon_sym_declare = 38,
  anon_sym_typeset = 39,
  anon_sym_export = 40,
  anon_sym_readonly = 41,
  anon_sym_local = 42,
  anon_sym_unset = 43,
  anon_sym_unsetenv = 44,
  anon_sym_EQ = 45,
  anon_sym_PLUS_EQ = 46,
  anon_sym_LT = 47,
  anon_sym_GT = 48,
  anon_sym_GT_GT = 49,
  anon_sym_AMP_GT = 50,
  anon_sym_AMP_GT_GT = 51,
  anon_sym_LT_AMP = 52,
  anon_sym_GT_AMP = 53,
  anon_sym_LT_LT = 54,
  anon_sym_LT_LT_DASH = 55,
  anon_sym_LT_LT_LT = 56,
  sym__special_characters = 57,
  anon_sym_DQUOTE = 58,
  anon_sym_DOLLAR = 59,
  sym__string_content = 60,
  sym_raw_string = 61,
  anon_sym_POUND = 62,
  anon_sym_DOLLAR_LBRACE = 63,
  aux_sym_SLASH = 64,
  anon_sym_COLON = 65,
  anon_sym_COLON_QMARK = 66,
  anon_sym_COLON_DASH = 67,
  anon_sym_PERCENT = 68,
  anon_sym_DASH = 69,
  anon_sym_DOLLAR_LPAREN = 70,
  anon_sym_BQUOTE = 71,
  anon_sym_LT_LPAREN = 72,
  anon_sym_GT_LPAREN = 73,
  sym_comment = 74,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 75,
  anon_sym_STAR = 76,
  anon_sym_AT = 77,
  anon_sym_QMARK = 78,
  anon_sym_0 = 79,
  anon_sym__ = 80,
  sym_word = 81,
  sym_regex = 82,
  sym_regex_without_right_brace = 83,
  anon_sym_SEMI = 84,
  anon_sym_LF = 85,
  anon_sym_AMP = 86,
  sym_program = 87,
  sym__terminated_statement = 88,
  sym_for_statement = 89,
  sym_while_statement = 90,
  sym_do_group = 91,
  sym_if_statement = 92,
  sym_elif_clause = 93,
  sym_else_clause = 94,
  sym_case_statement = 95,
  sym_case_item = 96,
  sym_last_case_item = 97,
  sym_function_definition = 98,
  sym_compound_statement = 99,
  sym_subshell = 100,
  sym_pipeline = 101,
  sym_list = 102,
  sym_command = 103,
  sym_command_name = 104,
  sym_bracket_command = 105,
  sym_variable_assignment = 106,
  sym_declaration_command = 107,
  sym_unset_command = 108,
  sym__assignment = 109,
  sym_subscript = 110,
  sym_file_redirect = 111,
  sym_heredoc_redirect = 112,
  sym_heredoc_body = 113,
  sym_herestring_redirect = 114,
  sym_concatenation = 115,
  sym_string = 116,
  sym_array = 117,
  sym_simple_expansion = 118,
  sym_string_expansion = 119,
  sym_expansion = 120,
  sym_command_substitution = 121,
  sym_process_substitution = 122,
  aux_sym_program_repeat1 = 123,
  aux_sym_for_statement_repeat1 = 124,
  aux_sym_while_statement_repeat1 = 125,
  aux_sym_if_statement_repeat1 = 126,
  aux_sym_case_statement_repeat1 = 127,
  aux_sym_case_item_repeat1 = 128,
  aux_sym_command_repeat1 = 129,
  aux_sym_command_repeat2 = 130,
  aux_sym_declaration_command_repeat1 = 131,
  aux_sym_unset_command_repeat1 = 132,
  aux_sym_heredoc_body_repeat1 = 133,
  aux_sym_concatenation_repeat1 = 134,
  aux_sym_string_repeat1 = 135,
  aux_sym_expansion_repeat1 = 136,
  alias_sym_case_item = 137,
  alias_sym_regex = 138,
  alias_sym_special_variable_name = 139,
  alias_sym_variable_name = 140,
  alias_sym_word = 141,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [aux_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [sym_regex] = "regex",
  [sym_regex_without_right_brace] = "regex_without_right_brace",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_bracket_command] = "bracket_command",
  [sym_variable_assignment] = "variable_assignment",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym__assignment] = "_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_regex] = "regex",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_without_right_brace] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regex] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[23][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_special_variable_name,
    [3] = alias_sym_regex,
  },
  [11] = {
    [1] = alias_sym_variable_name,
    [3] = alias_sym_regex,
  },
  [12] = {
    [3] = alias_sym_regex,
  },
  [13] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [14] = {
    [4] = alias_sym_case_item,
  },
  [15] = {
    [4] = alias_sym_word,
  },
  [16] = {
    [2] = alias_sym_special_variable_name,
    [4] = alias_sym_regex,
  },
  [17] = {
    [2] = alias_sym_variable_name,
    [4] = alias_sym_regex,
  },
  [18] = {
    [4] = alias_sym_regex,
  },
  [19] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [20] = {
    [5] = alias_sym_case_item,
  },
  [21] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [22] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(21);
      if (lookahead == ':')
        ADVANCE(23);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        SKIP(45);
      if (lookahead == ']')
        ADVANCE(46);
      if (lookahead == '_')
        ADVANCE(48);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(50);
      if (lookahead == 'd')
        ADVANCE(54);
      if (lookahead == 'e')
        ADVANCE(64);
      if (lookahead == 'f')
        ADVANCE(78);
      if (lookahead == 'i')
        ADVANCE(89);
      if (lookahead == 'l')
        ADVANCE(92);
      if (lookahead == 'r')
        ADVANCE(97);
      if (lookahead == 't')
        ADVANCE(105);
      if (lookahead == 'u')
        ADVANCE(115);
      if (lookahead == 'w')
        ADVANCE(123);
      if (lookahead == '{')
        ADVANCE(128);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(5);
      if (lookahead == '{')
        ADVANCE(6);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '>')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 12:
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead != 0)
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 17:
      if (lookahead == '=')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym_SLASH);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(24);
      if (lookahead == '?')
        ADVANCE(25);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(29);
      if (lookahead == '(')
        ADVANCE(30);
      if (lookahead == '<')
        ADVANCE(31);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(38);
      if (lookahead == '(')
        ADVANCE(39);
      if (lookahead == '>')
        ADVANCE(40);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 45:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'o')
        ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_declare);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_done);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(65);
      if (lookahead == 's')
        ADVANCE(70);
      if (lookahead == 'x')
        ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(66);
      if (lookahead == 's')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'f')
        ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'p')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_export);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(79);
      if (lookahead == 'o')
        ADVANCE(80);
      if (lookahead == 'u')
        ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_fi);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'f')
        ADVANCE(90);
      if (lookahead == 'n')
        ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_local);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'd')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'y')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'h')
        ADVANCE(106);
      if (lookahead == 'y')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_then);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'p')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'v')
        ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'h')
        ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(130);
      if (lookahead == '|')
        ADVANCE(131);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 133:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(133);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(134);
      END_STATE();
    case 135:
      if (lookahead == '>')
        ADVANCE(10);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(29);
      if (lookahead == '(')
        ADVANCE(30);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(133);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 139:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(143);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'c')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'l')
        ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'r')
        ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'x')
        ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'p')
        ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'r')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(159);
      if (lookahead == 'u')
        ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'r')
        ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'c')
        ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'f')
        ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'c')
        ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'l')
        ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'd')
        ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'o')
        ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'l')
        ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'y')
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'y')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'p')
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'v')
        ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'h')
        ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'l')
        ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 203:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '+')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(205);
      if (lookahead == '[')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == ']')
        ADVANCE(208);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'd')
        ADVANCE(209);
      if (lookahead == 'e')
        ADVANCE(211);
      if (lookahead == 'f')
        ADVANCE(220);
      if (lookahead == 'i')
        ADVANCE(222);
      if (lookahead == 't')
        ADVANCE(224);
      if (lookahead == '{')
        ADVANCE(128);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      END_STATE();
    case 204:
      if (lookahead == '&')
        ADVANCE(9);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(203);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 209:
      if (lookahead == 'o')
        ADVANCE(210);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 211:
      if (lookahead == 'l')
        ADVANCE(212);
      if (lookahead == 's')
        ADVANCE(217);
      END_STATE();
    case 212:
      if (lookahead == 'i')
        ADVANCE(213);
      if (lookahead == 's')
        ADVANCE(215);
      END_STATE();
    case 213:
      if (lookahead == 'f')
        ADVANCE(214);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 215:
      if (lookahead == 'e')
        ADVANCE(216);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 217:
      if (lookahead == 'a')
        ADVANCE(218);
      END_STATE();
    case 218:
      if (lookahead == 'c')
        ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 220:
      if (lookahead == 'i')
        ADVANCE(221);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 222:
      if (lookahead == 'n')
        ADVANCE(223);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 224:
      if (lookahead == 'h')
        ADVANCE(225);
      END_STATE();
    case 225:
      if (lookahead == 'e')
        ADVANCE(226);
      END_STATE();
    case 226:
      if (lookahead == 'n')
        ADVANCE(227);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 228:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '\\')
        SKIP(229);
      if (lookahead == '|')
        ADVANCE(230);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        SKIP(228);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 231:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(232);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        SKIP(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 233:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 234:
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '>')
        ADVANCE(10);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(236);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == '~')
        ADVANCE(237);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(138);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(233);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(244);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(9);
      END_STATE();
    case 242:
      if (lookahead == '(')
        ADVANCE(30);
      END_STATE();
    case 243:
      if (lookahead == '(')
        ADVANCE(39);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(239);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(247);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(246);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 248:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(249);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(254);
      if (lookahead != 0)
        ADVANCE(250);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(250);
      if (lookahead == '\\')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(249);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(251);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(250);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(250);
      if (lookahead == '\\')
        ADVANCE(251);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(250);
      if (lookahead != 0)
        ADVANCE(250);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(250);
      if (lookahead == '\\')
        ADVANCE(252);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(249);
      if (lookahead != 0)
        ADVANCE(249);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(254);
      if (lookahead == '\\')
        ADVANCE(251);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(250);
      if (lookahead != 0)
        ADVANCE(250);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(249);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(254);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(250);
      END_STATE();
    case 255:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(256);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '0')
        ADVANCE(21);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(257);
      if (lookahead == '_')
        ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 258:
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(256);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '0')
        ADVANCE(21);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '_')
        ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 259:
      if (lookahead == '\n')
        SKIP(258);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(261);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        SKIP(260);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(263);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(262);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(265);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(264);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 266:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(267);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 268:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(271);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(272);
      if (lookahead == 'i')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 272:
      if (lookahead == '\n')
        SKIP(270);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(274);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 274:
      if (lookahead == '\n')
        SKIP(273);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(276);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (lookahead != 0)
        ADVANCE(138);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        SKIP(275);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 277:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(278);
      if (lookahead == '$')
        ADVANCE(280);
      if (lookahead == '\'')
        ADVANCE(285);
      if (lookahead == '<')
        ADVANCE(288);
      if (lookahead == '>')
        ADVANCE(290);
      if (lookahead == '[')
        ADVANCE(292);
      if (lookahead == '\\')
        ADVANCE(293);
      if (lookahead == ']')
        ADVANCE(292);
      if (lookahead == '`')
        ADVANCE(296);
      if (lookahead == '{')
        ADVANCE(292);
      if (lookahead == '}')
        ADVANCE(292);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(283);
      if (lookahead != 0)
        ADVANCE(295);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(279);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(278);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(279);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(278);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(278);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(281);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == '{')
        ADVANCE(284);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(283);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\'')
        ADVANCE(286);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(12);
      if (lookahead != 0)
        ADVANCE(285);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\n')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(286);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(285);
      if (lookahead != 0)
        ADVANCE(285);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(289);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(291);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '[')
        ADVANCE(292);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(292);
      if (lookahead == '{')
        ADVANCE(292);
      if (lookahead == '}')
        ADVANCE(292);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(294);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(295);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(283);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(293);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(295);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(283);
      END_STATE();
    case 297:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(298);
      if (lookahead == ']')
        ADVANCE(208);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(297);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 298:
      if (lookahead == '\n')
        SKIP(297);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 299:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(300);
      if (lookahead == ']')
        ADVANCE(301);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(299);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        SKIP(299);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == ']')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      END_STATE();
    case 302:
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(256);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '0')
        ADVANCE(303);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(305);
      if (lookahead == '_')
        ADVANCE(307);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(306);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(304);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(250);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(304);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(304);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(306);
      if (lookahead == '\\')
        ADVANCE(251);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(250);
      if (lookahead != 0)
        ADVANCE(250);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '0')
        ADVANCE(303);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(305);
      if (lookahead == '_')
        ADVANCE(307);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(306);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(304);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(250);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(304);
      END_STATE();
    case 308:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(309);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(310);
      if (lookahead == '/')
        ADVANCE(20);
      if (lookahead == ':')
        ADVANCE(311);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '=')
        ADVANCE(314);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(315);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(312);
      if (lookahead == '?')
        ADVANCE(313);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 315:
      if (lookahead == '\n')
        SKIP(308);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 316:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(256);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '0')
        ADVANCE(21);
      if (lookahead == '?')
        ADVANCE(41);
      if (lookahead == '@')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(317);
      if (lookahead == '_')
        ADVANCE(48);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(316);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(22);
      END_STATE();
    case 317:
      if (lookahead == '\n')
        SKIP(316);
      END_STATE();
    case 318:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        SKIP(318);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 320:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(321);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0 &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 321:
      if (lookahead == '\n')
        SKIP(320);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 322:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(323);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 323:
      if (lookahead == '\n')
        SKIP(322);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 324:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(325);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 325:
      if (lookahead == '\n')
        SKIP(324);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 326:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(327);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 327:
      if (lookahead == '\n')
        SKIP(326);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 328:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(329);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 329:
      if (lookahead == '\n')
        SKIP(328);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 330:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(331);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 331:
      if (lookahead == '\n')
        SKIP(330);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 332:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(333);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(334);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 333:
      if (lookahead == ';')
        ADVANCE(27);
      END_STATE();
    case 334:
      if (lookahead == '\n')
        SKIP(332);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 335:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      END_STATE();
    case 336:
      if (lookahead == '\n')
        SKIP(335);
      END_STATE();
    case 337:
      if (lookahead == 's')
        ADVANCE(217);
      END_STATE();
    case 338:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(339);
      if (lookahead == '\\')
        SKIP(340);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(338);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(6);
      END_STATE();
    case 340:
      if (lookahead == '\n')
        SKIP(338);
      END_STATE();
    case 341:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '\\')
        SKIP(342);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(341);
      END_STATE();
    case 342:
      if (lookahead == '\n')
        SKIP(341);
      END_STATE();
    case 343:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(346);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(40);
      END_STATE();
    case 346:
      if (lookahead == '\n')
        SKIP(343);
      END_STATE();
    case 347:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == ']')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(347);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        SKIP(347);
      END_STATE();
    case 349:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(350);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(351);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 350:
      if (lookahead == '\n')
        SKIP(349);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == 'o')
        ADVANCE(352);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'n')
        ADVANCE(353);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 355:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(356);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(357);
      if (lookahead == 'f')
        ADVANCE(363);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 356:
      if (lookahead == '\n')
        SKIP(355);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'l')
        ADVANCE(358);
      if (lookahead == 'x')
        ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(359);
      if (lookahead == 's')
        ADVANCE(361);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'f')
        ADVANCE(360);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'e')
        ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(364);
      if (lookahead == 'o')
        ADVANCE(159);
      if (lookahead == 'u')
        ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 365:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 366:
      if (lookahead == '\n')
        SKIP(365);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 367:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(369);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(29);
      END_STATE();
    case 369:
      if (lookahead == '\n')
        SKIP(367);
      END_STATE();
    case 370:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(371);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 371:
      if (lookahead == '\n')
        SKIP(370);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 372:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(373);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      END_STATE();
    case 373:
      if (lookahead == '\n')
        SKIP(372);
      END_STATE();
    case 374:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(375);
      if (lookahead == ']')
        ADVANCE(301);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(230);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 375:
      if (lookahead == '\n')
        SKIP(374);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 376:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(377);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(376);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 377:
      if (lookahead == '\n')
        SKIP(376);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 378:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(309);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(310);
      if (lookahead == ':')
        ADVANCE(311);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '=')
        ADVANCE(314);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(379);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 379:
      if (lookahead == '\n')
        SKIP(378);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 380:
      if (lookahead == '#')
        ADVANCE(381);
      if (lookahead == '\\')
        ADVANCE(383);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '}')
        ADVANCE(384);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(382);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(381);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(382);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(381);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(381);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(383);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(384);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(384);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(383);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(384);
      END_STATE();
    case 385:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(386);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(385);
      END_STATE();
    case 386:
      if (lookahead == '\n')
        SKIP(385);
      END_STATE();
    case 387:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(388);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(387);
      END_STATE();
    case 388:
      if (lookahead == '\n')
        SKIP(387);
      END_STATE();
    case 389:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(390);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(389);
      END_STATE();
    case 390:
      if (lookahead == '\n')
        SKIP(389);
      END_STATE();
    case 391:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(392);
      if (lookahead == ']')
        ADVANCE(208);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(391);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 392:
      if (lookahead == '\n')
        SKIP(391);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 393:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '+')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(205);
      if (lookahead == '\\')
        SKIP(394);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      END_STATE();
    case 394:
      if (lookahead == '\n')
        SKIP(393);
      END_STATE();
    case 395:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(396);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(395);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 396:
      if (lookahead == '\n')
        SKIP(395);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 397:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(271);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(398);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(397);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 398:
      if (lookahead == '\n')
        SKIP(397);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 399:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(400);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead == 'f')
        ADVANCE(363);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 400:
      if (lookahead == '\n')
        SKIP(399);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 401:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(402);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'e')
        ADVANCE(403);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(401);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 402:
      if (lookahead == '\n')
        SKIP(401);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(404);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(405);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'c')
        ADVANCE(406);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 407:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(408);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      END_STATE();
    case 408:
      if (lookahead == '\n')
        SKIP(407);
      END_STATE();
    case 409:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(410);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(409);
      END_STATE();
    case 410:
      if (lookahead == '\n')
        SKIP(409);
      END_STATE();
    case 411:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '}')
        ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(411);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        SKIP(411);
      END_STATE();
    case 413:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(414);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      END_STATE();
    case 414:
      if (lookahead == '\n')
        SKIP(413);
      END_STATE();
    case 415:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(416);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(415);
      END_STATE();
    case 416:
      if (lookahead == '\n')
        SKIP(415);
      END_STATE();
    case 417:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(418);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(417);
      END_STATE();
    case 418:
      if (lookahead == '\n')
        SKIP(417);
      END_STATE();
    case 419:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '\\')
        SKIP(420);
      if (lookahead == '|')
        ADVANCE(230);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(419);
      END_STATE();
    case 420:
      if (lookahead == '\n')
        SKIP(419);
      END_STATE();
    case 421:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(421);
      END_STATE();
    case 422:
      if (lookahead == '\n')
        SKIP(421);
      END_STATE();
    case 423:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(234);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(424);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      END_STATE();
    case 424:
      if (lookahead == '\n')
        SKIP(423);
      END_STATE();
    case 425:
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(333);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(43);
      if (lookahead == '\\')
        ADVANCE(426);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'c')
        ADVANCE(141);
      if (lookahead == 'd')
        ADVANCE(145);
      if (lookahead == 'e')
        ADVANCE(427);
      if (lookahead == 'f')
        ADVANCE(158);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead == 'r')
        ADVANCE(175);
      if (lookahead == 't')
        ADVANCE(183);
      if (lookahead == 'u')
        ADVANCE(190);
      if (lookahead == 'w')
        ADVANCE(198);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(425);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 426:
      if (lookahead == '\n')
        SKIP(425);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(404);
      if (lookahead == 'x')
        ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 428:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(429);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      END_STATE();
    case 429:
      if (lookahead == '\n')
        SKIP(428);
      END_STATE();
    case 430:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(430);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(430);
      END_STATE();
    case 432:
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(433);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      END_STATE();
    case 433:
      if (lookahead == '\n')
        SKIP(432);
      END_STATE();
    case 434:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(242);
      if (lookahead == '>')
        ADVANCE(243);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(435);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'e')
        ADVANCE(436);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(434);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 435:
      if (lookahead == '\n')
        SKIP(434);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 's')
        ADVANCE(437);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'a')
        ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == 'c')
        ADVANCE(439);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 440:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(441);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'e')
        ADVANCE(403);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 441:
      if (lookahead == '\n')
        SKIP(440);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 442:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(28);
      if (lookahead == '=')
        ADVANCE(235);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(443);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'e')
        ADVANCE(403);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(442);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 443:
      if (lookahead == '\n')
        SKIP(442);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 444:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '\"')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(37);
      if (lookahead == '[')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(445);
      if (lookahead == ']')
        ADVANCE(140);
      if (lookahead == '`')
        ADVANCE(49);
      if (lookahead == 'e')
        ADVANCE(403);
      if (lookahead == '{')
        ADVANCE(140);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '}')
        ADVANCE(140);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(444);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 445:
      if (lookahead == '\n')
        SKIP(444);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 446:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(344);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(447);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      END_STATE();
    case 447:
      if (lookahead == '\n')
        SKIP(446);
      END_STATE();
    case 448:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(368);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\\')
        SKIP(449);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(448);
      END_STATE();
    case 449:
      if (lookahead == '\n')
        SKIP(448);
      END_STATE();
    case 450:
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead == '#')
        ADVANCE(134);
      if (lookahead == '&')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(26);
      if (lookahead == '\\')
        SKIP(451);
      if (lookahead == 'e')
        ADVANCE(337);
      if (lookahead == '|')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(450);
      END_STATE();
    case 451:
      if (lookahead == '\n')
        SKIP(450);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 133, .external_lex_state = 2},
  [2] = {.lex_state = 133},
  [3] = {.lex_state = 203},
  [4] = {.lex_state = 228},
  [5] = {.lex_state = 133, .external_lex_state = 2},
  [6] = {.lex_state = 133, .external_lex_state = 2},
  [7] = {.lex_state = 231},
  [8] = {.lex_state = 231},
  [9] = {.lex_state = 133, .external_lex_state = 2},
  [10] = {.lex_state = 233},
  [11] = {.lex_state = 233},
  [12] = {.lex_state = 239, .external_lex_state = 3},
  [13] = {.lex_state = 239, .external_lex_state = 4},
  [14] = {.lex_state = 231},
  [15] = {.lex_state = 246, .external_lex_state = 5},
  [16] = {.lex_state = 248},
  [17] = {.lex_state = 255},
  [18] = {.lex_state = 246, .external_lex_state = 5},
  [19] = {.lex_state = 258, .external_lex_state = 6},
  [20] = {.lex_state = 133, .external_lex_state = 2},
  [21] = {.lex_state = 133, .external_lex_state = 2},
  [22] = {.lex_state = 133, .external_lex_state = 2},
  [23] = {.lex_state = 260, .external_lex_state = 5},
  [24] = {.lex_state = 133},
  [25] = {.lex_state = 239, .external_lex_state = 4},
  [26] = {.lex_state = 246, .external_lex_state = 7},
  [27] = {.lex_state = 262, .external_lex_state = 8},
  [28] = {.lex_state = 203},
  [29] = {.lex_state = 264, .external_lex_state = 7},
  [30] = {.lex_state = 133, .external_lex_state = 2},
  [31] = {.lex_state = 231, .external_lex_state = 2},
  [32] = {.lex_state = 231},
  [33] = {.lex_state = 231},
  [34] = {.lex_state = 266, .external_lex_state = 9},
  [35] = {.lex_state = 268, .external_lex_state = 8},
  [36] = {.lex_state = 270, .external_lex_state = 4},
  [37] = {.lex_state = 203},
  [38] = {.lex_state = 239, .external_lex_state = 4},
  [39] = {.lex_state = 262, .external_lex_state = 8},
  [40] = {.lex_state = 203},
  [41] = {.lex_state = 270, .external_lex_state = 10},
  [42] = {.lex_state = 248},
  [43] = {.lex_state = 255},
  [44] = {.lex_state = 270, .external_lex_state = 10},
  [45] = {.lex_state = 258, .external_lex_state = 6},
  [46] = {.lex_state = 133, .external_lex_state = 2},
  [47] = {.lex_state = 133, .external_lex_state = 2},
  [48] = {.lex_state = 133, .external_lex_state = 2},
  [49] = {.lex_state = 270, .external_lex_state = 4},
  [50] = {.lex_state = 203},
  [51] = {.lex_state = 203},
  [52] = {.lex_state = 133, .external_lex_state = 2},
  [53] = {.lex_state = 231},
  [54] = {.lex_state = 233},
  [55] = {.lex_state = 233},
  [56] = {.lex_state = 273, .external_lex_state = 3},
  [57] = {.lex_state = 273, .external_lex_state = 4},
  [58] = {.lex_state = 264, .external_lex_state = 5},
  [59] = {.lex_state = 264, .external_lex_state = 5},
  [60] = {.lex_state = 275, .external_lex_state = 5},
  [61] = {.lex_state = 273, .external_lex_state = 4},
  [62] = {.lex_state = 264, .external_lex_state = 7},
  [63] = {.lex_state = 268, .external_lex_state = 8},
  [64] = {.lex_state = 203},
  [65] = {.lex_state = 133, .external_lex_state = 2},
  [66] = {.lex_state = 231, .external_lex_state = 2},
  [67] = {.lex_state = 277},
  [68] = {.lex_state = 297, .external_lex_state = 11},
  [69] = {.lex_state = 248},
  [70] = {.lex_state = 255},
  [71] = {.lex_state = 297, .external_lex_state = 11},
  [72] = {.lex_state = 258, .external_lex_state = 6},
  [73] = {.lex_state = 133, .external_lex_state = 2},
  [74] = {.lex_state = 133, .external_lex_state = 2},
  [75] = {.lex_state = 133, .external_lex_state = 2},
  [76] = {.lex_state = 297, .external_lex_state = 12},
  [77] = {.lex_state = 297, .external_lex_state = 12},
  [78] = {.lex_state = 277},
  [79] = {.lex_state = 299, .external_lex_state = 13},
  [80] = {.lex_state = 248},
  [81] = {.lex_state = 255},
  [82] = {.lex_state = 299, .external_lex_state = 13},
  [83] = {.lex_state = 258, .external_lex_state = 6},
  [84] = {.lex_state = 133, .external_lex_state = 2},
  [85] = {.lex_state = 133, .external_lex_state = 2},
  [86] = {.lex_state = 133, .external_lex_state = 2},
  [87] = {.lex_state = 299},
  [88] = {.lex_state = 299},
  [89] = {.lex_state = 203},
  [90] = {.lex_state = 239, .external_lex_state = 14},
  [91] = {.lex_state = 248},
  [92] = {.lex_state = 255},
  [93] = {.lex_state = 239, .external_lex_state = 14},
  [94] = {.lex_state = 258, .external_lex_state = 6},
  [95] = {.lex_state = 133, .external_lex_state = 2},
  [96] = {.lex_state = 133, .external_lex_state = 2},
  [97] = {.lex_state = 133, .external_lex_state = 2},
  [98] = {.lex_state = 273, .external_lex_state = 3},
  [99] = {.lex_state = 203},
  [100] = {.lex_state = 239, .external_lex_state = 3},
  [101] = {.lex_state = 239, .external_lex_state = 10},
  [102] = {.lex_state = 248},
  [103] = {.lex_state = 255},
  [104] = {.lex_state = 239, .external_lex_state = 10},
  [105] = {.lex_state = 258, .external_lex_state = 6},
  [106] = {.lex_state = 133, .external_lex_state = 2},
  [107] = {.lex_state = 133, .external_lex_state = 2},
  [108] = {.lex_state = 133, .external_lex_state = 2},
  [109] = {.lex_state = 273, .external_lex_state = 4},
  [110] = {.lex_state = 239, .external_lex_state = 4},
  [111] = {.lex_state = 231, .external_lex_state = 15},
  [112] = {.lex_state = 248},
  [113] = {.lex_state = 255},
  [114] = {.lex_state = 231, .external_lex_state = 15},
  [115] = {.lex_state = 258, .external_lex_state = 6},
  [116] = {.lex_state = 133, .external_lex_state = 2},
  [117] = {.lex_state = 133, .external_lex_state = 2},
  [118] = {.lex_state = 133, .external_lex_state = 2},
  [119] = {.lex_state = 231, .external_lex_state = 2},
  [120] = {.lex_state = 231},
  [121] = {.lex_state = 246, .external_lex_state = 5},
  [122] = {.lex_state = 264, .external_lex_state = 5},
  [123] = {.lex_state = 302},
  [124] = {.lex_state = 248, .external_lex_state = 13},
  [125] = {.lex_state = 258, .external_lex_state = 6},
  [126] = {.lex_state = 133, .external_lex_state = 2},
  [127] = {.lex_state = 133, .external_lex_state = 2},
  [128] = {.lex_state = 248},
  [129] = {.lex_state = 264, .external_lex_state = 5},
  [130] = {.lex_state = 264, .external_lex_state = 5},
  [131] = {.lex_state = 264, .external_lex_state = 5},
  [132] = {.lex_state = 203},
  [133] = {.lex_state = 308, .external_lex_state = 16},
  [134] = {.lex_state = 316, .external_lex_state = 6},
  [135] = {.lex_state = 308, .external_lex_state = 16},
  [136] = {.lex_state = 308, .external_lex_state = 16},
  [137] = {.lex_state = 203},
  [138] = {.lex_state = 228},
  [139] = {.lex_state = 133, .external_lex_state = 2},
  [140] = {.lex_state = 133, .external_lex_state = 2},
  [141] = {.lex_state = 231},
  [142] = {.lex_state = 231},
  [143] = {.lex_state = 133, .external_lex_state = 2},
  [144] = {.lex_state = 233},
  [145] = {.lex_state = 233},
  [146] = {.lex_state = 318, .external_lex_state = 6},
  [147] = {.lex_state = 318},
  [148] = {.lex_state = 233, .external_lex_state = 17},
  [149] = {.lex_state = 248},
  [150] = {.lex_state = 255},
  [151] = {.lex_state = 233, .external_lex_state = 17},
  [152] = {.lex_state = 258, .external_lex_state = 6},
  [153] = {.lex_state = 133, .external_lex_state = 2},
  [154] = {.lex_state = 133, .external_lex_state = 2},
  [155] = {.lex_state = 133, .external_lex_state = 2},
  [156] = {.lex_state = 320, .external_lex_state = 17},
  [157] = {.lex_state = 203},
  [158] = {.lex_state = 233, .external_lex_state = 18},
  [159] = {.lex_state = 322, .external_lex_state = 2},
  [160] = {.lex_state = 203},
  [161] = {.lex_state = 233, .external_lex_state = 18},
  [162] = {.lex_state = 231, .external_lex_state = 2},
  [163] = {.lex_state = 203},
  [164] = {.lex_state = 133, .external_lex_state = 2},
  [165] = {.lex_state = 231},
  [166] = {.lex_state = 233},
  [167] = {.lex_state = 233},
  [168] = {.lex_state = 324, .external_lex_state = 6},
  [169] = {.lex_state = 318},
  [170] = {.lex_state = 326, .external_lex_state = 17},
  [171] = {.lex_state = 326, .external_lex_state = 17},
  [172] = {.lex_state = 328, .external_lex_state = 17},
  [173] = {.lex_state = 203},
  [174] = {.lex_state = 326, .external_lex_state = 18},
  [175] = {.lex_state = 330, .external_lex_state = 2},
  [176] = {.lex_state = 203},
  [177] = {.lex_state = 231, .external_lex_state = 2},
  [178] = {.lex_state = 203},
  [179] = {.lex_state = 322, .external_lex_state = 2},
  [180] = {.lex_state = 203},
  [181] = {.lex_state = 133, .external_lex_state = 2},
  [182] = {.lex_state = 332, .external_lex_state = 2},
  [183] = {.lex_state = 133, .external_lex_state = 2},
  [184] = {.lex_state = 335, .external_lex_state = 4},
  [185] = {.lex_state = 338, .external_lex_state = 19},
  [186] = {.lex_state = 133},
  [187] = {.lex_state = 277},
  [188] = {.lex_state = 231},
  [189] = {.lex_state = 341, .external_lex_state = 20},
  [190] = {.lex_state = 231},
  [191] = {.lex_state = 246, .external_lex_state = 5},
  [192] = {.lex_state = 246, .external_lex_state = 5},
  [193] = {.lex_state = 335, .external_lex_state = 4},
  [194] = {.lex_state = 264, .external_lex_state = 7},
  [195] = {.lex_state = 343, .external_lex_state = 7},
  [196] = {.lex_state = 246, .external_lex_state = 7},
  [197] = {.lex_state = 133, .external_lex_state = 2},
  [198] = {.lex_state = 203},
  [199] = {.lex_state = 246, .external_lex_state = 7},
  [200] = {.lex_state = 203},
  [201] = {.lex_state = 231, .external_lex_state = 2},
  [202] = {.lex_state = 231, .external_lex_state = 15},
  [203] = {.lex_state = 231, .external_lex_state = 15},
  [204] = {.lex_state = 231, .external_lex_state = 2},
  [205] = {.lex_state = 347, .external_lex_state = 11},
  [206] = {.lex_state = 347, .external_lex_state = 11},
  [207] = {.lex_state = 347, .external_lex_state = 11},
  [208] = {.lex_state = 268, .external_lex_state = 8},
  [209] = {.lex_state = 322},
  [210] = {.lex_state = 262, .external_lex_state = 21},
  [211] = {.lex_state = 248},
  [212] = {.lex_state = 255},
  [213] = {.lex_state = 262, .external_lex_state = 21},
  [214] = {.lex_state = 258, .external_lex_state = 6},
  [215] = {.lex_state = 133, .external_lex_state = 2},
  [216] = {.lex_state = 133, .external_lex_state = 2},
  [217] = {.lex_state = 133, .external_lex_state = 2},
  [218] = {.lex_state = 231},
  [219] = {.lex_state = 203},
  [220] = {.lex_state = 349, .external_lex_state = 2},
  [221] = {.lex_state = 343, .external_lex_state = 7},
  [222] = {.lex_state = 203},
  [223] = {.lex_state = 355, .external_lex_state = 2},
  [224] = {.lex_state = 231},
  [225] = {.lex_state = 270, .external_lex_state = 4},
  [226] = {.lex_state = 203},
  [227] = {.lex_state = 270, .external_lex_state = 10},
  [228] = {.lex_state = 270, .external_lex_state = 10},
  [229] = {.lex_state = 248},
  [230] = {.lex_state = 270, .external_lex_state = 10},
  [231] = {.lex_state = 270, .external_lex_state = 10},
  [232] = {.lex_state = 270, .external_lex_state = 10},
  [233] = {.lex_state = 270, .external_lex_state = 4},
  [234] = {.lex_state = 203},
  [235] = {.lex_state = 203},
  [236] = {.lex_state = 308, .external_lex_state = 16},
  [237] = {.lex_state = 316, .external_lex_state = 6},
  [238] = {.lex_state = 308, .external_lex_state = 16},
  [239] = {.lex_state = 308, .external_lex_state = 16},
  [240] = {.lex_state = 203},
  [241] = {.lex_state = 322, .external_lex_state = 2},
  [242] = {.lex_state = 203},
  [243] = {.lex_state = 330, .external_lex_state = 2},
  [244] = {.lex_state = 203},
  [245] = {.lex_state = 322, .external_lex_state = 2},
  [246] = {.lex_state = 203},
  [247] = {.lex_state = 365, .external_lex_state = 22},
  [248] = {.lex_state = 367, .external_lex_state = 23},
  [249] = {.lex_state = 266, .external_lex_state = 9},
  [250] = {.lex_state = 203},
  [251] = {.lex_state = 203},
  [252] = {.lex_state = 297, .external_lex_state = 12},
  [253] = {.lex_state = 299},
  [254] = {.lex_state = 203},
  [255] = {.lex_state = 273, .external_lex_state = 14},
  [256] = {.lex_state = 273, .external_lex_state = 14},
  [257] = {.lex_state = 203},
  [258] = {.lex_state = 273, .external_lex_state = 3},
  [259] = {.lex_state = 273, .external_lex_state = 10},
  [260] = {.lex_state = 273, .external_lex_state = 10},
  [261] = {.lex_state = 273, .external_lex_state = 4},
  [262] = {.lex_state = 264, .external_lex_state = 5},
  [263] = {.lex_state = 203},
  [264] = {.lex_state = 133, .external_lex_state = 2},
  [265] = {.lex_state = 335, .external_lex_state = 4},
  [266] = {.lex_state = 370, .external_lex_state = 2},
  [267] = {.lex_state = 133, .external_lex_state = 2},
  [268] = {.lex_state = 133},
  [269] = {.lex_state = 277},
  [270] = {.lex_state = 231},
  [271] = {.lex_state = 231},
  [272] = {.lex_state = 264, .external_lex_state = 5},
  [273] = {.lex_state = 264, .external_lex_state = 5},
  [274] = {.lex_state = 372, .external_lex_state = 7},
  [275] = {.lex_state = 264, .external_lex_state = 7},
  [276] = {.lex_state = 273, .external_lex_state = 4},
  [277] = {.lex_state = 268, .external_lex_state = 8},
  [278] = {.lex_state = 133, .external_lex_state = 2},
  [279] = {.lex_state = 264, .external_lex_state = 7},
  [280] = {.lex_state = 297, .external_lex_state = 11},
  [281] = {.lex_state = 297, .external_lex_state = 11},
  [282] = {.lex_state = 297, .external_lex_state = 12},
  [283] = {.lex_state = 231},
  [284] = {.lex_state = 297, .external_lex_state = 11},
  [285] = {.lex_state = 297, .external_lex_state = 11},
  [286] = {.lex_state = 248},
  [287] = {.lex_state = 297, .external_lex_state = 11},
  [288] = {.lex_state = 297, .external_lex_state = 11},
  [289] = {.lex_state = 297, .external_lex_state = 11},
  [290] = {.lex_state = 203},
  [291] = {.lex_state = 308, .external_lex_state = 16},
  [292] = {.lex_state = 316, .external_lex_state = 6},
  [293] = {.lex_state = 308, .external_lex_state = 16},
  [294] = {.lex_state = 308, .external_lex_state = 16},
  [295] = {.lex_state = 203},
  [296] = {.lex_state = 322, .external_lex_state = 2},
  [297] = {.lex_state = 203},
  [298] = {.lex_state = 330, .external_lex_state = 2},
  [299] = {.lex_state = 203},
  [300] = {.lex_state = 322, .external_lex_state = 2},
  [301] = {.lex_state = 343, .external_lex_state = 23},
  [302] = {.lex_state = 297, .external_lex_state = 12},
  [303] = {.lex_state = 299, .external_lex_state = 13},
  [304] = {.lex_state = 299, .external_lex_state = 13},
  [305] = {.lex_state = 299},
  [306] = {.lex_state = 231},
  [307] = {.lex_state = 299, .external_lex_state = 13},
  [308] = {.lex_state = 374, .external_lex_state = 13},
  [309] = {.lex_state = 248},
  [310] = {.lex_state = 374, .external_lex_state = 13},
  [311] = {.lex_state = 374, .external_lex_state = 13},
  [312] = {.lex_state = 374, .external_lex_state = 13},
  [313] = {.lex_state = 203},
  [314] = {.lex_state = 308, .external_lex_state = 16},
  [315] = {.lex_state = 316, .external_lex_state = 6},
  [316] = {.lex_state = 308, .external_lex_state = 16},
  [317] = {.lex_state = 308, .external_lex_state = 16},
  [318] = {.lex_state = 203},
  [319] = {.lex_state = 322, .external_lex_state = 2},
  [320] = {.lex_state = 203},
  [321] = {.lex_state = 330, .external_lex_state = 2},
  [322] = {.lex_state = 203},
  [323] = {.lex_state = 322, .external_lex_state = 2},
  [324] = {.lex_state = 299},
  [325] = {.lex_state = 266, .external_lex_state = 9},
  [326] = {.lex_state = 273, .external_lex_state = 3},
  [327] = {.lex_state = 231},
  [328] = {.lex_state = 239, .external_lex_state = 14},
  [329] = {.lex_state = 273, .external_lex_state = 14},
  [330] = {.lex_state = 248},
  [331] = {.lex_state = 273, .external_lex_state = 14},
  [332] = {.lex_state = 273, .external_lex_state = 14},
  [333] = {.lex_state = 273, .external_lex_state = 14},
  [334] = {.lex_state = 203},
  [335] = {.lex_state = 308, .external_lex_state = 16},
  [336] = {.lex_state = 316, .external_lex_state = 6},
  [337] = {.lex_state = 308, .external_lex_state = 16},
  [338] = {.lex_state = 308, .external_lex_state = 16},
  [339] = {.lex_state = 203},
  [340] = {.lex_state = 322, .external_lex_state = 2},
  [341] = {.lex_state = 203},
  [342] = {.lex_state = 330, .external_lex_state = 2},
  [343] = {.lex_state = 203},
  [344] = {.lex_state = 322, .external_lex_state = 2},
  [345] = {.lex_state = 239, .external_lex_state = 3},
  [346] = {.lex_state = 231},
  [347] = {.lex_state = 239, .external_lex_state = 10},
  [348] = {.lex_state = 273, .external_lex_state = 10},
  [349] = {.lex_state = 248},
  [350] = {.lex_state = 273, .external_lex_state = 10},
  [351] = {.lex_state = 273, .external_lex_state = 10},
  [352] = {.lex_state = 273, .external_lex_state = 10},
  [353] = {.lex_state = 203},
  [354] = {.lex_state = 308, .external_lex_state = 16},
  [355] = {.lex_state = 316, .external_lex_state = 6},
  [356] = {.lex_state = 308, .external_lex_state = 16},
  [357] = {.lex_state = 308, .external_lex_state = 16},
  [358] = {.lex_state = 203},
  [359] = {.lex_state = 322, .external_lex_state = 2},
  [360] = {.lex_state = 203},
  [361] = {.lex_state = 330, .external_lex_state = 2},
  [362] = {.lex_state = 203},
  [363] = {.lex_state = 322, .external_lex_state = 2},
  [364] = {.lex_state = 239, .external_lex_state = 4},
  [365] = {.lex_state = 231},
  [366] = {.lex_state = 231, .external_lex_state = 15},
  [367] = {.lex_state = 322, .external_lex_state = 15},
  [368] = {.lex_state = 248},
  [369] = {.lex_state = 322, .external_lex_state = 15},
  [370] = {.lex_state = 322, .external_lex_state = 15},
  [371] = {.lex_state = 322, .external_lex_state = 15},
  [372] = {.lex_state = 203},
  [373] = {.lex_state = 308, .external_lex_state = 16},
  [374] = {.lex_state = 316, .external_lex_state = 6},
  [375] = {.lex_state = 308, .external_lex_state = 16},
  [376] = {.lex_state = 308, .external_lex_state = 16},
  [377] = {.lex_state = 203},
  [378] = {.lex_state = 322, .external_lex_state = 2},
  [379] = {.lex_state = 203},
  [380] = {.lex_state = 330, .external_lex_state = 2},
  [381] = {.lex_state = 203},
  [382] = {.lex_state = 322, .external_lex_state = 2},
  [383] = {.lex_state = 264, .external_lex_state = 5},
  [384] = {.lex_state = 246, .external_lex_state = 5},
  [385] = {.lex_state = 248, .external_lex_state = 13},
  [386] = {.lex_state = 248, .external_lex_state = 13},
  [387] = {.lex_state = 248, .external_lex_state = 13},
  [388] = {.lex_state = 248},
  [389] = {.lex_state = 203},
  [390] = {.lex_state = 308, .external_lex_state = 16},
  [391] = {.lex_state = 316, .external_lex_state = 6},
  [392] = {.lex_state = 308, .external_lex_state = 16},
  [393] = {.lex_state = 308, .external_lex_state = 16},
  [394] = {.lex_state = 203},
  [395] = {.lex_state = 322, .external_lex_state = 2},
  [396] = {.lex_state = 203},
  [397] = {.lex_state = 330, .external_lex_state = 2},
  [398] = {.lex_state = 264, .external_lex_state = 5},
  [399] = {.lex_state = 248},
  [400] = {.lex_state = 231},
  [401] = {.lex_state = 376, .external_lex_state = 16},
  [402] = {.lex_state = 264, .external_lex_state = 5},
  [403] = {.lex_state = 378, .external_lex_state = 24},
  [404] = {.lex_state = 248},
  [405] = {.lex_state = 255},
  [406] = {.lex_state = 378, .external_lex_state = 24},
  [407] = {.lex_state = 258, .external_lex_state = 6},
  [408] = {.lex_state = 380},
  [409] = {.lex_state = 133, .external_lex_state = 2},
  [410] = {.lex_state = 133, .external_lex_state = 2},
  [411] = {.lex_state = 133, .external_lex_state = 2},
  [412] = {.lex_state = 378, .external_lex_state = 16},
  [413] = {.lex_state = 203},
  [414] = {.lex_state = 308, .external_lex_state = 16},
  [415] = {.lex_state = 308, .external_lex_state = 16},
  [416] = {.lex_state = 308, .external_lex_state = 16},
  [417] = {.lex_state = 264, .external_lex_state = 5},
  [418] = {.lex_state = 380},
  [419] = {.lex_state = 378, .external_lex_state = 16},
  [420] = {.lex_state = 264, .external_lex_state = 5},
  [421] = {.lex_state = 380},
  [422] = {.lex_state = 378, .external_lex_state = 16},
  [423] = {.lex_state = 266, .external_lex_state = 9},
  [424] = {.lex_state = 322, .external_lex_state = 2},
  [425] = {.lex_state = 270, .external_lex_state = 4},
  [426] = {.lex_state = 203},
  [427] = {.lex_state = 203},
  [428] = {.lex_state = 270, .external_lex_state = 10},
  [429] = {.lex_state = 270, .external_lex_state = 10},
  [430] = {.lex_state = 270, .external_lex_state = 4},
  [431] = {.lex_state = 203},
  [432] = {.lex_state = 273, .external_lex_state = 4},
  [433] = {.lex_state = 268, .external_lex_state = 8},
  [434] = {.lex_state = 133, .external_lex_state = 2},
  [435] = {.lex_state = 297, .external_lex_state = 12},
  [436] = {.lex_state = 299},
  [437] = {.lex_state = 203},
  [438] = {.lex_state = 318, .external_lex_state = 25},
  [439] = {.lex_state = 248},
  [440] = {.lex_state = 255},
  [441] = {.lex_state = 318, .external_lex_state = 25},
  [442] = {.lex_state = 258, .external_lex_state = 6},
  [443] = {.lex_state = 133, .external_lex_state = 2},
  [444] = {.lex_state = 133, .external_lex_state = 2},
  [445] = {.lex_state = 133, .external_lex_state = 2},
  [446] = {.lex_state = 318, .external_lex_state = 6},
  [447] = {.lex_state = 203},
  [448] = {.lex_state = 318, .external_lex_state = 6},
  [449] = {.lex_state = 318, .external_lex_state = 13},
  [450] = {.lex_state = 248},
  [451] = {.lex_state = 255},
  [452] = {.lex_state = 318, .external_lex_state = 13},
  [453] = {.lex_state = 258, .external_lex_state = 6},
  [454] = {.lex_state = 133, .external_lex_state = 2},
  [455] = {.lex_state = 133, .external_lex_state = 2},
  [456] = {.lex_state = 133, .external_lex_state = 2},
  [457] = {.lex_state = 318},
  [458] = {.lex_state = 318},
  [459] = {.lex_state = 231},
  [460] = {.lex_state = 233, .external_lex_state = 17},
  [461] = {.lex_state = 233, .external_lex_state = 17},
  [462] = {.lex_state = 248},
  [463] = {.lex_state = 233, .external_lex_state = 17},
  [464] = {.lex_state = 233, .external_lex_state = 17},
  [465] = {.lex_state = 233, .external_lex_state = 17},
  [466] = {.lex_state = 203},
  [467] = {.lex_state = 308, .external_lex_state = 16},
  [468] = {.lex_state = 316, .external_lex_state = 6},
  [469] = {.lex_state = 308, .external_lex_state = 16},
  [470] = {.lex_state = 308, .external_lex_state = 16},
  [471] = {.lex_state = 203},
  [472] = {.lex_state = 322, .external_lex_state = 2},
  [473] = {.lex_state = 203},
  [474] = {.lex_state = 330, .external_lex_state = 2},
  [475] = {.lex_state = 203},
  [476] = {.lex_state = 322, .external_lex_state = 2},
  [477] = {.lex_state = 203},
  [478] = {.lex_state = 133, .external_lex_state = 2},
  [479] = {.lex_state = 264, .external_lex_state = 5},
  [480] = {.lex_state = 133, .external_lex_state = 2},
  [481] = {.lex_state = 203},
  [482] = {.lex_state = 338, .external_lex_state = 19},
  [483] = {.lex_state = 133},
  [484] = {.lex_state = 277},
  [485] = {.lex_state = 231},
  [486] = {.lex_state = 341, .external_lex_state = 20},
  [487] = {.lex_state = 231},
  [488] = {.lex_state = 233, .external_lex_state = 17},
  [489] = {.lex_state = 233, .external_lex_state = 17},
  [490] = {.lex_state = 203},
  [491] = {.lex_state = 233, .external_lex_state = 18},
  [492] = {.lex_state = 385, .external_lex_state = 18},
  [493] = {.lex_state = 233, .external_lex_state = 18},
  [494] = {.lex_state = 233, .external_lex_state = 18},
  [495] = {.lex_state = 266, .external_lex_state = 9},
  [496] = {.lex_state = 203},
  [497] = {.lex_state = 203},
  [498] = {.lex_state = 297, .external_lex_state = 12},
  [499] = {.lex_state = 299},
  [500] = {.lex_state = 203},
  [501] = {.lex_state = 324, .external_lex_state = 25},
  [502] = {.lex_state = 324, .external_lex_state = 25},
  [503] = {.lex_state = 203},
  [504] = {.lex_state = 324, .external_lex_state = 6},
  [505] = {.lex_state = 324, .external_lex_state = 13},
  [506] = {.lex_state = 324, .external_lex_state = 13},
  [507] = {.lex_state = 318},
  [508] = {.lex_state = 326, .external_lex_state = 17},
  [509] = {.lex_state = 203},
  [510] = {.lex_state = 133, .external_lex_state = 2},
  [511] = {.lex_state = 133, .external_lex_state = 2},
  [512] = {.lex_state = 133},
  [513] = {.lex_state = 277},
  [514] = {.lex_state = 231},
  [515] = {.lex_state = 231},
  [516] = {.lex_state = 326, .external_lex_state = 17},
  [517] = {.lex_state = 326, .external_lex_state = 17},
  [518] = {.lex_state = 387, .external_lex_state = 18},
  [519] = {.lex_state = 326, .external_lex_state = 18},
  [520] = {.lex_state = 326, .external_lex_state = 18},
  [521] = {.lex_state = 264, .external_lex_state = 5},
  [522] = {.lex_state = 203},
  [523] = {.lex_state = 335, .external_lex_state = 4},
  [524] = {.lex_state = 268, .external_lex_state = 8},
  [525] = {.lex_state = 239, .external_lex_state = 4},
  [526] = {.lex_state = 262, .external_lex_state = 8},
  [527] = {.lex_state = 338, .external_lex_state = 19},
  [528] = {.lex_state = 335, .external_lex_state = 4},
  [529] = {.lex_state = 255},
  [530] = {.lex_state = 258, .external_lex_state = 6},
  [531] = {.lex_state = 338, .external_lex_state = 19},
  [532] = {.lex_state = 231},
  [533] = {.lex_state = 246, .external_lex_state = 5},
  [534] = {.lex_state = 246, .external_lex_state = 5},
  [535] = {.lex_state = 264, .external_lex_state = 7},
  [536] = {.lex_state = 343, .external_lex_state = 5},
  [537] = {.lex_state = 343, .external_lex_state = 5},
  [538] = {.lex_state = 389, .external_lex_state = 7},
  [539] = {.lex_state = 389, .external_lex_state = 7},
  [540] = {.lex_state = 343, .external_lex_state = 5},
  [541] = {.lex_state = 343, .external_lex_state = 5},
  [542] = {.lex_state = 389, .external_lex_state = 7},
  [543] = {.lex_state = 335, .external_lex_state = 4},
  [544] = {.lex_state = 343, .external_lex_state = 7},
  [545] = {.lex_state = 343, .external_lex_state = 7},
  [546] = {.lex_state = 246, .external_lex_state = 7},
  [547] = {.lex_state = 266, .external_lex_state = 9},
  [548] = {.lex_state = 246, .external_lex_state = 7},
  [549] = {.lex_state = 391, .external_lex_state = 12},
  [550] = {.lex_state = 393, .external_lex_state = 13},
  [551] = {.lex_state = 347, .external_lex_state = 11},
  [552] = {.lex_state = 391, .external_lex_state = 12},
  [553] = {.lex_state = 393, .external_lex_state = 13},
  [554] = {.lex_state = 203, .external_lex_state = 12},
  [555] = {.lex_state = 268, .external_lex_state = 8},
  [556] = {.lex_state = 395, .external_lex_state = 13},
  [557] = {.lex_state = 248},
  [558] = {.lex_state = 255},
  [559] = {.lex_state = 395, .external_lex_state = 13},
  [560] = {.lex_state = 258, .external_lex_state = 6},
  [561] = {.lex_state = 133, .external_lex_state = 2},
  [562] = {.lex_state = 133, .external_lex_state = 2},
  [563] = {.lex_state = 133, .external_lex_state = 2},
  [564] = {.lex_state = 322},
  [565] = {.lex_state = 231},
  [566] = {.lex_state = 262, .external_lex_state = 21},
  [567] = {.lex_state = 268, .external_lex_state = 21},
  [568] = {.lex_state = 248},
  [569] = {.lex_state = 268, .external_lex_state = 21},
  [570] = {.lex_state = 268, .external_lex_state = 21},
  [571] = {.lex_state = 268, .external_lex_state = 21},
  [572] = {.lex_state = 203},
  [573] = {.lex_state = 308, .external_lex_state = 16},
  [574] = {.lex_state = 316, .external_lex_state = 6},
  [575] = {.lex_state = 308, .external_lex_state = 16},
  [576] = {.lex_state = 308, .external_lex_state = 16},
  [577] = {.lex_state = 203},
  [578] = {.lex_state = 322, .external_lex_state = 2},
  [579] = {.lex_state = 203},
  [580] = {.lex_state = 330, .external_lex_state = 2},
  [581] = {.lex_state = 203},
  [582] = {.lex_state = 322, .external_lex_state = 2},
  [583] = {.lex_state = 397, .external_lex_state = 10},
  [584] = {.lex_state = 248},
  [585] = {.lex_state = 255},
  [586] = {.lex_state = 397, .external_lex_state = 10},
  [587] = {.lex_state = 258, .external_lex_state = 6},
  [588] = {.lex_state = 133, .external_lex_state = 2},
  [589] = {.lex_state = 133, .external_lex_state = 2},
  [590] = {.lex_state = 133, .external_lex_state = 2},
  [591] = {.lex_state = 397, .external_lex_state = 4},
  [592] = {.lex_state = 349, .external_lex_state = 2},
  [593] = {.lex_state = 335, .external_lex_state = 4},
  [594] = {.lex_state = 389, .external_lex_state = 7},
  [595] = {.lex_state = 239, .external_lex_state = 4},
  [596] = {.lex_state = 262, .external_lex_state = 8},
  [597] = {.lex_state = 349, .external_lex_state = 2},
  [598] = {.lex_state = 335, .external_lex_state = 4},
  [599] = {.lex_state = 343, .external_lex_state = 7},
  [600] = {.lex_state = 335, .external_lex_state = 4},
  [601] = {.lex_state = 133, .external_lex_state = 2},
  [602] = {.lex_state = 399, .external_lex_state = 2},
  [603] = {.lex_state = 239, .external_lex_state = 4},
  [604] = {.lex_state = 203},
  [605] = {.lex_state = 262, .external_lex_state = 8},
  [606] = {.lex_state = 355, .external_lex_state = 2},
  [607] = {.lex_state = 203},
  [608] = {.lex_state = 270, .external_lex_state = 10},
  [609] = {.lex_state = 401},
  [610] = {.lex_state = 270, .external_lex_state = 4},
  [611] = {.lex_state = 270, .external_lex_state = 10},
  [612] = {.lex_state = 270, .external_lex_state = 10},
  [613] = {.lex_state = 401},
  [614] = {.lex_state = 270, .external_lex_state = 4},
  [615] = {.lex_state = 376, .external_lex_state = 16},
  [616] = {.lex_state = 270, .external_lex_state = 10},
  [617] = {.lex_state = 380},
  [618] = {.lex_state = 378, .external_lex_state = 16},
  [619] = {.lex_state = 203},
  [620] = {.lex_state = 308, .external_lex_state = 16},
  [621] = {.lex_state = 308, .external_lex_state = 16},
  [622] = {.lex_state = 308, .external_lex_state = 16},
  [623] = {.lex_state = 270, .external_lex_state = 10},
  [624] = {.lex_state = 380},
  [625] = {.lex_state = 378, .external_lex_state = 16},
  [626] = {.lex_state = 270, .external_lex_state = 10},
  [627] = {.lex_state = 380},
  [628] = {.lex_state = 378, .external_lex_state = 16},
  [629] = {.lex_state = 270, .external_lex_state = 10},
  [630] = {.lex_state = 270, .external_lex_state = 10},
  [631] = {.lex_state = 203},
  [632] = {.lex_state = 407, .external_lex_state = 23},
  [633] = {.lex_state = 239, .external_lex_state = 4},
  [634] = {.lex_state = 262, .external_lex_state = 8},
  [635] = {.lex_state = 365, .external_lex_state = 22},
  [636] = {.lex_state = 133},
  [637] = {.lex_state = 231},
  [638] = {.lex_state = 335, .external_lex_state = 4},
  [639] = {.lex_state = 268, .external_lex_state = 21},
  [640] = {.lex_state = 268, .external_lex_state = 21},
  [641] = {.lex_state = 372, .external_lex_state = 7},
  [642] = {.lex_state = 203},
  [643] = {.lex_state = 409, .external_lex_state = 23},
  [644] = {.lex_state = 372, .external_lex_state = 23},
  [645] = {.lex_state = 266, .external_lex_state = 9},
  [646] = {.lex_state = 273, .external_lex_state = 14},
  [647] = {.lex_state = 273, .external_lex_state = 3},
  [648] = {.lex_state = 273, .external_lex_state = 10},
  [649] = {.lex_state = 273, .external_lex_state = 4},
  [650] = {.lex_state = 264, .external_lex_state = 5},
  [651] = {.lex_state = 203},
  [652] = {.lex_state = 335, .external_lex_state = 4},
  [653] = {.lex_state = 273, .external_lex_state = 4},
  [654] = {.lex_state = 268, .external_lex_state = 8},
  [655] = {.lex_state = 231},
  [656] = {.lex_state = 264, .external_lex_state = 5},
  [657] = {.lex_state = 264, .external_lex_state = 5},
  [658] = {.lex_state = 372, .external_lex_state = 5},
  [659] = {.lex_state = 372, .external_lex_state = 5},
  [660] = {.lex_state = 372, .external_lex_state = 5},
  [661] = {.lex_state = 372, .external_lex_state = 5},
  [662] = {.lex_state = 372, .external_lex_state = 7},
  [663] = {.lex_state = 372, .external_lex_state = 7},
  [664] = {.lex_state = 264, .external_lex_state = 7},
  [665] = {.lex_state = 370, .external_lex_state = 2},
  [666] = {.lex_state = 264, .external_lex_state = 7},
  [667] = {.lex_state = 297, .external_lex_state = 11},
  [668] = {.lex_state = 297, .external_lex_state = 11},
  [669] = {.lex_state = 297, .external_lex_state = 11},
  [670] = {.lex_state = 376, .external_lex_state = 16},
  [671] = {.lex_state = 297, .external_lex_state = 11},
  [672] = {.lex_state = 380},
  [673] = {.lex_state = 378, .external_lex_state = 16},
  [674] = {.lex_state = 203},
  [675] = {.lex_state = 308, .external_lex_state = 16},
  [676] = {.lex_state = 308, .external_lex_state = 16},
  [677] = {.lex_state = 308, .external_lex_state = 16},
  [678] = {.lex_state = 297, .external_lex_state = 11},
  [679] = {.lex_state = 380},
  [680] = {.lex_state = 378, .external_lex_state = 16},
  [681] = {.lex_state = 297, .external_lex_state = 11},
  [682] = {.lex_state = 380},
  [683] = {.lex_state = 378, .external_lex_state = 16},
  [684] = {.lex_state = 297, .external_lex_state = 11},
  [685] = {.lex_state = 297, .external_lex_state = 11},
  [686] = {.lex_state = 133},
  [687] = {.lex_state = 231},
  [688] = {.lex_state = 341, .external_lex_state = 20},
  [689] = {.lex_state = 231},
  [690] = {.lex_state = 343, .external_lex_state = 23},
  [691] = {.lex_state = 374, .external_lex_state = 13},
  [692] = {.lex_state = 299, .external_lex_state = 13},
  [693] = {.lex_state = 374, .external_lex_state = 13},
  [694] = {.lex_state = 376, .external_lex_state = 16},
  [695] = {.lex_state = 374, .external_lex_state = 13},
  [696] = {.lex_state = 380},
  [697] = {.lex_state = 378, .external_lex_state = 16},
  [698] = {.lex_state = 203},
  [699] = {.lex_state = 308, .external_lex_state = 16},
  [700] = {.lex_state = 308, .external_lex_state = 16},
  [701] = {.lex_state = 308, .external_lex_state = 16},
  [702] = {.lex_state = 374, .external_lex_state = 13},
  [703] = {.lex_state = 380},
  [704] = {.lex_state = 378, .external_lex_state = 16},
  [705] = {.lex_state = 374, .external_lex_state = 13},
  [706] = {.lex_state = 380},
  [707] = {.lex_state = 378, .external_lex_state = 16},
  [708] = {.lex_state = 374, .external_lex_state = 13},
  [709] = {.lex_state = 374, .external_lex_state = 13},
  [710] = {.lex_state = 273, .external_lex_state = 3},
  [711] = {.lex_state = 322},
  [712] = {.lex_state = 239, .external_lex_state = 14},
  [713] = {.lex_state = 239, .external_lex_state = 14},
  [714] = {.lex_state = 273, .external_lex_state = 14},
  [715] = {.lex_state = 239, .external_lex_state = 14},
  [716] = {.lex_state = 273, .external_lex_state = 14},
  [717] = {.lex_state = 376, .external_lex_state = 16},
  [718] = {.lex_state = 273, .external_lex_state = 14},
  [719] = {.lex_state = 380},
  [720] = {.lex_state = 378, .external_lex_state = 16},
  [721] = {.lex_state = 203},
  [722] = {.lex_state = 308, .external_lex_state = 16},
  [723] = {.lex_state = 308, .external_lex_state = 16},
  [724] = {.lex_state = 308, .external_lex_state = 16},
  [725] = {.lex_state = 273, .external_lex_state = 14},
  [726] = {.lex_state = 380},
  [727] = {.lex_state = 378, .external_lex_state = 16},
  [728] = {.lex_state = 273, .external_lex_state = 14},
  [729] = {.lex_state = 380},
  [730] = {.lex_state = 378, .external_lex_state = 16},
  [731] = {.lex_state = 273, .external_lex_state = 14},
  [732] = {.lex_state = 273, .external_lex_state = 14},
  [733] = {.lex_state = 273, .external_lex_state = 10},
  [734] = {.lex_state = 239, .external_lex_state = 10},
  [735] = {.lex_state = 273, .external_lex_state = 10},
  [736] = {.lex_state = 376, .external_lex_state = 16},
  [737] = {.lex_state = 273, .external_lex_state = 10},
  [738] = {.lex_state = 380},
  [739] = {.lex_state = 378, .external_lex_state = 16},
  [740] = {.lex_state = 203},
  [741] = {.lex_state = 308, .external_lex_state = 16},
  [742] = {.lex_state = 308, .external_lex_state = 16},
  [743] = {.lex_state = 308, .external_lex_state = 16},
  [744] = {.lex_state = 273, .external_lex_state = 10},
  [745] = {.lex_state = 380},
  [746] = {.lex_state = 378, .external_lex_state = 16},
  [747] = {.lex_state = 273, .external_lex_state = 10},
  [748] = {.lex_state = 380},
  [749] = {.lex_state = 378, .external_lex_state = 16},
  [750] = {.lex_state = 273, .external_lex_state = 10},
  [751] = {.lex_state = 273, .external_lex_state = 10},
  [752] = {.lex_state = 322, .external_lex_state = 15},
  [753] = {.lex_state = 231, .external_lex_state = 15},
  [754] = {.lex_state = 322, .external_lex_state = 15},
  [755] = {.lex_state = 376, .external_lex_state = 16},
  [756] = {.lex_state = 322, .external_lex_state = 15},
  [757] = {.lex_state = 380},
  [758] = {.lex_state = 378, .external_lex_state = 16},
  [759] = {.lex_state = 203},
  [760] = {.lex_state = 308, .external_lex_state = 16},
  [761] = {.lex_state = 308, .external_lex_state = 16},
  [762] = {.lex_state = 308, .external_lex_state = 16},
  [763] = {.lex_state = 322, .external_lex_state = 15},
  [764] = {.lex_state = 380},
  [765] = {.lex_state = 378, .external_lex_state = 16},
  [766] = {.lex_state = 322, .external_lex_state = 15},
  [767] = {.lex_state = 380},
  [768] = {.lex_state = 378, .external_lex_state = 16},
  [769] = {.lex_state = 322, .external_lex_state = 15},
  [770] = {.lex_state = 322, .external_lex_state = 15},
  [771] = {.lex_state = 248},
  [772] = {.lex_state = 376, .external_lex_state = 16},
  [773] = {.lex_state = 248, .external_lex_state = 13},
  [774] = {.lex_state = 380},
  [775] = {.lex_state = 378, .external_lex_state = 16},
  [776] = {.lex_state = 203},
  [777] = {.lex_state = 308, .external_lex_state = 16},
  [778] = {.lex_state = 308, .external_lex_state = 16},
  [779] = {.lex_state = 308, .external_lex_state = 16},
  [780] = {.lex_state = 248, .external_lex_state = 13},
  [781] = {.lex_state = 380},
  [782] = {.lex_state = 378, .external_lex_state = 16},
  [783] = {.lex_state = 248, .external_lex_state = 13},
  [784] = {.lex_state = 380},
  [785] = {.lex_state = 378, .external_lex_state = 16},
  [786] = {.lex_state = 248, .external_lex_state = 13},
  [787] = {.lex_state = 347, .external_lex_state = 11},
  [788] = {.lex_state = 347, .external_lex_state = 11},
  [789] = {.lex_state = 347, .external_lex_state = 11},
  [790] = {.lex_state = 264, .external_lex_state = 5},
  [791] = {.lex_state = 411, .external_lex_state = 24},
  [792] = {.lex_state = 248},
  [793] = {.lex_state = 255},
  [794] = {.lex_state = 411, .external_lex_state = 24},
  [795] = {.lex_state = 258, .external_lex_state = 6},
  [796] = {.lex_state = 133, .external_lex_state = 2},
  [797] = {.lex_state = 133, .external_lex_state = 2},
  [798] = {.lex_state = 133, .external_lex_state = 2},
  [799] = {.lex_state = 203, .external_lex_state = 16},
  [800] = {.lex_state = 231},
  [801] = {.lex_state = 378, .external_lex_state = 24},
  [802] = {.lex_state = 378, .external_lex_state = 24},
  [803] = {.lex_state = 248},
  [804] = {.lex_state = 378, .external_lex_state = 24},
  [805] = {.lex_state = 378, .external_lex_state = 24},
  [806] = {.lex_state = 378, .external_lex_state = 24},
  [807] = {.lex_state = 203},
  [808] = {.lex_state = 308, .external_lex_state = 16},
  [809] = {.lex_state = 316, .external_lex_state = 6},
  [810] = {.lex_state = 308, .external_lex_state = 16},
  [811] = {.lex_state = 308, .external_lex_state = 16},
  [812] = {.lex_state = 378, .external_lex_state = 16},
  [813] = {.lex_state = 203},
  [814] = {.lex_state = 322, .external_lex_state = 2},
  [815] = {.lex_state = 203},
  [816] = {.lex_state = 330, .external_lex_state = 2},
  [817] = {.lex_state = 203},
  [818] = {.lex_state = 322, .external_lex_state = 2},
  [819] = {.lex_state = 264, .external_lex_state = 5},
  [820] = {.lex_state = 378, .external_lex_state = 16},
  [821] = {.lex_state = 376, .external_lex_state = 16},
  [822] = {.lex_state = 264, .external_lex_state = 5},
  [823] = {.lex_state = 380},
  [824] = {.lex_state = 378, .external_lex_state = 16},
  [825] = {.lex_state = 264, .external_lex_state = 5},
  [826] = {.lex_state = 380},
  [827] = {.lex_state = 378, .external_lex_state = 16},
  [828] = {.lex_state = 380},
  [829] = {.lex_state = 378, .external_lex_state = 16},
  [830] = {.lex_state = 378, .external_lex_state = 16},
  [831] = {.lex_state = 264, .external_lex_state = 5},
  [832] = {.lex_state = 378, .external_lex_state = 16},
  [833] = {.lex_state = 322, .external_lex_state = 2},
  [834] = {.lex_state = 322},
  [835] = {.lex_state = 322, .external_lex_state = 15},
  [836] = {.lex_state = 322, .external_lex_state = 15},
  [837] = {.lex_state = 231},
  [838] = {.lex_state = 203},
  [839] = {.lex_state = 349, .external_lex_state = 2},
  [840] = {.lex_state = 385, .external_lex_state = 18},
  [841] = {.lex_state = 355, .external_lex_state = 2},
  [842] = {.lex_state = 270, .external_lex_state = 4},
  [843] = {.lex_state = 203},
  [844] = {.lex_state = 270, .external_lex_state = 4},
  [845] = {.lex_state = 203},
  [846] = {.lex_state = 203},
  [847] = {.lex_state = 365, .external_lex_state = 22},
  [848] = {.lex_state = 413, .external_lex_state = 26},
  [849] = {.lex_state = 203},
  [850] = {.lex_state = 370, .external_lex_state = 2},
  [851] = {.lex_state = 273, .external_lex_state = 4},
  [852] = {.lex_state = 268, .external_lex_state = 8},
  [853] = {.lex_state = 385, .external_lex_state = 26},
  [854] = {.lex_state = 266, .external_lex_state = 9},
  [855] = {.lex_state = 318, .external_lex_state = 6},
  [856] = {.lex_state = 231},
  [857] = {.lex_state = 318, .external_lex_state = 25},
  [858] = {.lex_state = 318, .external_lex_state = 25},
  [859] = {.lex_state = 248},
  [860] = {.lex_state = 318, .external_lex_state = 25},
  [861] = {.lex_state = 318, .external_lex_state = 25},
  [862] = {.lex_state = 318, .external_lex_state = 25},
  [863] = {.lex_state = 203},
  [864] = {.lex_state = 308, .external_lex_state = 16},
  [865] = {.lex_state = 316, .external_lex_state = 6},
  [866] = {.lex_state = 308, .external_lex_state = 16},
  [867] = {.lex_state = 308, .external_lex_state = 16},
  [868] = {.lex_state = 203},
  [869] = {.lex_state = 322, .external_lex_state = 2},
  [870] = {.lex_state = 203},
  [871] = {.lex_state = 330, .external_lex_state = 2},
  [872] = {.lex_state = 203},
  [873] = {.lex_state = 322, .external_lex_state = 2},
  [874] = {.lex_state = 318, .external_lex_state = 6},
  [875] = {.lex_state = 231},
  [876] = {.lex_state = 318, .external_lex_state = 13},
  [877] = {.lex_state = 318, .external_lex_state = 13},
  [878] = {.lex_state = 248},
  [879] = {.lex_state = 318, .external_lex_state = 13},
  [880] = {.lex_state = 318, .external_lex_state = 13},
  [881] = {.lex_state = 318, .external_lex_state = 13},
  [882] = {.lex_state = 203},
  [883] = {.lex_state = 308, .external_lex_state = 16},
  [884] = {.lex_state = 316, .external_lex_state = 6},
  [885] = {.lex_state = 308, .external_lex_state = 16},
  [886] = {.lex_state = 308, .external_lex_state = 16},
  [887] = {.lex_state = 203},
  [888] = {.lex_state = 322, .external_lex_state = 2},
  [889] = {.lex_state = 203},
  [890] = {.lex_state = 330, .external_lex_state = 2},
  [891] = {.lex_state = 203},
  [892] = {.lex_state = 322, .external_lex_state = 2},
  [893] = {.lex_state = 318},
  [894] = {.lex_state = 233, .external_lex_state = 17},
  [895] = {.lex_state = 233, .external_lex_state = 17},
  [896] = {.lex_state = 233, .external_lex_state = 17},
  [897] = {.lex_state = 376, .external_lex_state = 16},
  [898] = {.lex_state = 233, .external_lex_state = 17},
  [899] = {.lex_state = 380},
  [900] = {.lex_state = 378, .external_lex_state = 16},
  [901] = {.lex_state = 203},
  [902] = {.lex_state = 308, .external_lex_state = 16},
  [903] = {.lex_state = 308, .external_lex_state = 16},
  [904] = {.lex_state = 308, .external_lex_state = 16},
  [905] = {.lex_state = 233, .external_lex_state = 17},
  [906] = {.lex_state = 380},
  [907] = {.lex_state = 378, .external_lex_state = 16},
  [908] = {.lex_state = 233, .external_lex_state = 17},
  [909] = {.lex_state = 380},
  [910] = {.lex_state = 378, .external_lex_state = 16},
  [911] = {.lex_state = 233, .external_lex_state = 17},
  [912] = {.lex_state = 233, .external_lex_state = 17},
  [913] = {.lex_state = 203},
  [914] = {.lex_state = 203},
  [915] = {.lex_state = 322, .external_lex_state = 2},
  [916] = {.lex_state = 203},
  [917] = {.lex_state = 322, .external_lex_state = 2},
  [918] = {.lex_state = 203},
  [919] = {.lex_state = 338, .external_lex_state = 19},
  [920] = {.lex_state = 231},
  [921] = {.lex_state = 233, .external_lex_state = 17},
  [922] = {.lex_state = 233, .external_lex_state = 17},
  [923] = {.lex_state = 233, .external_lex_state = 18},
  [924] = {.lex_state = 385, .external_lex_state = 17},
  [925] = {.lex_state = 385, .external_lex_state = 17},
  [926] = {.lex_state = 415, .external_lex_state = 18},
  [927] = {.lex_state = 415, .external_lex_state = 18},
  [928] = {.lex_state = 385, .external_lex_state = 17},
  [929] = {.lex_state = 385, .external_lex_state = 17},
  [930] = {.lex_state = 415, .external_lex_state = 18},
  [931] = {.lex_state = 203},
  [932] = {.lex_state = 385, .external_lex_state = 18},
  [933] = {.lex_state = 385, .external_lex_state = 18},
  [934] = {.lex_state = 233, .external_lex_state = 18},
  [935] = {.lex_state = 233, .external_lex_state = 18},
  [936] = {.lex_state = 330, .external_lex_state = 15},
  [937] = {.lex_state = 330, .external_lex_state = 15},
  [938] = {.lex_state = 387, .external_lex_state = 18},
  [939] = {.lex_state = 203},
  [940] = {.lex_state = 417, .external_lex_state = 26},
  [941] = {.lex_state = 387, .external_lex_state = 26},
  [942] = {.lex_state = 266, .external_lex_state = 9},
  [943] = {.lex_state = 324, .external_lex_state = 25},
  [944] = {.lex_state = 324, .external_lex_state = 6},
  [945] = {.lex_state = 324, .external_lex_state = 13},
  [946] = {.lex_state = 318},
  [947] = {.lex_state = 326, .external_lex_state = 17},
  [948] = {.lex_state = 203},
  [949] = {.lex_state = 330, .external_lex_state = 2},
  [950] = {.lex_state = 203},
  [951] = {.lex_state = 330, .external_lex_state = 2},
  [952] = {.lex_state = 231},
  [953] = {.lex_state = 326, .external_lex_state = 17},
  [954] = {.lex_state = 326, .external_lex_state = 17},
  [955] = {.lex_state = 387, .external_lex_state = 17},
  [956] = {.lex_state = 387, .external_lex_state = 17},
  [957] = {.lex_state = 387, .external_lex_state = 17},
  [958] = {.lex_state = 387, .external_lex_state = 17},
  [959] = {.lex_state = 387, .external_lex_state = 18},
  [960] = {.lex_state = 387, .external_lex_state = 18},
  [961] = {.lex_state = 326, .external_lex_state = 18},
  [962] = {.lex_state = 326, .external_lex_state = 18},
  [963] = {.lex_state = 367, .external_lex_state = 23},
  [964] = {.lex_state = 338, .external_lex_state = 19},
  [965] = {.lex_state = 338, .external_lex_state = 19},
  [966] = {.lex_state = 203},
  [967] = {.lex_state = 308, .external_lex_state = 16},
  [968] = {.lex_state = 316, .external_lex_state = 6},
  [969] = {.lex_state = 308, .external_lex_state = 16},
  [970] = {.lex_state = 308, .external_lex_state = 16},
  [971] = {.lex_state = 335, .external_lex_state = 4},
  [972] = {.lex_state = 338, .external_lex_state = 19},
  [973] = {.lex_state = 343, .external_lex_state = 5},
  [974] = {.lex_state = 343, .external_lex_state = 5},
  [975] = {.lex_state = 389, .external_lex_state = 7},
  [976] = {.lex_state = 343, .external_lex_state = 5},
  [977] = {.lex_state = 335, .external_lex_state = 4},
  [978] = {.lex_state = 231, .external_lex_state = 15},
  [979] = {.lex_state = 231, .external_lex_state = 15},
  [980] = {.lex_state = 343, .external_lex_state = 7},
  [981] = {.lex_state = 393, .external_lex_state = 13},
  [982] = {.lex_state = 203},
  [983] = {.lex_state = 347, .external_lex_state = 11},
  [984] = {.lex_state = 393, .external_lex_state = 13},
  [985] = {.lex_state = 203},
  [986] = {.lex_state = 231},
  [987] = {.lex_state = 395, .external_lex_state = 13},
  [988] = {.lex_state = 395, .external_lex_state = 13},
  [989] = {.lex_state = 248},
  [990] = {.lex_state = 395, .external_lex_state = 13},
  [991] = {.lex_state = 395, .external_lex_state = 13},
  [992] = {.lex_state = 395, .external_lex_state = 13},
  [993] = {.lex_state = 203},
  [994] = {.lex_state = 308, .external_lex_state = 16},
  [995] = {.lex_state = 316, .external_lex_state = 6},
  [996] = {.lex_state = 308, .external_lex_state = 16},
  [997] = {.lex_state = 308, .external_lex_state = 16},
  [998] = {.lex_state = 203},
  [999] = {.lex_state = 322, .external_lex_state = 2},
  [1000] = {.lex_state = 203},
  [1001] = {.lex_state = 330, .external_lex_state = 2},
  [1002] = {.lex_state = 203},
  [1003] = {.lex_state = 322, .external_lex_state = 2},
  [1004] = {.lex_state = 268, .external_lex_state = 8},
  [1005] = {.lex_state = 322},
  [1006] = {.lex_state = 268, .external_lex_state = 21},
  [1007] = {.lex_state = 262, .external_lex_state = 21},
  [1008] = {.lex_state = 268, .external_lex_state = 21},
  [1009] = {.lex_state = 376, .external_lex_state = 16},
  [1010] = {.lex_state = 268, .external_lex_state = 21},
  [1011] = {.lex_state = 380},
  [1012] = {.lex_state = 378, .external_lex_state = 16},
  [1013] = {.lex_state = 203},
  [1014] = {.lex_state = 308, .external_lex_state = 16},
  [1015] = {.lex_state = 308, .external_lex_state = 16},
  [1016] = {.lex_state = 308, .external_lex_state = 16},
  [1017] = {.lex_state = 268, .external_lex_state = 21},
  [1018] = {.lex_state = 380},
  [1019] = {.lex_state = 378, .external_lex_state = 16},
  [1020] = {.lex_state = 268, .external_lex_state = 21},
  [1021] = {.lex_state = 380},
  [1022] = {.lex_state = 378, .external_lex_state = 16},
  [1023] = {.lex_state = 268, .external_lex_state = 21},
  [1024] = {.lex_state = 268, .external_lex_state = 21},
  [1025] = {.lex_state = 231},
  [1026] = {.lex_state = 397, .external_lex_state = 10},
  [1027] = {.lex_state = 397, .external_lex_state = 10},
  [1028] = {.lex_state = 248},
  [1029] = {.lex_state = 397, .external_lex_state = 10},
  [1030] = {.lex_state = 397, .external_lex_state = 10},
  [1031] = {.lex_state = 397, .external_lex_state = 10},
  [1032] = {.lex_state = 203},
  [1033] = {.lex_state = 308, .external_lex_state = 16},
  [1034] = {.lex_state = 316, .external_lex_state = 6},
  [1035] = {.lex_state = 308, .external_lex_state = 16},
  [1036] = {.lex_state = 308, .external_lex_state = 16},
  [1037] = {.lex_state = 203},
  [1038] = {.lex_state = 322, .external_lex_state = 2},
  [1039] = {.lex_state = 203},
  [1040] = {.lex_state = 330, .external_lex_state = 2},
  [1041] = {.lex_state = 203},
  [1042] = {.lex_state = 322, .external_lex_state = 2},
  [1043] = {.lex_state = 203},
  [1044] = {.lex_state = 397, .external_lex_state = 4},
  [1045] = {.lex_state = 335, .external_lex_state = 4},
  [1046] = {.lex_state = 349, .external_lex_state = 2},
  [1047] = {.lex_state = 349, .external_lex_state = 2},
  [1048] = {.lex_state = 389, .external_lex_state = 7},
  [1049] = {.lex_state = 349, .external_lex_state = 2},
  [1050] = {.lex_state = 335, .external_lex_state = 4},
  [1051] = {.lex_state = 203},
  [1052] = {.lex_state = 239, .external_lex_state = 4},
  [1053] = {.lex_state = 262, .external_lex_state = 8},
  [1054] = {.lex_state = 399, .external_lex_state = 2},
  [1055] = {.lex_state = 355, .external_lex_state = 2},
  [1056] = {.lex_state = 335, .external_lex_state = 4},
  [1057] = {.lex_state = 203},
  [1058] = {.lex_state = 355, .external_lex_state = 2},
  [1059] = {.lex_state = 203},
  [1060] = {.lex_state = 203},
  [1061] = {.lex_state = 335, .external_lex_state = 4},
  [1062] = {.lex_state = 419, .external_lex_state = 13},
  [1063] = {.lex_state = 419, .external_lex_state = 13},
  [1064] = {.lex_state = 203},
  [1065] = {.lex_state = 228},
  [1066] = {.lex_state = 231},
  [1067] = {.lex_state = 401},
  [1068] = {.lex_state = 335, .external_lex_state = 4},
  [1069] = {.lex_state = 203},
  [1070] = {.lex_state = 231},
  [1071] = {.lex_state = 401},
  [1072] = {.lex_state = 270, .external_lex_state = 10},
  [1073] = {.lex_state = 411, .external_lex_state = 24},
  [1074] = {.lex_state = 411, .external_lex_state = 24},
  [1075] = {.lex_state = 203, .external_lex_state = 16},
  [1076] = {.lex_state = 378, .external_lex_state = 16},
  [1077] = {.lex_state = 270, .external_lex_state = 10},
  [1078] = {.lex_state = 376, .external_lex_state = 16},
  [1079] = {.lex_state = 270, .external_lex_state = 10},
  [1080] = {.lex_state = 380},
  [1081] = {.lex_state = 378, .external_lex_state = 16},
  [1082] = {.lex_state = 270, .external_lex_state = 10},
  [1083] = {.lex_state = 380},
  [1084] = {.lex_state = 378, .external_lex_state = 16},
  [1085] = {.lex_state = 380},
  [1086] = {.lex_state = 378, .external_lex_state = 16},
  [1087] = {.lex_state = 378, .external_lex_state = 16},
  [1088] = {.lex_state = 270, .external_lex_state = 10},
  [1089] = {.lex_state = 378, .external_lex_state = 16},
  [1090] = {.lex_state = 367, .external_lex_state = 23},
  [1091] = {.lex_state = 365, .external_lex_state = 22},
  [1092] = {.lex_state = 407, .external_lex_state = 23},
  [1093] = {.lex_state = 365, .external_lex_state = 22},
  [1094] = {.lex_state = 231},
  [1095] = {.lex_state = 421, .external_lex_state = 10},
  [1096] = {.lex_state = 421, .external_lex_state = 10},
  [1097] = {.lex_state = 335, .external_lex_state = 4},
  [1098] = {.lex_state = 268, .external_lex_state = 21},
  [1099] = {.lex_state = 372, .external_lex_state = 7},
  [1100] = {.lex_state = 203},
  [1101] = {.lex_state = 133},
  [1102] = {.lex_state = 231},
  [1103] = {.lex_state = 133},
  [1104] = {.lex_state = 231},
  [1105] = {.lex_state = 231},
  [1106] = {.lex_state = 372, .external_lex_state = 23},
  [1107] = {.lex_state = 273, .external_lex_state = 14},
  [1108] = {.lex_state = 273, .external_lex_state = 14},
  [1109] = {.lex_state = 273, .external_lex_state = 14},
  [1110] = {.lex_state = 273, .external_lex_state = 10},
  [1111] = {.lex_state = 409, .external_lex_state = 23},
  [1112] = {.lex_state = 372, .external_lex_state = 5},
  [1113] = {.lex_state = 372, .external_lex_state = 5},
  [1114] = {.lex_state = 372, .external_lex_state = 5},
  [1115] = {.lex_state = 335, .external_lex_state = 4},
  [1116] = {.lex_state = 372, .external_lex_state = 7},
  [1117] = {.lex_state = 297, .external_lex_state = 11},
  [1118] = {.lex_state = 411, .external_lex_state = 24},
  [1119] = {.lex_state = 411, .external_lex_state = 24},
  [1120] = {.lex_state = 203, .external_lex_state = 16},
  [1121] = {.lex_state = 378, .external_lex_state = 16},
  [1122] = {.lex_state = 297, .external_lex_state = 11},
  [1123] = {.lex_state = 376, .external_lex_state = 16},
  [1124] = {.lex_state = 297, .external_lex_state = 11},
  [1125] = {.lex_state = 380},
  [1126] = {.lex_state = 378, .external_lex_state = 16},
  [1127] = {.lex_state = 297, .external_lex_state = 11},
  [1128] = {.lex_state = 380},
  [1129] = {.lex_state = 378, .external_lex_state = 16},
  [1130] = {.lex_state = 380},
  [1131] = {.lex_state = 378, .external_lex_state = 16},
  [1132] = {.lex_state = 378, .external_lex_state = 16},
  [1133] = {.lex_state = 297, .external_lex_state = 11},
  [1134] = {.lex_state = 378, .external_lex_state = 16},
  [1135] = {.lex_state = 231},
  [1136] = {.lex_state = 343, .external_lex_state = 27},
  [1137] = {.lex_state = 248},
  [1138] = {.lex_state = 255},
  [1139] = {.lex_state = 343, .external_lex_state = 27},
  [1140] = {.lex_state = 258, .external_lex_state = 6},
  [1141] = {.lex_state = 133, .external_lex_state = 2},
  [1142] = {.lex_state = 133, .external_lex_state = 2},
  [1143] = {.lex_state = 133, .external_lex_state = 2},
  [1144] = {.lex_state = 389, .external_lex_state = 23},
  [1145] = {.lex_state = 389, .external_lex_state = 23},
  [1146] = {.lex_state = 343, .external_lex_state = 27},
  [1147] = {.lex_state = 343, .external_lex_state = 27},
  [1148] = {.lex_state = 389, .external_lex_state = 23},
  [1149] = {.lex_state = 343, .external_lex_state = 23},
  [1150] = {.lex_state = 374, .external_lex_state = 13},
  [1151] = {.lex_state = 411, .external_lex_state = 24},
  [1152] = {.lex_state = 411, .external_lex_state = 24},
  [1153] = {.lex_state = 203, .external_lex_state = 16},
  [1154] = {.lex_state = 378, .external_lex_state = 16},
  [1155] = {.lex_state = 374, .external_lex_state = 13},
  [1156] = {.lex_state = 376, .external_lex_state = 16},
  [1157] = {.lex_state = 374, .external_lex_state = 13},
  [1158] = {.lex_state = 380},
  [1159] = {.lex_state = 378, .external_lex_state = 16},
  [1160] = {.lex_state = 374, .external_lex_state = 13},
  [1161] = {.lex_state = 380},
  [1162] = {.lex_state = 378, .external_lex_state = 16},
  [1163] = {.lex_state = 380},
  [1164] = {.lex_state = 378, .external_lex_state = 16},
  [1165] = {.lex_state = 378, .external_lex_state = 16},
  [1166] = {.lex_state = 374, .external_lex_state = 13},
  [1167] = {.lex_state = 378, .external_lex_state = 16},
  [1168] = {.lex_state = 273, .external_lex_state = 3},
  [1169] = {.lex_state = 322},
  [1170] = {.lex_state = 273, .external_lex_state = 14},
  [1171] = {.lex_state = 411, .external_lex_state = 24},
  [1172] = {.lex_state = 411, .external_lex_state = 24},
  [1173] = {.lex_state = 203, .external_lex_state = 16},
  [1174] = {.lex_state = 378, .external_lex_state = 16},
  [1175] = {.lex_state = 273, .external_lex_state = 14},
  [1176] = {.lex_state = 376, .external_lex_state = 16},
  [1177] = {.lex_state = 273, .external_lex_state = 14},
  [1178] = {.lex_state = 380},
  [1179] = {.lex_state = 378, .external_lex_state = 16},
  [1180] = {.lex_state = 273, .external_lex_state = 14},
  [1181] = {.lex_state = 380},
  [1182] = {.lex_state = 378, .external_lex_state = 16},
  [1183] = {.lex_state = 380},
  [1184] = {.lex_state = 378, .external_lex_state = 16},
  [1185] = {.lex_state = 378, .external_lex_state = 16},
  [1186] = {.lex_state = 273, .external_lex_state = 14},
  [1187] = {.lex_state = 378, .external_lex_state = 16},
  [1188] = {.lex_state = 273, .external_lex_state = 10},
  [1189] = {.lex_state = 411, .external_lex_state = 24},
  [1190] = {.lex_state = 411, .external_lex_state = 24},
  [1191] = {.lex_state = 203, .external_lex_state = 16},
  [1192] = {.lex_state = 378, .external_lex_state = 16},
  [1193] = {.lex_state = 273, .external_lex_state = 10},
  [1194] = {.lex_state = 376, .external_lex_state = 16},
  [1195] = {.lex_state = 273, .external_lex_state = 10},
  [1196] = {.lex_state = 380},
  [1197] = {.lex_state = 378, .external_lex_state = 16},
  [1198] = {.lex_state = 273, .external_lex_state = 10},
  [1199] = {.lex_state = 380},
  [1200] = {.lex_state = 378, .external_lex_state = 16},
  [1201] = {.lex_state = 380},
  [1202] = {.lex_state = 378, .external_lex_state = 16},
  [1203] = {.lex_state = 378, .external_lex_state = 16},
  [1204] = {.lex_state = 273, .external_lex_state = 10},
  [1205] = {.lex_state = 378, .external_lex_state = 16},
  [1206] = {.lex_state = 322, .external_lex_state = 15},
  [1207] = {.lex_state = 411, .external_lex_state = 24},
  [1208] = {.lex_state = 411, .external_lex_state = 24},
  [1209] = {.lex_state = 203, .external_lex_state = 16},
  [1210] = {.lex_state = 378, .external_lex_state = 16},
  [1211] = {.lex_state = 322, .external_lex_state = 15},
  [1212] = {.lex_state = 376, .external_lex_state = 16},
  [1213] = {.lex_state = 322, .external_lex_state = 15},
  [1214] = {.lex_state = 380},
  [1215] = {.lex_state = 378, .external_lex_state = 16},
  [1216] = {.lex_state = 322, .external_lex_state = 15},
  [1217] = {.lex_state = 380},
  [1218] = {.lex_state = 378, .external_lex_state = 16},
  [1219] = {.lex_state = 380},
  [1220] = {.lex_state = 378, .external_lex_state = 16},
  [1221] = {.lex_state = 378, .external_lex_state = 16},
  [1222] = {.lex_state = 322, .external_lex_state = 15},
  [1223] = {.lex_state = 378, .external_lex_state = 16},
  [1224] = {.lex_state = 248, .external_lex_state = 13},
  [1225] = {.lex_state = 411, .external_lex_state = 24},
  [1226] = {.lex_state = 411, .external_lex_state = 24},
  [1227] = {.lex_state = 203, .external_lex_state = 16},
  [1228] = {.lex_state = 378, .external_lex_state = 16},
  [1229] = {.lex_state = 248, .external_lex_state = 13},
  [1230] = {.lex_state = 376, .external_lex_state = 16},
  [1231] = {.lex_state = 248, .external_lex_state = 13},
  [1232] = {.lex_state = 380},
  [1233] = {.lex_state = 378, .external_lex_state = 16},
  [1234] = {.lex_state = 248, .external_lex_state = 13},
  [1235] = {.lex_state = 380},
  [1236] = {.lex_state = 378, .external_lex_state = 16},
  [1237] = {.lex_state = 380},
  [1238] = {.lex_state = 378, .external_lex_state = 16},
  [1239] = {.lex_state = 378, .external_lex_state = 16},
  [1240] = {.lex_state = 248, .external_lex_state = 13},
  [1241] = {.lex_state = 378, .external_lex_state = 16},
  [1242] = {.lex_state = 391, .external_lex_state = 12},
  [1243] = {.lex_state = 308, .external_lex_state = 24},
  [1244] = {.lex_state = 391, .external_lex_state = 12},
  [1245] = {.lex_state = 308, .external_lex_state = 24},
  [1246] = {.lex_state = 203, .external_lex_state = 12},
  [1247] = {.lex_state = 231},
  [1248] = {.lex_state = 264, .external_lex_state = 5},
  [1249] = {.lex_state = 411, .external_lex_state = 24},
  [1250] = {.lex_state = 411, .external_lex_state = 24},
  [1251] = {.lex_state = 248},
  [1252] = {.lex_state = 411, .external_lex_state = 24},
  [1253] = {.lex_state = 411, .external_lex_state = 24},
  [1254] = {.lex_state = 411, .external_lex_state = 24},
  [1255] = {.lex_state = 264, .external_lex_state = 5},
  [1256] = {.lex_state = 203},
  [1257] = {.lex_state = 308, .external_lex_state = 16},
  [1258] = {.lex_state = 316, .external_lex_state = 6},
  [1259] = {.lex_state = 308, .external_lex_state = 16},
  [1260] = {.lex_state = 308, .external_lex_state = 16},
  [1261] = {.lex_state = 203},
  [1262] = {.lex_state = 322, .external_lex_state = 2},
  [1263] = {.lex_state = 203},
  [1264] = {.lex_state = 330, .external_lex_state = 2},
  [1265] = {.lex_state = 203},
  [1266] = {.lex_state = 322, .external_lex_state = 2},
  [1267] = {.lex_state = 378, .external_lex_state = 24},
  [1268] = {.lex_state = 378, .external_lex_state = 24},
  [1269] = {.lex_state = 378, .external_lex_state = 24},
  [1270] = {.lex_state = 376, .external_lex_state = 16},
  [1271] = {.lex_state = 378, .external_lex_state = 24},
  [1272] = {.lex_state = 380},
  [1273] = {.lex_state = 378, .external_lex_state = 16},
  [1274] = {.lex_state = 203},
  [1275] = {.lex_state = 308, .external_lex_state = 16},
  [1276] = {.lex_state = 308, .external_lex_state = 16},
  [1277] = {.lex_state = 308, .external_lex_state = 16},
  [1278] = {.lex_state = 378, .external_lex_state = 24},
  [1279] = {.lex_state = 380},
  [1280] = {.lex_state = 378, .external_lex_state = 16},
  [1281] = {.lex_state = 378, .external_lex_state = 24},
  [1282] = {.lex_state = 380},
  [1283] = {.lex_state = 378, .external_lex_state = 16},
  [1284] = {.lex_state = 264, .external_lex_state = 5},
  [1285] = {.lex_state = 378, .external_lex_state = 16},
  [1286] = {.lex_state = 378, .external_lex_state = 24},
  [1287] = {.lex_state = 378, .external_lex_state = 24},
  [1288] = {.lex_state = 411, .external_lex_state = 24},
  [1289] = {.lex_state = 411, .external_lex_state = 24},
  [1290] = {.lex_state = 203, .external_lex_state = 16},
  [1291] = {.lex_state = 378, .external_lex_state = 16},
  [1292] = {.lex_state = 264, .external_lex_state = 5},
  [1293] = {.lex_state = 378, .external_lex_state = 16},
  [1294] = {.lex_state = 264, .external_lex_state = 5},
  [1295] = {.lex_state = 378, .external_lex_state = 16},
  [1296] = {.lex_state = 264, .external_lex_state = 5},
  [1297] = {.lex_state = 378, .external_lex_state = 16},
  [1298] = {.lex_state = 264, .external_lex_state = 5},
  [1299] = {.lex_state = 378, .external_lex_state = 16},
  [1300] = {.lex_state = 322, .external_lex_state = 2},
  [1301] = {.lex_state = 322},
  [1302] = {.lex_state = 322, .external_lex_state = 15},
  [1303] = {.lex_state = 397, .external_lex_state = 4},
  [1304] = {.lex_state = 349, .external_lex_state = 2},
  [1305] = {.lex_state = 203},
  [1306] = {.lex_state = 415, .external_lex_state = 18},
  [1307] = {.lex_state = 349, .external_lex_state = 2},
  [1308] = {.lex_state = 203},
  [1309] = {.lex_state = 385, .external_lex_state = 18},
  [1310] = {.lex_state = 203},
  [1311] = {.lex_state = 203},
  [1312] = {.lex_state = 355, .external_lex_state = 2},
  [1313] = {.lex_state = 203},
  [1314] = {.lex_state = 401},
  [1315] = {.lex_state = 270, .external_lex_state = 4},
  [1316] = {.lex_state = 401},
  [1317] = {.lex_state = 270, .external_lex_state = 4},
  [1318] = {.lex_state = 203},
  [1319] = {.lex_state = 423, .external_lex_state = 26},
  [1320] = {.lex_state = 365, .external_lex_state = 22},
  [1321] = {.lex_state = 133},
  [1322] = {.lex_state = 231},
  [1323] = {.lex_state = 203},
  [1324] = {.lex_state = 203},
  [1325] = {.lex_state = 370, .external_lex_state = 2},
  [1326] = {.lex_state = 133},
  [1327] = {.lex_state = 231},
  [1328] = {.lex_state = 341, .external_lex_state = 20},
  [1329] = {.lex_state = 231},
  [1330] = {.lex_state = 385, .external_lex_state = 26},
  [1331] = {.lex_state = 318, .external_lex_state = 6},
  [1332] = {.lex_state = 322},
  [1333] = {.lex_state = 318, .external_lex_state = 25},
  [1334] = {.lex_state = 318, .external_lex_state = 25},
  [1335] = {.lex_state = 318, .external_lex_state = 25},
  [1336] = {.lex_state = 318, .external_lex_state = 25},
  [1337] = {.lex_state = 318, .external_lex_state = 25},
  [1338] = {.lex_state = 376, .external_lex_state = 16},
  [1339] = {.lex_state = 318, .external_lex_state = 25},
  [1340] = {.lex_state = 380},
  [1341] = {.lex_state = 378, .external_lex_state = 16},
  [1342] = {.lex_state = 203},
  [1343] = {.lex_state = 308, .external_lex_state = 16},
  [1344] = {.lex_state = 308, .external_lex_state = 16},
  [1345] = {.lex_state = 308, .external_lex_state = 16},
  [1346] = {.lex_state = 318, .external_lex_state = 25},
  [1347] = {.lex_state = 380},
  [1348] = {.lex_state = 378, .external_lex_state = 16},
  [1349] = {.lex_state = 318, .external_lex_state = 25},
  [1350] = {.lex_state = 380},
  [1351] = {.lex_state = 378, .external_lex_state = 16},
  [1352] = {.lex_state = 318, .external_lex_state = 25},
  [1353] = {.lex_state = 318, .external_lex_state = 25},
  [1354] = {.lex_state = 318, .external_lex_state = 13},
  [1355] = {.lex_state = 318, .external_lex_state = 13},
  [1356] = {.lex_state = 318, .external_lex_state = 13},
  [1357] = {.lex_state = 376, .external_lex_state = 16},
  [1358] = {.lex_state = 318, .external_lex_state = 13},
  [1359] = {.lex_state = 380},
  [1360] = {.lex_state = 378, .external_lex_state = 16},
  [1361] = {.lex_state = 203},
  [1362] = {.lex_state = 308, .external_lex_state = 16},
  [1363] = {.lex_state = 308, .external_lex_state = 16},
  [1364] = {.lex_state = 308, .external_lex_state = 16},
  [1365] = {.lex_state = 318, .external_lex_state = 13},
  [1366] = {.lex_state = 380},
  [1367] = {.lex_state = 378, .external_lex_state = 16},
  [1368] = {.lex_state = 318, .external_lex_state = 13},
  [1369] = {.lex_state = 380},
  [1370] = {.lex_state = 378, .external_lex_state = 16},
  [1371] = {.lex_state = 318, .external_lex_state = 13},
  [1372] = {.lex_state = 318, .external_lex_state = 13},
  [1373] = {.lex_state = 233, .external_lex_state = 17},
  [1374] = {.lex_state = 411, .external_lex_state = 24},
  [1375] = {.lex_state = 411, .external_lex_state = 24},
  [1376] = {.lex_state = 203, .external_lex_state = 16},
  [1377] = {.lex_state = 378, .external_lex_state = 16},
  [1378] = {.lex_state = 233, .external_lex_state = 17},
  [1379] = {.lex_state = 376, .external_lex_state = 16},
  [1380] = {.lex_state = 233, .external_lex_state = 17},
  [1381] = {.lex_state = 380},
  [1382] = {.lex_state = 378, .external_lex_state = 16},
  [1383] = {.lex_state = 233, .external_lex_state = 17},
  [1384] = {.lex_state = 380},
  [1385] = {.lex_state = 378, .external_lex_state = 16},
  [1386] = {.lex_state = 380},
  [1387] = {.lex_state = 378, .external_lex_state = 16},
  [1388] = {.lex_state = 378, .external_lex_state = 16},
  [1389] = {.lex_state = 233, .external_lex_state = 17},
  [1390] = {.lex_state = 378, .external_lex_state = 16},
  [1391] = {.lex_state = 413, .external_lex_state = 26},
  [1392] = {.lex_state = 203},
  [1393] = {.lex_state = 385, .external_lex_state = 17},
  [1394] = {.lex_state = 385, .external_lex_state = 17},
  [1395] = {.lex_state = 415, .external_lex_state = 18},
  [1396] = {.lex_state = 385, .external_lex_state = 17},
  [1397] = {.lex_state = 203},
  [1398] = {.lex_state = 385, .external_lex_state = 18},
  [1399] = {.lex_state = 330, .external_lex_state = 15},
  [1400] = {.lex_state = 387, .external_lex_state = 18},
  [1401] = {.lex_state = 203},
  [1402] = {.lex_state = 133},
  [1403] = {.lex_state = 231},
  [1404] = {.lex_state = 133},
  [1405] = {.lex_state = 231},
  [1406] = {.lex_state = 231},
  [1407] = {.lex_state = 387, .external_lex_state = 26},
  [1408] = {.lex_state = 324, .external_lex_state = 25},
  [1409] = {.lex_state = 324, .external_lex_state = 25},
  [1410] = {.lex_state = 324, .external_lex_state = 25},
  [1411] = {.lex_state = 324, .external_lex_state = 13},
  [1412] = {.lex_state = 417, .external_lex_state = 26},
  [1413] = {.lex_state = 387, .external_lex_state = 17},
  [1414] = {.lex_state = 387, .external_lex_state = 17},
  [1415] = {.lex_state = 387, .external_lex_state = 17},
  [1416] = {.lex_state = 387, .external_lex_state = 18},
  [1417] = {.lex_state = 335, .external_lex_state = 4},
  [1418] = {.lex_state = 376, .external_lex_state = 16},
  [1419] = {.lex_state = 338, .external_lex_state = 19},
  [1420] = {.lex_state = 380},
  [1421] = {.lex_state = 378, .external_lex_state = 16},
  [1422] = {.lex_state = 203},
  [1423] = {.lex_state = 308, .external_lex_state = 16},
  [1424] = {.lex_state = 308, .external_lex_state = 16},
  [1425] = {.lex_state = 308, .external_lex_state = 16},
  [1426] = {.lex_state = 338, .external_lex_state = 19},
  [1427] = {.lex_state = 380},
  [1428] = {.lex_state = 378, .external_lex_state = 16},
  [1429] = {.lex_state = 338, .external_lex_state = 19},
  [1430] = {.lex_state = 380},
  [1431] = {.lex_state = 378, .external_lex_state = 16},
  [1432] = {.lex_state = 343, .external_lex_state = 5},
  [1433] = {.lex_state = 335, .external_lex_state = 4},
  [1434] = {.lex_state = 203},
  [1435] = {.lex_state = 203},
  [1436] = {.lex_state = 395, .external_lex_state = 13},
  [1437] = {.lex_state = 395, .external_lex_state = 13},
  [1438] = {.lex_state = 395, .external_lex_state = 13},
  [1439] = {.lex_state = 376, .external_lex_state = 16},
  [1440] = {.lex_state = 395, .external_lex_state = 13},
  [1441] = {.lex_state = 380},
  [1442] = {.lex_state = 378, .external_lex_state = 16},
  [1443] = {.lex_state = 203},
  [1444] = {.lex_state = 308, .external_lex_state = 16},
  [1445] = {.lex_state = 308, .external_lex_state = 16},
  [1446] = {.lex_state = 308, .external_lex_state = 16},
  [1447] = {.lex_state = 395, .external_lex_state = 13},
  [1448] = {.lex_state = 380},
  [1449] = {.lex_state = 378, .external_lex_state = 16},
  [1450] = {.lex_state = 395, .external_lex_state = 13},
  [1451] = {.lex_state = 380},
  [1452] = {.lex_state = 378, .external_lex_state = 16},
  [1453] = {.lex_state = 395, .external_lex_state = 13},
  [1454] = {.lex_state = 395, .external_lex_state = 13},
  [1455] = {.lex_state = 268, .external_lex_state = 21},
  [1456] = {.lex_state = 411, .external_lex_state = 24},
  [1457] = {.lex_state = 411, .external_lex_state = 24},
  [1458] = {.lex_state = 203, .external_lex_state = 16},
  [1459] = {.lex_state = 378, .external_lex_state = 16},
  [1460] = {.lex_state = 268, .external_lex_state = 21},
  [1461] = {.lex_state = 376, .external_lex_state = 16},
  [1462] = {.lex_state = 268, .external_lex_state = 21},
  [1463] = {.lex_state = 380},
  [1464] = {.lex_state = 378, .external_lex_state = 16},
  [1465] = {.lex_state = 268, .external_lex_state = 21},
  [1466] = {.lex_state = 380},
  [1467] = {.lex_state = 378, .external_lex_state = 16},
  [1468] = {.lex_state = 380},
  [1469] = {.lex_state = 378, .external_lex_state = 16},
  [1470] = {.lex_state = 378, .external_lex_state = 16},
  [1471] = {.lex_state = 268, .external_lex_state = 21},
  [1472] = {.lex_state = 378, .external_lex_state = 16},
  [1473] = {.lex_state = 397, .external_lex_state = 10},
  [1474] = {.lex_state = 397, .external_lex_state = 10},
  [1475] = {.lex_state = 397, .external_lex_state = 10},
  [1476] = {.lex_state = 376, .external_lex_state = 16},
  [1477] = {.lex_state = 397, .external_lex_state = 10},
  [1478] = {.lex_state = 380},
  [1479] = {.lex_state = 378, .external_lex_state = 16},
  [1480] = {.lex_state = 203},
  [1481] = {.lex_state = 308, .external_lex_state = 16},
  [1482] = {.lex_state = 308, .external_lex_state = 16},
  [1483] = {.lex_state = 308, .external_lex_state = 16},
  [1484] = {.lex_state = 397, .external_lex_state = 10},
  [1485] = {.lex_state = 380},
  [1486] = {.lex_state = 378, .external_lex_state = 16},
  [1487] = {.lex_state = 397, .external_lex_state = 10},
  [1488] = {.lex_state = 380},
  [1489] = {.lex_state = 378, .external_lex_state = 16},
  [1490] = {.lex_state = 397, .external_lex_state = 10},
  [1491] = {.lex_state = 397, .external_lex_state = 10},
  [1492] = {.lex_state = 335, .external_lex_state = 4},
  [1493] = {.lex_state = 335, .external_lex_state = 4},
  [1494] = {.lex_state = 355, .external_lex_state = 2},
  [1495] = {.lex_state = 399, .external_lex_state = 2},
  [1496] = {.lex_state = 399, .external_lex_state = 2},
  [1497] = {.lex_state = 335, .external_lex_state = 4},
  [1498] = {.lex_state = 203},
  [1499] = {.lex_state = 231},
  [1500] = {.lex_state = 425, .external_lex_state = 2},
  [1501] = {.lex_state = 228},
  [1502] = {.lex_state = 419, .external_lex_state = 13},
  [1503] = {.lex_state = 425, .external_lex_state = 2},
  [1504] = {.lex_state = 228},
  [1505] = {.lex_state = 335, .external_lex_state = 4},
  [1506] = {.lex_state = 203},
  [1507] = {.lex_state = 231},
  [1508] = {.lex_state = 335, .external_lex_state = 4},
  [1509] = {.lex_state = 231},
  [1510] = {.lex_state = 335, .external_lex_state = 4},
  [1511] = {.lex_state = 203},
  [1512] = {.lex_state = 335, .external_lex_state = 4},
  [1513] = {.lex_state = 231},
  [1514] = {.lex_state = 270, .external_lex_state = 10},
  [1515] = {.lex_state = 270, .external_lex_state = 10},
  [1516] = {.lex_state = 270, .external_lex_state = 10},
  [1517] = {.lex_state = 378, .external_lex_state = 16},
  [1518] = {.lex_state = 411, .external_lex_state = 24},
  [1519] = {.lex_state = 411, .external_lex_state = 24},
  [1520] = {.lex_state = 203, .external_lex_state = 16},
  [1521] = {.lex_state = 378, .external_lex_state = 16},
  [1522] = {.lex_state = 270, .external_lex_state = 10},
  [1523] = {.lex_state = 378, .external_lex_state = 16},
  [1524] = {.lex_state = 270, .external_lex_state = 10},
  [1525] = {.lex_state = 378, .external_lex_state = 16},
  [1526] = {.lex_state = 270, .external_lex_state = 10},
  [1527] = {.lex_state = 378, .external_lex_state = 16},
  [1528] = {.lex_state = 270, .external_lex_state = 10},
  [1529] = {.lex_state = 378, .external_lex_state = 16},
  [1530] = {.lex_state = 335, .external_lex_state = 4},
  [1531] = {.lex_state = 421, .external_lex_state = 10},
  [1532] = {.lex_state = 421, .external_lex_state = 10},
  [1533] = {.lex_state = 335, .external_lex_state = 4},
  [1534] = {.lex_state = 421, .external_lex_state = 10},
  [1535] = {.lex_state = 268, .external_lex_state = 21},
  [1536] = {.lex_state = 409, .external_lex_state = 23},
  [1537] = {.lex_state = 231},
  [1538] = {.lex_state = 428, .external_lex_state = 10},
  [1539] = {.lex_state = 428, .external_lex_state = 10},
  [1540] = {.lex_state = 231},
  [1541] = {.lex_state = 372, .external_lex_state = 27},
  [1542] = {.lex_state = 372, .external_lex_state = 27},
  [1543] = {.lex_state = 372, .external_lex_state = 27},
  [1544] = {.lex_state = 372, .external_lex_state = 27},
  [1545] = {.lex_state = 372, .external_lex_state = 23},
  [1546] = {.lex_state = 372, .external_lex_state = 5},
  [1547] = {.lex_state = 297, .external_lex_state = 11},
  [1548] = {.lex_state = 297, .external_lex_state = 11},
  [1549] = {.lex_state = 297, .external_lex_state = 11},
  [1550] = {.lex_state = 378, .external_lex_state = 16},
  [1551] = {.lex_state = 411, .external_lex_state = 24},
  [1552] = {.lex_state = 411, .external_lex_state = 24},
  [1553] = {.lex_state = 203, .external_lex_state = 16},
  [1554] = {.lex_state = 378, .external_lex_state = 16},
  [1555] = {.lex_state = 297, .external_lex_state = 11},
  [1556] = {.lex_state = 378, .external_lex_state = 16},
  [1557] = {.lex_state = 297, .external_lex_state = 11},
  [1558] = {.lex_state = 378, .external_lex_state = 16},
  [1559] = {.lex_state = 297, .external_lex_state = 11},
  [1560] = {.lex_state = 378, .external_lex_state = 16},
  [1561] = {.lex_state = 297, .external_lex_state = 11},
  [1562] = {.lex_state = 378, .external_lex_state = 16},
  [1563] = {.lex_state = 343, .external_lex_state = 27},
  [1564] = {.lex_state = 343, .external_lex_state = 27},
  [1565] = {.lex_state = 389, .external_lex_state = 23},
  [1566] = {.lex_state = 231},
  [1567] = {.lex_state = 343, .external_lex_state = 27},
  [1568] = {.lex_state = 389, .external_lex_state = 27},
  [1569] = {.lex_state = 248},
  [1570] = {.lex_state = 389, .external_lex_state = 27},
  [1571] = {.lex_state = 389, .external_lex_state = 27},
  [1572] = {.lex_state = 389, .external_lex_state = 27},
  [1573] = {.lex_state = 203},
  [1574] = {.lex_state = 308, .external_lex_state = 16},
  [1575] = {.lex_state = 316, .external_lex_state = 6},
  [1576] = {.lex_state = 308, .external_lex_state = 16},
  [1577] = {.lex_state = 308, .external_lex_state = 16},
  [1578] = {.lex_state = 203},
  [1579] = {.lex_state = 322, .external_lex_state = 2},
  [1580] = {.lex_state = 203},
  [1581] = {.lex_state = 330, .external_lex_state = 2},
  [1582] = {.lex_state = 203},
  [1583] = {.lex_state = 322, .external_lex_state = 2},
  [1584] = {.lex_state = 374, .external_lex_state = 13},
  [1585] = {.lex_state = 374, .external_lex_state = 13},
  [1586] = {.lex_state = 374, .external_lex_state = 13},
  [1587] = {.lex_state = 378, .external_lex_state = 16},
  [1588] = {.lex_state = 411, .external_lex_state = 24},
  [1589] = {.lex_state = 411, .external_lex_state = 24},
  [1590] = {.lex_state = 203, .external_lex_state = 16},
  [1591] = {.lex_state = 378, .external_lex_state = 16},
  [1592] = {.lex_state = 374, .external_lex_state = 13},
  [1593] = {.lex_state = 378, .external_lex_state = 16},
  [1594] = {.lex_state = 374, .external_lex_state = 13},
  [1595] = {.lex_state = 378, .external_lex_state = 16},
  [1596] = {.lex_state = 374, .external_lex_state = 13},
  [1597] = {.lex_state = 378, .external_lex_state = 16},
  [1598] = {.lex_state = 374, .external_lex_state = 13},
  [1599] = {.lex_state = 378, .external_lex_state = 16},
  [1600] = {.lex_state = 273, .external_lex_state = 3},
  [1601] = {.lex_state = 273, .external_lex_state = 14},
  [1602] = {.lex_state = 273, .external_lex_state = 14},
  [1603] = {.lex_state = 273, .external_lex_state = 14},
  [1604] = {.lex_state = 378, .external_lex_state = 16},
  [1605] = {.lex_state = 411, .external_lex_state = 24},
  [1606] = {.lex_state = 411, .external_lex_state = 24},
  [1607] = {.lex_state = 203, .external_lex_state = 16},
  [1608] = {.lex_state = 378, .external_lex_state = 16},
  [1609] = {.lex_state = 273, .external_lex_state = 14},
  [1610] = {.lex_state = 378, .external_lex_state = 16},
  [1611] = {.lex_state = 273, .external_lex_state = 14},
  [1612] = {.lex_state = 378, .external_lex_state = 16},
  [1613] = {.lex_state = 273, .external_lex_state = 14},
  [1614] = {.lex_state = 378, .external_lex_state = 16},
  [1615] = {.lex_state = 273, .external_lex_state = 14},
  [1616] = {.lex_state = 378, .external_lex_state = 16},
  [1617] = {.lex_state = 273, .external_lex_state = 10},
  [1618] = {.lex_state = 273, .external_lex_state = 10},
  [1619] = {.lex_state = 273, .external_lex_state = 10},
  [1620] = {.lex_state = 378, .external_lex_state = 16},
  [1621] = {.lex_state = 411, .external_lex_state = 24},
  [1622] = {.lex_state = 411, .external_lex_state = 24},
  [1623] = {.lex_state = 203, .external_lex_state = 16},
  [1624] = {.lex_state = 378, .external_lex_state = 16},
  [1625] = {.lex_state = 273, .external_lex_state = 10},
  [1626] = {.lex_state = 378, .external_lex_state = 16},
  [1627] = {.lex_state = 273, .external_lex_state = 10},
  [1628] = {.lex_state = 378, .external_lex_state = 16},
  [1629] = {.lex_state = 273, .external_lex_state = 10},
  [1630] = {.lex_state = 378, .external_lex_state = 16},
  [1631] = {.lex_state = 273, .external_lex_state = 10},
  [1632] = {.lex_state = 378, .external_lex_state = 16},
  [1633] = {.lex_state = 322, .external_lex_state = 15},
  [1634] = {.lex_state = 322, .external_lex_state = 15},
  [1635] = {.lex_state = 322, .external_lex_state = 15},
  [1636] = {.lex_state = 378, .external_lex_state = 16},
  [1637] = {.lex_state = 411, .external_lex_state = 24},
  [1638] = {.lex_state = 411, .external_lex_state = 24},
  [1639] = {.lex_state = 203, .external_lex_state = 16},
  [1640] = {.lex_state = 378, .external_lex_state = 16},
  [1641] = {.lex_state = 322, .external_lex_state = 15},
  [1642] = {.lex_state = 378, .external_lex_state = 16},
  [1643] = {.lex_state = 322, .external_lex_state = 15},
  [1644] = {.lex_state = 378, .external_lex_state = 16},
  [1645] = {.lex_state = 322, .external_lex_state = 15},
  [1646] = {.lex_state = 378, .external_lex_state = 16},
  [1647] = {.lex_state = 322, .external_lex_state = 15},
  [1648] = {.lex_state = 378, .external_lex_state = 16},
  [1649] = {.lex_state = 248, .external_lex_state = 13},
  [1650] = {.lex_state = 248, .external_lex_state = 13},
  [1651] = {.lex_state = 248, .external_lex_state = 13},
  [1652] = {.lex_state = 378, .external_lex_state = 16},
  [1653] = {.lex_state = 411, .external_lex_state = 24},
  [1654] = {.lex_state = 411, .external_lex_state = 24},
  [1655] = {.lex_state = 203, .external_lex_state = 16},
  [1656] = {.lex_state = 378, .external_lex_state = 16},
  [1657] = {.lex_state = 248, .external_lex_state = 13},
  [1658] = {.lex_state = 378, .external_lex_state = 16},
  [1659] = {.lex_state = 248, .external_lex_state = 13},
  [1660] = {.lex_state = 378, .external_lex_state = 16},
  [1661] = {.lex_state = 248, .external_lex_state = 13},
  [1662] = {.lex_state = 378, .external_lex_state = 16},
  [1663] = {.lex_state = 248, .external_lex_state = 13},
  [1664] = {.lex_state = 378, .external_lex_state = 16},
  [1665] = {.lex_state = 308, .external_lex_state = 24},
  [1666] = {.lex_state = 308, .external_lex_state = 16},
  [1667] = {.lex_state = 308, .external_lex_state = 24},
  [1668] = {.lex_state = 308, .external_lex_state = 16},
  [1669] = {.lex_state = 411, .external_lex_state = 24},
  [1670] = {.lex_state = 411, .external_lex_state = 24},
  [1671] = {.lex_state = 411, .external_lex_state = 24},
  [1672] = {.lex_state = 376, .external_lex_state = 16},
  [1673] = {.lex_state = 411, .external_lex_state = 24},
  [1674] = {.lex_state = 380},
  [1675] = {.lex_state = 378, .external_lex_state = 16},
  [1676] = {.lex_state = 203},
  [1677] = {.lex_state = 308, .external_lex_state = 16},
  [1678] = {.lex_state = 308, .external_lex_state = 16},
  [1679] = {.lex_state = 308, .external_lex_state = 16},
  [1680] = {.lex_state = 411, .external_lex_state = 24},
  [1681] = {.lex_state = 380},
  [1682] = {.lex_state = 378, .external_lex_state = 16},
  [1683] = {.lex_state = 411, .external_lex_state = 24},
  [1684] = {.lex_state = 380},
  [1685] = {.lex_state = 378, .external_lex_state = 16},
  [1686] = {.lex_state = 411, .external_lex_state = 24},
  [1687] = {.lex_state = 411, .external_lex_state = 24},
  [1688] = {.lex_state = 378, .external_lex_state = 24},
  [1689] = {.lex_state = 411, .external_lex_state = 24},
  [1690] = {.lex_state = 411, .external_lex_state = 24},
  [1691] = {.lex_state = 203, .external_lex_state = 16},
  [1692] = {.lex_state = 378, .external_lex_state = 16},
  [1693] = {.lex_state = 378, .external_lex_state = 24},
  [1694] = {.lex_state = 376, .external_lex_state = 16},
  [1695] = {.lex_state = 378, .external_lex_state = 24},
  [1696] = {.lex_state = 380},
  [1697] = {.lex_state = 378, .external_lex_state = 16},
  [1698] = {.lex_state = 378, .external_lex_state = 24},
  [1699] = {.lex_state = 380},
  [1700] = {.lex_state = 378, .external_lex_state = 16},
  [1701] = {.lex_state = 380},
  [1702] = {.lex_state = 378, .external_lex_state = 16},
  [1703] = {.lex_state = 378, .external_lex_state = 16},
  [1704] = {.lex_state = 378, .external_lex_state = 24},
  [1705] = {.lex_state = 378, .external_lex_state = 16},
  [1706] = {.lex_state = 264, .external_lex_state = 5},
  [1707] = {.lex_state = 264, .external_lex_state = 5},
  [1708] = {.lex_state = 264, .external_lex_state = 5},
  [1709] = {.lex_state = 264, .external_lex_state = 5},
  [1710] = {.lex_state = 378, .external_lex_state = 16},
  [1711] = {.lex_state = 264, .external_lex_state = 5},
  [1712] = {.lex_state = 378, .external_lex_state = 16},
  [1713] = {.lex_state = 264, .external_lex_state = 5},
  [1714] = {.lex_state = 378, .external_lex_state = 16},
  [1715] = {.lex_state = 264, .external_lex_state = 5},
  [1716] = {.lex_state = 264, .external_lex_state = 5},
  [1717] = {.lex_state = 322, .external_lex_state = 2},
  [1718] = {.lex_state = 322, .external_lex_state = 15},
  [1719] = {.lex_state = 203},
  [1720] = {.lex_state = 203},
  [1721] = {.lex_state = 349, .external_lex_state = 2},
  [1722] = {.lex_state = 415, .external_lex_state = 18},
  [1723] = {.lex_state = 203},
  [1724] = {.lex_state = 203},
  [1725] = {.lex_state = 203},
  [1726] = {.lex_state = 203},
  [1727] = {.lex_state = 203},
  [1728] = {.lex_state = 203},
  [1729] = {.lex_state = 231},
  [1730] = {.lex_state = 401},
  [1731] = {.lex_state = 203},
  [1732] = {.lex_state = 203},
  [1733] = {.lex_state = 231},
  [1734] = {.lex_state = 401},
  [1735] = {.lex_state = 413, .external_lex_state = 26},
  [1736] = {.lex_state = 423, .external_lex_state = 26},
  [1737] = {.lex_state = 231},
  [1738] = {.lex_state = 430, .external_lex_state = 13},
  [1739] = {.lex_state = 430, .external_lex_state = 13},
  [1740] = {.lex_state = 203},
  [1741] = {.lex_state = 203},
  [1742] = {.lex_state = 231},
  [1743] = {.lex_state = 385, .external_lex_state = 28},
  [1744] = {.lex_state = 248},
  [1745] = {.lex_state = 255},
  [1746] = {.lex_state = 385, .external_lex_state = 28},
  [1747] = {.lex_state = 258, .external_lex_state = 6},
  [1748] = {.lex_state = 133, .external_lex_state = 2},
  [1749] = {.lex_state = 133, .external_lex_state = 2},
  [1750] = {.lex_state = 133, .external_lex_state = 2},
  [1751] = {.lex_state = 415, .external_lex_state = 26},
  [1752] = {.lex_state = 415, .external_lex_state = 26},
  [1753] = {.lex_state = 385, .external_lex_state = 28},
  [1754] = {.lex_state = 385, .external_lex_state = 28},
  [1755] = {.lex_state = 415, .external_lex_state = 26},
  [1756] = {.lex_state = 385, .external_lex_state = 26},
  [1757] = {.lex_state = 318, .external_lex_state = 6},
  [1758] = {.lex_state = 322},
  [1759] = {.lex_state = 318, .external_lex_state = 25},
  [1760] = {.lex_state = 411, .external_lex_state = 24},
  [1761] = {.lex_state = 411, .external_lex_state = 24},
  [1762] = {.lex_state = 203, .external_lex_state = 16},
  [1763] = {.lex_state = 378, .external_lex_state = 16},
  [1764] = {.lex_state = 318, .external_lex_state = 25},
  [1765] = {.lex_state = 376, .external_lex_state = 16},
  [1766] = {.lex_state = 318, .external_lex_state = 25},
  [1767] = {.lex_state = 380},
  [1768] = {.lex_state = 378, .external_lex_state = 16},
  [1769] = {.lex_state = 318, .external_lex_state = 25},
  [1770] = {.lex_state = 380},
  [1771] = {.lex_state = 378, .external_lex_state = 16},
  [1772] = {.lex_state = 380},
  [1773] = {.lex_state = 378, .external_lex_state = 16},
  [1774] = {.lex_state = 378, .external_lex_state = 16},
  [1775] = {.lex_state = 318, .external_lex_state = 25},
  [1776] = {.lex_state = 378, .external_lex_state = 16},
  [1777] = {.lex_state = 318, .external_lex_state = 13},
  [1778] = {.lex_state = 411, .external_lex_state = 24},
  [1779] = {.lex_state = 411, .external_lex_state = 24},
  [1780] = {.lex_state = 203, .external_lex_state = 16},
  [1781] = {.lex_state = 378, .external_lex_state = 16},
  [1782] = {.lex_state = 318, .external_lex_state = 13},
  [1783] = {.lex_state = 376, .external_lex_state = 16},
  [1784] = {.lex_state = 318, .external_lex_state = 13},
  [1785] = {.lex_state = 380},
  [1786] = {.lex_state = 378, .external_lex_state = 16},
  [1787] = {.lex_state = 318, .external_lex_state = 13},
  [1788] = {.lex_state = 380},
  [1789] = {.lex_state = 378, .external_lex_state = 16},
  [1790] = {.lex_state = 380},
  [1791] = {.lex_state = 378, .external_lex_state = 16},
  [1792] = {.lex_state = 378, .external_lex_state = 16},
  [1793] = {.lex_state = 318, .external_lex_state = 13},
  [1794] = {.lex_state = 378, .external_lex_state = 16},
  [1795] = {.lex_state = 233, .external_lex_state = 17},
  [1796] = {.lex_state = 233, .external_lex_state = 17},
  [1797] = {.lex_state = 233, .external_lex_state = 17},
  [1798] = {.lex_state = 378, .external_lex_state = 16},
  [1799] = {.lex_state = 411, .external_lex_state = 24},
  [1800] = {.lex_state = 411, .external_lex_state = 24},
  [1801] = {.lex_state = 203, .external_lex_state = 16},
  [1802] = {.lex_state = 378, .external_lex_state = 16},
  [1803] = {.lex_state = 233, .external_lex_state = 17},
  [1804] = {.lex_state = 378, .external_lex_state = 16},
  [1805] = {.lex_state = 233, .external_lex_state = 17},
  [1806] = {.lex_state = 378, .external_lex_state = 16},
  [1807] = {.lex_state = 233, .external_lex_state = 17},
  [1808] = {.lex_state = 378, .external_lex_state = 16},
  [1809] = {.lex_state = 233, .external_lex_state = 17},
  [1810] = {.lex_state = 378, .external_lex_state = 16},
  [1811] = {.lex_state = 203},
  [1812] = {.lex_state = 385, .external_lex_state = 17},
  [1813] = {.lex_state = 203},
  [1814] = {.lex_state = 330, .external_lex_state = 15},
  [1815] = {.lex_state = 417, .external_lex_state = 26},
  [1816] = {.lex_state = 231},
  [1817] = {.lex_state = 432, .external_lex_state = 13},
  [1818] = {.lex_state = 432, .external_lex_state = 13},
  [1819] = {.lex_state = 231},
  [1820] = {.lex_state = 387, .external_lex_state = 28},
  [1821] = {.lex_state = 387, .external_lex_state = 28},
  [1822] = {.lex_state = 387, .external_lex_state = 28},
  [1823] = {.lex_state = 387, .external_lex_state = 28},
  [1824] = {.lex_state = 387, .external_lex_state = 26},
  [1825] = {.lex_state = 387, .external_lex_state = 17},
  [1826] = {.lex_state = 338, .external_lex_state = 19},
  [1827] = {.lex_state = 411, .external_lex_state = 24},
  [1828] = {.lex_state = 411, .external_lex_state = 24},
  [1829] = {.lex_state = 203, .external_lex_state = 16},
  [1830] = {.lex_state = 378, .external_lex_state = 16},
  [1831] = {.lex_state = 338, .external_lex_state = 19},
  [1832] = {.lex_state = 376, .external_lex_state = 16},
  [1833] = {.lex_state = 338, .external_lex_state = 19},
  [1834] = {.lex_state = 380},
  [1835] = {.lex_state = 378, .external_lex_state = 16},
  [1836] = {.lex_state = 338, .external_lex_state = 19},
  [1837] = {.lex_state = 380},
  [1838] = {.lex_state = 378, .external_lex_state = 16},
  [1839] = {.lex_state = 380},
  [1840] = {.lex_state = 378, .external_lex_state = 16},
  [1841] = {.lex_state = 378, .external_lex_state = 16},
  [1842] = {.lex_state = 338, .external_lex_state = 19},
  [1843] = {.lex_state = 378, .external_lex_state = 16},
  [1844] = {.lex_state = 395, .external_lex_state = 13},
  [1845] = {.lex_state = 411, .external_lex_state = 24},
  [1846] = {.lex_state = 411, .external_lex_state = 24},
  [1847] = {.lex_state = 203, .external_lex_state = 16},
  [1848] = {.lex_state = 378, .external_lex_state = 16},
  [1849] = {.lex_state = 395, .external_lex_state = 13},
  [1850] = {.lex_state = 376, .external_lex_state = 16},
  [1851] = {.lex_state = 395, .external_lex_state = 13},
  [1852] = {.lex_state = 380},
  [1853] = {.lex_state = 378, .external_lex_state = 16},
  [1854] = {.lex_state = 395, .external_lex_state = 13},
  [1855] = {.lex_state = 380},
  [1856] = {.lex_state = 378, .external_lex_state = 16},
  [1857] = {.lex_state = 380},
  [1858] = {.lex_state = 378, .external_lex_state = 16},
  [1859] = {.lex_state = 378, .external_lex_state = 16},
  [1860] = {.lex_state = 395, .external_lex_state = 13},
  [1861] = {.lex_state = 378, .external_lex_state = 16},
  [1862] = {.lex_state = 268, .external_lex_state = 21},
  [1863] = {.lex_state = 268, .external_lex_state = 21},
  [1864] = {.lex_state = 268, .external_lex_state = 21},
  [1865] = {.lex_state = 378, .external_lex_state = 16},
  [1866] = {.lex_state = 411, .external_lex_state = 24},
  [1867] = {.lex_state = 411, .external_lex_state = 24},
  [1868] = {.lex_state = 203, .external_lex_state = 16},
  [1869] = {.lex_state = 378, .external_lex_state = 16},
  [1870] = {.lex_state = 268, .external_lex_state = 21},
  [1871] = {.lex_state = 378, .external_lex_state = 16},
  [1872] = {.lex_state = 268, .external_lex_state = 21},
  [1873] = {.lex_state = 378, .external_lex_state = 16},
  [1874] = {.lex_state = 268, .external_lex_state = 21},
  [1875] = {.lex_state = 378, .external_lex_state = 16},
  [1876] = {.lex_state = 268, .external_lex_state = 21},
  [1877] = {.lex_state = 378, .external_lex_state = 16},
  [1878] = {.lex_state = 397, .external_lex_state = 10},
  [1879] = {.lex_state = 411, .external_lex_state = 24},
  [1880] = {.lex_state = 411, .external_lex_state = 24},
  [1881] = {.lex_state = 203, .external_lex_state = 16},
  [1882] = {.lex_state = 378, .external_lex_state = 16},
  [1883] = {.lex_state = 397, .external_lex_state = 10},
  [1884] = {.lex_state = 376, .external_lex_state = 16},
  [1885] = {.lex_state = 397, .external_lex_state = 10},
  [1886] = {.lex_state = 380},
  [1887] = {.lex_state = 378, .external_lex_state = 16},
  [1888] = {.lex_state = 397, .external_lex_state = 10},
  [1889] = {.lex_state = 380},
  [1890] = {.lex_state = 378, .external_lex_state = 16},
  [1891] = {.lex_state = 380},
  [1892] = {.lex_state = 378, .external_lex_state = 16},
  [1893] = {.lex_state = 378, .external_lex_state = 16},
  [1894] = {.lex_state = 397, .external_lex_state = 10},
  [1895] = {.lex_state = 378, .external_lex_state = 16},
  [1896] = {.lex_state = 355, .external_lex_state = 2},
  [1897] = {.lex_state = 335, .external_lex_state = 4},
  [1898] = {.lex_state = 419, .external_lex_state = 13},
  [1899] = {.lex_state = 419, .external_lex_state = 13},
  [1900] = {.lex_state = 228},
  [1901] = {.lex_state = 203},
  [1902] = {.lex_state = 133, .external_lex_state = 2},
  [1903] = {.lex_state = 401},
  [1904] = {.lex_state = 231},
  [1905] = {.lex_state = 233},
  [1906] = {.lex_state = 233},
  [1907] = {.lex_state = 434, .external_lex_state = 3},
  [1908] = {.lex_state = 434, .external_lex_state = 4},
  [1909] = {.lex_state = 440, .external_lex_state = 5},
  [1910] = {.lex_state = 248},
  [1911] = {.lex_state = 255},
  [1912] = {.lex_state = 440, .external_lex_state = 5},
  [1913] = {.lex_state = 258, .external_lex_state = 6},
  [1914] = {.lex_state = 133, .external_lex_state = 2},
  [1915] = {.lex_state = 133, .external_lex_state = 2},
  [1916] = {.lex_state = 133, .external_lex_state = 2},
  [1917] = {.lex_state = 442, .external_lex_state = 5},
  [1918] = {.lex_state = 335, .external_lex_state = 4},
  [1919] = {.lex_state = 440, .external_lex_state = 7},
  [1920] = {.lex_state = 444, .external_lex_state = 8},
  [1921] = {.lex_state = 203},
  [1922] = {.lex_state = 440, .external_lex_state = 7},
  [1923] = {.lex_state = 425, .external_lex_state = 2},
  [1924] = {.lex_state = 231, .external_lex_state = 2},
  [1925] = {.lex_state = 425, .external_lex_state = 2},
  [1926] = {.lex_state = 228},
  [1927] = {.lex_state = 419, .external_lex_state = 13},
  [1928] = {.lex_state = 401},
  [1929] = {.lex_state = 335, .external_lex_state = 4},
  [1930] = {.lex_state = 444, .external_lex_state = 8},
  [1931] = {.lex_state = 425, .external_lex_state = 2},
  [1932] = {.lex_state = 425, .external_lex_state = 2},
  [1933] = {.lex_state = 335, .external_lex_state = 4},
  [1934] = {.lex_state = 419, .external_lex_state = 13},
  [1935] = {.lex_state = 419, .external_lex_state = 13},
  [1936] = {.lex_state = 228},
  [1937] = {.lex_state = 203},
  [1938] = {.lex_state = 335, .external_lex_state = 4},
  [1939] = {.lex_state = 203},
  [1940] = {.lex_state = 270, .external_lex_state = 10},
  [1941] = {.lex_state = 270, .external_lex_state = 10},
  [1942] = {.lex_state = 270, .external_lex_state = 10},
  [1943] = {.lex_state = 270, .external_lex_state = 10},
  [1944] = {.lex_state = 378, .external_lex_state = 16},
  [1945] = {.lex_state = 270, .external_lex_state = 10},
  [1946] = {.lex_state = 378, .external_lex_state = 16},
  [1947] = {.lex_state = 270, .external_lex_state = 10},
  [1948] = {.lex_state = 378, .external_lex_state = 16},
  [1949] = {.lex_state = 270, .external_lex_state = 10},
  [1950] = {.lex_state = 270, .external_lex_state = 10},
  [1951] = {.lex_state = 421, .external_lex_state = 10},
  [1952] = {.lex_state = 428, .external_lex_state = 10},
  [1953] = {.lex_state = 428, .external_lex_state = 10},
  [1954] = {.lex_state = 428, .external_lex_state = 10},
  [1955] = {.lex_state = 372, .external_lex_state = 27},
  [1956] = {.lex_state = 372, .external_lex_state = 27},
  [1957] = {.lex_state = 372, .external_lex_state = 27},
  [1958] = {.lex_state = 297, .external_lex_state = 11},
  [1959] = {.lex_state = 297, .external_lex_state = 11},
  [1960] = {.lex_state = 297, .external_lex_state = 11},
  [1961] = {.lex_state = 297, .external_lex_state = 11},
  [1962] = {.lex_state = 378, .external_lex_state = 16},
  [1963] = {.lex_state = 297, .external_lex_state = 11},
  [1964] = {.lex_state = 378, .external_lex_state = 16},
  [1965] = {.lex_state = 297, .external_lex_state = 11},
  [1966] = {.lex_state = 378, .external_lex_state = 16},
  [1967] = {.lex_state = 297, .external_lex_state = 11},
  [1968] = {.lex_state = 297, .external_lex_state = 11},
  [1969] = {.lex_state = 389, .external_lex_state = 27},
  [1970] = {.lex_state = 343, .external_lex_state = 27},
  [1971] = {.lex_state = 389, .external_lex_state = 27},
  [1972] = {.lex_state = 376, .external_lex_state = 16},
  [1973] = {.lex_state = 389, .external_lex_state = 27},
  [1974] = {.lex_state = 380},
  [1975] = {.lex_state = 378, .external_lex_state = 16},
  [1976] = {.lex_state = 203},
  [1977] = {.lex_state = 308, .external_lex_state = 16},
  [1978] = {.lex_state = 308, .external_lex_state = 16},
  [1979] = {.lex_state = 308, .external_lex_state = 16},
  [1980] = {.lex_state = 389, .external_lex_state = 27},
  [1981] = {.lex_state = 380},
  [1982] = {.lex_state = 378, .external_lex_state = 16},
  [1983] = {.lex_state = 389, .external_lex_state = 27},
  [1984] = {.lex_state = 380},
  [1985] = {.lex_state = 378, .external_lex_state = 16},
  [1986] = {.lex_state = 389, .external_lex_state = 27},
  [1987] = {.lex_state = 389, .external_lex_state = 27},
  [1988] = {.lex_state = 374, .external_lex_state = 13},
  [1989] = {.lex_state = 374, .external_lex_state = 13},
  [1990] = {.lex_state = 374, .external_lex_state = 13},
  [1991] = {.lex_state = 374, .external_lex_state = 13},
  [1992] = {.lex_state = 378, .external_lex_state = 16},
  [1993] = {.lex_state = 374, .external_lex_state = 13},
  [1994] = {.lex_state = 378, .external_lex_state = 16},
  [1995] = {.lex_state = 374, .external_lex_state = 13},
  [1996] = {.lex_state = 378, .external_lex_state = 16},
  [1997] = {.lex_state = 374, .external_lex_state = 13},
  [1998] = {.lex_state = 374, .external_lex_state = 13},
  [1999] = {.lex_state = 273, .external_lex_state = 14},
  [2000] = {.lex_state = 273, .external_lex_state = 14},
  [2001] = {.lex_state = 273, .external_lex_state = 14},
  [2002] = {.lex_state = 273, .external_lex_state = 14},
  [2003] = {.lex_state = 378, .external_lex_state = 16},
  [2004] = {.lex_state = 273, .external_lex_state = 14},
  [2005] = {.lex_state = 378, .external_lex_state = 16},
  [2006] = {.lex_state = 273, .external_lex_state = 14},
  [2007] = {.lex_state = 378, .external_lex_state = 16},
  [2008] = {.lex_state = 273, .external_lex_state = 14},
  [2009] = {.lex_state = 273, .external_lex_state = 14},
  [2010] = {.lex_state = 273, .external_lex_state = 10},
  [2011] = {.lex_state = 273, .external_lex_state = 10},
  [2012] = {.lex_state = 273, .external_lex_state = 10},
  [2013] = {.lex_state = 273, .external_lex_state = 10},
  [2014] = {.lex_state = 378, .external_lex_state = 16},
  [2015] = {.lex_state = 273, .external_lex_state = 10},
  [2016] = {.lex_state = 378, .external_lex_state = 16},
  [2017] = {.lex_state = 273, .external_lex_state = 10},
  [2018] = {.lex_state = 378, .external_lex_state = 16},
  [2019] = {.lex_state = 273, .external_lex_state = 10},
  [2020] = {.lex_state = 273, .external_lex_state = 10},
  [2021] = {.lex_state = 322, .external_lex_state = 15},
  [2022] = {.lex_state = 322, .external_lex_state = 15},
  [2023] = {.lex_state = 322, .external_lex_state = 15},
  [2024] = {.lex_state = 322, .external_lex_state = 15},
  [2025] = {.lex_state = 378, .external_lex_state = 16},
  [2026] = {.lex_state = 322, .external_lex_state = 15},
  [2027] = {.lex_state = 378, .external_lex_state = 16},
  [2028] = {.lex_state = 322, .external_lex_state = 15},
  [2029] = {.lex_state = 378, .external_lex_state = 16},
  [2030] = {.lex_state = 322, .external_lex_state = 15},
  [2031] = {.lex_state = 322, .external_lex_state = 15},
  [2032] = {.lex_state = 248, .external_lex_state = 13},
  [2033] = {.lex_state = 248, .external_lex_state = 13},
  [2034] = {.lex_state = 248, .external_lex_state = 13},
  [2035] = {.lex_state = 248, .external_lex_state = 13},
  [2036] = {.lex_state = 378, .external_lex_state = 16},
  [2037] = {.lex_state = 248, .external_lex_state = 13},
  [2038] = {.lex_state = 378, .external_lex_state = 16},
  [2039] = {.lex_state = 248, .external_lex_state = 13},
  [2040] = {.lex_state = 378, .external_lex_state = 16},
  [2041] = {.lex_state = 248, .external_lex_state = 13},
  [2042] = {.lex_state = 248, .external_lex_state = 13},
  [2043] = {.lex_state = 308, .external_lex_state = 16},
  [2044] = {.lex_state = 308, .external_lex_state = 16},
  [2045] = {.lex_state = 411, .external_lex_state = 24},
  [2046] = {.lex_state = 411, .external_lex_state = 24},
  [2047] = {.lex_state = 411, .external_lex_state = 24},
  [2048] = {.lex_state = 203, .external_lex_state = 16},
  [2049] = {.lex_state = 378, .external_lex_state = 16},
  [2050] = {.lex_state = 411, .external_lex_state = 24},
  [2051] = {.lex_state = 376, .external_lex_state = 16},
  [2052] = {.lex_state = 411, .external_lex_state = 24},
  [2053] = {.lex_state = 380},
  [2054] = {.lex_state = 378, .external_lex_state = 16},
  [2055] = {.lex_state = 411, .external_lex_state = 24},
  [2056] = {.lex_state = 380},
  [2057] = {.lex_state = 378, .external_lex_state = 16},
  [2058] = {.lex_state = 380},
  [2059] = {.lex_state = 378, .external_lex_state = 16},
  [2060] = {.lex_state = 378, .external_lex_state = 16},
  [2061] = {.lex_state = 411, .external_lex_state = 24},
  [2062] = {.lex_state = 378, .external_lex_state = 16},
  [2063] = {.lex_state = 378, .external_lex_state = 24},
  [2064] = {.lex_state = 378, .external_lex_state = 24},
  [2065] = {.lex_state = 378, .external_lex_state = 24},
  [2066] = {.lex_state = 378, .external_lex_state = 16},
  [2067] = {.lex_state = 411, .external_lex_state = 24},
  [2068] = {.lex_state = 411, .external_lex_state = 24},
  [2069] = {.lex_state = 203, .external_lex_state = 16},
  [2070] = {.lex_state = 378, .external_lex_state = 16},
  [2071] = {.lex_state = 378, .external_lex_state = 24},
  [2072] = {.lex_state = 378, .external_lex_state = 16},
  [2073] = {.lex_state = 378, .external_lex_state = 24},
  [2074] = {.lex_state = 378, .external_lex_state = 16},
  [2075] = {.lex_state = 378, .external_lex_state = 24},
  [2076] = {.lex_state = 378, .external_lex_state = 16},
  [2077] = {.lex_state = 378, .external_lex_state = 24},
  [2078] = {.lex_state = 378, .external_lex_state = 16},
  [2079] = {.lex_state = 264, .external_lex_state = 5},
  [2080] = {.lex_state = 264, .external_lex_state = 5},
  [2081] = {.lex_state = 264, .external_lex_state = 5},
  [2082] = {.lex_state = 203},
  [2083] = {.lex_state = 203},
  [2084] = {.lex_state = 203},
  [2085] = {.lex_state = 203},
  [2086] = {.lex_state = 203},
  [2087] = {.lex_state = 203},
  [2088] = {.lex_state = 203},
  [2089] = {.lex_state = 231},
  [2090] = {.lex_state = 203},
  [2091] = {.lex_state = 203},
  [2092] = {.lex_state = 203},
  [2093] = {.lex_state = 231},
  [2094] = {.lex_state = 203},
  [2095] = {.lex_state = 430, .external_lex_state = 13},
  [2096] = {.lex_state = 430, .external_lex_state = 13},
  [2097] = {.lex_state = 203},
  [2098] = {.lex_state = 430, .external_lex_state = 13},
  [2099] = {.lex_state = 385, .external_lex_state = 28},
  [2100] = {.lex_state = 385, .external_lex_state = 28},
  [2101] = {.lex_state = 415, .external_lex_state = 26},
  [2102] = {.lex_state = 231},
  [2103] = {.lex_state = 385, .external_lex_state = 28},
  [2104] = {.lex_state = 415, .external_lex_state = 28},
  [2105] = {.lex_state = 248},
  [2106] = {.lex_state = 415, .external_lex_state = 28},
  [2107] = {.lex_state = 415, .external_lex_state = 28},
  [2108] = {.lex_state = 415, .external_lex_state = 28},
  [2109] = {.lex_state = 203},
  [2110] = {.lex_state = 308, .external_lex_state = 16},
  [2111] = {.lex_state = 316, .external_lex_state = 6},
  [2112] = {.lex_state = 308, .external_lex_state = 16},
  [2113] = {.lex_state = 308, .external_lex_state = 16},
  [2114] = {.lex_state = 203},
  [2115] = {.lex_state = 322, .external_lex_state = 2},
  [2116] = {.lex_state = 203},
  [2117] = {.lex_state = 330, .external_lex_state = 2},
  [2118] = {.lex_state = 203},
  [2119] = {.lex_state = 322, .external_lex_state = 2},
  [2120] = {.lex_state = 318, .external_lex_state = 6},
  [2121] = {.lex_state = 318, .external_lex_state = 25},
  [2122] = {.lex_state = 318, .external_lex_state = 25},
  [2123] = {.lex_state = 318, .external_lex_state = 25},
  [2124] = {.lex_state = 378, .external_lex_state = 16},
  [2125] = {.lex_state = 411, .external_lex_state = 24},
  [2126] = {.lex_state = 411, .external_lex_state = 24},
  [2127] = {.lex_state = 203, .external_lex_state = 16},
  [2128] = {.lex_state = 378, .external_lex_state = 16},
  [2129] = {.lex_state = 318, .external_lex_state = 25},
  [2130] = {.lex_state = 378, .external_lex_state = 16},
  [2131] = {.lex_state = 318, .external_lex_state = 25},
  [2132] = {.lex_state = 378, .external_lex_state = 16},
  [2133] = {.lex_state = 318, .external_lex_state = 25},
  [2134] = {.lex_state = 378, .external_lex_state = 16},
  [2135] = {.lex_state = 318, .external_lex_state = 25},
  [2136] = {.lex_state = 378, .external_lex_state = 16},
  [2137] = {.lex_state = 318, .external_lex_state = 13},
  [2138] = {.lex_state = 318, .external_lex_state = 13},
  [2139] = {.lex_state = 318, .external_lex_state = 13},
  [2140] = {.lex_state = 378, .external_lex_state = 16},
  [2141] = {.lex_state = 411, .external_lex_state = 24},
  [2142] = {.lex_state = 411, .external_lex_state = 24},
  [2143] = {.lex_state = 203, .external_lex_state = 16},
  [2144] = {.lex_state = 378, .external_lex_state = 16},
  [2145] = {.lex_state = 318, .external_lex_state = 13},
  [2146] = {.lex_state = 378, .external_lex_state = 16},
  [2147] = {.lex_state = 318, .external_lex_state = 13},
  [2148] = {.lex_state = 378, .external_lex_state = 16},
  [2149] = {.lex_state = 318, .external_lex_state = 13},
  [2150] = {.lex_state = 378, .external_lex_state = 16},
  [2151] = {.lex_state = 318, .external_lex_state = 13},
  [2152] = {.lex_state = 378, .external_lex_state = 16},
  [2153] = {.lex_state = 233, .external_lex_state = 17},
  [2154] = {.lex_state = 233, .external_lex_state = 17},
  [2155] = {.lex_state = 233, .external_lex_state = 17},
  [2156] = {.lex_state = 233, .external_lex_state = 17},
  [2157] = {.lex_state = 378, .external_lex_state = 16},
  [2158] = {.lex_state = 233, .external_lex_state = 17},
  [2159] = {.lex_state = 378, .external_lex_state = 16},
  [2160] = {.lex_state = 233, .external_lex_state = 17},
  [2161] = {.lex_state = 378, .external_lex_state = 16},
  [2162] = {.lex_state = 233, .external_lex_state = 17},
  [2163] = {.lex_state = 233, .external_lex_state = 17},
  [2164] = {.lex_state = 432, .external_lex_state = 13},
  [2165] = {.lex_state = 432, .external_lex_state = 13},
  [2166] = {.lex_state = 432, .external_lex_state = 13},
  [2167] = {.lex_state = 387, .external_lex_state = 28},
  [2168] = {.lex_state = 387, .external_lex_state = 28},
  [2169] = {.lex_state = 387, .external_lex_state = 28},
  [2170] = {.lex_state = 338, .external_lex_state = 19},
  [2171] = {.lex_state = 338, .external_lex_state = 19},
  [2172] = {.lex_state = 338, .external_lex_state = 19},
  [2173] = {.lex_state = 378, .external_lex_state = 16},
  [2174] = {.lex_state = 411, .external_lex_state = 24},
  [2175] = {.lex_state = 411, .external_lex_state = 24},
  [2176] = {.lex_state = 203, .external_lex_state = 16},
  [2177] = {.lex_state = 378, .external_lex_state = 16},
  [2178] = {.lex_state = 338, .external_lex_state = 19},
  [2179] = {.lex_state = 378, .external_lex_state = 16},
  [2180] = {.lex_state = 338, .external_lex_state = 19},
  [2181] = {.lex_state = 378, .external_lex_state = 16},
  [2182] = {.lex_state = 338, .external_lex_state = 19},
  [2183] = {.lex_state = 378, .external_lex_state = 16},
  [2184] = {.lex_state = 338, .external_lex_state = 19},
  [2185] = {.lex_state = 378, .external_lex_state = 16},
  [2186] = {.lex_state = 395, .external_lex_state = 13},
  [2187] = {.lex_state = 395, .external_lex_state = 13},
  [2188] = {.lex_state = 395, .external_lex_state = 13},
  [2189] = {.lex_state = 378, .external_lex_state = 16},
  [2190] = {.lex_state = 411, .external_lex_state = 24},
  [2191] = {.lex_state = 411, .external_lex_state = 24},
  [2192] = {.lex_state = 203, .external_lex_state = 16},
  [2193] = {.lex_state = 378, .external_lex_state = 16},
  [2194] = {.lex_state = 395, .external_lex_state = 13},
  [2195] = {.lex_state = 378, .external_lex_state = 16},
  [2196] = {.lex_state = 395, .external_lex_state = 13},
  [2197] = {.lex_state = 378, .external_lex_state = 16},
  [2198] = {.lex_state = 395, .external_lex_state = 13},
  [2199] = {.lex_state = 378, .external_lex_state = 16},
  [2200] = {.lex_state = 395, .external_lex_state = 13},
  [2201] = {.lex_state = 378, .external_lex_state = 16},
  [2202] = {.lex_state = 268, .external_lex_state = 21},
  [2203] = {.lex_state = 268, .external_lex_state = 21},
  [2204] = {.lex_state = 268, .external_lex_state = 21},
  [2205] = {.lex_state = 268, .external_lex_state = 21},
  [2206] = {.lex_state = 378, .external_lex_state = 16},
  [2207] = {.lex_state = 268, .external_lex_state = 21},
  [2208] = {.lex_state = 378, .external_lex_state = 16},
  [2209] = {.lex_state = 268, .external_lex_state = 21},
  [2210] = {.lex_state = 378, .external_lex_state = 16},
  [2211] = {.lex_state = 268, .external_lex_state = 21},
  [2212] = {.lex_state = 268, .external_lex_state = 21},
  [2213] = {.lex_state = 397, .external_lex_state = 10},
  [2214] = {.lex_state = 397, .external_lex_state = 10},
  [2215] = {.lex_state = 397, .external_lex_state = 10},
  [2216] = {.lex_state = 378, .external_lex_state = 16},
  [2217] = {.lex_state = 411, .external_lex_state = 24},
  [2218] = {.lex_state = 411, .external_lex_state = 24},
  [2219] = {.lex_state = 203, .external_lex_state = 16},
  [2220] = {.lex_state = 378, .external_lex_state = 16},
  [2221] = {.lex_state = 397, .external_lex_state = 10},
  [2222] = {.lex_state = 378, .external_lex_state = 16},
  [2223] = {.lex_state = 397, .external_lex_state = 10},
  [2224] = {.lex_state = 378, .external_lex_state = 16},
  [2225] = {.lex_state = 397, .external_lex_state = 10},
  [2226] = {.lex_state = 378, .external_lex_state = 16},
  [2227] = {.lex_state = 397, .external_lex_state = 10},
  [2228] = {.lex_state = 378, .external_lex_state = 16},
  [2229] = {.lex_state = 266, .external_lex_state = 9},
  [2230] = {.lex_state = 444, .external_lex_state = 8},
  [2231] = {.lex_state = 203},
  [2232] = {.lex_state = 203},
  [2233] = {.lex_state = 297, .external_lex_state = 12},
  [2234] = {.lex_state = 299},
  [2235] = {.lex_state = 203},
  [2236] = {.lex_state = 434, .external_lex_state = 14},
  [2237] = {.lex_state = 248},
  [2238] = {.lex_state = 255},
  [2239] = {.lex_state = 434, .external_lex_state = 14},
  [2240] = {.lex_state = 258, .external_lex_state = 6},
  [2241] = {.lex_state = 133, .external_lex_state = 2},
  [2242] = {.lex_state = 133, .external_lex_state = 2},
  [2243] = {.lex_state = 133, .external_lex_state = 2},
  [2244] = {.lex_state = 434, .external_lex_state = 3},
  [2245] = {.lex_state = 203},
  [2246] = {.lex_state = 434, .external_lex_state = 3},
  [2247] = {.lex_state = 434, .external_lex_state = 10},
  [2248] = {.lex_state = 248},
  [2249] = {.lex_state = 255},
  [2250] = {.lex_state = 434, .external_lex_state = 10},
  [2251] = {.lex_state = 258, .external_lex_state = 6},
  [2252] = {.lex_state = 133, .external_lex_state = 2},
  [2253] = {.lex_state = 133, .external_lex_state = 2},
  [2254] = {.lex_state = 133, .external_lex_state = 2},
  [2255] = {.lex_state = 434, .external_lex_state = 4},
  [2256] = {.lex_state = 434, .external_lex_state = 4},
  [2257] = {.lex_state = 231},
  [2258] = {.lex_state = 440, .external_lex_state = 5},
  [2259] = {.lex_state = 440, .external_lex_state = 5},
  [2260] = {.lex_state = 248},
  [2261] = {.lex_state = 440, .external_lex_state = 5},
  [2262] = {.lex_state = 440, .external_lex_state = 5},
  [2263] = {.lex_state = 440, .external_lex_state = 5},
  [2264] = {.lex_state = 203},
  [2265] = {.lex_state = 308, .external_lex_state = 16},
  [2266] = {.lex_state = 316, .external_lex_state = 6},
  [2267] = {.lex_state = 308, .external_lex_state = 16},
  [2268] = {.lex_state = 308, .external_lex_state = 16},
  [2269] = {.lex_state = 203},
  [2270] = {.lex_state = 322, .external_lex_state = 2},
  [2271] = {.lex_state = 203},
  [2272] = {.lex_state = 330, .external_lex_state = 2},
  [2273] = {.lex_state = 203},
  [2274] = {.lex_state = 322, .external_lex_state = 2},
  [2275] = {.lex_state = 203},
  [2276] = {.lex_state = 133, .external_lex_state = 2},
  [2277] = {.lex_state = 425, .external_lex_state = 2},
  [2278] = {.lex_state = 133, .external_lex_state = 2},
  [2279] = {.lex_state = 425, .external_lex_state = 2},
  [2280] = {.lex_state = 133},
  [2281] = {.lex_state = 277},
  [2282] = {.lex_state = 231},
  [2283] = {.lex_state = 231},
  [2284] = {.lex_state = 440, .external_lex_state = 5},
  [2285] = {.lex_state = 440, .external_lex_state = 5},
  [2286] = {.lex_state = 440, .external_lex_state = 7},
  [2287] = {.lex_state = 446, .external_lex_state = 7},
  [2288] = {.lex_state = 440, .external_lex_state = 7},
  [2289] = {.lex_state = 401},
  [2290] = {.lex_state = 335, .external_lex_state = 4},
  [2291] = {.lex_state = 444, .external_lex_state = 8},
  [2292] = {.lex_state = 425, .external_lex_state = 2},
  [2293] = {.lex_state = 440, .external_lex_state = 7},
  [2294] = {.lex_state = 425, .external_lex_state = 2},
  [2295] = {.lex_state = 425, .external_lex_state = 2},
  [2296] = {.lex_state = 401},
  [2297] = {.lex_state = 335, .external_lex_state = 4},
  [2298] = {.lex_state = 444, .external_lex_state = 8},
  [2299] = {.lex_state = 425, .external_lex_state = 2},
  [2300] = {.lex_state = 332, .external_lex_state = 2},
  [2301] = {.lex_state = 228},
  [2302] = {.lex_state = 332, .external_lex_state = 2},
  [2303] = {.lex_state = 228},
  [2304] = {.lex_state = 335, .external_lex_state = 4},
  [2305] = {.lex_state = 335, .external_lex_state = 4},
  [2306] = {.lex_state = 270, .external_lex_state = 10},
  [2307] = {.lex_state = 270, .external_lex_state = 10},
  [2308] = {.lex_state = 270, .external_lex_state = 10},
  [2309] = {.lex_state = 428, .external_lex_state = 10},
  [2310] = {.lex_state = 372, .external_lex_state = 27},
  [2311] = {.lex_state = 297, .external_lex_state = 11},
  [2312] = {.lex_state = 297, .external_lex_state = 11},
  [2313] = {.lex_state = 297, .external_lex_state = 11},
  [2314] = {.lex_state = 389, .external_lex_state = 27},
  [2315] = {.lex_state = 411, .external_lex_state = 24},
  [2316] = {.lex_state = 411, .external_lex_state = 24},
  [2317] = {.lex_state = 203, .external_lex_state = 16},
  [2318] = {.lex_state = 378, .external_lex_state = 16},
  [2319] = {.lex_state = 389, .external_lex_state = 27},
  [2320] = {.lex_state = 376, .external_lex_state = 16},
  [2321] = {.lex_state = 389, .external_lex_state = 27},
  [2322] = {.lex_state = 380},
  [2323] = {.lex_state = 378, .external_lex_state = 16},
  [2324] = {.lex_state = 389, .external_lex_state = 27},
  [2325] = {.lex_state = 380},
  [2326] = {.lex_state = 378, .external_lex_state = 16},
  [2327] = {.lex_state = 380},
  [2328] = {.lex_state = 378, .external_lex_state = 16},
  [2329] = {.lex_state = 378, .external_lex_state = 16},
  [2330] = {.lex_state = 389, .external_lex_state = 27},
  [2331] = {.lex_state = 378, .external_lex_state = 16},
  [2332] = {.lex_state = 374, .external_lex_state = 13},
  [2333] = {.lex_state = 374, .external_lex_state = 13},
  [2334] = {.lex_state = 374, .external_lex_state = 13},
  [2335] = {.lex_state = 273, .external_lex_state = 14},
  [2336] = {.lex_state = 273, .external_lex_state = 14},
  [2337] = {.lex_state = 273, .external_lex_state = 14},
  [2338] = {.lex_state = 273, .external_lex_state = 10},
  [2339] = {.lex_state = 273, .external_lex_state = 10},
  [2340] = {.lex_state = 273, .external_lex_state = 10},
  [2341] = {.lex_state = 322, .external_lex_state = 15},
  [2342] = {.lex_state = 322, .external_lex_state = 15},
  [2343] = {.lex_state = 322, .external_lex_state = 15},
  [2344] = {.lex_state = 248, .external_lex_state = 13},
  [2345] = {.lex_state = 248, .external_lex_state = 13},
  [2346] = {.lex_state = 248, .external_lex_state = 13},
  [2347] = {.lex_state = 411, .external_lex_state = 24},
  [2348] = {.lex_state = 411, .external_lex_state = 24},
  [2349] = {.lex_state = 411, .external_lex_state = 24},
  [2350] = {.lex_state = 378, .external_lex_state = 16},
  [2351] = {.lex_state = 411, .external_lex_state = 24},
  [2352] = {.lex_state = 411, .external_lex_state = 24},
  [2353] = {.lex_state = 203, .external_lex_state = 16},
  [2354] = {.lex_state = 378, .external_lex_state = 16},
  [2355] = {.lex_state = 411, .external_lex_state = 24},
  [2356] = {.lex_state = 378, .external_lex_state = 16},
  [2357] = {.lex_state = 411, .external_lex_state = 24},
  [2358] = {.lex_state = 378, .external_lex_state = 16},
  [2359] = {.lex_state = 411, .external_lex_state = 24},
  [2360] = {.lex_state = 378, .external_lex_state = 16},
  [2361] = {.lex_state = 411, .external_lex_state = 24},
  [2362] = {.lex_state = 378, .external_lex_state = 16},
  [2363] = {.lex_state = 378, .external_lex_state = 24},
  [2364] = {.lex_state = 378, .external_lex_state = 24},
  [2365] = {.lex_state = 378, .external_lex_state = 24},
  [2366] = {.lex_state = 378, .external_lex_state = 24},
  [2367] = {.lex_state = 378, .external_lex_state = 16},
  [2368] = {.lex_state = 378, .external_lex_state = 24},
  [2369] = {.lex_state = 378, .external_lex_state = 16},
  [2370] = {.lex_state = 378, .external_lex_state = 24},
  [2371] = {.lex_state = 378, .external_lex_state = 16},
  [2372] = {.lex_state = 378, .external_lex_state = 24},
  [2373] = {.lex_state = 378, .external_lex_state = 24},
  [2374] = {.lex_state = 203},
  [2375] = {.lex_state = 203},
  [2376] = {.lex_state = 203},
  [2377] = {.lex_state = 203},
  [2378] = {.lex_state = 203},
  [2379] = {.lex_state = 430, .external_lex_state = 13},
  [2380] = {.lex_state = 415, .external_lex_state = 28},
  [2381] = {.lex_state = 385, .external_lex_state = 28},
  [2382] = {.lex_state = 415, .external_lex_state = 28},
  [2383] = {.lex_state = 376, .external_lex_state = 16},
  [2384] = {.lex_state = 415, .external_lex_state = 28},
  [2385] = {.lex_state = 380},
  [2386] = {.lex_state = 378, .external_lex_state = 16},
  [2387] = {.lex_state = 203},
  [2388] = {.lex_state = 308, .external_lex_state = 16},
  [2389] = {.lex_state = 308, .external_lex_state = 16},
  [2390] = {.lex_state = 308, .external_lex_state = 16},
  [2391] = {.lex_state = 415, .external_lex_state = 28},
  [2392] = {.lex_state = 380},
  [2393] = {.lex_state = 378, .external_lex_state = 16},
  [2394] = {.lex_state = 415, .external_lex_state = 28},
  [2395] = {.lex_state = 380},
  [2396] = {.lex_state = 378, .external_lex_state = 16},
  [2397] = {.lex_state = 415, .external_lex_state = 28},
  [2398] = {.lex_state = 415, .external_lex_state = 28},
  [2399] = {.lex_state = 318, .external_lex_state = 25},
  [2400] = {.lex_state = 318, .external_lex_state = 25},
  [2401] = {.lex_state = 318, .external_lex_state = 25},
  [2402] = {.lex_state = 318, .external_lex_state = 25},
  [2403] = {.lex_state = 378, .external_lex_state = 16},
  [2404] = {.lex_state = 318, .external_lex_state = 25},
  [2405] = {.lex_state = 378, .external_lex_state = 16},
  [2406] = {.lex_state = 318, .external_lex_state = 25},
  [2407] = {.lex_state = 378, .external_lex_state = 16},
  [2408] = {.lex_state = 318, .external_lex_state = 25},
  [2409] = {.lex_state = 318, .external_lex_state = 25},
  [2410] = {.lex_state = 318, .external_lex_state = 13},
  [2411] = {.lex_state = 318, .external_lex_state = 13},
  [2412] = {.lex_state = 318, .external_lex_state = 13},
  [2413] = {.lex_state = 318, .external_lex_state = 13},
  [2414] = {.lex_state = 378, .external_lex_state = 16},
  [2415] = {.lex_state = 318, .external_lex_state = 13},
  [2416] = {.lex_state = 378, .external_lex_state = 16},
  [2417] = {.lex_state = 318, .external_lex_state = 13},
  [2418] = {.lex_state = 378, .external_lex_state = 16},
  [2419] = {.lex_state = 318, .external_lex_state = 13},
  [2420] = {.lex_state = 318, .external_lex_state = 13},
  [2421] = {.lex_state = 233, .external_lex_state = 17},
  [2422] = {.lex_state = 233, .external_lex_state = 17},
  [2423] = {.lex_state = 233, .external_lex_state = 17},
  [2424] = {.lex_state = 432, .external_lex_state = 13},
  [2425] = {.lex_state = 387, .external_lex_state = 28},
  [2426] = {.lex_state = 338, .external_lex_state = 19},
  [2427] = {.lex_state = 338, .external_lex_state = 19},
  [2428] = {.lex_state = 338, .external_lex_state = 19},
  [2429] = {.lex_state = 338, .external_lex_state = 19},
  [2430] = {.lex_state = 378, .external_lex_state = 16},
  [2431] = {.lex_state = 338, .external_lex_state = 19},
  [2432] = {.lex_state = 378, .external_lex_state = 16},
  [2433] = {.lex_state = 338, .external_lex_state = 19},
  [2434] = {.lex_state = 378, .external_lex_state = 16},
  [2435] = {.lex_state = 338, .external_lex_state = 19},
  [2436] = {.lex_state = 338, .external_lex_state = 19},
  [2437] = {.lex_state = 395, .external_lex_state = 13},
  [2438] = {.lex_state = 395, .external_lex_state = 13},
  [2439] = {.lex_state = 395, .external_lex_state = 13},
  [2440] = {.lex_state = 395, .external_lex_state = 13},
  [2441] = {.lex_state = 378, .external_lex_state = 16},
  [2442] = {.lex_state = 395, .external_lex_state = 13},
  [2443] = {.lex_state = 378, .external_lex_state = 16},
  [2444] = {.lex_state = 395, .external_lex_state = 13},
  [2445] = {.lex_state = 378, .external_lex_state = 16},
  [2446] = {.lex_state = 395, .external_lex_state = 13},
  [2447] = {.lex_state = 395, .external_lex_state = 13},
  [2448] = {.lex_state = 268, .external_lex_state = 21},
  [2449] = {.lex_state = 268, .external_lex_state = 21},
  [2450] = {.lex_state = 268, .external_lex_state = 21},
  [2451] = {.lex_state = 397, .external_lex_state = 10},
  [2452] = {.lex_state = 397, .external_lex_state = 10},
  [2453] = {.lex_state = 397, .external_lex_state = 10},
  [2454] = {.lex_state = 397, .external_lex_state = 10},
  [2455] = {.lex_state = 378, .external_lex_state = 16},
  [2456] = {.lex_state = 397, .external_lex_state = 10},
  [2457] = {.lex_state = 378, .external_lex_state = 16},
  [2458] = {.lex_state = 397, .external_lex_state = 10},
  [2459] = {.lex_state = 378, .external_lex_state = 16},
  [2460] = {.lex_state = 397, .external_lex_state = 10},
  [2461] = {.lex_state = 397, .external_lex_state = 10},
  [2462] = {.lex_state = 444, .external_lex_state = 8},
  [2463] = {.lex_state = 322},
  [2464] = {.lex_state = 444, .external_lex_state = 21},
  [2465] = {.lex_state = 248},
  [2466] = {.lex_state = 255},
  [2467] = {.lex_state = 444, .external_lex_state = 21},
  [2468] = {.lex_state = 258, .external_lex_state = 6},
  [2469] = {.lex_state = 133, .external_lex_state = 2},
  [2470] = {.lex_state = 133, .external_lex_state = 2},
  [2471] = {.lex_state = 133, .external_lex_state = 2},
  [2472] = {.lex_state = 446, .external_lex_state = 7},
  [2473] = {.lex_state = 203},
  [2474] = {.lex_state = 448, .external_lex_state = 23},
  [2475] = {.lex_state = 446, .external_lex_state = 23},
  [2476] = {.lex_state = 266, .external_lex_state = 9},
  [2477] = {.lex_state = 434, .external_lex_state = 3},
  [2478] = {.lex_state = 231},
  [2479] = {.lex_state = 434, .external_lex_state = 14},
  [2480] = {.lex_state = 434, .external_lex_state = 14},
  [2481] = {.lex_state = 248},
  [2482] = {.lex_state = 434, .external_lex_state = 14},
  [2483] = {.lex_state = 434, .external_lex_state = 14},
  [2484] = {.lex_state = 434, .external_lex_state = 14},
  [2485] = {.lex_state = 203},
  [2486] = {.lex_state = 308, .external_lex_state = 16},
  [2487] = {.lex_state = 316, .external_lex_state = 6},
  [2488] = {.lex_state = 308, .external_lex_state = 16},
  [2489] = {.lex_state = 308, .external_lex_state = 16},
  [2490] = {.lex_state = 203},
  [2491] = {.lex_state = 322, .external_lex_state = 2},
  [2492] = {.lex_state = 203},
  [2493] = {.lex_state = 330, .external_lex_state = 2},
  [2494] = {.lex_state = 203},
  [2495] = {.lex_state = 322, .external_lex_state = 2},
  [2496] = {.lex_state = 434, .external_lex_state = 3},
  [2497] = {.lex_state = 231},
  [2498] = {.lex_state = 434, .external_lex_state = 10},
  [2499] = {.lex_state = 434, .external_lex_state = 10},
  [2500] = {.lex_state = 248},
  [2501] = {.lex_state = 434, .external_lex_state = 10},
  [2502] = {.lex_state = 434, .external_lex_state = 10},
  [2503] = {.lex_state = 434, .external_lex_state = 10},
  [2504] = {.lex_state = 203},
  [2505] = {.lex_state = 308, .external_lex_state = 16},
  [2506] = {.lex_state = 316, .external_lex_state = 6},
  [2507] = {.lex_state = 308, .external_lex_state = 16},
  [2508] = {.lex_state = 308, .external_lex_state = 16},
  [2509] = {.lex_state = 203},
  [2510] = {.lex_state = 322, .external_lex_state = 2},
  [2511] = {.lex_state = 203},
  [2512] = {.lex_state = 330, .external_lex_state = 2},
  [2513] = {.lex_state = 203},
  [2514] = {.lex_state = 322, .external_lex_state = 2},
  [2515] = {.lex_state = 434, .external_lex_state = 4},
  [2516] = {.lex_state = 440, .external_lex_state = 5},
  [2517] = {.lex_state = 440, .external_lex_state = 5},
  [2518] = {.lex_state = 440, .external_lex_state = 5},
  [2519] = {.lex_state = 376, .external_lex_state = 16},
  [2520] = {.lex_state = 440, .external_lex_state = 5},
  [2521] = {.lex_state = 380},
  [2522] = {.lex_state = 378, .external_lex_state = 16},
  [2523] = {.lex_state = 203},
  [2524] = {.lex_state = 308, .external_lex_state = 16},
  [2525] = {.lex_state = 308, .external_lex_state = 16},
  [2526] = {.lex_state = 308, .external_lex_state = 16},
  [2527] = {.lex_state = 440, .external_lex_state = 5},
  [2528] = {.lex_state = 380},
  [2529] = {.lex_state = 378, .external_lex_state = 16},
  [2530] = {.lex_state = 440, .external_lex_state = 5},
  [2531] = {.lex_state = 380},
  [2532] = {.lex_state = 378, .external_lex_state = 16},
  [2533] = {.lex_state = 440, .external_lex_state = 5},
  [2534] = {.lex_state = 440, .external_lex_state = 5},
  [2535] = {.lex_state = 203},
  [2536] = {.lex_state = 444, .external_lex_state = 8},
  [2537] = {.lex_state = 335, .external_lex_state = 4},
  [2538] = {.lex_state = 444, .external_lex_state = 8},
  [2539] = {.lex_state = 231},
  [2540] = {.lex_state = 440, .external_lex_state = 5},
  [2541] = {.lex_state = 440, .external_lex_state = 5},
  [2542] = {.lex_state = 440, .external_lex_state = 7},
  [2543] = {.lex_state = 446, .external_lex_state = 5},
  [2544] = {.lex_state = 248},
  [2545] = {.lex_state = 255},
  [2546] = {.lex_state = 446, .external_lex_state = 5},
  [2547] = {.lex_state = 258, .external_lex_state = 6},
  [2548] = {.lex_state = 133, .external_lex_state = 2},
  [2549] = {.lex_state = 133, .external_lex_state = 2},
  [2550] = {.lex_state = 133, .external_lex_state = 2},
  [2551] = {.lex_state = 446, .external_lex_state = 5},
  [2552] = {.lex_state = 446, .external_lex_state = 5},
  [2553] = {.lex_state = 446, .external_lex_state = 7},
  [2554] = {.lex_state = 446, .external_lex_state = 7},
  [2555] = {.lex_state = 440, .external_lex_state = 7},
  [2556] = {.lex_state = 425, .external_lex_state = 2},
  [2557] = {.lex_state = 239, .external_lex_state = 4},
  [2558] = {.lex_state = 262, .external_lex_state = 8},
  [2559] = {.lex_state = 440, .external_lex_state = 7},
  [2560] = {.lex_state = 401},
  [2561] = {.lex_state = 335, .external_lex_state = 4},
  [2562] = {.lex_state = 444, .external_lex_state = 8},
  [2563] = {.lex_state = 425, .external_lex_state = 2},
  [2564] = {.lex_state = 401},
  [2565] = {.lex_state = 335, .external_lex_state = 4},
  [2566] = {.lex_state = 444, .external_lex_state = 8},
  [2567] = {.lex_state = 231},
  [2568] = {.lex_state = 239, .external_lex_state = 4},
  [2569] = {.lex_state = 262, .external_lex_state = 8},
  [2570] = {.lex_state = 332, .external_lex_state = 2},
  [2571] = {.lex_state = 332, .external_lex_state = 2},
  [2572] = {.lex_state = 231},
  [2573] = {.lex_state = 239, .external_lex_state = 4},
  [2574] = {.lex_state = 262, .external_lex_state = 8},
  [2575] = {.lex_state = 332, .external_lex_state = 2},
  [2576] = {.lex_state = 332, .external_lex_state = 2},
  [2577] = {.lex_state = 389, .external_lex_state = 27},
  [2578] = {.lex_state = 389, .external_lex_state = 27},
  [2579] = {.lex_state = 389, .external_lex_state = 27},
  [2580] = {.lex_state = 378, .external_lex_state = 16},
  [2581] = {.lex_state = 411, .external_lex_state = 24},
  [2582] = {.lex_state = 411, .external_lex_state = 24},
  [2583] = {.lex_state = 203, .external_lex_state = 16},
  [2584] = {.lex_state = 378, .external_lex_state = 16},
  [2585] = {.lex_state = 389, .external_lex_state = 27},
  [2586] = {.lex_state = 378, .external_lex_state = 16},
  [2587] = {.lex_state = 389, .external_lex_state = 27},
  [2588] = {.lex_state = 378, .external_lex_state = 16},
  [2589] = {.lex_state = 389, .external_lex_state = 27},
  [2590] = {.lex_state = 378, .external_lex_state = 16},
  [2591] = {.lex_state = 389, .external_lex_state = 27},
  [2592] = {.lex_state = 378, .external_lex_state = 16},
  [2593] = {.lex_state = 411, .external_lex_state = 24},
  [2594] = {.lex_state = 411, .external_lex_state = 24},
  [2595] = {.lex_state = 411, .external_lex_state = 24},
  [2596] = {.lex_state = 411, .external_lex_state = 24},
  [2597] = {.lex_state = 378, .external_lex_state = 16},
  [2598] = {.lex_state = 411, .external_lex_state = 24},
  [2599] = {.lex_state = 378, .external_lex_state = 16},
  [2600] = {.lex_state = 411, .external_lex_state = 24},
  [2601] = {.lex_state = 378, .external_lex_state = 16},
  [2602] = {.lex_state = 411, .external_lex_state = 24},
  [2603] = {.lex_state = 411, .external_lex_state = 24},
  [2604] = {.lex_state = 378, .external_lex_state = 24},
  [2605] = {.lex_state = 378, .external_lex_state = 24},
  [2606] = {.lex_state = 378, .external_lex_state = 24},
  [2607] = {.lex_state = 203},
  [2608] = {.lex_state = 203},
  [2609] = {.lex_state = 415, .external_lex_state = 28},
  [2610] = {.lex_state = 411, .external_lex_state = 24},
  [2611] = {.lex_state = 411, .external_lex_state = 24},
  [2612] = {.lex_state = 203, .external_lex_state = 16},
  [2613] = {.lex_state = 378, .external_lex_state = 16},
  [2614] = {.lex_state = 415, .external_lex_state = 28},
  [2615] = {.lex_state = 376, .external_lex_state = 16},
  [2616] = {.lex_state = 415, .external_lex_state = 28},
  [2617] = {.lex_state = 380},
  [2618] = {.lex_state = 378, .external_lex_state = 16},
  [2619] = {.lex_state = 415, .external_lex_state = 28},
  [2620] = {.lex_state = 380},
  [2621] = {.lex_state = 378, .external_lex_state = 16},
  [2622] = {.lex_state = 380},
  [2623] = {.lex_state = 378, .external_lex_state = 16},
  [2624] = {.lex_state = 378, .external_lex_state = 16},
  [2625] = {.lex_state = 415, .external_lex_state = 28},
  [2626] = {.lex_state = 378, .external_lex_state = 16},
  [2627] = {.lex_state = 318, .external_lex_state = 25},
  [2628] = {.lex_state = 318, .external_lex_state = 25},
  [2629] = {.lex_state = 318, .external_lex_state = 25},
  [2630] = {.lex_state = 318, .external_lex_state = 13},
  [2631] = {.lex_state = 318, .external_lex_state = 13},
  [2632] = {.lex_state = 318, .external_lex_state = 13},
  [2633] = {.lex_state = 338, .external_lex_state = 19},
  [2634] = {.lex_state = 338, .external_lex_state = 19},
  [2635] = {.lex_state = 338, .external_lex_state = 19},
  [2636] = {.lex_state = 395, .external_lex_state = 13},
  [2637] = {.lex_state = 395, .external_lex_state = 13},
  [2638] = {.lex_state = 395, .external_lex_state = 13},
  [2639] = {.lex_state = 397, .external_lex_state = 10},
  [2640] = {.lex_state = 397, .external_lex_state = 10},
  [2641] = {.lex_state = 397, .external_lex_state = 10},
  [2642] = {.lex_state = 444, .external_lex_state = 8},
  [2643] = {.lex_state = 322},
  [2644] = {.lex_state = 231},
  [2645] = {.lex_state = 444, .external_lex_state = 21},
  [2646] = {.lex_state = 444, .external_lex_state = 21},
  [2647] = {.lex_state = 248},
  [2648] = {.lex_state = 444, .external_lex_state = 21},
  [2649] = {.lex_state = 444, .external_lex_state = 21},
  [2650] = {.lex_state = 444, .external_lex_state = 21},
  [2651] = {.lex_state = 203},
  [2652] = {.lex_state = 308, .external_lex_state = 16},
  [2653] = {.lex_state = 316, .external_lex_state = 6},
  [2654] = {.lex_state = 308, .external_lex_state = 16},
  [2655] = {.lex_state = 308, .external_lex_state = 16},
  [2656] = {.lex_state = 203},
  [2657] = {.lex_state = 322, .external_lex_state = 2},
  [2658] = {.lex_state = 203},
  [2659] = {.lex_state = 330, .external_lex_state = 2},
  [2660] = {.lex_state = 203},
  [2661] = {.lex_state = 322, .external_lex_state = 2},
  [2662] = {.lex_state = 446, .external_lex_state = 7},
  [2663] = {.lex_state = 203},
  [2664] = {.lex_state = 133},
  [2665] = {.lex_state = 231},
  [2666] = {.lex_state = 133},
  [2667] = {.lex_state = 231},
  [2668] = {.lex_state = 231},
  [2669] = {.lex_state = 446, .external_lex_state = 23},
  [2670] = {.lex_state = 434, .external_lex_state = 3},
  [2671] = {.lex_state = 322},
  [2672] = {.lex_state = 434, .external_lex_state = 14},
  [2673] = {.lex_state = 434, .external_lex_state = 14},
  [2674] = {.lex_state = 434, .external_lex_state = 14},
  [2675] = {.lex_state = 434, .external_lex_state = 14},
  [2676] = {.lex_state = 434, .external_lex_state = 14},
  [2677] = {.lex_state = 376, .external_lex_state = 16},
  [2678] = {.lex_state = 434, .external_lex_state = 14},
  [2679] = {.lex_state = 380},
  [2680] = {.lex_state = 378, .external_lex_state = 16},
  [2681] = {.lex_state = 203},
  [2682] = {.lex_state = 308, .external_lex_state = 16},
  [2683] = {.lex_state = 308, .external_lex_state = 16},
  [2684] = {.lex_state = 308, .external_lex_state = 16},
  [2685] = {.lex_state = 434, .external_lex_state = 14},
  [2686] = {.lex_state = 380},
  [2687] = {.lex_state = 378, .external_lex_state = 16},
  [2688] = {.lex_state = 434, .external_lex_state = 14},
  [2689] = {.lex_state = 380},
  [2690] = {.lex_state = 378, .external_lex_state = 16},
  [2691] = {.lex_state = 434, .external_lex_state = 14},
  [2692] = {.lex_state = 434, .external_lex_state = 14},
  [2693] = {.lex_state = 434, .external_lex_state = 10},
  [2694] = {.lex_state = 434, .external_lex_state = 10},
  [2695] = {.lex_state = 434, .external_lex_state = 10},
  [2696] = {.lex_state = 376, .external_lex_state = 16},
  [2697] = {.lex_state = 434, .external_lex_state = 10},
  [2698] = {.lex_state = 380},
  [2699] = {.lex_state = 378, .external_lex_state = 16},
  [2700] = {.lex_state = 203},
  [2701] = {.lex_state = 308, .external_lex_state = 16},
  [2702] = {.lex_state = 308, .external_lex_state = 16},
  [2703] = {.lex_state = 308, .external_lex_state = 16},
  [2704] = {.lex_state = 434, .external_lex_state = 10},
  [2705] = {.lex_state = 380},
  [2706] = {.lex_state = 378, .external_lex_state = 16},
  [2707] = {.lex_state = 434, .external_lex_state = 10},
  [2708] = {.lex_state = 380},
  [2709] = {.lex_state = 378, .external_lex_state = 16},
  [2710] = {.lex_state = 434, .external_lex_state = 10},
  [2711] = {.lex_state = 434, .external_lex_state = 10},
  [2712] = {.lex_state = 440, .external_lex_state = 5},
  [2713] = {.lex_state = 411, .external_lex_state = 24},
  [2714] = {.lex_state = 411, .external_lex_state = 24},
  [2715] = {.lex_state = 203, .external_lex_state = 16},
  [2716] = {.lex_state = 378, .external_lex_state = 16},
  [2717] = {.lex_state = 440, .external_lex_state = 5},
  [2718] = {.lex_state = 376, .external_lex_state = 16},
  [2719] = {.lex_state = 440, .external_lex_state = 5},
  [2720] = {.lex_state = 380},
  [2721] = {.lex_state = 378, .external_lex_state = 16},
  [2722] = {.lex_state = 440, .external_lex_state = 5},
  [2723] = {.lex_state = 380},
  [2724] = {.lex_state = 378, .external_lex_state = 16},
  [2725] = {.lex_state = 380},
  [2726] = {.lex_state = 378, .external_lex_state = 16},
  [2727] = {.lex_state = 378, .external_lex_state = 16},
  [2728] = {.lex_state = 440, .external_lex_state = 5},
  [2729] = {.lex_state = 378, .external_lex_state = 16},
  [2730] = {.lex_state = 448, .external_lex_state = 23},
  [2731] = {.lex_state = 446, .external_lex_state = 5},
  [2732] = {.lex_state = 446, .external_lex_state = 5},
  [2733] = {.lex_state = 231},
  [2734] = {.lex_state = 446, .external_lex_state = 5},
  [2735] = {.lex_state = 446, .external_lex_state = 5},
  [2736] = {.lex_state = 248},
  [2737] = {.lex_state = 446, .external_lex_state = 5},
  [2738] = {.lex_state = 446, .external_lex_state = 5},
  [2739] = {.lex_state = 446, .external_lex_state = 5},
  [2740] = {.lex_state = 203},
  [2741] = {.lex_state = 308, .external_lex_state = 16},
  [2742] = {.lex_state = 316, .external_lex_state = 6},
  [2743] = {.lex_state = 308, .external_lex_state = 16},
  [2744] = {.lex_state = 308, .external_lex_state = 16},
  [2745] = {.lex_state = 203},
  [2746] = {.lex_state = 322, .external_lex_state = 2},
  [2747] = {.lex_state = 203},
  [2748] = {.lex_state = 330, .external_lex_state = 2},
  [2749] = {.lex_state = 203},
  [2750] = {.lex_state = 322, .external_lex_state = 2},
  [2751] = {.lex_state = 446, .external_lex_state = 7},
  [2752] = {.lex_state = 425, .external_lex_state = 2},
  [2753] = {.lex_state = 425, .external_lex_state = 2},
  [2754] = {.lex_state = 332, .external_lex_state = 2},
  [2755] = {.lex_state = 231},
  [2756] = {.lex_state = 239, .external_lex_state = 4},
  [2757] = {.lex_state = 262, .external_lex_state = 8},
  [2758] = {.lex_state = 332, .external_lex_state = 2},
  [2759] = {.lex_state = 332, .external_lex_state = 2},
  [2760] = {.lex_state = 332, .external_lex_state = 2},
  [2761] = {.lex_state = 231},
  [2762] = {.lex_state = 239, .external_lex_state = 4},
  [2763] = {.lex_state = 262, .external_lex_state = 8},
  [2764] = {.lex_state = 332, .external_lex_state = 2},
  [2765] = {.lex_state = 389, .external_lex_state = 27},
  [2766] = {.lex_state = 389, .external_lex_state = 27},
  [2767] = {.lex_state = 389, .external_lex_state = 27},
  [2768] = {.lex_state = 389, .external_lex_state = 27},
  [2769] = {.lex_state = 378, .external_lex_state = 16},
  [2770] = {.lex_state = 389, .external_lex_state = 27},
  [2771] = {.lex_state = 378, .external_lex_state = 16},
  [2772] = {.lex_state = 389, .external_lex_state = 27},
  [2773] = {.lex_state = 378, .external_lex_state = 16},
  [2774] = {.lex_state = 389, .external_lex_state = 27},
  [2775] = {.lex_state = 389, .external_lex_state = 27},
  [2776] = {.lex_state = 411, .external_lex_state = 24},
  [2777] = {.lex_state = 411, .external_lex_state = 24},
  [2778] = {.lex_state = 411, .external_lex_state = 24},
  [2779] = {.lex_state = 415, .external_lex_state = 28},
  [2780] = {.lex_state = 415, .external_lex_state = 28},
  [2781] = {.lex_state = 415, .external_lex_state = 28},
  [2782] = {.lex_state = 378, .external_lex_state = 16},
  [2783] = {.lex_state = 411, .external_lex_state = 24},
  [2784] = {.lex_state = 411, .external_lex_state = 24},
  [2785] = {.lex_state = 203, .external_lex_state = 16},
  [2786] = {.lex_state = 378, .external_lex_state = 16},
  [2787] = {.lex_state = 415, .external_lex_state = 28},
  [2788] = {.lex_state = 378, .external_lex_state = 16},
  [2789] = {.lex_state = 415, .external_lex_state = 28},
  [2790] = {.lex_state = 378, .external_lex_state = 16},
  [2791] = {.lex_state = 415, .external_lex_state = 28},
  [2792] = {.lex_state = 378, .external_lex_state = 16},
  [2793] = {.lex_state = 415, .external_lex_state = 28},
  [2794] = {.lex_state = 378, .external_lex_state = 16},
  [2795] = {.lex_state = 444, .external_lex_state = 8},
  [2796] = {.lex_state = 444, .external_lex_state = 21},
  [2797] = {.lex_state = 444, .external_lex_state = 21},
  [2798] = {.lex_state = 444, .external_lex_state = 21},
  [2799] = {.lex_state = 376, .external_lex_state = 16},
  [2800] = {.lex_state = 444, .external_lex_state = 21},
  [2801] = {.lex_state = 380},
  [2802] = {.lex_state = 378, .external_lex_state = 16},
  [2803] = {.lex_state = 203},
  [2804] = {.lex_state = 308, .external_lex_state = 16},
  [2805] = {.lex_state = 308, .external_lex_state = 16},
  [2806] = {.lex_state = 308, .external_lex_state = 16},
  [2807] = {.lex_state = 444, .external_lex_state = 21},
  [2808] = {.lex_state = 380},
  [2809] = {.lex_state = 378, .external_lex_state = 16},
  [2810] = {.lex_state = 444, .external_lex_state = 21},
  [2811] = {.lex_state = 380},
  [2812] = {.lex_state = 378, .external_lex_state = 16},
  [2813] = {.lex_state = 444, .external_lex_state = 21},
  [2814] = {.lex_state = 444, .external_lex_state = 21},
  [2815] = {.lex_state = 448, .external_lex_state = 23},
  [2816] = {.lex_state = 231},
  [2817] = {.lex_state = 450, .external_lex_state = 10},
  [2818] = {.lex_state = 248},
  [2819] = {.lex_state = 255},
  [2820] = {.lex_state = 450, .external_lex_state = 10},
  [2821] = {.lex_state = 258, .external_lex_state = 6},
  [2822] = {.lex_state = 133, .external_lex_state = 2},
  [2823] = {.lex_state = 133, .external_lex_state = 2},
  [2824] = {.lex_state = 133, .external_lex_state = 2},
  [2825] = {.lex_state = 231},
  [2826] = {.lex_state = 446, .external_lex_state = 27},
  [2827] = {.lex_state = 446, .external_lex_state = 27},
  [2828] = {.lex_state = 446, .external_lex_state = 27},
  [2829] = {.lex_state = 446, .external_lex_state = 27},
  [2830] = {.lex_state = 446, .external_lex_state = 23},
  [2831] = {.lex_state = 434, .external_lex_state = 3},
  [2832] = {.lex_state = 322},
  [2833] = {.lex_state = 434, .external_lex_state = 14},
  [2834] = {.lex_state = 411, .external_lex_state = 24},
  [2835] = {.lex_state = 411, .external_lex_state = 24},
  [2836] = {.lex_state = 203, .external_lex_state = 16},
  [2837] = {.lex_state = 378, .external_lex_state = 16},
  [2838] = {.lex_state = 434, .external_lex_state = 14},
  [2839] = {.lex_state = 376, .external_lex_state = 16},
  [2840] = {.lex_state = 434, .external_lex_state = 14},
  [2841] = {.lex_state = 380},
  [2842] = {.lex_state = 378, .external_lex_state = 16},
  [2843] = {.lex_state = 434, .external_lex_state = 14},
  [2844] = {.lex_state = 380},
  [2845] = {.lex_state = 378, .external_lex_state = 16},
  [2846] = {.lex_state = 380},
  [2847] = {.lex_state = 378, .external_lex_state = 16},
  [2848] = {.lex_state = 378, .external_lex_state = 16},
  [2849] = {.lex_state = 434, .external_lex_state = 14},
  [2850] = {.lex_state = 378, .external_lex_state = 16},
  [2851] = {.lex_state = 434, .external_lex_state = 10},
  [2852] = {.lex_state = 411, .external_lex_state = 24},
  [2853] = {.lex_state = 411, .external_lex_state = 24},
  [2854] = {.lex_state = 203, .external_lex_state = 16},
  [2855] = {.lex_state = 378, .external_lex_state = 16},
  [2856] = {.lex_state = 434, .external_lex_state = 10},
  [2857] = {.lex_state = 376, .external_lex_state = 16},
  [2858] = {.lex_state = 434, .external_lex_state = 10},
  [2859] = {.lex_state = 380},
  [2860] = {.lex_state = 378, .external_lex_state = 16},
  [2861] = {.lex_state = 434, .external_lex_state = 10},
  [2862] = {.lex_state = 380},
  [2863] = {.lex_state = 378, .external_lex_state = 16},
  [2864] = {.lex_state = 380},
  [2865] = {.lex_state = 378, .external_lex_state = 16},
  [2866] = {.lex_state = 378, .external_lex_state = 16},
  [2867] = {.lex_state = 434, .external_lex_state = 10},
  [2868] = {.lex_state = 378, .external_lex_state = 16},
  [2869] = {.lex_state = 440, .external_lex_state = 5},
  [2870] = {.lex_state = 440, .external_lex_state = 5},
  [2871] = {.lex_state = 440, .external_lex_state = 5},
  [2872] = {.lex_state = 378, .external_lex_state = 16},
  [2873] = {.lex_state = 411, .external_lex_state = 24},
  [2874] = {.lex_state = 411, .external_lex_state = 24},
  [2875] = {.lex_state = 203, .external_lex_state = 16},
  [2876] = {.lex_state = 378, .external_lex_state = 16},
  [2877] = {.lex_state = 440, .external_lex_state = 5},
  [2878] = {.lex_state = 378, .external_lex_state = 16},
  [2879] = {.lex_state = 440, .external_lex_state = 5},
  [2880] = {.lex_state = 378, .external_lex_state = 16},
  [2881] = {.lex_state = 440, .external_lex_state = 5},
  [2882] = {.lex_state = 378, .external_lex_state = 16},
  [2883] = {.lex_state = 440, .external_lex_state = 5},
  [2884] = {.lex_state = 378, .external_lex_state = 16},
  [2885] = {.lex_state = 446, .external_lex_state = 5},
  [2886] = {.lex_state = 446, .external_lex_state = 5},
  [2887] = {.lex_state = 446, .external_lex_state = 5},
  [2888] = {.lex_state = 376, .external_lex_state = 16},
  [2889] = {.lex_state = 446, .external_lex_state = 5},
  [2890] = {.lex_state = 380},
  [2891] = {.lex_state = 378, .external_lex_state = 16},
  [2892] = {.lex_state = 203},
  [2893] = {.lex_state = 308, .external_lex_state = 16},
  [2894] = {.lex_state = 308, .external_lex_state = 16},
  [2895] = {.lex_state = 308, .external_lex_state = 16},
  [2896] = {.lex_state = 446, .external_lex_state = 5},
  [2897] = {.lex_state = 380},
  [2898] = {.lex_state = 378, .external_lex_state = 16},
  [2899] = {.lex_state = 446, .external_lex_state = 5},
  [2900] = {.lex_state = 380},
  [2901] = {.lex_state = 378, .external_lex_state = 16},
  [2902] = {.lex_state = 446, .external_lex_state = 5},
  [2903] = {.lex_state = 446, .external_lex_state = 5},
  [2904] = {.lex_state = 332, .external_lex_state = 2},
  [2905] = {.lex_state = 231},
  [2906] = {.lex_state = 239, .external_lex_state = 4},
  [2907] = {.lex_state = 262, .external_lex_state = 8},
  [2908] = {.lex_state = 332, .external_lex_state = 2},
  [2909] = {.lex_state = 231},
  [2910] = {.lex_state = 239, .external_lex_state = 4},
  [2911] = {.lex_state = 262, .external_lex_state = 8},
  [2912] = {.lex_state = 389, .external_lex_state = 27},
  [2913] = {.lex_state = 389, .external_lex_state = 27},
  [2914] = {.lex_state = 389, .external_lex_state = 27},
  [2915] = {.lex_state = 415, .external_lex_state = 28},
  [2916] = {.lex_state = 415, .external_lex_state = 28},
  [2917] = {.lex_state = 415, .external_lex_state = 28},
  [2918] = {.lex_state = 415, .external_lex_state = 28},
  [2919] = {.lex_state = 378, .external_lex_state = 16},
  [2920] = {.lex_state = 415, .external_lex_state = 28},
  [2921] = {.lex_state = 378, .external_lex_state = 16},
  [2922] = {.lex_state = 415, .external_lex_state = 28},
  [2923] = {.lex_state = 378, .external_lex_state = 16},
  [2924] = {.lex_state = 415, .external_lex_state = 28},
  [2925] = {.lex_state = 415, .external_lex_state = 28},
  [2926] = {.lex_state = 444, .external_lex_state = 21},
  [2927] = {.lex_state = 411, .external_lex_state = 24},
  [2928] = {.lex_state = 411, .external_lex_state = 24},
  [2929] = {.lex_state = 203, .external_lex_state = 16},
  [2930] = {.lex_state = 378, .external_lex_state = 16},
  [2931] = {.lex_state = 444, .external_lex_state = 21},
  [2932] = {.lex_state = 376, .external_lex_state = 16},
  [2933] = {.lex_state = 444, .external_lex_state = 21},
  [2934] = {.lex_state = 380},
  [2935] = {.lex_state = 378, .external_lex_state = 16},
  [2936] = {.lex_state = 444, .external_lex_state = 21},
  [2937] = {.lex_state = 380},
  [2938] = {.lex_state = 378, .external_lex_state = 16},
  [2939] = {.lex_state = 380},
  [2940] = {.lex_state = 378, .external_lex_state = 16},
  [2941] = {.lex_state = 378, .external_lex_state = 16},
  [2942] = {.lex_state = 444, .external_lex_state = 21},
  [2943] = {.lex_state = 378, .external_lex_state = 16},
  [2944] = {.lex_state = 450, .external_lex_state = 10},
  [2945] = {.lex_state = 450, .external_lex_state = 10},
  [2946] = {.lex_state = 231},
  [2947] = {.lex_state = 450, .external_lex_state = 10},
  [2948] = {.lex_state = 450, .external_lex_state = 10},
  [2949] = {.lex_state = 248},
  [2950] = {.lex_state = 450, .external_lex_state = 10},
  [2951] = {.lex_state = 450, .external_lex_state = 10},
  [2952] = {.lex_state = 450, .external_lex_state = 10},
  [2953] = {.lex_state = 203},
  [2954] = {.lex_state = 308, .external_lex_state = 16},
  [2955] = {.lex_state = 316, .external_lex_state = 6},
  [2956] = {.lex_state = 308, .external_lex_state = 16},
  [2957] = {.lex_state = 308, .external_lex_state = 16},
  [2958] = {.lex_state = 203},
  [2959] = {.lex_state = 322, .external_lex_state = 2},
  [2960] = {.lex_state = 203},
  [2961] = {.lex_state = 330, .external_lex_state = 2},
  [2962] = {.lex_state = 203},
  [2963] = {.lex_state = 322, .external_lex_state = 2},
  [2964] = {.lex_state = 446, .external_lex_state = 27},
  [2965] = {.lex_state = 446, .external_lex_state = 27},
  [2966] = {.lex_state = 446, .external_lex_state = 27},
  [2967] = {.lex_state = 434, .external_lex_state = 3},
  [2968] = {.lex_state = 434, .external_lex_state = 14},
  [2969] = {.lex_state = 434, .external_lex_state = 14},
  [2970] = {.lex_state = 434, .external_lex_state = 14},
  [2971] = {.lex_state = 378, .external_lex_state = 16},
  [2972] = {.lex_state = 411, .external_lex_state = 24},
  [2973] = {.lex_state = 411, .external_lex_state = 24},
  [2974] = {.lex_state = 203, .external_lex_state = 16},
  [2975] = {.lex_state = 378, .external_lex_state = 16},
  [2976] = {.lex_state = 434, .external_lex_state = 14},
  [2977] = {.lex_state = 378, .external_lex_state = 16},
  [2978] = {.lex_state = 434, .external_lex_state = 14},
  [2979] = {.lex_state = 378, .external_lex_state = 16},
  [2980] = {.lex_state = 434, .external_lex_state = 14},
  [2981] = {.lex_state = 378, .external_lex_state = 16},
  [2982] = {.lex_state = 434, .external_lex_state = 14},
  [2983] = {.lex_state = 378, .external_lex_state = 16},
  [2984] = {.lex_state = 434, .external_lex_state = 10},
  [2985] = {.lex_state = 434, .external_lex_state = 10},
  [2986] = {.lex_state = 434, .external_lex_state = 10},
  [2987] = {.lex_state = 378, .external_lex_state = 16},
  [2988] = {.lex_state = 411, .external_lex_state = 24},
  [2989] = {.lex_state = 411, .external_lex_state = 24},
  [2990] = {.lex_state = 203, .external_lex_state = 16},
  [2991] = {.lex_state = 378, .external_lex_state = 16},
  [2992] = {.lex_state = 434, .external_lex_state = 10},
  [2993] = {.lex_state = 378, .external_lex_state = 16},
  [2994] = {.lex_state = 434, .external_lex_state = 10},
  [2995] = {.lex_state = 378, .external_lex_state = 16},
  [2996] = {.lex_state = 434, .external_lex_state = 10},
  [2997] = {.lex_state = 378, .external_lex_state = 16},
  [2998] = {.lex_state = 434, .external_lex_state = 10},
  [2999] = {.lex_state = 378, .external_lex_state = 16},
  [3000] = {.lex_state = 440, .external_lex_state = 5},
  [3001] = {.lex_state = 440, .external_lex_state = 5},
  [3002] = {.lex_state = 440, .external_lex_state = 5},
  [3003] = {.lex_state = 440, .external_lex_state = 5},
  [3004] = {.lex_state = 378, .external_lex_state = 16},
  [3005] = {.lex_state = 440, .external_lex_state = 5},
  [3006] = {.lex_state = 378, .external_lex_state = 16},
  [3007] = {.lex_state = 440, .external_lex_state = 5},
  [3008] = {.lex_state = 378, .external_lex_state = 16},
  [3009] = {.lex_state = 440, .external_lex_state = 5},
  [3010] = {.lex_state = 440, .external_lex_state = 5},
  [3011] = {.lex_state = 446, .external_lex_state = 5},
  [3012] = {.lex_state = 411, .external_lex_state = 24},
  [3013] = {.lex_state = 411, .external_lex_state = 24},
  [3014] = {.lex_state = 203, .external_lex_state = 16},
  [3015] = {.lex_state = 378, .external_lex_state = 16},
  [3016] = {.lex_state = 446, .external_lex_state = 5},
  [3017] = {.lex_state = 376, .external_lex_state = 16},
  [3018] = {.lex_state = 446, .external_lex_state = 5},
  [3019] = {.lex_state = 380},
  [3020] = {.lex_state = 378, .external_lex_state = 16},
  [3021] = {.lex_state = 446, .external_lex_state = 5},
  [3022] = {.lex_state = 380},
  [3023] = {.lex_state = 378, .external_lex_state = 16},
  [3024] = {.lex_state = 380},
  [3025] = {.lex_state = 378, .external_lex_state = 16},
  [3026] = {.lex_state = 378, .external_lex_state = 16},
  [3027] = {.lex_state = 446, .external_lex_state = 5},
  [3028] = {.lex_state = 378, .external_lex_state = 16},
  [3029] = {.lex_state = 332, .external_lex_state = 2},
  [3030] = {.lex_state = 332, .external_lex_state = 2},
  [3031] = {.lex_state = 415, .external_lex_state = 28},
  [3032] = {.lex_state = 415, .external_lex_state = 28},
  [3033] = {.lex_state = 415, .external_lex_state = 28},
  [3034] = {.lex_state = 444, .external_lex_state = 21},
  [3035] = {.lex_state = 444, .external_lex_state = 21},
  [3036] = {.lex_state = 444, .external_lex_state = 21},
  [3037] = {.lex_state = 378, .external_lex_state = 16},
  [3038] = {.lex_state = 411, .external_lex_state = 24},
  [3039] = {.lex_state = 411, .external_lex_state = 24},
  [3040] = {.lex_state = 203, .external_lex_state = 16},
  [3041] = {.lex_state = 378, .external_lex_state = 16},
  [3042] = {.lex_state = 444, .external_lex_state = 21},
  [3043] = {.lex_state = 378, .external_lex_state = 16},
  [3044] = {.lex_state = 444, .external_lex_state = 21},
  [3045] = {.lex_state = 378, .external_lex_state = 16},
  [3046] = {.lex_state = 444, .external_lex_state = 21},
  [3047] = {.lex_state = 378, .external_lex_state = 16},
  [3048] = {.lex_state = 444, .external_lex_state = 21},
  [3049] = {.lex_state = 378, .external_lex_state = 16},
  [3050] = {.lex_state = 450, .external_lex_state = 10},
  [3051] = {.lex_state = 450, .external_lex_state = 10},
  [3052] = {.lex_state = 450, .external_lex_state = 10},
  [3053] = {.lex_state = 376, .external_lex_state = 16},
  [3054] = {.lex_state = 450, .external_lex_state = 10},
  [3055] = {.lex_state = 380},
  [3056] = {.lex_state = 378, .external_lex_state = 16},
  [3057] = {.lex_state = 203},
  [3058] = {.lex_state = 308, .external_lex_state = 16},
  [3059] = {.lex_state = 308, .external_lex_state = 16},
  [3060] = {.lex_state = 308, .external_lex_state = 16},
  [3061] = {.lex_state = 450, .external_lex_state = 10},
  [3062] = {.lex_state = 380},
  [3063] = {.lex_state = 378, .external_lex_state = 16},
  [3064] = {.lex_state = 450, .external_lex_state = 10},
  [3065] = {.lex_state = 380},
  [3066] = {.lex_state = 378, .external_lex_state = 16},
  [3067] = {.lex_state = 450, .external_lex_state = 10},
  [3068] = {.lex_state = 450, .external_lex_state = 10},
  [3069] = {.lex_state = 446, .external_lex_state = 27},
  [3070] = {.lex_state = 434, .external_lex_state = 14},
  [3071] = {.lex_state = 434, .external_lex_state = 14},
  [3072] = {.lex_state = 434, .external_lex_state = 14},
  [3073] = {.lex_state = 434, .external_lex_state = 14},
  [3074] = {.lex_state = 378, .external_lex_state = 16},
  [3075] = {.lex_state = 434, .external_lex_state = 14},
  [3076] = {.lex_state = 378, .external_lex_state = 16},
  [3077] = {.lex_state = 434, .external_lex_state = 14},
  [3078] = {.lex_state = 378, .external_lex_state = 16},
  [3079] = {.lex_state = 434, .external_lex_state = 14},
  [3080] = {.lex_state = 434, .external_lex_state = 14},
  [3081] = {.lex_state = 434, .external_lex_state = 10},
  [3082] = {.lex_state = 434, .external_lex_state = 10},
  [3083] = {.lex_state = 434, .external_lex_state = 10},
  [3084] = {.lex_state = 434, .external_lex_state = 10},
  [3085] = {.lex_state = 378, .external_lex_state = 16},
  [3086] = {.lex_state = 434, .external_lex_state = 10},
  [3087] = {.lex_state = 378, .external_lex_state = 16},
  [3088] = {.lex_state = 434, .external_lex_state = 10},
  [3089] = {.lex_state = 378, .external_lex_state = 16},
  [3090] = {.lex_state = 434, .external_lex_state = 10},
  [3091] = {.lex_state = 434, .external_lex_state = 10},
  [3092] = {.lex_state = 440, .external_lex_state = 5},
  [3093] = {.lex_state = 440, .external_lex_state = 5},
  [3094] = {.lex_state = 440, .external_lex_state = 5},
  [3095] = {.lex_state = 446, .external_lex_state = 5},
  [3096] = {.lex_state = 446, .external_lex_state = 5},
  [3097] = {.lex_state = 446, .external_lex_state = 5},
  [3098] = {.lex_state = 378, .external_lex_state = 16},
  [3099] = {.lex_state = 411, .external_lex_state = 24},
  [3100] = {.lex_state = 411, .external_lex_state = 24},
  [3101] = {.lex_state = 203, .external_lex_state = 16},
  [3102] = {.lex_state = 378, .external_lex_state = 16},
  [3103] = {.lex_state = 446, .external_lex_state = 5},
  [3104] = {.lex_state = 378, .external_lex_state = 16},
  [3105] = {.lex_state = 446, .external_lex_state = 5},
  [3106] = {.lex_state = 378, .external_lex_state = 16},
  [3107] = {.lex_state = 446, .external_lex_state = 5},
  [3108] = {.lex_state = 378, .external_lex_state = 16},
  [3109] = {.lex_state = 446, .external_lex_state = 5},
  [3110] = {.lex_state = 378, .external_lex_state = 16},
  [3111] = {.lex_state = 444, .external_lex_state = 21},
  [3112] = {.lex_state = 444, .external_lex_state = 21},
  [3113] = {.lex_state = 444, .external_lex_state = 21},
  [3114] = {.lex_state = 444, .external_lex_state = 21},
  [3115] = {.lex_state = 378, .external_lex_state = 16},
  [3116] = {.lex_state = 444, .external_lex_state = 21},
  [3117] = {.lex_state = 378, .external_lex_state = 16},
  [3118] = {.lex_state = 444, .external_lex_state = 21},
  [3119] = {.lex_state = 378, .external_lex_state = 16},
  [3120] = {.lex_state = 444, .external_lex_state = 21},
  [3121] = {.lex_state = 444, .external_lex_state = 21},
  [3122] = {.lex_state = 450, .external_lex_state = 10},
  [3123] = {.lex_state = 411, .external_lex_state = 24},
  [3124] = {.lex_state = 411, .external_lex_state = 24},
  [3125] = {.lex_state = 203, .external_lex_state = 16},
  [3126] = {.lex_state = 378, .external_lex_state = 16},
  [3127] = {.lex_state = 450, .external_lex_state = 10},
  [3128] = {.lex_state = 376, .external_lex_state = 16},
  [3129] = {.lex_state = 450, .external_lex_state = 10},
  [3130] = {.lex_state = 380},
  [3131] = {.lex_state = 378, .external_lex_state = 16},
  [3132] = {.lex_state = 450, .external_lex_state = 10},
  [3133] = {.lex_state = 380},
  [3134] = {.lex_state = 378, .external_lex_state = 16},
  [3135] = {.lex_state = 380},
  [3136] = {.lex_state = 378, .external_lex_state = 16},
  [3137] = {.lex_state = 378, .external_lex_state = 16},
  [3138] = {.lex_state = 450, .external_lex_state = 10},
  [3139] = {.lex_state = 378, .external_lex_state = 16},
  [3140] = {.lex_state = 434, .external_lex_state = 14},
  [3141] = {.lex_state = 434, .external_lex_state = 14},
  [3142] = {.lex_state = 434, .external_lex_state = 14},
  [3143] = {.lex_state = 434, .external_lex_state = 10},
  [3144] = {.lex_state = 434, .external_lex_state = 10},
  [3145] = {.lex_state = 434, .external_lex_state = 10},
  [3146] = {.lex_state = 446, .external_lex_state = 5},
  [3147] = {.lex_state = 446, .external_lex_state = 5},
  [3148] = {.lex_state = 446, .external_lex_state = 5},
  [3149] = {.lex_state = 446, .external_lex_state = 5},
  [3150] = {.lex_state = 378, .external_lex_state = 16},
  [3151] = {.lex_state = 446, .external_lex_state = 5},
  [3152] = {.lex_state = 378, .external_lex_state = 16},
  [3153] = {.lex_state = 446, .external_lex_state = 5},
  [3154] = {.lex_state = 378, .external_lex_state = 16},
  [3155] = {.lex_state = 446, .external_lex_state = 5},
  [3156] = {.lex_state = 446, .external_lex_state = 5},
  [3157] = {.lex_state = 444, .external_lex_state = 21},
  [3158] = {.lex_state = 444, .external_lex_state = 21},
  [3159] = {.lex_state = 444, .external_lex_state = 21},
  [3160] = {.lex_state = 450, .external_lex_state = 10},
  [3161] = {.lex_state = 450, .external_lex_state = 10},
  [3162] = {.lex_state = 450, .external_lex_state = 10},
  [3163] = {.lex_state = 378, .external_lex_state = 16},
  [3164] = {.lex_state = 411, .external_lex_state = 24},
  [3165] = {.lex_state = 411, .external_lex_state = 24},
  [3166] = {.lex_state = 203, .external_lex_state = 16},
  [3167] = {.lex_state = 378, .external_lex_state = 16},
  [3168] = {.lex_state = 450, .external_lex_state = 10},
  [3169] = {.lex_state = 378, .external_lex_state = 16},
  [3170] = {.lex_state = 450, .external_lex_state = 10},
  [3171] = {.lex_state = 378, .external_lex_state = 16},
  [3172] = {.lex_state = 450, .external_lex_state = 10},
  [3173] = {.lex_state = 378, .external_lex_state = 16},
  [3174] = {.lex_state = 450, .external_lex_state = 10},
  [3175] = {.lex_state = 378, .external_lex_state = 16},
  [3176] = {.lex_state = 446, .external_lex_state = 5},
  [3177] = {.lex_state = 446, .external_lex_state = 5},
  [3178] = {.lex_state = 446, .external_lex_state = 5},
  [3179] = {.lex_state = 450, .external_lex_state = 10},
  [3180] = {.lex_state = 450, .external_lex_state = 10},
  [3181] = {.lex_state = 450, .external_lex_state = 10},
  [3182] = {.lex_state = 450, .external_lex_state = 10},
  [3183] = {.lex_state = 378, .external_lex_state = 16},
  [3184] = {.lex_state = 450, .external_lex_state = 10},
  [3185] = {.lex_state = 378, .external_lex_state = 16},
  [3186] = {.lex_state = 450, .external_lex_state = 10},
  [3187] = {.lex_state = 378, .external_lex_state = 16},
  [3188] = {.lex_state = 450, .external_lex_state = 10},
  [3189] = {.lex_state = 450, .external_lex_state = 10},
  [3190] = {.lex_state = 450, .external_lex_state = 10},
  [3191] = {.lex_state = 450, .external_lex_state = 10},
  [3192] = {.lex_state = 450, .external_lex_state = 10},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[29][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_variable_name] = true,
  },
  [7] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [18] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [20] = {
    [ts_external_token_heredoc_start] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [24] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [25] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
  },
  [27] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_then] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(3),
    [anon_sym_typeset] = ACTIONS(3),
    [anon_sym_export] = ACTIONS(3),
    [anon_sym_readonly] = ACTIONS(3),
    [anon_sym_local] = ACTIONS(3),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [aux_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(24),
    [sym__terminated_statement] = STATE(30),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(25),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_unset_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(58),
    [anon_sym_GT] = ACTIONS(58),
    [anon_sym_GT_GT] = ACTIONS(60),
    [anon_sym_AMP_GT] = ACTIONS(58),
    [anon_sym_AMP_GT_GT] = ACTIONS(60),
    [anon_sym_LT_AMP] = ACTIONS(60),
    [anon_sym_GT_AMP] = ACTIONS(60),
    [sym_comment] = ACTIONS(54),
  },
  [3] = {
    [sym__assignment] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(64),
    [sym_comment] = ACTIONS(54),
  },
  [4] = {
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(66),
  },
  [5] = {
    [sym__terminated_statement] = STATE(37),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [6] = {
    [sym__terminated_statement] = STATE(40),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [7] = {
    [sym_concatenation] = STATE(49),
    [sym_string] = STATE(44),
    [sym_simple_expansion] = STATE(44),
    [sym_string_expansion] = STATE(44),
    [sym_expansion] = STATE(44),
    [sym_command_substitution] = STATE(44),
    [sym_process_substitution] = STATE(44),
    [sym__special_characters] = ACTIONS(68),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [sym_raw_string] = ACTIONS(74),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(76),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [anon_sym_LT_LPAREN] = ACTIONS(82),
    [anon_sym_GT_LPAREN] = ACTIONS(82),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(74),
  },
  [8] = {
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(84),
  },
  [9] = {
    [sym__terminated_statement] = STATE(65),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_case_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_subshell] = STATE(61),
    [sym_pipeline] = STATE(61),
    [sym_list] = STATE(61),
    [sym_command] = STATE(61),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(61),
    [sym_variable_assignment] = STATE(63),
    [sym_declaration_command] = STATE(61),
    [sym_unset_command] = STATE(61),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_program_repeat1] = STATE(65),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [10] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(77),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [sym__special_characters] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [11] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(88),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [sym__special_characters] = ACTIONS(128),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [12] = {
    [sym_variable_assignment] = STATE(100),
    [sym_subscript] = STATE(99),
    [sym_concatenation] = STATE(100),
    [sym_string] = STATE(93),
    [sym_simple_expansion] = STATE(93),
    [sym_string_expansion] = STATE(93),
    [sym_expansion] = STATE(93),
    [sym_command_substitution] = STATE(93),
    [sym_process_substitution] = STATE(93),
    [aux_sym_declaration_command_repeat1] = STATE(100),
    [sym_variable_name] = ACTIONS(146),
    [anon_sym_PIPE] = ACTIONS(148),
    [anon_sym_SEMI_SEMI] = ACTIONS(148),
    [anon_sym_PIPE_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(148),
    [anon_sym_PIPE_PIPE] = ACTIONS(148),
    [sym__special_characters] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(160),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(164),
    [anon_sym_GT_LPAREN] = ACTIONS(164),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(168),
    [sym_word] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(148),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(148),
  },
  [13] = {
    [sym_concatenation] = STATE(110),
    [sym_string] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_unset_command_repeat1] = STATE(110),
    [anon_sym_PIPE] = ACTIONS(172),
    [anon_sym_SEMI_SEMI] = ACTIONS(172),
    [anon_sym_PIPE_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(172),
    [anon_sym_PIPE_PIPE] = ACTIONS(172),
    [sym__special_characters] = ACTIONS(174),
    [anon_sym_DQUOTE] = ACTIONS(176),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(184),
    [anon_sym_BQUOTE] = ACTIONS(186),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(190),
    [sym_word] = ACTIONS(180),
    [anon_sym_SEMI] = ACTIONS(172),
    [anon_sym_LF] = ACTIONS(192),
    [anon_sym_AMP] = ACTIONS(172),
  },
  [14] = {
    [sym_concatenation] = STATE(119),
    [sym_string] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym__special_characters] = ACTIONS(194),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(200),
  },
  [15] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(210),
    [sym__heredoc_body_beginning] = ACTIONS(210),
    [sym_file_descriptor] = ACTIONS(210),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_SEMI_SEMI] = ACTIONS(214),
    [anon_sym_PIPE_AMP] = ACTIONS(214),
    [anon_sym_AMP_AMP] = ACTIONS(214),
    [anon_sym_PIPE_PIPE] = ACTIONS(214),
    [anon_sym_EQ_TILDE] = ACTIONS(214),
    [anon_sym_EQ_EQ] = ACTIONS(214),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_LT_LT_DASH] = ACTIONS(214),
    [anon_sym_LT_LT_LT] = ACTIONS(214),
    [sym__special_characters] = ACTIONS(214),
    [anon_sym_DQUOTE] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(214),
    [sym_raw_string] = ACTIONS(214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(214),
    [anon_sym_LT_LPAREN] = ACTIONS(214),
    [anon_sym_GT_LPAREN] = ACTIONS(214),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(214),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(214),
  },
  [16] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(128),
    [anon_sym_DQUOTE] = ACTIONS(216),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [17] = {
    [sym_string] = STATE(130),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(228),
    [sym_raw_string] = ACTIONS(230),
    [anon_sym_POUND] = ACTIONS(228),
    [anon_sym_DASH] = ACTIONS(228),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(232),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_AT] = ACTIONS(228),
    [anon_sym_QMARK] = ACTIONS(228),
    [anon_sym_0] = ACTIONS(234),
    [anon_sym__] = ACTIONS(234),
  },
  [18] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [19] = {
    [sym_subscript] = STATE(136),
    [sym_variable_name] = ACTIONS(240),
    [anon_sym_DOLLAR] = ACTIONS(242),
    [anon_sym_POUND] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(242),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_0] = ACTIONS(248),
    [anon_sym__] = ACTIONS(248),
  },
  [20] = {
    [sym_for_statement] = STATE(157),
    [sym_while_statement] = STATE(157),
    [sym_if_statement] = STATE(157),
    [sym_case_statement] = STATE(157),
    [sym_function_definition] = STATE(157),
    [sym_subshell] = STATE(157),
    [sym_pipeline] = STATE(157),
    [sym_list] = STATE(157),
    [sym_command] = STATE(157),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(157),
    [sym_variable_assignment] = STATE(159),
    [sym_declaration_command] = STATE(157),
    [sym_unset_command] = STATE(157),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [21] = {
    [sym_for_statement] = STATE(173),
    [sym_while_statement] = STATE(173),
    [sym_if_statement] = STATE(173),
    [sym_case_statement] = STATE(173),
    [sym_function_definition] = STATE(173),
    [sym_subshell] = STATE(173),
    [sym_pipeline] = STATE(173),
    [sym_list] = STATE(173),
    [sym_command] = STATE(173),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(173),
    [sym_variable_assignment] = STATE(175),
    [sym_declaration_command] = STATE(173),
    [sym_unset_command] = STATE(173),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [22] = {
    [sym_for_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_case_statement] = STATE(178),
    [sym_function_definition] = STATE(178),
    [sym_subshell] = STATE(178),
    [sym_pipeline] = STATE(178),
    [sym_list] = STATE(178),
    [sym_command] = STATE(178),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(178),
    [sym_variable_assignment] = STATE(179),
    [sym_declaration_command] = STATE(178),
    [sym_unset_command] = STATE(178),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [23] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(310),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(312),
    [sym_comment] = ACTIONS(54),
  },
  [25] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(316),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [26] = {
    [sym_file_redirect] = STATE(195),
    [sym_heredoc_redirect] = STATE(195),
    [sym_heredoc_body] = STATE(193),
    [sym_herestring_redirect] = STATE(195),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(192),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [aux_sym_while_statement_repeat1] = STATE(195),
    [aux_sym_command_repeat2] = STATE(196),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_SEMI_SEMI] = ACTIONS(328),
    [anon_sym_PIPE_AMP] = ACTIONS(328),
    [anon_sym_AMP_AMP] = ACTIONS(328),
    [anon_sym_PIPE_PIPE] = ACTIONS(328),
    [anon_sym_EQ_TILDE] = ACTIONS(330),
    [anon_sym_EQ_EQ] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(342),
    [anon_sym_SEMI] = ACTIONS(328),
    [anon_sym_LF] = ACTIONS(352),
    [anon_sym_AMP] = ACTIONS(328),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(316),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [28] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(64),
    [sym_comment] = ACTIONS(54),
  },
  [29] = {
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [30] = {
    [sym__terminated_statement] = STATE(197),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(25),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_unset_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(197),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(358),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [31] = {
    [sym_command_name] = STATE(199),
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(44),
  },
  [32] = {
    [sym_concatenation] = STATE(204),
    [sym_string] = STATE(203),
    [sym_simple_expansion] = STATE(203),
    [sym_string_expansion] = STATE(203),
    [sym_expansion] = STATE(203),
    [sym_command_substitution] = STATE(203),
    [sym_process_substitution] = STATE(203),
    [sym__special_characters] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(366),
  },
  [33] = {
    [sym_concatenation] = STATE(207),
    [sym_string] = STATE(206),
    [sym_simple_expansion] = STATE(206),
    [sym_string_expansion] = STATE(206),
    [sym_expansion] = STATE(206),
    [sym_command_substitution] = STATE(206),
    [sym_process_substitution] = STATE(206),
    [sym__special_characters] = ACTIONS(368),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(370),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(370),
  },
  [34] = {
    [sym_concatenation] = STATE(208),
    [sym_string] = STATE(213),
    [sym_array] = STATE(208),
    [sym_simple_expansion] = STATE(213),
    [sym_string_expansion] = STATE(213),
    [sym_expansion] = STATE(213),
    [sym_command_substitution] = STATE(213),
    [sym_process_substitution] = STATE(213),
    [sym__empty_value] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(374),
    [sym__special_characters] = ACTIONS(376),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(388),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(382),
  },
  [35] = {
    [sym_file_descriptor] = ACTIONS(392),
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_SEMI_SEMI] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(394),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(394),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LF] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
  },
  [36] = {
    [anon_sym_in] = ACTIONS(396),
    [anon_sym_SEMI_SEMI] = ACTIONS(398),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(398),
    [anon_sym_LF] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(398),
  },
  [37] = {
    [sym_do_group] = STATE(221),
    [anon_sym_do] = ACTIONS(402),
    [sym_comment] = ACTIONS(54),
  },
  [38] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(404),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(404),
    [anon_sym_LF] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(404),
  },
  [39] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(404),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(404),
    [anon_sym_LF] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(404),
  },
  [40] = {
    [anon_sym_then] = ACTIONS(408),
    [sym_comment] = ACTIONS(54),
  },
  [41] = {
    [aux_sym_concatenation_repeat1] = STATE(227),
    [sym__concat] = ACTIONS(410),
    [anon_sym_in] = ACTIONS(412),
    [anon_sym_SEMI_SEMI] = ACTIONS(414),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_LF] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(414),
  },
  [42] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(229),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [43] = {
    [sym_string] = STATE(231),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [anon_sym_DOLLAR] = ACTIONS(420),
    [sym_raw_string] = ACTIONS(422),
    [anon_sym_POUND] = ACTIONS(420),
    [anon_sym_DASH] = ACTIONS(420),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(420),
    [anon_sym_AT] = ACTIONS(420),
    [anon_sym_QMARK] = ACTIONS(420),
    [anon_sym_0] = ACTIONS(426),
    [anon_sym__] = ACTIONS(426),
  },
  [44] = {
    [aux_sym_concatenation_repeat1] = STATE(227),
    [sym__concat] = ACTIONS(410),
    [anon_sym_in] = ACTIONS(428),
    [anon_sym_SEMI_SEMI] = ACTIONS(430),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(430),
    [anon_sym_LF] = ACTIONS(432),
    [anon_sym_AMP] = ACTIONS(430),
  },
  [45] = {
    [sym_subscript] = STATE(239),
    [sym_variable_name] = ACTIONS(434),
    [anon_sym_DOLLAR] = ACTIONS(436),
    [anon_sym_POUND] = ACTIONS(438),
    [anon_sym_DASH] = ACTIONS(436),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(440),
    [anon_sym_STAR] = ACTIONS(436),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_QMARK] = ACTIONS(436),
    [anon_sym_0] = ACTIONS(442),
    [anon_sym__] = ACTIONS(442),
  },
  [46] = {
    [sym_for_statement] = STATE(240),
    [sym_while_statement] = STATE(240),
    [sym_if_statement] = STATE(240),
    [sym_case_statement] = STATE(240),
    [sym_function_definition] = STATE(240),
    [sym_subshell] = STATE(240),
    [sym_pipeline] = STATE(240),
    [sym_list] = STATE(240),
    [sym_command] = STATE(240),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(240),
    [sym_variable_assignment] = STATE(241),
    [sym_declaration_command] = STATE(240),
    [sym_unset_command] = STATE(240),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [47] = {
    [sym_for_statement] = STATE(242),
    [sym_while_statement] = STATE(242),
    [sym_if_statement] = STATE(242),
    [sym_case_statement] = STATE(242),
    [sym_function_definition] = STATE(242),
    [sym_subshell] = STATE(242),
    [sym_pipeline] = STATE(242),
    [sym_list] = STATE(242),
    [sym_command] = STATE(242),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(242),
    [sym_variable_assignment] = STATE(243),
    [sym_declaration_command] = STATE(242),
    [sym_unset_command] = STATE(242),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [48] = {
    [sym_for_statement] = STATE(244),
    [sym_while_statement] = STATE(244),
    [sym_if_statement] = STATE(244),
    [sym_case_statement] = STATE(244),
    [sym_function_definition] = STATE(244),
    [sym_subshell] = STATE(244),
    [sym_pipeline] = STATE(244),
    [sym_list] = STATE(244),
    [sym_command] = STATE(244),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(244),
    [sym_variable_assignment] = STATE(245),
    [sym_declaration_command] = STATE(244),
    [sym_unset_command] = STATE(244),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [49] = {
    [anon_sym_in] = ACTIONS(428),
    [anon_sym_SEMI_SEMI] = ACTIONS(430),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(430),
    [anon_sym_LF] = ACTIONS(432),
    [anon_sym_AMP] = ACTIONS(430),
  },
  [50] = {
    [sym_compound_statement] = STATE(248),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [51] = {
    [sym__assignment] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(448),
    [anon_sym_PLUS_EQ] = ACTIONS(448),
    [sym_comment] = ACTIONS(54),
  },
  [52] = {
    [sym__terminated_statement] = STATE(250),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [53] = {
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(450),
  },
  [54] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(252),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [sym__special_characters] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [55] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(253),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [sym__special_characters] = ACTIONS(128),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [56] = {
    [sym_variable_assignment] = STATE(258),
    [sym_subscript] = STATE(257),
    [sym_concatenation] = STATE(258),
    [sym_string] = STATE(256),
    [sym_simple_expansion] = STATE(256),
    [sym_string_expansion] = STATE(256),
    [sym_expansion] = STATE(256),
    [sym_command_substitution] = STATE(256),
    [sym_process_substitution] = STATE(256),
    [aux_sym_declaration_command_repeat1] = STATE(258),
    [sym_variable_name] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(148),
    [anon_sym_RPAREN] = ACTIONS(148),
    [anon_sym_SEMI_SEMI] = ACTIONS(148),
    [anon_sym_PIPE_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(148),
    [anon_sym_PIPE_PIPE] = ACTIONS(148),
    [sym__special_characters] = ACTIONS(454),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(160),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(164),
    [anon_sym_GT_LPAREN] = ACTIONS(164),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(168),
    [sym_word] = ACTIONS(456),
    [anon_sym_SEMI] = ACTIONS(148),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(148),
  },
  [57] = {
    [sym_concatenation] = STATE(261),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_unset_command_repeat1] = STATE(261),
    [anon_sym_PIPE] = ACTIONS(172),
    [anon_sym_RPAREN] = ACTIONS(172),
    [anon_sym_SEMI_SEMI] = ACTIONS(172),
    [anon_sym_PIPE_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(172),
    [anon_sym_PIPE_PIPE] = ACTIONS(172),
    [sym__special_characters] = ACTIONS(458),
    [anon_sym_DQUOTE] = ACTIONS(176),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(184),
    [anon_sym_BQUOTE] = ACTIONS(186),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(190),
    [sym_word] = ACTIONS(460),
    [anon_sym_SEMI] = ACTIONS(172),
    [anon_sym_LF] = ACTIONS(192),
    [anon_sym_AMP] = ACTIONS(172),
  },
  [58] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(210),
    [sym__heredoc_body_beginning] = ACTIONS(210),
    [sym_file_descriptor] = ACTIONS(210),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(214),
    [anon_sym_SEMI_SEMI] = ACTIONS(214),
    [anon_sym_PIPE_AMP] = ACTIONS(214),
    [anon_sym_AMP_AMP] = ACTIONS(214),
    [anon_sym_PIPE_PIPE] = ACTIONS(214),
    [anon_sym_EQ_TILDE] = ACTIONS(214),
    [anon_sym_EQ_EQ] = ACTIONS(214),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_LT_LT_DASH] = ACTIONS(214),
    [anon_sym_LT_LT_LT] = ACTIONS(214),
    [sym__special_characters] = ACTIONS(214),
    [anon_sym_DQUOTE] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(214),
    [sym_raw_string] = ACTIONS(214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(214),
    [anon_sym_LT_LPAREN] = ACTIONS(214),
    [anon_sym_GT_LPAREN] = ACTIONS(214),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(214),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(214),
  },
  [59] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [60] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(462),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [61] = {
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_LF] = ACTIONS(472),
    [anon_sym_AMP] = ACTIONS(468),
  },
  [62] = {
    [sym_file_redirect] = STATE(274),
    [sym_heredoc_redirect] = STATE(274),
    [sym_heredoc_body] = STATE(193),
    [sym_herestring_redirect] = STATE(274),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(273),
    [sym_simple_expansion] = STATE(273),
    [sym_string_expansion] = STATE(273),
    [sym_expansion] = STATE(273),
    [sym_command_substitution] = STATE(273),
    [sym_process_substitution] = STATE(273),
    [aux_sym_while_statement_repeat1] = STATE(274),
    [aux_sym_command_repeat2] = STATE(275),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_RPAREN] = ACTIONS(328),
    [anon_sym_SEMI_SEMI] = ACTIONS(328),
    [anon_sym_PIPE_AMP] = ACTIONS(328),
    [anon_sym_AMP_AMP] = ACTIONS(328),
    [anon_sym_PIPE_PIPE] = ACTIONS(328),
    [anon_sym_EQ_TILDE] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(482),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(484),
    [anon_sym_SEMI] = ACTIONS(328),
    [anon_sym_LF] = ACTIONS(352),
    [anon_sym_AMP] = ACTIONS(328),
  },
  [63] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI_SEMI] = ACTIONS(468),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_LF] = ACTIONS(472),
    [anon_sym_AMP] = ACTIONS(468),
  },
  [64] = {
    [sym__assignment] = STATE(35),
    [anon_sym_EQ] = ACTIONS(448),
    [anon_sym_PLUS_EQ] = ACTIONS(448),
    [sym_comment] = ACTIONS(54),
  },
  [65] = {
    [sym__terminated_statement] = STATE(278),
    [sym_for_statement] = STATE(276),
    [sym_while_statement] = STATE(276),
    [sym_if_statement] = STATE(276),
    [sym_case_statement] = STATE(276),
    [sym_function_definition] = STATE(276),
    [sym_subshell] = STATE(276),
    [sym_pipeline] = STATE(276),
    [sym_list] = STATE(276),
    [sym_command] = STATE(276),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(276),
    [sym_variable_assignment] = STATE(277),
    [sym_declaration_command] = STATE(276),
    [sym_unset_command] = STATE(276),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_program_repeat1] = STATE(278),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [66] = {
    [sym_command_name] = STATE(279),
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(486),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(102),
  },
  [67] = {
    [sym_concatenation] = STATE(282),
    [sym_string] = STATE(281),
    [sym_simple_expansion] = STATE(281),
    [sym_string_expansion] = STATE(281),
    [sym_expansion] = STATE(281),
    [sym_command_substitution] = STATE(281),
    [sym_process_substitution] = STATE(281),
    [sym__special_characters] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(496),
    [anon_sym_BQUOTE] = ACTIONS(498),
    [anon_sym_LT_LPAREN] = ACTIONS(500),
    [anon_sym_GT_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(492),
    [sym_regex] = ACTIONS(502),
  },
  [68] = {
    [aux_sym_concatenation_repeat1] = STATE(284),
    [sym__concat] = ACTIONS(504),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_RBRACK] = ACTIONS(508),
    [sym__special_characters] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(508),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(508),
    [anon_sym_GT_LPAREN] = ACTIONS(508),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(506),
  },
  [69] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [70] = {
    [sym_string] = STATE(288),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(512),
    [sym_raw_string] = ACTIONS(514),
    [anon_sym_POUND] = ACTIONS(512),
    [anon_sym_DASH] = ACTIONS(512),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(512),
    [anon_sym_AT] = ACTIONS(512),
    [anon_sym_QMARK] = ACTIONS(512),
    [anon_sym_0] = ACTIONS(518),
    [anon_sym__] = ACTIONS(518),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(284),
    [sym__concat] = ACTIONS(504),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_RBRACK] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [72] = {
    [sym_subscript] = STATE(294),
    [sym_variable_name] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_POUND] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(526),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_QMARK] = ACTIONS(526),
    [anon_sym_0] = ACTIONS(532),
    [anon_sym__] = ACTIONS(532),
  },
  [73] = {
    [sym_for_statement] = STATE(295),
    [sym_while_statement] = STATE(295),
    [sym_if_statement] = STATE(295),
    [sym_case_statement] = STATE(295),
    [sym_function_definition] = STATE(295),
    [sym_subshell] = STATE(295),
    [sym_pipeline] = STATE(295),
    [sym_list] = STATE(295),
    [sym_command] = STATE(295),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(295),
    [sym_variable_assignment] = STATE(296),
    [sym_declaration_command] = STATE(295),
    [sym_unset_command] = STATE(295),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [74] = {
    [sym_for_statement] = STATE(297),
    [sym_while_statement] = STATE(297),
    [sym_if_statement] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_function_definition] = STATE(297),
    [sym_subshell] = STATE(297),
    [sym_pipeline] = STATE(297),
    [sym_list] = STATE(297),
    [sym_command] = STATE(297),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(297),
    [sym_variable_assignment] = STATE(298),
    [sym_declaration_command] = STATE(297),
    [sym_unset_command] = STATE(297),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [75] = {
    [sym_for_statement] = STATE(299),
    [sym_while_statement] = STATE(299),
    [sym_if_statement] = STATE(299),
    [sym_case_statement] = STATE(299),
    [sym_function_definition] = STATE(299),
    [sym_subshell] = STATE(299),
    [sym_pipeline] = STATE(299),
    [sym_list] = STATE(299),
    [sym_command] = STATE(299),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(299),
    [sym_variable_assignment] = STATE(300),
    [sym_declaration_command] = STATE(299),
    [sym_unset_command] = STATE(299),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [76] = {
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_RBRACK] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [77] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [anon_sym_RBRACK] = ACTIONS(534),
    [sym__special_characters] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [78] = {
    [sym_concatenation] = STATE(305),
    [sym_string] = STATE(304),
    [sym_simple_expansion] = STATE(304),
    [sym_string_expansion] = STATE(304),
    [sym_expansion] = STATE(304),
    [sym_command_substitution] = STATE(304),
    [sym_process_substitution] = STATE(304),
    [sym__special_characters] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(548),
    [anon_sym_LT_LPAREN] = ACTIONS(550),
    [anon_sym_GT_LPAREN] = ACTIONS(550),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(542),
    [sym_regex] = ACTIONS(552),
  },
  [79] = {
    [aux_sym_concatenation_repeat1] = STATE(307),
    [sym__concat] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(508),
    [sym__special_characters] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(508),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(508),
    [anon_sym_GT_LPAREN] = ACTIONS(508),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(506),
  },
  [80] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(309),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [81] = {
    [sym_string] = STATE(311),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(558),
    [sym_raw_string] = ACTIONS(560),
    [anon_sym_POUND] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(558),
    [anon_sym_0] = ACTIONS(564),
    [anon_sym__] = ACTIONS(564),
  },
  [82] = {
    [aux_sym_concatenation_repeat1] = STATE(307),
    [sym__concat] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [83] = {
    [sym_subscript] = STATE(317),
    [sym_variable_name] = ACTIONS(566),
    [anon_sym_DOLLAR] = ACTIONS(568),
    [anon_sym_POUND] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(568),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(568),
    [anon_sym_0] = ACTIONS(574),
    [anon_sym__] = ACTIONS(574),
  },
  [84] = {
    [sym_for_statement] = STATE(318),
    [sym_while_statement] = STATE(318),
    [sym_if_statement] = STATE(318),
    [sym_case_statement] = STATE(318),
    [sym_function_definition] = STATE(318),
    [sym_subshell] = STATE(318),
    [sym_pipeline] = STATE(318),
    [sym_list] = STATE(318),
    [sym_command] = STATE(318),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(318),
    [sym_variable_assignment] = STATE(319),
    [sym_declaration_command] = STATE(318),
    [sym_unset_command] = STATE(318),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [85] = {
    [sym_for_statement] = STATE(320),
    [sym_while_statement] = STATE(320),
    [sym_if_statement] = STATE(320),
    [sym_case_statement] = STATE(320),
    [sym_function_definition] = STATE(320),
    [sym_subshell] = STATE(320),
    [sym_pipeline] = STATE(320),
    [sym_list] = STATE(320),
    [sym_command] = STATE(320),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(320),
    [sym_variable_assignment] = STATE(321),
    [sym_declaration_command] = STATE(320),
    [sym_unset_command] = STATE(320),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [86] = {
    [sym_for_statement] = STATE(322),
    [sym_while_statement] = STATE(322),
    [sym_if_statement] = STATE(322),
    [sym_case_statement] = STATE(322),
    [sym_function_definition] = STATE(322),
    [sym_subshell] = STATE(322),
    [sym_pipeline] = STATE(322),
    [sym_list] = STATE(322),
    [sym_command] = STATE(322),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(322),
    [sym_variable_assignment] = STATE(323),
    [sym_declaration_command] = STATE(322),
    [sym_unset_command] = STATE(322),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [87] = {
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [88] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(534),
    [sym__special_characters] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [89] = {
    [sym__assignment] = STATE(326),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_PLUS_EQ] = ACTIONS(578),
    [sym_comment] = ACTIONS(54),
  },
  [90] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_SEMI_SEMI] = ACTIONS(584),
    [anon_sym_PIPE_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(584),
    [anon_sym_PIPE_PIPE] = ACTIONS(584),
    [sym__special_characters] = ACTIONS(584),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [anon_sym_DOLLAR] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(584),
    [anon_sym_BQUOTE] = ACTIONS(584),
    [anon_sym_LT_LPAREN] = ACTIONS(584),
    [anon_sym_GT_LPAREN] = ACTIONS(584),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(584),
    [sym_word] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(584),
  },
  [91] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(330),
    [anon_sym_DQUOTE] = ACTIONS(586),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [92] = {
    [sym_string] = STATE(332),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(590),
    [sym_raw_string] = ACTIONS(592),
    [anon_sym_POUND] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(594),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_AT] = ACTIONS(590),
    [anon_sym_QMARK] = ACTIONS(590),
    [anon_sym_0] = ACTIONS(596),
    [anon_sym__] = ACTIONS(596),
  },
  [93] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_SEMI_SEMI] = ACTIONS(600),
    [anon_sym_PIPE_AMP] = ACTIONS(600),
    [anon_sym_AMP_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(600),
    [sym__special_characters] = ACTIONS(600),
    [anon_sym_DQUOTE] = ACTIONS(600),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [sym_raw_string] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(600),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [anon_sym_LT_LPAREN] = ACTIONS(600),
    [anon_sym_GT_LPAREN] = ACTIONS(600),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(600),
    [sym_word] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(600),
    [anon_sym_LF] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
  },
  [94] = {
    [sym_subscript] = STATE(338),
    [sym_variable_name] = ACTIONS(602),
    [anon_sym_DOLLAR] = ACTIONS(604),
    [anon_sym_POUND] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(604),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(608),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_QMARK] = ACTIONS(604),
    [anon_sym_0] = ACTIONS(610),
    [anon_sym__] = ACTIONS(610),
  },
  [95] = {
    [sym_for_statement] = STATE(339),
    [sym_while_statement] = STATE(339),
    [sym_if_statement] = STATE(339),
    [sym_case_statement] = STATE(339),
    [sym_function_definition] = STATE(339),
    [sym_subshell] = STATE(339),
    [sym_pipeline] = STATE(339),
    [sym_list] = STATE(339),
    [sym_command] = STATE(339),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(339),
    [sym_variable_assignment] = STATE(340),
    [sym_declaration_command] = STATE(339),
    [sym_unset_command] = STATE(339),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [96] = {
    [sym_for_statement] = STATE(341),
    [sym_while_statement] = STATE(341),
    [sym_if_statement] = STATE(341),
    [sym_case_statement] = STATE(341),
    [sym_function_definition] = STATE(341),
    [sym_subshell] = STATE(341),
    [sym_pipeline] = STATE(341),
    [sym_list] = STATE(341),
    [sym_command] = STATE(341),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(341),
    [sym_variable_assignment] = STATE(342),
    [sym_declaration_command] = STATE(341),
    [sym_unset_command] = STATE(341),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [97] = {
    [sym_for_statement] = STATE(343),
    [sym_while_statement] = STATE(343),
    [sym_if_statement] = STATE(343),
    [sym_case_statement] = STATE(343),
    [sym_function_definition] = STATE(343),
    [sym_subshell] = STATE(343),
    [sym_pipeline] = STATE(343),
    [sym_list] = STATE(343),
    [sym_command] = STATE(343),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(343),
    [sym_variable_assignment] = STATE(344),
    [sym_declaration_command] = STATE(343),
    [sym_unset_command] = STATE(343),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [98] = {
    [sym_variable_name] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_RPAREN] = ACTIONS(614),
    [anon_sym_SEMI_SEMI] = ACTIONS(614),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [sym__special_characters] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(614),
    [anon_sym_DOLLAR] = ACTIONS(614),
    [sym_raw_string] = ACTIONS(614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(614),
    [anon_sym_LT_LPAREN] = ACTIONS(614),
    [anon_sym_GT_LPAREN] = ACTIONS(614),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(614),
    [sym_word] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(614),
    [anon_sym_LF] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(614),
  },
  [99] = {
    [sym__assignment] = STATE(326),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_PLUS_EQ] = ACTIONS(578),
    [sym_comment] = ACTIONS(54),
  },
  [100] = {
    [sym_variable_assignment] = STATE(345),
    [sym_subscript] = STATE(99),
    [sym_concatenation] = STATE(345),
    [sym_string] = STATE(93),
    [sym_simple_expansion] = STATE(93),
    [sym_string_expansion] = STATE(93),
    [sym_expansion] = STATE(93),
    [sym_command_substitution] = STATE(93),
    [sym_process_substitution] = STATE(93),
    [aux_sym_declaration_command_repeat1] = STATE(345),
    [sym_variable_name] = ACTIONS(146),
    [anon_sym_PIPE] = ACTIONS(616),
    [anon_sym_SEMI_SEMI] = ACTIONS(616),
    [anon_sym_PIPE_AMP] = ACTIONS(616),
    [anon_sym_AMP_AMP] = ACTIONS(616),
    [anon_sym_PIPE_PIPE] = ACTIONS(616),
    [sym__special_characters] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(160),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(164),
    [anon_sym_GT_LPAREN] = ACTIONS(164),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(168),
    [sym_word] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_LF] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(616),
  },
  [101] = {
    [aux_sym_concatenation_repeat1] = STATE(347),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_SEMI_SEMI] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [sym__special_characters] = ACTIONS(622),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [anon_sym_DOLLAR] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [anon_sym_LT_LPAREN] = ACTIONS(622),
    [anon_sym_GT_LPAREN] = ACTIONS(622),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(622),
    [sym_word] = ACTIONS(622),
    [anon_sym_SEMI] = ACTIONS(622),
    [anon_sym_LF] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(622),
  },
  [102] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(349),
    [anon_sym_DQUOTE] = ACTIONS(626),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [103] = {
    [sym_string] = STATE(351),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(630),
    [sym_raw_string] = ACTIONS(632),
    [anon_sym_POUND] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(630),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_QMARK] = ACTIONS(630),
    [anon_sym_0] = ACTIONS(636),
    [anon_sym__] = ACTIONS(636),
  },
  [104] = {
    [aux_sym_concatenation_repeat1] = STATE(347),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_SEMI_SEMI] = ACTIONS(638),
    [anon_sym_PIPE_AMP] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(638),
    [anon_sym_PIPE_PIPE] = ACTIONS(638),
    [sym__special_characters] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(638),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [sym_raw_string] = ACTIONS(638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(638),
    [anon_sym_BQUOTE] = ACTIONS(638),
    [anon_sym_LT_LPAREN] = ACTIONS(638),
    [anon_sym_GT_LPAREN] = ACTIONS(638),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [sym_word] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_AMP] = ACTIONS(638),
  },
  [105] = {
    [sym_subscript] = STATE(357),
    [sym_variable_name] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(644),
    [anon_sym_POUND] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(644),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(648),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_0] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
  },
  [106] = {
    [sym_for_statement] = STATE(358),
    [sym_while_statement] = STATE(358),
    [sym_if_statement] = STATE(358),
    [sym_case_statement] = STATE(358),
    [sym_function_definition] = STATE(358),
    [sym_subshell] = STATE(358),
    [sym_pipeline] = STATE(358),
    [sym_list] = STATE(358),
    [sym_command] = STATE(358),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(358),
    [sym_variable_assignment] = STATE(359),
    [sym_declaration_command] = STATE(358),
    [sym_unset_command] = STATE(358),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [107] = {
    [sym_for_statement] = STATE(360),
    [sym_while_statement] = STATE(360),
    [sym_if_statement] = STATE(360),
    [sym_case_statement] = STATE(360),
    [sym_function_definition] = STATE(360),
    [sym_subshell] = STATE(360),
    [sym_pipeline] = STATE(360),
    [sym_list] = STATE(360),
    [sym_command] = STATE(360),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(360),
    [sym_variable_assignment] = STATE(361),
    [sym_declaration_command] = STATE(360),
    [sym_unset_command] = STATE(360),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [108] = {
    [sym_for_statement] = STATE(362),
    [sym_while_statement] = STATE(362),
    [sym_if_statement] = STATE(362),
    [sym_case_statement] = STATE(362),
    [sym_function_definition] = STATE(362),
    [sym_subshell] = STATE(362),
    [sym_pipeline] = STATE(362),
    [sym_list] = STATE(362),
    [sym_command] = STATE(362),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(362),
    [sym_variable_assignment] = STATE(363),
    [sym_declaration_command] = STATE(362),
    [sym_unset_command] = STATE(362),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [109] = {
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(652),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [110] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_unset_command_repeat1] = STATE(364),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_SEMI_SEMI] = ACTIONS(656),
    [anon_sym_PIPE_AMP] = ACTIONS(656),
    [anon_sym_AMP_AMP] = ACTIONS(656),
    [anon_sym_PIPE_PIPE] = ACTIONS(656),
    [sym__special_characters] = ACTIONS(174),
    [anon_sym_DQUOTE] = ACTIONS(176),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(184),
    [anon_sym_BQUOTE] = ACTIONS(186),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(190),
    [sym_word] = ACTIONS(180),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_LF] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(656),
  },
  [111] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(660),
    [anon_sym_LT_AMP] = ACTIONS(660),
    [anon_sym_GT_AMP] = ACTIONS(660),
    [sym__special_characters] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(664),
    [sym_raw_string] = ACTIONS(660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(660),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(660),
  },
  [112] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(368),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [113] = {
    [sym_string] = STATE(370),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [sym_raw_string] = ACTIONS(670),
    [anon_sym_POUND] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_QMARK] = ACTIONS(668),
    [anon_sym_0] = ACTIONS(674),
    [anon_sym__] = ACTIONS(674),
  },
  [114] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [sym__special_characters] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_DOLLAR] = ACTIONS(678),
    [sym_raw_string] = ACTIONS(676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [anon_sym_LT_LPAREN] = ACTIONS(676),
    [anon_sym_GT_LPAREN] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(676),
  },
  [115] = {
    [sym_subscript] = STATE(376),
    [sym_variable_name] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(682),
    [anon_sym_POUND] = ACTIONS(684),
    [anon_sym_DASH] = ACTIONS(682),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(686),
    [anon_sym_STAR] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_QMARK] = ACTIONS(682),
    [anon_sym_0] = ACTIONS(688),
    [anon_sym__] = ACTIONS(688),
  },
  [116] = {
    [sym_for_statement] = STATE(377),
    [sym_while_statement] = STATE(377),
    [sym_if_statement] = STATE(377),
    [sym_case_statement] = STATE(377),
    [sym_function_definition] = STATE(377),
    [sym_subshell] = STATE(377),
    [sym_pipeline] = STATE(377),
    [sym_list] = STATE(377),
    [sym_command] = STATE(377),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(377),
    [sym_variable_assignment] = STATE(378),
    [sym_declaration_command] = STATE(377),
    [sym_unset_command] = STATE(377),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [117] = {
    [sym_for_statement] = STATE(379),
    [sym_while_statement] = STATE(379),
    [sym_if_statement] = STATE(379),
    [sym_case_statement] = STATE(379),
    [sym_function_definition] = STATE(379),
    [sym_subshell] = STATE(379),
    [sym_pipeline] = STATE(379),
    [sym_list] = STATE(379),
    [sym_command] = STATE(379),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(379),
    [sym_variable_assignment] = STATE(380),
    [sym_declaration_command] = STATE(379),
    [sym_unset_command] = STATE(379),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [118] = {
    [sym_for_statement] = STATE(381),
    [sym_while_statement] = STATE(381),
    [sym_if_statement] = STATE(381),
    [sym_case_statement] = STATE(381),
    [sym_function_definition] = STATE(381),
    [sym_subshell] = STATE(381),
    [sym_pipeline] = STATE(381),
    [sym_list] = STATE(381),
    [sym_command] = STATE(381),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(381),
    [sym_variable_assignment] = STATE(382),
    [sym_declaration_command] = STATE(381),
    [sym_unset_command] = STATE(381),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [119] = {
    [sym_file_descriptor] = ACTIONS(676),
    [sym_variable_name] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [sym__special_characters] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_DOLLAR] = ACTIONS(678),
    [sym_raw_string] = ACTIONS(676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [anon_sym_LT_LPAREN] = ACTIONS(676),
    [anon_sym_GT_LPAREN] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(676),
  },
  [120] = {
    [sym_string] = STATE(383),
    [sym_simple_expansion] = STATE(383),
    [sym_string_expansion] = STATE(383),
    [sym_expansion] = STATE(383),
    [sym_command_substitution] = STATE(383),
    [sym_process_substitution] = STATE(383),
    [sym__special_characters] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(690),
  },
  [121] = {
    [aux_sym_concatenation_repeat1] = STATE(384),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [122] = {
    [sym__simple_heredoc_body] = ACTIONS(696),
    [sym__heredoc_body_beginning] = ACTIONS(696),
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_EQ_TILDE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(698),
    [anon_sym_LT_LT_LT] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [123] = {
    [anon_sym_DOLLAR] = ACTIONS(700),
    [sym__string_content] = ACTIONS(702),
    [anon_sym_POUND] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(704),
    [anon_sym_0] = ACTIONS(700),
    [anon_sym__] = ACTIONS(700),
  },
  [124] = {
    [sym__concat] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(710),
    [sym__string_content] = ACTIONS(712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [sym_comment] = ACTIONS(166),
  },
  [125] = {
    [sym_subscript] = STATE(393),
    [sym_variable_name] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(716),
    [anon_sym_POUND] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(716),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(716),
    [anon_sym_0] = ACTIONS(722),
    [anon_sym__] = ACTIONS(722),
  },
  [126] = {
    [sym_for_statement] = STATE(394),
    [sym_while_statement] = STATE(394),
    [sym_if_statement] = STATE(394),
    [sym_case_statement] = STATE(394),
    [sym_function_definition] = STATE(394),
    [sym_subshell] = STATE(394),
    [sym_pipeline] = STATE(394),
    [sym_list] = STATE(394),
    [sym_command] = STATE(394),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(394),
    [sym_variable_assignment] = STATE(395),
    [sym_declaration_command] = STATE(394),
    [sym_unset_command] = STATE(394),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [127] = {
    [sym_for_statement] = STATE(396),
    [sym_while_statement] = STATE(396),
    [sym_if_statement] = STATE(396),
    [sym_case_statement] = STATE(396),
    [sym_function_definition] = STATE(396),
    [sym_subshell] = STATE(396),
    [sym_pipeline] = STATE(396),
    [sym_list] = STATE(396),
    [sym_command] = STATE(396),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(396),
    [sym_variable_assignment] = STATE(397),
    [sym_declaration_command] = STATE(396),
    [sym_unset_command] = STATE(396),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [128] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(724),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [129] = {
    [sym__simple_heredoc_body] = ACTIONS(726),
    [sym__heredoc_body_beginning] = ACTIONS(726),
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_EQ_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_LT] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [130] = {
    [sym__simple_heredoc_body] = ACTIONS(730),
    [sym__heredoc_body_beginning] = ACTIONS(730),
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_EQ_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_LT] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [131] = {
    [sym__simple_heredoc_body] = ACTIONS(734),
    [sym__heredoc_body_beginning] = ACTIONS(734),
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_EQ_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(736),
    [anon_sym_LT_LT_LT] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [132] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(740),
    [sym_comment] = ACTIONS(54),
  },
  [133] = {
    [sym_concatenation] = STATE(412),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(412),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(744),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(758),
    [anon_sym_COLON] = ACTIONS(744),
    [anon_sym_COLON_QMARK] = ACTIONS(744),
    [anon_sym_COLON_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [134] = {
    [sym_subscript] = STATE(416),
    [sym_variable_name] = ACTIONS(768),
    [anon_sym_DOLLAR] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(772),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(770),
    [anon_sym_QMARK] = ACTIONS(770),
    [anon_sym_0] = ACTIONS(774),
    [anon_sym__] = ACTIONS(774),
  },
  [135] = {
    [sym_concatenation] = STATE(419),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(419),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(782),
    [anon_sym_COLON] = ACTIONS(778),
    [anon_sym_COLON_QMARK] = ACTIONS(778),
    [anon_sym_COLON_DASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [136] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(422),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_EQ] = ACTIONS(786),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(790),
    [anon_sym_COLON] = ACTIONS(786),
    [anon_sym_COLON_QMARK] = ACTIONS(786),
    [anon_sym_COLON_DASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [137] = {
    [sym__assignment] = STATE(424),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(792),
    [anon_sym_PLUS_EQ] = ACTIONS(792),
    [sym_comment] = ACTIONS(54),
  },
  [138] = {
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(794),
  },
  [139] = {
    [sym__terminated_statement] = STATE(426),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [140] = {
    [sym__terminated_statement] = STATE(427),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [141] = {
    [sym_concatenation] = STATE(430),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [sym__special_characters] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [sym_raw_string] = ACTIONS(798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(76),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [anon_sym_LT_LPAREN] = ACTIONS(82),
    [anon_sym_GT_LPAREN] = ACTIONS(82),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(798),
  },
  [142] = {
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(800),
  },
  [143] = {
    [sym__terminated_statement] = STATE(434),
    [sym_for_statement] = STATE(432),
    [sym_while_statement] = STATE(432),
    [sym_if_statement] = STATE(432),
    [sym_case_statement] = STATE(432),
    [sym_function_definition] = STATE(432),
    [sym_subshell] = STATE(432),
    [sym_pipeline] = STATE(432),
    [sym_list] = STATE(432),
    [sym_command] = STATE(432),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(432),
    [sym_variable_assignment] = STATE(433),
    [sym_declaration_command] = STATE(432),
    [sym_unset_command] = STATE(432),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_program_repeat1] = STATE(434),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [144] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(435),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [sym__special_characters] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [145] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(436),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [sym__special_characters] = ACTIONS(128),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [146] = {
    [sym_variable_assignment] = STATE(448),
    [sym_subscript] = STATE(447),
    [sym_concatenation] = STATE(448),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_declaration_command_repeat1] = STATE(448),
    [sym_variable_name] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(148),
    [anon_sym_RPAREN] = ACTIONS(170),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(816),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(820),
    [sym_word] = ACTIONS(822),
  },
  [147] = {
    [sym_concatenation] = STATE(458),
    [sym_string] = STATE(452),
    [sym_simple_expansion] = STATE(452),
    [sym_string_expansion] = STATE(452),
    [sym_expansion] = STATE(452),
    [sym_command_substitution] = STATE(452),
    [sym_process_substitution] = STATE(452),
    [aux_sym_unset_command_repeat1] = STATE(458),
    [anon_sym_PIPE] = ACTIONS(172),
    [anon_sym_RPAREN] = ACTIONS(192),
    [anon_sym_PIPE_AMP] = ACTIONS(192),
    [anon_sym_AMP_AMP] = ACTIONS(192),
    [anon_sym_PIPE_PIPE] = ACTIONS(192),
    [sym__special_characters] = ACTIONS(824),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(840),
    [sym_word] = ACTIONS(842),
  },
  [148] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(210),
    [sym__heredoc_body_beginning] = ACTIONS(210),
    [sym_file_descriptor] = ACTIONS(210),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_RPAREN] = ACTIONS(210),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_EQ_TILDE] = ACTIONS(214),
    [anon_sym_EQ_EQ] = ACTIONS(214),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(214),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(214),
  },
  [149] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(462),
    [anon_sym_DQUOTE] = ACTIONS(846),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [150] = {
    [sym_string] = STATE(464),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [sym_raw_string] = ACTIONS(850),
    [anon_sym_POUND] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(852),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(848),
    [anon_sym_QMARK] = ACTIONS(848),
    [anon_sym_0] = ACTIONS(854),
    [anon_sym__] = ACTIONS(854),
  },
  [151] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(236),
    [anon_sym_LT_LT_LT] = ACTIONS(236),
    [sym__special_characters] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(238),
  },
  [152] = {
    [sym_subscript] = STATE(470),
    [sym_variable_name] = ACTIONS(856),
    [anon_sym_DOLLAR] = ACTIONS(858),
    [anon_sym_POUND] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(858),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(862),
    [anon_sym_STAR] = ACTIONS(858),
    [anon_sym_AT] = ACTIONS(858),
    [anon_sym_QMARK] = ACTIONS(858),
    [anon_sym_0] = ACTIONS(864),
    [anon_sym__] = ACTIONS(864),
  },
  [153] = {
    [sym_for_statement] = STATE(471),
    [sym_while_statement] = STATE(471),
    [sym_if_statement] = STATE(471),
    [sym_case_statement] = STATE(471),
    [sym_function_definition] = STATE(471),
    [sym_subshell] = STATE(471),
    [sym_pipeline] = STATE(471),
    [sym_list] = STATE(471),
    [sym_command] = STATE(471),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(471),
    [sym_variable_assignment] = STATE(472),
    [sym_declaration_command] = STATE(471),
    [sym_unset_command] = STATE(471),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [154] = {
    [sym_for_statement] = STATE(473),
    [sym_while_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_case_statement] = STATE(473),
    [sym_function_definition] = STATE(473),
    [sym_subshell] = STATE(473),
    [sym_pipeline] = STATE(473),
    [sym_list] = STATE(473),
    [sym_command] = STATE(473),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(473),
    [sym_variable_assignment] = STATE(474),
    [sym_declaration_command] = STATE(473),
    [sym_unset_command] = STATE(473),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [155] = {
    [sym_for_statement] = STATE(475),
    [sym_while_statement] = STATE(475),
    [sym_if_statement] = STATE(475),
    [sym_case_statement] = STATE(475),
    [sym_function_definition] = STATE(475),
    [sym_subshell] = STATE(475),
    [sym_pipeline] = STATE(475),
    [sym_list] = STATE(475),
    [sym_command] = STATE(475),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(475),
    [sym_variable_assignment] = STATE(476),
    [sym_declaration_command] = STATE(475),
    [sym_unset_command] = STATE(475),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [156] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_LPAREN] = ACTIONS(866),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(236),
    [anon_sym_LT_LT_LT] = ACTIONS(236),
    [sym__special_characters] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(238),
  },
  [157] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(870),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [158] = {
    [sym_file_redirect] = STATE(492),
    [sym_heredoc_redirect] = STATE(492),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(492),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(489),
    [sym_simple_expansion] = STATE(489),
    [sym_string_expansion] = STATE(489),
    [sym_expansion] = STATE(489),
    [sym_command_substitution] = STATE(489),
    [sym_process_substitution] = STATE(489),
    [aux_sym_while_statement_repeat1] = STATE(492),
    [aux_sym_command_repeat2] = STATE(493),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_RPAREN] = ACTIONS(352),
    [anon_sym_PIPE_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(352),
    [anon_sym_PIPE_PIPE] = ACTIONS(352),
    [anon_sym_EQ_TILDE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym__special_characters] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(898),
  },
  [159] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(870),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [160] = {
    [sym__assignment] = STATE(424),
    [anon_sym_EQ] = ACTIONS(792),
    [anon_sym_PLUS_EQ] = ACTIONS(792),
    [sym_comment] = ACTIONS(54),
  },
  [161] = {
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(236),
    [anon_sym_LT_LT_LT] = ACTIONS(236),
    [sym__special_characters] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(238),
  },
  [162] = {
    [sym_command_name] = STATE(494),
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(278),
  },
  [163] = {
    [sym__assignment] = STATE(424),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(902),
    [anon_sym_PLUS_EQ] = ACTIONS(902),
    [sym_comment] = ACTIONS(54),
  },
  [164] = {
    [sym__terminated_statement] = STATE(496),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [165] = {
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(904),
  },
  [166] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(498),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [sym__special_characters] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [167] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(499),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [sym__special_characters] = ACTIONS(128),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [168] = {
    [sym_variable_assignment] = STATE(504),
    [sym_subscript] = STATE(503),
    [sym_concatenation] = STATE(504),
    [sym_string] = STATE(502),
    [sym_simple_expansion] = STATE(502),
    [sym_string_expansion] = STATE(502),
    [sym_expansion] = STATE(502),
    [sym_command_substitution] = STATE(502),
    [sym_process_substitution] = STATE(502),
    [aux_sym_declaration_command_repeat1] = STATE(504),
    [sym_variable_name] = ACTIONS(906),
    [anon_sym_PIPE] = ACTIONS(148),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(820),
    [sym_word] = ACTIONS(912),
  },
  [169] = {
    [sym_concatenation] = STATE(507),
    [sym_string] = STATE(506),
    [sym_simple_expansion] = STATE(506),
    [sym_string_expansion] = STATE(506),
    [sym_expansion] = STATE(506),
    [sym_command_substitution] = STATE(506),
    [sym_process_substitution] = STATE(506),
    [aux_sym_unset_command_repeat1] = STATE(507),
    [anon_sym_PIPE] = ACTIONS(172),
    [anon_sym_PIPE_AMP] = ACTIONS(192),
    [anon_sym_AMP_AMP] = ACTIONS(192),
    [anon_sym_PIPE_PIPE] = ACTIONS(192),
    [sym__special_characters] = ACTIONS(914),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(192),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(840),
    [sym_word] = ACTIONS(918),
  },
  [170] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(210),
    [sym__heredoc_body_beginning] = ACTIONS(210),
    [sym_file_descriptor] = ACTIONS(210),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_PIPE_AMP] = ACTIONS(210),
    [anon_sym_AMP_AMP] = ACTIONS(210),
    [anon_sym_PIPE_PIPE] = ACTIONS(210),
    [anon_sym_EQ_TILDE] = ACTIONS(214),
    [anon_sym_EQ_EQ] = ACTIONS(214),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(210),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(210),
    [anon_sym_LT_AMP] = ACTIONS(210),
    [anon_sym_GT_AMP] = ACTIONS(210),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_LT_LT_DASH] = ACTIONS(210),
    [anon_sym_LT_LT_LT] = ACTIONS(210),
    [sym__special_characters] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(214),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_LT_LPAREN] = ACTIONS(210),
    [anon_sym_GT_LPAREN] = ACTIONS(210),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(214),
  },
  [171] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(236),
    [anon_sym_LT_LT_LT] = ACTIONS(236),
    [sym__special_characters] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(238),
  },
  [172] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_PIPE_AMP] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(236),
    [anon_sym_LT_LT_LT] = ACTIONS(236),
    [sym__special_characters] = ACTIONS(236),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(236),
    [anon_sym_BQUOTE] = ACTIONS(236),
    [anon_sym_LT_LPAREN] = ACTIONS(236),
    [anon_sym_GT_LPAREN] = ACTIONS(236),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(238),
  },
  [173] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(870),
    [sym_comment] = ACTIONS(54),
  },
  [174] = {
    [sym_file_redirect] = STATE(518),
    [sym_heredoc_redirect] = STATE(518),
    [sym_heredoc_body] = STATE(490),
    [sym_herestring_redirect] = STATE(518),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(517),
    [sym_simple_expansion] = STATE(517),
    [sym_string_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(518),
    [aux_sym_command_repeat2] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_PIPE_AMP] = ACTIONS(352),
    [anon_sym_AMP_AMP] = ACTIONS(352),
    [anon_sym_PIPE_PIPE] = ACTIONS(352),
    [anon_sym_EQ_TILDE] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(352),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(942),
  },
  [175] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(870),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [176] = {
    [sym__assignment] = STATE(424),
    [anon_sym_EQ] = ACTIONS(902),
    [anon_sym_PLUS_EQ] = ACTIONS(902),
    [sym_comment] = ACTIONS(54),
  },
  [177] = {
    [sym_command_name] = STATE(520),
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(306),
  },
  [178] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(946),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [179] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(946),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [180] = {
    [anon_sym_RPAREN] = ACTIONS(948),
    [sym_comment] = ACTIONS(54),
  },
  [181] = {
    [sym_for_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_case_statement] = STATE(523),
    [sym_function_definition] = STATE(523),
    [sym_subshell] = STATE(523),
    [sym_pipeline] = STATE(523),
    [sym_list] = STATE(523),
    [sym_command] = STATE(523),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(523),
    [sym_variable_assignment] = STATE(524),
    [sym_declaration_command] = STATE(523),
    [sym_unset_command] = STATE(523),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [182] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [ts_builtin_sym_end] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [183] = {
    [sym_for_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_case_statement] = STATE(525),
    [sym_function_definition] = STATE(525),
    [sym_subshell] = STATE(525),
    [sym_pipeline] = STATE(525),
    [sym_list] = STATE(525),
    [sym_command] = STATE(525),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(525),
    [sym_variable_assignment] = STATE(526),
    [sym_declaration_command] = STATE(525),
    [sym_unset_command] = STATE(525),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [184] = {
    [anon_sym_esac] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(954),
    [anon_sym_RPAREN] = ACTIONS(954),
    [anon_sym_SEMI_SEMI] = ACTIONS(954),
    [anon_sym_PIPE_AMP] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(954),
    [anon_sym_LF] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(954),
  },
  [185] = {
    [sym_simple_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [aux_sym_heredoc_body_repeat1] = STATE(531),
    [sym__heredoc_body_middle] = ACTIONS(958),
    [sym__heredoc_body_end] = ACTIONS(960),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(964),
    [sym_comment] = ACTIONS(54),
  },
  [186] = {
    [anon_sym_LT] = ACTIONS(966),
    [anon_sym_GT] = ACTIONS(966),
    [anon_sym_GT_GT] = ACTIONS(968),
    [anon_sym_AMP_GT] = ACTIONS(966),
    [anon_sym_AMP_GT_GT] = ACTIONS(968),
    [anon_sym_LT_AMP] = ACTIONS(968),
    [anon_sym_GT_AMP] = ACTIONS(968),
    [sym_comment] = ACTIONS(54),
  },
  [187] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [sym__special_characters] = ACTIONS(970),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(972),
    [sym_regex] = ACTIONS(974),
  },
  [188] = {
    [sym_concatenation] = STATE(538),
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_string_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [sym__special_characters] = ACTIONS(976),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(978),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(978),
  },
  [189] = {
    [sym_heredoc_start] = ACTIONS(980),
    [sym_comment] = ACTIONS(54),
  },
  [190] = {
    [sym_concatenation] = STATE(542),
    [sym_string] = STATE(541),
    [sym_simple_expansion] = STATE(541),
    [sym_string_expansion] = STATE(541),
    [sym_expansion] = STATE(541),
    [sym_command_substitution] = STATE(541),
    [sym_process_substitution] = STATE(541),
    [sym__special_characters] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(984),
  },
  [191] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(508),
    [sym__heredoc_body_beginning] = ACTIONS(508),
    [sym_file_descriptor] = ACTIONS(508),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_SEMI_SEMI] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_LT_LT_LT] = ACTIONS(506),
    [sym__special_characters] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(506),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [anon_sym_LT_LPAREN] = ACTIONS(506),
    [anon_sym_GT_LPAREN] = ACTIONS(506),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(506),
    [anon_sym_SEMI] = ACTIONS(506),
    [anon_sym_LF] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(506),
  },
  [192] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [193] = {
    [anon_sym_esac] = ACTIONS(986),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [194] = {
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [195] = {
    [sym_file_redirect] = STATE(544),
    [sym_heredoc_redirect] = STATE(544),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(544),
    [aux_sym_while_statement_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [196] = {
    [sym_file_redirect] = STATE(545),
    [sym_heredoc_redirect] = STATE(545),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(545),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(192),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [aux_sym_while_statement_repeat1] = STATE(545),
    [aux_sym_command_repeat2] = STATE(546),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(330),
    [anon_sym_EQ_EQ] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(342),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [197] = {
    [sym__terminated_statement] = STATE(197),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(25),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_unset_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(197),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [198] = {
    [sym__assignment] = STATE(424),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [sym_comment] = ACTIONS(54),
  },
  [199] = {
    [sym_file_redirect] = STATE(545),
    [sym_heredoc_redirect] = STATE(545),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(545),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(192),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [aux_sym_while_statement_repeat1] = STATE(545),
    [aux_sym_command_repeat2] = STATE(548),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(330),
    [anon_sym_EQ_EQ] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(342),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [200] = {
    [sym__assignment] = STATE(424),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [sym_comment] = ACTIONS(54),
  },
  [201] = {
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP_GT] = ACTIONS(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_AMP] = ACTIONS(1072),
    [anon_sym_GT_AMP] = ACTIONS(1072),
    [sym__special_characters] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [sym_raw_string] = ACTIONS(1075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1075),
    [anon_sym_BQUOTE] = ACTIONS(1075),
    [anon_sym_LT_LPAREN] = ACTIONS(1075),
    [anon_sym_GT_LPAREN] = ACTIONS(1075),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1075),
  },
  [202] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [sym__special_characters] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [anon_sym_LT_LPAREN] = ACTIONS(1079),
    [anon_sym_GT_LPAREN] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1079),
  },
  [203] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [sym__special_characters] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1083),
    [anon_sym_DOLLAR] = ACTIONS(1085),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [anon_sym_LT_LPAREN] = ACTIONS(1083),
    [anon_sym_GT_LPAREN] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1083),
  },
  [204] = {
    [sym_file_descriptor] = ACTIONS(1083),
    [sym_variable_name] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [sym__special_characters] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1083),
    [anon_sym_DOLLAR] = ACTIONS(1085),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [anon_sym_LT_LPAREN] = ACTIONS(1083),
    [anon_sym_GT_LPAREN] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1083),
  },
  [205] = {
    [aux_sym_concatenation_repeat1] = STATE(551),
    [sym__concat] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [sym_comment] = ACTIONS(54),
  },
  [206] = {
    [aux_sym_concatenation_repeat1] = STATE(551),
    [sym__concat] = ACTIONS(1091),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [sym_comment] = ACTIONS(54),
  },
  [207] = {
    [sym__concat] = ACTIONS(1095),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [sym_comment] = ACTIONS(54),
  },
  [208] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [209] = {
    [sym_concatenation] = STATE(564),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(564),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [210] = {
    [aux_sym_concatenation_repeat1] = STATE(566),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_AMP] = ACTIONS(1123),
    [anon_sym_GT_AMP] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [211] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(568),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [212] = {
    [sym_string] = STATE(570),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_POUND] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_0] = ACTIONS(1133),
    [anon_sym__] = ACTIONS(1133),
  },
  [213] = {
    [aux_sym_concatenation_repeat1] = STATE(566),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [214] = {
    [sym_subscript] = STATE(576),
    [sym_variable_name] = ACTIONS(1135),
    [anon_sym_DOLLAR] = ACTIONS(1137),
    [anon_sym_POUND] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_0] = ACTIONS(1143),
    [anon_sym__] = ACTIONS(1143),
  },
  [215] = {
    [sym_for_statement] = STATE(577),
    [sym_while_statement] = STATE(577),
    [sym_if_statement] = STATE(577),
    [sym_case_statement] = STATE(577),
    [sym_function_definition] = STATE(577),
    [sym_subshell] = STATE(577),
    [sym_pipeline] = STATE(577),
    [sym_list] = STATE(577),
    [sym_command] = STATE(577),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(577),
    [sym_variable_assignment] = STATE(578),
    [sym_declaration_command] = STATE(577),
    [sym_unset_command] = STATE(577),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [216] = {
    [sym_for_statement] = STATE(579),
    [sym_while_statement] = STATE(579),
    [sym_if_statement] = STATE(579),
    [sym_case_statement] = STATE(579),
    [sym_function_definition] = STATE(579),
    [sym_subshell] = STATE(579),
    [sym_pipeline] = STATE(579),
    [sym_list] = STATE(579),
    [sym_command] = STATE(579),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(579),
    [sym_variable_assignment] = STATE(580),
    [sym_declaration_command] = STATE(579),
    [sym_unset_command] = STATE(579),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [217] = {
    [sym_for_statement] = STATE(581),
    [sym_while_statement] = STATE(581),
    [sym_if_statement] = STATE(581),
    [sym_case_statement] = STATE(581),
    [sym_function_definition] = STATE(581),
    [sym_subshell] = STATE(581),
    [sym_pipeline] = STATE(581),
    [sym_list] = STATE(581),
    [sym_command] = STATE(581),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(581),
    [sym_variable_assignment] = STATE(582),
    [sym_declaration_command] = STATE(581),
    [sym_unset_command] = STATE(581),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [218] = {
    [sym_concatenation] = STATE(591),
    [sym_string] = STATE(586),
    [sym_simple_expansion] = STATE(586),
    [sym_string_expansion] = STATE(586),
    [sym_expansion] = STATE(586),
    [sym_command_substitution] = STATE(586),
    [sym_process_substitution] = STATE(586),
    [aux_sym_for_statement_repeat1] = STATE(591),
    [sym__special_characters] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(1149),
    [sym_raw_string] = ACTIONS(1151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1155),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_LT_LPAREN] = ACTIONS(1159),
    [anon_sym_GT_LPAREN] = ACTIONS(1159),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1151),
  },
  [219] = {
    [sym_do_group] = STATE(593),
    [anon_sym_do] = ACTIONS(1161),
    [sym_comment] = ACTIONS(54),
  },
  [220] = {
    [sym__terminated_statement] = STATE(597),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(597),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [221] = {
    [sym_file_redirect] = STATE(599),
    [sym_heredoc_redirect] = STATE(599),
    [sym_heredoc_body] = STATE(598),
    [sym_herestring_redirect] = STATE(599),
    [aux_sym_while_statement_repeat1] = STATE(599),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
  },
  [222] = {
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_then] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
  },
  [223] = {
    [sym__terminated_statement] = STATE(606),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_elif_clause] = STATE(607),
    [sym_else_clause] = STATE(604),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(606),
    [aux_sym_if_statement_repeat1] = STATE(607),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(1169),
    [anon_sym_elif] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [224] = {
    [sym_string] = STATE(608),
    [sym_simple_expansion] = STATE(608),
    [sym_string_expansion] = STATE(608),
    [sym_expansion] = STATE(608),
    [sym_command_substitution] = STATE(608),
    [sym_process_substitution] = STATE(608),
    [sym__special_characters] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(70),
    [anon_sym_DOLLAR] = ACTIONS(72),
    [sym_raw_string] = ACTIONS(1175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(76),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [anon_sym_LT_LPAREN] = ACTIONS(82),
    [anon_sym_GT_LPAREN] = ACTIONS(82),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1175),
  },
  [225] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1177),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1177),
  },
  [226] = {
    [anon_sym_in] = ACTIONS(1181),
    [sym_comment] = ACTIONS(54),
  },
  [227] = {
    [aux_sym_concatenation_repeat1] = STATE(611),
    [sym__concat] = ACTIONS(410),
    [anon_sym_in] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [228] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_in] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [229] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [230] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [231] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [232] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_in] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [233] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1185),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_LF] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1185),
  },
  [234] = {
    [anon_sym_in] = ACTIONS(1189),
    [sym_comment] = ACTIONS(54),
  },
  [235] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1191),
    [sym_comment] = ACTIONS(54),
  },
  [236] = {
    [sym_concatenation] = STATE(618),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(618),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_EQ] = ACTIONS(1195),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1199),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_COLON_QMARK] = ACTIONS(1195),
    [anon_sym_COLON_DASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [237] = {
    [sym_subscript] = STATE(622),
    [sym_variable_name] = ACTIONS(1201),
    [anon_sym_DOLLAR] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AT] = ACTIONS(1203),
    [anon_sym_QMARK] = ACTIONS(1203),
    [anon_sym_0] = ACTIONS(1207),
    [anon_sym__] = ACTIONS(1207),
  },
  [238] = {
    [sym_concatenation] = STATE(625),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(625),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_EQ] = ACTIONS(1211),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1211),
    [anon_sym_COLON_QMARK] = ACTIONS(1211),
    [anon_sym_COLON_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [239] = {
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(628),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_EQ] = ACTIONS(1219),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(1219),
    [anon_sym_COLON_QMARK] = ACTIONS(1219),
    [anon_sym_COLON_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [240] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [241] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [242] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(54),
  },
  [243] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [244] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [245] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [246] = {
    [anon_sym_RPAREN] = ACTIONS(1229),
    [sym_comment] = ACTIONS(54),
  },
  [247] = {
    [sym__terminated_statement] = STATE(635),
    [sym_for_statement] = STATE(633),
    [sym_while_statement] = STATE(633),
    [sym_if_statement] = STATE(633),
    [sym_case_statement] = STATE(633),
    [sym_function_definition] = STATE(633),
    [sym_subshell] = STATE(633),
    [sym_pipeline] = STATE(633),
    [sym_list] = STATE(633),
    [sym_command] = STATE(633),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(633),
    [sym_variable_assignment] = STATE(634),
    [sym_declaration_command] = STATE(633),
    [sym_unset_command] = STATE(633),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(635),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [248] = {
    [sym_file_redirect] = STATE(638),
    [sym_file_descriptor] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_SEMI_SEMI] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LF] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [249] = {
    [sym_concatenation] = STATE(208),
    [sym_string] = STATE(640),
    [sym_array] = STATE(208),
    [sym_simple_expansion] = STATE(640),
    [sym_string_expansion] = STATE(640),
    [sym_expansion] = STATE(640),
    [sym_command_substitution] = STATE(640),
    [sym_process_substitution] = STATE(640),
    [sym__empty_value] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(374),
    [sym__special_characters] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(1243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(388),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1243),
  },
  [250] = {
    [sym_do_group] = STATE(641),
    [anon_sym_do] = ACTIONS(402),
    [sym_comment] = ACTIONS(54),
  },
  [251] = {
    [sym_compound_statement] = STATE(643),
    [anon_sym_LPAREN] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [252] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [anon_sym_RBRACK] = ACTIONS(1247),
    [sym__special_characters] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [253] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1247),
    [sym__special_characters] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [254] = {
    [sym__assignment] = STATE(326),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_PLUS_EQ] = ACTIONS(1249),
    [sym_comment] = ACTIONS(54),
  },
  [255] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_RPAREN] = ACTIONS(584),
    [anon_sym_SEMI_SEMI] = ACTIONS(584),
    [anon_sym_PIPE_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(584),
    [anon_sym_PIPE_PIPE] = ACTIONS(584),
    [sym__special_characters] = ACTIONS(584),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [anon_sym_DOLLAR] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(584),
    [anon_sym_BQUOTE] = ACTIONS(584),
    [anon_sym_LT_LPAREN] = ACTIONS(584),
    [anon_sym_GT_LPAREN] = ACTIONS(584),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(584),
    [sym_word] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(584),
  },
  [256] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(600),
    [anon_sym_SEMI_SEMI] = ACTIONS(600),
    [anon_sym_PIPE_AMP] = ACTIONS(600),
    [anon_sym_AMP_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(600),
    [sym__special_characters] = ACTIONS(600),
    [anon_sym_DQUOTE] = ACTIONS(600),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [sym_raw_string] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(600),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [anon_sym_LT_LPAREN] = ACTIONS(600),
    [anon_sym_GT_LPAREN] = ACTIONS(600),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(600),
    [sym_word] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(600),
    [anon_sym_LF] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
  },
  [257] = {
    [sym__assignment] = STATE(326),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_PLUS_EQ] = ACTIONS(1249),
    [sym_comment] = ACTIONS(54),
  },
  [258] = {
    [sym_variable_assignment] = STATE(647),
    [sym_subscript] = STATE(257),
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(256),
    [sym_simple_expansion] = STATE(256),
    [sym_string_expansion] = STATE(256),
    [sym_expansion] = STATE(256),
    [sym_command_substitution] = STATE(256),
    [sym_process_substitution] = STATE(256),
    [aux_sym_declaration_command_repeat1] = STATE(647),
    [sym_variable_name] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(616),
    [anon_sym_RPAREN] = ACTIONS(616),
    [anon_sym_SEMI_SEMI] = ACTIONS(616),
    [anon_sym_PIPE_AMP] = ACTIONS(616),
    [anon_sym_AMP_AMP] = ACTIONS(616),
    [anon_sym_PIPE_PIPE] = ACTIONS(616),
    [sym__special_characters] = ACTIONS(454),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(160),
    [anon_sym_BQUOTE] = ACTIONS(162),
    [anon_sym_LT_LPAREN] = ACTIONS(164),
    [anon_sym_GT_LPAREN] = ACTIONS(164),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(168),
    [sym_word] = ACTIONS(456),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_LF] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(616),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(648),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_SEMI_SEMI] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [sym__special_characters] = ACTIONS(622),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [anon_sym_DOLLAR] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [anon_sym_LT_LPAREN] = ACTIONS(622),
    [anon_sym_GT_LPAREN] = ACTIONS(622),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(622),
    [sym_word] = ACTIONS(622),
    [anon_sym_SEMI] = ACTIONS(622),
    [anon_sym_LF] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(622),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(648),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_SEMI_SEMI] = ACTIONS(638),
    [anon_sym_PIPE_AMP] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(638),
    [anon_sym_PIPE_PIPE] = ACTIONS(638),
    [sym__special_characters] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(638),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [sym_raw_string] = ACTIONS(638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(638),
    [anon_sym_BQUOTE] = ACTIONS(638),
    [anon_sym_LT_LPAREN] = ACTIONS(638),
    [anon_sym_GT_LPAREN] = ACTIONS(638),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [sym_word] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_AMP] = ACTIONS(638),
  },
  [261] = {
    [sym_concatenation] = STATE(649),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_unset_command_repeat1] = STATE(649),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_RPAREN] = ACTIONS(656),
    [anon_sym_SEMI_SEMI] = ACTIONS(656),
    [anon_sym_PIPE_AMP] = ACTIONS(656),
    [anon_sym_AMP_AMP] = ACTIONS(656),
    [anon_sym_PIPE_PIPE] = ACTIONS(656),
    [sym__special_characters] = ACTIONS(458),
    [anon_sym_DQUOTE] = ACTIONS(176),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(184),
    [anon_sym_BQUOTE] = ACTIONS(186),
    [anon_sym_LT_LPAREN] = ACTIONS(188),
    [anon_sym_GT_LPAREN] = ACTIONS(188),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(190),
    [sym_word] = ACTIONS(460),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_LF] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(656),
  },
  [262] = {
    [aux_sym_concatenation_repeat1] = STATE(650),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [263] = {
    [anon_sym_RPAREN] = ACTIONS(1251),
    [sym_comment] = ACTIONS(54),
  },
  [264] = {
    [sym_for_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_case_statement] = STATE(523),
    [sym_function_definition] = STATE(523),
    [sym_subshell] = STATE(523),
    [sym_pipeline] = STATE(523),
    [sym_list] = STATE(523),
    [sym_command] = STATE(523),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(523),
    [sym_variable_assignment] = STATE(524),
    [sym_declaration_command] = STATE(523),
    [sym_unset_command] = STATE(523),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [265] = {
    [anon_sym_esac] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1253),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1253),
  },
  [266] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [267] = {
    [sym_for_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_case_statement] = STATE(653),
    [sym_function_definition] = STATE(653),
    [sym_subshell] = STATE(653),
    [sym_pipeline] = STATE(653),
    [sym_list] = STATE(653),
    [sym_command] = STATE(653),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(653),
    [sym_variable_assignment] = STATE(654),
    [sym_declaration_command] = STATE(653),
    [sym_unset_command] = STATE(653),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [268] = {
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [sym_comment] = ACTIONS(54),
  },
  [269] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(657),
    [sym_simple_expansion] = STATE(657),
    [sym_string_expansion] = STATE(657),
    [sym_expansion] = STATE(657),
    [sym_command_substitution] = STATE(657),
    [sym_process_substitution] = STATE(657),
    [sym__special_characters] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(1265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1265),
    [sym_regex] = ACTIONS(974),
  },
  [270] = {
    [sym_concatenation] = STATE(538),
    [sym_string] = STATE(659),
    [sym_simple_expansion] = STATE(659),
    [sym_string_expansion] = STATE(659),
    [sym_expansion] = STATE(659),
    [sym_command_substitution] = STATE(659),
    [sym_process_substitution] = STATE(659),
    [sym__special_characters] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1269),
  },
  [271] = {
    [sym_concatenation] = STATE(542),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [sym__special_characters] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(1273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1273),
  },
  [272] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(508),
    [sym__heredoc_body_beginning] = ACTIONS(508),
    [sym_file_descriptor] = ACTIONS(508),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_SEMI_SEMI] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_LT_LT_LT] = ACTIONS(506),
    [sym__special_characters] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(506),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [anon_sym_LT_LPAREN] = ACTIONS(506),
    [anon_sym_GT_LPAREN] = ACTIONS(506),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(506),
    [anon_sym_SEMI] = ACTIONS(506),
    [anon_sym_LF] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(506),
  },
  [273] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [274] = {
    [sym_file_redirect] = STATE(662),
    [sym_heredoc_redirect] = STATE(662),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(662),
    [aux_sym_while_statement_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [275] = {
    [sym_file_redirect] = STATE(663),
    [sym_heredoc_redirect] = STATE(663),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(663),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(273),
    [sym_simple_expansion] = STATE(273),
    [sym_string_expansion] = STATE(273),
    [sym_expansion] = STATE(273),
    [sym_command_substitution] = STATE(273),
    [sym_process_substitution] = STATE(273),
    [aux_sym_while_statement_repeat1] = STATE(663),
    [aux_sym_command_repeat2] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(482),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(484),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [276] = {
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_LF] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1277),
  },
  [277] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_LF] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1277),
  },
  [278] = {
    [sym__terminated_statement] = STATE(278),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(25),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_unset_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(278),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [279] = {
    [sym_file_redirect] = STATE(663),
    [sym_heredoc_redirect] = STATE(663),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(663),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(273),
    [sym_simple_expansion] = STATE(273),
    [sym_string_expansion] = STATE(273),
    [sym_expansion] = STATE(273),
    [sym_command_substitution] = STATE(273),
    [sym_process_substitution] = STATE(273),
    [aux_sym_while_statement_repeat1] = STATE(663),
    [aux_sym_command_repeat2] = STATE(666),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(482),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(484),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [280] = {
    [aux_sym_concatenation_repeat1] = STATE(284),
    [sym__concat] = ACTIONS(504),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [anon_sym_LT_LPAREN] = ACTIONS(1283),
    [anon_sym_GT_LPAREN] = ACTIONS(1283),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1281),
  },
  [281] = {
    [aux_sym_concatenation_repeat1] = STATE(284),
    [sym__concat] = ACTIONS(504),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [282] = {
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [283] = {
    [sym_string] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [sym_process_substitution] = STATE(667),
    [sym__special_characters] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1289),
  },
  [284] = {
    [aux_sym_concatenation_repeat1] = STATE(668),
    [sym__concat] = ACTIONS(504),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_RBRACK] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(694),
  },
  [285] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_EQ_TILDE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_RBRACK] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(698),
  },
  [286] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [287] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_EQ_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RBRACK] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(728),
  },
  [288] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_EQ_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(732),
  },
  [289] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_EQ_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(736),
  },
  [290] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1293),
    [sym_comment] = ACTIONS(54),
  },
  [291] = {
    [sym_concatenation] = STATE(673),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(673),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_EQ] = ACTIONS(1297),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1301),
    [anon_sym_COLON] = ACTIONS(1297),
    [anon_sym_COLON_QMARK] = ACTIONS(1297),
    [anon_sym_COLON_DASH] = ACTIONS(1297),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [292] = {
    [sym_subscript] = STATE(677),
    [sym_variable_name] = ACTIONS(1303),
    [anon_sym_DOLLAR] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1305),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1305),
    [anon_sym_AT] = ACTIONS(1305),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_0] = ACTIONS(1309),
    [anon_sym__] = ACTIONS(1309),
  },
  [293] = {
    [sym_concatenation] = STATE(680),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(680),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_EQ] = ACTIONS(1313),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1317),
    [anon_sym_COLON] = ACTIONS(1313),
    [anon_sym_COLON_QMARK] = ACTIONS(1313),
    [anon_sym_COLON_DASH] = ACTIONS(1313),
    [anon_sym_PERCENT] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [294] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(683),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1321),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1325),
    [anon_sym_COLON] = ACTIONS(1321),
    [anon_sym_COLON_QMARK] = ACTIONS(1321),
    [anon_sym_COLON_DASH] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [295] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1327),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [296] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1327),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [297] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(54),
  },
  [298] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1327),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [299] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1329),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [300] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1329),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [301] = {
    [sym_file_redirect] = STATE(690),
    [sym_heredoc_redirect] = STATE(690),
    [sym_herestring_redirect] = STATE(690),
    [aux_sym_while_statement_repeat1] = STATE(690),
    [sym_file_descriptor] = ACTIONS(1331),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_SEMI_SEMI] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(1339),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_LF] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1333),
  },
  [302] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1343),
    [anon_sym_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1361),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_LT_LPAREN] = ACTIONS(1367),
    [anon_sym_GT_LPAREN] = ACTIONS(1367),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1370),
  },
  [303] = {
    [aux_sym_concatenation_repeat1] = STATE(307),
    [sym__concat] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1283),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [anon_sym_LT_LPAREN] = ACTIONS(1283),
    [anon_sym_GT_LPAREN] = ACTIONS(1283),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1281),
  },
  [304] = {
    [aux_sym_concatenation_repeat1] = STATE(307),
    [sym__concat] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [305] = {
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [306] = {
    [sym_string] = STATE(691),
    [sym_simple_expansion] = STATE(691),
    [sym_string_expansion] = STATE(691),
    [sym_expansion] = STATE(691),
    [sym_command_substitution] = STATE(691),
    [sym_process_substitution] = STATE(691),
    [sym__special_characters] = ACTIONS(1373),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1373),
  },
  [307] = {
    [aux_sym_concatenation_repeat1] = STATE(692),
    [sym__concat] = ACTIONS(554),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(694),
  },
  [308] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(696),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_EQ_TILDE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(698),
  },
  [309] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [310] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_EQ_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(728),
  },
  [311] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_EQ_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(732),
  },
  [312] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_EQ_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(736),
  },
  [313] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1377),
    [sym_comment] = ACTIONS(54),
  },
  [314] = {
    [sym_concatenation] = STATE(697),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(697),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(1381),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1381),
    [anon_sym_COLON_QMARK] = ACTIONS(1381),
    [anon_sym_COLON_DASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [315] = {
    [sym_subscript] = STATE(701),
    [sym_variable_name] = ACTIONS(1387),
    [anon_sym_DOLLAR] = ACTIONS(1389),
    [anon_sym_DASH] = ACTIONS(1389),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(1389),
    [anon_sym_AT] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1389),
    [anon_sym_0] = ACTIONS(1393),
    [anon_sym__] = ACTIONS(1393),
  },
  [316] = {
    [sym_concatenation] = STATE(704),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(704),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [anon_sym_EQ] = ACTIONS(1397),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1401),
    [anon_sym_COLON] = ACTIONS(1397),
    [anon_sym_COLON_QMARK] = ACTIONS(1397),
    [anon_sym_COLON_DASH] = ACTIONS(1397),
    [anon_sym_PERCENT] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [317] = {
    [sym_concatenation] = STATE(707),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(707),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_EQ] = ACTIONS(1405),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1405),
    [anon_sym_COLON_QMARK] = ACTIONS(1405),
    [anon_sym_COLON_DASH] = ACTIONS(1405),
    [anon_sym_PERCENT] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [318] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [319] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1411),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [320] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [sym_comment] = ACTIONS(54),
  },
  [321] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1411),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [322] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [323] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [324] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1433),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1439),
    [anon_sym_GT_LPAREN] = ACTIONS(1439),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1442),
  },
  [325] = {
    [sym_concatenation] = STATE(710),
    [sym_string] = STATE(713),
    [sym_array] = STATE(710),
    [sym_simple_expansion] = STATE(713),
    [sym_string_expansion] = STATE(713),
    [sym_expansion] = STATE(713),
    [sym_command_substitution] = STATE(713),
    [sym_process_substitution] = STATE(713),
    [sym__empty_value] = ACTIONS(1445),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [sym__special_characters] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(1451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1455),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1451),
  },
  [326] = {
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_SEMI_SEMI] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LF] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
  },
  [327] = {
    [sym_string] = STATE(714),
    [sym_simple_expansion] = STATE(714),
    [sym_string_expansion] = STATE(714),
    [sym_expansion] = STATE(714),
    [sym_command_substitution] = STATE(714),
    [sym_process_substitution] = STATE(714),
    [sym__special_characters] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1455),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1461),
  },
  [328] = {
    [aux_sym_concatenation_repeat1] = STATE(715),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [329] = {
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [330] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [331] = {
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [332] = {
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [333] = {
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [334] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1465),
    [sym_comment] = ACTIONS(54),
  },
  [335] = {
    [sym_concatenation] = STATE(720),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(720),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_EQ] = ACTIONS(1469),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1473),
    [anon_sym_COLON] = ACTIONS(1469),
    [anon_sym_COLON_QMARK] = ACTIONS(1469),
    [anon_sym_COLON_DASH] = ACTIONS(1469),
    [anon_sym_PERCENT] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [336] = {
    [sym_subscript] = STATE(724),
    [sym_variable_name] = ACTIONS(1475),
    [anon_sym_DOLLAR] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1477),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_0] = ACTIONS(1481),
    [anon_sym__] = ACTIONS(1481),
  },
  [337] = {
    [sym_concatenation] = STATE(727),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(727),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1485),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1489),
    [anon_sym_COLON] = ACTIONS(1485),
    [anon_sym_COLON_QMARK] = ACTIONS(1485),
    [anon_sym_COLON_DASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1485),
    [anon_sym_DASH] = ACTIONS(1485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [338] = {
    [sym_concatenation] = STATE(730),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(730),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_EQ] = ACTIONS(1493),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1497),
    [anon_sym_COLON] = ACTIONS(1493),
    [anon_sym_COLON_QMARK] = ACTIONS(1493),
    [anon_sym_COLON_DASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1493),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [339] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [340] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [341] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1499),
    [sym_comment] = ACTIONS(54),
  },
  [342] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1499),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [343] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1501),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [344] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1501),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [345] = {
    [sym_variable_assignment] = STATE(345),
    [sym_subscript] = STATE(99),
    [sym_concatenation] = STATE(345),
    [sym_string] = STATE(93),
    [sym_simple_expansion] = STATE(93),
    [sym_string_expansion] = STATE(93),
    [sym_expansion] = STATE(93),
    [sym_command_substitution] = STATE(93),
    [sym_process_substitution] = STATE(93),
    [aux_sym_declaration_command_repeat1] = STATE(345),
    [sym_variable_name] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_SEMI_SEMI] = ACTIONS(1506),
    [anon_sym_PIPE_AMP] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [sym__special_characters] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_raw_string] = ACTIONS(1517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [anon_sym_LT_LPAREN] = ACTIONS(1529),
    [anon_sym_GT_LPAREN] = ACTIONS(1529),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1532),
    [sym_word] = ACTIONS(1517),
    [anon_sym_SEMI] = ACTIONS(1506),
    [anon_sym_LF] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1506),
  },
  [346] = {
    [sym_string] = STATE(733),
    [sym_simple_expansion] = STATE(733),
    [sym_string_expansion] = STATE(733),
    [sym_expansion] = STATE(733),
    [sym_command_substitution] = STATE(733),
    [sym_process_substitution] = STATE(733),
    [sym__special_characters] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(1537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(1545),
    [anon_sym_GT_LPAREN] = ACTIONS(1545),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1537),
  },
  [347] = {
    [aux_sym_concatenation_repeat1] = STATE(734),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [348] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [349] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [350] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [351] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [352] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [353] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1549),
    [sym_comment] = ACTIONS(54),
  },
  [354] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(739),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1553),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1557),
    [anon_sym_COLON] = ACTIONS(1553),
    [anon_sym_COLON_QMARK] = ACTIONS(1553),
    [anon_sym_COLON_DASH] = ACTIONS(1553),
    [anon_sym_PERCENT] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [355] = {
    [sym_subscript] = STATE(743),
    [sym_variable_name] = ACTIONS(1559),
    [anon_sym_DOLLAR] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_QMARK] = ACTIONS(1561),
    [anon_sym_0] = ACTIONS(1565),
    [anon_sym__] = ACTIONS(1565),
  },
  [356] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(746),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_EQ] = ACTIONS(1569),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1573),
    [anon_sym_COLON] = ACTIONS(1569),
    [anon_sym_COLON_QMARK] = ACTIONS(1569),
    [anon_sym_COLON_DASH] = ACTIONS(1569),
    [anon_sym_PERCENT] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [357] = {
    [sym_concatenation] = STATE(749),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(749),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_EQ] = ACTIONS(1577),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1581),
    [anon_sym_COLON] = ACTIONS(1577),
    [anon_sym_COLON_QMARK] = ACTIONS(1577),
    [anon_sym_COLON_DASH] = ACTIONS(1577),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [358] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [359] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [360] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(54),
  },
  [361] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1583),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [362] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1585),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [363] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1585),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [364] = {
    [sym_concatenation] = STATE(364),
    [sym_string] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_unset_command_repeat1] = STATE(364),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_SEMI_SEMI] = ACTIONS(1587),
    [anon_sym_PIPE_AMP] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [sym__special_characters] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1592),
    [anon_sym_DOLLAR] = ACTIONS(1595),
    [sym_raw_string] = ACTIONS(1598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [anon_sym_LT_LPAREN] = ACTIONS(1610),
    [anon_sym_GT_LPAREN] = ACTIONS(1610),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1613),
    [sym_word] = ACTIONS(1598),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_LF] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1587),
  },
  [365] = {
    [sym_string] = STATE(752),
    [sym_simple_expansion] = STATE(752),
    [sym_string_expansion] = STATE(752),
    [sym_expansion] = STATE(752),
    [sym_command_substitution] = STATE(752),
    [sym_process_substitution] = STATE(752),
    [sym__special_characters] = ACTIONS(1618),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(1618),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1618),
  },
  [366] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(692),
  },
  [367] = {
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_PIPE_AMP] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(696),
    [anon_sym_LT_AMP] = ACTIONS(696),
    [anon_sym_GT_AMP] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(696),
  },
  [368] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [369] = {
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_PIPE_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(726),
    [anon_sym_LT_AMP] = ACTIONS(726),
    [anon_sym_GT_AMP] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(726),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_PIPE_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(730),
    [anon_sym_LT_AMP] = ACTIONS(730),
    [anon_sym_GT_AMP] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(730),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(730),
  },
  [371] = {
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_PIPE_AMP] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(734),
    [anon_sym_LT_AMP] = ACTIONS(734),
    [anon_sym_GT_AMP] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(734),
  },
  [372] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1622),
    [sym_comment] = ACTIONS(54),
  },
  [373] = {
    [sym_concatenation] = STATE(758),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(758),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_EQ] = ACTIONS(1626),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1630),
    [anon_sym_COLON] = ACTIONS(1626),
    [anon_sym_COLON_QMARK] = ACTIONS(1626),
    [anon_sym_COLON_DASH] = ACTIONS(1626),
    [anon_sym_PERCENT] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [374] = {
    [sym_subscript] = STATE(762),
    [sym_variable_name] = ACTIONS(1632),
    [anon_sym_DOLLAR] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1634),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1634),
    [anon_sym_AT] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(1634),
    [anon_sym_0] = ACTIONS(1638),
    [anon_sym__] = ACTIONS(1638),
  },
  [375] = {
    [sym_concatenation] = STATE(765),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(765),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1646),
    [anon_sym_COLON] = ACTIONS(1642),
    [anon_sym_COLON_QMARK] = ACTIONS(1642),
    [anon_sym_COLON_DASH] = ACTIONS(1642),
    [anon_sym_PERCENT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [376] = {
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(768),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_EQ] = ACTIONS(1650),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1654),
    [anon_sym_COLON] = ACTIONS(1650),
    [anon_sym_COLON_QMARK] = ACTIONS(1650),
    [anon_sym_COLON_DASH] = ACTIONS(1650),
    [anon_sym_PERCENT] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [377] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [379] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(54),
  },
  [380] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [381] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1658),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [382] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1658),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [383] = {
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [384] = {
    [aux_sym_concatenation_repeat1] = STATE(384),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [385] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym__string_content] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
  },
  [386] = {
    [sym__concat] = ACTIONS(1667),
    [anon_sym_DQUOTE] = ACTIONS(1669),
    [anon_sym_DOLLAR] = ACTIONS(1669),
    [sym__string_content] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1669),
    [anon_sym_BQUOTE] = ACTIONS(1669),
    [sym_comment] = ACTIONS(166),
  },
  [387] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym__string_content] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
  },
  [388] = {
    [anon_sym_DQUOTE] = ACTIONS(1669),
    [anon_sym_DOLLAR] = ACTIONS(1669),
    [sym__string_content] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1669),
    [anon_sym_BQUOTE] = ACTIONS(1669),
    [sym_comment] = ACTIONS(166),
  },
  [389] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1673),
    [sym_comment] = ACTIONS(54),
  },
  [390] = {
    [sym_concatenation] = STATE(775),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(775),
    [anon_sym_RBRACE] = ACTIONS(1675),
    [anon_sym_EQ] = ACTIONS(1677),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1681),
    [anon_sym_COLON] = ACTIONS(1677),
    [anon_sym_COLON_QMARK] = ACTIONS(1677),
    [anon_sym_COLON_DASH] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [391] = {
    [sym_subscript] = STATE(779),
    [sym_variable_name] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1685),
    [anon_sym_DASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_AT] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1685),
    [anon_sym_0] = ACTIONS(1689),
    [anon_sym__] = ACTIONS(1689),
  },
  [392] = {
    [sym_concatenation] = STATE(782),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(782),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1697),
    [anon_sym_COLON] = ACTIONS(1693),
    [anon_sym_COLON_QMARK] = ACTIONS(1693),
    [anon_sym_COLON_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [393] = {
    [sym_concatenation] = STATE(785),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(785),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1701),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1705),
    [anon_sym_COLON] = ACTIONS(1701),
    [anon_sym_COLON_QMARK] = ACTIONS(1701),
    [anon_sym_COLON_DASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [394] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [395] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [396] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1707),
    [sym_comment] = ACTIONS(54),
  },
  [397] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1707),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [398] = {
    [sym__simple_heredoc_body] = ACTIONS(1709),
    [sym__heredoc_body_beginning] = ACTIONS(1709),
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_TILDE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1711),
    [anon_sym_LT_LT_LT] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [399] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1669),
    [anon_sym_DOLLAR] = ACTIONS(1713),
    [sym__string_content] = ACTIONS(1716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1725),
    [sym_comment] = ACTIONS(166),
  },
  [400] = {
    [sym_concatenation] = STATE(789),
    [sym_string] = STATE(788),
    [sym_simple_expansion] = STATE(788),
    [sym_string_expansion] = STATE(788),
    [sym_expansion] = STATE(788),
    [sym_command_substitution] = STATE(788),
    [sym_process_substitution] = STATE(788),
    [sym__special_characters] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1730),
  },
  [401] = {
    [sym_concatenation] = STATE(799),
    [sym_string] = STATE(794),
    [sym_simple_expansion] = STATE(794),
    [sym_string_expansion] = STATE(794),
    [sym_expansion] = STATE(794),
    [sym_command_substitution] = STATE(794),
    [sym_process_substitution] = STATE(794),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [sym__special_characters] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(1740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1740),
  },
  [402] = {
    [sym__simple_heredoc_body] = ACTIONS(1750),
    [sym__heredoc_body_beginning] = ACTIONS(1750),
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_EQ_TILDE] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1752),
    [anon_sym_LT_LT_LT] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [403] = {
    [aux_sym_concatenation_repeat1] = STATE(801),
    [sym__concat] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_EQ] = ACTIONS(1758),
    [sym__special_characters] = ACTIONS(1758),
    [anon_sym_DQUOTE] = ACTIONS(1756),
    [anon_sym_DOLLAR] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1756),
    [anon_sym_POUND] = ACTIONS(1756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1756),
    [anon_sym_COLON] = ACTIONS(1758),
    [anon_sym_COLON_QMARK] = ACTIONS(1758),
    [anon_sym_COLON_DASH] = ACTIONS(1758),
    [anon_sym_PERCENT] = ACTIONS(1758),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1756),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [anon_sym_LT_LPAREN] = ACTIONS(1756),
    [anon_sym_GT_LPAREN] = ACTIONS(1756),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1758),
  },
  [404] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(803),
    [anon_sym_DQUOTE] = ACTIONS(1760),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [405] = {
    [sym_string] = STATE(805),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_DASH] = ACTIONS(1762),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_0] = ACTIONS(1768),
    [anon_sym__] = ACTIONS(1768),
  },
  [406] = {
    [aux_sym_concatenation_repeat1] = STATE(801),
    [sym__concat] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_EQ] = ACTIONS(1772),
    [sym__special_characters] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1770),
    [anon_sym_DOLLAR] = ACTIONS(1772),
    [sym_raw_string] = ACTIONS(1770),
    [anon_sym_POUND] = ACTIONS(1770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1770),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_COLON_QMARK] = ACTIONS(1772),
    [anon_sym_COLON_DASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1770),
    [anon_sym_BQUOTE] = ACTIONS(1770),
    [anon_sym_LT_LPAREN] = ACTIONS(1770),
    [anon_sym_GT_LPAREN] = ACTIONS(1770),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1772),
  },
  [407] = {
    [sym_subscript] = STATE(811),
    [sym_variable_name] = ACTIONS(1774),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_POUND] = ACTIONS(1778),
    [anon_sym_DASH] = ACTIONS(1776),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1780),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(1776),
    [anon_sym_QMARK] = ACTIONS(1776),
    [anon_sym_0] = ACTIONS(1782),
    [anon_sym__] = ACTIONS(1782),
  },
  [408] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(1784),
  },
  [409] = {
    [sym_for_statement] = STATE(813),
    [sym_while_statement] = STATE(813),
    [sym_if_statement] = STATE(813),
    [sym_case_statement] = STATE(813),
    [sym_function_definition] = STATE(813),
    [sym_subshell] = STATE(813),
    [sym_pipeline] = STATE(813),
    [sym_list] = STATE(813),
    [sym_command] = STATE(813),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(813),
    [sym_variable_assignment] = STATE(814),
    [sym_declaration_command] = STATE(813),
    [sym_unset_command] = STATE(813),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [410] = {
    [sym_for_statement] = STATE(815),
    [sym_while_statement] = STATE(815),
    [sym_if_statement] = STATE(815),
    [sym_case_statement] = STATE(815),
    [sym_function_definition] = STATE(815),
    [sym_subshell] = STATE(815),
    [sym_pipeline] = STATE(815),
    [sym_list] = STATE(815),
    [sym_command] = STATE(815),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(815),
    [sym_variable_assignment] = STATE(816),
    [sym_declaration_command] = STATE(815),
    [sym_unset_command] = STATE(815),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [411] = {
    [sym_for_statement] = STATE(817),
    [sym_while_statement] = STATE(817),
    [sym_if_statement] = STATE(817),
    [sym_case_statement] = STATE(817),
    [sym_function_definition] = STATE(817),
    [sym_subshell] = STATE(817),
    [sym_pipeline] = STATE(817),
    [sym_list] = STATE(817),
    [sym_command] = STATE(817),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(817),
    [sym_variable_assignment] = STATE(818),
    [sym_declaration_command] = STATE(817),
    [sym_unset_command] = STATE(817),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [412] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [413] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1792),
    [sym_comment] = ACTIONS(54),
  },
  [414] = {
    [sym_concatenation] = STATE(824),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(824),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(1796),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1800),
    [anon_sym_COLON] = ACTIONS(1796),
    [anon_sym_COLON_QMARK] = ACTIONS(1796),
    [anon_sym_COLON_DASH] = ACTIONS(1796),
    [anon_sym_PERCENT] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [415] = {
    [sym_concatenation] = STATE(827),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(827),
    [anon_sym_RBRACE] = ACTIONS(1802),
    [anon_sym_EQ] = ACTIONS(1804),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1808),
    [anon_sym_COLON] = ACTIONS(1804),
    [anon_sym_COLON_QMARK] = ACTIONS(1804),
    [anon_sym_COLON_DASH] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [416] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(829),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1814),
    [anon_sym_COLON] = ACTIONS(1810),
    [anon_sym_COLON_QMARK] = ACTIONS(1810),
    [anon_sym_COLON_DASH] = ACTIONS(1810),
    [anon_sym_PERCENT] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [417] = {
    [sym__simple_heredoc_body] = ACTIONS(1816),
    [sym__heredoc_body_beginning] = ACTIONS(1816),
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [418] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(1820),
  },
  [419] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [420] = {
    [sym__simple_heredoc_body] = ACTIONS(1824),
    [sym__heredoc_body_beginning] = ACTIONS(1824),
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_EQ_TILDE] = ACTIONS(1826),
    [anon_sym_EQ_EQ] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1826),
    [anon_sym_LT_LT_LT] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [421] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(1828),
  },
  [422] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [423] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(836),
    [sym_array] = STATE(833),
    [sym_simple_expansion] = STATE(836),
    [sym_string_expansion] = STATE(836),
    [sym_expansion] = STATE(836),
    [sym_command_substitution] = STATE(836),
    [sym_process_substitution] = STATE(836),
    [sym__empty_value] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(1836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1836),
  },
  [424] = {
    [sym_file_descriptor] = ACTIONS(392),
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(392),
    [anon_sym_PIPE_AMP] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(392),
    [anon_sym_PIPE_PIPE] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(394),
    [anon_sym_GT_GT] = ACTIONS(392),
    [anon_sym_AMP_GT] = ACTIONS(394),
    [anon_sym_AMP_GT_GT] = ACTIONS(392),
    [anon_sym_LT_AMP] = ACTIONS(392),
    [anon_sym_GT_AMP] = ACTIONS(392),
    [sym__special_characters] = ACTIONS(392),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(392),
    [anon_sym_LT_LPAREN] = ACTIONS(392),
    [anon_sym_GT_LPAREN] = ACTIONS(392),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(392),
  },
  [425] = {
    [anon_sym_in] = ACTIONS(1838),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_LF] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1840),
  },
  [426] = {
    [sym_do_group] = STATE(840),
    [anon_sym_do] = ACTIONS(1844),
    [sym_comment] = ACTIONS(54),
  },
  [427] = {
    [anon_sym_then] = ACTIONS(1846),
    [sym_comment] = ACTIONS(54),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(227),
    [sym__concat] = ACTIONS(410),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1850),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_LF] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1850),
  },
  [429] = {
    [aux_sym_concatenation_repeat1] = STATE(227),
    [sym__concat] = ACTIONS(410),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_SEMI_SEMI] = ACTIONS(1856),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LF] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1856),
  },
  [430] = {
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_SEMI_SEMI] = ACTIONS(1856),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LF] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1856),
  },
  [431] = {
    [sym_compound_statement] = STATE(848),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [432] = {
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(1864),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_LF] = ACTIONS(1868),
    [anon_sym_AMP] = ACTIONS(1866),
  },
  [433] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(1864),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_LF] = ACTIONS(1868),
    [anon_sym_AMP] = ACTIONS(1866),
  },
  [434] = {
    [sym__terminated_statement] = STATE(278),
    [sym_for_statement] = STATE(851),
    [sym_while_statement] = STATE(851),
    [sym_if_statement] = STATE(851),
    [sym_case_statement] = STATE(851),
    [sym_function_definition] = STATE(851),
    [sym_subshell] = STATE(851),
    [sym_pipeline] = STATE(851),
    [sym_list] = STATE(851),
    [sym_command] = STATE(851),
    [sym_command_name] = STATE(62),
    [sym_bracket_command] = STATE(851),
    [sym_variable_assignment] = STATE(852),
    [sym_declaration_command] = STATE(851),
    [sym_unset_command] = STATE(851),
    [sym_subscript] = STATE(64),
    [sym_file_redirect] = STATE(66),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_program_repeat1] = STATE(278),
    [aux_sym_command_repeat1] = STATE(66),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(86),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(88),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(90),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(92),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(94),
    [anon_sym_declare] = ACTIONS(96),
    [anon_sym_typeset] = ACTIONS(96),
    [anon_sym_export] = ACTIONS(96),
    [anon_sym_readonly] = ACTIONS(96),
    [anon_sym_local] = ACTIONS(96),
    [anon_sym_unset] = ACTIONS(98),
    [anon_sym_unsetenv] = ACTIONS(98),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(100),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(104),
  },
  [435] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [anon_sym_RBRACK] = ACTIONS(1870),
    [sym__special_characters] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [436] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1870),
    [sym__special_characters] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [437] = {
    [sym__assignment] = STATE(855),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_PLUS_EQ] = ACTIONS(1872),
    [sym_comment] = ACTIONS(54),
  },
  [438] = {
    [aux_sym_concatenation_repeat1] = STATE(857),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(584),
    [sym_word] = ACTIONS(584),
  },
  [439] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(859),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [440] = {
    [sym_string] = STATE(861),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1880),
    [anon_sym_POUND] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1882),
    [anon_sym_STAR] = ACTIONS(1878),
    [anon_sym_AT] = ACTIONS(1878),
    [anon_sym_QMARK] = ACTIONS(1878),
    [anon_sym_0] = ACTIONS(1884),
    [anon_sym__] = ACTIONS(1884),
  },
  [441] = {
    [aux_sym_concatenation_repeat1] = STATE(857),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(598),
    [anon_sym_PIPE_AMP] = ACTIONS(598),
    [anon_sym_AMP_AMP] = ACTIONS(598),
    [anon_sym_PIPE_PIPE] = ACTIONS(598),
    [sym__special_characters] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(600),
    [sym_word] = ACTIONS(600),
  },
  [442] = {
    [sym_subscript] = STATE(867),
    [sym_variable_name] = ACTIONS(1886),
    [anon_sym_DOLLAR] = ACTIONS(1888),
    [anon_sym_POUND] = ACTIONS(1890),
    [anon_sym_DASH] = ACTIONS(1888),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(1888),
    [anon_sym_QMARK] = ACTIONS(1888),
    [anon_sym_0] = ACTIONS(1894),
    [anon_sym__] = ACTIONS(1894),
  },
  [443] = {
    [sym_for_statement] = STATE(868),
    [sym_while_statement] = STATE(868),
    [sym_if_statement] = STATE(868),
    [sym_case_statement] = STATE(868),
    [sym_function_definition] = STATE(868),
    [sym_subshell] = STATE(868),
    [sym_pipeline] = STATE(868),
    [sym_list] = STATE(868),
    [sym_command] = STATE(868),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(868),
    [sym_variable_assignment] = STATE(869),
    [sym_declaration_command] = STATE(868),
    [sym_unset_command] = STATE(868),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [444] = {
    [sym_for_statement] = STATE(870),
    [sym_while_statement] = STATE(870),
    [sym_if_statement] = STATE(870),
    [sym_case_statement] = STATE(870),
    [sym_function_definition] = STATE(870),
    [sym_subshell] = STATE(870),
    [sym_pipeline] = STATE(870),
    [sym_list] = STATE(870),
    [sym_command] = STATE(870),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(870),
    [sym_variable_assignment] = STATE(871),
    [sym_declaration_command] = STATE(870),
    [sym_unset_command] = STATE(870),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [445] = {
    [sym_for_statement] = STATE(872),
    [sym_while_statement] = STATE(872),
    [sym_if_statement] = STATE(872),
    [sym_case_statement] = STATE(872),
    [sym_function_definition] = STATE(872),
    [sym_subshell] = STATE(872),
    [sym_pipeline] = STATE(872),
    [sym_list] = STATE(872),
    [sym_command] = STATE(872),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(872),
    [sym_variable_assignment] = STATE(873),
    [sym_declaration_command] = STATE(872),
    [sym_unset_command] = STATE(872),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [446] = {
    [sym_variable_name] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_PIPE_AMP] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [sym__special_characters] = ACTIONS(612),
    [anon_sym_DQUOTE] = ACTIONS(612),
    [anon_sym_DOLLAR] = ACTIONS(614),
    [sym_raw_string] = ACTIONS(612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(612),
    [anon_sym_BQUOTE] = ACTIONS(612),
    [anon_sym_LT_LPAREN] = ACTIONS(612),
    [anon_sym_GT_LPAREN] = ACTIONS(612),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(614),
    [sym_word] = ACTIONS(614),
  },
  [447] = {
    [sym__assignment] = STATE(855),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_PLUS_EQ] = ACTIONS(1872),
    [sym_comment] = ACTIONS(54),
  },
  [448] = {
    [sym_variable_assignment] = STATE(874),
    [sym_subscript] = STATE(447),
    [sym_concatenation] = STATE(874),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_declaration_command_repeat1] = STATE(874),
    [sym_variable_name] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(616),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_PIPE_AMP] = ACTIONS(618),
    [anon_sym_AMP_AMP] = ACTIONS(618),
    [anon_sym_PIPE_PIPE] = ACTIONS(618),
    [sym__special_characters] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(816),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(820),
    [sym_word] = ACTIONS(822),
  },
  [449] = {
    [aux_sym_concatenation_repeat1] = STATE(876),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_PIPE_AMP] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [sym__special_characters] = ACTIONS(624),
    [anon_sym_DQUOTE] = ACTIONS(624),
    [anon_sym_DOLLAR] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(624),
    [anon_sym_BQUOTE] = ACTIONS(624),
    [anon_sym_LT_LPAREN] = ACTIONS(624),
    [anon_sym_GT_LPAREN] = ACTIONS(624),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(622),
    [sym_word] = ACTIONS(622),
  },
  [450] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(878),
    [anon_sym_DQUOTE] = ACTIONS(1898),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [451] = {
    [sym_string] = STATE(880),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(1900),
    [sym_raw_string] = ACTIONS(1902),
    [anon_sym_POUND] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(1900),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_0] = ACTIONS(1906),
    [anon_sym__] = ACTIONS(1906),
  },
  [452] = {
    [aux_sym_concatenation_repeat1] = STATE(876),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_PIPE_AMP] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [sym__special_characters] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [sym_raw_string] = ACTIONS(640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(640),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(640),
    [anon_sym_GT_LPAREN] = ACTIONS(640),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [sym_word] = ACTIONS(638),
  },
  [453] = {
    [sym_subscript] = STATE(886),
    [sym_variable_name] = ACTIONS(1908),
    [anon_sym_DOLLAR] = ACTIONS(1910),
    [anon_sym_POUND] = ACTIONS(1912),
    [anon_sym_DASH] = ACTIONS(1910),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_0] = ACTIONS(1916),
    [anon_sym__] = ACTIONS(1916),
  },
  [454] = {
    [sym_for_statement] = STATE(887),
    [sym_while_statement] = STATE(887),
    [sym_if_statement] = STATE(887),
    [sym_case_statement] = STATE(887),
    [sym_function_definition] = STATE(887),
    [sym_subshell] = STATE(887),
    [sym_pipeline] = STATE(887),
    [sym_list] = STATE(887),
    [sym_command] = STATE(887),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(887),
    [sym_variable_assignment] = STATE(888),
    [sym_declaration_command] = STATE(887),
    [sym_unset_command] = STATE(887),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [455] = {
    [sym_for_statement] = STATE(889),
    [sym_while_statement] = STATE(889),
    [sym_if_statement] = STATE(889),
    [sym_case_statement] = STATE(889),
    [sym_function_definition] = STATE(889),
    [sym_subshell] = STATE(889),
    [sym_pipeline] = STATE(889),
    [sym_list] = STATE(889),
    [sym_command] = STATE(889),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(889),
    [sym_variable_assignment] = STATE(890),
    [sym_declaration_command] = STATE(889),
    [sym_unset_command] = STATE(889),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [456] = {
    [sym_for_statement] = STATE(891),
    [sym_while_statement] = STATE(891),
    [sym_if_statement] = STATE(891),
    [sym_case_statement] = STATE(891),
    [sym_function_definition] = STATE(891),
    [sym_subshell] = STATE(891),
    [sym_pipeline] = STATE(891),
    [sym_list] = STATE(891),
    [sym_command] = STATE(891),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(891),
    [sym_variable_assignment] = STATE(892),
    [sym_declaration_command] = STATE(891),
    [sym_unset_command] = STATE(891),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [457] = {
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_PIPE_AMP] = ACTIONS(654),
    [anon_sym_AMP_AMP] = ACTIONS(654),
    [anon_sym_PIPE_PIPE] = ACTIONS(654),
    [sym__special_characters] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(654),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(654),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(654),
    [anon_sym_GT_LPAREN] = ACTIONS(654),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(652),
    [sym_word] = ACTIONS(652),
  },
  [458] = {
    [sym_concatenation] = STATE(893),
    [sym_string] = STATE(452),
    [sym_simple_expansion] = STATE(452),
    [sym_string_expansion] = STATE(452),
    [sym_expansion] = STATE(452),
    [sym_command_substitution] = STATE(452),
    [sym_process_substitution] = STATE(452),
    [aux_sym_unset_command_repeat1] = STATE(893),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_PIPE_AMP] = ACTIONS(658),
    [anon_sym_AMP_AMP] = ACTIONS(658),
    [anon_sym_PIPE_PIPE] = ACTIONS(658),
    [sym__special_characters] = ACTIONS(824),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(840),
    [sym_word] = ACTIONS(842),
  },
  [459] = {
    [sym_string] = STATE(894),
    [sym_simple_expansion] = STATE(894),
    [sym_string_expansion] = STATE(894),
    [sym_expansion] = STATE(894),
    [sym_command_substitution] = STATE(894),
    [sym_process_substitution] = STATE(894),
    [sym__special_characters] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1918),
  },
  [460] = {
    [aux_sym_concatenation_repeat1] = STATE(895),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(694),
  },
  [461] = {
    [sym__simple_heredoc_body] = ACTIONS(696),
    [sym__heredoc_body_beginning] = ACTIONS(696),
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_PIPE_AMP] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [anon_sym_EQ_TILDE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(696),
    [anon_sym_LT_AMP] = ACTIONS(696),
    [anon_sym_GT_AMP] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(696),
    [anon_sym_LT_LT_LT] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(698),
  },
  [462] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [463] = {
    [sym__simple_heredoc_body] = ACTIONS(726),
    [sym__heredoc_body_beginning] = ACTIONS(726),
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_PIPE_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_EQ_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(726),
    [anon_sym_LT_AMP] = ACTIONS(726),
    [anon_sym_GT_AMP] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(726),
    [anon_sym_LT_LT_LT] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(728),
  },
  [464] = {
    [sym__simple_heredoc_body] = ACTIONS(730),
    [sym__heredoc_body_beginning] = ACTIONS(730),
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_PIPE_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(730),
    [anon_sym_EQ_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(730),
    [anon_sym_LT_AMP] = ACTIONS(730),
    [anon_sym_GT_AMP] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(730),
    [anon_sym_LT_LT_LT] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(730),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(732),
  },
  [465] = {
    [sym__simple_heredoc_body] = ACTIONS(734),
    [sym__heredoc_body_beginning] = ACTIONS(734),
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_PIPE_AMP] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_EQ_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(734),
    [anon_sym_LT_AMP] = ACTIONS(734),
    [anon_sym_GT_AMP] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_LT] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(736),
  },
  [466] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(1922),
    [sym_comment] = ACTIONS(54),
  },
  [467] = {
    [sym_concatenation] = STATE(900),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(900),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_EQ] = ACTIONS(1926),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1930),
    [anon_sym_COLON] = ACTIONS(1926),
    [anon_sym_COLON_QMARK] = ACTIONS(1926),
    [anon_sym_COLON_DASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [468] = {
    [sym_subscript] = STATE(904),
    [sym_variable_name] = ACTIONS(1932),
    [anon_sym_DOLLAR] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1934),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1934),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1934),
    [anon_sym_0] = ACTIONS(1938),
    [anon_sym__] = ACTIONS(1938),
  },
  [469] = {
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(907),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1942),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1946),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_COLON_QMARK] = ACTIONS(1942),
    [anon_sym_COLON_DASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1942),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [470] = {
    [sym_concatenation] = STATE(910),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(910),
    [anon_sym_RBRACE] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1950),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(1954),
    [anon_sym_COLON] = ACTIONS(1950),
    [anon_sym_COLON_QMARK] = ACTIONS(1950),
    [anon_sym_COLON_DASH] = ACTIONS(1950),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [471] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1956),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [472] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1956),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [473] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(54),
  },
  [474] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(1956),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [475] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [476] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [477] = {
    [anon_sym_RPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(54),
  },
  [478] = {
    [sym_for_statement] = STATE(914),
    [sym_while_statement] = STATE(914),
    [sym_if_statement] = STATE(914),
    [sym_case_statement] = STATE(914),
    [sym_function_definition] = STATE(914),
    [sym_subshell] = STATE(914),
    [sym_pipeline] = STATE(914),
    [sym_list] = STATE(914),
    [sym_command] = STATE(914),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(914),
    [sym_variable_assignment] = STATE(915),
    [sym_declaration_command] = STATE(914),
    [sym_unset_command] = STATE(914),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [479] = {
    [sym__simple_heredoc_body] = ACTIONS(1962),
    [sym__heredoc_body_beginning] = ACTIONS(1962),
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [480] = {
    [sym_for_statement] = STATE(916),
    [sym_while_statement] = STATE(916),
    [sym_if_statement] = STATE(916),
    [sym_case_statement] = STATE(916),
    [sym_function_definition] = STATE(916),
    [sym_subshell] = STATE(916),
    [sym_pipeline] = STATE(916),
    [sym_list] = STATE(916),
    [sym_command] = STATE(916),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(916),
    [sym_variable_assignment] = STATE(917),
    [sym_declaration_command] = STATE(916),
    [sym_unset_command] = STATE(916),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [481] = {
    [anon_sym_PIPE] = ACTIONS(954),
    [anon_sym_RPAREN] = ACTIONS(956),
    [anon_sym_PIPE_AMP] = ACTIONS(956),
    [anon_sym_AMP_AMP] = ACTIONS(956),
    [anon_sym_PIPE_PIPE] = ACTIONS(956),
    [anon_sym_BQUOTE] = ACTIONS(956),
    [sym_comment] = ACTIONS(54),
  },
  [482] = {
    [sym_simple_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [aux_sym_heredoc_body_repeat1] = STATE(919),
    [sym__heredoc_body_middle] = ACTIONS(958),
    [sym__heredoc_body_end] = ACTIONS(1966),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(964),
    [sym_comment] = ACTIONS(54),
  },
  [483] = {
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT_GT] = ACTIONS(1970),
    [anon_sym_LT_AMP] = ACTIONS(1970),
    [anon_sym_GT_AMP] = ACTIONS(1970),
    [sym_comment] = ACTIONS(54),
  },
  [484] = {
    [sym_concatenation] = STATE(923),
    [sym_string] = STATE(922),
    [sym_simple_expansion] = STATE(922),
    [sym_string_expansion] = STATE(922),
    [sym_expansion] = STATE(922),
    [sym_command_substitution] = STATE(922),
    [sym_process_substitution] = STATE(922),
    [sym__special_characters] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(1976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1982),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1976),
    [sym_regex] = ACTIONS(1986),
  },
  [485] = {
    [sym_concatenation] = STATE(926),
    [sym_string] = STATE(925),
    [sym_simple_expansion] = STATE(925),
    [sym_string_expansion] = STATE(925),
    [sym_expansion] = STATE(925),
    [sym_command_substitution] = STATE(925),
    [sym_process_substitution] = STATE(925),
    [sym__special_characters] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(1990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1990),
  },
  [486] = {
    [sym_heredoc_start] = ACTIONS(1992),
    [sym_comment] = ACTIONS(54),
  },
  [487] = {
    [sym_concatenation] = STATE(930),
    [sym_string] = STATE(929),
    [sym_simple_expansion] = STATE(929),
    [sym_string_expansion] = STATE(929),
    [sym_expansion] = STATE(929),
    [sym_command_substitution] = STATE(929),
    [sym_process_substitution] = STATE(929),
    [sym__special_characters] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(1996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1996),
  },
  [488] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(508),
    [sym__heredoc_body_beginning] = ACTIONS(508),
    [sym_file_descriptor] = ACTIONS(508),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(508),
    [anon_sym_PIPE_AMP] = ACTIONS(508),
    [anon_sym_AMP_AMP] = ACTIONS(508),
    [anon_sym_PIPE_PIPE] = ACTIONS(508),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_AMP_GT] = ACTIONS(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(508),
    [anon_sym_LT_AMP] = ACTIONS(508),
    [anon_sym_GT_AMP] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(508),
    [anon_sym_LT_LT_LT] = ACTIONS(508),
    [sym__special_characters] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(508),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(508),
    [anon_sym_GT_LPAREN] = ACTIONS(508),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(506),
  },
  [489] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(522),
    [anon_sym_LT_LT_LT] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(522),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [490] = {
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [sym_comment] = ACTIONS(54),
  },
  [491] = {
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(522),
    [anon_sym_LT_LT_LT] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(522),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [492] = {
    [sym_file_redirect] = STATE(932),
    [sym_heredoc_redirect] = STATE(932),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(932),
    [aux_sym_while_statement_repeat1] = STATE(932),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym_comment] = ACTIONS(54),
  },
  [493] = {
    [sym_file_redirect] = STATE(933),
    [sym_heredoc_redirect] = STATE(933),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(933),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(489),
    [sym_simple_expansion] = STATE(489),
    [sym_string_expansion] = STATE(489),
    [sym_expansion] = STATE(489),
    [sym_command_substitution] = STATE(489),
    [sym_process_substitution] = STATE(489),
    [aux_sym_while_statement_repeat1] = STATE(933),
    [aux_sym_command_repeat2] = STATE(934),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_EQ_TILDE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym__special_characters] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(898),
  },
  [494] = {
    [sym_file_redirect] = STATE(933),
    [sym_heredoc_redirect] = STATE(933),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(933),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(489),
    [sym_simple_expansion] = STATE(489),
    [sym_string_expansion] = STATE(489),
    [sym_expansion] = STATE(489),
    [sym_command_substitution] = STATE(489),
    [sym_process_substitution] = STATE(489),
    [aux_sym_while_statement_repeat1] = STATE(933),
    [aux_sym_command_repeat2] = STATE(935),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_EQ_TILDE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym__special_characters] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(898),
  },
  [495] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(937),
    [sym_array] = STATE(833),
    [sym_simple_expansion] = STATE(937),
    [sym_string_expansion] = STATE(937),
    [sym_expansion] = STATE(937),
    [sym_command_substitution] = STATE(937),
    [sym_process_substitution] = STATE(937),
    [sym__empty_value] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(2000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2000),
  },
  [496] = {
    [sym_do_group] = STATE(938),
    [anon_sym_do] = ACTIONS(1844),
    [sym_comment] = ACTIONS(54),
  },
  [497] = {
    [sym_compound_statement] = STATE(940),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [498] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [anon_sym_RBRACK] = ACTIONS(2004),
    [sym__special_characters] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [499] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2004),
    [sym__special_characters] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [500] = {
    [sym__assignment] = STATE(855),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(2006),
    [anon_sym_PLUS_EQ] = ACTIONS(2006),
    [sym_comment] = ACTIONS(54),
  },
  [501] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(584),
    [sym_word] = ACTIONS(584),
  },
  [502] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_PIPE_AMP] = ACTIONS(598),
    [anon_sym_AMP_AMP] = ACTIONS(598),
    [anon_sym_PIPE_PIPE] = ACTIONS(598),
    [sym__special_characters] = ACTIONS(598),
    [anon_sym_DQUOTE] = ACTIONS(598),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [sym_raw_string] = ACTIONS(598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(598),
    [anon_sym_BQUOTE] = ACTIONS(598),
    [anon_sym_LT_LPAREN] = ACTIONS(598),
    [anon_sym_GT_LPAREN] = ACTIONS(598),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(600),
    [sym_word] = ACTIONS(600),
  },
  [503] = {
    [sym__assignment] = STATE(855),
    [anon_sym_EQ] = ACTIONS(2006),
    [anon_sym_PLUS_EQ] = ACTIONS(2006),
    [sym_comment] = ACTIONS(54),
  },
  [504] = {
    [sym_variable_assignment] = STATE(944),
    [sym_subscript] = STATE(503),
    [sym_concatenation] = STATE(944),
    [sym_string] = STATE(502),
    [sym_simple_expansion] = STATE(502),
    [sym_string_expansion] = STATE(502),
    [sym_expansion] = STATE(502),
    [sym_command_substitution] = STATE(502),
    [sym_process_substitution] = STATE(502),
    [aux_sym_declaration_command_repeat1] = STATE(944),
    [sym_variable_name] = ACTIONS(906),
    [anon_sym_PIPE] = ACTIONS(616),
    [anon_sym_PIPE_AMP] = ACTIONS(618),
    [anon_sym_AMP_AMP] = ACTIONS(618),
    [anon_sym_PIPE_PIPE] = ACTIONS(618),
    [sym__special_characters] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(618),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(820),
    [sym_word] = ACTIONS(912),
  },
  [505] = {
    [aux_sym_concatenation_repeat1] = STATE(945),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(624),
    [anon_sym_PIPE_PIPE] = ACTIONS(624),
    [sym__special_characters] = ACTIONS(624),
    [anon_sym_DQUOTE] = ACTIONS(624),
    [anon_sym_DOLLAR] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(624),
    [anon_sym_BQUOTE] = ACTIONS(624),
    [anon_sym_LT_LPAREN] = ACTIONS(624),
    [anon_sym_GT_LPAREN] = ACTIONS(624),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(622),
    [sym_word] = ACTIONS(622),
  },
  [506] = {
    [aux_sym_concatenation_repeat1] = STATE(945),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_PIPE_AMP] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [sym__special_characters] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [sym_raw_string] = ACTIONS(640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(640),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(640),
    [anon_sym_GT_LPAREN] = ACTIONS(640),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [sym_word] = ACTIONS(638),
  },
  [507] = {
    [sym_concatenation] = STATE(946),
    [sym_string] = STATE(506),
    [sym_simple_expansion] = STATE(506),
    [sym_string_expansion] = STATE(506),
    [sym_expansion] = STATE(506),
    [sym_command_substitution] = STATE(506),
    [sym_process_substitution] = STATE(506),
    [aux_sym_unset_command_repeat1] = STATE(946),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_PIPE_AMP] = ACTIONS(658),
    [anon_sym_AMP_AMP] = ACTIONS(658),
    [anon_sym_PIPE_PIPE] = ACTIONS(658),
    [sym__special_characters] = ACTIONS(914),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(658),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(840),
    [sym_word] = ACTIONS(918),
  },
  [508] = {
    [aux_sym_concatenation_repeat1] = STATE(947),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(694),
  },
  [509] = {
    [anon_sym_RPAREN] = ACTIONS(2008),
    [sym_comment] = ACTIONS(54),
  },
  [510] = {
    [sym_for_statement] = STATE(914),
    [sym_while_statement] = STATE(914),
    [sym_if_statement] = STATE(914),
    [sym_case_statement] = STATE(914),
    [sym_function_definition] = STATE(914),
    [sym_subshell] = STATE(914),
    [sym_pipeline] = STATE(914),
    [sym_list] = STATE(914),
    [sym_command] = STATE(914),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(914),
    [sym_variable_assignment] = STATE(949),
    [sym_declaration_command] = STATE(914),
    [sym_unset_command] = STATE(914),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [511] = {
    [sym_for_statement] = STATE(950),
    [sym_while_statement] = STATE(950),
    [sym_if_statement] = STATE(950),
    [sym_case_statement] = STATE(950),
    [sym_function_definition] = STATE(950),
    [sym_subshell] = STATE(950),
    [sym_pipeline] = STATE(950),
    [sym_list] = STATE(950),
    [sym_command] = STATE(950),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(950),
    [sym_variable_assignment] = STATE(951),
    [sym_declaration_command] = STATE(950),
    [sym_unset_command] = STATE(950),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [512] = {
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [sym_comment] = ACTIONS(54),
  },
  [513] = {
    [sym_concatenation] = STATE(923),
    [sym_string] = STATE(954),
    [sym_simple_expansion] = STATE(954),
    [sym_string_expansion] = STATE(954),
    [sym_expansion] = STATE(954),
    [sym_command_substitution] = STATE(954),
    [sym_process_substitution] = STATE(954),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1982),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2016),
    [sym_regex] = ACTIONS(1986),
  },
  [514] = {
    [sym_concatenation] = STATE(926),
    [sym_string] = STATE(956),
    [sym_simple_expansion] = STATE(956),
    [sym_string_expansion] = STATE(956),
    [sym_expansion] = STATE(956),
    [sym_command_substitution] = STATE(956),
    [sym_process_substitution] = STATE(956),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2020),
  },
  [515] = {
    [sym_concatenation] = STATE(930),
    [sym_string] = STATE(958),
    [sym_simple_expansion] = STATE(958),
    [sym_string_expansion] = STATE(958),
    [sym_expansion] = STATE(958),
    [sym_command_substitution] = STATE(958),
    [sym_process_substitution] = STATE(958),
    [sym__special_characters] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(2024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2024),
  },
  [516] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(508),
    [sym__heredoc_body_beginning] = ACTIONS(508),
    [sym_file_descriptor] = ACTIONS(508),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(508),
    [anon_sym_AMP_AMP] = ACTIONS(508),
    [anon_sym_PIPE_PIPE] = ACTIONS(508),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_AMP_GT] = ACTIONS(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(508),
    [anon_sym_LT_AMP] = ACTIONS(508),
    [anon_sym_GT_AMP] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(508),
    [anon_sym_LT_LT_LT] = ACTIONS(508),
    [sym__special_characters] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(508),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(508),
    [anon_sym_GT_LPAREN] = ACTIONS(508),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(506),
  },
  [517] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(522),
    [anon_sym_AMP_AMP] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(522),
    [anon_sym_LT_LT_LT] = ACTIONS(522),
    [sym__special_characters] = ACTIONS(522),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(522),
    [anon_sym_LT_LPAREN] = ACTIONS(522),
    [anon_sym_GT_LPAREN] = ACTIONS(522),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(520),
  },
  [518] = {
    [sym_file_redirect] = STATE(959),
    [sym_heredoc_redirect] = STATE(959),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(959),
    [aux_sym_while_statement_repeat1] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [sym_comment] = ACTIONS(54),
  },
  [519] = {
    [sym_file_redirect] = STATE(960),
    [sym_heredoc_redirect] = STATE(960),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(960),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(517),
    [sym_simple_expansion] = STATE(517),
    [sym_string_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(960),
    [aux_sym_command_repeat2] = STATE(961),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_EQ_TILDE] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(942),
  },
  [520] = {
    [sym_file_redirect] = STATE(960),
    [sym_heredoc_redirect] = STATE(960),
    [sym_heredoc_body] = STATE(931),
    [sym_herestring_redirect] = STATE(960),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(517),
    [sym_simple_expansion] = STATE(517),
    [sym_string_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(960),
    [aux_sym_command_repeat2] = STATE(962),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_EQ_TILDE] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(942),
  },
  [521] = {
    [sym__simple_heredoc_body] = ACTIONS(2026),
    [sym__heredoc_body_beginning] = ACTIONS(2026),
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_EQ_TILDE] = ACTIONS(2028),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2028),
    [anon_sym_LT_LT_LT] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [522] = {
    [sym_compound_statement] = STATE(963),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [523] = {
    [anon_sym_esac] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2030),
    [anon_sym_SEMI_SEMI] = ACTIONS(2030),
    [anon_sym_PIPE_AMP] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_PIPE_PIPE] = ACTIONS(2030),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_LF] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
  },
  [524] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2030),
    [anon_sym_SEMI_SEMI] = ACTIONS(2030),
    [anon_sym_PIPE_AMP] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_PIPE_PIPE] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_LF] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
  },
  [525] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [526] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [527] = {
    [sym__heredoc_body_middle] = ACTIONS(2038),
    [sym__heredoc_body_end] = ACTIONS(2038),
    [anon_sym_DOLLAR] = ACTIONS(2040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(54),
  },
  [528] = {
    [anon_sym_esac] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2042),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_SEMI_SEMI] = ACTIONS(2042),
    [anon_sym_PIPE_AMP] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_PIPE_PIPE] = ACTIONS(2042),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_LF] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2042),
  },
  [529] = {
    [anon_sym_DOLLAR] = ACTIONS(2046),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2046),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_QMARK] = ACTIONS(2046),
    [anon_sym_0] = ACTIONS(2050),
    [anon_sym__] = ACTIONS(2050),
  },
  [530] = {
    [sym_subscript] = STATE(970),
    [sym_variable_name] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(2054),
    [anon_sym_POUND] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2054),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_QMARK] = ACTIONS(2054),
    [anon_sym_0] = ACTIONS(2060),
    [anon_sym__] = ACTIONS(2060),
  },
  [531] = {
    [sym_simple_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [aux_sym_heredoc_body_repeat1] = STATE(972),
    [sym__heredoc_body_middle] = ACTIONS(958),
    [sym__heredoc_body_end] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(964),
    [sym_comment] = ACTIONS(54),
  },
  [532] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(974),
    [sym_simple_expansion] = STATE(974),
    [sym_string_expansion] = STATE(974),
    [sym_expansion] = STATE(974),
    [sym_command_substitution] = STATE(974),
    [sym_process_substitution] = STATE(974),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(2066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2066),
  },
  [533] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(1283),
    [sym__heredoc_body_beginning] = ACTIONS(1283),
    [sym_file_descriptor] = ACTIONS(1283),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_AMP] = ACTIONS(1281),
    [anon_sym_GT_AMP] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1281),
    [anon_sym_LT_LT_LT] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1281),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LT_LPAREN] = ACTIONS(1281),
    [anon_sym_GT_LPAREN] = ACTIONS(1281),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1281),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(121),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [535] = {
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [536] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(660),
    [sym__heredoc_body_beginning] = ACTIONS(660),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [537] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [538] = {
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [539] = {
    [sym__simple_heredoc_body] = ACTIONS(2068),
    [sym__heredoc_body_beginning] = ACTIONS(2068),
    [sym_file_descriptor] = ACTIONS(2068),
    [anon_sym_esac] = ACTIONS(2070),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_SEMI_SEMI] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(2070),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2070),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2070),
  },
  [540] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(2072),
    [sym__heredoc_body_beginning] = ACTIONS(2072),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [541] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [542] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [543] = {
    [anon_sym_esac] = ACTIONS(2080),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [544] = {
    [sym_file_redirect] = STATE(544),
    [sym_heredoc_redirect] = STATE(544),
    [sym_herestring_redirect] = STATE(544),
    [aux_sym_while_statement_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(2084),
    [sym__heredoc_body_beginning] = ACTIONS(2084),
    [sym_file_descriptor] = ACTIONS(2086),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2091),
    [anon_sym_GT] = ACTIONS(2091),
    [anon_sym_GT_GT] = ACTIONS(2091),
    [anon_sym_AMP_GT] = ACTIONS(2091),
    [anon_sym_AMP_GT_GT] = ACTIONS(2091),
    [anon_sym_LT_AMP] = ACTIONS(2091),
    [anon_sym_GT_AMP] = ACTIONS(2091),
    [anon_sym_LT_LT] = ACTIONS(2094),
    [anon_sym_LT_LT_DASH] = ACTIONS(2094),
    [anon_sym_LT_LT_LT] = ACTIONS(2097),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [545] = {
    [sym_file_redirect] = STATE(544),
    [sym_heredoc_redirect] = STATE(544),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(544),
    [aux_sym_while_statement_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [546] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(192),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [aux_sym_command_repeat2] = STATE(546),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(2100),
    [anon_sym_EQ_EQ] = ACTIONS(2100),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2112),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2118),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [anon_sym_LT_LPAREN] = ACTIONS(2124),
    [anon_sym_GT_LPAREN] = ACTIONS(2124),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [547] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(979),
    [sym_array] = STATE(833),
    [sym_simple_expansion] = STATE(979),
    [sym_string_expansion] = STATE(979),
    [sym_expansion] = STATE(979),
    [sym_command_substitution] = STATE(979),
    [sym_process_substitution] = STATE(979),
    [sym__empty_value] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [sym_raw_string] = ACTIONS(2129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(204),
    [anon_sym_BQUOTE] = ACTIONS(206),
    [anon_sym_LT_LPAREN] = ACTIONS(208),
    [anon_sym_GT_LPAREN] = ACTIONS(208),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2129),
  },
  [548] = {
    [sym_file_redirect] = STATE(980),
    [sym_heredoc_redirect] = STATE(980),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(980),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(192),
    [sym_simple_expansion] = STATE(192),
    [sym_string_expansion] = STATE(192),
    [sym_expansion] = STATE(192),
    [sym_command_substitution] = STATE(192),
    [sym_process_substitution] = STATE(192),
    [aux_sym_while_statement_repeat1] = STATE(980),
    [aux_sym_command_repeat2] = STATE(546),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_EQ_TILDE] = ACTIONS(330),
    [anon_sym_EQ_EQ] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym__special_characters] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(342),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [549] = {
    [sym_string] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [sym_process_substitution] = STATE(667),
    [anon_sym_RBRACK] = ACTIONS(2131),
    [sym__special_characters] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1289),
  },
  [550] = {
    [sym__concat] = ACTIONS(2135),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_PLUS_EQ] = ACTIONS(2137),
    [sym_comment] = ACTIONS(54),
  },
  [551] = {
    [aux_sym_concatenation_repeat1] = STATE(983),
    [sym__concat] = ACTIONS(504),
    [anon_sym_RBRACK] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [552] = {
    [sym_string] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [sym_process_substitution] = STATE(667),
    [anon_sym_RBRACK] = ACTIONS(2139),
    [sym__special_characters] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1289),
  },
  [553] = {
    [sym__concat] = ACTIONS(2141),
    [anon_sym_EQ] = ACTIONS(2143),
    [anon_sym_PLUS_EQ] = ACTIONS(2143),
    [sym_comment] = ACTIONS(54),
  },
  [554] = {
    [anon_sym_RBRACK] = ACTIONS(2139),
    [sym_comment] = ACTIONS(54),
  },
  [555] = {
    [sym_file_descriptor] = ACTIONS(2145),
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_PIPE_AMP] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_GT] = ACTIONS(2147),
    [anon_sym_AMP_GT_GT] = ACTIONS(2147),
    [anon_sym_LT_AMP] = ACTIONS(2147),
    [anon_sym_GT_AMP] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [556] = {
    [aux_sym_concatenation_repeat1] = STATE(987),
    [sym__concat] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(2151),
    [sym__special_characters] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2151),
    [anon_sym_BQUOTE] = ACTIONS(2151),
    [anon_sym_LT_LPAREN] = ACTIONS(2151),
    [anon_sym_GT_LPAREN] = ACTIONS(2151),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2151),
  },
  [557] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(989),
    [anon_sym_DQUOTE] = ACTIONS(2155),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [558] = {
    [sym_string] = STATE(991),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(2157),
    [sym_raw_string] = ACTIONS(2159),
    [anon_sym_POUND] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AT] = ACTIONS(2157),
    [anon_sym_QMARK] = ACTIONS(2157),
    [anon_sym_0] = ACTIONS(2163),
    [anon_sym__] = ACTIONS(2163),
  },
  [559] = {
    [aux_sym_concatenation_repeat1] = STATE(987),
    [sym__concat] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(2165),
    [sym__special_characters] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [anon_sym_DOLLAR] = ACTIONS(2167),
    [sym_raw_string] = ACTIONS(2165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2165),
    [anon_sym_BQUOTE] = ACTIONS(2165),
    [anon_sym_LT_LPAREN] = ACTIONS(2165),
    [anon_sym_GT_LPAREN] = ACTIONS(2165),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2165),
  },
  [560] = {
    [sym_subscript] = STATE(997),
    [sym_variable_name] = ACTIONS(2169),
    [anon_sym_DOLLAR] = ACTIONS(2171),
    [anon_sym_POUND] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2171),
    [anon_sym_AT] = ACTIONS(2171),
    [anon_sym_QMARK] = ACTIONS(2171),
    [anon_sym_0] = ACTIONS(2177),
    [anon_sym__] = ACTIONS(2177),
  },
  [561] = {
    [sym_for_statement] = STATE(998),
    [sym_while_statement] = STATE(998),
    [sym_if_statement] = STATE(998),
    [sym_case_statement] = STATE(998),
    [sym_function_definition] = STATE(998),
    [sym_subshell] = STATE(998),
    [sym_pipeline] = STATE(998),
    [sym_list] = STATE(998),
    [sym_command] = STATE(998),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(998),
    [sym_variable_assignment] = STATE(999),
    [sym_declaration_command] = STATE(998),
    [sym_unset_command] = STATE(998),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [562] = {
    [sym_for_statement] = STATE(1000),
    [sym_while_statement] = STATE(1000),
    [sym_if_statement] = STATE(1000),
    [sym_case_statement] = STATE(1000),
    [sym_function_definition] = STATE(1000),
    [sym_subshell] = STATE(1000),
    [sym_pipeline] = STATE(1000),
    [sym_list] = STATE(1000),
    [sym_command] = STATE(1000),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(1000),
    [sym_variable_assignment] = STATE(1001),
    [sym_declaration_command] = STATE(1000),
    [sym_unset_command] = STATE(1000),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [563] = {
    [sym_for_statement] = STATE(1002),
    [sym_while_statement] = STATE(1002),
    [sym_if_statement] = STATE(1002),
    [sym_case_statement] = STATE(1002),
    [sym_function_definition] = STATE(1002),
    [sym_subshell] = STATE(1002),
    [sym_pipeline] = STATE(1002),
    [sym_list] = STATE(1002),
    [sym_command] = STATE(1002),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1002),
    [sym_variable_assignment] = STATE(1003),
    [sym_declaration_command] = STATE(1002),
    [sym_unset_command] = STATE(1002),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [564] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [565] = {
    [sym_string] = STATE(1006),
    [sym_simple_expansion] = STATE(1006),
    [sym_string_expansion] = STATE(1006),
    [sym_expansion] = STATE(1006),
    [sym_command_substitution] = STATE(1006),
    [sym_process_substitution] = STATE(1006),
    [sym__special_characters] = ACTIONS(2181),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(380),
    [sym_raw_string] = ACTIONS(2181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(388),
    [anon_sym_LT_LPAREN] = ACTIONS(390),
    [anon_sym_GT_LPAREN] = ACTIONS(390),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2181),
  },
  [566] = {
    [aux_sym_concatenation_repeat1] = STATE(1007),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [567] = {
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [568] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [569] = {
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [570] = {
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [571] = {
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [572] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2185),
    [sym_comment] = ACTIONS(54),
  },
  [573] = {
    [sym_concatenation] = STATE(1012),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1012),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2189),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2193),
    [anon_sym_COLON] = ACTIONS(2189),
    [anon_sym_COLON_QMARK] = ACTIONS(2189),
    [anon_sym_COLON_DASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [574] = {
    [sym_subscript] = STATE(1016),
    [sym_variable_name] = ACTIONS(2195),
    [anon_sym_DOLLAR] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2197),
    [anon_sym_0] = ACTIONS(2201),
    [anon_sym__] = ACTIONS(2201),
  },
  [575] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1019),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2205),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2209),
    [anon_sym_COLON] = ACTIONS(2205),
    [anon_sym_COLON_QMARK] = ACTIONS(2205),
    [anon_sym_COLON_DASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [576] = {
    [sym_concatenation] = STATE(1022),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1022),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(2213),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2213),
    [anon_sym_COLON_QMARK] = ACTIONS(2213),
    [anon_sym_COLON_DASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [577] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [578] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [579] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(54),
  },
  [580] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [581] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [582] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [583] = {
    [aux_sym_concatenation_repeat1] = STATE(1026),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_SEMI_SEMI] = ACTIONS(2153),
    [sym__special_characters] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2153),
    [anon_sym_LT_LPAREN] = ACTIONS(2153),
    [anon_sym_GT_LPAREN] = ACTIONS(2153),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_LF] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2153),
  },
  [584] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(1028),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [585] = {
    [sym_string] = STATE(1030),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(2227),
    [sym_raw_string] = ACTIONS(2229),
    [anon_sym_POUND] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2227),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_QMARK] = ACTIONS(2227),
    [anon_sym_0] = ACTIONS(2233),
    [anon_sym__] = ACTIONS(2233),
  },
  [586] = {
    [aux_sym_concatenation_repeat1] = STATE(1026),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_SEMI_SEMI] = ACTIONS(2167),
    [sym__special_characters] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(2167),
    [sym_raw_string] = ACTIONS(2167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2167),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2167),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [anon_sym_LT_LPAREN] = ACTIONS(2167),
    [anon_sym_GT_LPAREN] = ACTIONS(2167),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_LF] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
  },
  [587] = {
    [sym_subscript] = STATE(1036),
    [sym_variable_name] = ACTIONS(2235),
    [anon_sym_DOLLAR] = ACTIONS(2237),
    [anon_sym_POUND] = ACTIONS(2239),
    [anon_sym_DASH] = ACTIONS(2237),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_QMARK] = ACTIONS(2237),
    [anon_sym_0] = ACTIONS(2243),
    [anon_sym__] = ACTIONS(2243),
  },
  [588] = {
    [sym_for_statement] = STATE(1037),
    [sym_while_statement] = STATE(1037),
    [sym_if_statement] = STATE(1037),
    [sym_case_statement] = STATE(1037),
    [sym_function_definition] = STATE(1037),
    [sym_subshell] = STATE(1037),
    [sym_pipeline] = STATE(1037),
    [sym_list] = STATE(1037),
    [sym_command] = STATE(1037),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1037),
    [sym_variable_assignment] = STATE(1038),
    [sym_declaration_command] = STATE(1037),
    [sym_unset_command] = STATE(1037),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [589] = {
    [sym_for_statement] = STATE(1039),
    [sym_while_statement] = STATE(1039),
    [sym_if_statement] = STATE(1039),
    [sym_case_statement] = STATE(1039),
    [sym_function_definition] = STATE(1039),
    [sym_subshell] = STATE(1039),
    [sym_pipeline] = STATE(1039),
    [sym_list] = STATE(1039),
    [sym_command] = STATE(1039),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(1039),
    [sym_variable_assignment] = STATE(1040),
    [sym_declaration_command] = STATE(1039),
    [sym_unset_command] = STATE(1039),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [590] = {
    [sym_for_statement] = STATE(1041),
    [sym_while_statement] = STATE(1041),
    [sym_if_statement] = STATE(1041),
    [sym_case_statement] = STATE(1041),
    [sym_function_definition] = STATE(1041),
    [sym_subshell] = STATE(1041),
    [sym_pipeline] = STATE(1041),
    [sym_list] = STATE(1041),
    [sym_command] = STATE(1041),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1041),
    [sym_variable_assignment] = STATE(1042),
    [sym_declaration_command] = STATE(1041),
    [sym_unset_command] = STATE(1041),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [591] = {
    [sym_concatenation] = STATE(1044),
    [sym_string] = STATE(586),
    [sym_simple_expansion] = STATE(586),
    [sym_string_expansion] = STATE(586),
    [sym_expansion] = STATE(586),
    [sym_command_substitution] = STATE(586),
    [sym_process_substitution] = STATE(586),
    [aux_sym_for_statement_repeat1] = STATE(1044),
    [anon_sym_SEMI_SEMI] = ACTIONS(2245),
    [sym__special_characters] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_DOLLAR] = ACTIONS(1149),
    [sym_raw_string] = ACTIONS(2251),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2257),
    [anon_sym_LT_LPAREN] = ACTIONS(2259),
    [anon_sym_GT_LPAREN] = ACTIONS(2259),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_LF] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2245),
  },
  [592] = {
    [sym__terminated_statement] = STATE(1046),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1046),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [593] = {
    [anon_sym_esac] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_SEMI_SEMI] = ACTIONS(2265),
    [anon_sym_PIPE_AMP] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_LF] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2265),
  },
  [594] = {
    [sym__simple_heredoc_body] = ACTIONS(2269),
    [sym__heredoc_body_beginning] = ACTIONS(2269),
    [sym_file_descriptor] = ACTIONS(2269),
    [anon_sym_esac] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_RPAREN] = ACTIONS(2271),
    [anon_sym_SEMI_SEMI] = ACTIONS(2271),
    [anon_sym_PIPE_AMP] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_GT_GT] = ACTIONS(2271),
    [anon_sym_AMP_GT] = ACTIONS(2271),
    [anon_sym_AMP_GT_GT] = ACTIONS(2271),
    [anon_sym_LT_AMP] = ACTIONS(2271),
    [anon_sym_GT_AMP] = ACTIONS(2271),
    [anon_sym_LT_LT] = ACTIONS(2271),
    [anon_sym_LT_LT_DASH] = ACTIONS(2271),
    [anon_sym_LT_LT_LT] = ACTIONS(2271),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_LF] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2271),
  },
  [595] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [596] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [597] = {
    [sym__terminated_statement] = STATE(1049),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1049),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [598] = {
    [anon_sym_esac] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2279),
  },
  [599] = {
    [sym_file_redirect] = STATE(544),
    [sym_heredoc_redirect] = STATE(544),
    [sym_heredoc_body] = STATE(1050),
    [sym_herestring_redirect] = STATE(544),
    [aux_sym_while_statement_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2279),
  },
  [600] = {
    [anon_sym_esac] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2283),
  },
  [601] = {
    [sym__terminated_statement] = STATE(1051),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [602] = {
    [sym__terminated_statement] = STATE(1054),
    [sym_for_statement] = STATE(1052),
    [sym_while_statement] = STATE(1052),
    [sym_if_statement] = STATE(1052),
    [sym_case_statement] = STATE(1052),
    [sym_function_definition] = STATE(1052),
    [sym_subshell] = STATE(1052),
    [sym_pipeline] = STATE(1052),
    [sym_list] = STATE(1052),
    [sym_command] = STATE(1052),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(1052),
    [sym_variable_assignment] = STATE(1053),
    [sym_declaration_command] = STATE(1052),
    [sym_unset_command] = STATE(1052),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1054),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2287),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [603] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [604] = {
    [anon_sym_fi] = ACTIONS(2293),
    [sym_comment] = ACTIONS(54),
  },
  [605] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_LF] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2289),
  },
  [606] = {
    [sym__terminated_statement] = STATE(1058),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_elif_clause] = STATE(1059),
    [sym_else_clause] = STATE(1057),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1058),
    [aux_sym_if_statement_repeat1] = STATE(1059),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2295),
    [anon_sym_elif] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [607] = {
    [sym_elif_clause] = STATE(1060),
    [sym_else_clause] = STATE(1057),
    [aux_sym_if_statement_repeat1] = STATE(1060),
    [anon_sym_fi] = ACTIONS(2293),
    [anon_sym_elif] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [sym_comment] = ACTIONS(54),
  },
  [608] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_in] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [609] = {
    [sym_case_item] = STATE(1066),
    [sym_last_case_item] = STATE(1064),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1066),
    [anon_sym_esac] = ACTIONS(2301),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [610] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2309),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2309),
    [anon_sym_LF] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2309),
  },
  [611] = {
    [aux_sym_concatenation_repeat1] = STATE(611),
    [sym__concat] = ACTIONS(2313),
    [anon_sym_in] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [612] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_in] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [613] = {
    [sym_case_item] = STATE(1070),
    [sym_last_case_item] = STATE(1069),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1070),
    [anon_sym_esac] = ACTIONS(2316),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [614] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_LF] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2318),
  },
  [615] = {
    [sym_concatenation] = STATE(1075),
    [sym_string] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [sym_command_substitution] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [sym__special_characters] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2326),
  },
  [616] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [617] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2328),
  },
  [618] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [619] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2332),
    [sym_comment] = ACTIONS(54),
  },
  [620] = {
    [sym_concatenation] = STATE(1081),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1081),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(2336),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(2336),
    [anon_sym_COLON_QMARK] = ACTIONS(2336),
    [anon_sym_COLON_DASH] = ACTIONS(2336),
    [anon_sym_PERCENT] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [621] = {
    [sym_concatenation] = STATE(1084),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1084),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_EQ] = ACTIONS(2344),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2348),
    [anon_sym_COLON] = ACTIONS(2344),
    [anon_sym_COLON_QMARK] = ACTIONS(2344),
    [anon_sym_COLON_DASH] = ACTIONS(2344),
    [anon_sym_PERCENT] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [622] = {
    [sym_concatenation] = STATE(1086),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1086),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_EQ] = ACTIONS(2350),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2354),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_COLON_QMARK] = ACTIONS(2350),
    [anon_sym_COLON_DASH] = ACTIONS(2350),
    [anon_sym_PERCENT] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [623] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [624] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2356),
  },
  [625] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [626] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_in] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [627] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2360),
  },
  [628] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [629] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [630] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_in] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [631] = {
    [sym_compound_statement] = STATE(1090),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [632] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE_AMP] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_PIPE_PIPE] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2364),
    [anon_sym_LT_AMP] = ACTIONS(2364),
    [anon_sym_GT_AMP] = ACTIONS(2364),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [633] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2366),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_LF] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
  },
  [634] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2366),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_LF] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
  },
  [635] = {
    [sym__terminated_statement] = STATE(1093),
    [sym_for_statement] = STATE(633),
    [sym_while_statement] = STATE(633),
    [sym_if_statement] = STATE(633),
    [sym_case_statement] = STATE(633),
    [sym_function_definition] = STATE(633),
    [sym_subshell] = STATE(633),
    [sym_pipeline] = STATE(633),
    [sym_list] = STATE(633),
    [sym_command] = STATE(633),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(633),
    [sym_variable_assignment] = STATE(634),
    [sym_declaration_command] = STATE(633),
    [sym_unset_command] = STATE(633),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1093),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [636] = {
    [anon_sym_LT] = ACTIONS(2372),
    [anon_sym_GT] = ACTIONS(2372),
    [anon_sym_GT_GT] = ACTIONS(2374),
    [anon_sym_AMP_GT] = ACTIONS(2372),
    [anon_sym_AMP_GT_GT] = ACTIONS(2374),
    [anon_sym_LT_AMP] = ACTIONS(2374),
    [anon_sym_GT_AMP] = ACTIONS(2374),
    [sym_comment] = ACTIONS(54),
  },
  [637] = {
    [sym_concatenation] = STATE(1097),
    [sym_string] = STATE(1096),
    [sym_simple_expansion] = STATE(1096),
    [sym_string_expansion] = STATE(1096),
    [sym_expansion] = STATE(1096),
    [sym_command_substitution] = STATE(1096),
    [sym_process_substitution] = STATE(1096),
    [sym__special_characters] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(2378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(1545),
    [anon_sym_GT_LPAREN] = ACTIONS(1545),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2378),
  },
  [638] = {
    [anon_sym_esac] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2380),
    [anon_sym_SEMI_SEMI] = ACTIONS(2380),
    [anon_sym_PIPE_AMP] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LF] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2380),
  },
  [639] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_AMP] = ACTIONS(1123),
    [anon_sym_GT_AMP] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [640] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [641] = {
    [sym_file_redirect] = STATE(1099),
    [sym_heredoc_redirect] = STATE(1099),
    [sym_heredoc_body] = STATE(598),
    [sym_herestring_redirect] = STATE(1099),
    [aux_sym_while_statement_repeat1] = STATE(1099),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
  },
  [642] = {
    [anon_sym_RPAREN] = ACTIONS(2384),
    [sym_comment] = ACTIONS(54),
  },
  [643] = {
    [sym_file_redirect] = STATE(638),
    [sym_file_descriptor] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_SEMI_SEMI] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_AMP] = ACTIONS(2388),
    [anon_sym_GT_AMP] = ACTIONS(2388),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LF] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [644] = {
    [sym_file_redirect] = STATE(1106),
    [sym_heredoc_redirect] = STATE(1106),
    [sym_herestring_redirect] = STATE(1106),
    [aux_sym_while_statement_repeat1] = STATE(1106),
    [sym_file_descriptor] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_SEMI_SEMI] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2392),
    [anon_sym_AMP_GT] = ACTIONS(2392),
    [anon_sym_AMP_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_AMP] = ACTIONS(2392),
    [anon_sym_GT_AMP] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(2394),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_LF] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1333),
  },
  [645] = {
    [sym_concatenation] = STATE(710),
    [sym_string] = STATE(1108),
    [sym_array] = STATE(710),
    [sym_simple_expansion] = STATE(1108),
    [sym_string_expansion] = STATE(1108),
    [sym_expansion] = STATE(1108),
    [sym_command_substitution] = STATE(1108),
    [sym_process_substitution] = STATE(1108),
    [sym__empty_value] = ACTIONS(1445),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [sym__special_characters] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(588),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(2398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1455),
    [anon_sym_BQUOTE] = ACTIONS(1457),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2398),
  },
  [646] = {
    [aux_sym_concatenation_repeat1] = STATE(1109),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [647] = {
    [sym_variable_assignment] = STATE(647),
    [sym_subscript] = STATE(257),
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(256),
    [sym_simple_expansion] = STATE(256),
    [sym_string_expansion] = STATE(256),
    [sym_expansion] = STATE(256),
    [sym_command_substitution] = STATE(256),
    [sym_process_substitution] = STATE(256),
    [aux_sym_declaration_command_repeat1] = STATE(647),
    [sym_variable_name] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1506),
    [anon_sym_SEMI_SEMI] = ACTIONS(1506),
    [anon_sym_PIPE_AMP] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [sym__special_characters] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1523),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [anon_sym_LT_LPAREN] = ACTIONS(1529),
    [anon_sym_GT_LPAREN] = ACTIONS(1529),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1532),
    [sym_word] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(1506),
    [anon_sym_LF] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1506),
  },
  [648] = {
    [aux_sym_concatenation_repeat1] = STATE(1110),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [649] = {
    [sym_concatenation] = STATE(649),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_unset_command_repeat1] = STATE(649),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_SEMI_SEMI] = ACTIONS(1587),
    [anon_sym_PIPE_AMP] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [sym__special_characters] = ACTIONS(2409),
    [anon_sym_DQUOTE] = ACTIONS(1592),
    [anon_sym_DOLLAR] = ACTIONS(1595),
    [sym_raw_string] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [anon_sym_LT_LPAREN] = ACTIONS(1610),
    [anon_sym_GT_LPAREN] = ACTIONS(1610),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1613),
    [sym_word] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_LF] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1587),
  },
  [650] = {
    [aux_sym_concatenation_repeat1] = STATE(650),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [651] = {
    [sym_compound_statement] = STATE(1111),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [652] = {
    [anon_sym_esac] = ACTIONS(2415),
    [anon_sym_PIPE] = ACTIONS(2415),
    [anon_sym_RPAREN] = ACTIONS(2415),
    [anon_sym_SEMI_SEMI] = ACTIONS(2415),
    [anon_sym_PIPE_AMP] = ACTIONS(2415),
    [anon_sym_AMP_AMP] = ACTIONS(2415),
    [anon_sym_PIPE_PIPE] = ACTIONS(2415),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2415),
    [anon_sym_LF] = ACTIONS(2417),
    [anon_sym_AMP] = ACTIONS(2415),
  },
  [653] = {
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(2034),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [654] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(2034),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [655] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(1113),
    [sym_simple_expansion] = STATE(1113),
    [sym_string_expansion] = STATE(1113),
    [sym_expansion] = STATE(1113),
    [sym_command_substitution] = STATE(1113),
    [sym_process_substitution] = STATE(1113),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(2421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2421),
  },
  [656] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(1283),
    [sym__heredoc_body_beginning] = ACTIONS(1283),
    [sym_file_descriptor] = ACTIONS(1283),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_AMP] = ACTIONS(1281),
    [anon_sym_GT_AMP] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1281),
    [anon_sym_LT_LT_LT] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1281),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LT_LPAREN] = ACTIONS(1281),
    [anon_sym_GT_LPAREN] = ACTIONS(1281),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1281),
  },
  [657] = {
    [aux_sym_concatenation_repeat1] = STATE(262),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [658] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(660),
    [sym__heredoc_body_beginning] = ACTIONS(660),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [659] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(2072),
    [sym__heredoc_body_beginning] = ACTIONS(2072),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [662] = {
    [sym_file_redirect] = STATE(662),
    [sym_heredoc_redirect] = STATE(662),
    [sym_herestring_redirect] = STATE(662),
    [aux_sym_while_statement_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(2084),
    [sym__heredoc_body_beginning] = ACTIONS(2084),
    [sym_file_descriptor] = ACTIONS(2423),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_AMP_GT] = ACTIONS(2426),
    [anon_sym_AMP_GT_GT] = ACTIONS(2426),
    [anon_sym_LT_AMP] = ACTIONS(2426),
    [anon_sym_GT_AMP] = ACTIONS(2426),
    [anon_sym_LT_LT] = ACTIONS(2094),
    [anon_sym_LT_LT_DASH] = ACTIONS(2094),
    [anon_sym_LT_LT_LT] = ACTIONS(2429),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [663] = {
    [sym_file_redirect] = STATE(662),
    [sym_heredoc_redirect] = STATE(662),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(662),
    [aux_sym_while_statement_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [664] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(273),
    [sym_simple_expansion] = STATE(273),
    [sym_string_expansion] = STATE(273),
    [sym_expansion] = STATE(273),
    [sym_command_substitution] = STATE(273),
    [sym_process_substitution] = STATE(273),
    [aux_sym_command_repeat2] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2118),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [anon_sym_LT_LPAREN] = ACTIONS(2124),
    [anon_sym_GT_LPAREN] = ACTIONS(2124),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [665] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(2441),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [666] = {
    [sym_file_redirect] = STATE(1116),
    [sym_heredoc_redirect] = STATE(1116),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(1116),
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(273),
    [sym_simple_expansion] = STATE(273),
    [sym_string_expansion] = STATE(273),
    [sym_expansion] = STATE(273),
    [sym_command_substitution] = STATE(273),
    [sym_process_substitution] = STATE(273),
    [aux_sym_while_statement_repeat1] = STATE(1116),
    [aux_sym_command_repeat2] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_EQ_TILDE] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(482),
    [anon_sym_DQUOTE] = ACTIONS(340),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(346),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(484),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [667] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [668] = {
    [aux_sym_concatenation_repeat1] = STATE(668),
    [sym__concat] = ACTIONS(2443),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [669] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_EQ_TILDE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1711),
  },
  [670] = {
    [sym_concatenation] = STATE(1120),
    [sym_string] = STATE(1119),
    [sym_simple_expansion] = STATE(1119),
    [sym_string_expansion] = STATE(1119),
    [sym_expansion] = STATE(1119),
    [sym_command_substitution] = STATE(1119),
    [sym_process_substitution] = STATE(1119),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [sym__special_characters] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2450),
  },
  [671] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_EQ_TILDE] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_RBRACK] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1752),
  },
  [672] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2452),
  },
  [673] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [674] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2456),
    [sym_comment] = ACTIONS(54),
  },
  [675] = {
    [sym_concatenation] = STATE(1126),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1126),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_EQ] = ACTIONS(2460),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2460),
    [anon_sym_COLON_QMARK] = ACTIONS(2460),
    [anon_sym_COLON_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [676] = {
    [sym_concatenation] = STATE(1129),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1129),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2468),
    [anon_sym_COLON_QMARK] = ACTIONS(2468),
    [anon_sym_COLON_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [677] = {
    [sym_concatenation] = STATE(1131),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1131),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_EQ] = ACTIONS(2474),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2478),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [678] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_RBRACK] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1818),
  },
  [679] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2480),
  },
  [680] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [681] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_EQ_TILDE] = ACTIONS(1826),
    [anon_sym_EQ_EQ] = ACTIONS(1826),
    [anon_sym_RBRACK] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1826),
  },
  [682] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2484),
  },
  [683] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [684] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_EQ_TILDE] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_RBRACK] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1964),
  },
  [685] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_EQ_TILDE] = ACTIONS(2028),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_RBRACK] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2028),
  },
  [686] = {
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_GT] = ACTIONS(2486),
    [anon_sym_AMP_GT_GT] = ACTIONS(2488),
    [anon_sym_LT_AMP] = ACTIONS(2488),
    [anon_sym_GT_AMP] = ACTIONS(2488),
    [sym_comment] = ACTIONS(54),
  },
  [687] = {
    [sym_concatenation] = STATE(1144),
    [sym_string] = STATE(1139),
    [sym_simple_expansion] = STATE(1139),
    [sym_string_expansion] = STATE(1139),
    [sym_expansion] = STATE(1139),
    [sym_command_substitution] = STATE(1139),
    [sym_process_substitution] = STATE(1139),
    [sym__special_characters] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2496),
  },
  [688] = {
    [sym_heredoc_start] = ACTIONS(2506),
    [sym_comment] = ACTIONS(54),
  },
  [689] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(1147),
    [sym_simple_expansion] = STATE(1147),
    [sym_string_expansion] = STATE(1147),
    [sym_expansion] = STATE(1147),
    [sym_command_substitution] = STATE(1147),
    [sym_process_substitution] = STATE(1147),
    [sym__special_characters] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2510),
  },
  [690] = {
    [sym_file_redirect] = STATE(1149),
    [sym_heredoc_redirect] = STATE(1149),
    [sym_herestring_redirect] = STATE(1149),
    [aux_sym_while_statement_repeat1] = STATE(1149),
    [sym_file_descriptor] = ACTIONS(1331),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(1339),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_LF] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
  },
  [691] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [692] = {
    [aux_sym_concatenation_repeat1] = STATE(692),
    [sym__concat] = ACTIONS(2516),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [693] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_EQ_TILDE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1711),
  },
  [694] = {
    [sym_concatenation] = STATE(1153),
    [sym_string] = STATE(1152),
    [sym_simple_expansion] = STATE(1152),
    [sym_string_expansion] = STATE(1152),
    [sym_expansion] = STATE(1152),
    [sym_command_substitution] = STATE(1152),
    [sym_process_substitution] = STATE(1152),
    [anon_sym_RBRACE] = ACTIONS(2519),
    [sym__special_characters] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2523),
  },
  [695] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_EQ_TILDE] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1752),
  },
  [696] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2525),
  },
  [697] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [698] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2529),
    [sym_comment] = ACTIONS(54),
  },
  [699] = {
    [sym_concatenation] = STATE(1159),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1159),
    [anon_sym_RBRACE] = ACTIONS(2531),
    [anon_sym_EQ] = ACTIONS(2533),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2535),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2537),
    [anon_sym_COLON] = ACTIONS(2533),
    [anon_sym_COLON_QMARK] = ACTIONS(2533),
    [anon_sym_COLON_DASH] = ACTIONS(2533),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [700] = {
    [sym_concatenation] = STATE(1162),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1162),
    [anon_sym_RBRACE] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2541),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2545),
    [anon_sym_COLON] = ACTIONS(2541),
    [anon_sym_COLON_QMARK] = ACTIONS(2541),
    [anon_sym_COLON_DASH] = ACTIONS(2541),
    [anon_sym_PERCENT] = ACTIONS(2541),
    [anon_sym_DASH] = ACTIONS(2541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [701] = {
    [sym_concatenation] = STATE(1164),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1164),
    [anon_sym_RBRACE] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(2547),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2551),
    [anon_sym_COLON] = ACTIONS(2547),
    [anon_sym_COLON_QMARK] = ACTIONS(2547),
    [anon_sym_COLON_DASH] = ACTIONS(2547),
    [anon_sym_PERCENT] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [702] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1818),
  },
  [703] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2553),
  },
  [704] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [705] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1824),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_EQ_TILDE] = ACTIONS(1826),
    [anon_sym_EQ_EQ] = ACTIONS(1826),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1826),
  },
  [706] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2557),
  },
  [707] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [708] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_EQ_TILDE] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1964),
  },
  [709] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_EQ_TILDE] = ACTIONS(2028),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2028),
  },
  [710] = {
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [711] = {
    [sym_concatenation] = STATE(1169),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1169),
    [anon_sym_RPAREN] = ACTIONS(2559),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [712] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1123),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [713] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [714] = {
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [715] = {
    [aux_sym_concatenation_repeat1] = STATE(715),
    [sym__concat] = ACTIONS(2561),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [716] = {
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [717] = {
    [sym_concatenation] = STATE(1173),
    [sym_string] = STATE(1172),
    [sym_simple_expansion] = STATE(1172),
    [sym_string_expansion] = STATE(1172),
    [sym_expansion] = STATE(1172),
    [sym_command_substitution] = STATE(1172),
    [sym_process_substitution] = STATE(1172),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [sym__special_characters] = ACTIONS(2566),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2568),
  },
  [718] = {
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [719] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2570),
  },
  [720] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [721] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2574),
    [sym_comment] = ACTIONS(54),
  },
  [722] = {
    [sym_concatenation] = STATE(1179),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1179),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(2578),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2578),
    [anon_sym_COLON_QMARK] = ACTIONS(2578),
    [anon_sym_COLON_DASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [723] = {
    [sym_concatenation] = STATE(1182),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1182),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_EQ] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_COLON_QMARK] = ACTIONS(2586),
    [anon_sym_COLON_DASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [724] = {
    [sym_concatenation] = STATE(1184),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1184),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(2592),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2596),
    [anon_sym_COLON] = ACTIONS(2592),
    [anon_sym_COLON_QMARK] = ACTIONS(2592),
    [anon_sym_COLON_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [725] = {
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [726] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2598),
  },
  [727] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [728] = {
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [729] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2602),
  },
  [730] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [731] = {
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [732] = {
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [733] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [734] = {
    [aux_sym_concatenation_repeat1] = STATE(734),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [735] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [736] = {
    [sym_concatenation] = STATE(1191),
    [sym_string] = STATE(1190),
    [sym_simple_expansion] = STATE(1190),
    [sym_string_expansion] = STATE(1190),
    [sym_expansion] = STATE(1190),
    [sym_command_substitution] = STATE(1190),
    [sym_process_substitution] = STATE(1190),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [sym__special_characters] = ACTIONS(2609),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2611),
  },
  [737] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [738] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2613),
  },
  [739] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [740] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2617),
    [sym_comment] = ACTIONS(54),
  },
  [741] = {
    [sym_concatenation] = STATE(1197),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1197),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(2621),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2625),
    [anon_sym_COLON] = ACTIONS(2621),
    [anon_sym_COLON_QMARK] = ACTIONS(2621),
    [anon_sym_COLON_DASH] = ACTIONS(2621),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [742] = {
    [sym_concatenation] = STATE(1200),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1200),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2633),
    [anon_sym_COLON] = ACTIONS(2629),
    [anon_sym_COLON_QMARK] = ACTIONS(2629),
    [anon_sym_COLON_DASH] = ACTIONS(2629),
    [anon_sym_PERCENT] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [743] = {
    [sym_concatenation] = STATE(1202),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1202),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_EQ] = ACTIONS(2635),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2635),
    [anon_sym_COLON_QMARK] = ACTIONS(2635),
    [anon_sym_COLON_DASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [744] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [745] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2641),
  },
  [746] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [747] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [748] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2645),
  },
  [749] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [750] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [751] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [752] = {
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [753] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(2647),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [754] = {
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_PIPE_AMP] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1709),
    [anon_sym_LT_AMP] = ACTIONS(1709),
    [anon_sym_GT_AMP] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1709),
  },
  [755] = {
    [sym_concatenation] = STATE(1209),
    [sym_string] = STATE(1208),
    [sym_simple_expansion] = STATE(1208),
    [sym_string_expansion] = STATE(1208),
    [sym_expansion] = STATE(1208),
    [sym_command_substitution] = STATE(1208),
    [sym_process_substitution] = STATE(1208),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [sym__special_characters] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2654),
  },
  [756] = {
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_PIPE_AMP] = ACTIONS(1750),
    [anon_sym_AMP_AMP] = ACTIONS(1750),
    [anon_sym_PIPE_PIPE] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1750),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1750),
    [anon_sym_LT_AMP] = ACTIONS(1750),
    [anon_sym_GT_AMP] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1750),
  },
  [757] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2656),
  },
  [758] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [759] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2660),
    [sym_comment] = ACTIONS(54),
  },
  [760] = {
    [sym_concatenation] = STATE(1215),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1215),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_EQ] = ACTIONS(2664),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2668),
    [anon_sym_COLON] = ACTIONS(2664),
    [anon_sym_COLON_QMARK] = ACTIONS(2664),
    [anon_sym_COLON_DASH] = ACTIONS(2664),
    [anon_sym_PERCENT] = ACTIONS(2664),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [761] = {
    [sym_concatenation] = STATE(1218),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1218),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_EQ] = ACTIONS(2672),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2676),
    [anon_sym_COLON] = ACTIONS(2672),
    [anon_sym_COLON_QMARK] = ACTIONS(2672),
    [anon_sym_COLON_DASH] = ACTIONS(2672),
    [anon_sym_PERCENT] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [762] = {
    [sym_concatenation] = STATE(1220),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1220),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_EQ] = ACTIONS(2678),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2682),
    [anon_sym_COLON] = ACTIONS(2678),
    [anon_sym_COLON_QMARK] = ACTIONS(2678),
    [anon_sym_COLON_DASH] = ACTIONS(2678),
    [anon_sym_PERCENT] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [763] = {
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_PIPE_AMP] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1816),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1816),
    [anon_sym_LT_AMP] = ACTIONS(1816),
    [anon_sym_GT_AMP] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1816),
  },
  [764] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2684),
  },
  [765] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [766] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1824),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1824),
    [anon_sym_LT_AMP] = ACTIONS(1824),
    [anon_sym_GT_AMP] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1824),
  },
  [767] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2688),
  },
  [768] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [769] = {
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1962),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2026),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2026),
    [anon_sym_LT_AMP] = ACTIONS(2026),
    [anon_sym_GT_AMP] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2026),
  },
  [771] = {
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [sym__string_content] = ACTIONS(2692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2690),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(166),
  },
  [772] = {
    [sym_concatenation] = STATE(1227),
    [sym_string] = STATE(1226),
    [sym_simple_expansion] = STATE(1226),
    [sym_string_expansion] = STATE(1226),
    [sym_expansion] = STATE(1226),
    [sym_command_substitution] = STATE(1226),
    [sym_process_substitution] = STATE(1226),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [sym__special_characters] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2698),
  },
  [773] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym__string_content] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
  },
  [774] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2700),
  },
  [775] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [776] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2704),
    [sym_comment] = ACTIONS(54),
  },
  [777] = {
    [sym_concatenation] = STATE(1233),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1233),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2712),
    [anon_sym_COLON] = ACTIONS(2708),
    [anon_sym_COLON_QMARK] = ACTIONS(2708),
    [anon_sym_COLON_DASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [778] = {
    [sym_concatenation] = STATE(1236),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1236),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_EQ] = ACTIONS(2716),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2720),
    [anon_sym_COLON] = ACTIONS(2716),
    [anon_sym_COLON_QMARK] = ACTIONS(2716),
    [anon_sym_COLON_DASH] = ACTIONS(2716),
    [anon_sym_PERCENT] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [779] = {
    [sym_concatenation] = STATE(1238),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1238),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(2722),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2726),
    [anon_sym_COLON] = ACTIONS(2722),
    [anon_sym_COLON_QMARK] = ACTIONS(2722),
    [anon_sym_COLON_DASH] = ACTIONS(2722),
    [anon_sym_PERCENT] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [780] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__string_content] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
  },
  [781] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2728),
  },
  [782] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [783] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym__string_content] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
  },
  [784] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2732),
  },
  [785] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [786] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym__string_content] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
  },
  [787] = {
    [aux_sym_concatenation_repeat1] = STATE(551),
    [sym__concat] = ACTIONS(2734),
    [anon_sym_RBRACK] = ACTIONS(2736),
    [sym_comment] = ACTIONS(54),
  },
  [788] = {
    [aux_sym_concatenation_repeat1] = STATE(551),
    [sym__concat] = ACTIONS(2738),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [sym_comment] = ACTIONS(54),
  },
  [789] = {
    [sym__concat] = ACTIONS(2742),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [sym_comment] = ACTIONS(54),
  },
  [790] = {
    [sym__simple_heredoc_body] = ACTIONS(2744),
    [sym__heredoc_body_beginning] = ACTIONS(2744),
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_EQ_TILDE] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2746),
    [anon_sym_LT_LT_LT] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [791] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(54),
  },
  [792] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(1251),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [793] = {
    [sym_string] = STATE(1253),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2756),
    [anon_sym_POUND] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2754),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2758),
    [anon_sym_STAR] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2754),
    [anon_sym_0] = ACTIONS(2760),
    [anon_sym__] = ACTIONS(2760),
  },
  [794] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(54),
  },
  [795] = {
    [sym_subscript] = STATE(1260),
    [sym_variable_name] = ACTIONS(2764),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_POUND] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2766),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_0] = ACTIONS(2772),
    [anon_sym__] = ACTIONS(2772),
  },
  [796] = {
    [sym_for_statement] = STATE(1261),
    [sym_while_statement] = STATE(1261),
    [sym_if_statement] = STATE(1261),
    [sym_case_statement] = STATE(1261),
    [sym_function_definition] = STATE(1261),
    [sym_subshell] = STATE(1261),
    [sym_pipeline] = STATE(1261),
    [sym_list] = STATE(1261),
    [sym_command] = STATE(1261),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1261),
    [sym_variable_assignment] = STATE(1262),
    [sym_declaration_command] = STATE(1261),
    [sym_unset_command] = STATE(1261),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [797] = {
    [sym_for_statement] = STATE(1263),
    [sym_while_statement] = STATE(1263),
    [sym_if_statement] = STATE(1263),
    [sym_case_statement] = STATE(1263),
    [sym_function_definition] = STATE(1263),
    [sym_subshell] = STATE(1263),
    [sym_pipeline] = STATE(1263),
    [sym_list] = STATE(1263),
    [sym_command] = STATE(1263),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(1263),
    [sym_variable_assignment] = STATE(1264),
    [sym_declaration_command] = STATE(1263),
    [sym_unset_command] = STATE(1263),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [798] = {
    [sym_for_statement] = STATE(1265),
    [sym_while_statement] = STATE(1265),
    [sym_if_statement] = STATE(1265),
    [sym_case_statement] = STATE(1265),
    [sym_function_definition] = STATE(1265),
    [sym_subshell] = STATE(1265),
    [sym_pipeline] = STATE(1265),
    [sym_list] = STATE(1265),
    [sym_command] = STATE(1265),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1265),
    [sym_variable_assignment] = STATE(1266),
    [sym_declaration_command] = STATE(1265),
    [sym_unset_command] = STATE(1265),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [799] = {
    [anon_sym_RBRACE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(54),
  },
  [800] = {
    [sym_string] = STATE(1267),
    [sym_simple_expansion] = STATE(1267),
    [sym_string_expansion] = STATE(1267),
    [sym_expansion] = STATE(1267),
    [sym_command_substitution] = STATE(1267),
    [sym_process_substitution] = STATE(1267),
    [sym__special_characters] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(2774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2774),
  },
  [801] = {
    [aux_sym_concatenation_repeat1] = STATE(1268),
    [sym__concat] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_POUND] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_COLON_QMARK] = ACTIONS(694),
    [anon_sym_COLON_DASH] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
  },
  [802] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_EQ] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_COLON_QMARK] = ACTIONS(698),
    [anon_sym_COLON_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
  },
  [803] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(2776),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [804] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_POUND] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_COLON] = ACTIONS(728),
    [anon_sym_COLON_QMARK] = ACTIONS(728),
    [anon_sym_COLON_DASH] = ACTIONS(728),
    [anon_sym_PERCENT] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
  },
  [805] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_COLON] = ACTIONS(732),
    [anon_sym_COLON_QMARK] = ACTIONS(732),
    [anon_sym_COLON_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
  },
  [806] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_POUND] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_COLON] = ACTIONS(736),
    [anon_sym_COLON_QMARK] = ACTIONS(736),
    [anon_sym_COLON_DASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
  },
  [807] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2778),
    [sym_comment] = ACTIONS(54),
  },
  [808] = {
    [sym_concatenation] = STATE(1273),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1273),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2782),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2786),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_COLON_QMARK] = ACTIONS(2782),
    [anon_sym_COLON_DASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [809] = {
    [sym_subscript] = STATE(1277),
    [sym_variable_name] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(2790),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_0] = ACTIONS(2794),
    [anon_sym__] = ACTIONS(2794),
  },
  [810] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_EQ] = ACTIONS(2798),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2802),
    [anon_sym_COLON] = ACTIONS(2798),
    [anon_sym_COLON_QMARK] = ACTIONS(2798),
    [anon_sym_COLON_DASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2798),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [811] = {
    [sym_concatenation] = STATE(1283),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1283),
    [anon_sym_RBRACE] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2810),
    [anon_sym_COLON] = ACTIONS(2806),
    [anon_sym_COLON_QMARK] = ACTIONS(2806),
    [anon_sym_COLON_DASH] = ACTIONS(2806),
    [anon_sym_PERCENT] = ACTIONS(2806),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [812] = {
    [sym_concatenation] = STATE(1285),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1285),
    [anon_sym_RBRACE] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(2814),
    [anon_sym_COLON_QMARK] = ACTIONS(2814),
    [anon_sym_COLON_DASH] = ACTIONS(2814),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_DASH] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [813] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [814] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [815] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(54),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [817] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [818] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [819] = {
    [sym__simple_heredoc_body] = ACTIONS(2822),
    [sym__heredoc_body_beginning] = ACTIONS(2822),
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_EQ_TILDE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2824),
    [anon_sym_LT_LT_LT] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [820] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2828),
    [sym__special_characters] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [sym_raw_string] = ACTIONS(2840),
    [anon_sym_POUND] = ACTIONS(2843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2846),
    [anon_sym_COLON] = ACTIONS(2828),
    [anon_sym_COLON_QMARK] = ACTIONS(2828),
    [anon_sym_COLON_DASH] = ACTIONS(2828),
    [anon_sym_PERCENT] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2849),
    [anon_sym_BQUOTE] = ACTIONS(2852),
    [anon_sym_LT_LPAREN] = ACTIONS(2855),
    [anon_sym_GT_LPAREN] = ACTIONS(2855),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2858),
  },
  [821] = {
    [sym_concatenation] = STATE(1290),
    [sym_string] = STATE(1289),
    [sym_simple_expansion] = STATE(1289),
    [sym_string_expansion] = STATE(1289),
    [sym_expansion] = STATE(1289),
    [sym_command_substitution] = STATE(1289),
    [sym_process_substitution] = STATE(1289),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [sym__special_characters] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(2863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2863),
  },
  [822] = {
    [sym__simple_heredoc_body] = ACTIONS(2865),
    [sym__heredoc_body_beginning] = ACTIONS(2865),
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_EQ_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2867),
    [anon_sym_LT_LT_LT] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [823] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2869),
  },
  [824] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [825] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [826] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2877),
  },
  [827] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [828] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(2881),
  },
  [829] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [830] = {
    [sym_concatenation] = STATE(1297),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1297),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(2885),
    [anon_sym_COLON_QMARK] = ACTIONS(2885),
    [anon_sym_COLON_DASH] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [831] = {
    [sym__simple_heredoc_body] = ACTIONS(2889),
    [sym__heredoc_body_beginning] = ACTIONS(2889),
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2891),
    [anon_sym_LT_LT_LT] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [832] = {
    [sym_concatenation] = STATE(1299),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1299),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2895),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_DASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [833] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1097),
  },
  [834] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1301),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [835] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [anon_sym_PIPE_AMP] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_AMP] = ACTIONS(1119),
    [anon_sym_GT_AMP] = ACTIONS(1119),
    [sym__special_characters] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1119),
    [anon_sym_GT_LPAREN] = ACTIONS(1119),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1119),
  },
  [836] = {
    [aux_sym_concatenation_repeat1] = STATE(1302),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1097),
  },
  [837] = {
    [sym_concatenation] = STATE(1303),
    [sym_string] = STATE(586),
    [sym_simple_expansion] = STATE(586),
    [sym_string_expansion] = STATE(586),
    [sym_expansion] = STATE(586),
    [sym_command_substitution] = STATE(586),
    [sym_process_substitution] = STATE(586),
    [aux_sym_for_statement_repeat1] = STATE(1303),
    [sym__special_characters] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(1149),
    [sym_raw_string] = ACTIONS(1151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1155),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_LT_LPAREN] = ACTIONS(1159),
    [anon_sym_GT_LPAREN] = ACTIONS(1159),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1151),
  },
  [838] = {
    [sym_do_group] = STATE(1305),
    [anon_sym_do] = ACTIONS(2901),
    [sym_comment] = ACTIONS(54),
  },
  [839] = {
    [sym__terminated_statement] = STATE(1307),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1307),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [840] = {
    [sym_file_redirect] = STATE(1309),
    [sym_heredoc_redirect] = STATE(1309),
    [sym_heredoc_body] = STATE(1308),
    [sym_herestring_redirect] = STATE(1309),
    [aux_sym_while_statement_repeat1] = STATE(1309),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_PIPE_AMP] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym_comment] = ACTIONS(54),
  },
  [841] = {
    [sym__terminated_statement] = STATE(1312),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_elif_clause] = STATE(1313),
    [sym_else_clause] = STATE(1311),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1312),
    [aux_sym_if_statement_repeat1] = STATE(1313),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2905),
    [anon_sym_elif] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [842] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2907),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LF] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2907),
  },
  [843] = {
    [anon_sym_in] = ACTIONS(2911),
    [sym_comment] = ACTIONS(54),
  },
  [844] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_LF] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2913),
  },
  [845] = {
    [anon_sym_in] = ACTIONS(2917),
    [sym_comment] = ACTIONS(54),
  },
  [846] = {
    [anon_sym_RPAREN] = ACTIONS(2919),
    [sym_comment] = ACTIONS(54),
  },
  [847] = {
    [sym__terminated_statement] = STATE(1320),
    [sym_for_statement] = STATE(633),
    [sym_while_statement] = STATE(633),
    [sym_if_statement] = STATE(633),
    [sym_case_statement] = STATE(633),
    [sym_function_definition] = STATE(633),
    [sym_subshell] = STATE(633),
    [sym_pipeline] = STATE(633),
    [sym_list] = STATE(633),
    [sym_command] = STATE(633),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(633),
    [sym_variable_assignment] = STATE(634),
    [sym_declaration_command] = STATE(633),
    [sym_unset_command] = STATE(633),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1320),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [848] = {
    [sym_file_redirect] = STATE(1323),
    [sym_file_descriptor] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2927),
    [anon_sym_AMP_GT] = ACTIONS(2925),
    [anon_sym_AMP_GT_GT] = ACTIONS(2927),
    [anon_sym_LT_AMP] = ACTIONS(2927),
    [anon_sym_GT_AMP] = ACTIONS(2927),
    [sym_comment] = ACTIONS(54),
  },
  [849] = {
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [sym_comment] = ACTIONS(54),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [851] = {
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_SEMI_SEMI] = ACTIONS(2933),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2933),
  },
  [852] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_SEMI_SEMI] = ACTIONS(2933),
    [anon_sym_PIPE_AMP] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(470),
    [anon_sym_PIPE_PIPE] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_LF] = ACTIONS(2935),
    [anon_sym_AMP] = ACTIONS(2933),
  },
  [853] = {
    [sym_file_redirect] = STATE(1330),
    [sym_heredoc_redirect] = STATE(1330),
    [sym_herestring_redirect] = STATE(1330),
    [aux_sym_while_statement_repeat1] = STATE(1330),
    [sym_file_descriptor] = ACTIONS(2937),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(2939),
    [anon_sym_GT] = ACTIONS(2939),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(2939),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [854] = {
    [sym_concatenation] = STATE(1331),
    [sym_string] = STATE(1334),
    [sym_array] = STATE(1331),
    [sym_simple_expansion] = STATE(1334),
    [sym_string_expansion] = STATE(1334),
    [sym_expansion] = STATE(1334),
    [sym_command_substitution] = STATE(1334),
    [sym_process_substitution] = STATE(1334),
    [sym__empty_value] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [sym__special_characters] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(2955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(816),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2955),
  },
  [855] = {
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(392),
    [anon_sym_PIPE_AMP] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(392),
    [anon_sym_PIPE_PIPE] = ACTIONS(392),
    [sym__special_characters] = ACTIONS(392),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(392),
    [anon_sym_LT_LPAREN] = ACTIONS(392),
    [anon_sym_GT_LPAREN] = ACTIONS(392),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
  },
  [856] = {
    [sym_string] = STATE(1335),
    [sym_simple_expansion] = STATE(1335),
    [sym_string_expansion] = STATE(1335),
    [sym_expansion] = STATE(1335),
    [sym_command_substitution] = STATE(1335),
    [sym_process_substitution] = STATE(1335),
    [sym__special_characters] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(816),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2957),
  },
  [857] = {
    [aux_sym_concatenation_repeat1] = STATE(1336),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
  },
  [858] = {
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_PIPE_AMP] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
  },
  [859] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [860] = {
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_PIPE_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
  },
  [861] = {
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_PIPE_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(730),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
  },
  [862] = {
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_PIPE_AMP] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
  },
  [863] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(2961),
    [sym_comment] = ACTIONS(54),
  },
  [864] = {
    [sym_concatenation] = STATE(1341),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1341),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2965),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2969),
    [anon_sym_COLON] = ACTIONS(2965),
    [anon_sym_COLON_QMARK] = ACTIONS(2965),
    [anon_sym_COLON_DASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [865] = {
    [sym_subscript] = STATE(1345),
    [sym_variable_name] = ACTIONS(2971),
    [anon_sym_DOLLAR] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_0] = ACTIONS(2977),
    [anon_sym__] = ACTIONS(2977),
  },
  [866] = {
    [sym_concatenation] = STATE(1348),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1348),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_EQ] = ACTIONS(2981),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2985),
    [anon_sym_COLON] = ACTIONS(2981),
    [anon_sym_COLON_QMARK] = ACTIONS(2981),
    [anon_sym_COLON_DASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [867] = {
    [sym_concatenation] = STATE(1351),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1351),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_EQ] = ACTIONS(2989),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(2991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2989),
    [anon_sym_COLON_QMARK] = ACTIONS(2989),
    [anon_sym_COLON_DASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [868] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [870] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(54),
  },
  [871] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [872] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [873] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [874] = {
    [sym_variable_assignment] = STATE(874),
    [sym_subscript] = STATE(447),
    [sym_concatenation] = STATE(874),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_declaration_command_repeat1] = STATE(874),
    [sym_variable_name] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1535),
    [anon_sym_PIPE_AMP] = ACTIONS(1535),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [sym__special_characters] = ACTIONS(3002),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3008),
    [sym_raw_string] = ACTIONS(3011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3017),
    [anon_sym_BQUOTE] = ACTIONS(3020),
    [anon_sym_LT_LPAREN] = ACTIONS(3023),
    [anon_sym_GT_LPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3026),
    [sym_word] = ACTIONS(3029),
  },
  [875] = {
    [sym_string] = STATE(1354),
    [sym_simple_expansion] = STATE(1354),
    [sym_string_expansion] = STATE(1354),
    [sym_expansion] = STATE(1354),
    [sym_command_substitution] = STATE(1354),
    [sym_process_substitution] = STATE(1354),
    [sym__special_characters] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(3032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3032),
  },
  [876] = {
    [aux_sym_concatenation_repeat1] = STATE(1355),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
  },
  [877] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_PIPE_AMP] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
  },
  [878] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [879] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_PIPE_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
  },
  [880] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_PIPE_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(730),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
  },
  [881] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_PIPE_AMP] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
  },
  [882] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3036),
    [sym_comment] = ACTIONS(54),
  },
  [883] = {
    [sym_concatenation] = STATE(1360),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1360),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_EQ] = ACTIONS(3040),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3044),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_COLON_QMARK] = ACTIONS(3040),
    [anon_sym_COLON_DASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [884] = {
    [sym_subscript] = STATE(1364),
    [sym_variable_name] = ACTIONS(3046),
    [anon_sym_DOLLAR] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3048),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_0] = ACTIONS(3052),
    [anon_sym__] = ACTIONS(3052),
  },
  [885] = {
    [sym_concatenation] = STATE(1367),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1367),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_EQ] = ACTIONS(3056),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_COLON_QMARK] = ACTIONS(3056),
    [anon_sym_COLON_DASH] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [886] = {
    [sym_concatenation] = STATE(1370),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1370),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_EQ] = ACTIONS(3064),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3068),
    [anon_sym_COLON] = ACTIONS(3064),
    [anon_sym_COLON_QMARK] = ACTIONS(3064),
    [anon_sym_COLON_DASH] = ACTIONS(3064),
    [anon_sym_PERCENT] = ACTIONS(3064),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [887] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [888] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [889] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(54),
  },
  [890] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [891] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3072),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [892] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3072),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [893] = {
    [sym_concatenation] = STATE(893),
    [sym_string] = STATE(452),
    [sym_simple_expansion] = STATE(452),
    [sym_string_expansion] = STATE(452),
    [sym_expansion] = STATE(452),
    [sym_command_substitution] = STATE(452),
    [sym_process_substitution] = STATE(452),
    [aux_sym_unset_command_repeat1] = STATE(893),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_RPAREN] = ACTIONS(1616),
    [anon_sym_PIPE_AMP] = ACTIONS(1616),
    [anon_sym_AMP_AMP] = ACTIONS(1616),
    [anon_sym_PIPE_PIPE] = ACTIONS(1616),
    [sym__special_characters] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3089),
    [anon_sym_BQUOTE] = ACTIONS(3092),
    [anon_sym_LT_LPAREN] = ACTIONS(3095),
    [anon_sym_GT_LPAREN] = ACTIONS(3095),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3098),
    [sym_word] = ACTIONS(3101),
  },
  [894] = {
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [895] = {
    [aux_sym_concatenation_repeat1] = STATE(895),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [896] = {
    [sym__simple_heredoc_body] = ACTIONS(1709),
    [sym__heredoc_body_beginning] = ACTIONS(1709),
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_PIPE_AMP] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_EQ_TILDE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1709),
    [anon_sym_LT_AMP] = ACTIONS(1709),
    [anon_sym_GT_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1709),
    [anon_sym_LT_LT_LT] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1711),
  },
  [897] = {
    [sym_concatenation] = STATE(1376),
    [sym_string] = STATE(1375),
    [sym_simple_expansion] = STATE(1375),
    [sym_string_expansion] = STATE(1375),
    [sym_expansion] = STATE(1375),
    [sym_command_substitution] = STATE(1375),
    [sym_process_substitution] = STATE(1375),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [sym__special_characters] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3111),
  },
  [898] = {
    [sym__simple_heredoc_body] = ACTIONS(1750),
    [sym__heredoc_body_beginning] = ACTIONS(1750),
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_PIPE_AMP] = ACTIONS(1750),
    [anon_sym_AMP_AMP] = ACTIONS(1750),
    [anon_sym_PIPE_PIPE] = ACTIONS(1750),
    [anon_sym_EQ_TILDE] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1750),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1750),
    [anon_sym_LT_AMP] = ACTIONS(1750),
    [anon_sym_GT_AMP] = ACTIONS(1750),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1750),
    [anon_sym_LT_LT_LT] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1752),
  },
  [899] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3113),
  },
  [900] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [901] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3117),
    [sym_comment] = ACTIONS(54),
  },
  [902] = {
    [sym_concatenation] = STATE(1382),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1382),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_COLON_QMARK] = ACTIONS(3121),
    [anon_sym_COLON_DASH] = ACTIONS(3121),
    [anon_sym_PERCENT] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [903] = {
    [sym_concatenation] = STATE(1385),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1385),
    [anon_sym_RBRACE] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3129),
    [anon_sym_COLON_QMARK] = ACTIONS(3129),
    [anon_sym_COLON_DASH] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [904] = {
    [sym_concatenation] = STATE(1387),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1387),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3135),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3139),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_DASH] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [905] = {
    [sym__simple_heredoc_body] = ACTIONS(1816),
    [sym__heredoc_body_beginning] = ACTIONS(1816),
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_PIPE_AMP] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1816),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1816),
    [anon_sym_LT_AMP] = ACTIONS(1816),
    [anon_sym_GT_AMP] = ACTIONS(1816),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1816),
    [anon_sym_LT_LT_LT] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1818),
  },
  [906] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3141),
  },
  [907] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [908] = {
    [sym__simple_heredoc_body] = ACTIONS(1824),
    [sym__heredoc_body_beginning] = ACTIONS(1824),
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [anon_sym_EQ_TILDE] = ACTIONS(1826),
    [anon_sym_EQ_EQ] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1824),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1824),
    [anon_sym_LT_AMP] = ACTIONS(1824),
    [anon_sym_GT_AMP] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1824),
    [anon_sym_LT_LT_LT] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1826),
  },
  [909] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3145),
  },
  [910] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [911] = {
    [sym__simple_heredoc_body] = ACTIONS(1962),
    [sym__heredoc_body_beginning] = ACTIONS(1962),
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_EQ_TILDE] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1962),
    [anon_sym_LT_LT_LT] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1964),
  },
  [912] = {
    [sym__simple_heredoc_body] = ACTIONS(2026),
    [sym__heredoc_body_beginning] = ACTIONS(2026),
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_EQ_TILDE] = ACTIONS(2028),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2026),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2026),
    [anon_sym_LT_AMP] = ACTIONS(2026),
    [anon_sym_GT_AMP] = ACTIONS(2026),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2026),
    [anon_sym_LT_LT_LT] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2028),
  },
  [913] = {
    [sym_compound_statement] = STATE(1391),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [914] = {
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_PIPE_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2032),
    [anon_sym_PIPE_PIPE] = ACTIONS(2032),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(54),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_PIPE_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2032),
    [anon_sym_PIPE_PIPE] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [916] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2036),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(2036),
    [anon_sym_PIPE_PIPE] = ACTIONS(2036),
    [sym_comment] = ACTIONS(54),
  },
  [917] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(2036),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(2036),
    [anon_sym_PIPE_PIPE] = ACTIONS(2036),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [918] = {
    [anon_sym_PIPE] = ACTIONS(2042),
    [anon_sym_RPAREN] = ACTIONS(2044),
    [anon_sym_PIPE_AMP] = ACTIONS(2044),
    [anon_sym_AMP_AMP] = ACTIONS(2044),
    [anon_sym_PIPE_PIPE] = ACTIONS(2044),
    [anon_sym_BQUOTE] = ACTIONS(2044),
    [sym_comment] = ACTIONS(54),
  },
  [919] = {
    [sym_simple_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [aux_sym_heredoc_body_repeat1] = STATE(972),
    [sym__heredoc_body_middle] = ACTIONS(958),
    [sym__heredoc_body_end] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(964),
    [sym_comment] = ACTIONS(54),
  },
  [920] = {
    [sym_concatenation] = STATE(1395),
    [sym_string] = STATE(1394),
    [sym_simple_expansion] = STATE(1394),
    [sym_string_expansion] = STATE(1394),
    [sym_expansion] = STATE(1394),
    [sym_command_substitution] = STATE(1394),
    [sym_process_substitution] = STATE(1394),
    [sym__special_characters] = ACTIONS(3149),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(3151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3151),
  },
  [921] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(1283),
    [sym__heredoc_body_beginning] = ACTIONS(1283),
    [sym_file_descriptor] = ACTIONS(1283),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_LT_LT_LT] = ACTIONS(1283),
    [sym__special_characters] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [anon_sym_LT_LPAREN] = ACTIONS(1283),
    [anon_sym_GT_LPAREN] = ACTIONS(1283),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1281),
  },
  [922] = {
    [aux_sym_concatenation_repeat1] = STATE(460),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_LT_LT_LT] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [923] = {
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_LT_LT_LT] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(660),
    [sym__heredoc_body_beginning] = ACTIONS(660),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(660),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(660),
    [anon_sym_LT_AMP] = ACTIONS(660),
    [anon_sym_GT_AMP] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(660),
    [anon_sym_LT_LT_LT] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [925] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [926] = {
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [927] = {
    [sym__simple_heredoc_body] = ACTIONS(2068),
    [sym__heredoc_body_beginning] = ACTIONS(2068),
    [sym_file_descriptor] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(2070),
    [anon_sym_GT_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT_GT] = ACTIONS(2068),
    [anon_sym_LT_AMP] = ACTIONS(2068),
    [anon_sym_GT_AMP] = ACTIONS(2068),
    [anon_sym_LT_LT] = ACTIONS(2070),
    [anon_sym_LT_LT_DASH] = ACTIONS(2068),
    [anon_sym_LT_LT_LT] = ACTIONS(2068),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(54),
  },
  [928] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(2072),
    [sym__heredoc_body_beginning] = ACTIONS(2072),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(54),
  },
  [929] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [930] = {
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [931] = {
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(54),
  },
  [932] = {
    [sym_file_redirect] = STATE(932),
    [sym_heredoc_redirect] = STATE(932),
    [sym_herestring_redirect] = STATE(932),
    [aux_sym_while_statement_repeat1] = STATE(932),
    [sym__simple_heredoc_body] = ACTIONS(2084),
    [sym__heredoc_body_beginning] = ACTIONS(2084),
    [sym_file_descriptor] = ACTIONS(3153),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_RPAREN] = ACTIONS(2084),
    [anon_sym_PIPE_AMP] = ACTIONS(2084),
    [anon_sym_AMP_AMP] = ACTIONS(2084),
    [anon_sym_PIPE_PIPE] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_GT_GT] = ACTIONS(3159),
    [anon_sym_AMP_GT] = ACTIONS(3156),
    [anon_sym_AMP_GT_GT] = ACTIONS(3159),
    [anon_sym_LT_AMP] = ACTIONS(3159),
    [anon_sym_GT_AMP] = ACTIONS(3159),
    [anon_sym_LT_LT] = ACTIONS(3162),
    [anon_sym_LT_LT_DASH] = ACTIONS(3165),
    [anon_sym_LT_LT_LT] = ACTIONS(3168),
    [sym_comment] = ACTIONS(54),
  },
  [933] = {
    [sym_file_redirect] = STATE(932),
    [sym_heredoc_redirect] = STATE(932),
    [sym_heredoc_body] = STATE(1397),
    [sym_herestring_redirect] = STATE(932),
    [aux_sym_while_statement_repeat1] = STATE(932),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym_comment] = ACTIONS(54),
  },
  [934] = {
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(489),
    [sym_simple_expansion] = STATE(489),
    [sym_string_expansion] = STATE(489),
    [sym_expansion] = STATE(489),
    [sym_command_substitution] = STATE(489),
    [sym_process_substitution] = STATE(489),
    [aux_sym_command_repeat2] = STATE(934),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_EQ_TILDE] = ACTIONS(3171),
    [anon_sym_EQ_EQ] = ACTIONS(3171),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_LT_LT_LT] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3186),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3189),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_LT_LPAREN] = ACTIONS(3195),
    [anon_sym_GT_LPAREN] = ACTIONS(3195),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3198),
  },
  [935] = {
    [sym_file_redirect] = STATE(1398),
    [sym_heredoc_redirect] = STATE(1398),
    [sym_heredoc_body] = STATE(1397),
    [sym_herestring_redirect] = STATE(1398),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(489),
    [sym_simple_expansion] = STATE(489),
    [sym_string_expansion] = STATE(489),
    [sym_expansion] = STATE(489),
    [sym_command_substitution] = STATE(489),
    [sym_process_substitution] = STATE(489),
    [aux_sym_while_statement_repeat1] = STATE(1398),
    [aux_sym_command_repeat2] = STATE(934),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_EQ_TILDE] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym__special_characters] = ACTIONS(894),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(898),
  },
  [936] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_AMP] = ACTIONS(1119),
    [anon_sym_GT_AMP] = ACTIONS(1119),
    [sym__special_characters] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1119),
    [anon_sym_GT_LPAREN] = ACTIONS(1119),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1119),
  },
  [937] = {
    [aux_sym_concatenation_repeat1] = STATE(1399),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1097),
  },
  [938] = {
    [sym_file_redirect] = STATE(1400),
    [sym_heredoc_redirect] = STATE(1400),
    [sym_heredoc_body] = STATE(1308),
    [sym_herestring_redirect] = STATE(1400),
    [aux_sym_while_statement_repeat1] = STATE(1400),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(54),
  },
  [939] = {
    [anon_sym_RPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(54),
  },
  [940] = {
    [sym_file_redirect] = STATE(1323),
    [sym_file_descriptor] = ACTIONS(3203),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_GT] = ACTIONS(3205),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_AMP_GT] = ACTIONS(3205),
    [anon_sym_AMP_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_AMP] = ACTIONS(3207),
    [anon_sym_GT_AMP] = ACTIONS(3207),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_comment] = ACTIONS(54),
  },
  [941] = {
    [sym_file_redirect] = STATE(1407),
    [sym_heredoc_redirect] = STATE(1407),
    [sym_herestring_redirect] = STATE(1407),
    [aux_sym_while_statement_repeat1] = STATE(1407),
    [sym_file_descriptor] = ACTIONS(3209),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_GT] = ACTIONS(3211),
    [anon_sym_GT_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT] = ACTIONS(3211),
    [anon_sym_AMP_GT_GT] = ACTIONS(3213),
    [anon_sym_LT_AMP] = ACTIONS(3213),
    [anon_sym_GT_AMP] = ACTIONS(3213),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(3215),
    [anon_sym_BQUOTE] = ACTIONS(1341),
    [sym_comment] = ACTIONS(54),
  },
  [942] = {
    [sym_concatenation] = STATE(1331),
    [sym_string] = STATE(1409),
    [sym_array] = STATE(1331),
    [sym_simple_expansion] = STATE(1409),
    [sym_string_expansion] = STATE(1409),
    [sym_expansion] = STATE(1409),
    [sym_command_substitution] = STATE(1409),
    [sym_process_substitution] = STATE(1409),
    [sym__empty_value] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [sym__special_characters] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(808),
    [sym_raw_string] = ACTIONS(3219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(814),
    [anon_sym_BQUOTE] = ACTIONS(816),
    [anon_sym_LT_LPAREN] = ACTIONS(818),
    [anon_sym_GT_LPAREN] = ACTIONS(818),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3219),
  },
  [943] = {
    [aux_sym_concatenation_repeat1] = STATE(1410),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
  },
  [944] = {
    [sym_variable_assignment] = STATE(944),
    [sym_subscript] = STATE(503),
    [sym_concatenation] = STATE(944),
    [sym_string] = STATE(502),
    [sym_simple_expansion] = STATE(502),
    [sym_string_expansion] = STATE(502),
    [sym_expansion] = STATE(502),
    [sym_command_substitution] = STATE(502),
    [sym_process_substitution] = STATE(502),
    [aux_sym_declaration_command_repeat1] = STATE(944),
    [sym_variable_name] = ACTIONS(3221),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_PIPE_AMP] = ACTIONS(1535),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [sym__special_characters] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3008),
    [sym_raw_string] = ACTIONS(3227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3017),
    [anon_sym_BQUOTE] = ACTIONS(3020),
    [anon_sym_LT_LPAREN] = ACTIONS(3023),
    [anon_sym_GT_LPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3026),
    [sym_word] = ACTIONS(3230),
  },
  [945] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
  },
  [946] = {
    [sym_concatenation] = STATE(946),
    [sym_string] = STATE(506),
    [sym_simple_expansion] = STATE(506),
    [sym_string_expansion] = STATE(506),
    [sym_expansion] = STATE(506),
    [sym_command_substitution] = STATE(506),
    [sym_process_substitution] = STATE(506),
    [aux_sym_unset_command_repeat1] = STATE(946),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_PIPE_AMP] = ACTIONS(1616),
    [anon_sym_AMP_AMP] = ACTIONS(1616),
    [anon_sym_PIPE_PIPE] = ACTIONS(1616),
    [sym__special_characters] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym_raw_string] = ACTIONS(3236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3089),
    [anon_sym_BQUOTE] = ACTIONS(3092),
    [anon_sym_LT_LPAREN] = ACTIONS(3095),
    [anon_sym_GT_LPAREN] = ACTIONS(3095),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3098),
    [sym_word] = ACTIONS(3239),
  },
  [947] = {
    [aux_sym_concatenation_repeat1] = STATE(947),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1662),
  },
  [948] = {
    [sym_compound_statement] = STATE(1412),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [949] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_PIPE_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2032),
    [anon_sym_PIPE_PIPE] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [950] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(2036),
    [anon_sym_PIPE_PIPE] = ACTIONS(2036),
    [anon_sym_BQUOTE] = ACTIONS(2036),
    [sym_comment] = ACTIONS(54),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(2036),
    [anon_sym_PIPE_PIPE] = ACTIONS(2036),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [952] = {
    [sym_concatenation] = STATE(1395),
    [sym_string] = STATE(1414),
    [sym_simple_expansion] = STATE(1414),
    [sym_string_expansion] = STATE(1414),
    [sym_expansion] = STATE(1414),
    [sym_command_substitution] = STATE(1414),
    [sym_process_substitution] = STATE(1414),
    [sym__special_characters] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(3244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3244),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(1283),
    [sym__heredoc_body_beginning] = ACTIONS(1283),
    [sym_file_descriptor] = ACTIONS(1283),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_LT_LT_LT] = ACTIONS(1283),
    [sym__special_characters] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [anon_sym_LT_LPAREN] = ACTIONS(1283),
    [anon_sym_GT_LPAREN] = ACTIONS(1283),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1281),
  },
  [954] = {
    [aux_sym_concatenation_repeat1] = STATE(508),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_LT_LT_LT] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [anon_sym_LT_LPAREN] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1287),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1285),
  },
  [955] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(660),
    [sym__heredoc_body_beginning] = ACTIONS(660),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(660),
    [anon_sym_LT_AMP] = ACTIONS(660),
    [anon_sym_GT_AMP] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(660),
    [anon_sym_LT_LT_LT] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [956] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [957] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(2072),
    [sym__heredoc_body_beginning] = ACTIONS(2072),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [anon_sym_BQUOTE] = ACTIONS(2072),
    [sym_comment] = ACTIONS(54),
  },
  [958] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [959] = {
    [sym_file_redirect] = STATE(959),
    [sym_heredoc_redirect] = STATE(959),
    [sym_herestring_redirect] = STATE(959),
    [aux_sym_while_statement_repeat1] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(2084),
    [sym__heredoc_body_beginning] = ACTIONS(2084),
    [sym_file_descriptor] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2084),
    [anon_sym_AMP_AMP] = ACTIONS(2084),
    [anon_sym_PIPE_PIPE] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_GT] = ACTIONS(3249),
    [anon_sym_GT_GT] = ACTIONS(3252),
    [anon_sym_AMP_GT] = ACTIONS(3249),
    [anon_sym_AMP_GT_GT] = ACTIONS(3252),
    [anon_sym_LT_AMP] = ACTIONS(3252),
    [anon_sym_GT_AMP] = ACTIONS(3252),
    [anon_sym_LT_LT] = ACTIONS(3162),
    [anon_sym_LT_LT_DASH] = ACTIONS(3165),
    [anon_sym_LT_LT_LT] = ACTIONS(3255),
    [anon_sym_BQUOTE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(54),
  },
  [960] = {
    [sym_file_redirect] = STATE(959),
    [sym_heredoc_redirect] = STATE(959),
    [sym_heredoc_body] = STATE(1397),
    [sym_herestring_redirect] = STATE(959),
    [aux_sym_while_statement_repeat1] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(54),
  },
  [961] = {
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(517),
    [sym_simple_expansion] = STATE(517),
    [sym_string_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [aux_sym_command_repeat2] = STATE(961),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_EQ_TILDE] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_LT_LT_LT] = ACTIONS(1287),
    [sym__special_characters] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3186),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3189),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_LT_LPAREN] = ACTIONS(3195),
    [anon_sym_GT_LPAREN] = ACTIONS(3195),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3267),
  },
  [962] = {
    [sym_file_redirect] = STATE(1416),
    [sym_heredoc_redirect] = STATE(1416),
    [sym_heredoc_body] = STATE(1397),
    [sym_herestring_redirect] = STATE(1416),
    [sym_concatenation] = STATE(491),
    [sym_string] = STATE(517),
    [sym_simple_expansion] = STATE(517),
    [sym_string_expansion] = STATE(517),
    [sym_expansion] = STATE(517),
    [sym_command_substitution] = STATE(517),
    [sym_process_substitution] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(1416),
    [aux_sym_command_repeat2] = STATE(961),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_EQ_TILDE] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [sym__special_characters] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(942),
  },
  [963] = {
    [sym_file_redirect] = STATE(1417),
    [sym_file_descriptor] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_SEMI_SEMI] = ACTIONS(2380),
    [anon_sym_PIPE_AMP] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LF] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2380),
  },
  [964] = {
    [sym__heredoc_body_middle] = ACTIONS(726),
    [sym__heredoc_body_end] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
  },
  [965] = {
    [sym__heredoc_body_middle] = ACTIONS(734),
    [sym__heredoc_body_end] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
  },
  [966] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3270),
    [sym_comment] = ACTIONS(54),
  },
  [967] = {
    [sym_concatenation] = STATE(1421),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1421),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_EQ] = ACTIONS(3274),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3278),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_COLON_QMARK] = ACTIONS(3274),
    [anon_sym_COLON_DASH] = ACTIONS(3274),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [968] = {
    [sym_subscript] = STATE(1425),
    [sym_variable_name] = ACTIONS(3280),
    [anon_sym_DOLLAR] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3282),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3284),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_AT] = ACTIONS(3282),
    [anon_sym_QMARK] = ACTIONS(3282),
    [anon_sym_0] = ACTIONS(3286),
    [anon_sym__] = ACTIONS(3286),
  },
  [969] = {
    [sym_concatenation] = STATE(1428),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1428),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3290),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3294),
    [anon_sym_COLON] = ACTIONS(3290),
    [anon_sym_COLON_QMARK] = ACTIONS(3290),
    [anon_sym_COLON_DASH] = ACTIONS(3290),
    [anon_sym_PERCENT] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [970] = {
    [sym_concatenation] = STATE(1431),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1431),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(3298),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3298),
    [anon_sym_COLON_QMARK] = ACTIONS(3298),
    [anon_sym_COLON_DASH] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [971] = {
    [anon_sym_esac] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_RPAREN] = ACTIONS(3304),
    [anon_sym_SEMI_SEMI] = ACTIONS(3304),
    [anon_sym_PIPE_AMP] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_LF] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3304),
  },
  [972] = {
    [sym_simple_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [aux_sym_heredoc_body_repeat1] = STATE(972),
    [sym__heredoc_body_middle] = ACTIONS(3308),
    [sym__heredoc_body_end] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3316),
    [sym_comment] = ACTIONS(54),
  },
  [973] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1079),
    [sym__heredoc_body_beginning] = ACTIONS(1079),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(976),
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [975] = {
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [976] = {
    [aux_sym_concatenation_repeat1] = STATE(1432),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [977] = {
    [anon_sym_esac] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [anon_sym_SEMI_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE_AMP] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [978] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_AMP] = ACTIONS(1119),
    [anon_sym_GT_AMP] = ACTIONS(1119),
    [sym__special_characters] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1119),
    [anon_sym_GT_LPAREN] = ACTIONS(1119),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1119),
  },
  [979] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1097),
  },
  [980] = {
    [sym_file_redirect] = STATE(544),
    [sym_heredoc_redirect] = STATE(544),
    [sym_heredoc_body] = STATE(1433),
    [sym_herestring_redirect] = STATE(544),
    [aux_sym_while_statement_repeat1] = STATE(544),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_SEMI_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE_AMP] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(332),
    [anon_sym_AMP_GT] = ACTIONS(332),
    [anon_sym_AMP_GT_GT] = ACTIONS(332),
    [anon_sym_LT_AMP] = ACTIONS(332),
    [anon_sym_GT_AMP] = ACTIONS(332),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(336),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [981] = {
    [sym__concat] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_PLUS_EQ] = ACTIONS(3325),
    [sym_comment] = ACTIONS(54),
  },
  [982] = {
    [anon_sym_EQ] = ACTIONS(3325),
    [anon_sym_PLUS_EQ] = ACTIONS(3325),
    [sym_comment] = ACTIONS(54),
  },
  [983] = {
    [aux_sym_concatenation_repeat1] = STATE(983),
    [sym__concat] = ACTIONS(2443),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [984] = {
    [sym__concat] = ACTIONS(3327),
    [anon_sym_EQ] = ACTIONS(3329),
    [anon_sym_PLUS_EQ] = ACTIONS(3329),
    [sym_comment] = ACTIONS(54),
  },
  [985] = {
    [anon_sym_EQ] = ACTIONS(3329),
    [anon_sym_PLUS_EQ] = ACTIONS(3329),
    [sym_comment] = ACTIONS(54),
  },
  [986] = {
    [sym_string] = STATE(1436),
    [sym_simple_expansion] = STATE(1436),
    [sym_string_expansion] = STATE(1436),
    [sym_expansion] = STATE(1436),
    [sym_command_substitution] = STATE(1436),
    [sym_process_substitution] = STATE(1436),
    [sym__special_characters] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(3331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3331),
  },
  [987] = {
    [aux_sym_concatenation_repeat1] = STATE(1437),
    [sym__concat] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(692),
  },
  [988] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_RPAREN] = ACTIONS(696),
    [sym__special_characters] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(696),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [anon_sym_LT_LPAREN] = ACTIONS(696),
    [anon_sym_GT_LPAREN] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(696),
  },
  [989] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [990] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(726),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(726),
    [anon_sym_GT_LPAREN] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(726),
  },
  [991] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_RPAREN] = ACTIONS(730),
    [sym__special_characters] = ACTIONS(730),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [anon_sym_LT_LPAREN] = ACTIONS(730),
    [anon_sym_GT_LPAREN] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(730),
  },
  [992] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_RPAREN] = ACTIONS(734),
    [sym__special_characters] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_LT_LPAREN] = ACTIONS(734),
    [anon_sym_GT_LPAREN] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(734),
  },
  [993] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3335),
    [sym_comment] = ACTIONS(54),
  },
  [994] = {
    [sym_concatenation] = STATE(1442),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1442),
    [anon_sym_RBRACE] = ACTIONS(3337),
    [anon_sym_EQ] = ACTIONS(3339),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3343),
    [anon_sym_COLON] = ACTIONS(3339),
    [anon_sym_COLON_QMARK] = ACTIONS(3339),
    [anon_sym_COLON_DASH] = ACTIONS(3339),
    [anon_sym_PERCENT] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [995] = {
    [sym_subscript] = STATE(1446),
    [sym_variable_name] = ACTIONS(3345),
    [anon_sym_DOLLAR] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3347),
    [anon_sym_0] = ACTIONS(3351),
    [anon_sym__] = ACTIONS(3351),
  },
  [996] = {
    [sym_concatenation] = STATE(1449),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1449),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_EQ] = ACTIONS(3355),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3359),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_COLON_QMARK] = ACTIONS(3355),
    [anon_sym_COLON_DASH] = ACTIONS(3355),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [997] = {
    [sym_concatenation] = STATE(1452),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1452),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_EQ] = ACTIONS(3363),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3367),
    [anon_sym_COLON] = ACTIONS(3363),
    [anon_sym_COLON_QMARK] = ACTIONS(3363),
    [anon_sym_COLON_DASH] = ACTIONS(3363),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [998] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3369),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3369),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1000] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_comment] = ACTIONS(54),
  },
  [1001] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1002] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1003] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1004] = {
    [sym_file_descriptor] = ACTIONS(3373),
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_SEMI_SEMI] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3375),
    [anon_sym_LT_AMP] = ACTIONS(3375),
    [anon_sym_GT_AMP] = ACTIONS(3375),
    [sym__special_characters] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3375),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_LT_LPAREN] = ACTIONS(3375),
    [anon_sym_GT_LPAREN] = ACTIONS(3375),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [1005] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [sym__special_characters] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [anon_sym_DOLLAR] = ACTIONS(3385),
    [sym_raw_string] = ACTIONS(3388),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3394),
    [anon_sym_BQUOTE] = ACTIONS(3397),
    [anon_sym_LT_LPAREN] = ACTIONS(3400),
    [anon_sym_GT_LPAREN] = ACTIONS(3400),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3388),
  },
  [1006] = {
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1007] = {
    [aux_sym_concatenation_repeat1] = STATE(1007),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3403),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1008] = {
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [1009] = {
    [sym_concatenation] = STATE(1458),
    [sym_string] = STATE(1457),
    [sym_simple_expansion] = STATE(1457),
    [sym_string_expansion] = STATE(1457),
    [sym_expansion] = STATE(1457),
    [sym_command_substitution] = STATE(1457),
    [sym_process_substitution] = STATE(1457),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [sym__special_characters] = ACTIONS(3408),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3410),
  },
  [1010] = {
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [1011] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3412),
  },
  [1012] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3414),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1013] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3416),
    [sym_comment] = ACTIONS(54),
  },
  [1014] = {
    [sym_concatenation] = STATE(1464),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1464),
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3420),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3424),
    [anon_sym_COLON] = ACTIONS(3420),
    [anon_sym_COLON_QMARK] = ACTIONS(3420),
    [anon_sym_COLON_DASH] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1015] = {
    [sym_concatenation] = STATE(1467),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1467),
    [anon_sym_RBRACE] = ACTIONS(3426),
    [anon_sym_EQ] = ACTIONS(3428),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3432),
    [anon_sym_COLON] = ACTIONS(3428),
    [anon_sym_COLON_QMARK] = ACTIONS(3428),
    [anon_sym_COLON_DASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1016] = {
    [sym_concatenation] = STATE(1469),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1469),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(3434),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3438),
    [anon_sym_COLON] = ACTIONS(3434),
    [anon_sym_COLON_QMARK] = ACTIONS(3434),
    [anon_sym_COLON_DASH] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3434),
    [anon_sym_DASH] = ACTIONS(3434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1017] = {
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [1018] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3440),
  },
  [1019] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1020] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [1021] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3444),
  },
  [1022] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1023] = {
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [1024] = {
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [1025] = {
    [sym_string] = STATE(1473),
    [sym_simple_expansion] = STATE(1473),
    [sym_string_expansion] = STATE(1473),
    [sym_expansion] = STATE(1473),
    [sym_command_substitution] = STATE(1473),
    [sym_process_substitution] = STATE(1473),
    [sym__special_characters] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_DOLLAR] = ACTIONS(1149),
    [sym_raw_string] = ACTIONS(3446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1153),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1155),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_LT_LPAREN] = ACTIONS(1159),
    [anon_sym_GT_LPAREN] = ACTIONS(1159),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3446),
  },
  [1026] = {
    [aux_sym_concatenation_repeat1] = STATE(1474),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1027] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [1028] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(3448),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1029] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [1030] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [1031] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [1032] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3450),
    [sym_comment] = ACTIONS(54),
  },
  [1033] = {
    [sym_concatenation] = STATE(1479),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1479),
    [anon_sym_RBRACE] = ACTIONS(3452),
    [anon_sym_EQ] = ACTIONS(3454),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3454),
    [anon_sym_COLON_QMARK] = ACTIONS(3454),
    [anon_sym_COLON_DASH] = ACTIONS(3454),
    [anon_sym_PERCENT] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1034] = {
    [sym_subscript] = STATE(1483),
    [sym_variable_name] = ACTIONS(3460),
    [anon_sym_DOLLAR] = ACTIONS(3462),
    [anon_sym_DASH] = ACTIONS(3462),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3464),
    [anon_sym_STAR] = ACTIONS(3462),
    [anon_sym_AT] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(3462),
    [anon_sym_0] = ACTIONS(3466),
    [anon_sym__] = ACTIONS(3466),
  },
  [1035] = {
    [sym_concatenation] = STATE(1486),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1486),
    [anon_sym_RBRACE] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3470),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3472),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_COLON_QMARK] = ACTIONS(3470),
    [anon_sym_COLON_DASH] = ACTIONS(3470),
    [anon_sym_PERCENT] = ACTIONS(3470),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1036] = {
    [sym_concatenation] = STATE(1489),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1489),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3478),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3482),
    [anon_sym_COLON] = ACTIONS(3478),
    [anon_sym_COLON_QMARK] = ACTIONS(3478),
    [anon_sym_COLON_DASH] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1037] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3484),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1038] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3484),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1039] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [sym_comment] = ACTIONS(54),
  },
  [1040] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1041] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1042] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1043] = {
    [sym_do_group] = STATE(1492),
    [anon_sym_do] = ACTIONS(1161),
    [sym_comment] = ACTIONS(54),
  },
  [1044] = {
    [sym_concatenation] = STATE(1044),
    [sym_string] = STATE(586),
    [sym_simple_expansion] = STATE(586),
    [sym_string_expansion] = STATE(586),
    [sym_expansion] = STATE(586),
    [sym_command_substitution] = STATE(586),
    [sym_process_substitution] = STATE(586),
    [aux_sym_for_statement_repeat1] = STATE(1044),
    [anon_sym_SEMI_SEMI] = ACTIONS(3488),
    [sym__special_characters] = ACTIONS(3490),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_DOLLAR] = ACTIONS(3496),
    [sym_raw_string] = ACTIONS(3499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3505),
    [anon_sym_BQUOTE] = ACTIONS(3508),
    [anon_sym_LT_LPAREN] = ACTIONS(3511),
    [anon_sym_GT_LPAREN] = ACTIONS(3511),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3488),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3488),
  },
  [1045] = {
    [anon_sym_esac] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_RPAREN] = ACTIONS(2271),
    [anon_sym_SEMI_SEMI] = ACTIONS(2271),
    [anon_sym_PIPE_AMP] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_LF] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2271),
  },
  [1046] = {
    [sym__terminated_statement] = STATE(1049),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1049),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(3514),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1047] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_done] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [1048] = {
    [sym__simple_heredoc_body] = ACTIONS(3516),
    [sym__heredoc_body_beginning] = ACTIONS(3516),
    [sym_file_descriptor] = ACTIONS(3516),
    [anon_sym_esac] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3518),
    [anon_sym_SEMI_SEMI] = ACTIONS(3518),
    [anon_sym_PIPE_AMP] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_LT] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3518),
    [anon_sym_GT_GT] = ACTIONS(3518),
    [anon_sym_AMP_GT] = ACTIONS(3518),
    [anon_sym_AMP_GT_GT] = ACTIONS(3518),
    [anon_sym_LT_AMP] = ACTIONS(3518),
    [anon_sym_GT_AMP] = ACTIONS(3518),
    [anon_sym_LT_LT] = ACTIONS(3518),
    [anon_sym_LT_LT_DASH] = ACTIONS(3518),
    [anon_sym_LT_LT_LT] = ACTIONS(3518),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym_LF] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
  },
  [1049] = {
    [sym__terminated_statement] = STATE(1049),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1049),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_done] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [1050] = {
    [anon_sym_esac] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3522),
    [anon_sym_PIPE_AMP] = ACTIONS(3522),
    [anon_sym_AMP_AMP] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE] = ACTIONS(3522),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_LF] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1051] = {
    [anon_sym_then] = ACTIONS(3526),
    [sym_comment] = ACTIONS(54),
  },
  [1052] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LF] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3528),
  },
  [1053] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LF] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3528),
  },
  [1054] = {
    [sym__terminated_statement] = STATE(1496),
    [sym_for_statement] = STATE(1052),
    [sym_while_statement] = STATE(1052),
    [sym_if_statement] = STATE(1052),
    [sym_case_statement] = STATE(1052),
    [sym_function_definition] = STATE(1052),
    [sym_subshell] = STATE(1052),
    [sym_pipeline] = STATE(1052),
    [sym_list] = STATE(1052),
    [sym_command] = STATE(1052),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(1052),
    [sym_variable_assignment] = STATE(1053),
    [sym_declaration_command] = STATE(1052),
    [sym_unset_command] = STATE(1052),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1496),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3532),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1055] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_fi] = ACTIONS(952),
    [anon_sym_elif] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [1056] = {
    [anon_sym_esac] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(3534),
    [anon_sym_RPAREN] = ACTIONS(3534),
    [anon_sym_SEMI_SEMI] = ACTIONS(3534),
    [anon_sym_PIPE_AMP] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_LF] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3534),
  },
  [1057] = {
    [anon_sym_fi] = ACTIONS(3538),
    [sym_comment] = ACTIONS(54),
  },
  [1058] = {
    [sym__terminated_statement] = STATE(1058),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1058),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_fi] = ACTIONS(3520),
    [anon_sym_elif] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [1059] = {
    [sym_elif_clause] = STATE(1060),
    [sym_else_clause] = STATE(1498),
    [aux_sym_if_statement_repeat1] = STATE(1060),
    [anon_sym_fi] = ACTIONS(3538),
    [anon_sym_elif] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [sym_comment] = ACTIONS(54),
  },
  [1060] = {
    [sym_elif_clause] = STATE(1060),
    [aux_sym_if_statement_repeat1] = STATE(1060),
    [anon_sym_fi] = ACTIONS(3540),
    [anon_sym_elif] = ACTIONS(3542),
    [anon_sym_else] = ACTIONS(3540),
    [sym_comment] = ACTIONS(54),
  },
  [1061] = {
    [anon_sym_esac] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_RPAREN] = ACTIONS(3545),
    [anon_sym_SEMI_SEMI] = ACTIONS(3545),
    [anon_sym_PIPE_AMP] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3545),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_LF] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3545),
  },
  [1062] = {
    [aux_sym_case_item_repeat1] = STATE(1501),
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(54),
  },
  [1063] = {
    [aux_sym_case_item_repeat1] = STATE(1504),
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(54),
  },
  [1064] = {
    [anon_sym_esac] = ACTIONS(3555),
    [sym_comment] = ACTIONS(54),
  },
  [1065] = {
    [aux_sym_case_item_repeat1] = STATE(1504),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(54),
  },
  [1066] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(1506),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1067] = {
    [sym_case_item] = STATE(1509),
    [sym_last_case_item] = STATE(1506),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1509),
    [anon_sym_esac] = ACTIONS(3557),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1068] = {
    [anon_sym_esac] = ACTIONS(3559),
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(3559),
    [anon_sym_SEMI_SEMI] = ACTIONS(3559),
    [anon_sym_PIPE_AMP] = ACTIONS(3559),
    [anon_sym_AMP_AMP] = ACTIONS(3559),
    [anon_sym_PIPE_PIPE] = ACTIONS(3559),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_LF] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3559),
  },
  [1069] = {
    [anon_sym_esac] = ACTIONS(3563),
    [sym_comment] = ACTIONS(54),
  },
  [1070] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(1511),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1071] = {
    [sym_case_item] = STATE(1513),
    [sym_last_case_item] = STATE(1511),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1513),
    [anon_sym_esac] = ACTIONS(3565),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1072] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [1073] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [sym_comment] = ACTIONS(54),
  },
  [1074] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [sym_comment] = ACTIONS(54),
  },
  [1075] = {
    [anon_sym_RBRACE] = ACTIONS(3569),
    [sym_comment] = ACTIONS(54),
  },
  [1076] = {
    [sym_concatenation] = STATE(1517),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1517),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [anon_sym_EQ] = ACTIONS(3573),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3573),
    [anon_sym_COLON_QMARK] = ACTIONS(3573),
    [anon_sym_COLON_DASH] = ACTIONS(3573),
    [anon_sym_PERCENT] = ACTIONS(3573),
    [anon_sym_DASH] = ACTIONS(3573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1077] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_in] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [1078] = {
    [sym_concatenation] = STATE(1520),
    [sym_string] = STATE(1519),
    [sym_simple_expansion] = STATE(1519),
    [sym_string_expansion] = STATE(1519),
    [sym_expansion] = STATE(1519),
    [sym_command_substitution] = STATE(1519),
    [sym_process_substitution] = STATE(1519),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [sym__special_characters] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3579),
  },
  [1079] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [1080] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3581),
  },
  [1081] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1082] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1083] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3585),
  },
  [1084] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1085] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3589),
  },
  [1086] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1087] = {
    [sym_concatenation] = STATE(1527),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1527),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_EQ] = ACTIONS(3593),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3593),
    [anon_sym_COLON_QMARK] = ACTIONS(3593),
    [anon_sym_COLON_DASH] = ACTIONS(3593),
    [anon_sym_PERCENT] = ACTIONS(3593),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1088] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [1089] = {
    [sym_concatenation] = STATE(1529),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1529),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_EQ] = ACTIONS(3599),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3599),
    [anon_sym_COLON_QMARK] = ACTIONS(3599),
    [anon_sym_COLON_DASH] = ACTIONS(3599),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1090] = {
    [sym_file_redirect] = STATE(1530),
    [sym_file_descriptor] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_SEMI_SEMI] = ACTIONS(3603),
    [anon_sym_PIPE_AMP] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_LF] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3603),
  },
  [1091] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [1092] = {
    [sym_file_descriptor] = ACTIONS(3607),
    [anon_sym_esac] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3609),
    [anon_sym_AMP_GT] = ACTIONS(3609),
    [anon_sym_AMP_GT_GT] = ACTIONS(3609),
    [anon_sym_LT_AMP] = ACTIONS(3609),
    [anon_sym_GT_AMP] = ACTIONS(3609),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LF] = ACTIONS(3607),
    [anon_sym_AMP] = ACTIONS(3609),
  },
  [1093] = {
    [sym__terminated_statement] = STATE(1093),
    [sym_for_statement] = STATE(633),
    [sym_while_statement] = STATE(633),
    [sym_if_statement] = STATE(633),
    [sym_case_statement] = STATE(633),
    [sym_function_definition] = STATE(633),
    [sym_subshell] = STATE(633),
    [sym_pipeline] = STATE(633),
    [sym_list] = STATE(633),
    [sym_command] = STATE(633),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(633),
    [sym_variable_assignment] = STATE(634),
    [sym_declaration_command] = STATE(633),
    [sym_unset_command] = STATE(633),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1093),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [1094] = {
    [sym_concatenation] = STATE(1533),
    [sym_string] = STATE(1532),
    [sym_simple_expansion] = STATE(1532),
    [sym_string_expansion] = STATE(1532),
    [sym_expansion] = STATE(1532),
    [sym_command_substitution] = STATE(1532),
    [sym_process_substitution] = STATE(1532),
    [sym__special_characters] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(3613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(1545),
    [anon_sym_GT_LPAREN] = ACTIONS(1545),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3613),
  },
  [1095] = {
    [aux_sym_concatenation_repeat1] = STATE(1534),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [1096] = {
    [aux_sym_concatenation_repeat1] = STATE(1534),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1097] = {
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1098] = {
    [aux_sym_concatenation_repeat1] = STATE(1535),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(1121),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1099] = {
    [sym_file_redirect] = STATE(662),
    [sym_heredoc_redirect] = STATE(662),
    [sym_heredoc_body] = STATE(1050),
    [sym_herestring_redirect] = STATE(662),
    [aux_sym_while_statement_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2279),
  },
  [1100] = {
    [sym_compound_statement] = STATE(1536),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [1101] = {
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_GT_GT] = ACTIONS(3617),
    [anon_sym_AMP_GT] = ACTIONS(3615),
    [anon_sym_AMP_GT_GT] = ACTIONS(3617),
    [anon_sym_LT_AMP] = ACTIONS(3617),
    [anon_sym_GT_AMP] = ACTIONS(3617),
    [sym_comment] = ACTIONS(54),
  },
  [1102] = {
    [sym_concatenation] = STATE(1097),
    [sym_string] = STATE(1539),
    [sym_simple_expansion] = STATE(1539),
    [sym_string_expansion] = STATE(1539),
    [sym_expansion] = STATE(1539),
    [sym_command_substitution] = STATE(1539),
    [sym_process_substitution] = STATE(1539),
    [sym__special_characters] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(3621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(1545),
    [anon_sym_GT_LPAREN] = ACTIONS(1545),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3621),
  },
  [1103] = {
    [anon_sym_LT] = ACTIONS(3623),
    [anon_sym_GT] = ACTIONS(3623),
    [anon_sym_GT_GT] = ACTIONS(3625),
    [anon_sym_AMP_GT] = ACTIONS(3623),
    [anon_sym_AMP_GT_GT] = ACTIONS(3625),
    [anon_sym_LT_AMP] = ACTIONS(3625),
    [anon_sym_GT_AMP] = ACTIONS(3625),
    [sym_comment] = ACTIONS(54),
  },
  [1104] = {
    [sym_concatenation] = STATE(1144),
    [sym_string] = STATE(1542),
    [sym_simple_expansion] = STATE(1542),
    [sym_string_expansion] = STATE(1542),
    [sym_expansion] = STATE(1542),
    [sym_command_substitution] = STATE(1542),
    [sym_process_substitution] = STATE(1542),
    [sym__special_characters] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(3629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3629),
  },
  [1105] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(1544),
    [sym_simple_expansion] = STATE(1544),
    [sym_string_expansion] = STATE(1544),
    [sym_expansion] = STATE(1544),
    [sym_command_substitution] = STATE(1544),
    [sym_process_substitution] = STATE(1544),
    [sym__special_characters] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(3633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3633),
  },
  [1106] = {
    [sym_file_redirect] = STATE(1545),
    [sym_heredoc_redirect] = STATE(1545),
    [sym_herestring_redirect] = STATE(1545),
    [aux_sym_while_statement_repeat1] = STATE(1545),
    [sym_file_descriptor] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2392),
    [anon_sym_AMP_GT] = ACTIONS(2392),
    [anon_sym_AMP_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_AMP] = ACTIONS(2392),
    [anon_sym_GT_AMP] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(2394),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_LF] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
  },
  [1107] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1123),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [1108] = {
    [aux_sym_concatenation_repeat1] = STATE(646),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1109] = {
    [aux_sym_concatenation_repeat1] = STATE(1109),
    [sym__concat] = ACTIONS(2561),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1110] = {
    [aux_sym_concatenation_repeat1] = STATE(1110),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1111] = {
    [sym_file_redirect] = STATE(1417),
    [sym_file_descriptor] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2380),
    [anon_sym_SEMI_SEMI] = ACTIONS(2380),
    [anon_sym_PIPE_AMP] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_AMP] = ACTIONS(2388),
    [anon_sym_GT_AMP] = ACTIONS(2388),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LF] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2380),
  },
  [1112] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(1079),
    [sym__heredoc_body_beginning] = ACTIONS(1079),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [1113] = {
    [aux_sym_concatenation_repeat1] = STATE(1114),
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1114] = {
    [aux_sym_concatenation_repeat1] = STATE(1546),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(212),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1115] = {
    [anon_sym_esac] = ACTIONS(3635),
    [anon_sym_PIPE] = ACTIONS(3635),
    [anon_sym_RPAREN] = ACTIONS(3635),
    [anon_sym_SEMI_SEMI] = ACTIONS(3635),
    [anon_sym_PIPE_AMP] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3635),
    [anon_sym_PIPE_PIPE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_LF] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3635),
  },
  [1116] = {
    [sym_file_redirect] = STATE(662),
    [sym_heredoc_redirect] = STATE(662),
    [sym_heredoc_body] = STATE(1433),
    [sym_herestring_redirect] = STATE(662),
    [aux_sym_while_statement_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [anon_sym_SEMI_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE_AMP] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_AMP_GT] = ACTIONS(478),
    [anon_sym_AMP_GT_GT] = ACTIONS(478),
    [anon_sym_LT_AMP] = ACTIONS(478),
    [anon_sym_GT_AMP] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(480),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [1117] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_EQ_TILDE] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2746),
    [anon_sym_RBRACK] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2746),
  },
  [1118] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [sym_comment] = ACTIONS(54),
  },
  [1119] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [sym_comment] = ACTIONS(54),
  },
  [1120] = {
    [anon_sym_RBRACE] = ACTIONS(3641),
    [sym_comment] = ACTIONS(54),
  },
  [1121] = {
    [sym_concatenation] = STATE(1550),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1550),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(3645),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_COLON_QMARK] = ACTIONS(3645),
    [anon_sym_COLON_DASH] = ACTIONS(3645),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1122] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_EQ_TILDE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2824),
  },
  [1123] = {
    [sym_concatenation] = STATE(1553),
    [sym_string] = STATE(1552),
    [sym_simple_expansion] = STATE(1552),
    [sym_string_expansion] = STATE(1552),
    [sym_expansion] = STATE(1552),
    [sym_command_substitution] = STATE(1552),
    [sym_process_substitution] = STATE(1552),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [sym__special_characters] = ACTIONS(3649),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3651),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3651),
  },
  [1124] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_EQ_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2867),
  },
  [1125] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3653),
  },
  [1126] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3655),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1127] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2875),
  },
  [1128] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3657),
  },
  [1129] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1130] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3661),
  },
  [1131] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1132] = {
    [sym_concatenation] = STATE(1560),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1560),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(3665),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3665),
    [anon_sym_COLON_QMARK] = ACTIONS(3665),
    [anon_sym_COLON_DASH] = ACTIONS(3665),
    [anon_sym_PERCENT] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1133] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_RBRACK] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2891),
  },
  [1134] = {
    [sym_concatenation] = STATE(1562),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1562),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_EQ] = ACTIONS(3671),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3671),
    [anon_sym_COLON_QMARK] = ACTIONS(3671),
    [anon_sym_COLON_DASH] = ACTIONS(3671),
    [anon_sym_PERCENT] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1135] = {
    [sym_concatenation] = STATE(1565),
    [sym_string] = STATE(1564),
    [sym_simple_expansion] = STATE(1564),
    [sym_string_expansion] = STATE(1564),
    [sym_expansion] = STATE(1564),
    [sym_command_substitution] = STATE(1564),
    [sym_process_substitution] = STATE(1564),
    [sym__special_characters] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(3677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3677),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [1137] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(1569),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1138] = {
    [sym_string] = STATE(1571),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(3683),
    [sym_raw_string] = ACTIONS(3685),
    [anon_sym_POUND] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3683),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3687),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_AT] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3683),
    [anon_sym_0] = ACTIONS(3689),
    [anon_sym__] = ACTIONS(3689),
  },
  [1139] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1140] = {
    [sym_subscript] = STATE(1577),
    [sym_variable_name] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_POUND] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3693),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AT] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_0] = ACTIONS(3699),
    [anon_sym__] = ACTIONS(3699),
  },
  [1141] = {
    [sym_for_statement] = STATE(1578),
    [sym_while_statement] = STATE(1578),
    [sym_if_statement] = STATE(1578),
    [sym_case_statement] = STATE(1578),
    [sym_function_definition] = STATE(1578),
    [sym_subshell] = STATE(1578),
    [sym_pipeline] = STATE(1578),
    [sym_list] = STATE(1578),
    [sym_command] = STATE(1578),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1578),
    [sym_variable_assignment] = STATE(1579),
    [sym_declaration_command] = STATE(1578),
    [sym_unset_command] = STATE(1578),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1142] = {
    [sym_for_statement] = STATE(1580),
    [sym_while_statement] = STATE(1580),
    [sym_if_statement] = STATE(1580),
    [sym_case_statement] = STATE(1580),
    [sym_function_definition] = STATE(1580),
    [sym_subshell] = STATE(1580),
    [sym_pipeline] = STATE(1580),
    [sym_list] = STATE(1580),
    [sym_command] = STATE(1580),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(1580),
    [sym_variable_assignment] = STATE(1581),
    [sym_declaration_command] = STATE(1580),
    [sym_unset_command] = STATE(1580),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [1143] = {
    [sym_for_statement] = STATE(1582),
    [sym_while_statement] = STATE(1582),
    [sym_if_statement] = STATE(1582),
    [sym_case_statement] = STATE(1582),
    [sym_function_definition] = STATE(1582),
    [sym_subshell] = STATE(1582),
    [sym_pipeline] = STATE(1582),
    [sym_list] = STATE(1582),
    [sym_command] = STATE(1582),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(1582),
    [sym_variable_assignment] = STATE(1583),
    [sym_declaration_command] = STATE(1582),
    [sym_unset_command] = STATE(1582),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1144] = {
    [sym_file_descriptor] = ACTIONS(676),
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1145] = {
    [sym_file_descriptor] = ACTIONS(2068),
    [anon_sym_esac] = ACTIONS(2070),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_SEMI_SEMI] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(2070),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2070),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_LF] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2070),
  },
  [1146] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [1147] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [1148] = {
    [sym_file_descriptor] = ACTIONS(2076),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [1149] = {
    [sym_file_redirect] = STATE(1149),
    [sym_heredoc_redirect] = STATE(1149),
    [sym_herestring_redirect] = STATE(1149),
    [aux_sym_while_statement_repeat1] = STATE(1149),
    [sym_file_descriptor] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3704),
    [anon_sym_AMP_GT] = ACTIONS(3704),
    [anon_sym_AMP_GT_GT] = ACTIONS(3704),
    [anon_sym_LT_AMP] = ACTIONS(3704),
    [anon_sym_GT_AMP] = ACTIONS(3704),
    [anon_sym_LT_LT] = ACTIONS(3707),
    [anon_sym_LT_LT_DASH] = ACTIONS(3707),
    [anon_sym_LT_LT_LT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [1150] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_EQ_TILDE] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2746),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2746),
  },
  [1151] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [sym_comment] = ACTIONS(54),
  },
  [1152] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [sym_comment] = ACTIONS(54),
  },
  [1153] = {
    [anon_sym_RBRACE] = ACTIONS(3715),
    [sym_comment] = ACTIONS(54),
  },
  [1154] = {
    [sym_concatenation] = STATE(1587),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1587),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3719),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_COLON_QMARK] = ACTIONS(3719),
    [anon_sym_COLON_DASH] = ACTIONS(3719),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1155] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_EQ_TILDE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2824),
  },
  [1156] = {
    [sym_concatenation] = STATE(1590),
    [sym_string] = STATE(1589),
    [sym_simple_expansion] = STATE(1589),
    [sym_string_expansion] = STATE(1589),
    [sym_expansion] = STATE(1589),
    [sym_command_substitution] = STATE(1589),
    [sym_process_substitution] = STATE(1589),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [sym__special_characters] = ACTIONS(3723),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3725),
  },
  [1157] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_EQ_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2867),
  },
  [1158] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3727),
  },
  [1159] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3729),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1160] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2875),
  },
  [1161] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3731),
  },
  [1162] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1163] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3735),
  },
  [1164] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1165] = {
    [sym_concatenation] = STATE(1597),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1597),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(3739),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3739),
    [anon_sym_COLON_QMARK] = ACTIONS(3739),
    [anon_sym_COLON_DASH] = ACTIONS(3739),
    [anon_sym_PERCENT] = ACTIONS(3739),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1166] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2889),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2891),
  },
  [1167] = {
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1599),
    [anon_sym_RBRACE] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3745),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3747),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_COLON_QMARK] = ACTIONS(3745),
    [anon_sym_COLON_DASH] = ACTIONS(3745),
    [anon_sym_PERCENT] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1168] = {
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_PIPE_AMP] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2147),
    [sym_word] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [1169] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [1170] = {
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [1171] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3751),
    [sym_comment] = ACTIONS(54),
  },
  [1172] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [sym_comment] = ACTIONS(54),
  },
  [1173] = {
    [anon_sym_RBRACE] = ACTIONS(3753),
    [sym_comment] = ACTIONS(54),
  },
  [1174] = {
    [sym_concatenation] = STATE(1604),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1604),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_EQ] = ACTIONS(3757),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3757),
    [anon_sym_COLON_QMARK] = ACTIONS(3757),
    [anon_sym_COLON_DASH] = ACTIONS(3757),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1175] = {
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [1176] = {
    [sym_concatenation] = STATE(1607),
    [sym_string] = STATE(1606),
    [sym_simple_expansion] = STATE(1606),
    [sym_string_expansion] = STATE(1606),
    [sym_expansion] = STATE(1606),
    [sym_command_substitution] = STATE(1606),
    [sym_process_substitution] = STATE(1606),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [sym__special_characters] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3763),
  },
  [1177] = {
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [1178] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3765),
  },
  [1179] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1180] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1181] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3769),
  },
  [1182] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1183] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3773),
  },
  [1184] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1185] = {
    [sym_concatenation] = STATE(1614),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1614),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3777),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3777),
    [anon_sym_COLON_QMARK] = ACTIONS(3777),
    [anon_sym_COLON_DASH] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3777),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1186] = {
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [1187] = {
    [sym_concatenation] = STATE(1616),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1616),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3783),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3783),
    [anon_sym_COLON_QMARK] = ACTIONS(3783),
    [anon_sym_COLON_DASH] = ACTIONS(3783),
    [anon_sym_PERCENT] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1188] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [1189] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3787),
    [sym_comment] = ACTIONS(54),
  },
  [1190] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [sym_comment] = ACTIONS(54),
  },
  [1191] = {
    [anon_sym_RBRACE] = ACTIONS(3789),
    [sym_comment] = ACTIONS(54),
  },
  [1192] = {
    [sym_concatenation] = STATE(1620),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1620),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_EQ] = ACTIONS(3793),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_COLON_QMARK] = ACTIONS(3793),
    [anon_sym_COLON_DASH] = ACTIONS(3793),
    [anon_sym_PERCENT] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1193] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [1194] = {
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1622),
    [sym_simple_expansion] = STATE(1622),
    [sym_string_expansion] = STATE(1622),
    [sym_expansion] = STATE(1622),
    [sym_command_substitution] = STATE(1622),
    [sym_process_substitution] = STATE(1622),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [sym__special_characters] = ACTIONS(3797),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3799),
  },
  [1195] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [1196] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3801),
  },
  [1197] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1198] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1199] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3805),
  },
  [1200] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3807),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1201] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3809),
  },
  [1202] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1203] = {
    [sym_concatenation] = STATE(1630),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1630),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(3813),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1204] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [1205] = {
    [sym_concatenation] = STATE(1632),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1632),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_EQ] = ACTIONS(3819),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_COLON_QMARK] = ACTIONS(3819),
    [anon_sym_COLON_DASH] = ACTIONS(3819),
    [anon_sym_PERCENT] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1206] = {
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2744),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2744),
    [anon_sym_LT_AMP] = ACTIONS(2744),
    [anon_sym_GT_AMP] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2744),
  },
  [1207] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [sym_comment] = ACTIONS(54),
  },
  [1208] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [sym_comment] = ACTIONS(54),
  },
  [1209] = {
    [anon_sym_RBRACE] = ACTIONS(3825),
    [sym_comment] = ACTIONS(54),
  },
  [1210] = {
    [sym_concatenation] = STATE(1636),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1636),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(3829),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(3829),
    [anon_sym_COLON_DASH] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1211] = {
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2822),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2822),
    [anon_sym_LT_AMP] = ACTIONS(2822),
    [anon_sym_GT_AMP] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2822),
  },
  [1212] = {
    [sym_concatenation] = STATE(1639),
    [sym_string] = STATE(1638),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [sym_process_substitution] = STATE(1638),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [sym__special_characters] = ACTIONS(3833),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3835),
  },
  [1213] = {
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_PIPE_AMP] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2865),
    [anon_sym_LT_AMP] = ACTIONS(2865),
    [anon_sym_GT_AMP] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2865),
  },
  [1214] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3837),
  },
  [1215] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1216] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2873),
  },
  [1217] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3841),
  },
  [1218] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1219] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3845),
  },
  [1220] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1221] = {
    [sym_concatenation] = STATE(1646),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1646),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(3849),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3849),
    [anon_sym_COLON_QMARK] = ACTIONS(3849),
    [anon_sym_COLON_DASH] = ACTIONS(3849),
    [anon_sym_PERCENT] = ACTIONS(3849),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1222] = {
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2889),
    [anon_sym_LT_AMP] = ACTIONS(2889),
    [anon_sym_GT_AMP] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2889),
  },
  [1223] = {
    [sym_concatenation] = STATE(1648),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1648),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [anon_sym_EQ] = ACTIONS(3855),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3855),
    [anon_sym_COLON_QMARK] = ACTIONS(3855),
    [anon_sym_COLON_DASH] = ACTIONS(3855),
    [anon_sym_PERCENT] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1224] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym__string_content] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
  },
  [1225] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [sym_comment] = ACTIONS(54),
  },
  [1226] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [sym_comment] = ACTIONS(54),
  },
  [1227] = {
    [anon_sym_RBRACE] = ACTIONS(3861),
    [sym_comment] = ACTIONS(54),
  },
  [1228] = {
    [sym_concatenation] = STATE(1652),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1652),
    [anon_sym_RBRACE] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3865),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3865),
    [anon_sym_COLON_QMARK] = ACTIONS(3865),
    [anon_sym_COLON_DASH] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1229] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym__string_content] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
  },
  [1230] = {
    [sym_concatenation] = STATE(1655),
    [sym_string] = STATE(1654),
    [sym_simple_expansion] = STATE(1654),
    [sym_string_expansion] = STATE(1654),
    [sym_expansion] = STATE(1654),
    [sym_command_substitution] = STATE(1654),
    [sym_process_substitution] = STATE(1654),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [sym__special_characters] = ACTIONS(3869),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3871),
  },
  [1231] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym__string_content] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
  },
  [1232] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3873),
  },
  [1233] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1234] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym__string_content] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
  },
  [1235] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3877),
  },
  [1236] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1237] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3881),
  },
  [1238] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1239] = {
    [sym_concatenation] = STATE(1662),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1662),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_EQ] = ACTIONS(3885),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_DASH] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1240] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym__string_content] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
  },
  [1241] = {
    [sym_concatenation] = STATE(1664),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1664),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3891),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(3891),
    [anon_sym_COLON_QMARK] = ACTIONS(3891),
    [anon_sym_COLON_DASH] = ACTIONS(3891),
    [anon_sym_PERCENT] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1242] = {
    [sym_string] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [sym_process_substitution] = STATE(667),
    [anon_sym_RBRACK] = ACTIONS(3895),
    [sym__special_characters] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1289),
  },
  [1243] = {
    [sym__concat] = ACTIONS(3897),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_EQ] = ACTIONS(3899),
    [sym__special_characters] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [sym_raw_string] = ACTIONS(2137),
    [anon_sym_POUND] = ACTIONS(2137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2137),
    [aux_sym_SLASH] = ACTIONS(2137),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2137),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [anon_sym_LT_LPAREN] = ACTIONS(2137),
    [anon_sym_GT_LPAREN] = ACTIONS(2137),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3899),
  },
  [1244] = {
    [sym_string] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [sym_process_substitution] = STATE(667),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [sym__special_characters] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1289),
  },
  [1245] = {
    [sym__concat] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_EQ] = ACTIONS(3905),
    [sym__special_characters] = ACTIONS(3905),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_DOLLAR] = ACTIONS(3905),
    [sym_raw_string] = ACTIONS(2143),
    [anon_sym_POUND] = ACTIONS(2143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2143),
    [aux_sym_SLASH] = ACTIONS(2143),
    [anon_sym_COLON] = ACTIONS(3905),
    [anon_sym_COLON_QMARK] = ACTIONS(3905),
    [anon_sym_COLON_DASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_LT_LPAREN] = ACTIONS(2143),
    [anon_sym_GT_LPAREN] = ACTIONS(2143),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3905),
  },
  [1246] = {
    [anon_sym_RBRACK] = ACTIONS(3901),
    [sym_comment] = ACTIONS(54),
  },
  [1247] = {
    [sym_string] = STATE(1669),
    [sym_simple_expansion] = STATE(1669),
    [sym_string_expansion] = STATE(1669),
    [sym_expansion] = STATE(1669),
    [sym_command_substitution] = STATE(1669),
    [sym_process_substitution] = STATE(1669),
    [sym__special_characters] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3907),
  },
  [1248] = {
    [sym__simple_heredoc_body] = ACTIONS(3909),
    [sym__heredoc_body_beginning] = ACTIONS(3909),
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1249] = {
    [aux_sym_concatenation_repeat1] = STATE(1670),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [1250] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [1251] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(3913),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1252] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
  },
  [1253] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_RBRACE] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
  },
  [1254] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_RBRACE] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
  },
  [1255] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1256] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3919),
    [sym_comment] = ACTIONS(54),
  },
  [1257] = {
    [sym_concatenation] = STATE(1675),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1675),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3923),
    [anon_sym_COLON_QMARK] = ACTIONS(3923),
    [anon_sym_COLON_DASH] = ACTIONS(3923),
    [anon_sym_PERCENT] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1258] = {
    [sym_subscript] = STATE(1679),
    [sym_variable_name] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3931),
    [anon_sym_AT] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_0] = ACTIONS(3935),
    [anon_sym__] = ACTIONS(3935),
  },
  [1259] = {
    [sym_concatenation] = STATE(1682),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1682),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_EQ] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3939),
    [anon_sym_COLON_QMARK] = ACTIONS(3939),
    [anon_sym_COLON_DASH] = ACTIONS(3939),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1260] = {
    [sym_concatenation] = STATE(1685),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1685),
    [anon_sym_RBRACE] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3947),
    [anon_sym_COLON_QMARK] = ACTIONS(3947),
    [anon_sym_COLON_DASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1261] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1262] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1263] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(3953),
    [sym_comment] = ACTIONS(54),
  },
  [1264] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(3953),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1265] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1266] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1267] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_POUND] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_COLON] = ACTIONS(1662),
    [anon_sym_COLON_QMARK] = ACTIONS(1662),
    [anon_sym_COLON_DASH] = ACTIONS(1662),
    [anon_sym_PERCENT] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
  },
  [1268] = {
    [aux_sym_concatenation_repeat1] = STATE(1268),
    [sym__concat] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_POUND] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_COLON] = ACTIONS(1662),
    [anon_sym_COLON_QMARK] = ACTIONS(1662),
    [anon_sym_COLON_DASH] = ACTIONS(1662),
    [anon_sym_PERCENT] = ACTIONS(1662),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
  },
  [1269] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_POUND] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_COLON_QMARK] = ACTIONS(1711),
    [anon_sym_COLON_DASH] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
  },
  [1270] = {
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1690),
    [sym_simple_expansion] = STATE(1690),
    [sym_string_expansion] = STATE(1690),
    [sym_expansion] = STATE(1690),
    [sym_command_substitution] = STATE(1690),
    [sym_process_substitution] = STATE(1690),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [sym__special_characters] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3964),
  },
  [1271] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_POUND] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_COLON] = ACTIONS(1752),
    [anon_sym_COLON_QMARK] = ACTIONS(1752),
    [anon_sym_COLON_DASH] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
  },
  [1272] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3966),
  },
  [1273] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1274] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(3970),
    [sym_comment] = ACTIONS(54),
  },
  [1275] = {
    [sym_concatenation] = STATE(1697),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1697),
    [anon_sym_RBRACE] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3974),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3974),
    [anon_sym_COLON_QMARK] = ACTIONS(3974),
    [anon_sym_COLON_DASH] = ACTIONS(3974),
    [anon_sym_PERCENT] = ACTIONS(3974),
    [anon_sym_DASH] = ACTIONS(3974),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1276] = {
    [sym_concatenation] = STATE(1700),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1700),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3982),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3982),
    [anon_sym_COLON_QMARK] = ACTIONS(3982),
    [anon_sym_COLON_DASH] = ACTIONS(3982),
    [anon_sym_PERCENT] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3982),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1277] = {
    [sym_concatenation] = STATE(1702),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1702),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3988),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(3990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_DASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1278] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_RBRACE] = ACTIONS(1816),
    [anon_sym_EQ] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_POUND] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_COLON] = ACTIONS(1818),
    [anon_sym_COLON_QMARK] = ACTIONS(1818),
    [anon_sym_COLON_DASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
  },
  [1279] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3994),
  },
  [1280] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1281] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_RBRACE] = ACTIONS(1824),
    [anon_sym_EQ] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_POUND] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_COLON] = ACTIONS(1826),
    [anon_sym_COLON_QMARK] = ACTIONS(1826),
    [anon_sym_COLON_DASH] = ACTIONS(1826),
    [anon_sym_PERCENT] = ACTIONS(1826),
    [anon_sym_DASH] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
  },
  [1282] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(3998),
  },
  [1283] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1284] = {
    [sym__simple_heredoc_body] = ACTIONS(4000),
    [sym__heredoc_body_beginning] = ACTIONS(4000),
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_EQ_TILDE] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4002),
    [anon_sym_LT_LT_LT] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [1285] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1286] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_POUND] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(1964),
    [anon_sym_COLON_QMARK] = ACTIONS(1964),
    [anon_sym_COLON_DASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
  },
  [1287] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_POUND] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_COLON] = ACTIONS(2028),
    [anon_sym_COLON_QMARK] = ACTIONS(2028),
    [anon_sym_COLON_DASH] = ACTIONS(2028),
    [anon_sym_PERCENT] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
  },
  [1288] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4006),
    [sym_comment] = ACTIONS(54),
  },
  [1289] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(54),
  },
  [1290] = {
    [anon_sym_RBRACE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(54),
  },
  [1291] = {
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1710),
    [anon_sym_RBRACE] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4012),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_COLON_QMARK] = ACTIONS(4012),
    [anon_sym_COLON_DASH] = ACTIONS(4012),
    [anon_sym_PERCENT] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1292] = {
    [sym__simple_heredoc_body] = ACTIONS(4016),
    [sym__heredoc_body_beginning] = ACTIONS(4016),
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_EQ_TILDE] = ACTIONS(4018),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4018),
    [anon_sym_LT_LT_LT] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1293] = {
    [sym_concatenation] = STATE(1712),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1712),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(4022),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_DASH] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1294] = {
    [sym__simple_heredoc_body] = ACTIONS(4026),
    [sym__heredoc_body_beginning] = ACTIONS(4026),
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4028),
    [anon_sym_LT_LT_LT] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [1295] = {
    [sym_concatenation] = STATE(1714),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1714),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4032),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_COLON_QMARK] = ACTIONS(4032),
    [anon_sym_COLON_DASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1296] = {
    [sym__simple_heredoc_body] = ACTIONS(4036),
    [sym__heredoc_body_beginning] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [1297] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1298] = {
    [sym__simple_heredoc_body] = ACTIONS(4042),
    [sym__heredoc_body_beginning] = ACTIONS(4042),
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [1299] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1300] = {
    [sym_file_descriptor] = ACTIONS(2145),
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [anon_sym_PIPE_AMP] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_GT] = ACTIONS(2147),
    [anon_sym_AMP_GT_GT] = ACTIONS(2145),
    [anon_sym_LT_AMP] = ACTIONS(2145),
    [anon_sym_GT_AMP] = ACTIONS(2145),
    [sym__special_characters] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [anon_sym_LT_LPAREN] = ACTIONS(2145),
    [anon_sym_GT_LPAREN] = ACTIONS(2145),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2145),
  },
  [1301] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [1302] = {
    [aux_sym_concatenation_repeat1] = STATE(1718),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(692),
  },
  [1303] = {
    [sym_concatenation] = STATE(1044),
    [sym_string] = STATE(586),
    [sym_simple_expansion] = STATE(586),
    [sym_string_expansion] = STATE(586),
    [sym_expansion] = STATE(586),
    [sym_command_substitution] = STATE(586),
    [sym_process_substitution] = STATE(586),
    [aux_sym_for_statement_repeat1] = STATE(1044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_DOLLAR] = ACTIONS(1149),
    [sym_raw_string] = ACTIONS(2251),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2257),
    [anon_sym_LT_LPAREN] = ACTIONS(2259),
    [anon_sym_GT_LPAREN] = ACTIONS(2259),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_LF] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4050),
  },
  [1304] = {
    [sym__terminated_statement] = STATE(1721),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1721),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1305] = {
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_PIPE_AMP] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(2267),
    [sym_comment] = ACTIONS(54),
  },
  [1306] = {
    [sym__simple_heredoc_body] = ACTIONS(2269),
    [sym__heredoc_body_beginning] = ACTIONS(2269),
    [sym_file_descriptor] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_PIPE_AMP] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_AMP_GT] = ACTIONS(2271),
    [anon_sym_AMP_GT_GT] = ACTIONS(2269),
    [anon_sym_LT_AMP] = ACTIONS(2269),
    [anon_sym_GT_AMP] = ACTIONS(2269),
    [anon_sym_LT_LT] = ACTIONS(2271),
    [anon_sym_LT_LT_DASH] = ACTIONS(2269),
    [anon_sym_LT_LT_LT] = ACTIONS(2269),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_comment] = ACTIONS(54),
  },
  [1307] = {
    [sym__terminated_statement] = STATE(1049),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1049),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1308] = {
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_PIPE_AMP] = ACTIONS(2281),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_BQUOTE] = ACTIONS(2281),
    [sym_comment] = ACTIONS(54),
  },
  [1309] = {
    [sym_file_redirect] = STATE(932),
    [sym_heredoc_redirect] = STATE(932),
    [sym_heredoc_body] = STATE(1723),
    [sym_herestring_redirect] = STATE(932),
    [aux_sym_while_statement_repeat1] = STATE(932),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_PIPE_AMP] = ACTIONS(2281),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym_comment] = ACTIONS(54),
  },
  [1310] = {
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_PIPE_AMP] = ACTIONS(2285),
    [anon_sym_AMP_AMP] = ACTIONS(2285),
    [anon_sym_PIPE_PIPE] = ACTIONS(2285),
    [anon_sym_BQUOTE] = ACTIONS(2285),
    [sym_comment] = ACTIONS(54),
  },
  [1311] = {
    [anon_sym_fi] = ACTIONS(4058),
    [sym_comment] = ACTIONS(54),
  },
  [1312] = {
    [sym__terminated_statement] = STATE(1058),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_elif_clause] = STATE(1726),
    [sym_else_clause] = STATE(1725),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1058),
    [aux_sym_if_statement_repeat1] = STATE(1726),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(4060),
    [anon_sym_elif] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1313] = {
    [sym_elif_clause] = STATE(1060),
    [sym_else_clause] = STATE(1725),
    [aux_sym_if_statement_repeat1] = STATE(1060),
    [anon_sym_fi] = ACTIONS(4058),
    [anon_sym_elif] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [sym_comment] = ACTIONS(54),
  },
  [1314] = {
    [sym_case_item] = STATE(1729),
    [sym_last_case_item] = STATE(1728),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1729),
    [anon_sym_esac] = ACTIONS(4062),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1315] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(4064),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_LF] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4064),
  },
  [1316] = {
    [sym_case_item] = STATE(1733),
    [sym_last_case_item] = STATE(1732),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1733),
    [anon_sym_esac] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1317] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1318] = {
    [sym_compound_statement] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [1319] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(54),
  },
  [1320] = {
    [sym__terminated_statement] = STATE(1093),
    [sym_for_statement] = STATE(633),
    [sym_while_statement] = STATE(633),
    [sym_if_statement] = STATE(633),
    [sym_case_statement] = STATE(633),
    [sym_function_definition] = STATE(633),
    [sym_subshell] = STATE(633),
    [sym_pipeline] = STATE(633),
    [sym_list] = STATE(633),
    [sym_command] = STATE(633),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(633),
    [sym_variable_assignment] = STATE(634),
    [sym_declaration_command] = STATE(633),
    [sym_unset_command] = STATE(633),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1093),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1321] = {
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym_AMP_GT] = ACTIONS(4076),
    [anon_sym_AMP_GT_GT] = ACTIONS(4078),
    [anon_sym_LT_AMP] = ACTIONS(4078),
    [anon_sym_GT_AMP] = ACTIONS(4078),
    [sym_comment] = ACTIONS(54),
  },
  [1322] = {
    [sym_concatenation] = STATE(1740),
    [sym_string] = STATE(1739),
    [sym_simple_expansion] = STATE(1739),
    [sym_string_expansion] = STATE(1739),
    [sym_expansion] = STATE(1739),
    [sym_command_substitution] = STATE(1739),
    [sym_process_substitution] = STATE(1739),
    [sym__special_characters] = ACTIONS(4080),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(4082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4082),
  },
  [1323] = {
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_PIPE_AMP] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(54),
  },
  [1324] = {
    [anon_sym_PIPE] = ACTIONS(2415),
    [anon_sym_RPAREN] = ACTIONS(2417),
    [anon_sym_PIPE_AMP] = ACTIONS(2417),
    [anon_sym_AMP_AMP] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2417),
    [anon_sym_BQUOTE] = ACTIONS(2417),
    [sym_comment] = ACTIONS(54),
  },
  [1325] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [1326] = {
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4088),
    [anon_sym_AMP_GT] = ACTIONS(4086),
    [anon_sym_AMP_GT_GT] = ACTIONS(4088),
    [anon_sym_LT_AMP] = ACTIONS(4088),
    [anon_sym_GT_AMP] = ACTIONS(4088),
    [sym_comment] = ACTIONS(54),
  },
  [1327] = {
    [sym_concatenation] = STATE(1751),
    [sym_string] = STATE(1746),
    [sym_simple_expansion] = STATE(1746),
    [sym_string_expansion] = STATE(1746),
    [sym_expansion] = STATE(1746),
    [sym_command_substitution] = STATE(1746),
    [sym_process_substitution] = STATE(1746),
    [sym__special_characters] = ACTIONS(4090),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(4096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4096),
  },
  [1328] = {
    [sym_heredoc_start] = ACTIONS(4106),
    [sym_comment] = ACTIONS(54),
  },
  [1329] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_simple_expansion] = STATE(1754),
    [sym_string_expansion] = STATE(1754),
    [sym_expansion] = STATE(1754),
    [sym_command_substitution] = STATE(1754),
    [sym_process_substitution] = STATE(1754),
    [sym__special_characters] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(4110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4110),
  },
  [1330] = {
    [sym_file_redirect] = STATE(1756),
    [sym_heredoc_redirect] = STATE(1756),
    [sym_herestring_redirect] = STATE(1756),
    [aux_sym_while_statement_repeat1] = STATE(1756),
    [sym_file_descriptor] = ACTIONS(2937),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2514),
    [anon_sym_PIPE_AMP] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2939),
    [anon_sym_GT] = ACTIONS(2939),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_AMP_GT] = ACTIONS(2939),
    [anon_sym_AMP_GT_GT] = ACTIONS(2941),
    [anon_sym_LT_AMP] = ACTIONS(2941),
    [anon_sym_GT_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(54),
  },
  [1331] = {
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
  },
  [1332] = {
    [sym_concatenation] = STATE(1758),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1758),
    [anon_sym_RPAREN] = ACTIONS(4112),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [1333] = {
    [aux_sym_concatenation_repeat1] = STATE(857),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [anon_sym_PIPE_AMP] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [sym__special_characters] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1119),
    [anon_sym_GT_LPAREN] = ACTIONS(1119),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1123),
    [sym_word] = ACTIONS(1123),
  },
  [1334] = {
    [aux_sym_concatenation_repeat1] = STATE(857),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
  },
  [1335] = {
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1336] = {
    [aux_sym_concatenation_repeat1] = STATE(1336),
    [sym__concat] = ACTIONS(4114),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1337] = {
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_PIPE_AMP] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
  },
  [1338] = {
    [sym_concatenation] = STATE(1762),
    [sym_string] = STATE(1761),
    [sym_simple_expansion] = STATE(1761),
    [sym_string_expansion] = STATE(1761),
    [sym_expansion] = STATE(1761),
    [sym_command_substitution] = STATE(1761),
    [sym_process_substitution] = STATE(1761),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [sym__special_characters] = ACTIONS(4119),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4121),
  },
  [1339] = {
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_PIPE_AMP] = ACTIONS(1750),
    [anon_sym_AMP_AMP] = ACTIONS(1750),
    [anon_sym_PIPE_PIPE] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
  },
  [1340] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4123),
  },
  [1341] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1342] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4127),
    [sym_comment] = ACTIONS(54),
  },
  [1343] = {
    [sym_concatenation] = STATE(1768),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1768),
    [anon_sym_RBRACE] = ACTIONS(4129),
    [anon_sym_EQ] = ACTIONS(4131),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4131),
    [anon_sym_COLON_QMARK] = ACTIONS(4131),
    [anon_sym_COLON_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1344] = {
    [sym_concatenation] = STATE(1771),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1771),
    [anon_sym_RBRACE] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4139),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4143),
    [anon_sym_COLON] = ACTIONS(4139),
    [anon_sym_COLON_QMARK] = ACTIONS(4139),
    [anon_sym_COLON_DASH] = ACTIONS(4139),
    [anon_sym_PERCENT] = ACTIONS(4139),
    [anon_sym_DASH] = ACTIONS(4139),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1345] = {
    [sym_concatenation] = STATE(1773),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1773),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(4145),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_COLON_QMARK] = ACTIONS(4145),
    [anon_sym_COLON_DASH] = ACTIONS(4145),
    [anon_sym_PERCENT] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1346] = {
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_PIPE_AMP] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
  },
  [1347] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4151),
  },
  [1348] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4153),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1349] = {
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
  },
  [1350] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4155),
  },
  [1351] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
  },
  [1353] = {
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
  },
  [1354] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1355] = {
    [aux_sym_concatenation_repeat1] = STATE(1355),
    [sym__concat] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1356] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_PIPE_AMP] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
  },
  [1357] = {
    [sym_concatenation] = STATE(1780),
    [sym_string] = STATE(1779),
    [sym_simple_expansion] = STATE(1779),
    [sym_string_expansion] = STATE(1779),
    [sym_expansion] = STATE(1779),
    [sym_command_substitution] = STATE(1779),
    [sym_process_substitution] = STATE(1779),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [sym__special_characters] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4164),
  },
  [1358] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_PIPE_AMP] = ACTIONS(1750),
    [anon_sym_AMP_AMP] = ACTIONS(1750),
    [anon_sym_PIPE_PIPE] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
  },
  [1359] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4166),
  },
  [1360] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1361] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4170),
    [sym_comment] = ACTIONS(54),
  },
  [1362] = {
    [sym_concatenation] = STATE(1786),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1786),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_EQ] = ACTIONS(4174),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_DASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1363] = {
    [sym_concatenation] = STATE(1789),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1789),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4182),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_DASH] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1364] = {
    [sym_concatenation] = STATE(1791),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1791),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4188),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4192),
    [anon_sym_COLON] = ACTIONS(4188),
    [anon_sym_COLON_QMARK] = ACTIONS(4188),
    [anon_sym_COLON_DASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1365] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_PIPE_AMP] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
  },
  [1366] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4194),
  },
  [1367] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1368] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
  },
  [1369] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4198),
  },
  [1370] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1371] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
  },
  [1372] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
  },
  [1373] = {
    [sym__simple_heredoc_body] = ACTIONS(2744),
    [sym__heredoc_body_beginning] = ACTIONS(2744),
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_EQ_TILDE] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2744),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2744),
    [anon_sym_LT_AMP] = ACTIONS(2744),
    [anon_sym_GT_AMP] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2744),
    [anon_sym_LT_LT_LT] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2746),
  },
  [1374] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4200),
    [sym_comment] = ACTIONS(54),
  },
  [1375] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [sym_comment] = ACTIONS(54),
  },
  [1376] = {
    [anon_sym_RBRACE] = ACTIONS(4202),
    [sym_comment] = ACTIONS(54),
  },
  [1377] = {
    [sym_concatenation] = STATE(1798),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1798),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_EQ] = ACTIONS(4206),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4206),
    [anon_sym_COLON_QMARK] = ACTIONS(4206),
    [anon_sym_COLON_DASH] = ACTIONS(4206),
    [anon_sym_PERCENT] = ACTIONS(4206),
    [anon_sym_DASH] = ACTIONS(4206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1378] = {
    [sym__simple_heredoc_body] = ACTIONS(2822),
    [sym__heredoc_body_beginning] = ACTIONS(2822),
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_EQ_TILDE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2822),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2822),
    [anon_sym_LT_AMP] = ACTIONS(2822),
    [anon_sym_GT_AMP] = ACTIONS(2822),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2822),
    [anon_sym_LT_LT_LT] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2824),
  },
  [1379] = {
    [sym_concatenation] = STATE(1801),
    [sym_string] = STATE(1800),
    [sym_simple_expansion] = STATE(1800),
    [sym_string_expansion] = STATE(1800),
    [sym_expansion] = STATE(1800),
    [sym_command_substitution] = STATE(1800),
    [sym_process_substitution] = STATE(1800),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [sym__special_characters] = ACTIONS(4210),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4212),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4212),
  },
  [1380] = {
    [sym__simple_heredoc_body] = ACTIONS(2865),
    [sym__heredoc_body_beginning] = ACTIONS(2865),
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_PIPE_AMP] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_EQ_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2865),
    [anon_sym_LT_AMP] = ACTIONS(2865),
    [anon_sym_GT_AMP] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT_LT] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2867),
  },
  [1381] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4214),
  },
  [1382] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1383] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT_LT] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2875),
  },
  [1384] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4218),
  },
  [1385] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1386] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4222),
  },
  [1387] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1388] = {
    [sym_concatenation] = STATE(1808),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1808),
    [anon_sym_RBRACE] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4226),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4226),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_DASH] = ACTIONS(4226),
    [anon_sym_PERCENT] = ACTIONS(4226),
    [anon_sym_DASH] = ACTIONS(4226),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1389] = {
    [sym__simple_heredoc_body] = ACTIONS(2889),
    [sym__heredoc_body_beginning] = ACTIONS(2889),
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2889),
    [anon_sym_LT_AMP] = ACTIONS(2889),
    [anon_sym_GT_AMP] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT_LT] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2891),
  },
  [1390] = {
    [sym_concatenation] = STATE(1810),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1810),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_DASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1391] = {
    [sym_file_redirect] = STATE(1811),
    [sym_file_descriptor] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_PIPE_AMP] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2927),
    [anon_sym_AMP_GT] = ACTIONS(2925),
    [anon_sym_AMP_GT_GT] = ACTIONS(2927),
    [anon_sym_LT_AMP] = ACTIONS(2927),
    [anon_sym_GT_AMP] = ACTIONS(2927),
    [sym_comment] = ACTIONS(54),
  },
  [1392] = {
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_RPAREN] = ACTIONS(3306),
    [anon_sym_PIPE_AMP] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_PIPE_PIPE] = ACTIONS(3306),
    [anon_sym_BQUOTE] = ACTIONS(3306),
    [sym_comment] = ACTIONS(54),
  },
  [1393] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(1079),
    [sym__heredoc_body_beginning] = ACTIONS(1079),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_LT_LT_LT] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [1394] = {
    [aux_sym_concatenation_repeat1] = STATE(1396),
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [1395] = {
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [1396] = {
    [aux_sym_concatenation_repeat1] = STATE(1812),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [1397] = {
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3321),
    [anon_sym_PIPE_AMP] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_PIPE_PIPE] = ACTIONS(3321),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_comment] = ACTIONS(54),
  },
  [1398] = {
    [sym_file_redirect] = STATE(932),
    [sym_heredoc_redirect] = STATE(932),
    [sym_heredoc_body] = STATE(1813),
    [sym_herestring_redirect] = STATE(932),
    [aux_sym_while_statement_repeat1] = STATE(932),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_RPAREN] = ACTIONS(3321),
    [anon_sym_PIPE_AMP] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_PIPE_PIPE] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_AMP_GT] = ACTIONS(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(886),
    [anon_sym_LT_AMP] = ACTIONS(886),
    [anon_sym_GT_AMP] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(892),
    [sym_comment] = ACTIONS(54),
  },
  [1399] = {
    [aux_sym_concatenation_repeat1] = STATE(1814),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(662),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [sym__special_characters] = ACTIONS(692),
    [anon_sym_DQUOTE] = ACTIONS(692),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(692),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [anon_sym_LT_LPAREN] = ACTIONS(692),
    [anon_sym_GT_LPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(692),
  },
  [1400] = {
    [sym_file_redirect] = STATE(959),
    [sym_heredoc_redirect] = STATE(959),
    [sym_heredoc_body] = STATE(1723),
    [sym_herestring_redirect] = STATE(959),
    [aux_sym_while_statement_repeat1] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2281),
    [anon_sym_AMP_AMP] = ACTIONS(2281),
    [anon_sym_PIPE_PIPE] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [anon_sym_BQUOTE] = ACTIONS(2281),
    [sym_comment] = ACTIONS(54),
  },
  [1401] = {
    [sym_compound_statement] = STATE(1815),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(54),
  },
  [1402] = {
    [anon_sym_LT] = ACTIONS(4236),
    [anon_sym_GT] = ACTIONS(4236),
    [anon_sym_GT_GT] = ACTIONS(4238),
    [anon_sym_AMP_GT] = ACTIONS(4236),
    [anon_sym_AMP_GT_GT] = ACTIONS(4238),
    [anon_sym_LT_AMP] = ACTIONS(4238),
    [anon_sym_GT_AMP] = ACTIONS(4238),
    [sym_comment] = ACTIONS(54),
  },
  [1403] = {
    [sym_concatenation] = STATE(1740),
    [sym_string] = STATE(1818),
    [sym_simple_expansion] = STATE(1818),
    [sym_string_expansion] = STATE(1818),
    [sym_expansion] = STATE(1818),
    [sym_command_substitution] = STATE(1818),
    [sym_process_substitution] = STATE(1818),
    [sym__special_characters] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(4242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4242),
  },
  [1404] = {
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_AMP_GT] = ACTIONS(4244),
    [anon_sym_AMP_GT_GT] = ACTIONS(4246),
    [anon_sym_LT_AMP] = ACTIONS(4246),
    [anon_sym_GT_AMP] = ACTIONS(4246),
    [sym_comment] = ACTIONS(54),
  },
  [1405] = {
    [sym_concatenation] = STATE(1751),
    [sym_string] = STATE(1821),
    [sym_simple_expansion] = STATE(1821),
    [sym_string_expansion] = STATE(1821),
    [sym_expansion] = STATE(1821),
    [sym_command_substitution] = STATE(1821),
    [sym_process_substitution] = STATE(1821),
    [sym__special_characters] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(4250),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4250),
  },
  [1406] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(1823),
    [sym_simple_expansion] = STATE(1823),
    [sym_string_expansion] = STATE(1823),
    [sym_expansion] = STATE(1823),
    [sym_command_substitution] = STATE(1823),
    [sym_process_substitution] = STATE(1823),
    [sym__special_characters] = ACTIONS(4252),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(4254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4254),
  },
  [1407] = {
    [sym_file_redirect] = STATE(1824),
    [sym_heredoc_redirect] = STATE(1824),
    [sym_herestring_redirect] = STATE(1824),
    [aux_sym_while_statement_repeat1] = STATE(1824),
    [sym_file_descriptor] = ACTIONS(3209),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_GT] = ACTIONS(3211),
    [anon_sym_GT_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT] = ACTIONS(3211),
    [anon_sym_AMP_GT_GT] = ACTIONS(3213),
    [anon_sym_LT_AMP] = ACTIONS(3213),
    [anon_sym_GT_AMP] = ACTIONS(3213),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(3215),
    [anon_sym_BQUOTE] = ACTIONS(2514),
    [sym_comment] = ACTIONS(54),
  },
  [1408] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [sym__special_characters] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1119),
    [anon_sym_GT_LPAREN] = ACTIONS(1119),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1123),
    [sym_word] = ACTIONS(1123),
  },
  [1409] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym__concat] = ACTIONS(1874),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [sym__special_characters] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
  },
  [1410] = {
    [aux_sym_concatenation_repeat1] = STATE(1410),
    [sym__concat] = ACTIONS(4114),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1411] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__concat] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
  },
  [1412] = {
    [sym_file_redirect] = STATE(1811),
    [sym_file_descriptor] = ACTIONS(3203),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_PIPE_AMP] = ACTIONS(2382),
    [anon_sym_AMP_AMP] = ACTIONS(2382),
    [anon_sym_PIPE_PIPE] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_GT] = ACTIONS(3205),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_AMP_GT] = ACTIONS(3205),
    [anon_sym_AMP_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_AMP] = ACTIONS(3207),
    [anon_sym_GT_AMP] = ACTIONS(3207),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(54),
  },
  [1413] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1079),
    [sym__heredoc_body_beginning] = ACTIONS(1079),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_LT_LT_LT] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [1414] = {
    [aux_sym_concatenation_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [1415] = {
    [aux_sym_concatenation_repeat1] = STATE(1825),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [1416] = {
    [sym_file_redirect] = STATE(959),
    [sym_heredoc_redirect] = STATE(959),
    [sym_heredoc_body] = STATE(1813),
    [sym_herestring_redirect] = STATE(959),
    [aux_sym_while_statement_repeat1] = STATE(959),
    [sym__simple_heredoc_body] = ACTIONS(876),
    [sym__heredoc_body_beginning] = ACTIONS(878),
    [sym_file_descriptor] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_PIPE_AMP] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_PIPE_PIPE] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(934),
    [anon_sym_LT_AMP] = ACTIONS(934),
    [anon_sym_GT_AMP] = ACTIONS(934),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_LT_LT_DASH] = ACTIONS(890),
    [anon_sym_LT_LT_LT] = ACTIONS(936),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_comment] = ACTIONS(54),
  },
  [1417] = {
    [anon_sym_esac] = ACTIONS(3603),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_RPAREN] = ACTIONS(3603),
    [anon_sym_SEMI_SEMI] = ACTIONS(3603),
    [anon_sym_PIPE_AMP] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3603),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_LF] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3603),
  },
  [1418] = {
    [sym_concatenation] = STATE(1829),
    [sym_string] = STATE(1828),
    [sym_simple_expansion] = STATE(1828),
    [sym_string_expansion] = STATE(1828),
    [sym_expansion] = STATE(1828),
    [sym_command_substitution] = STATE(1828),
    [sym_process_substitution] = STATE(1828),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [sym__special_characters] = ACTIONS(4258),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4260),
  },
  [1419] = {
    [sym__heredoc_body_middle] = ACTIONS(1750),
    [sym__heredoc_body_end] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
  },
  [1420] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4262),
  },
  [1421] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4264),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1422] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4266),
    [sym_comment] = ACTIONS(54),
  },
  [1423] = {
    [sym_concatenation] = STATE(1835),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1835),
    [anon_sym_RBRACE] = ACTIONS(4268),
    [anon_sym_EQ] = ACTIONS(4270),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4274),
    [anon_sym_COLON] = ACTIONS(4270),
    [anon_sym_COLON_QMARK] = ACTIONS(4270),
    [anon_sym_COLON_DASH] = ACTIONS(4270),
    [anon_sym_PERCENT] = ACTIONS(4270),
    [anon_sym_DASH] = ACTIONS(4270),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1424] = {
    [sym_concatenation] = STATE(1838),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1838),
    [anon_sym_RBRACE] = ACTIONS(4276),
    [anon_sym_EQ] = ACTIONS(4278),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4282),
    [anon_sym_COLON] = ACTIONS(4278),
    [anon_sym_COLON_QMARK] = ACTIONS(4278),
    [anon_sym_COLON_DASH] = ACTIONS(4278),
    [anon_sym_PERCENT] = ACTIONS(4278),
    [anon_sym_DASH] = ACTIONS(4278),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1425] = {
    [sym_concatenation] = STATE(1840),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1840),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(4284),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_COLON_QMARK] = ACTIONS(4284),
    [anon_sym_COLON_DASH] = ACTIONS(4284),
    [anon_sym_PERCENT] = ACTIONS(4284),
    [anon_sym_DASH] = ACTIONS(4284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1426] = {
    [sym__heredoc_body_middle] = ACTIONS(1816),
    [sym__heredoc_body_end] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
  },
  [1427] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4290),
  },
  [1428] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1429] = {
    [sym__heredoc_body_middle] = ACTIONS(1824),
    [sym__heredoc_body_end] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
  },
  [1430] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4294),
  },
  [1431] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4256),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1432] = {
    [aux_sym_concatenation_repeat1] = STATE(1432),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1433] = {
    [anon_sym_esac] = ACTIONS(4296),
    [anon_sym_PIPE] = ACTIONS(4296),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_SEMI_SEMI] = ACTIONS(4296),
    [anon_sym_PIPE_AMP] = ACTIONS(4296),
    [anon_sym_AMP_AMP] = ACTIONS(4296),
    [anon_sym_PIPE_PIPE] = ACTIONS(4296),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4296),
    [anon_sym_LF] = ACTIONS(4298),
    [anon_sym_AMP] = ACTIONS(4296),
  },
  [1434] = {
    [anon_sym_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [sym_comment] = ACTIONS(54),
  },
  [1435] = {
    [anon_sym_EQ] = ACTIONS(4302),
    [anon_sym_PLUS_EQ] = ACTIONS(4302),
    [sym_comment] = ACTIONS(54),
  },
  [1436] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [1437] = {
    [aux_sym_concatenation_repeat1] = STATE(1437),
    [sym__concat] = ACTIONS(4304),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [1438] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [sym__special_characters] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1709),
  },
  [1439] = {
    [sym_concatenation] = STATE(1847),
    [sym_string] = STATE(1846),
    [sym_simple_expansion] = STATE(1846),
    [sym_string_expansion] = STATE(1846),
    [sym_expansion] = STATE(1846),
    [sym_command_substitution] = STATE(1846),
    [sym_process_substitution] = STATE(1846),
    [anon_sym_RBRACE] = ACTIONS(4307),
    [sym__special_characters] = ACTIONS(4309),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4311),
  },
  [1440] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [sym__special_characters] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1750),
  },
  [1441] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4313),
  },
  [1442] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4315),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1443] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4317),
    [sym_comment] = ACTIONS(54),
  },
  [1444] = {
    [sym_concatenation] = STATE(1853),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1853),
    [anon_sym_RBRACE] = ACTIONS(4319),
    [anon_sym_EQ] = ACTIONS(4321),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4325),
    [anon_sym_COLON] = ACTIONS(4321),
    [anon_sym_COLON_QMARK] = ACTIONS(4321),
    [anon_sym_COLON_DASH] = ACTIONS(4321),
    [anon_sym_PERCENT] = ACTIONS(4321),
    [anon_sym_DASH] = ACTIONS(4321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1445] = {
    [sym_concatenation] = STATE(1856),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1856),
    [anon_sym_RBRACE] = ACTIONS(4327),
    [anon_sym_EQ] = ACTIONS(4329),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4333),
    [anon_sym_COLON] = ACTIONS(4329),
    [anon_sym_COLON_QMARK] = ACTIONS(4329),
    [anon_sym_COLON_DASH] = ACTIONS(4329),
    [anon_sym_PERCENT] = ACTIONS(4329),
    [anon_sym_DASH] = ACTIONS(4329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1446] = {
    [sym_concatenation] = STATE(1858),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1858),
    [anon_sym_RBRACE] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(4335),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COLON_QMARK] = ACTIONS(4335),
    [anon_sym_COLON_DASH] = ACTIONS(4335),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_DASH] = ACTIONS(4335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1447] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [sym__special_characters] = ACTIONS(1816),
    [anon_sym_DQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_LT_LPAREN] = ACTIONS(1816),
    [anon_sym_GT_LPAREN] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1816),
  },
  [1448] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4341),
  },
  [1449] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4343),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1450] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1824),
  },
  [1451] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4345),
  },
  [1452] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4307),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1453] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [sym__special_characters] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LT_LPAREN] = ACTIONS(1962),
    [anon_sym_GT_LPAREN] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1962),
  },
  [1454] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [sym__special_characters] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(2026),
    [anon_sym_GT_LPAREN] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2026),
  },
  [1455] = {
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [1456] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4347),
    [sym_comment] = ACTIONS(54),
  },
  [1457] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(54),
  },
  [1458] = {
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(54),
  },
  [1459] = {
    [sym_concatenation] = STATE(1865),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1865),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [anon_sym_EQ] = ACTIONS(4353),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4353),
    [anon_sym_COLON_QMARK] = ACTIONS(4353),
    [anon_sym_COLON_DASH] = ACTIONS(4353),
    [anon_sym_PERCENT] = ACTIONS(4353),
    [anon_sym_DASH] = ACTIONS(4353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1460] = {
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [1461] = {
    [sym_concatenation] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_simple_expansion] = STATE(1867),
    [sym_string_expansion] = STATE(1867),
    [sym_expansion] = STATE(1867),
    [sym_command_substitution] = STATE(1867),
    [sym_process_substitution] = STATE(1867),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym__special_characters] = ACTIONS(4357),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4359),
  },
  [1462] = {
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [1463] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4361),
  },
  [1464] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1465] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1466] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4365),
  },
  [1467] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4367),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1468] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4369),
  },
  [1469] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1470] = {
    [sym_concatenation] = STATE(1875),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1875),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4373),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COLON_QMARK] = ACTIONS(4373),
    [anon_sym_COLON_DASH] = ACTIONS(4373),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1471] = {
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [1472] = {
    [sym_concatenation] = STATE(1877),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1877),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [anon_sym_EQ] = ACTIONS(4379),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4379),
    [anon_sym_COLON_QMARK] = ACTIONS(4379),
    [anon_sym_COLON_DASH] = ACTIONS(4379),
    [anon_sym_PERCENT] = ACTIONS(4379),
    [anon_sym_DASH] = ACTIONS(4379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1473] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1474] = {
    [aux_sym_concatenation_repeat1] = STATE(1474),
    [sym__concat] = ACTIONS(4383),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1475] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [1476] = {
    [sym_concatenation] = STATE(1881),
    [sym_string] = STATE(1880),
    [sym_simple_expansion] = STATE(1880),
    [sym_string_expansion] = STATE(1880),
    [sym_expansion] = STATE(1880),
    [sym_command_substitution] = STATE(1880),
    [sym_process_substitution] = STATE(1880),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [sym__special_characters] = ACTIONS(4388),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4390),
  },
  [1477] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [1478] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4392),
  },
  [1479] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1480] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4396),
    [sym_comment] = ACTIONS(54),
  },
  [1481] = {
    [sym_concatenation] = STATE(1887),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(4400),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4404),
    [anon_sym_COLON] = ACTIONS(4400),
    [anon_sym_COLON_QMARK] = ACTIONS(4400),
    [anon_sym_COLON_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1482] = {
    [sym_concatenation] = STATE(1890),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1890),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_EQ] = ACTIONS(4408),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4412),
    [anon_sym_COLON] = ACTIONS(4408),
    [anon_sym_COLON_QMARK] = ACTIONS(4408),
    [anon_sym_COLON_DASH] = ACTIONS(4408),
    [anon_sym_PERCENT] = ACTIONS(4408),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1483] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_EQ] = ACTIONS(4414),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4418),
    [anon_sym_COLON] = ACTIONS(4414),
    [anon_sym_COLON_QMARK] = ACTIONS(4414),
    [anon_sym_COLON_DASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1484] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [1485] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4420),
  },
  [1486] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1487] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [1488] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4424),
  },
  [1489] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1490] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [1491] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [1492] = {
    [anon_sym_esac] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_SEMI_SEMI] = ACTIONS(4426),
    [anon_sym_PIPE_AMP] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_LF] = ACTIONS(4428),
    [anon_sym_AMP] = ACTIONS(4426),
  },
  [1493] = {
    [anon_sym_esac] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3518),
    [anon_sym_SEMI_SEMI] = ACTIONS(3518),
    [anon_sym_PIPE_AMP] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym_LF] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
  },
  [1494] = {
    [sym__terminated_statement] = STATE(1896),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1896),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(4430),
    [anon_sym_elif] = ACTIONS(4430),
    [anon_sym_else] = ACTIONS(4430),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1495] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_fi] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [1496] = {
    [sym__terminated_statement] = STATE(1496),
    [sym_for_statement] = STATE(1052),
    [sym_while_statement] = STATE(1052),
    [sym_if_statement] = STATE(1052),
    [sym_case_statement] = STATE(1052),
    [sym_function_definition] = STATE(1052),
    [sym_subshell] = STATE(1052),
    [sym_pipeline] = STATE(1052),
    [sym_list] = STATE(1052),
    [sym_command] = STATE(1052),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(1052),
    [sym_variable_assignment] = STATE(1053),
    [sym_declaration_command] = STATE(1052),
    [sym_unset_command] = STATE(1052),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1496),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_fi] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [1497] = {
    [anon_sym_esac] = ACTIONS(4432),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(4432),
    [anon_sym_SEMI_SEMI] = ACTIONS(4432),
    [anon_sym_PIPE_AMP] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4432),
    [anon_sym_PIPE_PIPE] = ACTIONS(4432),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4432),
    [anon_sym_LF] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4432),
  },
  [1498] = {
    [anon_sym_fi] = ACTIONS(4436),
    [sym_comment] = ACTIONS(54),
  },
  [1499] = {
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(1899),
    [sym_simple_expansion] = STATE(1899),
    [sym_string_expansion] = STATE(1899),
    [sym_expansion] = STATE(1899),
    [sym_command_substitution] = STATE(1899),
    [sym_process_substitution] = STATE(1899),
    [sym__special_characters] = ACTIONS(4438),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(4440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4440),
  },
  [1500] = {
    [sym__terminated_statement] = STATE(1923),
    [sym_for_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_case_statement] = STATE(1918),
    [sym_function_definition] = STATE(1918),
    [sym_subshell] = STATE(1918),
    [sym_pipeline] = STATE(1918),
    [sym_list] = STATE(1918),
    [sym_command] = STATE(1918),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(1918),
    [sym_variable_assignment] = STATE(1920),
    [sym_declaration_command] = STATE(1918),
    [sym_unset_command] = STATE(1918),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(1923),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4446),
    [anon_sym_SEMI_SEMI] = ACTIONS(4448),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1501] = {
    [aux_sym_case_item_repeat1] = STATE(1926),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(4478),
    [sym_comment] = ACTIONS(54),
  },
  [1502] = {
    [aux_sym_concatenation_repeat1] = STATE(1927),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [1503] = {
    [sym__terminated_statement] = STATE(1931),
    [sym_for_statement] = STATE(1929),
    [sym_while_statement] = STATE(1929),
    [sym_if_statement] = STATE(1929),
    [sym_case_statement] = STATE(1929),
    [sym_function_definition] = STATE(1929),
    [sym_subshell] = STATE(1929),
    [sym_pipeline] = STATE(1929),
    [sym_list] = STATE(1929),
    [sym_command] = STATE(1929),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(1929),
    [sym_variable_assignment] = STATE(1930),
    [sym_declaration_command] = STATE(1929),
    [sym_unset_command] = STATE(1929),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(1931),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4480),
    [anon_sym_SEMI_SEMI] = ACTIONS(4482),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1504] = {
    [aux_sym_case_item_repeat1] = STATE(1926),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [sym_comment] = ACTIONS(54),
  },
  [1505] = {
    [anon_sym_esac] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_SEMI_SEMI] = ACTIONS(4486),
    [anon_sym_PIPE_AMP] = ACTIONS(4486),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_LF] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4486),
  },
  [1506] = {
    [anon_sym_esac] = ACTIONS(4490),
    [sym_comment] = ACTIONS(54),
  },
  [1507] = {
    [sym_case_item] = STATE(1507),
    [sym_concatenation] = STATE(1936),
    [sym_string] = STATE(1935),
    [sym_simple_expansion] = STATE(1935),
    [sym_string_expansion] = STATE(1935),
    [sym_expansion] = STATE(1935),
    [sym_command_substitution] = STATE(1935),
    [sym_process_substitution] = STATE(1935),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(4495),
    [anon_sym_DOLLAR] = ACTIONS(4498),
    [sym_raw_string] = ACTIONS(4501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4507),
    [anon_sym_BQUOTE] = ACTIONS(4510),
    [anon_sym_LT_LPAREN] = ACTIONS(4513),
    [anon_sym_GT_LPAREN] = ACTIONS(4513),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4501),
  },
  [1508] = {
    [anon_sym_esac] = ACTIONS(4516),
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(4516),
    [anon_sym_SEMI_SEMI] = ACTIONS(4516),
    [anon_sym_PIPE_AMP] = ACTIONS(4516),
    [anon_sym_AMP_AMP] = ACTIONS(4516),
    [anon_sym_PIPE_PIPE] = ACTIONS(4516),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_LF] = ACTIONS(4518),
    [anon_sym_AMP] = ACTIONS(4516),
  },
  [1509] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(1937),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1510] = {
    [anon_sym_esac] = ACTIONS(4520),
    [anon_sym_PIPE] = ACTIONS(4520),
    [anon_sym_RPAREN] = ACTIONS(4520),
    [anon_sym_SEMI_SEMI] = ACTIONS(4520),
    [anon_sym_PIPE_AMP] = ACTIONS(4520),
    [anon_sym_AMP_AMP] = ACTIONS(4520),
    [anon_sym_PIPE_PIPE] = ACTIONS(4520),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_LF] = ACTIONS(4522),
    [anon_sym_AMP] = ACTIONS(4520),
  },
  [1511] = {
    [anon_sym_esac] = ACTIONS(4524),
    [sym_comment] = ACTIONS(54),
  },
  [1512] = {
    [anon_sym_esac] = ACTIONS(4526),
    [anon_sym_PIPE] = ACTIONS(4526),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_SEMI_SEMI] = ACTIONS(4526),
    [anon_sym_PIPE_AMP] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4526),
    [anon_sym_LF] = ACTIONS(4528),
    [anon_sym_AMP] = ACTIONS(4526),
  },
  [1513] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(1939),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1514] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1515] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_in] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1516] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_in] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [1517] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1518] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [sym_comment] = ACTIONS(54),
  },
  [1519] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym_comment] = ACTIONS(54),
  },
  [1520] = {
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym_comment] = ACTIONS(54),
  },
  [1521] = {
    [sym_concatenation] = STATE(1944),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1944),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_EQ] = ACTIONS(4538),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4538),
    [anon_sym_COLON_QMARK] = ACTIONS(4538),
    [anon_sym_COLON_DASH] = ACTIONS(4538),
    [anon_sym_PERCENT] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1522] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1523] = {
    [sym_concatenation] = STATE(1946),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1946),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [anon_sym_EQ] = ACTIONS(4544),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_COLON_QMARK] = ACTIONS(4544),
    [anon_sym_COLON_DASH] = ACTIONS(4544),
    [anon_sym_PERCENT] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1524] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_in] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [1525] = {
    [sym_concatenation] = STATE(1948),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1948),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_EQ] = ACTIONS(4550),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4550),
    [anon_sym_COLON_QMARK] = ACTIONS(4550),
    [anon_sym_COLON_DASH] = ACTIONS(4550),
    [anon_sym_PERCENT] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1526] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_in] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [1527] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4554),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1528] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_in] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [1529] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1530] = {
    [anon_sym_esac] = ACTIONS(4558),
    [anon_sym_PIPE] = ACTIONS(4558),
    [anon_sym_RPAREN] = ACTIONS(4558),
    [anon_sym_SEMI_SEMI] = ACTIONS(4558),
    [anon_sym_PIPE_AMP] = ACTIONS(4558),
    [anon_sym_AMP_AMP] = ACTIONS(4558),
    [anon_sym_PIPE_PIPE] = ACTIONS(4558),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4558),
    [anon_sym_LF] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4558),
  },
  [1531] = {
    [aux_sym_concatenation_repeat1] = STATE(1534),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [1532] = {
    [aux_sym_concatenation_repeat1] = STATE(1534),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1533] = {
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1534] = {
    [aux_sym_concatenation_repeat1] = STATE(1951),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1535] = {
    [aux_sym_concatenation_repeat1] = STATE(1535),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3403),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1536] = {
    [sym_file_redirect] = STATE(1530),
    [sym_file_descriptor] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_RPAREN] = ACTIONS(3603),
    [anon_sym_SEMI_SEMI] = ACTIONS(3603),
    [anon_sym_PIPE_AMP] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_AMP] = ACTIONS(2388),
    [anon_sym_GT_AMP] = ACTIONS(2388),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_LF] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3603),
  },
  [1537] = {
    [sym_concatenation] = STATE(1533),
    [sym_string] = STATE(1953),
    [sym_simple_expansion] = STATE(1953),
    [sym_string_expansion] = STATE(1953),
    [sym_expansion] = STATE(1953),
    [sym_command_substitution] = STATE(1953),
    [sym_process_substitution] = STATE(1953),
    [sym__special_characters] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(628),
    [anon_sym_DOLLAR] = ACTIONS(178),
    [sym_raw_string] = ACTIONS(4564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(1545),
    [anon_sym_GT_LPAREN] = ACTIONS(1545),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4564),
  },
  [1538] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [1539] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1540] = {
    [sym_concatenation] = STATE(1565),
    [sym_string] = STATE(1956),
    [sym_simple_expansion] = STATE(1956),
    [sym_string_expansion] = STATE(1956),
    [sym_expansion] = STATE(1956),
    [sym_command_substitution] = STATE(1956),
    [sym_process_substitution] = STATE(1956),
    [sym__special_characters] = ACTIONS(4566),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4568),
  },
  [1541] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [1542] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [1543] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [1544] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [1545] = {
    [sym_file_redirect] = STATE(1545),
    [sym_heredoc_redirect] = STATE(1545),
    [sym_herestring_redirect] = STATE(1545),
    [aux_sym_while_statement_repeat1] = STATE(1545),
    [sym_file_descriptor] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4573),
    [anon_sym_GT_GT] = ACTIONS(4573),
    [anon_sym_AMP_GT] = ACTIONS(4573),
    [anon_sym_AMP_GT_GT] = ACTIONS(4573),
    [anon_sym_LT_AMP] = ACTIONS(4573),
    [anon_sym_GT_AMP] = ACTIONS(4573),
    [anon_sym_LT_LT] = ACTIONS(3707),
    [anon_sym_LT_LT_DASH] = ACTIONS(3707),
    [anon_sym_LT_LT_LT] = ACTIONS(4576),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(1546),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1547] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_RBRACK] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3911),
  },
  [1548] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3917),
  },
  [1549] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_EQ_TILDE] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_RBRACK] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4002),
  },
  [1550] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1551] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4581),
    [sym_comment] = ACTIONS(54),
  },
  [1552] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4583),
    [sym_comment] = ACTIONS(54),
  },
  [1553] = {
    [anon_sym_RBRACE] = ACTIONS(4583),
    [sym_comment] = ACTIONS(54),
  },
  [1554] = {
    [sym_concatenation] = STATE(1962),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1962),
    [anon_sym_RBRACE] = ACTIONS(4585),
    [anon_sym_EQ] = ACTIONS(4587),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4587),
    [anon_sym_COLON_QMARK] = ACTIONS(4587),
    [anon_sym_COLON_DASH] = ACTIONS(4587),
    [anon_sym_PERCENT] = ACTIONS(4587),
    [anon_sym_DASH] = ACTIONS(4587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1555] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_EQ_TILDE] = ACTIONS(4018),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4018),
  },
  [1556] = {
    [sym_concatenation] = STATE(1964),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1964),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(4593),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4593),
    [anon_sym_COLON_QMARK] = ACTIONS(4593),
    [anon_sym_COLON_DASH] = ACTIONS(4593),
    [anon_sym_PERCENT] = ACTIONS(4593),
    [anon_sym_DASH] = ACTIONS(4593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1557] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_RBRACK] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4028),
  },
  [1558] = {
    [sym_concatenation] = STATE(1966),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_EQ] = ACTIONS(4599),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4599),
    [anon_sym_COLON_QMARK] = ACTIONS(4599),
    [anon_sym_COLON_DASH] = ACTIONS(4599),
    [anon_sym_PERCENT] = ACTIONS(4599),
    [anon_sym_DASH] = ACTIONS(4599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1559] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4038),
  },
  [1560] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4603),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1561] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4044),
  },
  [1562] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1563] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [1564] = {
    [aux_sym_concatenation_repeat1] = STATE(1567),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1565] = {
    [sym_file_descriptor] = ACTIONS(1083),
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1566] = {
    [sym_string] = STATE(1969),
    [sym_simple_expansion] = STATE(1969),
    [sym_string_expansion] = STATE(1969),
    [sym_expansion] = STATE(1969),
    [sym_command_substitution] = STATE(1969),
    [sym_process_substitution] = STATE(1969),
    [sym__special_characters] = ACTIONS(4607),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(4607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4607),
  },
  [1567] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1568] = {
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(698),
    [anon_sym_LT_LT_LT] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [1569] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(4609),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1570] = {
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_LT] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [1571] = {
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_LT] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [1572] = {
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(736),
    [anon_sym_LT_LT_LT] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [1573] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4611),
    [sym_comment] = ACTIONS(54),
  },
  [1574] = {
    [sym_concatenation] = STATE(1975),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1975),
    [anon_sym_RBRACE] = ACTIONS(4613),
    [anon_sym_EQ] = ACTIONS(4615),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4619),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_COLON_QMARK] = ACTIONS(4615),
    [anon_sym_COLON_DASH] = ACTIONS(4615),
    [anon_sym_PERCENT] = ACTIONS(4615),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1575] = {
    [sym_subscript] = STATE(1979),
    [sym_variable_name] = ACTIONS(4621),
    [anon_sym_DOLLAR] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_AT] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(4623),
    [anon_sym_0] = ACTIONS(4627),
    [anon_sym__] = ACTIONS(4627),
  },
  [1576] = {
    [sym_concatenation] = STATE(1982),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1982),
    [anon_sym_RBRACE] = ACTIONS(4629),
    [anon_sym_EQ] = ACTIONS(4631),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4635),
    [anon_sym_COLON] = ACTIONS(4631),
    [anon_sym_COLON_QMARK] = ACTIONS(4631),
    [anon_sym_COLON_DASH] = ACTIONS(4631),
    [anon_sym_PERCENT] = ACTIONS(4631),
    [anon_sym_DASH] = ACTIONS(4631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1577] = {
    [sym_concatenation] = STATE(1985),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1985),
    [anon_sym_RBRACE] = ACTIONS(4637),
    [anon_sym_EQ] = ACTIONS(4639),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4639),
    [anon_sym_COLON_QMARK] = ACTIONS(4639),
    [anon_sym_COLON_DASH] = ACTIONS(4639),
    [anon_sym_PERCENT] = ACTIONS(4639),
    [anon_sym_DASH] = ACTIONS(4639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1578] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(4645),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1579] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(4645),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1580] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(4645),
    [sym_comment] = ACTIONS(54),
  },
  [1581] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(4645),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1582] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [1583] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [1584] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3911),
  },
  [1585] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3917),
  },
  [1586] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_EQ_TILDE] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4002),
  },
  [1587] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4649),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1588] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [sym_comment] = ACTIONS(54),
  },
  [1589] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4653),
    [sym_comment] = ACTIONS(54),
  },
  [1590] = {
    [anon_sym_RBRACE] = ACTIONS(4653),
    [sym_comment] = ACTIONS(54),
  },
  [1591] = {
    [sym_concatenation] = STATE(1992),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1992),
    [anon_sym_RBRACE] = ACTIONS(4655),
    [anon_sym_EQ] = ACTIONS(4657),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4657),
    [anon_sym_COLON_QMARK] = ACTIONS(4657),
    [anon_sym_COLON_DASH] = ACTIONS(4657),
    [anon_sym_PERCENT] = ACTIONS(4657),
    [anon_sym_DASH] = ACTIONS(4657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1592] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4016),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_EQ_TILDE] = ACTIONS(4018),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4018),
  },
  [1593] = {
    [sym_concatenation] = STATE(1994),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1994),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [anon_sym_EQ] = ACTIONS(4663),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4663),
    [anon_sym_COLON_QMARK] = ACTIONS(4663),
    [anon_sym_COLON_DASH] = ACTIONS(4663),
    [anon_sym_PERCENT] = ACTIONS(4663),
    [anon_sym_DASH] = ACTIONS(4663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1594] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4028),
  },
  [1595] = {
    [sym_concatenation] = STATE(1996),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(1996),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_COLON_QMARK] = ACTIONS(4669),
    [anon_sym_COLON_DASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1596] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4038),
  },
  [1597] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1598] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4044),
  },
  [1599] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1600] = {
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_SEMI_SEMI] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [sym__special_characters] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3375),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_LT_LPAREN] = ACTIONS(3375),
    [anon_sym_GT_LPAREN] = ACTIONS(3375),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3375),
    [sym_word] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [1601] = {
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1602] = {
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1603] = {
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [1604] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4677),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1605] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4679),
    [sym_comment] = ACTIONS(54),
  },
  [1606] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [sym_comment] = ACTIONS(54),
  },
  [1607] = {
    [anon_sym_RBRACE] = ACTIONS(4681),
    [sym_comment] = ACTIONS(54),
  },
  [1608] = {
    [sym_concatenation] = STATE(2003),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2003),
    [anon_sym_RBRACE] = ACTIONS(4683),
    [anon_sym_EQ] = ACTIONS(4685),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4687),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4685),
    [anon_sym_COLON_QMARK] = ACTIONS(4685),
    [anon_sym_COLON_DASH] = ACTIONS(4685),
    [anon_sym_PERCENT] = ACTIONS(4685),
    [anon_sym_DASH] = ACTIONS(4685),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1609] = {
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1610] = {
    [sym_concatenation] = STATE(2005),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2005),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(4691),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COLON_QMARK] = ACTIONS(4691),
    [anon_sym_COLON_DASH] = ACTIONS(4691),
    [anon_sym_PERCENT] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1611] = {
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [1612] = {
    [sym_concatenation] = STATE(2007),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2007),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4697),
    [anon_sym_COLON_QMARK] = ACTIONS(4697),
    [anon_sym_COLON_DASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1613] = {
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [1614] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1615] = {
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [1616] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1617] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1618] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1619] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [1620] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1621] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4707),
    [sym_comment] = ACTIONS(54),
  },
  [1622] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [sym_comment] = ACTIONS(54),
  },
  [1623] = {
    [anon_sym_RBRACE] = ACTIONS(4709),
    [sym_comment] = ACTIONS(54),
  },
  [1624] = {
    [sym_concatenation] = STATE(2014),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2014),
    [anon_sym_RBRACE] = ACTIONS(4711),
    [anon_sym_EQ] = ACTIONS(4713),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4713),
    [anon_sym_COLON_QMARK] = ACTIONS(4713),
    [anon_sym_COLON_DASH] = ACTIONS(4713),
    [anon_sym_PERCENT] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1625] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1626] = {
    [sym_concatenation] = STATE(2016),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2016),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4719),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4719),
    [anon_sym_COLON_QMARK] = ACTIONS(4719),
    [anon_sym_COLON_DASH] = ACTIONS(4719),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_DASH] = ACTIONS(4719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1627] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [1628] = {
    [sym_concatenation] = STATE(2018),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2018),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4725),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4725),
    [anon_sym_COLON_QMARK] = ACTIONS(4725),
    [anon_sym_COLON_DASH] = ACTIONS(4725),
    [anon_sym_PERCENT] = ACTIONS(4725),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1629] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [1630] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1631] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [1632] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1633] = {
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_PIPE_AMP] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3909),
    [anon_sym_LT_AMP] = ACTIONS(3909),
    [anon_sym_GT_AMP] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3909),
  },
  [1634] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3915),
  },
  [1635] = {
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_PIPE_AMP] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4000),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4000),
    [anon_sym_LT_AMP] = ACTIONS(4000),
    [anon_sym_GT_AMP] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4000),
  },
  [1636] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4733),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1637] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(54),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4737),
    [sym_comment] = ACTIONS(54),
  },
  [1639] = {
    [anon_sym_RBRACE] = ACTIONS(4737),
    [sym_comment] = ACTIONS(54),
  },
  [1640] = {
    [sym_concatenation] = STATE(2025),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2025),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4741),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4741),
    [anon_sym_COLON_QMARK] = ACTIONS(4741),
    [anon_sym_COLON_DASH] = ACTIONS(4741),
    [anon_sym_PERCENT] = ACTIONS(4741),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1641] = {
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4016),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4016),
    [anon_sym_LT_AMP] = ACTIONS(4016),
    [anon_sym_GT_AMP] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4016),
  },
  [1642] = {
    [sym_concatenation] = STATE(2027),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2027),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_EQ] = ACTIONS(4747),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4747),
    [anon_sym_COLON_QMARK] = ACTIONS(4747),
    [anon_sym_COLON_DASH] = ACTIONS(4747),
    [anon_sym_PERCENT] = ACTIONS(4747),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1643] = {
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4026),
  },
  [1644] = {
    [sym_concatenation] = STATE(2029),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2029),
    [anon_sym_RBRACE] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4753),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4753),
    [anon_sym_COLON_QMARK] = ACTIONS(4753),
    [anon_sym_COLON_DASH] = ACTIONS(4753),
    [anon_sym_PERCENT] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1645] = {
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4036),
  },
  [1646] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1647] = {
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_PIPE_AMP] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4042),
    [anon_sym_LT_AMP] = ACTIONS(4042),
    [anon_sym_GT_AMP] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4042),
  },
  [1648] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1649] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym__string_content] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
  },
  [1650] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym__string_content] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
  },
  [1651] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym__string_content] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
  },
  [1652] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1653] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [sym_comment] = ACTIONS(54),
  },
  [1654] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(54),
  },
  [1655] = {
    [anon_sym_RBRACE] = ACTIONS(4765),
    [sym_comment] = ACTIONS(54),
  },
  [1656] = {
    [sym_concatenation] = STATE(2036),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2036),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_EQ] = ACTIONS(4769),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4769),
    [anon_sym_COLON_QMARK] = ACTIONS(4769),
    [anon_sym_COLON_DASH] = ACTIONS(4769),
    [anon_sym_PERCENT] = ACTIONS(4769),
    [anon_sym_DASH] = ACTIONS(4769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1657] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym__string_content] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
  },
  [1658] = {
    [sym_concatenation] = STATE(2038),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2038),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_EQ] = ACTIONS(4775),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4775),
    [anon_sym_COLON_QMARK] = ACTIONS(4775),
    [anon_sym_COLON_DASH] = ACTIONS(4775),
    [anon_sym_PERCENT] = ACTIONS(4775),
    [anon_sym_DASH] = ACTIONS(4775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1659] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym__string_content] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
  },
  [1660] = {
    [sym_concatenation] = STATE(2040),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2040),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [anon_sym_EQ] = ACTIONS(4781),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4783),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4781),
    [anon_sym_COLON_QMARK] = ACTIONS(4781),
    [anon_sym_COLON_DASH] = ACTIONS(4781),
    [anon_sym_PERCENT] = ACTIONS(4781),
    [anon_sym_DASH] = ACTIONS(4781),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1661] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym__string_content] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
  },
  [1662] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4785),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1663] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym__string_content] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
  },
  [1664] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1665] = {
    [sym__concat] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_EQ] = ACTIONS(4791),
    [sym__special_characters] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_DOLLAR] = ACTIONS(4791),
    [sym_raw_string] = ACTIONS(3325),
    [anon_sym_POUND] = ACTIONS(3325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3325),
    [aux_sym_SLASH] = ACTIONS(3325),
    [anon_sym_COLON] = ACTIONS(4791),
    [anon_sym_COLON_QMARK] = ACTIONS(4791),
    [anon_sym_COLON_DASH] = ACTIONS(4791),
    [anon_sym_PERCENT] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3325),
    [anon_sym_BQUOTE] = ACTIONS(3325),
    [anon_sym_LT_LPAREN] = ACTIONS(3325),
    [anon_sym_GT_LPAREN] = ACTIONS(3325),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4791),
  },
  [1666] = {
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_EQ] = ACTIONS(4791),
    [sym__special_characters] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_DOLLAR] = ACTIONS(4791),
    [sym_raw_string] = ACTIONS(3325),
    [anon_sym_POUND] = ACTIONS(3325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3325),
    [aux_sym_SLASH] = ACTIONS(3325),
    [anon_sym_COLON] = ACTIONS(4791),
    [anon_sym_COLON_QMARK] = ACTIONS(4791),
    [anon_sym_COLON_DASH] = ACTIONS(4791),
    [anon_sym_PERCENT] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3325),
    [anon_sym_BQUOTE] = ACTIONS(3325),
    [anon_sym_LT_LPAREN] = ACTIONS(3325),
    [anon_sym_GT_LPAREN] = ACTIONS(3325),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4791),
  },
  [1667] = {
    [sym__concat] = ACTIONS(4793),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_EQ] = ACTIONS(4795),
    [sym__special_characters] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_DOLLAR] = ACTIONS(4795),
    [sym_raw_string] = ACTIONS(3329),
    [anon_sym_POUND] = ACTIONS(3329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3329),
    [aux_sym_SLASH] = ACTIONS(3329),
    [anon_sym_COLON] = ACTIONS(4795),
    [anon_sym_COLON_QMARK] = ACTIONS(4795),
    [anon_sym_COLON_DASH] = ACTIONS(4795),
    [anon_sym_PERCENT] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3329),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [anon_sym_LT_LPAREN] = ACTIONS(3329),
    [anon_sym_GT_LPAREN] = ACTIONS(3329),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4795),
  },
  [1668] = {
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_EQ] = ACTIONS(4795),
    [sym__special_characters] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_DOLLAR] = ACTIONS(4795),
    [sym_raw_string] = ACTIONS(3329),
    [anon_sym_POUND] = ACTIONS(3329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3329),
    [aux_sym_SLASH] = ACTIONS(3329),
    [anon_sym_COLON] = ACTIONS(4795),
    [anon_sym_COLON_QMARK] = ACTIONS(4795),
    [anon_sym_COLON_DASH] = ACTIONS(4795),
    [anon_sym_PERCENT] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3329),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [anon_sym_LT_LPAREN] = ACTIONS(3329),
    [anon_sym_GT_LPAREN] = ACTIONS(3329),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4795),
  },
  [1669] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [1670] = {
    [aux_sym_concatenation_repeat1] = STATE(1670),
    [sym__concat] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [1671] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
  },
  [1672] = {
    [sym_concatenation] = STATE(2048),
    [sym_string] = STATE(2047),
    [sym_simple_expansion] = STATE(2047),
    [sym_string_expansion] = STATE(2047),
    [sym_expansion] = STATE(2047),
    [sym_command_substitution] = STATE(2047),
    [sym_process_substitution] = STATE(2047),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [sym__special_characters] = ACTIONS(4802),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4804),
  },
  [1673] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
  },
  [1674] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4806),
  },
  [1675] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4808),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1676] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(4810),
    [sym_comment] = ACTIONS(54),
  },
  [1677] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4814),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4818),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_COLON_QMARK] = ACTIONS(4814),
    [anon_sym_COLON_DASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1678] = {
    [sym_concatenation] = STATE(2057),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2057),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4822),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_COLON_QMARK] = ACTIONS(4822),
    [anon_sym_COLON_DASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1679] = {
    [sym_concatenation] = STATE(2059),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2059),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(4828),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(4832),
    [anon_sym_COLON] = ACTIONS(4828),
    [anon_sym_COLON_QMARK] = ACTIONS(4828),
    [anon_sym_COLON_DASH] = ACTIONS(4828),
    [anon_sym_PERCENT] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1680] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_RBRACE] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
  },
  [1681] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4834),
  },
  [1682] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1683] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_RBRACE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
  },
  [1684] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4838),
  },
  [1685] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1686] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
  },
  [1687] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
  },
  [1688] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_RBRACE] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_POUND] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_COLON_QMARK] = ACTIONS(2746),
    [anon_sym_COLON_DASH] = ACTIONS(2746),
    [anon_sym_PERCENT] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
  },
  [1689] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [sym_comment] = ACTIONS(54),
  },
  [1690] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [sym_comment] = ACTIONS(54),
  },
  [1691] = {
    [anon_sym_RBRACE] = ACTIONS(4842),
    [sym_comment] = ACTIONS(54),
  },
  [1692] = {
    [sym_concatenation] = STATE(2066),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [anon_sym_EQ] = ACTIONS(4846),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4846),
    [anon_sym_COLON_QMARK] = ACTIONS(4846),
    [anon_sym_COLON_DASH] = ACTIONS(4846),
    [anon_sym_PERCENT] = ACTIONS(4846),
    [anon_sym_DASH] = ACTIONS(4846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1693] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_EQ] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_POUND] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_COLON] = ACTIONS(2824),
    [anon_sym_COLON_QMARK] = ACTIONS(2824),
    [anon_sym_COLON_DASH] = ACTIONS(2824),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
  },
  [1694] = {
    [sym_concatenation] = STATE(2069),
    [sym_string] = STATE(2068),
    [sym_simple_expansion] = STATE(2068),
    [sym_string_expansion] = STATE(2068),
    [sym_expansion] = STATE(2068),
    [sym_command_substitution] = STATE(2068),
    [sym_process_substitution] = STATE(2068),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [sym__special_characters] = ACTIONS(4850),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4852),
  },
  [1695] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_POUND] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_DASH] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
  },
  [1696] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4854),
  },
  [1697] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4856),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1698] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_COLON_QMARK] = ACTIONS(2875),
    [anon_sym_COLON_DASH] = ACTIONS(2875),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
  },
  [1699] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4858),
  },
  [1700] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1701] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4862),
  },
  [1702] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1703] = {
    [sym_concatenation] = STATE(2076),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2076),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(4866),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4868),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4866),
    [anon_sym_COLON_QMARK] = ACTIONS(4866),
    [anon_sym_COLON_DASH] = ACTIONS(4866),
    [anon_sym_PERCENT] = ACTIONS(4866),
    [anon_sym_DASH] = ACTIONS(4866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1704] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_POUND] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_DASH] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
  },
  [1705] = {
    [sym_concatenation] = STATE(2078),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [anon_sym_RBRACE] = ACTIONS(4870),
    [anon_sym_EQ] = ACTIONS(4872),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4872),
    [anon_sym_COLON_QMARK] = ACTIONS(4872),
    [anon_sym_COLON_DASH] = ACTIONS(4872),
    [anon_sym_PERCENT] = ACTIONS(4872),
    [anon_sym_DASH] = ACTIONS(4872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1706] = {
    [sym__simple_heredoc_body] = ACTIONS(4876),
    [sym__heredoc_body_beginning] = ACTIONS(4876),
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_EQ_TILDE] = ACTIONS(4878),
    [anon_sym_EQ_EQ] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4878),
    [anon_sym_LT_LT_LT] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [1707] = {
    [sym__simple_heredoc_body] = ACTIONS(4880),
    [sym__heredoc_body_beginning] = ACTIONS(4880),
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_EQ_TILDE] = ACTIONS(4882),
    [anon_sym_EQ_EQ] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4882),
    [anon_sym_LT_LT_LT] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [1708] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [1709] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [1710] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1711] = {
    [sym__simple_heredoc_body] = ACTIONS(4894),
    [sym__heredoc_body_beginning] = ACTIONS(4894),
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [1712] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1713] = {
    [sym__simple_heredoc_body] = ACTIONS(4900),
    [sym__heredoc_body_beginning] = ACTIONS(4900),
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [1714] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1715] = {
    [sym__simple_heredoc_body] = ACTIONS(4906),
    [sym__heredoc_body_beginning] = ACTIONS(4906),
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [1716] = {
    [sym__simple_heredoc_body] = ACTIONS(4910),
    [sym__heredoc_body_beginning] = ACTIONS(4910),
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_EQ_TILDE] = ACTIONS(4912),
    [anon_sym_EQ_EQ] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [1717] = {
    [sym_file_descriptor] = ACTIONS(3373),
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3373),
    [anon_sym_PIPE_AMP] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_PIPE_PIPE] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3373),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3373),
    [anon_sym_LT_AMP] = ACTIONS(3373),
    [anon_sym_GT_AMP] = ACTIONS(3373),
    [sym__special_characters] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3373),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [anon_sym_LT_LPAREN] = ACTIONS(3373),
    [anon_sym_GT_LPAREN] = ACTIONS(3373),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3373),
  },
  [1718] = {
    [aux_sym_concatenation_repeat1] = STATE(1718),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(2647),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [1719] = {
    [sym_do_group] = STATE(2082),
    [anon_sym_do] = ACTIONS(2901),
    [sym_comment] = ACTIONS(54),
  },
  [1720] = {
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_PIPE_AMP] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [sym_comment] = ACTIONS(54),
  },
  [1721] = {
    [sym__terminated_statement] = STATE(1049),
    [sym_for_statement] = STATE(595),
    [sym_while_statement] = STATE(595),
    [sym_if_statement] = STATE(595),
    [sym_case_statement] = STATE(595),
    [sym_function_definition] = STATE(595),
    [sym_subshell] = STATE(595),
    [sym_pipeline] = STATE(595),
    [sym_list] = STATE(595),
    [sym_command] = STATE(595),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(595),
    [sym_variable_assignment] = STATE(596),
    [sym_declaration_command] = STATE(595),
    [sym_unset_command] = STATE(595),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1049),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4914),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1722] = {
    [sym__simple_heredoc_body] = ACTIONS(3516),
    [sym__heredoc_body_beginning] = ACTIONS(3516),
    [sym_file_descriptor] = ACTIONS(3516),
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3516),
    [anon_sym_PIPE_AMP] = ACTIONS(3516),
    [anon_sym_AMP_AMP] = ACTIONS(3516),
    [anon_sym_PIPE_PIPE] = ACTIONS(3516),
    [anon_sym_LT] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3518),
    [anon_sym_GT_GT] = ACTIONS(3516),
    [anon_sym_AMP_GT] = ACTIONS(3518),
    [anon_sym_AMP_GT_GT] = ACTIONS(3516),
    [anon_sym_LT_AMP] = ACTIONS(3516),
    [anon_sym_GT_AMP] = ACTIONS(3516),
    [anon_sym_LT_LT] = ACTIONS(3518),
    [anon_sym_LT_LT_DASH] = ACTIONS(3516),
    [anon_sym_LT_LT_LT] = ACTIONS(3516),
    [anon_sym_BQUOTE] = ACTIONS(3516),
    [sym_comment] = ACTIONS(54),
  },
  [1723] = {
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_PIPE_AMP] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_BQUOTE] = ACTIONS(3524),
    [sym_comment] = ACTIONS(54),
  },
  [1724] = {
    [anon_sym_PIPE] = ACTIONS(3534),
    [anon_sym_RPAREN] = ACTIONS(3536),
    [anon_sym_PIPE_AMP] = ACTIONS(3536),
    [anon_sym_AMP_AMP] = ACTIONS(3536),
    [anon_sym_PIPE_PIPE] = ACTIONS(3536),
    [anon_sym_BQUOTE] = ACTIONS(3536),
    [sym_comment] = ACTIONS(54),
  },
  [1725] = {
    [anon_sym_fi] = ACTIONS(4916),
    [sym_comment] = ACTIONS(54),
  },
  [1726] = {
    [sym_elif_clause] = STATE(1060),
    [sym_else_clause] = STATE(2085),
    [aux_sym_if_statement_repeat1] = STATE(1060),
    [anon_sym_fi] = ACTIONS(4916),
    [anon_sym_elif] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2299),
    [sym_comment] = ACTIONS(54),
  },
  [1727] = {
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_RPAREN] = ACTIONS(3547),
    [anon_sym_PIPE_AMP] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BQUOTE] = ACTIONS(3547),
    [sym_comment] = ACTIONS(54),
  },
  [1728] = {
    [anon_sym_esac] = ACTIONS(4918),
    [sym_comment] = ACTIONS(54),
  },
  [1729] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(2087),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1730] = {
    [sym_case_item] = STATE(2089),
    [sym_last_case_item] = STATE(2087),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(2089),
    [anon_sym_esac] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1731] = {
    [anon_sym_PIPE] = ACTIONS(3559),
    [anon_sym_RPAREN] = ACTIONS(3561),
    [anon_sym_PIPE_AMP] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3561),
    [anon_sym_PIPE_PIPE] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(3561),
    [sym_comment] = ACTIONS(54),
  },
  [1732] = {
    [anon_sym_esac] = ACTIONS(4922),
    [sym_comment] = ACTIONS(54),
  },
  [1733] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(2091),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [1734] = {
    [sym_case_item] = STATE(2093),
    [sym_last_case_item] = STATE(2091),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(2093),
    [anon_sym_esac] = ACTIONS(4924),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2307),
  },
  [1735] = {
    [sym_file_redirect] = STATE(2094),
    [sym_file_descriptor] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_RPAREN] = ACTIONS(3605),
    [anon_sym_PIPE_AMP] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2927),
    [anon_sym_AMP_GT] = ACTIONS(2925),
    [anon_sym_AMP_GT_GT] = ACTIONS(2927),
    [anon_sym_LT_AMP] = ACTIONS(2927),
    [anon_sym_GT_AMP] = ACTIONS(2927),
    [sym_comment] = ACTIONS(54),
  },
  [1736] = {
    [sym_file_descriptor] = ACTIONS(3607),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3607),
    [anon_sym_PIPE_AMP] = ACTIONS(3607),
    [anon_sym_AMP_AMP] = ACTIONS(3607),
    [anon_sym_PIPE_PIPE] = ACTIONS(3607),
    [anon_sym_LT] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3609),
    [anon_sym_GT_GT] = ACTIONS(3607),
    [anon_sym_AMP_GT] = ACTIONS(3609),
    [anon_sym_AMP_GT_GT] = ACTIONS(3607),
    [anon_sym_LT_AMP] = ACTIONS(3607),
    [anon_sym_GT_AMP] = ACTIONS(3607),
    [anon_sym_BQUOTE] = ACTIONS(3607),
    [sym_comment] = ACTIONS(54),
  },
  [1737] = {
    [sym_concatenation] = STATE(2097),
    [sym_string] = STATE(2096),
    [sym_simple_expansion] = STATE(2096),
    [sym_string_expansion] = STATE(2096),
    [sym_expansion] = STATE(2096),
    [sym_command_substitution] = STATE(2096),
    [sym_process_substitution] = STATE(2096),
    [sym__special_characters] = ACTIONS(4926),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(4928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4928),
  },
  [1738] = {
    [aux_sym_concatenation_repeat1] = STATE(2098),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(660),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [1739] = {
    [aux_sym_concatenation_repeat1] = STATE(2098),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1740] = {
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1741] = {
    [anon_sym_PIPE] = ACTIONS(3635),
    [anon_sym_RPAREN] = ACTIONS(3637),
    [anon_sym_PIPE_AMP] = ACTIONS(3637),
    [anon_sym_AMP_AMP] = ACTIONS(3637),
    [anon_sym_PIPE_PIPE] = ACTIONS(3637),
    [anon_sym_BQUOTE] = ACTIONS(3637),
    [sym_comment] = ACTIONS(54),
  },
  [1742] = {
    [sym_concatenation] = STATE(2101),
    [sym_string] = STATE(2100),
    [sym_simple_expansion] = STATE(2100),
    [sym_string_expansion] = STATE(2100),
    [sym_expansion] = STATE(2100),
    [sym_command_substitution] = STATE(2100),
    [sym_process_substitution] = STATE(2100),
    [sym__special_characters] = ACTIONS(4930),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(4932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4932),
  },
  [1743] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(660),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(660),
    [anon_sym_LT_AMP] = ACTIONS(660),
    [anon_sym_GT_AMP] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(660),
    [anon_sym_LT_LT_LT] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [1744] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2105),
    [anon_sym_DQUOTE] = ACTIONS(4936),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1745] = {
    [sym_string] = STATE(2107),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4938),
    [sym_raw_string] = ACTIONS(4940),
    [anon_sym_POUND] = ACTIONS(4938),
    [anon_sym_DASH] = ACTIONS(4938),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4942),
    [anon_sym_STAR] = ACTIONS(4938),
    [anon_sym_AT] = ACTIONS(4938),
    [anon_sym_QMARK] = ACTIONS(4938),
    [anon_sym_0] = ACTIONS(4944),
    [anon_sym__] = ACTIONS(4944),
  },
  [1746] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1747] = {
    [sym_subscript] = STATE(2113),
    [sym_variable_name] = ACTIONS(4946),
    [anon_sym_DOLLAR] = ACTIONS(4948),
    [anon_sym_POUND] = ACTIONS(4950),
    [anon_sym_DASH] = ACTIONS(4948),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_AT] = ACTIONS(4948),
    [anon_sym_QMARK] = ACTIONS(4948),
    [anon_sym_0] = ACTIONS(4954),
    [anon_sym__] = ACTIONS(4954),
  },
  [1748] = {
    [sym_for_statement] = STATE(2114),
    [sym_while_statement] = STATE(2114),
    [sym_if_statement] = STATE(2114),
    [sym_case_statement] = STATE(2114),
    [sym_function_definition] = STATE(2114),
    [sym_subshell] = STATE(2114),
    [sym_pipeline] = STATE(2114),
    [sym_list] = STATE(2114),
    [sym_command] = STATE(2114),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2114),
    [sym_variable_assignment] = STATE(2115),
    [sym_declaration_command] = STATE(2114),
    [sym_unset_command] = STATE(2114),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1749] = {
    [sym_for_statement] = STATE(2116),
    [sym_while_statement] = STATE(2116),
    [sym_if_statement] = STATE(2116),
    [sym_case_statement] = STATE(2116),
    [sym_function_definition] = STATE(2116),
    [sym_subshell] = STATE(2116),
    [sym_pipeline] = STATE(2116),
    [sym_list] = STATE(2116),
    [sym_command] = STATE(2116),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2116),
    [sym_variable_assignment] = STATE(2117),
    [sym_declaration_command] = STATE(2116),
    [sym_unset_command] = STATE(2116),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [1750] = {
    [sym_for_statement] = STATE(2118),
    [sym_while_statement] = STATE(2118),
    [sym_if_statement] = STATE(2118),
    [sym_case_statement] = STATE(2118),
    [sym_function_definition] = STATE(2118),
    [sym_subshell] = STATE(2118),
    [sym_pipeline] = STATE(2118),
    [sym_list] = STATE(2118),
    [sym_command] = STATE(2118),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2118),
    [sym_variable_assignment] = STATE(2119),
    [sym_declaration_command] = STATE(2118),
    [sym_unset_command] = STATE(2118),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1751] = {
    [sym_file_descriptor] = ACTIONS(676),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1752] = {
    [sym_file_descriptor] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(2070),
    [anon_sym_GT_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT_GT] = ACTIONS(2068),
    [anon_sym_LT_AMP] = ACTIONS(2068),
    [anon_sym_GT_AMP] = ACTIONS(2068),
    [anon_sym_LT_LT] = ACTIONS(2070),
    [anon_sym_LT_LT_DASH] = ACTIONS(2068),
    [anon_sym_LT_LT_LT] = ACTIONS(2068),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(54),
  },
  [1753] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_RPAREN] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(54),
  },
  [1754] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [1755] = {
    [sym_file_descriptor] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [1756] = {
    [sym_file_redirect] = STATE(1756),
    [sym_heredoc_redirect] = STATE(1756),
    [sym_herestring_redirect] = STATE(1756),
    [aux_sym_while_statement_repeat1] = STATE(1756),
    [sym_file_descriptor] = ACTIONS(4956),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_RPAREN] = ACTIONS(2084),
    [anon_sym_PIPE_AMP] = ACTIONS(2084),
    [anon_sym_AMP_AMP] = ACTIONS(2084),
    [anon_sym_PIPE_PIPE] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(4959),
    [anon_sym_GT] = ACTIONS(4959),
    [anon_sym_GT_GT] = ACTIONS(4962),
    [anon_sym_AMP_GT] = ACTIONS(4959),
    [anon_sym_AMP_GT_GT] = ACTIONS(4962),
    [anon_sym_LT_AMP] = ACTIONS(4962),
    [anon_sym_GT_AMP] = ACTIONS(4962),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_LT_LT_DASH] = ACTIONS(4968),
    [anon_sym_LT_LT_LT] = ACTIONS(4971),
    [sym_comment] = ACTIONS(54),
  },
  [1757] = {
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [anon_sym_PIPE_AMP] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [sym__special_characters] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [anon_sym_LT_LPAREN] = ACTIONS(2145),
    [anon_sym_GT_LPAREN] = ACTIONS(2145),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2147),
    [sym_word] = ACTIONS(2147),
  },
  [1758] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(4974),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [1759] = {
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
  },
  [1760] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4976),
    [sym_comment] = ACTIONS(54),
  },
  [1761] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(4978),
    [sym_comment] = ACTIONS(54),
  },
  [1762] = {
    [anon_sym_RBRACE] = ACTIONS(4978),
    [sym_comment] = ACTIONS(54),
  },
  [1763] = {
    [sym_concatenation] = STATE(2124),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2124),
    [anon_sym_RBRACE] = ACTIONS(4980),
    [anon_sym_EQ] = ACTIONS(4982),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(4984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(4982),
    [anon_sym_COLON_QMARK] = ACTIONS(4982),
    [anon_sym_COLON_DASH] = ACTIONS(4982),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [anon_sym_DASH] = ACTIONS(4982),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1764] = {
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
  },
  [1765] = {
    [sym_concatenation] = STATE(2127),
    [sym_string] = STATE(2126),
    [sym_simple_expansion] = STATE(2126),
    [sym_string_expansion] = STATE(2126),
    [sym_expansion] = STATE(2126),
    [sym_command_substitution] = STATE(2126),
    [sym_process_substitution] = STATE(2126),
    [anon_sym_RBRACE] = ACTIONS(4978),
    [sym__special_characters] = ACTIONS(4986),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(4988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4988),
  },
  [1766] = {
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_PIPE_AMP] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
  },
  [1767] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4990),
  },
  [1768] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1769] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
  },
  [1770] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4994),
  },
  [1771] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4996),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1772] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(4998),
  },
  [1773] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(4978),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1774] = {
    [sym_concatenation] = STATE(2134),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2134),
    [anon_sym_RBRACE] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5002),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5002),
    [anon_sym_COLON_QMARK] = ACTIONS(5002),
    [anon_sym_COLON_DASH] = ACTIONS(5002),
    [anon_sym_PERCENT] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1775] = {
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
  },
  [1776] = {
    [sym_concatenation] = STATE(2136),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2136),
    [anon_sym_RBRACE] = ACTIONS(5006),
    [anon_sym_EQ] = ACTIONS(5008),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5008),
    [anon_sym_COLON_QMARK] = ACTIONS(5008),
    [anon_sym_COLON_DASH] = ACTIONS(5008),
    [anon_sym_PERCENT] = ACTIONS(5008),
    [anon_sym_DASH] = ACTIONS(5008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1777] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
  },
  [1778] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5012),
    [sym_comment] = ACTIONS(54),
  },
  [1779] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(54),
  },
  [1780] = {
    [anon_sym_RBRACE] = ACTIONS(5014),
    [sym_comment] = ACTIONS(54),
  },
  [1781] = {
    [sym_concatenation] = STATE(2140),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2140),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_EQ] = ACTIONS(5018),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5018),
    [anon_sym_COLON_QMARK] = ACTIONS(5018),
    [anon_sym_COLON_DASH] = ACTIONS(5018),
    [anon_sym_PERCENT] = ACTIONS(5018),
    [anon_sym_DASH] = ACTIONS(5018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1782] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
  },
  [1783] = {
    [sym_concatenation] = STATE(2143),
    [sym_string] = STATE(2142),
    [sym_simple_expansion] = STATE(2142),
    [sym_string_expansion] = STATE(2142),
    [sym_expansion] = STATE(2142),
    [sym_command_substitution] = STATE(2142),
    [sym_process_substitution] = STATE(2142),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [sym__special_characters] = ACTIONS(5022),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5024),
  },
  [1784] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_PIPE_AMP] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
  },
  [1785] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5026),
  },
  [1786] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5028),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1787] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
  },
  [1788] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5030),
  },
  [1789] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1790] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5034),
  },
  [1791] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1792] = {
    [sym_concatenation] = STATE(2150),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2150),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_EQ] = ACTIONS(5038),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5038),
    [anon_sym_COLON_QMARK] = ACTIONS(5038),
    [anon_sym_COLON_DASH] = ACTIONS(5038),
    [anon_sym_PERCENT] = ACTIONS(5038),
    [anon_sym_DASH] = ACTIONS(5038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1793] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
  },
  [1794] = {
    [sym_concatenation] = STATE(2152),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2152),
    [anon_sym_RBRACE] = ACTIONS(5042),
    [anon_sym_EQ] = ACTIONS(5044),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5044),
    [anon_sym_COLON_QMARK] = ACTIONS(5044),
    [anon_sym_COLON_DASH] = ACTIONS(5044),
    [anon_sym_PERCENT] = ACTIONS(5044),
    [anon_sym_DASH] = ACTIONS(5044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1795] = {
    [sym__simple_heredoc_body] = ACTIONS(3909),
    [sym__heredoc_body_beginning] = ACTIONS(3909),
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_PIPE_AMP] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3909),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3909),
    [anon_sym_LT_AMP] = ACTIONS(3909),
    [anon_sym_GT_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3909),
    [anon_sym_LT_LT_LT] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3911),
  },
  [1796] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3917),
  },
  [1797] = {
    [sym__simple_heredoc_body] = ACTIONS(4000),
    [sym__heredoc_body_beginning] = ACTIONS(4000),
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_PIPE_AMP] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [anon_sym_EQ_TILDE] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4000),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4000),
    [anon_sym_LT_AMP] = ACTIONS(4000),
    [anon_sym_GT_AMP] = ACTIONS(4000),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4000),
    [anon_sym_LT_LT_LT] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4002),
  },
  [1798] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5048),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1799] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5050),
    [sym_comment] = ACTIONS(54),
  },
  [1800] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [sym_comment] = ACTIONS(54),
  },
  [1801] = {
    [anon_sym_RBRACE] = ACTIONS(5052),
    [sym_comment] = ACTIONS(54),
  },
  [1802] = {
    [sym_concatenation] = STATE(2157),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2157),
    [anon_sym_RBRACE] = ACTIONS(5054),
    [anon_sym_EQ] = ACTIONS(5056),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5056),
    [anon_sym_COLON_QMARK] = ACTIONS(5056),
    [anon_sym_COLON_DASH] = ACTIONS(5056),
    [anon_sym_PERCENT] = ACTIONS(5056),
    [anon_sym_DASH] = ACTIONS(5056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1803] = {
    [sym__simple_heredoc_body] = ACTIONS(4016),
    [sym__heredoc_body_beginning] = ACTIONS(4016),
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [anon_sym_EQ_TILDE] = ACTIONS(4018),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4016),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4016),
    [anon_sym_LT_AMP] = ACTIONS(4016),
    [anon_sym_GT_AMP] = ACTIONS(4016),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4016),
    [anon_sym_LT_LT_LT] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4018),
  },
  [1804] = {
    [sym_concatenation] = STATE(2159),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2159),
    [anon_sym_RBRACE] = ACTIONS(5060),
    [anon_sym_EQ] = ACTIONS(5062),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5062),
    [anon_sym_COLON_QMARK] = ACTIONS(5062),
    [anon_sym_COLON_DASH] = ACTIONS(5062),
    [anon_sym_PERCENT] = ACTIONS(5062),
    [anon_sym_DASH] = ACTIONS(5062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1805] = {
    [sym__simple_heredoc_body] = ACTIONS(4026),
    [sym__heredoc_body_beginning] = ACTIONS(4026),
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4028),
  },
  [1806] = {
    [sym_concatenation] = STATE(2161),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2161),
    [anon_sym_RBRACE] = ACTIONS(5066),
    [anon_sym_EQ] = ACTIONS(5068),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_COLON_QMARK] = ACTIONS(5068),
    [anon_sym_COLON_DASH] = ACTIONS(5068),
    [anon_sym_PERCENT] = ACTIONS(5068),
    [anon_sym_DASH] = ACTIONS(5068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1807] = {
    [sym__simple_heredoc_body] = ACTIONS(4036),
    [sym__heredoc_body_beginning] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4038),
  },
  [1808] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1809] = {
    [sym__simple_heredoc_body] = ACTIONS(4042),
    [sym__heredoc_body_beginning] = ACTIONS(4042),
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_PIPE_AMP] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4042),
    [anon_sym_LT_AMP] = ACTIONS(4042),
    [anon_sym_GT_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4042),
    [anon_sym_LT_LT_LT] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4044),
  },
  [1810] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1811] = {
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_RPAREN] = ACTIONS(3605),
    [anon_sym_PIPE_AMP] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_BQUOTE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(54),
  },
  [1812] = {
    [aux_sym_concatenation_repeat1] = STATE(1812),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [1813] = {
    [anon_sym_PIPE] = ACTIONS(4296),
    [anon_sym_RPAREN] = ACTIONS(4298),
    [anon_sym_PIPE_AMP] = ACTIONS(4298),
    [anon_sym_AMP_AMP] = ACTIONS(4298),
    [anon_sym_PIPE_PIPE] = ACTIONS(4298),
    [anon_sym_BQUOTE] = ACTIONS(4298),
    [sym_comment] = ACTIONS(54),
  },
  [1814] = {
    [aux_sym_concatenation_repeat1] = STATE(1814),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(2647),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [sym__special_characters] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LT_LPAREN] = ACTIONS(1660),
    [anon_sym_GT_LPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1660),
  },
  [1815] = {
    [sym_file_redirect] = STATE(2094),
    [sym_file_descriptor] = ACTIONS(3203),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_PIPE_AMP] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3605),
    [anon_sym_LT] = ACTIONS(3205),
    [anon_sym_GT] = ACTIONS(3205),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_AMP_GT] = ACTIONS(3205),
    [anon_sym_AMP_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_AMP] = ACTIONS(3207),
    [anon_sym_GT_AMP] = ACTIONS(3207),
    [anon_sym_BQUOTE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(54),
  },
  [1816] = {
    [sym_concatenation] = STATE(2097),
    [sym_string] = STATE(2165),
    [sym_simple_expansion] = STATE(2165),
    [sym_string_expansion] = STATE(2165),
    [sym_expansion] = STATE(2165),
    [sym_command_substitution] = STATE(2165),
    [sym_process_substitution] = STATE(2165),
    [sym__special_characters] = ACTIONS(5076),
    [anon_sym_DQUOTE] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(5078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [anon_sym_LT_LPAREN] = ACTIONS(838),
    [anon_sym_GT_LPAREN] = ACTIONS(838),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5078),
  },
  [1817] = {
    [aux_sym_concatenation_repeat1] = STATE(2166),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [1818] = {
    [aux_sym_concatenation_repeat1] = STATE(2166),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1819] = {
    [sym_concatenation] = STATE(2101),
    [sym_string] = STATE(2168),
    [sym_simple_expansion] = STATE(2168),
    [sym_string_expansion] = STATE(2168),
    [sym_expansion] = STATE(2168),
    [sym_command_substitution] = STATE(2168),
    [sym_process_substitution] = STATE(2168),
    [sym__special_characters] = ACTIONS(5080),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(5082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5082),
  },
  [1820] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(660),
    [anon_sym_AMP_AMP] = ACTIONS(660),
    [anon_sym_PIPE_PIPE] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(660),
    [anon_sym_LT_AMP] = ACTIONS(660),
    [anon_sym_GT_AMP] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(660),
    [anon_sym_LT_LT_LT] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(660),
    [sym_comment] = ACTIONS(54),
  },
  [1821] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(676),
    [anon_sym_AMP_AMP] = ACTIONS(676),
    [anon_sym_PIPE_PIPE] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(676),
    [anon_sym_LT_AMP] = ACTIONS(676),
    [anon_sym_GT_AMP] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(676),
    [anon_sym_LT_LT_LT] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(676),
    [sym_comment] = ACTIONS(54),
  },
  [1822] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [anon_sym_BQUOTE] = ACTIONS(2072),
    [sym_comment] = ACTIONS(54),
  },
  [1823] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [sym_comment] = ACTIONS(54),
  },
  [1824] = {
    [sym_file_redirect] = STATE(1824),
    [sym_heredoc_redirect] = STATE(1824),
    [sym_herestring_redirect] = STATE(1824),
    [aux_sym_while_statement_repeat1] = STATE(1824),
    [sym_file_descriptor] = ACTIONS(5084),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2084),
    [anon_sym_AMP_AMP] = ACTIONS(2084),
    [anon_sym_PIPE_PIPE] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(5087),
    [anon_sym_GT] = ACTIONS(5087),
    [anon_sym_GT_GT] = ACTIONS(5090),
    [anon_sym_AMP_GT] = ACTIONS(5087),
    [anon_sym_AMP_GT_GT] = ACTIONS(5090),
    [anon_sym_LT_AMP] = ACTIONS(5090),
    [anon_sym_GT_AMP] = ACTIONS(5090),
    [anon_sym_LT_LT] = ACTIONS(4965),
    [anon_sym_LT_LT_DASH] = ACTIONS(4968),
    [anon_sym_LT_LT_LT] = ACTIONS(5093),
    [anon_sym_BQUOTE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(54),
  },
  [1825] = {
    [aux_sym_concatenation_repeat1] = STATE(1825),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [1826] = {
    [sym__heredoc_body_middle] = ACTIONS(2744),
    [sym__heredoc_body_end] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
  },
  [1827] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5096),
    [sym_comment] = ACTIONS(54),
  },
  [1828] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [sym_comment] = ACTIONS(54),
  },
  [1829] = {
    [anon_sym_RBRACE] = ACTIONS(5098),
    [sym_comment] = ACTIONS(54),
  },
  [1830] = {
    [sym_concatenation] = STATE(2173),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2173),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_EQ] = ACTIONS(5102),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5102),
    [anon_sym_COLON_QMARK] = ACTIONS(5102),
    [anon_sym_COLON_DASH] = ACTIONS(5102),
    [anon_sym_PERCENT] = ACTIONS(5102),
    [anon_sym_DASH] = ACTIONS(5102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1831] = {
    [sym__heredoc_body_middle] = ACTIONS(2822),
    [sym__heredoc_body_end] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
  },
  [1832] = {
    [sym_concatenation] = STATE(2176),
    [sym_string] = STATE(2175),
    [sym_simple_expansion] = STATE(2175),
    [sym_string_expansion] = STATE(2175),
    [sym_expansion] = STATE(2175),
    [sym_command_substitution] = STATE(2175),
    [sym_process_substitution] = STATE(2175),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [sym__special_characters] = ACTIONS(5106),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5108),
  },
  [1833] = {
    [sym__heredoc_body_middle] = ACTIONS(2865),
    [sym__heredoc_body_end] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
  },
  [1834] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5110),
  },
  [1835] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5112),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1836] = {
    [sym__heredoc_body_middle] = ACTIONS(2873),
    [sym__heredoc_body_end] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
  },
  [1837] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5114),
  },
  [1838] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5116),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1839] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5118),
  },
  [1840] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1841] = {
    [sym_concatenation] = STATE(2183),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2183),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(5122),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5122),
    [anon_sym_COLON_QMARK] = ACTIONS(5122),
    [anon_sym_COLON_DASH] = ACTIONS(5122),
    [anon_sym_PERCENT] = ACTIONS(5122),
    [anon_sym_DASH] = ACTIONS(5122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1842] = {
    [sym__heredoc_body_middle] = ACTIONS(2889),
    [sym__heredoc_body_end] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
  },
  [1843] = {
    [sym_concatenation] = STATE(2185),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2185),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(5128),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_COLON_QMARK] = ACTIONS(5128),
    [anon_sym_COLON_DASH] = ACTIONS(5128),
    [anon_sym_PERCENT] = ACTIONS(5128),
    [anon_sym_DASH] = ACTIONS(5128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1844] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [sym__special_characters] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LT_LPAREN] = ACTIONS(2744),
    [anon_sym_GT_LPAREN] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2744),
  },
  [1845] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5132),
    [sym_comment] = ACTIONS(54),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [sym_comment] = ACTIONS(54),
  },
  [1847] = {
    [anon_sym_RBRACE] = ACTIONS(5134),
    [sym_comment] = ACTIONS(54),
  },
  [1848] = {
    [sym_concatenation] = STATE(2189),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2189),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_EQ] = ACTIONS(5138),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5140),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5138),
    [anon_sym_COLON_QMARK] = ACTIONS(5138),
    [anon_sym_COLON_DASH] = ACTIONS(5138),
    [anon_sym_PERCENT] = ACTIONS(5138),
    [anon_sym_DASH] = ACTIONS(5138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1849] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [anon_sym_LT_LPAREN] = ACTIONS(2822),
    [anon_sym_GT_LPAREN] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2822),
  },
  [1850] = {
    [sym_concatenation] = STATE(2192),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [sym__special_characters] = ACTIONS(5142),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5144),
  },
  [1851] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [sym__special_characters] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [anon_sym_LT_LPAREN] = ACTIONS(2865),
    [anon_sym_GT_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2865),
  },
  [1852] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5146),
  },
  [1853] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1854] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2873),
  },
  [1855] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5150),
  },
  [1856] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1857] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5154),
  },
  [1858] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1859] = {
    [sym_concatenation] = STATE(2199),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5158),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5158),
    [anon_sym_COLON_QMARK] = ACTIONS(5158),
    [anon_sym_COLON_DASH] = ACTIONS(5158),
    [anon_sym_PERCENT] = ACTIONS(5158),
    [anon_sym_DASH] = ACTIONS(5158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1860] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [sym__special_characters] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [anon_sym_LT_LPAREN] = ACTIONS(2889),
    [anon_sym_GT_LPAREN] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2889),
  },
  [1861] = {
    [sym_concatenation] = STATE(2201),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2201),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_EQ] = ACTIONS(5164),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5164),
    [anon_sym_COLON_QMARK] = ACTIONS(5164),
    [anon_sym_COLON_DASH] = ACTIONS(5164),
    [anon_sym_PERCENT] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1862] = {
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1863] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1864] = {
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [1865] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1866] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [sym_comment] = ACTIONS(54),
  },
  [1867] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [sym_comment] = ACTIONS(54),
  },
  [1868] = {
    [anon_sym_RBRACE] = ACTIONS(5172),
    [sym_comment] = ACTIONS(54),
  },
  [1869] = {
    [sym_concatenation] = STATE(2206),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2206),
    [anon_sym_RBRACE] = ACTIONS(5174),
    [anon_sym_EQ] = ACTIONS(5176),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5176),
    [anon_sym_COLON_QMARK] = ACTIONS(5176),
    [anon_sym_COLON_DASH] = ACTIONS(5176),
    [anon_sym_PERCENT] = ACTIONS(5176),
    [anon_sym_DASH] = ACTIONS(5176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1870] = {
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1871] = {
    [sym_concatenation] = STATE(2208),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2208),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(5182),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5182),
    [anon_sym_COLON_QMARK] = ACTIONS(5182),
    [anon_sym_COLON_DASH] = ACTIONS(5182),
    [anon_sym_PERCENT] = ACTIONS(5182),
    [anon_sym_DASH] = ACTIONS(5182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1872] = {
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [1873] = {
    [sym_concatenation] = STATE(2210),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2210),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [anon_sym_EQ] = ACTIONS(5188),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5188),
    [anon_sym_COLON_QMARK] = ACTIONS(5188),
    [anon_sym_COLON_DASH] = ACTIONS(5188),
    [anon_sym_PERCENT] = ACTIONS(5188),
    [anon_sym_DASH] = ACTIONS(5188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1874] = {
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [1875] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1876] = {
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [1877] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1878] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [1879] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [sym_comment] = ACTIONS(54),
  },
  [1880] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [sym_comment] = ACTIONS(54),
  },
  [1881] = {
    [anon_sym_RBRACE] = ACTIONS(5198),
    [sym_comment] = ACTIONS(54),
  },
  [1882] = {
    [sym_concatenation] = STATE(2216),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2216),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(5202),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5202),
    [anon_sym_COLON_QMARK] = ACTIONS(5202),
    [anon_sym_COLON_DASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [anon_sym_DASH] = ACTIONS(5202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1883] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [1884] = {
    [sym_concatenation] = STATE(2219),
    [sym_string] = STATE(2218),
    [sym_simple_expansion] = STATE(2218),
    [sym_string_expansion] = STATE(2218),
    [sym_expansion] = STATE(2218),
    [sym_command_substitution] = STATE(2218),
    [sym_process_substitution] = STATE(2218),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [sym__special_characters] = ACTIONS(5206),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5208),
  },
  [1885] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [1886] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5210),
  },
  [1887] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1888] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1889] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5214),
  },
  [1890] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1891] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5218),
  },
  [1892] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1893] = {
    [sym_concatenation] = STATE(2226),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2226),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_EQ] = ACTIONS(5222),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5224),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5222),
    [anon_sym_COLON_QMARK] = ACTIONS(5222),
    [anon_sym_COLON_DASH] = ACTIONS(5222),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_DASH] = ACTIONS(5222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1894] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [1895] = {
    [sym_concatenation] = STATE(2228),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2228),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_EQ] = ACTIONS(5228),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5230),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_COLON_QMARK] = ACTIONS(5228),
    [anon_sym_COLON_DASH] = ACTIONS(5228),
    [anon_sym_PERCENT] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5228),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1896] = {
    [sym__terminated_statement] = STATE(1058),
    [sym_for_statement] = STATE(603),
    [sym_while_statement] = STATE(603),
    [sym_if_statement] = STATE(603),
    [sym_case_statement] = STATE(603),
    [sym_function_definition] = STATE(603),
    [sym_subshell] = STATE(603),
    [sym_pipeline] = STATE(603),
    [sym_list] = STATE(603),
    [sym_command] = STATE(603),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(603),
    [sym_variable_assignment] = STATE(605),
    [sym_declaration_command] = STATE(603),
    [sym_unset_command] = STATE(603),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(1058),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(5232),
    [anon_sym_elif] = ACTIONS(5232),
    [anon_sym_else] = ACTIONS(5232),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1897] = {
    [anon_sym_esac] = ACTIONS(5234),
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [anon_sym_SEMI_SEMI] = ACTIONS(5234),
    [anon_sym_PIPE_AMP] = ACTIONS(5234),
    [anon_sym_AMP_AMP] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5234),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_LF] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5234),
  },
  [1898] = {
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [sym_comment] = ACTIONS(54),
  },
  [1899] = {
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [sym_comment] = ACTIONS(54),
  },
  [1900] = {
    [anon_sym_PIPE] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [sym_comment] = ACTIONS(54),
  },
  [1901] = {
    [sym__assignment] = STATE(2230),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(5242),
    [anon_sym_PLUS_EQ] = ACTIONS(5242),
    [sym_comment] = ACTIONS(54),
  },
  [1902] = {
    [sym__terminated_statement] = STATE(2231),
    [sym_for_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_case_statement] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_subshell] = STATE(38),
    [sym_pipeline] = STATE(38),
    [sym_list] = STATE(38),
    [sym_command] = STATE(38),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(38),
    [sym_variable_assignment] = STATE(39),
    [sym_declaration_command] = STATE(38),
    [sym_unset_command] = STATE(38),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [1903] = {
    [anon_sym_esac] = ACTIONS(5244),
    [sym__special_characters] = ACTIONS(5246),
    [anon_sym_DQUOTE] = ACTIONS(5246),
    [anon_sym_DOLLAR] = ACTIONS(5248),
    [sym_raw_string] = ACTIONS(5246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5246),
    [anon_sym_BQUOTE] = ACTIONS(5246),
    [anon_sym_LT_LPAREN] = ACTIONS(5246),
    [anon_sym_GT_LPAREN] = ACTIONS(5246),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5248),
  },
  [1904] = {
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5250),
  },
  [1905] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [sym__special_characters] = ACTIONS(108),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [1906] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(2234),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [sym__special_characters] = ACTIONS(128),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [1907] = {
    [sym_variable_assignment] = STATE(2246),
    [sym_subscript] = STATE(2245),
    [sym_concatenation] = STATE(2246),
    [sym_string] = STATE(2239),
    [sym_simple_expansion] = STATE(2239),
    [sym_string_expansion] = STATE(2239),
    [sym_expansion] = STATE(2239),
    [sym_command_substitution] = STATE(2239),
    [sym_process_substitution] = STATE(2239),
    [aux_sym_declaration_command_repeat1] = STATE(2246),
    [sym_variable_name] = ACTIONS(5252),
    [anon_sym_esac] = ACTIONS(148),
    [anon_sym_PIPE] = ACTIONS(148),
    [anon_sym_SEMI_SEMI] = ACTIONS(148),
    [anon_sym_PIPE_AMP] = ACTIONS(148),
    [anon_sym_AMP_AMP] = ACTIONS(148),
    [anon_sym_PIPE_PIPE] = ACTIONS(148),
    [sym__special_characters] = ACTIONS(5254),
    [anon_sym_DQUOTE] = ACTIONS(5256),
    [anon_sym_DOLLAR] = ACTIONS(5258),
    [sym_raw_string] = ACTIONS(5260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5264),
    [anon_sym_BQUOTE] = ACTIONS(5266),
    [anon_sym_LT_LPAREN] = ACTIONS(5268),
    [anon_sym_GT_LPAREN] = ACTIONS(5268),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5270),
    [sym_word] = ACTIONS(5260),
    [anon_sym_SEMI] = ACTIONS(148),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(148),
  },
  [1908] = {
    [sym_concatenation] = STATE(2256),
    [sym_string] = STATE(2250),
    [sym_simple_expansion] = STATE(2250),
    [sym_string_expansion] = STATE(2250),
    [sym_expansion] = STATE(2250),
    [sym_command_substitution] = STATE(2250),
    [sym_process_substitution] = STATE(2250),
    [aux_sym_unset_command_repeat1] = STATE(2256),
    [anon_sym_esac] = ACTIONS(172),
    [anon_sym_PIPE] = ACTIONS(172),
    [anon_sym_SEMI_SEMI] = ACTIONS(172),
    [anon_sym_PIPE_AMP] = ACTIONS(172),
    [anon_sym_AMP_AMP] = ACTIONS(172),
    [anon_sym_PIPE_PIPE] = ACTIONS(172),
    [sym__special_characters] = ACTIONS(5272),
    [anon_sym_DQUOTE] = ACTIONS(5274),
    [anon_sym_DOLLAR] = ACTIONS(5276),
    [sym_raw_string] = ACTIONS(5278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5282),
    [anon_sym_BQUOTE] = ACTIONS(5284),
    [anon_sym_LT_LPAREN] = ACTIONS(5286),
    [anon_sym_GT_LPAREN] = ACTIONS(5286),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5288),
    [sym_word] = ACTIONS(5278),
    [anon_sym_SEMI] = ACTIONS(172),
    [anon_sym_LF] = ACTIONS(192),
    [anon_sym_AMP] = ACTIONS(172),
  },
  [1909] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(210),
    [sym__heredoc_body_beginning] = ACTIONS(210),
    [sym_file_descriptor] = ACTIONS(210),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(214),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_SEMI_SEMI] = ACTIONS(214),
    [anon_sym_PIPE_AMP] = ACTIONS(214),
    [anon_sym_AMP_AMP] = ACTIONS(214),
    [anon_sym_PIPE_PIPE] = ACTIONS(214),
    [anon_sym_EQ_TILDE] = ACTIONS(214),
    [anon_sym_EQ_EQ] = ACTIONS(214),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_AMP_GT] = ACTIONS(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(214),
    [anon_sym_LT_AMP] = ACTIONS(214),
    [anon_sym_GT_AMP] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_LT_LT_DASH] = ACTIONS(214),
    [anon_sym_LT_LT_LT] = ACTIONS(214),
    [sym__special_characters] = ACTIONS(214),
    [anon_sym_DQUOTE] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(214),
    [sym_raw_string] = ACTIONS(214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(214),
    [anon_sym_LT_LPAREN] = ACTIONS(214),
    [anon_sym_GT_LPAREN] = ACTIONS(214),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(214),
    [anon_sym_SEMI] = ACTIONS(214),
    [anon_sym_LF] = ACTIONS(210),
    [anon_sym_AMP] = ACTIONS(214),
  },
  [1910] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2260),
    [anon_sym_DQUOTE] = ACTIONS(5292),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [1911] = {
    [sym_string] = STATE(2262),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(5294),
    [sym_raw_string] = ACTIONS(5296),
    [anon_sym_POUND] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5294),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5298),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_AT] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5294),
    [anon_sym_0] = ACTIONS(5300),
    [anon_sym__] = ACTIONS(5300),
  },
  [1912] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [1913] = {
    [sym_subscript] = STATE(2268),
    [sym_variable_name] = ACTIONS(5302),
    [anon_sym_DOLLAR] = ACTIONS(5304),
    [anon_sym_POUND] = ACTIONS(5306),
    [anon_sym_DASH] = ACTIONS(5304),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5308),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_AT] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5304),
    [anon_sym_0] = ACTIONS(5310),
    [anon_sym__] = ACTIONS(5310),
  },
  [1914] = {
    [sym_for_statement] = STATE(2269),
    [sym_while_statement] = STATE(2269),
    [sym_if_statement] = STATE(2269),
    [sym_case_statement] = STATE(2269),
    [sym_function_definition] = STATE(2269),
    [sym_subshell] = STATE(2269),
    [sym_pipeline] = STATE(2269),
    [sym_list] = STATE(2269),
    [sym_command] = STATE(2269),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2269),
    [sym_variable_assignment] = STATE(2270),
    [sym_declaration_command] = STATE(2269),
    [sym_unset_command] = STATE(2269),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1915] = {
    [sym_for_statement] = STATE(2271),
    [sym_while_statement] = STATE(2271),
    [sym_if_statement] = STATE(2271),
    [sym_case_statement] = STATE(2271),
    [sym_function_definition] = STATE(2271),
    [sym_subshell] = STATE(2271),
    [sym_pipeline] = STATE(2271),
    [sym_list] = STATE(2271),
    [sym_command] = STATE(2271),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2271),
    [sym_variable_assignment] = STATE(2272),
    [sym_declaration_command] = STATE(2271),
    [sym_unset_command] = STATE(2271),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [1916] = {
    [sym_for_statement] = STATE(2273),
    [sym_while_statement] = STATE(2273),
    [sym_if_statement] = STATE(2273),
    [sym_case_statement] = STATE(2273),
    [sym_function_definition] = STATE(2273),
    [sym_subshell] = STATE(2273),
    [sym_pipeline] = STATE(2273),
    [sym_list] = STATE(2273),
    [sym_command] = STATE(2273),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2273),
    [sym_variable_assignment] = STATE(2274),
    [sym_declaration_command] = STATE(2273),
    [sym_unset_command] = STATE(2273),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [1917] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(5312),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [1918] = {
    [anon_sym_esac] = ACTIONS(5244),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5316),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [1919] = {
    [sym_file_redirect] = STATE(2287),
    [sym_heredoc_redirect] = STATE(2287),
    [sym_heredoc_body] = STATE(193),
    [sym_herestring_redirect] = STATE(2287),
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [aux_sym_while_statement_repeat1] = STATE(2287),
    [aux_sym_command_repeat2] = STATE(2288),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(328),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_SEMI_SEMI] = ACTIONS(328),
    [anon_sym_PIPE_AMP] = ACTIONS(328),
    [anon_sym_AMP_AMP] = ACTIONS(328),
    [anon_sym_PIPE_PIPE] = ACTIONS(328),
    [anon_sym_EQ_TILDE] = ACTIONS(5326),
    [anon_sym_EQ_EQ] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym__special_characters] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5340),
    [anon_sym_BQUOTE] = ACTIONS(5342),
    [anon_sym_LT_LPAREN] = ACTIONS(5344),
    [anon_sym_GT_LPAREN] = ACTIONS(5344),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(328),
    [anon_sym_LF] = ACTIONS(352),
    [anon_sym_AMP] = ACTIONS(328),
  },
  [1920] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(5244),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5316),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [1921] = {
    [sym__assignment] = STATE(2230),
    [anon_sym_EQ] = ACTIONS(5242),
    [anon_sym_PLUS_EQ] = ACTIONS(5242),
    [sym_comment] = ACTIONS(54),
  },
  [1922] = {
    [sym__simple_heredoc_body] = ACTIONS(236),
    [sym__heredoc_body_beginning] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
    [anon_sym_esac] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_SEMI_SEMI] = ACTIONS(238),
    [anon_sym_PIPE_AMP] = ACTIONS(238),
    [anon_sym_AMP_AMP] = ACTIONS(238),
    [anon_sym_PIPE_PIPE] = ACTIONS(238),
    [anon_sym_EQ_TILDE] = ACTIONS(238),
    [anon_sym_EQ_EQ] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_AMP_GT] = ACTIONS(238),
    [anon_sym_AMP_GT_GT] = ACTIONS(238),
    [anon_sym_LT_AMP] = ACTIONS(238),
    [anon_sym_GT_AMP] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_LT_LT_LT] = ACTIONS(238),
    [sym__special_characters] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(238),
    [sym_raw_string] = ACTIONS(238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(238),
    [anon_sym_BQUOTE] = ACTIONS(238),
    [anon_sym_LT_LPAREN] = ACTIONS(238),
    [anon_sym_GT_LPAREN] = ACTIONS(238),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
  },
  [1923] = {
    [sym__terminated_statement] = STATE(2292),
    [sym_for_statement] = STATE(2290),
    [sym_while_statement] = STATE(2290),
    [sym_if_statement] = STATE(2290),
    [sym_case_statement] = STATE(2290),
    [sym_function_definition] = STATE(2290),
    [sym_subshell] = STATE(2290),
    [sym_pipeline] = STATE(2290),
    [sym_list] = STATE(2290),
    [sym_command] = STATE(2290),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2290),
    [sym_variable_assignment] = STATE(2291),
    [sym_declaration_command] = STATE(2290),
    [sym_unset_command] = STATE(2290),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2292),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5244),
    [anon_sym_SEMI_SEMI] = ACTIONS(5346),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1924] = {
    [sym_command_name] = STATE(2293),
    [sym_variable_assignment] = STATE(201),
    [sym_subscript] = STATE(200),
    [sym_file_redirect] = STATE(201),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_command_repeat1] = STATE(201),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(360),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(5348),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4466),
  },
  [1925] = {
    [sym__terminated_statement] = STATE(2294),
    [sym_for_statement] = STATE(2290),
    [sym_while_statement] = STATE(2290),
    [sym_if_statement] = STATE(2290),
    [sym_case_statement] = STATE(2290),
    [sym_function_definition] = STATE(2290),
    [sym_subshell] = STATE(2290),
    [sym_pipeline] = STATE(2290),
    [sym_list] = STATE(2290),
    [sym_command] = STATE(2290),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2290),
    [sym_variable_assignment] = STATE(2291),
    [sym_declaration_command] = STATE(2290),
    [sym_unset_command] = STATE(2290),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2294),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5244),
    [anon_sym_SEMI_SEMI] = ACTIONS(5346),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1926] = {
    [aux_sym_case_item_repeat1] = STATE(1926),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [sym_comment] = ACTIONS(54),
  },
  [1927] = {
    [aux_sym_concatenation_repeat1] = STATE(1927),
    [sym__concat] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [1928] = {
    [anon_sym_esac] = ACTIONS(5353),
    [sym__special_characters] = ACTIONS(5355),
    [anon_sym_DQUOTE] = ACTIONS(5355),
    [anon_sym_DOLLAR] = ACTIONS(5357),
    [sym_raw_string] = ACTIONS(5355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5355),
    [anon_sym_BQUOTE] = ACTIONS(5355),
    [anon_sym_LT_LPAREN] = ACTIONS(5355),
    [anon_sym_GT_LPAREN] = ACTIONS(5355),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5357),
  },
  [1929] = {
    [anon_sym_esac] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [1930] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(5353),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [1931] = {
    [sym__terminated_statement] = STATE(2292),
    [sym_for_statement] = STATE(2297),
    [sym_while_statement] = STATE(2297),
    [sym_if_statement] = STATE(2297),
    [sym_case_statement] = STATE(2297),
    [sym_function_definition] = STATE(2297),
    [sym_subshell] = STATE(2297),
    [sym_pipeline] = STATE(2297),
    [sym_list] = STATE(2297),
    [sym_command] = STATE(2297),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2297),
    [sym_variable_assignment] = STATE(2298),
    [sym_declaration_command] = STATE(2297),
    [sym_unset_command] = STATE(2297),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2292),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5353),
    [anon_sym_SEMI_SEMI] = ACTIONS(5361),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1932] = {
    [sym__terminated_statement] = STATE(2299),
    [sym_for_statement] = STATE(2297),
    [sym_while_statement] = STATE(2297),
    [sym_if_statement] = STATE(2297),
    [sym_case_statement] = STATE(2297),
    [sym_function_definition] = STATE(2297),
    [sym_subshell] = STATE(2297),
    [sym_pipeline] = STATE(2297),
    [sym_list] = STATE(2297),
    [sym_command] = STATE(2297),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2297),
    [sym_variable_assignment] = STATE(2298),
    [sym_declaration_command] = STATE(2297),
    [sym_unset_command] = STATE(2297),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2299),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5353),
    [anon_sym_SEMI_SEMI] = ACTIONS(5361),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [1933] = {
    [anon_sym_esac] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_SEMI_SEMI] = ACTIONS(5363),
    [anon_sym_PIPE_AMP] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym_LF] = ACTIONS(5365),
    [anon_sym_AMP] = ACTIONS(5363),
  },
  [1934] = {
    [aux_sym_case_item_repeat1] = STATE(2301),
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(54),
  },
  [1935] = {
    [aux_sym_case_item_repeat1] = STATE(2303),
    [aux_sym_concatenation_repeat1] = STATE(1502),
    [sym__concat] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(5369),
    [sym_comment] = ACTIONS(54),
  },
  [1936] = {
    [aux_sym_case_item_repeat1] = STATE(2303),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(5369),
    [sym_comment] = ACTIONS(54),
  },
  [1937] = {
    [anon_sym_esac] = ACTIONS(5371),
    [sym_comment] = ACTIONS(54),
  },
  [1938] = {
    [anon_sym_esac] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_SEMI_SEMI] = ACTIONS(5373),
    [anon_sym_PIPE_AMP] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym_LF] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5373),
  },
  [1939] = {
    [anon_sym_esac] = ACTIONS(5377),
    [sym_comment] = ACTIONS(54),
  },
  [1940] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_in] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [1941] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_in] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [1942] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [1943] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_in] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [1944] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1945] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_in] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [1946] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1947] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_in] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [1948] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1949] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_in] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [1950] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_in] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [1951] = {
    [aux_sym_concatenation_repeat1] = STATE(1951),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1952] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [1953] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1954] = {
    [aux_sym_concatenation_repeat1] = STATE(2309),
    [sym__concat] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1955] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [1956] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [1957] = {
    [aux_sym_concatenation_repeat1] = STATE(2310),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [1958] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_EQ_TILDE] = ACTIONS(4878),
    [anon_sym_EQ_EQ] = ACTIONS(4878),
    [anon_sym_RBRACK] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4878),
  },
  [1959] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_EQ_TILDE] = ACTIONS(4882),
    [anon_sym_EQ_EQ] = ACTIONS(4882),
    [anon_sym_RBRACK] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4882),
  },
  [1960] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_RBRACK] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4886),
  },
  [1961] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_RBRACK] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4890),
  },
  [1962] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1963] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_RBRACK] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4896),
  },
  [1964] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1965] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_RBRACK] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4902),
  },
  [1966] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1967] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4908),
  },
  [1968] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_EQ_TILDE] = ACTIONS(4912),
    [anon_sym_EQ_EQ] = ACTIONS(4912),
    [anon_sym_RBRACK] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4912),
  },
  [1969] = {
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1970] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(5391),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [1971] = {
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1711),
    [anon_sym_LT_LT_LT] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [1972] = {
    [sym_concatenation] = STATE(2317),
    [sym_string] = STATE(2316),
    [sym_simple_expansion] = STATE(2316),
    [sym_string_expansion] = STATE(2316),
    [sym_expansion] = STATE(2316),
    [sym_command_substitution] = STATE(2316),
    [sym_process_substitution] = STATE(2316),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [sym__special_characters] = ACTIONS(5396),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5398),
  },
  [1973] = {
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1752),
    [anon_sym_LT_LT_LT] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [1974] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5400),
  },
  [1975] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1976] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(5404),
    [sym_comment] = ACTIONS(54),
  },
  [1977] = {
    [sym_concatenation] = STATE(2323),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2323),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_EQ] = ACTIONS(5408),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5412),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COLON_QMARK] = ACTIONS(5408),
    [anon_sym_COLON_DASH] = ACTIONS(5408),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_DASH] = ACTIONS(5408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1978] = {
    [sym_concatenation] = STATE(2326),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2326),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [anon_sym_EQ] = ACTIONS(5416),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_COLON_QMARK] = ACTIONS(5416),
    [anon_sym_COLON_DASH] = ACTIONS(5416),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1979] = {
    [sym_concatenation] = STATE(2328),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2328),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(5422),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5426),
    [anon_sym_COLON] = ACTIONS(5422),
    [anon_sym_COLON_QMARK] = ACTIONS(5422),
    [anon_sym_COLON_DASH] = ACTIONS(5422),
    [anon_sym_PERCENT] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1980] = {
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [1981] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5428),
  },
  [1982] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5430),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1983] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1826),
    [anon_sym_LT_LT_LT] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [1984] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5432),
  },
  [1985] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1986] = {
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [1987] = {
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2028),
    [anon_sym_LT_LT_LT] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [1988] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4876),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_EQ_TILDE] = ACTIONS(4878),
    [anon_sym_EQ_EQ] = ACTIONS(4878),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4878),
  },
  [1989] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4880),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_EQ_TILDE] = ACTIONS(4882),
    [anon_sym_EQ_EQ] = ACTIONS(4882),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4882),
  },
  [1990] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4884),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4886),
  },
  [1991] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4888),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4890),
  },
  [1992] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5434),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1993] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4896),
  },
  [1994] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1995] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4900),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4902),
  },
  [1996] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5438),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [1997] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4908),
  },
  [1998] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_EQ_TILDE] = ACTIONS(4912),
    [anon_sym_EQ_EQ] = ACTIONS(4912),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4912),
  },
  [1999] = {
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [2000] = {
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [2001] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2002] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2003] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2004] = {
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [2005] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2006] = {
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [2007] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2008] = {
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [2009] = {
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [2010] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [2011] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [2012] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2013] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2014] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5446),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2015] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [2016] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2017] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [2018] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2019] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [2020] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [2021] = {
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_PIPE_AMP] = ACTIONS(4876),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_PIPE_PIPE] = ACTIONS(4876),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4876),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4876),
    [anon_sym_LT_AMP] = ACTIONS(4876),
    [anon_sym_GT_AMP] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4876),
  },
  [2022] = {
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_PIPE_AMP] = ACTIONS(4880),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_PIPE_PIPE] = ACTIONS(4880),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4880),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4880),
    [anon_sym_LT_AMP] = ACTIONS(4880),
    [anon_sym_GT_AMP] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4880),
  },
  [2023] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4884),
  },
  [2024] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4888),
  },
  [2025] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2026] = {
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4894),
  },
  [2027] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2028] = {
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_PIPE_AMP] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4900),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4900),
    [anon_sym_LT_AMP] = ACTIONS(4900),
    [anon_sym_GT_AMP] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4900),
  },
  [2029] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2030] = {
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_PIPE_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4906),
    [anon_sym_LT_AMP] = ACTIONS(4906),
    [anon_sym_GT_AMP] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4906),
  },
  [2031] = {
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4910),
  },
  [2032] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym__string_content] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
  },
  [2033] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym__string_content] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
  },
  [2034] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym__string_content] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
  },
  [2035] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym__string_content] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
  },
  [2036] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2037] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym__string_content] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
  },
  [2038] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2039] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym__string_content] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
  },
  [2040] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2041] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym__string_content] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
  },
  [2042] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym__string_content] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
  },
  [2043] = {
    [anon_sym_RBRACE] = ACTIONS(4300),
    [anon_sym_EQ] = ACTIONS(5464),
    [sym__special_characters] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(4300),
    [anon_sym_DOLLAR] = ACTIONS(5464),
    [sym_raw_string] = ACTIONS(4300),
    [anon_sym_POUND] = ACTIONS(4300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4300),
    [aux_sym_SLASH] = ACTIONS(4300),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COLON_QMARK] = ACTIONS(5464),
    [anon_sym_COLON_DASH] = ACTIONS(5464),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4300),
    [anon_sym_BQUOTE] = ACTIONS(4300),
    [anon_sym_LT_LPAREN] = ACTIONS(4300),
    [anon_sym_GT_LPAREN] = ACTIONS(4300),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5464),
  },
  [2044] = {
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(5466),
    [sym__special_characters] = ACTIONS(5466),
    [anon_sym_DQUOTE] = ACTIONS(4302),
    [anon_sym_DOLLAR] = ACTIONS(5466),
    [sym_raw_string] = ACTIONS(4302),
    [anon_sym_POUND] = ACTIONS(4302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4302),
    [aux_sym_SLASH] = ACTIONS(4302),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COLON_QMARK] = ACTIONS(5466),
    [anon_sym_COLON_DASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4302),
    [anon_sym_BQUOTE] = ACTIONS(4302),
    [anon_sym_LT_LPAREN] = ACTIONS(4302),
    [anon_sym_GT_LPAREN] = ACTIONS(4302),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5466),
  },
  [2045] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_RBRACE] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
  },
  [2046] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym_comment] = ACTIONS(54),
  },
  [2047] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [sym_comment] = ACTIONS(54),
  },
  [2048] = {
    [anon_sym_RBRACE] = ACTIONS(5470),
    [sym_comment] = ACTIONS(54),
  },
  [2049] = {
    [sym_concatenation] = STATE(2350),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2350),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5474),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COLON_QMARK] = ACTIONS(5474),
    [anon_sym_COLON_DASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2050] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
  },
  [2051] = {
    [sym_concatenation] = STATE(2353),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [sym__special_characters] = ACTIONS(5478),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5480),
  },
  [2052] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
  },
  [2053] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5482),
  },
  [2054] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2055] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
  },
  [2056] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5486),
  },
  [2057] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2058] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5490),
  },
  [2059] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2060] = {
    [sym_concatenation] = STATE(2360),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2360),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_EQ] = ACTIONS(5494),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COLON_QMARK] = ACTIONS(5494),
    [anon_sym_COLON_DASH] = ACTIONS(5494),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2061] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
  },
  [2062] = {
    [sym_concatenation] = STATE(2362),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2362),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_EQ] = ACTIONS(5500),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_COLON_DASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2063] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_RBRACE] = ACTIONS(3909),
    [anon_sym_EQ] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_POUND] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_COLON_QMARK] = ACTIONS(3911),
    [anon_sym_COLON_DASH] = ACTIONS(3911),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
  },
  [2064] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_POUND] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_DASH] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
  },
  [2065] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_POUND] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_COLON] = ACTIONS(4002),
    [anon_sym_COLON_QMARK] = ACTIONS(4002),
    [anon_sym_COLON_DASH] = ACTIONS(4002),
    [anon_sym_PERCENT] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
  },
  [2066] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2067] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [sym_comment] = ACTIONS(54),
  },
  [2068] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [sym_comment] = ACTIONS(54),
  },
  [2069] = {
    [anon_sym_RBRACE] = ACTIONS(5508),
    [sym_comment] = ACTIONS(54),
  },
  [2070] = {
    [sym_concatenation] = STATE(2367),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2367),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_EQ] = ACTIONS(5512),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5514),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5512),
    [anon_sym_COLON_QMARK] = ACTIONS(5512),
    [anon_sym_COLON_DASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2071] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_EQ] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_POUND] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_DASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
  },
  [2072] = {
    [sym_concatenation] = STATE(2369),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2369),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_EQ] = ACTIONS(5518),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COLON_QMARK] = ACTIONS(5518),
    [anon_sym_COLON_DASH] = ACTIONS(5518),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_DASH] = ACTIONS(5518),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2073] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_POUND] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COLON_QMARK] = ACTIONS(4028),
    [anon_sym_COLON_DASH] = ACTIONS(4028),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_DASH] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
  },
  [2074] = {
    [sym_concatenation] = STATE(2371),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2371),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_EQ] = ACTIONS(5524),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5524),
    [anon_sym_COLON_QMARK] = ACTIONS(5524),
    [anon_sym_COLON_DASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2075] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_POUND] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_COLON] = ACTIONS(4038),
    [anon_sym_COLON_QMARK] = ACTIONS(4038),
    [anon_sym_COLON_DASH] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
  },
  [2076] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2077] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_EQ] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_POUND] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COLON_QMARK] = ACTIONS(4044),
    [anon_sym_COLON_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
  },
  [2078] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2079] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5534),
    [anon_sym_LT_LT_LT] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2080] = {
    [sym__simple_heredoc_body] = ACTIONS(5536),
    [sym__heredoc_body_beginning] = ACTIONS(5536),
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_EQ_TILDE] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5538),
    [anon_sym_LT_LT_LT] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2081] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2082] = {
    [anon_sym_PIPE] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_PIPE_AMP] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_BQUOTE] = ACTIONS(4428),
    [sym_comment] = ACTIONS(54),
  },
  [2083] = {
    [anon_sym_PIPE] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3516),
    [anon_sym_PIPE_AMP] = ACTIONS(3516),
    [anon_sym_AMP_AMP] = ACTIONS(3516),
    [anon_sym_PIPE_PIPE] = ACTIONS(3516),
    [anon_sym_BQUOTE] = ACTIONS(3516),
    [sym_comment] = ACTIONS(54),
  },
  [2084] = {
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_PIPE_AMP] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [sym_comment] = ACTIONS(54),
  },
  [2085] = {
    [anon_sym_fi] = ACTIONS(5544),
    [sym_comment] = ACTIONS(54),
  },
  [2086] = {
    [anon_sym_PIPE] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4488),
    [anon_sym_PIPE_AMP] = ACTIONS(4488),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [anon_sym_BQUOTE] = ACTIONS(4488),
    [sym_comment] = ACTIONS(54),
  },
  [2087] = {
    [anon_sym_esac] = ACTIONS(5546),
    [sym_comment] = ACTIONS(54),
  },
  [2088] = {
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(4518),
    [anon_sym_PIPE_AMP] = ACTIONS(4518),
    [anon_sym_AMP_AMP] = ACTIONS(4518),
    [anon_sym_PIPE_PIPE] = ACTIONS(4518),
    [anon_sym_BQUOTE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(54),
  },
  [2089] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(2376),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [2090] = {
    [anon_sym_PIPE] = ACTIONS(4520),
    [anon_sym_RPAREN] = ACTIONS(4522),
    [anon_sym_PIPE_AMP] = ACTIONS(4522),
    [anon_sym_AMP_AMP] = ACTIONS(4522),
    [anon_sym_PIPE_PIPE] = ACTIONS(4522),
    [anon_sym_BQUOTE] = ACTIONS(4522),
    [sym_comment] = ACTIONS(54),
  },
  [2091] = {
    [anon_sym_esac] = ACTIONS(5548),
    [sym_comment] = ACTIONS(54),
  },
  [2092] = {
    [anon_sym_PIPE] = ACTIONS(4526),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_PIPE_AMP] = ACTIONS(4528),
    [anon_sym_AMP_AMP] = ACTIONS(4528),
    [anon_sym_PIPE_PIPE] = ACTIONS(4528),
    [anon_sym_BQUOTE] = ACTIONS(4528),
    [sym_comment] = ACTIONS(54),
  },
  [2093] = {
    [sym_case_item] = STATE(1507),
    [sym_last_case_item] = STATE(2378),
    [sym_concatenation] = STATE(1065),
    [sym_string] = STATE(1063),
    [sym_simple_expansion] = STATE(1063),
    [sym_string_expansion] = STATE(1063),
    [sym_expansion] = STATE(1063),
    [sym_command_substitution] = STATE(1063),
    [sym_process_substitution] = STATE(1063),
    [aux_sym_case_statement_repeat1] = STATE(1507),
    [sym__special_characters] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(2305),
  },
  [2094] = {
    [anon_sym_PIPE] = ACTIONS(4558),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [anon_sym_PIPE_AMP] = ACTIONS(4560),
    [anon_sym_AMP_AMP] = ACTIONS(4560),
    [anon_sym_PIPE_PIPE] = ACTIONS(4560),
    [anon_sym_BQUOTE] = ACTIONS(4560),
    [sym_comment] = ACTIONS(54),
  },
  [2095] = {
    [aux_sym_concatenation_repeat1] = STATE(2098),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [2096] = {
    [aux_sym_concatenation_repeat1] = STATE(2098),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2097] = {
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2098] = {
    [aux_sym_concatenation_repeat1] = STATE(2379),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [2099] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_LT_LT_LT] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [2100] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2101] = {
    [sym_file_descriptor] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2102] = {
    [sym_string] = STATE(2380),
    [sym_simple_expansion] = STATE(2380),
    [sym_string_expansion] = STATE(2380),
    [sym_expansion] = STATE(2380),
    [sym_command_substitution] = STATE(2380),
    [sym_process_substitution] = STATE(2380),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(4094),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4100),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LT_LPAREN] = ACTIONS(4104),
    [anon_sym_GT_LPAREN] = ACTIONS(4104),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5550),
  },
  [2103] = {
    [aux_sym_concatenation_repeat1] = STATE(2381),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [2104] = {
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_PIPE_AMP] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(696),
    [anon_sym_LT_AMP] = ACTIONS(696),
    [anon_sym_GT_AMP] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(696),
    [anon_sym_LT_LT_LT] = ACTIONS(696),
    [anon_sym_BQUOTE] = ACTIONS(696),
    [sym_comment] = ACTIONS(54),
  },
  [2105] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(5552),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2106] = {
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_PIPE_AMP] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(726),
    [anon_sym_LT_AMP] = ACTIONS(726),
    [anon_sym_GT_AMP] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(726),
    [anon_sym_LT_LT_LT] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [sym_comment] = ACTIONS(54),
  },
  [2107] = {
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_PIPE_AMP] = ACTIONS(730),
    [anon_sym_AMP_AMP] = ACTIONS(730),
    [anon_sym_PIPE_PIPE] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(730),
    [anon_sym_LT_AMP] = ACTIONS(730),
    [anon_sym_GT_AMP] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(730),
    [anon_sym_LT_LT_LT] = ACTIONS(730),
    [anon_sym_BQUOTE] = ACTIONS(730),
    [sym_comment] = ACTIONS(54),
  },
  [2108] = {
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_PIPE_AMP] = ACTIONS(734),
    [anon_sym_AMP_AMP] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(734),
    [anon_sym_LT_AMP] = ACTIONS(734),
    [anon_sym_GT_AMP] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(734),
    [anon_sym_LT_LT_LT] = ACTIONS(734),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [sym_comment] = ACTIONS(54),
  },
  [2109] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(5554),
    [sym_comment] = ACTIONS(54),
  },
  [2110] = {
    [sym_concatenation] = STATE(2386),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2386),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_EQ] = ACTIONS(5558),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_COLON_QMARK] = ACTIONS(5558),
    [anon_sym_COLON_DASH] = ACTIONS(5558),
    [anon_sym_PERCENT] = ACTIONS(5558),
    [anon_sym_DASH] = ACTIONS(5558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2111] = {
    [sym_subscript] = STATE(2390),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AT] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5566),
    [anon_sym_0] = ACTIONS(5570),
    [anon_sym__] = ACTIONS(5570),
  },
  [2112] = {
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2393),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_EQ] = ACTIONS(5574),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_COLON_QMARK] = ACTIONS(5574),
    [anon_sym_COLON_DASH] = ACTIONS(5574),
    [anon_sym_PERCENT] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2113] = {
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2396),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(5582),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COLON_QMARK] = ACTIONS(5582),
    [anon_sym_COLON_DASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_DASH] = ACTIONS(5582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2114] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5588),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2115] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5588),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2116] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(5588),
    [sym_comment] = ACTIONS(54),
  },
  [2117] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(5588),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2118] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2119] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2120] = {
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_RPAREN] = ACTIONS(3373),
    [anon_sym_PIPE_AMP] = ACTIONS(3373),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_PIPE_PIPE] = ACTIONS(3373),
    [sym__special_characters] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3373),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [anon_sym_LT_LPAREN] = ACTIONS(3373),
    [anon_sym_GT_LPAREN] = ACTIONS(3373),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3375),
    [sym_word] = ACTIONS(3375),
  },
  [2121] = {
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_PIPE_AMP] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
  },
  [2122] = {
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
  },
  [2123] = {
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_PIPE_AMP] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
  },
  [2124] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2125] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [sym_comment] = ACTIONS(54),
  },
  [2126] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [sym_comment] = ACTIONS(54),
  },
  [2127] = {
    [anon_sym_RBRACE] = ACTIONS(5596),
    [sym_comment] = ACTIONS(54),
  },
  [2128] = {
    [sym_concatenation] = STATE(2403),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2403),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COLON_QMARK] = ACTIONS(5600),
    [anon_sym_COLON_DASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2129] = {
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
  },
  [2130] = {
    [sym_concatenation] = STATE(2405),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2405),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_EQ] = ACTIONS(5606),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5606),
    [anon_sym_COLON_QMARK] = ACTIONS(5606),
    [anon_sym_COLON_DASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5606),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2131] = {
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
  },
  [2132] = {
    [sym_concatenation] = STATE(2407),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2407),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(5612),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COLON_QMARK] = ACTIONS(5612),
    [anon_sym_COLON_DASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2133] = {
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
  },
  [2134] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2135] = {
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_PIPE_AMP] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
  },
  [2136] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2137] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_PIPE_AMP] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
  },
  [2138] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
  },
  [2139] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_PIPE_AMP] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
  },
  [2140] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2141] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5622),
    [sym_comment] = ACTIONS(54),
  },
  [2142] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [sym_comment] = ACTIONS(54),
  },
  [2143] = {
    [anon_sym_RBRACE] = ACTIONS(5624),
    [sym_comment] = ACTIONS(54),
  },
  [2144] = {
    [sym_concatenation] = STATE(2414),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2414),
    [anon_sym_RBRACE] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5628),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COLON_QMARK] = ACTIONS(5628),
    [anon_sym_COLON_DASH] = ACTIONS(5628),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5628),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2145] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
  },
  [2146] = {
    [sym_concatenation] = STATE(2416),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2416),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5634),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5634),
    [anon_sym_COLON_QMARK] = ACTIONS(5634),
    [anon_sym_COLON_DASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2147] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
  },
  [2148] = {
    [sym_concatenation] = STATE(2418),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2418),
    [anon_sym_RBRACE] = ACTIONS(5638),
    [anon_sym_EQ] = ACTIONS(5640),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_COLON_QMARK] = ACTIONS(5640),
    [anon_sym_COLON_DASH] = ACTIONS(5640),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(5640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2149] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
  },
  [2150] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2151] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_PIPE_AMP] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
  },
  [2152] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2153] = {
    [sym__simple_heredoc_body] = ACTIONS(4876),
    [sym__heredoc_body_beginning] = ACTIONS(4876),
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_PIPE_AMP] = ACTIONS(4876),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_PIPE_PIPE] = ACTIONS(4876),
    [anon_sym_EQ_TILDE] = ACTIONS(4878),
    [anon_sym_EQ_EQ] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4876),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4876),
    [anon_sym_LT_AMP] = ACTIONS(4876),
    [anon_sym_GT_AMP] = ACTIONS(4876),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4876),
    [anon_sym_LT_LT_LT] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4878),
  },
  [2154] = {
    [sym__simple_heredoc_body] = ACTIONS(4880),
    [sym__heredoc_body_beginning] = ACTIONS(4880),
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_PIPE_AMP] = ACTIONS(4880),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_PIPE_PIPE] = ACTIONS(4880),
    [anon_sym_EQ_TILDE] = ACTIONS(4882),
    [anon_sym_EQ_EQ] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4880),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4880),
    [anon_sym_LT_AMP] = ACTIONS(4880),
    [anon_sym_GT_AMP] = ACTIONS(4880),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4880),
    [anon_sym_LT_LT_LT] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4882),
  },
  [2155] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4884),
    [anon_sym_LT_LT_LT] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4886),
  },
  [2156] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4888),
    [anon_sym_LT_LT_LT] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4890),
  },
  [2157] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2158] = {
    [sym__simple_heredoc_body] = ACTIONS(4894),
    [sym__heredoc_body_beginning] = ACTIONS(4894),
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4896),
  },
  [2159] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2160] = {
    [sym__simple_heredoc_body] = ACTIONS(4900),
    [sym__heredoc_body_beginning] = ACTIONS(4900),
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_PIPE_AMP] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4900),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4900),
    [anon_sym_LT_AMP] = ACTIONS(4900),
    [anon_sym_GT_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4900),
    [anon_sym_LT_LT_LT] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4902),
  },
  [2161] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2162] = {
    [sym__simple_heredoc_body] = ACTIONS(4906),
    [sym__heredoc_body_beginning] = ACTIONS(4906),
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_PIPE_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4906),
    [anon_sym_LT_AMP] = ACTIONS(4906),
    [anon_sym_GT_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4906),
    [anon_sym_LT_LT_LT] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4908),
  },
  [2163] = {
    [sym__simple_heredoc_body] = ACTIONS(4910),
    [sym__heredoc_body_beginning] = ACTIONS(4910),
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_EQ_TILDE] = ACTIONS(4912),
    [anon_sym_EQ_EQ] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4912),
  },
  [2164] = {
    [aux_sym_concatenation_repeat1] = STATE(2166),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [2165] = {
    [aux_sym_concatenation_repeat1] = STATE(2166),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2166] = {
    [aux_sym_concatenation_repeat1] = STATE(2424),
    [sym__concat] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [2167] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_LT_LT_LT] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(54),
  },
  [2168] = {
    [aux_sym_concatenation_repeat1] = STATE(2169),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_AMP] = ACTIONS(1083),
    [anon_sym_GT_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1083),
    [anon_sym_LT_LT_LT] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(54),
  },
  [2169] = {
    [aux_sym_concatenation_repeat1] = STATE(2425),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(692),
    [anon_sym_PIPE_PIPE] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(692),
    [anon_sym_LT_AMP] = ACTIONS(692),
    [anon_sym_GT_AMP] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(692),
    [anon_sym_LT_LT_LT] = ACTIONS(692),
    [anon_sym_BQUOTE] = ACTIONS(692),
    [sym_comment] = ACTIONS(54),
  },
  [2170] = {
    [sym__heredoc_body_middle] = ACTIONS(3909),
    [sym__heredoc_body_end] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
  },
  [2171] = {
    [sym__heredoc_body_middle] = ACTIONS(3915),
    [sym__heredoc_body_end] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
  },
  [2172] = {
    [sym__heredoc_body_middle] = ACTIONS(4000),
    [sym__heredoc_body_end] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
  },
  [2173] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2174] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [sym_comment] = ACTIONS(54),
  },
  [2175] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [sym_comment] = ACTIONS(54),
  },
  [2176] = {
    [anon_sym_RBRACE] = ACTIONS(5658),
    [sym_comment] = ACTIONS(54),
  },
  [2177] = {
    [sym_concatenation] = STATE(2430),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2430),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_EQ] = ACTIONS(5662),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5662),
    [anon_sym_COLON_QMARK] = ACTIONS(5662),
    [anon_sym_COLON_DASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2178] = {
    [sym__heredoc_body_middle] = ACTIONS(4016),
    [sym__heredoc_body_end] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
  },
  [2179] = {
    [sym_concatenation] = STATE(2432),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2432),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_EQ] = ACTIONS(5668),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_COLON_QMARK] = ACTIONS(5668),
    [anon_sym_COLON_DASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_DASH] = ACTIONS(5668),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2180] = {
    [sym__heredoc_body_middle] = ACTIONS(4026),
    [sym__heredoc_body_end] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
  },
  [2181] = {
    [sym_concatenation] = STATE(2434),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2434),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_EQ] = ACTIONS(5674),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_COLON_QMARK] = ACTIONS(5674),
    [anon_sym_COLON_DASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2182] = {
    [sym__heredoc_body_middle] = ACTIONS(4036),
    [sym__heredoc_body_end] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
  },
  [2183] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2184] = {
    [sym__heredoc_body_middle] = ACTIONS(4042),
    [sym__heredoc_body_end] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
  },
  [2185] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5680),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2186] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(3909),
    [anon_sym_DQUOTE] = ACTIONS(3909),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3909),
  },
  [2187] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(3915),
  },
  [2188] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(4000),
    [anon_sym_DQUOTE] = ACTIONS(4000),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [anon_sym_LT_LPAREN] = ACTIONS(4000),
    [anon_sym_GT_LPAREN] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4000),
  },
  [2189] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2190] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [sym_comment] = ACTIONS(54),
  },
  [2191] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [sym_comment] = ACTIONS(54),
  },
  [2192] = {
    [anon_sym_RBRACE] = ACTIONS(5686),
    [sym_comment] = ACTIONS(54),
  },
  [2193] = {
    [sym_concatenation] = STATE(2441),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2441),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5690),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_COLON_QMARK] = ACTIONS(5690),
    [anon_sym_COLON_DASH] = ACTIONS(5690),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2194] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [sym__special_characters] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_LT_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4016),
  },
  [2195] = {
    [sym_concatenation] = STATE(2443),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2443),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(5696),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5696),
    [anon_sym_COLON_QMARK] = ACTIONS(5696),
    [anon_sym_COLON_DASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2196] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4026),
  },
  [2197] = {
    [sym_concatenation] = STATE(2445),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2445),
    [anon_sym_RBRACE] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(5702),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5702),
    [anon_sym_COLON_QMARK] = ACTIONS(5702),
    [anon_sym_COLON_DASH] = ACTIONS(5702),
    [anon_sym_PERCENT] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2198] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4036),
  },
  [2199] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2200] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [sym__special_characters] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_LT_LPAREN] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4042),
  },
  [2201] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2202] = {
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [2203] = {
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [2204] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2205] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2206] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2207] = {
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [2208] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2209] = {
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [2210] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2211] = {
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [2212] = {
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [2213] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2214] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2215] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [2216] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2217] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(54),
  },
  [2218] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5720),
    [sym_comment] = ACTIONS(54),
  },
  [2219] = {
    [anon_sym_RBRACE] = ACTIONS(5720),
    [sym_comment] = ACTIONS(54),
  },
  [2220] = {
    [sym_concatenation] = STATE(2455),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2455),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(5724),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5724),
    [anon_sym_COLON_QMARK] = ACTIONS(5724),
    [anon_sym_COLON_DASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5724),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2221] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [2222] = {
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2457),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_EQ] = ACTIONS(5730),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_COLON_QMARK] = ACTIONS(5730),
    [anon_sym_COLON_DASH] = ACTIONS(5730),
    [anon_sym_PERCENT] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2223] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [2224] = {
    [sym_concatenation] = STATE(2459),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2459),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5736),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5736),
    [anon_sym_COLON_QMARK] = ACTIONS(5736),
    [anon_sym_COLON_DASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2225] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [2226] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2227] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [2228] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2229] = {
    [sym_concatenation] = STATE(2462),
    [sym_string] = STATE(2467),
    [sym_array] = STATE(2462),
    [sym_simple_expansion] = STATE(2467),
    [sym_string_expansion] = STATE(2467),
    [sym_expansion] = STATE(2467),
    [sym_command_substitution] = STATE(2467),
    [sym_process_substitution] = STATE(2467),
    [sym__empty_value] = ACTIONS(5744),
    [anon_sym_LPAREN] = ACTIONS(5746),
    [sym__special_characters] = ACTIONS(5748),
    [anon_sym_DQUOTE] = ACTIONS(5750),
    [anon_sym_DOLLAR] = ACTIONS(5752),
    [sym_raw_string] = ACTIONS(5754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5758),
    [anon_sym_BQUOTE] = ACTIONS(5760),
    [anon_sym_LT_LPAREN] = ACTIONS(5762),
    [anon_sym_GT_LPAREN] = ACTIONS(5762),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5754),
  },
  [2230] = {
    [sym_file_descriptor] = ACTIONS(392),
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_esac] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_SEMI_SEMI] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(394),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_AMP_GT] = ACTIONS(394),
    [anon_sym_AMP_GT_GT] = ACTIONS(394),
    [anon_sym_LT_AMP] = ACTIONS(394),
    [anon_sym_GT_AMP] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LF] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
  },
  [2231] = {
    [sym_do_group] = STATE(2472),
    [anon_sym_do] = ACTIONS(402),
    [sym_comment] = ACTIONS(54),
  },
  [2232] = {
    [sym_compound_statement] = STATE(2474),
    [anon_sym_LPAREN] = ACTIONS(5764),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [2233] = {
    [sym_concatenation] = STATE(76),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat2] = STATE(302),
    [anon_sym_EQ_TILDE] = ACTIONS(106),
    [anon_sym_EQ_EQ] = ACTIONS(106),
    [anon_sym_RBRACK] = ACTIONS(5766),
    [sym__special_characters] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(110),
    [anon_sym_DOLLAR] = ACTIONS(112),
    [sym_raw_string] = ACTIONS(114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(118),
    [anon_sym_BQUOTE] = ACTIONS(120),
    [anon_sym_LT_LPAREN] = ACTIONS(122),
    [anon_sym_GT_LPAREN] = ACTIONS(122),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(124),
  },
  [2234] = {
    [sym_concatenation] = STATE(87),
    [sym_string] = STATE(82),
    [sym_simple_expansion] = STATE(82),
    [sym_string_expansion] = STATE(82),
    [sym_expansion] = STATE(82),
    [sym_command_substitution] = STATE(82),
    [sym_process_substitution] = STATE(82),
    [aux_sym_command_repeat2] = STATE(324),
    [anon_sym_EQ_TILDE] = ACTIONS(126),
    [anon_sym_EQ_EQ] = ACTIONS(126),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5766),
    [sym__special_characters] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(130),
    [anon_sym_DOLLAR] = ACTIONS(132),
    [sym_raw_string] = ACTIONS(134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(138),
    [anon_sym_BQUOTE] = ACTIONS(140),
    [anon_sym_LT_LPAREN] = ACTIONS(142),
    [anon_sym_GT_LPAREN] = ACTIONS(142),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(144),
  },
  [2235] = {
    [sym__assignment] = STATE(2477),
    [anon_sym_LBRACK] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_PLUS_EQ] = ACTIONS(5768),
    [sym_comment] = ACTIONS(54),
  },
  [2236] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(582),
    [anon_sym_esac] = ACTIONS(584),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_SEMI_SEMI] = ACTIONS(584),
    [anon_sym_PIPE_AMP] = ACTIONS(584),
    [anon_sym_AMP_AMP] = ACTIONS(584),
    [anon_sym_PIPE_PIPE] = ACTIONS(584),
    [sym__special_characters] = ACTIONS(584),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [anon_sym_DOLLAR] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(584),
    [anon_sym_BQUOTE] = ACTIONS(584),
    [anon_sym_LT_LPAREN] = ACTIONS(584),
    [anon_sym_GT_LPAREN] = ACTIONS(584),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(584),
    [sym_word] = ACTIONS(584),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(584),
  },
  [2237] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2481),
    [anon_sym_DQUOTE] = ACTIONS(5772),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2238] = {
    [sym_string] = STATE(2483),
    [anon_sym_DQUOTE] = ACTIONS(5774),
    [anon_sym_DOLLAR] = ACTIONS(5776),
    [sym_raw_string] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5776),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5780),
    [anon_sym_STAR] = ACTIONS(5776),
    [anon_sym_AT] = ACTIONS(5776),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_0] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5782),
  },
  [2239] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(598),
    [anon_sym_esac] = ACTIONS(600),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_SEMI_SEMI] = ACTIONS(600),
    [anon_sym_PIPE_AMP] = ACTIONS(600),
    [anon_sym_AMP_AMP] = ACTIONS(600),
    [anon_sym_PIPE_PIPE] = ACTIONS(600),
    [sym__special_characters] = ACTIONS(600),
    [anon_sym_DQUOTE] = ACTIONS(600),
    [anon_sym_DOLLAR] = ACTIONS(600),
    [sym_raw_string] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(600),
    [anon_sym_BQUOTE] = ACTIONS(600),
    [anon_sym_LT_LPAREN] = ACTIONS(600),
    [anon_sym_GT_LPAREN] = ACTIONS(600),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(600),
    [sym_word] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(600),
    [anon_sym_LF] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(600),
  },
  [2240] = {
    [sym_subscript] = STATE(2489),
    [sym_variable_name] = ACTIONS(5784),
    [anon_sym_DOLLAR] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5786),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5790),
    [anon_sym_STAR] = ACTIONS(5786),
    [anon_sym_AT] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_0] = ACTIONS(5792),
    [anon_sym__] = ACTIONS(5792),
  },
  [2241] = {
    [sym_for_statement] = STATE(2490),
    [sym_while_statement] = STATE(2490),
    [sym_if_statement] = STATE(2490),
    [sym_case_statement] = STATE(2490),
    [sym_function_definition] = STATE(2490),
    [sym_subshell] = STATE(2490),
    [sym_pipeline] = STATE(2490),
    [sym_list] = STATE(2490),
    [sym_command] = STATE(2490),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2490),
    [sym_variable_assignment] = STATE(2491),
    [sym_declaration_command] = STATE(2490),
    [sym_unset_command] = STATE(2490),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2242] = {
    [sym_for_statement] = STATE(2492),
    [sym_while_statement] = STATE(2492),
    [sym_if_statement] = STATE(2492),
    [sym_case_statement] = STATE(2492),
    [sym_function_definition] = STATE(2492),
    [sym_subshell] = STATE(2492),
    [sym_pipeline] = STATE(2492),
    [sym_list] = STATE(2492),
    [sym_command] = STATE(2492),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2492),
    [sym_variable_assignment] = STATE(2493),
    [sym_declaration_command] = STATE(2492),
    [sym_unset_command] = STATE(2492),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [2243] = {
    [sym_for_statement] = STATE(2494),
    [sym_while_statement] = STATE(2494),
    [sym_if_statement] = STATE(2494),
    [sym_case_statement] = STATE(2494),
    [sym_function_definition] = STATE(2494),
    [sym_subshell] = STATE(2494),
    [sym_pipeline] = STATE(2494),
    [sym_list] = STATE(2494),
    [sym_command] = STATE(2494),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2494),
    [sym_variable_assignment] = STATE(2495),
    [sym_declaration_command] = STATE(2494),
    [sym_unset_command] = STATE(2494),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2244] = {
    [sym_variable_name] = ACTIONS(612),
    [anon_sym_esac] = ACTIONS(614),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_SEMI_SEMI] = ACTIONS(614),
    [anon_sym_PIPE_AMP] = ACTIONS(614),
    [anon_sym_AMP_AMP] = ACTIONS(614),
    [anon_sym_PIPE_PIPE] = ACTIONS(614),
    [sym__special_characters] = ACTIONS(614),
    [anon_sym_DQUOTE] = ACTIONS(614),
    [anon_sym_DOLLAR] = ACTIONS(614),
    [sym_raw_string] = ACTIONS(614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(614),
    [anon_sym_LT_LPAREN] = ACTIONS(614),
    [anon_sym_GT_LPAREN] = ACTIONS(614),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(614),
    [sym_word] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(614),
    [anon_sym_LF] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(614),
  },
  [2245] = {
    [sym__assignment] = STATE(2477),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_PLUS_EQ] = ACTIONS(5768),
    [sym_comment] = ACTIONS(54),
  },
  [2246] = {
    [sym_variable_assignment] = STATE(2496),
    [sym_subscript] = STATE(2245),
    [sym_concatenation] = STATE(2496),
    [sym_string] = STATE(2239),
    [sym_simple_expansion] = STATE(2239),
    [sym_string_expansion] = STATE(2239),
    [sym_expansion] = STATE(2239),
    [sym_command_substitution] = STATE(2239),
    [sym_process_substitution] = STATE(2239),
    [aux_sym_declaration_command_repeat1] = STATE(2496),
    [sym_variable_name] = ACTIONS(5252),
    [anon_sym_esac] = ACTIONS(616),
    [anon_sym_PIPE] = ACTIONS(616),
    [anon_sym_SEMI_SEMI] = ACTIONS(616),
    [anon_sym_PIPE_AMP] = ACTIONS(616),
    [anon_sym_AMP_AMP] = ACTIONS(616),
    [anon_sym_PIPE_PIPE] = ACTIONS(616),
    [sym__special_characters] = ACTIONS(5254),
    [anon_sym_DQUOTE] = ACTIONS(5256),
    [anon_sym_DOLLAR] = ACTIONS(5258),
    [sym_raw_string] = ACTIONS(5260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5264),
    [anon_sym_BQUOTE] = ACTIONS(5266),
    [anon_sym_LT_LPAREN] = ACTIONS(5268),
    [anon_sym_GT_LPAREN] = ACTIONS(5268),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5270),
    [sym_word] = ACTIONS(5260),
    [anon_sym_SEMI] = ACTIONS(616),
    [anon_sym_LF] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(616),
  },
  [2247] = {
    [aux_sym_concatenation_repeat1] = STATE(2498),
    [sym__concat] = ACTIONS(5794),
    [anon_sym_esac] = ACTIONS(622),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_SEMI_SEMI] = ACTIONS(622),
    [anon_sym_PIPE_AMP] = ACTIONS(622),
    [anon_sym_AMP_AMP] = ACTIONS(622),
    [anon_sym_PIPE_PIPE] = ACTIONS(622),
    [sym__special_characters] = ACTIONS(622),
    [anon_sym_DQUOTE] = ACTIONS(622),
    [anon_sym_DOLLAR] = ACTIONS(622),
    [sym_raw_string] = ACTIONS(622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(622),
    [anon_sym_BQUOTE] = ACTIONS(622),
    [anon_sym_LT_LPAREN] = ACTIONS(622),
    [anon_sym_GT_LPAREN] = ACTIONS(622),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(622),
    [sym_word] = ACTIONS(622),
    [anon_sym_SEMI] = ACTIONS(622),
    [anon_sym_LF] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(622),
  },
  [2248] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2500),
    [anon_sym_DQUOTE] = ACTIONS(5796),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2249] = {
    [sym_string] = STATE(2502),
    [anon_sym_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR] = ACTIONS(5800),
    [sym_raw_string] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5804),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_AT] = ACTIONS(5800),
    [anon_sym_QMARK] = ACTIONS(5800),
    [anon_sym_0] = ACTIONS(5806),
    [anon_sym__] = ACTIONS(5806),
  },
  [2250] = {
    [aux_sym_concatenation_repeat1] = STATE(2498),
    [sym__concat] = ACTIONS(5794),
    [anon_sym_esac] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_SEMI_SEMI] = ACTIONS(638),
    [anon_sym_PIPE_AMP] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(638),
    [anon_sym_PIPE_PIPE] = ACTIONS(638),
    [sym__special_characters] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(638),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [sym_raw_string] = ACTIONS(638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(638),
    [anon_sym_BQUOTE] = ACTIONS(638),
    [anon_sym_LT_LPAREN] = ACTIONS(638),
    [anon_sym_GT_LPAREN] = ACTIONS(638),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(638),
    [sym_word] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_AMP] = ACTIONS(638),
  },
  [2251] = {
    [sym_subscript] = STATE(2508),
    [sym_variable_name] = ACTIONS(5808),
    [anon_sym_DOLLAR] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5810),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5814),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_AT] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5810),
    [anon_sym_0] = ACTIONS(5816),
    [anon_sym__] = ACTIONS(5816),
  },
  [2252] = {
    [sym_for_statement] = STATE(2509),
    [sym_while_statement] = STATE(2509),
    [sym_if_statement] = STATE(2509),
    [sym_case_statement] = STATE(2509),
    [sym_function_definition] = STATE(2509),
    [sym_subshell] = STATE(2509),
    [sym_pipeline] = STATE(2509),
    [sym_list] = STATE(2509),
    [sym_command] = STATE(2509),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2509),
    [sym_variable_assignment] = STATE(2510),
    [sym_declaration_command] = STATE(2509),
    [sym_unset_command] = STATE(2509),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2253] = {
    [sym_for_statement] = STATE(2511),
    [sym_while_statement] = STATE(2511),
    [sym_if_statement] = STATE(2511),
    [sym_case_statement] = STATE(2511),
    [sym_function_definition] = STATE(2511),
    [sym_subshell] = STATE(2511),
    [sym_pipeline] = STATE(2511),
    [sym_list] = STATE(2511),
    [sym_command] = STATE(2511),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2511),
    [sym_variable_assignment] = STATE(2512),
    [sym_declaration_command] = STATE(2511),
    [sym_unset_command] = STATE(2511),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [2254] = {
    [sym_for_statement] = STATE(2513),
    [sym_while_statement] = STATE(2513),
    [sym_if_statement] = STATE(2513),
    [sym_case_statement] = STATE(2513),
    [sym_function_definition] = STATE(2513),
    [sym_subshell] = STATE(2513),
    [sym_pipeline] = STATE(2513),
    [sym_list] = STATE(2513),
    [sym_command] = STATE(2513),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2513),
    [sym_variable_assignment] = STATE(2514),
    [sym_declaration_command] = STATE(2513),
    [sym_unset_command] = STATE(2513),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2255] = {
    [anon_sym_esac] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_SEMI_SEMI] = ACTIONS(652),
    [anon_sym_PIPE_AMP] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [sym__special_characters] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(652),
    [sym_raw_string] = ACTIONS(652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(652),
    [anon_sym_LT_LPAREN] = ACTIONS(652),
    [anon_sym_GT_LPAREN] = ACTIONS(652),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(652),
    [sym_word] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [anon_sym_LF] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(652),
  },
  [2256] = {
    [sym_concatenation] = STATE(2515),
    [sym_string] = STATE(2250),
    [sym_simple_expansion] = STATE(2250),
    [sym_string_expansion] = STATE(2250),
    [sym_expansion] = STATE(2250),
    [sym_command_substitution] = STATE(2250),
    [sym_process_substitution] = STATE(2250),
    [aux_sym_unset_command_repeat1] = STATE(2515),
    [anon_sym_esac] = ACTIONS(656),
    [anon_sym_PIPE] = ACTIONS(656),
    [anon_sym_SEMI_SEMI] = ACTIONS(656),
    [anon_sym_PIPE_AMP] = ACTIONS(656),
    [anon_sym_AMP_AMP] = ACTIONS(656),
    [anon_sym_PIPE_PIPE] = ACTIONS(656),
    [sym__special_characters] = ACTIONS(5272),
    [anon_sym_DQUOTE] = ACTIONS(5274),
    [anon_sym_DOLLAR] = ACTIONS(5276),
    [sym_raw_string] = ACTIONS(5278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5282),
    [anon_sym_BQUOTE] = ACTIONS(5284),
    [anon_sym_LT_LPAREN] = ACTIONS(5286),
    [anon_sym_GT_LPAREN] = ACTIONS(5286),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5288),
    [sym_word] = ACTIONS(5278),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_LF] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(656),
  },
  [2257] = {
    [sym_string] = STATE(2516),
    [sym_simple_expansion] = STATE(2516),
    [sym_string_expansion] = STATE(2516),
    [sym_expansion] = STATE(2516),
    [sym_command_substitution] = STATE(2516),
    [sym_process_substitution] = STATE(2516),
    [sym__special_characters] = ACTIONS(5818),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5818),
  },
  [2258] = {
    [aux_sym_concatenation_repeat1] = STATE(2517),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_EQ_TILDE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2259] = {
    [sym__simple_heredoc_body] = ACTIONS(696),
    [sym__heredoc_body_beginning] = ACTIONS(696),
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_EQ_TILDE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(698),
    [anon_sym_LT_LT_LT] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2260] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(5820),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2261] = {
    [sym__simple_heredoc_body] = ACTIONS(726),
    [sym__heredoc_body_beginning] = ACTIONS(726),
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_EQ_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_LT] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2262] = {
    [sym__simple_heredoc_body] = ACTIONS(730),
    [sym__heredoc_body_beginning] = ACTIONS(730),
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_EQ_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_LT] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2263] = {
    [sym__simple_heredoc_body] = ACTIONS(734),
    [sym__heredoc_body_beginning] = ACTIONS(734),
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_EQ_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(736),
    [anon_sym_LT_LT_LT] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2264] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(5822),
    [sym_comment] = ACTIONS(54),
  },
  [2265] = {
    [sym_concatenation] = STATE(2522),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2522),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5826),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5830),
    [anon_sym_COLON] = ACTIONS(5826),
    [anon_sym_COLON_QMARK] = ACTIONS(5826),
    [anon_sym_COLON_DASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2266] = {
    [sym_subscript] = STATE(2526),
    [sym_variable_name] = ACTIONS(5832),
    [anon_sym_DOLLAR] = ACTIONS(5834),
    [anon_sym_DASH] = ACTIONS(5834),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5836),
    [anon_sym_STAR] = ACTIONS(5834),
    [anon_sym_AT] = ACTIONS(5834),
    [anon_sym_QMARK] = ACTIONS(5834),
    [anon_sym_0] = ACTIONS(5838),
    [anon_sym__] = ACTIONS(5838),
  },
  [2267] = {
    [sym_concatenation] = STATE(2529),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2529),
    [anon_sym_RBRACE] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5842),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5846),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_COLON_QMARK] = ACTIONS(5842),
    [anon_sym_COLON_DASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2268] = {
    [sym_concatenation] = STATE(2532),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2532),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5850),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(5854),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_COLON_QMARK] = ACTIONS(5850),
    [anon_sym_COLON_DASH] = ACTIONS(5850),
    [anon_sym_PERCENT] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2269] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2270] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2271] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(5856),
    [sym_comment] = ACTIONS(54),
  },
  [2272] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(5856),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2273] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5858),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2274] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(5858),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2275] = {
    [anon_sym_RPAREN] = ACTIONS(5860),
    [sym_comment] = ACTIONS(54),
  },
  [2276] = {
    [sym_for_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_case_statement] = STATE(523),
    [sym_function_definition] = STATE(523),
    [sym_subshell] = STATE(523),
    [sym_pipeline] = STATE(523),
    [sym_list] = STATE(523),
    [sym_command] = STATE(523),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(523),
    [sym_variable_assignment] = STATE(2536),
    [sym_declaration_command] = STATE(523),
    [sym_unset_command] = STATE(523),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [2277] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(5862),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(5864),
    [anon_sym_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR] = ACTIONS(5864),
    [sym_raw_string] = ACTIONS(5866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5866),
    [anon_sym_LT_LPAREN] = ACTIONS(5866),
    [anon_sym_GT_LPAREN] = ACTIONS(5866),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5864),
  },
  [2278] = {
    [sym_for_statement] = STATE(2537),
    [sym_while_statement] = STATE(2537),
    [sym_if_statement] = STATE(2537),
    [sym_case_statement] = STATE(2537),
    [sym_function_definition] = STATE(2537),
    [sym_subshell] = STATE(2537),
    [sym_pipeline] = STATE(2537),
    [sym_list] = STATE(2537),
    [sym_command] = STATE(2537),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2537),
    [sym_variable_assignment] = STATE(2538),
    [sym_declaration_command] = STATE(2537),
    [sym_unset_command] = STATE(2537),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [2279] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [anon_sym_DOLLAR] = ACTIONS(952),
    [sym_raw_string] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(950),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(952),
  },
  [2280] = {
    [anon_sym_LT] = ACTIONS(5868),
    [anon_sym_GT] = ACTIONS(5868),
    [anon_sym_GT_GT] = ACTIONS(5870),
    [anon_sym_AMP_GT] = ACTIONS(5868),
    [anon_sym_AMP_GT_GT] = ACTIONS(5870),
    [anon_sym_LT_AMP] = ACTIONS(5870),
    [anon_sym_GT_AMP] = ACTIONS(5870),
    [sym_comment] = ACTIONS(54),
  },
  [2281] = {
    [sym_concatenation] = STATE(2542),
    [sym_string] = STATE(2541),
    [sym_simple_expansion] = STATE(2541),
    [sym_string_expansion] = STATE(2541),
    [sym_expansion] = STATE(2541),
    [sym_command_substitution] = STATE(2541),
    [sym_process_substitution] = STATE(2541),
    [sym__special_characters] = ACTIONS(5872),
    [anon_sym_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5340),
    [anon_sym_BQUOTE] = ACTIONS(5342),
    [anon_sym_LT_LPAREN] = ACTIONS(5344),
    [anon_sym_GT_LPAREN] = ACTIONS(5344),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5874),
    [sym_regex] = ACTIONS(5876),
  },
  [2282] = {
    [sym_concatenation] = STATE(538),
    [sym_string] = STATE(2546),
    [sym_simple_expansion] = STATE(2546),
    [sym_string_expansion] = STATE(2546),
    [sym_expansion] = STATE(2546),
    [sym_command_substitution] = STATE(2546),
    [sym_process_substitution] = STATE(2546),
    [sym__special_characters] = ACTIONS(5878),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_DOLLAR] = ACTIONS(5882),
    [sym_raw_string] = ACTIONS(5884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5888),
    [anon_sym_BQUOTE] = ACTIONS(5890),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5884),
  },
  [2283] = {
    [sym_concatenation] = STATE(542),
    [sym_string] = STATE(2552),
    [sym_simple_expansion] = STATE(2552),
    [sym_string_expansion] = STATE(2552),
    [sym_expansion] = STATE(2552),
    [sym_command_substitution] = STATE(2552),
    [sym_process_substitution] = STATE(2552),
    [sym__special_characters] = ACTIONS(5894),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_DOLLAR] = ACTIONS(5882),
    [sym_raw_string] = ACTIONS(5896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5888),
    [anon_sym_BQUOTE] = ACTIONS(5890),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5896),
  },
  [2284] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(508),
    [sym__heredoc_body_beginning] = ACTIONS(508),
    [sym_file_descriptor] = ACTIONS(508),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_SEMI_SEMI] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_TILDE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_LT_LT_LT] = ACTIONS(506),
    [sym__special_characters] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(506),
    [anon_sym_DOLLAR] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [anon_sym_LT_LPAREN] = ACTIONS(506),
    [anon_sym_GT_LPAREN] = ACTIONS(506),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(506),
    [anon_sym_SEMI] = ACTIONS(506),
    [anon_sym_LF] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(506),
  },
  [2285] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(520),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [2286] = {
    [sym__simple_heredoc_body] = ACTIONS(522),
    [sym__heredoc_body_beginning] = ACTIONS(522),
    [sym_file_descriptor] = ACTIONS(522),
    [anon_sym_esac] = ACTIONS(520),
    [anon_sym_PIPE] = ACTIONS(520),
    [anon_sym_SEMI_SEMI] = ACTIONS(520),
    [anon_sym_PIPE_AMP] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_TILDE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(520),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(520),
    [anon_sym_LT_AMP] = ACTIONS(520),
    [anon_sym_GT_AMP] = ACTIONS(520),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_LT_LT_DASH] = ACTIONS(520),
    [anon_sym_LT_LT_LT] = ACTIONS(520),
    [sym__special_characters] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_DOLLAR] = ACTIONS(520),
    [sym_raw_string] = ACTIONS(520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(520),
    [anon_sym_BQUOTE] = ACTIONS(520),
    [anon_sym_LT_LPAREN] = ACTIONS(520),
    [anon_sym_GT_LPAREN] = ACTIONS(520),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_LF] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
  },
  [2287] = {
    [sym_file_redirect] = STATE(2553),
    [sym_heredoc_redirect] = STATE(2553),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(2553),
    [aux_sym_while_statement_repeat1] = STATE(2553),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(986),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [2288] = {
    [sym_file_redirect] = STATE(2554),
    [sym_heredoc_redirect] = STATE(2554),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(2554),
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [aux_sym_while_statement_repeat1] = STATE(2554),
    [aux_sym_command_repeat2] = STATE(2555),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(986),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(5326),
    [anon_sym_EQ_EQ] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym__special_characters] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5340),
    [anon_sym_BQUOTE] = ACTIONS(5342),
    [anon_sym_LT_LPAREN] = ACTIONS(5344),
    [anon_sym_GT_LPAREN] = ACTIONS(5344),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [2289] = {
    [anon_sym_esac] = ACTIONS(5862),
    [sym__special_characters] = ACTIONS(5866),
    [anon_sym_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR] = ACTIONS(5864),
    [sym_raw_string] = ACTIONS(5866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5866),
    [anon_sym_LT_LPAREN] = ACTIONS(5866),
    [anon_sym_GT_LPAREN] = ACTIONS(5866),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5864),
  },
  [2290] = {
    [anon_sym_esac] = ACTIONS(5862),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5898),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2291] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(5862),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5898),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2292] = {
    [sym__terminated_statement] = STATE(2292),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_if_statement] = STATE(2557),
    [sym_case_statement] = STATE(2557),
    [sym_function_definition] = STATE(2557),
    [sym_subshell] = STATE(2557),
    [sym_pipeline] = STATE(2557),
    [sym_list] = STATE(2557),
    [sym_command] = STATE(2557),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2557),
    [sym_variable_assignment] = STATE(2558),
    [sym_declaration_command] = STATE(2557),
    [sym_unset_command] = STATE(2557),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2292),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_esac] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(996),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [2293] = {
    [sym_file_redirect] = STATE(2554),
    [sym_heredoc_redirect] = STATE(2554),
    [sym_heredoc_body] = STATE(543),
    [sym_herestring_redirect] = STATE(2554),
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [aux_sym_while_statement_repeat1] = STATE(2554),
    [aux_sym_command_repeat2] = STATE(2559),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(986),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_SEMI_SEMI] = ACTIONS(986),
    [anon_sym_PIPE_AMP] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_TILDE] = ACTIONS(5326),
    [anon_sym_EQ_EQ] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym__special_characters] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5340),
    [anon_sym_BQUOTE] = ACTIONS(5342),
    [anon_sym_LT_LPAREN] = ACTIONS(5344),
    [anon_sym_GT_LPAREN] = ACTIONS(5344),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_LF] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(986),
  },
  [2294] = {
    [sym__terminated_statement] = STATE(2292),
    [sym_for_statement] = STATE(2561),
    [sym_while_statement] = STATE(2561),
    [sym_if_statement] = STATE(2561),
    [sym_case_statement] = STATE(2561),
    [sym_function_definition] = STATE(2561),
    [sym_subshell] = STATE(2561),
    [sym_pipeline] = STATE(2561),
    [sym_list] = STATE(2561),
    [sym_command] = STATE(2561),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2561),
    [sym_variable_assignment] = STATE(2562),
    [sym_declaration_command] = STATE(2561),
    [sym_unset_command] = STATE(2561),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2292),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5862),
    [anon_sym_SEMI_SEMI] = ACTIONS(5900),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [2295] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(5902),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(5904),
    [anon_sym_DQUOTE] = ACTIONS(5906),
    [anon_sym_DOLLAR] = ACTIONS(5904),
    [sym_raw_string] = ACTIONS(5906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5906),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [anon_sym_LT_LPAREN] = ACTIONS(5906),
    [anon_sym_GT_LPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5904),
  },
  [2296] = {
    [anon_sym_esac] = ACTIONS(5902),
    [sym__special_characters] = ACTIONS(5906),
    [anon_sym_DQUOTE] = ACTIONS(5906),
    [anon_sym_DOLLAR] = ACTIONS(5904),
    [sym_raw_string] = ACTIONS(5906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5906),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [anon_sym_LT_LPAREN] = ACTIONS(5906),
    [anon_sym_GT_LPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5904),
  },
  [2297] = {
    [anon_sym_esac] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2298] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(5902),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2299] = {
    [sym__terminated_statement] = STATE(2292),
    [sym_for_statement] = STATE(2565),
    [sym_while_statement] = STATE(2565),
    [sym_if_statement] = STATE(2565),
    [sym_case_statement] = STATE(2565),
    [sym_function_definition] = STATE(2565),
    [sym_subshell] = STATE(2565),
    [sym_pipeline] = STATE(2565),
    [sym_list] = STATE(2565),
    [sym_command] = STATE(2565),
    [sym_command_name] = STATE(1919),
    [sym_bracket_command] = STATE(2565),
    [sym_variable_assignment] = STATE(2566),
    [sym_declaration_command] = STATE(2565),
    [sym_unset_command] = STATE(2565),
    [sym_subscript] = STATE(1921),
    [sym_file_redirect] = STATE(1924),
    [sym_concatenation] = STATE(1922),
    [sym_string] = STATE(1912),
    [sym_simple_expansion] = STATE(1912),
    [sym_string_expansion] = STATE(1912),
    [sym_expansion] = STATE(1912),
    [sym_command_substitution] = STATE(1912),
    [sym_process_substitution] = STATE(1912),
    [aux_sym_program_repeat1] = STATE(2292),
    [aux_sym_command_repeat1] = STATE(1924),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(4444),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(5902),
    [anon_sym_SEMI_SEMI] = ACTIONS(5910),
    [anon_sym_function] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(4452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4454),
    [anon_sym_declare] = ACTIONS(4456),
    [anon_sym_typeset] = ACTIONS(4456),
    [anon_sym_export] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_local] = ACTIONS(4456),
    [anon_sym_unset] = ACTIONS(4458),
    [anon_sym_unsetenv] = ACTIONS(4458),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(4460),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(4466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_LT_LPAREN] = ACTIONS(4474),
    [anon_sym_GT_LPAREN] = ACTIONS(4474),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4476),
  },
  [2300] = {
    [sym__terminated_statement] = STATE(2570),
    [sym_for_statement] = STATE(2568),
    [sym_while_statement] = STATE(2568),
    [sym_if_statement] = STATE(2568),
    [sym_case_statement] = STATE(2568),
    [sym_function_definition] = STATE(2568),
    [sym_subshell] = STATE(2568),
    [sym_pipeline] = STATE(2568),
    [sym_list] = STATE(2568),
    [sym_command] = STATE(2568),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2568),
    [sym_variable_assignment] = STATE(2569),
    [sym_declaration_command] = STATE(2568),
    [sym_unset_command] = STATE(2568),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2570),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5912),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2301] = {
    [aux_sym_case_item_repeat1] = STATE(1926),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(5914),
    [sym_comment] = ACTIONS(54),
  },
  [2302] = {
    [sym__terminated_statement] = STATE(2575),
    [sym_for_statement] = STATE(2573),
    [sym_while_statement] = STATE(2573),
    [sym_if_statement] = STATE(2573),
    [sym_case_statement] = STATE(2573),
    [sym_function_definition] = STATE(2573),
    [sym_subshell] = STATE(2573),
    [sym_pipeline] = STATE(2573),
    [sym_list] = STATE(2573),
    [sym_command] = STATE(2573),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2573),
    [sym_variable_assignment] = STATE(2574),
    [sym_declaration_command] = STATE(2573),
    [sym_unset_command] = STATE(2573),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2575),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5916),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2303] = {
    [aux_sym_case_item_repeat1] = STATE(1926),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_RPAREN] = ACTIONS(5918),
    [sym_comment] = ACTIONS(54),
  },
  [2304] = {
    [anon_sym_esac] = ACTIONS(5920),
    [anon_sym_PIPE] = ACTIONS(5920),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_SEMI_SEMI] = ACTIONS(5920),
    [anon_sym_PIPE_AMP] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(5920),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5920),
    [anon_sym_LF] = ACTIONS(5922),
    [anon_sym_AMP] = ACTIONS(5920),
  },
  [2305] = {
    [anon_sym_esac] = ACTIONS(5924),
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_RPAREN] = ACTIONS(5924),
    [anon_sym_SEMI_SEMI] = ACTIONS(5924),
    [anon_sym_PIPE_AMP] = ACTIONS(5924),
    [anon_sym_AMP_AMP] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5924),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5924),
    [anon_sym_LF] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5924),
  },
  [2306] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2307] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2308] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2309] = {
    [aux_sym_concatenation_repeat1] = STATE(2309),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2310] = {
    [aux_sym_concatenation_repeat1] = STATE(2310),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(5391),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2311] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_RBRACK] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5534),
  },
  [2312] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_EQ_TILDE] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_RBRACK] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5538),
  },
  [2313] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_RBRACK] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5542),
  },
  [2314] = {
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2746),
    [anon_sym_LT_LT_LT] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [2315] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [sym_comment] = ACTIONS(54),
  },
  [2316] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [sym_comment] = ACTIONS(54),
  },
  [2317] = {
    [anon_sym_RBRACE] = ACTIONS(5930),
    [sym_comment] = ACTIONS(54),
  },
  [2318] = {
    [sym_concatenation] = STATE(2580),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2580),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5934),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5934),
    [anon_sym_COLON_QMARK] = ACTIONS(5934),
    [anon_sym_COLON_DASH] = ACTIONS(5934),
    [anon_sym_PERCENT] = ACTIONS(5934),
    [anon_sym_DASH] = ACTIONS(5934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2319] = {
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2824),
    [anon_sym_LT_LT_LT] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [2320] = {
    [sym_concatenation] = STATE(2583),
    [sym_string] = STATE(2582),
    [sym_simple_expansion] = STATE(2582),
    [sym_string_expansion] = STATE(2582),
    [sym_expansion] = STATE(2582),
    [sym_command_substitution] = STATE(2582),
    [sym_process_substitution] = STATE(2582),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [sym__special_characters] = ACTIONS(5938),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(5940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5940),
  },
  [2321] = {
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2867),
    [anon_sym_LT_LT_LT] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [2322] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5942),
  },
  [2323] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5944),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2324] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2325] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5946),
  },
  [2326] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2327] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(5950),
  },
  [2328] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2329] = {
    [sym_concatenation] = STATE(2590),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2590),
    [anon_sym_RBRACE] = ACTIONS(5952),
    [anon_sym_EQ] = ACTIONS(5954),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_COLON_QMARK] = ACTIONS(5954),
    [anon_sym_COLON_DASH] = ACTIONS(5954),
    [anon_sym_PERCENT] = ACTIONS(5954),
    [anon_sym_DASH] = ACTIONS(5954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2330] = {
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2891),
    [anon_sym_LT_LT_LT] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [2331] = {
    [sym_concatenation] = STATE(2592),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2592),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5960),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5960),
    [anon_sym_COLON_QMARK] = ACTIONS(5960),
    [anon_sym_COLON_DASH] = ACTIONS(5960),
    [anon_sym_PERCENT] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2332] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5534),
  },
  [2333] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5536),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_EQ_TILDE] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5538),
  },
  [2334] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5540),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5542),
  },
  [2335] = {
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2336] = {
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2337] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2338] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2339] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2340] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2341] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5532),
  },
  [2342] = {
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_PIPE_AMP] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE] = ACTIONS(5536),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5536),
    [anon_sym_LT_AMP] = ACTIONS(5536),
    [anon_sym_GT_AMP] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5536),
  },
  [2343] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5540),
  },
  [2344] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym__string_content] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
  },
  [2345] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym__string_content] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
  },
  [2346] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym__string_content] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
  },
  [2347] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_RBRACE] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
  },
  [2348] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
  },
  [2349] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
  },
  [2350] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5964),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2351] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [sym_comment] = ACTIONS(54),
  },
  [2352] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(5968),
    [sym_comment] = ACTIONS(54),
  },
  [2353] = {
    [anon_sym_RBRACE] = ACTIONS(5968),
    [sym_comment] = ACTIONS(54),
  },
  [2354] = {
    [sym_concatenation] = STATE(2597),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2597),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_EQ] = ACTIONS(5972),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5972),
    [anon_sym_COLON_QMARK] = ACTIONS(5972),
    [anon_sym_COLON_DASH] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_DASH] = ACTIONS(5972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2355] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
  },
  [2356] = {
    [sym_concatenation] = STATE(2599),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2599),
    [anon_sym_RBRACE] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5978),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5978),
    [anon_sym_COLON_QMARK] = ACTIONS(5978),
    [anon_sym_COLON_DASH] = ACTIONS(5978),
    [anon_sym_PERCENT] = ACTIONS(5978),
    [anon_sym_DASH] = ACTIONS(5978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2357] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
  },
  [2358] = {
    [sym_concatenation] = STATE(2601),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2601),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_EQ] = ACTIONS(5984),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(5986),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(5984),
    [anon_sym_COLON_QMARK] = ACTIONS(5984),
    [anon_sym_COLON_DASH] = ACTIONS(5984),
    [anon_sym_PERCENT] = ACTIONS(5984),
    [anon_sym_DASH] = ACTIONS(5984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2359] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
  },
  [2360] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2361] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
  },
  [2362] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2363] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_RBRACE] = ACTIONS(4876),
    [anon_sym_EQ] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_POUND] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_COLON] = ACTIONS(4878),
    [anon_sym_COLON_QMARK] = ACTIONS(4878),
    [anon_sym_COLON_DASH] = ACTIONS(4878),
    [anon_sym_PERCENT] = ACTIONS(4878),
    [anon_sym_DASH] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
  },
  [2364] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_EQ] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_POUND] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_COLON] = ACTIONS(4882),
    [anon_sym_COLON_QMARK] = ACTIONS(4882),
    [anon_sym_COLON_DASH] = ACTIONS(4882),
    [anon_sym_PERCENT] = ACTIONS(4882),
    [anon_sym_DASH] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
  },
  [2365] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_EQ] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_POUND] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_COLON] = ACTIONS(4886),
    [anon_sym_COLON_QMARK] = ACTIONS(4886),
    [anon_sym_COLON_DASH] = ACTIONS(4886),
    [anon_sym_PERCENT] = ACTIONS(4886),
    [anon_sym_DASH] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
  },
  [2366] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_POUND] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_COLON] = ACTIONS(4890),
    [anon_sym_COLON_QMARK] = ACTIONS(4890),
    [anon_sym_COLON_DASH] = ACTIONS(4890),
    [anon_sym_PERCENT] = ACTIONS(4890),
    [anon_sym_DASH] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
  },
  [2367] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2368] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [anon_sym_EQ] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_POUND] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_COLON] = ACTIONS(4896),
    [anon_sym_COLON_QMARK] = ACTIONS(4896),
    [anon_sym_COLON_DASH] = ACTIONS(4896),
    [anon_sym_PERCENT] = ACTIONS(4896),
    [anon_sym_DASH] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
  },
  [2369] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5994),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2370] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [anon_sym_EQ] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_POUND] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_COLON] = ACTIONS(4902),
    [anon_sym_COLON_QMARK] = ACTIONS(4902),
    [anon_sym_COLON_DASH] = ACTIONS(4902),
    [anon_sym_PERCENT] = ACTIONS(4902),
    [anon_sym_DASH] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
  },
  [2371] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2372] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_RBRACE] = ACTIONS(4906),
    [anon_sym_EQ] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_POUND] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_COLON_QMARK] = ACTIONS(4908),
    [anon_sym_COLON_DASH] = ACTIONS(4908),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
  },
  [2373] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_RBRACE] = ACTIONS(4910),
    [anon_sym_EQ] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_POUND] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_COLON] = ACTIONS(4912),
    [anon_sym_COLON_QMARK] = ACTIONS(4912),
    [anon_sym_COLON_DASH] = ACTIONS(4912),
    [anon_sym_PERCENT] = ACTIONS(4912),
    [anon_sym_DASH] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
  },
  [2374] = {
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_PIPE_AMP] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(5236),
    [sym_comment] = ACTIONS(54),
  },
  [2375] = {
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_PIPE_AMP] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_BQUOTE] = ACTIONS(5365),
    [sym_comment] = ACTIONS(54),
  },
  [2376] = {
    [anon_sym_esac] = ACTIONS(5998),
    [sym_comment] = ACTIONS(54),
  },
  [2377] = {
    [anon_sym_PIPE] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5375),
    [anon_sym_PIPE_AMP] = ACTIONS(5375),
    [anon_sym_AMP_AMP] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5375),
    [anon_sym_BQUOTE] = ACTIONS(5375),
    [sym_comment] = ACTIONS(54),
  },
  [2378] = {
    [anon_sym_esac] = ACTIONS(6000),
    [sym_comment] = ACTIONS(54),
  },
  [2379] = {
    [aux_sym_concatenation_repeat1] = STATE(2379),
    [sym__concat] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [2380] = {
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [2381] = {
    [aux_sym_concatenation_repeat1] = STATE(2381),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(6002),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [2382] = {
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_PIPE_AMP] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1709),
    [anon_sym_LT_AMP] = ACTIONS(1709),
    [anon_sym_GT_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1709),
    [anon_sym_LT_LT_LT] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(1709),
    [sym_comment] = ACTIONS(54),
  },
  [2383] = {
    [sym_concatenation] = STATE(2612),
    [sym_string] = STATE(2611),
    [sym_simple_expansion] = STATE(2611),
    [sym_string_expansion] = STATE(2611),
    [sym_expansion] = STATE(2611),
    [sym_command_substitution] = STATE(2611),
    [sym_process_substitution] = STATE(2611),
    [anon_sym_RBRACE] = ACTIONS(6005),
    [sym__special_characters] = ACTIONS(6007),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6009),
  },
  [2384] = {
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_PIPE_AMP] = ACTIONS(1750),
    [anon_sym_AMP_AMP] = ACTIONS(1750),
    [anon_sym_PIPE_PIPE] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1750),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1750),
    [anon_sym_LT_AMP] = ACTIONS(1750),
    [anon_sym_GT_AMP] = ACTIONS(1750),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1750),
    [anon_sym_LT_LT_LT] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(54),
  },
  [2385] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6011),
  },
  [2386] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2387] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6015),
    [sym_comment] = ACTIONS(54),
  },
  [2388] = {
    [sym_concatenation] = STATE(2618),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2618),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_EQ] = ACTIONS(6019),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6023),
    [anon_sym_COLON] = ACTIONS(6019),
    [anon_sym_COLON_QMARK] = ACTIONS(6019),
    [anon_sym_COLON_DASH] = ACTIONS(6019),
    [anon_sym_PERCENT] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2389] = {
    [sym_concatenation] = STATE(2621),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2621),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_EQ] = ACTIONS(6027),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6031),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_COLON_QMARK] = ACTIONS(6027),
    [anon_sym_COLON_DASH] = ACTIONS(6027),
    [anon_sym_PERCENT] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2390] = {
    [sym_concatenation] = STATE(2623),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2623),
    [anon_sym_RBRACE] = ACTIONS(6005),
    [anon_sym_EQ] = ACTIONS(6033),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6033),
    [anon_sym_COLON_QMARK] = ACTIONS(6033),
    [anon_sym_COLON_DASH] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6033),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2391] = {
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_PIPE_AMP] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1816),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1816),
    [anon_sym_LT_AMP] = ACTIONS(1816),
    [anon_sym_GT_AMP] = ACTIONS(1816),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1816),
    [anon_sym_LT_LT_LT] = ACTIONS(1816),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [sym_comment] = ACTIONS(54),
  },
  [2392] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6039),
  },
  [2393] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6041),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2394] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1824),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1824),
    [anon_sym_LT_AMP] = ACTIONS(1824),
    [anon_sym_GT_AMP] = ACTIONS(1824),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1824),
    [anon_sym_LT_LT_LT] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(54),
  },
  [2395] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6043),
  },
  [2396] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6005),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2397] = {
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_PIPE_AMP] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1962),
    [anon_sym_LT_LT_LT] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [sym_comment] = ACTIONS(54),
  },
  [2398] = {
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2026),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2026),
    [anon_sym_LT_AMP] = ACTIONS(2026),
    [anon_sym_GT_AMP] = ACTIONS(2026),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2026),
    [anon_sym_LT_LT_LT] = ACTIONS(2026),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(54),
  },
  [2399] = {
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_PIPE_AMP] = ACTIONS(4876),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_PIPE_PIPE] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
  },
  [2400] = {
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_PIPE_AMP] = ACTIONS(4880),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_PIPE_PIPE] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
  },
  [2401] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
  },
  [2402] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
  },
  [2403] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6045),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2404] = {
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
  },
  [2405] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2406] = {
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_PIPE_AMP] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
  },
  [2407] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2408] = {
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_PIPE_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
  },
  [2409] = {
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
  },
  [2410] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_PIPE_AMP] = ACTIONS(4876),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_PIPE_PIPE] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
  },
  [2411] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_PIPE_AMP] = ACTIONS(4880),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_PIPE_PIPE] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
  },
  [2412] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
  },
  [2413] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
  },
  [2414] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2415] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
  },
  [2416] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6053),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2417] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_PIPE_AMP] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
  },
  [2418] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2419] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_PIPE_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
  },
  [2420] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
  },
  [2421] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5534),
  },
  [2422] = {
    [sym__simple_heredoc_body] = ACTIONS(5536),
    [sym__heredoc_body_beginning] = ACTIONS(5536),
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_PIPE_AMP] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE] = ACTIONS(5536),
    [anon_sym_EQ_TILDE] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5536),
    [anon_sym_LT_AMP] = ACTIONS(5536),
    [anon_sym_GT_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5536),
    [anon_sym_LT_LT_LT] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5538),
  },
  [2423] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5540),
    [anon_sym_LT_LT_LT] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5542),
  },
  [2424] = {
    [aux_sym_concatenation_repeat1] = STATE(2424),
    [sym__concat] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [2425] = {
    [aux_sym_concatenation_repeat1] = STATE(2425),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(6002),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1660),
    [anon_sym_AMP_AMP] = ACTIONS(1660),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1660),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1660),
    [anon_sym_LT_AMP] = ACTIONS(1660),
    [anon_sym_GT_AMP] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1660),
    [anon_sym_LT_LT_LT] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(54),
  },
  [2426] = {
    [sym__heredoc_body_middle] = ACTIONS(4876),
    [sym__heredoc_body_end] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
  },
  [2427] = {
    [sym__heredoc_body_middle] = ACTIONS(4880),
    [sym__heredoc_body_end] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
  },
  [2428] = {
    [sym__heredoc_body_middle] = ACTIONS(4884),
    [sym__heredoc_body_end] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
  },
  [2429] = {
    [sym__heredoc_body_middle] = ACTIONS(4888),
    [sym__heredoc_body_end] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
  },
  [2430] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6057),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2431] = {
    [sym__heredoc_body_middle] = ACTIONS(4894),
    [sym__heredoc_body_end] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
  },
  [2432] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2433] = {
    [sym__heredoc_body_middle] = ACTIONS(4900),
    [sym__heredoc_body_end] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
  },
  [2434] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2435] = {
    [sym__heredoc_body_middle] = ACTIONS(4906),
    [sym__heredoc_body_end] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
  },
  [2436] = {
    [sym__heredoc_body_middle] = ACTIONS(4910),
    [sym__heredoc_body_end] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
  },
  [2437] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [sym__special_characters] = ACTIONS(4876),
    [anon_sym_DQUOTE] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [anon_sym_LT_LPAREN] = ACTIONS(4876),
    [anon_sym_GT_LPAREN] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4876),
  },
  [2438] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(4880),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [anon_sym_LT_LPAREN] = ACTIONS(4880),
    [anon_sym_GT_LPAREN] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4880),
  },
  [2439] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4884),
  },
  [2440] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4888),
  },
  [2441] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2442] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4894),
  },
  [2443] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6065),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2444] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [sym__special_characters] = ACTIONS(4900),
    [anon_sym_DQUOTE] = ACTIONS(4900),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [anon_sym_LT_LPAREN] = ACTIONS(4900),
    [anon_sym_GT_LPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4900),
  },
  [2445] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2446] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [sym__special_characters] = ACTIONS(4906),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [anon_sym_LT_LPAREN] = ACTIONS(4906),
    [anon_sym_GT_LPAREN] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4906),
  },
  [2447] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(4910),
  },
  [2448] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2449] = {
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2450] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2451] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [2452] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [2453] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2454] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2455] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2456] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [2457] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2458] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [2459] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2460] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [2461] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [2462] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2463] = {
    [sym_concatenation] = STATE(2643),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(2643),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [2464] = {
    [aux_sym_concatenation_repeat1] = STATE(2645),
    [sym_file_descriptor] = ACTIONS(1119),
    [sym__concat] = ACTIONS(6077),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_esac] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT] = ACTIONS(1123),
    [anon_sym_AMP_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_AMP] = ACTIONS(1123),
    [anon_sym_GT_AMP] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [2465] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2647),
    [anon_sym_DQUOTE] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2466] = {
    [sym_string] = STATE(2649),
    [anon_sym_DQUOTE] = ACTIONS(5750),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [sym_raw_string] = ACTIONS(6083),
    [anon_sym_POUND] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6081),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6085),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_AT] = ACTIONS(6081),
    [anon_sym_QMARK] = ACTIONS(6081),
    [anon_sym_0] = ACTIONS(6087),
    [anon_sym__] = ACTIONS(6087),
  },
  [2467] = {
    [aux_sym_concatenation_repeat1] = STATE(2645),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(6077),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2468] = {
    [sym_subscript] = STATE(2655),
    [sym_variable_name] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_POUND] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6091),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6091),
    [anon_sym_QMARK] = ACTIONS(6091),
    [anon_sym_0] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6097),
  },
  [2469] = {
    [sym_for_statement] = STATE(2656),
    [sym_while_statement] = STATE(2656),
    [sym_if_statement] = STATE(2656),
    [sym_case_statement] = STATE(2656),
    [sym_function_definition] = STATE(2656),
    [sym_subshell] = STATE(2656),
    [sym_pipeline] = STATE(2656),
    [sym_list] = STATE(2656),
    [sym_command] = STATE(2656),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2656),
    [sym_variable_assignment] = STATE(2657),
    [sym_declaration_command] = STATE(2656),
    [sym_unset_command] = STATE(2656),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2470] = {
    [sym_for_statement] = STATE(2658),
    [sym_while_statement] = STATE(2658),
    [sym_if_statement] = STATE(2658),
    [sym_case_statement] = STATE(2658),
    [sym_function_definition] = STATE(2658),
    [sym_subshell] = STATE(2658),
    [sym_pipeline] = STATE(2658),
    [sym_list] = STATE(2658),
    [sym_command] = STATE(2658),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2658),
    [sym_variable_assignment] = STATE(2659),
    [sym_declaration_command] = STATE(2658),
    [sym_unset_command] = STATE(2658),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [2471] = {
    [sym_for_statement] = STATE(2660),
    [sym_while_statement] = STATE(2660),
    [sym_if_statement] = STATE(2660),
    [sym_case_statement] = STATE(2660),
    [sym_function_definition] = STATE(2660),
    [sym_subshell] = STATE(2660),
    [sym_pipeline] = STATE(2660),
    [sym_list] = STATE(2660),
    [sym_command] = STATE(2660),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2660),
    [sym_variable_assignment] = STATE(2661),
    [sym_declaration_command] = STATE(2660),
    [sym_unset_command] = STATE(2660),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2472] = {
    [sym_file_redirect] = STATE(2662),
    [sym_heredoc_redirect] = STATE(2662),
    [sym_heredoc_body] = STATE(598),
    [sym_herestring_redirect] = STATE(2662),
    [aux_sym_while_statement_repeat1] = STATE(2662),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
  },
  [2473] = {
    [anon_sym_RPAREN] = ACTIONS(6099),
    [sym_comment] = ACTIONS(54),
  },
  [2474] = {
    [sym_file_redirect] = STATE(638),
    [sym_file_descriptor] = ACTIONS(6101),
    [anon_sym_esac] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_SEMI_SEMI] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(6103),
    [anon_sym_GT] = ACTIONS(6103),
    [anon_sym_GT_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT_GT] = ACTIONS(6103),
    [anon_sym_LT_AMP] = ACTIONS(6103),
    [anon_sym_GT_AMP] = ACTIONS(6103),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LF] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [2475] = {
    [sym_file_redirect] = STATE(2669),
    [sym_heredoc_redirect] = STATE(2669),
    [sym_herestring_redirect] = STATE(2669),
    [aux_sym_while_statement_repeat1] = STATE(2669),
    [sym_file_descriptor] = ACTIONS(6105),
    [anon_sym_esac] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_SEMI_SEMI] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(6107),
    [anon_sym_GT] = ACTIONS(6107),
    [anon_sym_GT_GT] = ACTIONS(6107),
    [anon_sym_AMP_GT] = ACTIONS(6107),
    [anon_sym_AMP_GT_GT] = ACTIONS(6107),
    [anon_sym_LT_AMP] = ACTIONS(6107),
    [anon_sym_GT_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(6109),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_LF] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1333),
  },
  [2476] = {
    [sym_concatenation] = STATE(2670),
    [sym_string] = STATE(2673),
    [sym_array] = STATE(2670),
    [sym_simple_expansion] = STATE(2673),
    [sym_string_expansion] = STATE(2673),
    [sym_expansion] = STATE(2673),
    [sym_command_substitution] = STATE(2673),
    [sym_process_substitution] = STATE(2673),
    [sym__empty_value] = ACTIONS(6111),
    [anon_sym_LPAREN] = ACTIONS(6113),
    [sym__special_characters] = ACTIONS(6115),
    [anon_sym_DQUOTE] = ACTIONS(5774),
    [anon_sym_DOLLAR] = ACTIONS(5258),
    [sym_raw_string] = ACTIONS(6117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6121),
    [anon_sym_BQUOTE] = ACTIONS(6123),
    [anon_sym_LT_LPAREN] = ACTIONS(6125),
    [anon_sym_GT_LPAREN] = ACTIONS(6125),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6117),
  },
  [2477] = {
    [sym_variable_name] = ACTIONS(392),
    [anon_sym_esac] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_SEMI_SEMI] = ACTIONS(394),
    [anon_sym_PIPE_AMP] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [sym__special_characters] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(394),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [sym_raw_string] = ACTIONS(394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(394),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_LT_LPAREN] = ACTIONS(394),
    [anon_sym_GT_LPAREN] = ACTIONS(394),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(394),
    [sym_word] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LF] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
  },
  [2478] = {
    [sym_string] = STATE(2674),
    [sym_simple_expansion] = STATE(2674),
    [sym_string_expansion] = STATE(2674),
    [sym_expansion] = STATE(2674),
    [sym_command_substitution] = STATE(2674),
    [sym_process_substitution] = STATE(2674),
    [sym__special_characters] = ACTIONS(6127),
    [anon_sym_DQUOTE] = ACTIONS(5774),
    [anon_sym_DOLLAR] = ACTIONS(5258),
    [sym_raw_string] = ACTIONS(6127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6121),
    [anon_sym_BQUOTE] = ACTIONS(6123),
    [anon_sym_LT_LPAREN] = ACTIONS(6125),
    [anon_sym_GT_LPAREN] = ACTIONS(6125),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6127),
  },
  [2479] = {
    [aux_sym_concatenation_repeat1] = STATE(2675),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2480] = {
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2481] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2482] = {
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2483] = {
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2484] = {
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2485] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6131),
    [sym_comment] = ACTIONS(54),
  },
  [2486] = {
    [sym_concatenation] = STATE(2680),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2680),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6135),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6139),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_COLON_QMARK] = ACTIONS(6135),
    [anon_sym_COLON_DASH] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(6135),
    [anon_sym_DASH] = ACTIONS(6135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2487] = {
    [sym_subscript] = STATE(2684),
    [sym_variable_name] = ACTIONS(6141),
    [anon_sym_DOLLAR] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6143),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6145),
    [anon_sym_STAR] = ACTIONS(6143),
    [anon_sym_AT] = ACTIONS(6143),
    [anon_sym_QMARK] = ACTIONS(6143),
    [anon_sym_0] = ACTIONS(6147),
    [anon_sym__] = ACTIONS(6147),
  },
  [2488] = {
    [sym_concatenation] = STATE(2687),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2687),
    [anon_sym_RBRACE] = ACTIONS(6149),
    [anon_sym_EQ] = ACTIONS(6151),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6155),
    [anon_sym_COLON] = ACTIONS(6151),
    [anon_sym_COLON_QMARK] = ACTIONS(6151),
    [anon_sym_COLON_DASH] = ACTIONS(6151),
    [anon_sym_PERCENT] = ACTIONS(6151),
    [anon_sym_DASH] = ACTIONS(6151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2489] = {
    [sym_concatenation] = STATE(2690),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2690),
    [anon_sym_RBRACE] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6159),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6163),
    [anon_sym_COLON] = ACTIONS(6159),
    [anon_sym_COLON_QMARK] = ACTIONS(6159),
    [anon_sym_COLON_DASH] = ACTIONS(6159),
    [anon_sym_PERCENT] = ACTIONS(6159),
    [anon_sym_DASH] = ACTIONS(6159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2490] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6165),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2491] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6165),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2492] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(6165),
    [sym_comment] = ACTIONS(54),
  },
  [2493] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(6165),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2494] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6167),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2495] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6167),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2496] = {
    [sym_variable_assignment] = STATE(2496),
    [sym_subscript] = STATE(2245),
    [sym_concatenation] = STATE(2496),
    [sym_string] = STATE(2239),
    [sym_simple_expansion] = STATE(2239),
    [sym_string_expansion] = STATE(2239),
    [sym_expansion] = STATE(2239),
    [sym_command_substitution] = STATE(2239),
    [sym_process_substitution] = STATE(2239),
    [aux_sym_declaration_command_repeat1] = STATE(2496),
    [sym_variable_name] = ACTIONS(6169),
    [anon_sym_esac] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_SEMI_SEMI] = ACTIONS(1506),
    [anon_sym_PIPE_AMP] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [sym__special_characters] = ACTIONS(6172),
    [anon_sym_DQUOTE] = ACTIONS(6175),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [sym_raw_string] = ACTIONS(6181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6187),
    [anon_sym_BQUOTE] = ACTIONS(6190),
    [anon_sym_LT_LPAREN] = ACTIONS(6193),
    [anon_sym_GT_LPAREN] = ACTIONS(6193),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6196),
    [sym_word] = ACTIONS(6181),
    [anon_sym_SEMI] = ACTIONS(1506),
    [anon_sym_LF] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1506),
  },
  [2497] = {
    [sym_string] = STATE(2693),
    [sym_simple_expansion] = STATE(2693),
    [sym_string_expansion] = STATE(2693),
    [sym_expansion] = STATE(2693),
    [sym_command_substitution] = STATE(2693),
    [sym_process_substitution] = STATE(2693),
    [sym__special_characters] = ACTIONS(6199),
    [anon_sym_DQUOTE] = ACTIONS(5798),
    [anon_sym_DOLLAR] = ACTIONS(5276),
    [sym_raw_string] = ACTIONS(6199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6203),
    [anon_sym_BQUOTE] = ACTIONS(6205),
    [anon_sym_LT_LPAREN] = ACTIONS(6207),
    [anon_sym_GT_LPAREN] = ACTIONS(6207),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6199),
  },
  [2498] = {
    [aux_sym_concatenation_repeat1] = STATE(2694),
    [sym__concat] = ACTIONS(5794),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(694),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2499] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(698),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2500] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(6209),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2501] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(728),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2502] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(732),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2503] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(736),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2504] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6211),
    [sym_comment] = ACTIONS(54),
  },
  [2505] = {
    [sym_concatenation] = STATE(2699),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2699),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [anon_sym_EQ] = ACTIONS(6215),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6219),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_COLON_QMARK] = ACTIONS(6215),
    [anon_sym_COLON_DASH] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_DASH] = ACTIONS(6215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2506] = {
    [sym_subscript] = STATE(2703),
    [sym_variable_name] = ACTIONS(6221),
    [anon_sym_DOLLAR] = ACTIONS(6223),
    [anon_sym_DASH] = ACTIONS(6223),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6225),
    [anon_sym_STAR] = ACTIONS(6223),
    [anon_sym_AT] = ACTIONS(6223),
    [anon_sym_QMARK] = ACTIONS(6223),
    [anon_sym_0] = ACTIONS(6227),
    [anon_sym__] = ACTIONS(6227),
  },
  [2507] = {
    [sym_concatenation] = STATE(2706),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2706),
    [anon_sym_RBRACE] = ACTIONS(6229),
    [anon_sym_EQ] = ACTIONS(6231),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6235),
    [anon_sym_COLON] = ACTIONS(6231),
    [anon_sym_COLON_QMARK] = ACTIONS(6231),
    [anon_sym_COLON_DASH] = ACTIONS(6231),
    [anon_sym_PERCENT] = ACTIONS(6231),
    [anon_sym_DASH] = ACTIONS(6231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2508] = {
    [sym_concatenation] = STATE(2709),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2709),
    [anon_sym_RBRACE] = ACTIONS(6237),
    [anon_sym_EQ] = ACTIONS(6239),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6243),
    [anon_sym_COLON] = ACTIONS(6239),
    [anon_sym_COLON_QMARK] = ACTIONS(6239),
    [anon_sym_COLON_DASH] = ACTIONS(6239),
    [anon_sym_PERCENT] = ACTIONS(6239),
    [anon_sym_DASH] = ACTIONS(6239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2509] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6245),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2510] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6245),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2511] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(6245),
    [sym_comment] = ACTIONS(54),
  },
  [2512] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(6245),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2513] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6247),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2514] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6247),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2515] = {
    [sym_concatenation] = STATE(2515),
    [sym_string] = STATE(2250),
    [sym_simple_expansion] = STATE(2250),
    [sym_string_expansion] = STATE(2250),
    [sym_expansion] = STATE(2250),
    [sym_command_substitution] = STATE(2250),
    [sym_process_substitution] = STATE(2250),
    [aux_sym_unset_command_repeat1] = STATE(2515),
    [anon_sym_esac] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_SEMI_SEMI] = ACTIONS(1587),
    [anon_sym_PIPE_AMP] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [sym__special_characters] = ACTIONS(6249),
    [anon_sym_DQUOTE] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6255),
    [sym_raw_string] = ACTIONS(6258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6264),
    [anon_sym_BQUOTE] = ACTIONS(6267),
    [anon_sym_LT_LPAREN] = ACTIONS(6270),
    [anon_sym_GT_LPAREN] = ACTIONS(6270),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6273),
    [sym_word] = ACTIONS(6258),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_LF] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1587),
  },
  [2516] = {
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2517] = {
    [aux_sym_concatenation_repeat1] = STATE(2517),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(6276),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_EQ_TILDE] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2518] = {
    [sym__simple_heredoc_body] = ACTIONS(1709),
    [sym__heredoc_body_beginning] = ACTIONS(1709),
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_TILDE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1711),
    [anon_sym_LT_LT_LT] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [2519] = {
    [sym_concatenation] = STATE(2715),
    [sym_string] = STATE(2714),
    [sym_simple_expansion] = STATE(2714),
    [sym_string_expansion] = STATE(2714),
    [sym_expansion] = STATE(2714),
    [sym_command_substitution] = STATE(2714),
    [sym_process_substitution] = STATE(2714),
    [anon_sym_RBRACE] = ACTIONS(6279),
    [sym__special_characters] = ACTIONS(6281),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6283),
  },
  [2520] = {
    [sym__simple_heredoc_body] = ACTIONS(1750),
    [sym__heredoc_body_beginning] = ACTIONS(1750),
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_EQ_TILDE] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1752),
    [anon_sym_LT_LT_LT] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [2521] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6285),
  },
  [2522] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6287),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2523] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6289),
    [sym_comment] = ACTIONS(54),
  },
  [2524] = {
    [sym_concatenation] = STATE(2721),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2721),
    [anon_sym_RBRACE] = ACTIONS(6291),
    [anon_sym_EQ] = ACTIONS(6293),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6297),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_COLON_QMARK] = ACTIONS(6293),
    [anon_sym_COLON_DASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2525] = {
    [sym_concatenation] = STATE(2724),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2724),
    [anon_sym_RBRACE] = ACTIONS(6299),
    [anon_sym_EQ] = ACTIONS(6301),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6303),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6305),
    [anon_sym_COLON] = ACTIONS(6301),
    [anon_sym_COLON_QMARK] = ACTIONS(6301),
    [anon_sym_COLON_DASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_DASH] = ACTIONS(6301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2526] = {
    [sym_concatenation] = STATE(2726),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2726),
    [anon_sym_RBRACE] = ACTIONS(6279),
    [anon_sym_EQ] = ACTIONS(6307),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6311),
    [anon_sym_COLON] = ACTIONS(6307),
    [anon_sym_COLON_QMARK] = ACTIONS(6307),
    [anon_sym_COLON_DASH] = ACTIONS(6307),
    [anon_sym_PERCENT] = ACTIONS(6307),
    [anon_sym_DASH] = ACTIONS(6307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2527] = {
    [sym__simple_heredoc_body] = ACTIONS(1816),
    [sym__heredoc_body_beginning] = ACTIONS(1816),
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [2528] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6313),
  },
  [2529] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6315),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2530] = {
    [sym__simple_heredoc_body] = ACTIONS(1824),
    [sym__heredoc_body_beginning] = ACTIONS(1824),
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_EQ_TILDE] = ACTIONS(1826),
    [anon_sym_EQ_EQ] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1826),
    [anon_sym_LT_LT_LT] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [2531] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6317),
  },
  [2532] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6279),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2533] = {
    [sym__simple_heredoc_body] = ACTIONS(1962),
    [sym__heredoc_body_beginning] = ACTIONS(1962),
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [2534] = {
    [sym__simple_heredoc_body] = ACTIONS(2026),
    [sym__heredoc_body_beginning] = ACTIONS(2026),
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_EQ_TILDE] = ACTIONS(2028),
    [anon_sym_EQ_EQ] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2028),
    [anon_sym_LT_LT_LT] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [2535] = {
    [sym_compound_statement] = STATE(2730),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [2536] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_SEMI_SEMI] = ACTIONS(2030),
    [anon_sym_PIPE_AMP] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_PIPE_PIPE] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_LF] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
  },
  [2537] = {
    [anon_sym_esac] = ACTIONS(2034),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [2538] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(2034),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(2034),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_PIPE_PIPE] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_AMP] = ACTIONS(2034),
  },
  [2539] = {
    [sym_concatenation] = STATE(975),
    [sym_string] = STATE(2732),
    [sym_simple_expansion] = STATE(2732),
    [sym_string_expansion] = STATE(2732),
    [sym_expansion] = STATE(2732),
    [sym_command_substitution] = STATE(2732),
    [sym_process_substitution] = STATE(2732),
    [sym__special_characters] = ACTIONS(6319),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_DOLLAR] = ACTIONS(5882),
    [sym_raw_string] = ACTIONS(6321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5888),
    [anon_sym_BQUOTE] = ACTIONS(5890),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6321),
  },
  [2540] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(1283),
    [sym__heredoc_body_beginning] = ACTIONS(1283),
    [sym_file_descriptor] = ACTIONS(1283),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_EQ_TILDE] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_AMP] = ACTIONS(1281),
    [anon_sym_GT_AMP] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1281),
    [anon_sym_LT_LT_LT] = ACTIONS(1281),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [sym_raw_string] = ACTIONS(1281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1281),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LT_LPAREN] = ACTIONS(1281),
    [anon_sym_GT_LPAREN] = ACTIONS(1281),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1281),
  },
  [2541] = {
    [aux_sym_concatenation_repeat1] = STATE(2258),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [sym__concat] = ACTIONS(5290),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [2542] = {
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [2543] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(660),
    [sym__heredoc_body_beginning] = ACTIONS(660),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [2544] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2736),
    [anon_sym_DQUOTE] = ACTIONS(6325),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2545] = {
    [sym_string] = STATE(2738),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_DOLLAR] = ACTIONS(6327),
    [sym_raw_string] = ACTIONS(6329),
    [anon_sym_POUND] = ACTIONS(6327),
    [anon_sym_DASH] = ACTIONS(6327),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6327),
    [anon_sym_AT] = ACTIONS(6327),
    [anon_sym_QMARK] = ACTIONS(6327),
    [anon_sym_0] = ACTIONS(6333),
    [anon_sym__] = ACTIONS(6333),
  },
  [2546] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(676),
    [sym__heredoc_body_beginning] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [2547] = {
    [sym_subscript] = STATE(2744),
    [sym_variable_name] = ACTIONS(6335),
    [anon_sym_DOLLAR] = ACTIONS(6337),
    [anon_sym_POUND] = ACTIONS(6339),
    [anon_sym_DASH] = ACTIONS(6337),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6341),
    [anon_sym_STAR] = ACTIONS(6337),
    [anon_sym_AT] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_0] = ACTIONS(6343),
    [anon_sym__] = ACTIONS(6343),
  },
  [2548] = {
    [sym_for_statement] = STATE(2745),
    [sym_while_statement] = STATE(2745),
    [sym_if_statement] = STATE(2745),
    [sym_case_statement] = STATE(2745),
    [sym_function_definition] = STATE(2745),
    [sym_subshell] = STATE(2745),
    [sym_pipeline] = STATE(2745),
    [sym_list] = STATE(2745),
    [sym_command] = STATE(2745),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2745),
    [sym_variable_assignment] = STATE(2746),
    [sym_declaration_command] = STATE(2745),
    [sym_unset_command] = STATE(2745),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2549] = {
    [sym_for_statement] = STATE(2747),
    [sym_while_statement] = STATE(2747),
    [sym_if_statement] = STATE(2747),
    [sym_case_statement] = STATE(2747),
    [sym_function_definition] = STATE(2747),
    [sym_subshell] = STATE(2747),
    [sym_pipeline] = STATE(2747),
    [sym_list] = STATE(2747),
    [sym_command] = STATE(2747),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2747),
    [sym_variable_assignment] = STATE(2748),
    [sym_declaration_command] = STATE(2747),
    [sym_unset_command] = STATE(2747),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [2550] = {
    [sym_for_statement] = STATE(2749),
    [sym_while_statement] = STATE(2749),
    [sym_if_statement] = STATE(2749),
    [sym_case_statement] = STATE(2749),
    [sym_function_definition] = STATE(2749),
    [sym_subshell] = STATE(2749),
    [sym_pipeline] = STATE(2749),
    [sym_list] = STATE(2749),
    [sym_command] = STATE(2749),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2749),
    [sym_variable_assignment] = STATE(2750),
    [sym_declaration_command] = STATE(2749),
    [sym_unset_command] = STATE(2749),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2551] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(2072),
    [sym__heredoc_body_beginning] = ACTIONS(2072),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [2552] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(2076),
    [sym__heredoc_body_beginning] = ACTIONS(2076),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2553] = {
    [sym_file_redirect] = STATE(2553),
    [sym_heredoc_redirect] = STATE(2553),
    [sym_herestring_redirect] = STATE(2553),
    [aux_sym_while_statement_repeat1] = STATE(2553),
    [sym__simple_heredoc_body] = ACTIONS(2084),
    [sym__heredoc_body_beginning] = ACTIONS(2084),
    [sym_file_descriptor] = ACTIONS(6345),
    [anon_sym_esac] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(6348),
    [anon_sym_GT] = ACTIONS(6348),
    [anon_sym_GT_GT] = ACTIONS(6348),
    [anon_sym_AMP_GT] = ACTIONS(6348),
    [anon_sym_AMP_GT_GT] = ACTIONS(6348),
    [anon_sym_LT_AMP] = ACTIONS(6348),
    [anon_sym_GT_AMP] = ACTIONS(6348),
    [anon_sym_LT_LT] = ACTIONS(2094),
    [anon_sym_LT_LT_DASH] = ACTIONS(2094),
    [anon_sym_LT_LT_LT] = ACTIONS(6351),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [2554] = {
    [sym_file_redirect] = STATE(2553),
    [sym_heredoc_redirect] = STATE(2553),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(2553),
    [aux_sym_while_statement_repeat1] = STATE(2553),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(2080),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [2555] = {
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [aux_sym_command_repeat2] = STATE(2555),
    [sym__simple_heredoc_body] = ACTIONS(1287),
    [sym__heredoc_body_beginning] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(6354),
    [anon_sym_EQ_EQ] = ACTIONS(6354),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [sym__special_characters] = ACTIONS(6357),
    [anon_sym_DQUOTE] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6363),
    [sym_raw_string] = ACTIONS(6366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6372),
    [anon_sym_BQUOTE] = ACTIONS(6375),
    [anon_sym_LT_LPAREN] = ACTIONS(6378),
    [anon_sym_GT_LPAREN] = ACTIONS(6378),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(6366),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [2556] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(6381),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6383),
    [anon_sym_DQUOTE] = ACTIONS(6385),
    [anon_sym_DOLLAR] = ACTIONS(6383),
    [sym_raw_string] = ACTIONS(6385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6385),
    [anon_sym_BQUOTE] = ACTIONS(6385),
    [anon_sym_LT_LPAREN] = ACTIONS(6385),
    [anon_sym_GT_LPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6383),
  },
  [2557] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5320),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2558] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5320),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2559] = {
    [sym_file_redirect] = STATE(2751),
    [sym_heredoc_redirect] = STATE(2751),
    [sym_heredoc_body] = STATE(977),
    [sym_herestring_redirect] = STATE(2751),
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2285),
    [sym_simple_expansion] = STATE(2285),
    [sym_string_expansion] = STATE(2285),
    [sym_expansion] = STATE(2285),
    [sym_command_substitution] = STATE(2285),
    [sym_process_substitution] = STATE(2285),
    [aux_sym_while_statement_repeat1] = STATE(2751),
    [aux_sym_command_repeat2] = STATE(2555),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(2080),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_EQ_TILDE] = ACTIONS(5326),
    [anon_sym_EQ_EQ] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym__special_characters] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(5334),
    [anon_sym_DOLLAR] = ACTIONS(4464),
    [sym_raw_string] = ACTIONS(5336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5340),
    [anon_sym_BQUOTE] = ACTIONS(5342),
    [anon_sym_LT_LPAREN] = ACTIONS(5344),
    [anon_sym_GT_LPAREN] = ACTIONS(5344),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
  },
  [2560] = {
    [anon_sym_esac] = ACTIONS(6381),
    [sym__special_characters] = ACTIONS(6385),
    [anon_sym_DQUOTE] = ACTIONS(6385),
    [anon_sym_DOLLAR] = ACTIONS(6383),
    [sym_raw_string] = ACTIONS(6385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6385),
    [anon_sym_BQUOTE] = ACTIONS(6385),
    [anon_sym_LT_LPAREN] = ACTIONS(6385),
    [anon_sym_GT_LPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6383),
  },
  [2561] = {
    [anon_sym_esac] = ACTIONS(6381),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6387),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2562] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(6381),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6387),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2563] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6391),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6391),
  },
  [2564] = {
    [anon_sym_esac] = ACTIONS(6389),
    [sym__special_characters] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6391),
  },
  [2565] = {
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6395),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2566] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_PIPE] = ACTIONS(5314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6395),
    [anon_sym_PIPE_AMP] = ACTIONS(5314),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(5320),
    [anon_sym_LF] = ACTIONS(5322),
    [anon_sym_AMP] = ACTIONS(5320),
  },
  [2567] = {
    [sym__special_characters] = ACTIONS(5246),
    [anon_sym_DQUOTE] = ACTIONS(5246),
    [anon_sym_DOLLAR] = ACTIONS(5248),
    [sym_raw_string] = ACTIONS(5246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5246),
    [anon_sym_BQUOTE] = ACTIONS(5246),
    [anon_sym_LT_LPAREN] = ACTIONS(5246),
    [anon_sym_GT_LPAREN] = ACTIONS(5246),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5246),
  },
  [2568] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6397),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2569] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6397),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2570] = {
    [sym__terminated_statement] = STATE(2758),
    [sym_for_statement] = STATE(2756),
    [sym_while_statement] = STATE(2756),
    [sym_if_statement] = STATE(2756),
    [sym_case_statement] = STATE(2756),
    [sym_function_definition] = STATE(2756),
    [sym_subshell] = STATE(2756),
    [sym_pipeline] = STATE(2756),
    [sym_list] = STATE(2756),
    [sym_command] = STATE(2756),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2756),
    [sym_variable_assignment] = STATE(2757),
    [sym_declaration_command] = STATE(2756),
    [sym_unset_command] = STATE(2756),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2758),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6399),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2571] = {
    [sym__terminated_statement] = STATE(2759),
    [sym_for_statement] = STATE(2756),
    [sym_while_statement] = STATE(2756),
    [sym_if_statement] = STATE(2756),
    [sym_case_statement] = STATE(2756),
    [sym_function_definition] = STATE(2756),
    [sym_subshell] = STATE(2756),
    [sym_pipeline] = STATE(2756),
    [sym_list] = STATE(2756),
    [sym_command] = STATE(2756),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2756),
    [sym_variable_assignment] = STATE(2757),
    [sym_declaration_command] = STATE(2756),
    [sym_unset_command] = STATE(2756),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2759),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6399),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2572] = {
    [sym__special_characters] = ACTIONS(5355),
    [anon_sym_DQUOTE] = ACTIONS(5355),
    [anon_sym_DOLLAR] = ACTIONS(5357),
    [sym_raw_string] = ACTIONS(5355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5355),
    [anon_sym_BQUOTE] = ACTIONS(5355),
    [anon_sym_LT_LPAREN] = ACTIONS(5355),
    [anon_sym_GT_LPAREN] = ACTIONS(5355),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5355),
  },
  [2573] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6401),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2574] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6401),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2575] = {
    [sym__terminated_statement] = STATE(2758),
    [sym_for_statement] = STATE(2762),
    [sym_while_statement] = STATE(2762),
    [sym_if_statement] = STATE(2762),
    [sym_case_statement] = STATE(2762),
    [sym_function_definition] = STATE(2762),
    [sym_subshell] = STATE(2762),
    [sym_pipeline] = STATE(2762),
    [sym_list] = STATE(2762),
    [sym_command] = STATE(2762),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2762),
    [sym_variable_assignment] = STATE(2763),
    [sym_declaration_command] = STATE(2762),
    [sym_unset_command] = STATE(2762),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2758),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6403),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2576] = {
    [sym__terminated_statement] = STATE(2764),
    [sym_for_statement] = STATE(2762),
    [sym_while_statement] = STATE(2762),
    [sym_if_statement] = STATE(2762),
    [sym_case_statement] = STATE(2762),
    [sym_function_definition] = STATE(2762),
    [sym_subshell] = STATE(2762),
    [sym_pipeline] = STATE(2762),
    [sym_list] = STATE(2762),
    [sym_command] = STATE(2762),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2762),
    [sym_variable_assignment] = STATE(2763),
    [sym_declaration_command] = STATE(2762),
    [sym_unset_command] = STATE(2762),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2764),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6403),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2577] = {
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2578] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2579] = {
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4002),
    [anon_sym_LT_LT_LT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [2580] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6405),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2581] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6407),
    [sym_comment] = ACTIONS(54),
  },
  [2582] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6409),
    [sym_comment] = ACTIONS(54),
  },
  [2583] = {
    [anon_sym_RBRACE] = ACTIONS(6409),
    [sym_comment] = ACTIONS(54),
  },
  [2584] = {
    [sym_concatenation] = STATE(2769),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2769),
    [anon_sym_RBRACE] = ACTIONS(6411),
    [anon_sym_EQ] = ACTIONS(6413),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6413),
    [anon_sym_COLON_QMARK] = ACTIONS(6413),
    [anon_sym_COLON_DASH] = ACTIONS(6413),
    [anon_sym_PERCENT] = ACTIONS(6413),
    [anon_sym_DASH] = ACTIONS(6413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2585] = {
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4018),
    [anon_sym_LT_LT_LT] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [2586] = {
    [sym_concatenation] = STATE(2771),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2771),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6419),
    [anon_sym_COLON_QMARK] = ACTIONS(6419),
    [anon_sym_COLON_DASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2587] = {
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4028),
    [anon_sym_LT_LT_LT] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [2588] = {
    [sym_concatenation] = STATE(2773),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2773),
    [anon_sym_RBRACE] = ACTIONS(6423),
    [anon_sym_EQ] = ACTIONS(6425),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6425),
    [anon_sym_COLON_QMARK] = ACTIONS(6425),
    [anon_sym_COLON_DASH] = ACTIONS(6425),
    [anon_sym_PERCENT] = ACTIONS(6425),
    [anon_sym_DASH] = ACTIONS(6425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2589] = {
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [2590] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6429),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2591] = {
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [2592] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6431),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2593] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_RBRACE] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
  },
  [2594] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
  },
  [2595] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
  },
  [2596] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
  },
  [2597] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2598] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
  },
  [2599] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2600] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
  },
  [2601] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2602] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_RBRACE] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
  },
  [2603] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_RBRACE] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
  },
  [2604] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_POUND] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COLON_QMARK] = ACTIONS(5534),
    [anon_sym_COLON_DASH] = ACTIONS(5534),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
  },
  [2605] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_POUND] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_COLON_QMARK] = ACTIONS(5538),
    [anon_sym_COLON_DASH] = ACTIONS(5538),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
  },
  [2606] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_POUND] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_COLON] = ACTIONS(5542),
    [anon_sym_COLON_QMARK] = ACTIONS(5542),
    [anon_sym_COLON_DASH] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
  },
  [2607] = {
    [anon_sym_PIPE] = ACTIONS(5920),
    [anon_sym_RPAREN] = ACTIONS(5922),
    [anon_sym_PIPE_AMP] = ACTIONS(5922),
    [anon_sym_AMP_AMP] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5922),
    [anon_sym_BQUOTE] = ACTIONS(5922),
    [sym_comment] = ACTIONS(54),
  },
  [2608] = {
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_PIPE_AMP] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_BQUOTE] = ACTIONS(5926),
    [sym_comment] = ACTIONS(54),
  },
  [2609] = {
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_PIPE_AMP] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2744),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2744),
    [anon_sym_LT_AMP] = ACTIONS(2744),
    [anon_sym_GT_AMP] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2744),
    [anon_sym_LT_LT_LT] = ACTIONS(2744),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [sym_comment] = ACTIONS(54),
  },
  [2610] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6439),
    [sym_comment] = ACTIONS(54),
  },
  [2611] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [sym_comment] = ACTIONS(54),
  },
  [2612] = {
    [anon_sym_RBRACE] = ACTIONS(6441),
    [sym_comment] = ACTIONS(54),
  },
  [2613] = {
    [sym_concatenation] = STATE(2782),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2782),
    [anon_sym_RBRACE] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(6445),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6445),
    [anon_sym_COLON_QMARK] = ACTIONS(6445),
    [anon_sym_COLON_DASH] = ACTIONS(6445),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_DASH] = ACTIONS(6445),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2614] = {
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2822),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2822),
    [anon_sym_LT_AMP] = ACTIONS(2822),
    [anon_sym_GT_AMP] = ACTIONS(2822),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2822),
    [anon_sym_LT_LT_LT] = ACTIONS(2822),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(54),
  },
  [2615] = {
    [sym_concatenation] = STATE(2785),
    [sym_string] = STATE(2784),
    [sym_simple_expansion] = STATE(2784),
    [sym_string_expansion] = STATE(2784),
    [sym_expansion] = STATE(2784),
    [sym_command_substitution] = STATE(2784),
    [sym_process_substitution] = STATE(2784),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [sym__special_characters] = ACTIONS(6449),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6451),
  },
  [2616] = {
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_PIPE_AMP] = ACTIONS(2865),
    [anon_sym_AMP_AMP] = ACTIONS(2865),
    [anon_sym_PIPE_PIPE] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2865),
    [anon_sym_LT_AMP] = ACTIONS(2865),
    [anon_sym_GT_AMP] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2865),
    [anon_sym_LT_LT_LT] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [sym_comment] = ACTIONS(54),
  },
  [2617] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6453),
  },
  [2618] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2619] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT_LT] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(54),
  },
  [2620] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6457),
  },
  [2621] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2622] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6461),
  },
  [2623] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2624] = {
    [sym_concatenation] = STATE(2792),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2792),
    [anon_sym_RBRACE] = ACTIONS(6463),
    [anon_sym_EQ] = ACTIONS(6465),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_COLON_QMARK] = ACTIONS(6465),
    [anon_sym_COLON_DASH] = ACTIONS(6465),
    [anon_sym_PERCENT] = ACTIONS(6465),
    [anon_sym_DASH] = ACTIONS(6465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2625] = {
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2889),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2889),
    [anon_sym_LT_AMP] = ACTIONS(2889),
    [anon_sym_GT_AMP] = ACTIONS(2889),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2889),
    [anon_sym_LT_LT_LT] = ACTIONS(2889),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(54),
  },
  [2626] = {
    [sym_concatenation] = STATE(2794),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2794),
    [anon_sym_RBRACE] = ACTIONS(6469),
    [anon_sym_EQ] = ACTIONS(6471),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6471),
    [anon_sym_COLON_QMARK] = ACTIONS(6471),
    [anon_sym_COLON_DASH] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6471),
    [anon_sym_DASH] = ACTIONS(6471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2627] = {
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
  },
  [2628] = {
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_PIPE_AMP] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
  },
  [2629] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
  },
  [2630] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
  },
  [2631] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_PIPE_AMP] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
  },
  [2632] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
  },
  [2633] = {
    [sym__heredoc_body_middle] = ACTIONS(5532),
    [sym__heredoc_body_end] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
  },
  [2634] = {
    [sym__heredoc_body_middle] = ACTIONS(5536),
    [sym__heredoc_body_end] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
  },
  [2635] = {
    [sym__heredoc_body_middle] = ACTIONS(5540),
    [sym__heredoc_body_end] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
  },
  [2636] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(5532),
    [anon_sym_DQUOTE] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [anon_sym_LT_LPAREN] = ACTIONS(5532),
    [anon_sym_GT_LPAREN] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5532),
  },
  [2637] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [sym__special_characters] = ACTIONS(5536),
    [anon_sym_DQUOTE] = ACTIONS(5536),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [anon_sym_LT_LPAREN] = ACTIONS(5536),
    [anon_sym_GT_LPAREN] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5536),
  },
  [2638] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5540),
  },
  [2639] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2640] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2641] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2642] = {
    [sym_file_descriptor] = ACTIONS(2145),
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_esac] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_PIPE_AMP] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_AMP_GT] = ACTIONS(2147),
    [anon_sym_AMP_GT_GT] = ACTIONS(2147),
    [anon_sym_LT_AMP] = ACTIONS(2147),
    [anon_sym_GT_AMP] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [2643] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(6475),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [2644] = {
    [sym_string] = STATE(2796),
    [sym_simple_expansion] = STATE(2796),
    [sym_string_expansion] = STATE(2796),
    [sym_expansion] = STATE(2796),
    [sym_command_substitution] = STATE(2796),
    [sym_process_substitution] = STATE(2796),
    [sym__special_characters] = ACTIONS(6477),
    [anon_sym_DQUOTE] = ACTIONS(5750),
    [anon_sym_DOLLAR] = ACTIONS(5752),
    [sym_raw_string] = ACTIONS(6477),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5758),
    [anon_sym_BQUOTE] = ACTIONS(5760),
    [anon_sym_LT_LPAREN] = ACTIONS(5762),
    [anon_sym_GT_LPAREN] = ACTIONS(5762),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6477),
  },
  [2645] = {
    [aux_sym_concatenation_repeat1] = STATE(2797),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(6077),
    [sym_variable_name] = ACTIONS(692),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [sym__special_characters] = ACTIONS(694),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [sym_raw_string] = ACTIONS(694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LT_LPAREN] = ACTIONS(694),
    [anon_sym_GT_LPAREN] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2646] = {
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [sym_variable_name] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [sym__special_characters] = ACTIONS(698),
    [anon_sym_DQUOTE] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(698),
    [sym_raw_string] = ACTIONS(698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(698),
    [anon_sym_BQUOTE] = ACTIONS(698),
    [anon_sym_LT_LPAREN] = ACTIONS(698),
    [anon_sym_GT_LPAREN] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2647] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(6479),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2648] = {
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [sym_variable_name] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [sym__special_characters] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(728),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2649] = {
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [sym_variable_name] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [sym__special_characters] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [sym_raw_string] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(732),
    [anon_sym_LT_LPAREN] = ACTIONS(732),
    [anon_sym_GT_LPAREN] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2650] = {
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [sym__special_characters] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [sym_raw_string] = ACTIONS(736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(736),
    [anon_sym_LT_LPAREN] = ACTIONS(736),
    [anon_sym_GT_LPAREN] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2651] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6481),
    [sym_comment] = ACTIONS(54),
  },
  [2652] = {
    [sym_concatenation] = STATE(2802),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2802),
    [anon_sym_RBRACE] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(6485),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6489),
    [anon_sym_COLON] = ACTIONS(6485),
    [anon_sym_COLON_QMARK] = ACTIONS(6485),
    [anon_sym_COLON_DASH] = ACTIONS(6485),
    [anon_sym_PERCENT] = ACTIONS(6485),
    [anon_sym_DASH] = ACTIONS(6485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2653] = {
    [sym_subscript] = STATE(2806),
    [sym_variable_name] = ACTIONS(6491),
    [anon_sym_DOLLAR] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6493),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6495),
    [anon_sym_STAR] = ACTIONS(6493),
    [anon_sym_AT] = ACTIONS(6493),
    [anon_sym_QMARK] = ACTIONS(6493),
    [anon_sym_0] = ACTIONS(6497),
    [anon_sym__] = ACTIONS(6497),
  },
  [2654] = {
    [sym_concatenation] = STATE(2809),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2809),
    [anon_sym_RBRACE] = ACTIONS(6499),
    [anon_sym_EQ] = ACTIONS(6501),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6505),
    [anon_sym_COLON] = ACTIONS(6501),
    [anon_sym_COLON_QMARK] = ACTIONS(6501),
    [anon_sym_COLON_DASH] = ACTIONS(6501),
    [anon_sym_PERCENT] = ACTIONS(6501),
    [anon_sym_DASH] = ACTIONS(6501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2655] = {
    [sym_concatenation] = STATE(2812),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2812),
    [anon_sym_RBRACE] = ACTIONS(6507),
    [anon_sym_EQ] = ACTIONS(6509),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6513),
    [anon_sym_COLON] = ACTIONS(6509),
    [anon_sym_COLON_QMARK] = ACTIONS(6509),
    [anon_sym_COLON_DASH] = ACTIONS(6509),
    [anon_sym_PERCENT] = ACTIONS(6509),
    [anon_sym_DASH] = ACTIONS(6509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2656] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6515),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2657] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6515),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2658] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(6515),
    [sym_comment] = ACTIONS(54),
  },
  [2659] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(6515),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2660] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2661] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2662] = {
    [sym_file_redirect] = STATE(2553),
    [sym_heredoc_redirect] = STATE(2553),
    [sym_heredoc_body] = STATE(1050),
    [sym_herestring_redirect] = STATE(2553),
    [aux_sym_while_statement_repeat1] = STATE(2553),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_AMP] = ACTIONS(2279),
  },
  [2663] = {
    [sym_compound_statement] = STATE(2815),
    [anon_sym_LBRACE] = ACTIONS(446),
    [sym_comment] = ACTIONS(54),
  },
  [2664] = {
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_GT] = ACTIONS(6521),
    [anon_sym_AMP_GT] = ACTIONS(6519),
    [anon_sym_AMP_GT_GT] = ACTIONS(6521),
    [anon_sym_LT_AMP] = ACTIONS(6521),
    [anon_sym_GT_AMP] = ACTIONS(6521),
    [sym_comment] = ACTIONS(54),
  },
  [2665] = {
    [sym_concatenation] = STATE(1097),
    [sym_string] = STATE(2820),
    [sym_simple_expansion] = STATE(2820),
    [sym_string_expansion] = STATE(2820),
    [sym_expansion] = STATE(2820),
    [sym_command_substitution] = STATE(2820),
    [sym_process_substitution] = STATE(2820),
    [sym__special_characters] = ACTIONS(6523),
    [anon_sym_DQUOTE] = ACTIONS(6525),
    [anon_sym_DOLLAR] = ACTIONS(6527),
    [sym_raw_string] = ACTIONS(6529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6531),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6533),
    [anon_sym_BQUOTE] = ACTIONS(6535),
    [anon_sym_LT_LPAREN] = ACTIONS(6537),
    [anon_sym_GT_LPAREN] = ACTIONS(6537),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6529),
  },
  [2666] = {
    [anon_sym_LT] = ACTIONS(6539),
    [anon_sym_GT] = ACTIONS(6539),
    [anon_sym_GT_GT] = ACTIONS(6541),
    [anon_sym_AMP_GT] = ACTIONS(6539),
    [anon_sym_AMP_GT_GT] = ACTIONS(6541),
    [anon_sym_LT_AMP] = ACTIONS(6541),
    [anon_sym_GT_AMP] = ACTIONS(6541),
    [sym_comment] = ACTIONS(54),
  },
  [2667] = {
    [sym_concatenation] = STATE(1144),
    [sym_string] = STATE(2827),
    [sym_simple_expansion] = STATE(2827),
    [sym_string_expansion] = STATE(2827),
    [sym_expansion] = STATE(2827),
    [sym_command_substitution] = STATE(2827),
    [sym_process_substitution] = STATE(2827),
    [sym__special_characters] = ACTIONS(6543),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(6545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6545),
  },
  [2668] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(2829),
    [sym_simple_expansion] = STATE(2829),
    [sym_string_expansion] = STATE(2829),
    [sym_expansion] = STATE(2829),
    [sym_command_substitution] = STATE(2829),
    [sym_process_substitution] = STATE(2829),
    [sym__special_characters] = ACTIONS(6547),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(6549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6549),
  },
  [2669] = {
    [sym_file_redirect] = STATE(2830),
    [sym_heredoc_redirect] = STATE(2830),
    [sym_herestring_redirect] = STATE(2830),
    [aux_sym_while_statement_repeat1] = STATE(2830),
    [sym_file_descriptor] = ACTIONS(6105),
    [anon_sym_esac] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(6107),
    [anon_sym_GT] = ACTIONS(6107),
    [anon_sym_GT_GT] = ACTIONS(6107),
    [anon_sym_AMP_GT] = ACTIONS(6107),
    [anon_sym_AMP_GT_GT] = ACTIONS(6107),
    [anon_sym_LT_AMP] = ACTIONS(6107),
    [anon_sym_GT_AMP] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_LT_LT_DASH] = ACTIONS(1337),
    [anon_sym_LT_LT_LT] = ACTIONS(6109),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_LF] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
  },
  [2670] = {
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2671] = {
    [sym_concatenation] = STATE(2832),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(2832),
    [anon_sym_RPAREN] = ACTIONS(6551),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [2672] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(1119),
    [anon_sym_esac] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [sym__special_characters] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [sym_raw_string] = ACTIONS(1123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LT_LPAREN] = ACTIONS(1123),
    [anon_sym_GT_LPAREN] = ACTIONS(1123),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1123),
    [sym_word] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [2673] = {
    [aux_sym_concatenation_repeat1] = STATE(2479),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [sym__special_characters] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LT_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_LPAREN] = ACTIONS(1099),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2674] = {
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2675] = {
    [aux_sym_concatenation_repeat1] = STATE(2675),
    [sym__concat] = ACTIONS(6553),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2676] = {
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [2677] = {
    [sym_concatenation] = STATE(2836),
    [sym_string] = STATE(2835),
    [sym_simple_expansion] = STATE(2835),
    [sym_string_expansion] = STATE(2835),
    [sym_expansion] = STATE(2835),
    [sym_command_substitution] = STATE(2835),
    [sym_process_substitution] = STATE(2835),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [sym__special_characters] = ACTIONS(6558),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6560),
  },
  [2678] = {
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [2679] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6562),
  },
  [2680] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2681] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6566),
    [sym_comment] = ACTIONS(54),
  },
  [2682] = {
    [sym_concatenation] = STATE(2842),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2842),
    [anon_sym_RBRACE] = ACTIONS(6568),
    [anon_sym_EQ] = ACTIONS(6570),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6574),
    [anon_sym_COLON] = ACTIONS(6570),
    [anon_sym_COLON_QMARK] = ACTIONS(6570),
    [anon_sym_COLON_DASH] = ACTIONS(6570),
    [anon_sym_PERCENT] = ACTIONS(6570),
    [anon_sym_DASH] = ACTIONS(6570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2683] = {
    [sym_concatenation] = STATE(2845),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2845),
    [anon_sym_RBRACE] = ACTIONS(6576),
    [anon_sym_EQ] = ACTIONS(6578),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6582),
    [anon_sym_COLON] = ACTIONS(6578),
    [anon_sym_COLON_QMARK] = ACTIONS(6578),
    [anon_sym_COLON_DASH] = ACTIONS(6578),
    [anon_sym_PERCENT] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2684] = {
    [sym_concatenation] = STATE(2847),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2847),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6584),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6588),
    [anon_sym_COLON] = ACTIONS(6584),
    [anon_sym_COLON_QMARK] = ACTIONS(6584),
    [anon_sym_COLON_DASH] = ACTIONS(6584),
    [anon_sym_PERCENT] = ACTIONS(6584),
    [anon_sym_DASH] = ACTIONS(6584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2685] = {
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [2686] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6590),
  },
  [2687] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2688] = {
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [2689] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6594),
  },
  [2690] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2691] = {
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [2692] = {
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [2693] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2694] = {
    [aux_sym_concatenation_repeat1] = STATE(2694),
    [sym__concat] = ACTIONS(6596),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1662),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2695] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1711),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [2696] = {
    [sym_concatenation] = STATE(2854),
    [sym_string] = STATE(2853),
    [sym_simple_expansion] = STATE(2853),
    [sym_string_expansion] = STATE(2853),
    [sym_expansion] = STATE(2853),
    [sym_command_substitution] = STATE(2853),
    [sym_process_substitution] = STATE(2853),
    [anon_sym_RBRACE] = ACTIONS(6599),
    [sym__special_characters] = ACTIONS(6601),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6603),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6603),
  },
  [2697] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1752),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [2698] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6605),
  },
  [2699] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2700] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6609),
    [sym_comment] = ACTIONS(54),
  },
  [2701] = {
    [sym_concatenation] = STATE(2860),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2860),
    [anon_sym_RBRACE] = ACTIONS(6611),
    [anon_sym_EQ] = ACTIONS(6613),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6617),
    [anon_sym_COLON] = ACTIONS(6613),
    [anon_sym_COLON_QMARK] = ACTIONS(6613),
    [anon_sym_COLON_DASH] = ACTIONS(6613),
    [anon_sym_PERCENT] = ACTIONS(6613),
    [anon_sym_DASH] = ACTIONS(6613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2702] = {
    [sym_concatenation] = STATE(2863),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2863),
    [anon_sym_RBRACE] = ACTIONS(6619),
    [anon_sym_EQ] = ACTIONS(6621),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6625),
    [anon_sym_COLON] = ACTIONS(6621),
    [anon_sym_COLON_QMARK] = ACTIONS(6621),
    [anon_sym_COLON_DASH] = ACTIONS(6621),
    [anon_sym_PERCENT] = ACTIONS(6621),
    [anon_sym_DASH] = ACTIONS(6621),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2703] = {
    [sym_concatenation] = STATE(2865),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2865),
    [anon_sym_RBRACE] = ACTIONS(6599),
    [anon_sym_EQ] = ACTIONS(6627),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6631),
    [anon_sym_COLON] = ACTIONS(6627),
    [anon_sym_COLON_QMARK] = ACTIONS(6627),
    [anon_sym_COLON_DASH] = ACTIONS(6627),
    [anon_sym_PERCENT] = ACTIONS(6627),
    [anon_sym_DASH] = ACTIONS(6627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2704] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1818),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [2705] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6633),
  },
  [2706] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6635),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2707] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1826),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [2708] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6637),
  },
  [2709] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6599),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2710] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [2711] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2028),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [2712] = {
    [sym__simple_heredoc_body] = ACTIONS(2744),
    [sym__heredoc_body_beginning] = ACTIONS(2744),
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_EQ_TILDE] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2746),
    [anon_sym_LT_LT_LT] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [2713] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6639),
    [sym_comment] = ACTIONS(54),
  },
  [2714] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6641),
    [sym_comment] = ACTIONS(54),
  },
  [2715] = {
    [anon_sym_RBRACE] = ACTIONS(6641),
    [sym_comment] = ACTIONS(54),
  },
  [2716] = {
    [sym_concatenation] = STATE(2872),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2872),
    [anon_sym_RBRACE] = ACTIONS(6643),
    [anon_sym_EQ] = ACTIONS(6645),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6645),
    [anon_sym_COLON_QMARK] = ACTIONS(6645),
    [anon_sym_COLON_DASH] = ACTIONS(6645),
    [anon_sym_PERCENT] = ACTIONS(6645),
    [anon_sym_DASH] = ACTIONS(6645),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2717] = {
    [sym__simple_heredoc_body] = ACTIONS(2822),
    [sym__heredoc_body_beginning] = ACTIONS(2822),
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_EQ_TILDE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2824),
    [anon_sym_LT_LT_LT] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [2718] = {
    [sym_concatenation] = STATE(2875),
    [sym_string] = STATE(2874),
    [sym_simple_expansion] = STATE(2874),
    [sym_string_expansion] = STATE(2874),
    [sym_expansion] = STATE(2874),
    [sym_command_substitution] = STATE(2874),
    [sym_process_substitution] = STATE(2874),
    [anon_sym_RBRACE] = ACTIONS(6641),
    [sym__special_characters] = ACTIONS(6649),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6651),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6651),
  },
  [2719] = {
    [sym__simple_heredoc_body] = ACTIONS(2865),
    [sym__heredoc_body_beginning] = ACTIONS(2865),
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_EQ_TILDE] = ACTIONS(2867),
    [anon_sym_EQ_EQ] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2867),
    [anon_sym_LT_LT_LT] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [2720] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6653),
  },
  [2721] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6655),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2722] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2723] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6657),
  },
  [2724] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6659),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2725] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6661),
  },
  [2726] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6641),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2727] = {
    [sym_concatenation] = STATE(2882),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2882),
    [anon_sym_RBRACE] = ACTIONS(6663),
    [anon_sym_EQ] = ACTIONS(6665),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6665),
    [anon_sym_COLON_QMARK] = ACTIONS(6665),
    [anon_sym_COLON_DASH] = ACTIONS(6665),
    [anon_sym_PERCENT] = ACTIONS(6665),
    [anon_sym_DASH] = ACTIONS(6665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2728] = {
    [sym__simple_heredoc_body] = ACTIONS(2889),
    [sym__heredoc_body_beginning] = ACTIONS(2889),
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_EQ_TILDE] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2891),
    [anon_sym_LT_LT_LT] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [2729] = {
    [sym_concatenation] = STATE(2884),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2884),
    [anon_sym_RBRACE] = ACTIONS(6669),
    [anon_sym_EQ] = ACTIONS(6671),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6671),
    [anon_sym_COLON_QMARK] = ACTIONS(6671),
    [anon_sym_COLON_DASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [anon_sym_DASH] = ACTIONS(6671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2730] = {
    [sym_file_redirect] = STATE(1417),
    [sym_file_descriptor] = ACTIONS(6101),
    [anon_sym_esac] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_SEMI_SEMI] = ACTIONS(2380),
    [anon_sym_PIPE_AMP] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(6103),
    [anon_sym_GT] = ACTIONS(6103),
    [anon_sym_GT_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT_GT] = ACTIONS(6103),
    [anon_sym_LT_AMP] = ACTIONS(6103),
    [anon_sym_GT_AMP] = ACTIONS(6103),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LF] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2380),
  },
  [2731] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(1079),
    [sym__heredoc_body_beginning] = ACTIONS(1079),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [2732] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [sym__simple_heredoc_body] = ACTIONS(1083),
    [sym__heredoc_body_beginning] = ACTIONS(1083),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [2733] = {
    [sym_string] = STATE(2885),
    [sym_simple_expansion] = STATE(2885),
    [sym_string_expansion] = STATE(2885),
    [sym_expansion] = STATE(2885),
    [sym_command_substitution] = STATE(2885),
    [sym_process_substitution] = STATE(2885),
    [sym__special_characters] = ACTIONS(6675),
    [anon_sym_DQUOTE] = ACTIONS(5880),
    [anon_sym_DOLLAR] = ACTIONS(5882),
    [sym_raw_string] = ACTIONS(6675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5888),
    [anon_sym_BQUOTE] = ACTIONS(5890),
    [anon_sym_LT_LPAREN] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(5892),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6675),
  },
  [2734] = {
    [aux_sym_concatenation_repeat1] = STATE(2886),
    [sym__simple_heredoc_body] = ACTIONS(692),
    [sym__heredoc_body_beginning] = ACTIONS(692),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(6323),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2735] = {
    [sym__simple_heredoc_body] = ACTIONS(696),
    [sym__heredoc_body_beginning] = ACTIONS(696),
    [sym_file_descriptor] = ACTIONS(696),
    [sym__concat] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_AMP_GT] = ACTIONS(698),
    [anon_sym_AMP_GT_GT] = ACTIONS(698),
    [anon_sym_LT_AMP] = ACTIONS(698),
    [anon_sym_GT_AMP] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT_LT_DASH] = ACTIONS(698),
    [anon_sym_LT_LT_LT] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2736] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(6677),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2737] = {
    [sym__simple_heredoc_body] = ACTIONS(726),
    [sym__heredoc_body_beginning] = ACTIONS(726),
    [sym_file_descriptor] = ACTIONS(726),
    [sym__concat] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(728),
    [anon_sym_GT] = ACTIONS(728),
    [anon_sym_GT_GT] = ACTIONS(728),
    [anon_sym_AMP_GT] = ACTIONS(728),
    [anon_sym_AMP_GT_GT] = ACTIONS(728),
    [anon_sym_LT_AMP] = ACTIONS(728),
    [anon_sym_GT_AMP] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(728),
    [anon_sym_LT_LT_DASH] = ACTIONS(728),
    [anon_sym_LT_LT_LT] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2738] = {
    [sym__simple_heredoc_body] = ACTIONS(730),
    [sym__heredoc_body_beginning] = ACTIONS(730),
    [sym_file_descriptor] = ACTIONS(730),
    [sym__concat] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(732),
    [anon_sym_GT] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(732),
    [anon_sym_AMP_GT] = ACTIONS(732),
    [anon_sym_AMP_GT_GT] = ACTIONS(732),
    [anon_sym_LT_AMP] = ACTIONS(732),
    [anon_sym_GT_AMP] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(732),
    [anon_sym_LT_LT_DASH] = ACTIONS(732),
    [anon_sym_LT_LT_LT] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2739] = {
    [sym__simple_heredoc_body] = ACTIONS(734),
    [sym__heredoc_body_beginning] = ACTIONS(734),
    [sym_file_descriptor] = ACTIONS(734),
    [sym__concat] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(736),
    [anon_sym_AMP_GT] = ACTIONS(736),
    [anon_sym_AMP_GT_GT] = ACTIONS(736),
    [anon_sym_LT_AMP] = ACTIONS(736),
    [anon_sym_GT_AMP] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_LT_LT_DASH] = ACTIONS(736),
    [anon_sym_LT_LT_LT] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2740] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6679),
    [sym_comment] = ACTIONS(54),
  },
  [2741] = {
    [sym_concatenation] = STATE(2891),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2891),
    [anon_sym_RBRACE] = ACTIONS(6681),
    [anon_sym_EQ] = ACTIONS(6683),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6687),
    [anon_sym_COLON] = ACTIONS(6683),
    [anon_sym_COLON_QMARK] = ACTIONS(6683),
    [anon_sym_COLON_DASH] = ACTIONS(6683),
    [anon_sym_PERCENT] = ACTIONS(6683),
    [anon_sym_DASH] = ACTIONS(6683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2742] = {
    [sym_subscript] = STATE(2895),
    [sym_variable_name] = ACTIONS(6689),
    [anon_sym_DOLLAR] = ACTIONS(6691),
    [anon_sym_DASH] = ACTIONS(6691),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6693),
    [anon_sym_STAR] = ACTIONS(6691),
    [anon_sym_AT] = ACTIONS(6691),
    [anon_sym_QMARK] = ACTIONS(6691),
    [anon_sym_0] = ACTIONS(6695),
    [anon_sym__] = ACTIONS(6695),
  },
  [2743] = {
    [sym_concatenation] = STATE(2898),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2898),
    [anon_sym_RBRACE] = ACTIONS(6697),
    [anon_sym_EQ] = ACTIONS(6699),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6703),
    [anon_sym_COLON] = ACTIONS(6699),
    [anon_sym_COLON_QMARK] = ACTIONS(6699),
    [anon_sym_COLON_DASH] = ACTIONS(6699),
    [anon_sym_PERCENT] = ACTIONS(6699),
    [anon_sym_DASH] = ACTIONS(6699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2744] = {
    [sym_concatenation] = STATE(2901),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2901),
    [anon_sym_RBRACE] = ACTIONS(6705),
    [anon_sym_EQ] = ACTIONS(6707),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6711),
    [anon_sym_COLON] = ACTIONS(6707),
    [anon_sym_COLON_QMARK] = ACTIONS(6707),
    [anon_sym_COLON_DASH] = ACTIONS(6707),
    [anon_sym_PERCENT] = ACTIONS(6707),
    [anon_sym_DASH] = ACTIONS(6707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2745] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6713),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2746] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6713),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2747] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(6713),
    [sym_comment] = ACTIONS(54),
  },
  [2748] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(6713),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2749] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6715),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2750] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(6715),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2751] = {
    [sym_file_redirect] = STATE(2553),
    [sym_heredoc_redirect] = STATE(2553),
    [sym_heredoc_body] = STATE(1433),
    [sym_herestring_redirect] = STATE(2553),
    [aux_sym_while_statement_repeat1] = STATE(2553),
    [sym__simple_heredoc_body] = ACTIONS(322),
    [sym__heredoc_body_beginning] = ACTIONS(324),
    [sym_file_descriptor] = ACTIONS(5324),
    [anon_sym_esac] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3319),
    [anon_sym_SEMI_SEMI] = ACTIONS(3319),
    [anon_sym_PIPE_AMP] = ACTIONS(3319),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(5328),
    [anon_sym_GT] = ACTIONS(5328),
    [anon_sym_GT_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT] = ACTIONS(5328),
    [anon_sym_AMP_GT_GT] = ACTIONS(5328),
    [anon_sym_LT_AMP] = ACTIONS(5328),
    [anon_sym_GT_AMP] = ACTIONS(5328),
    [anon_sym_LT_LT] = ACTIONS(334),
    [anon_sym_LT_LT_DASH] = ACTIONS(334),
    [anon_sym_LT_LT_LT] = ACTIONS(5330),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3319),
  },
  [2752] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(6717),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6719),
    [anon_sym_DQUOTE] = ACTIONS(6721),
    [anon_sym_DOLLAR] = ACTIONS(6719),
    [sym_raw_string] = ACTIONS(6721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6721),
    [anon_sym_LT_LPAREN] = ACTIONS(6721),
    [anon_sym_GT_LPAREN] = ACTIONS(6721),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6719),
  },
  [2753] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(6723),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6725),
    [anon_sym_DQUOTE] = ACTIONS(6727),
    [anon_sym_DOLLAR] = ACTIONS(6725),
    [sym_raw_string] = ACTIONS(6727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6727),
    [anon_sym_BQUOTE] = ACTIONS(6727),
    [anon_sym_LT_LPAREN] = ACTIONS(6727),
    [anon_sym_GT_LPAREN] = ACTIONS(6727),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6725),
  },
  [2754] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(5864),
    [anon_sym_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR] = ACTIONS(5864),
    [sym_raw_string] = ACTIONS(5866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5866),
    [anon_sym_LT_LPAREN] = ACTIONS(5866),
    [anon_sym_GT_LPAREN] = ACTIONS(5866),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5864),
  },
  [2755] = {
    [sym__special_characters] = ACTIONS(5866),
    [anon_sym_DQUOTE] = ACTIONS(5866),
    [anon_sym_DOLLAR] = ACTIONS(5864),
    [sym_raw_string] = ACTIONS(5866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5866),
    [anon_sym_BQUOTE] = ACTIONS(5866),
    [anon_sym_LT_LPAREN] = ACTIONS(5866),
    [anon_sym_GT_LPAREN] = ACTIONS(5866),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5866),
  },
  [2756] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6729),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2757] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6729),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2758] = {
    [sym__terminated_statement] = STATE(2758),
    [sym_for_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_subshell] = STATE(25),
    [sym_pipeline] = STATE(25),
    [sym_list] = STATE(25),
    [sym_command] = STATE(25),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(25),
    [sym_variable_assignment] = STATE(27),
    [sym_declaration_command] = STATE(25),
    [sym_unset_command] = STATE(25),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2758),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(990),
    [sym_variable_name] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_SEMI_SEMI] = ACTIONS(996),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_typeset] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_local] = ACTIONS(1022),
    [anon_sym_unset] = ACTIONS(1025),
    [anon_sym_unsetenv] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_AMP_GT] = ACTIONS(1028),
    [anon_sym_AMP_GT_GT] = ACTIONS(1031),
    [anon_sym_LT_AMP] = ACTIONS(1031),
    [anon_sym_GT_AMP] = ACTIONS(1031),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [sym_raw_string] = ACTIONS(1043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(1055),
    [anon_sym_GT_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1058),
  },
  [2759] = {
    [sym__terminated_statement] = STATE(2758),
    [sym_for_statement] = STATE(2906),
    [sym_while_statement] = STATE(2906),
    [sym_if_statement] = STATE(2906),
    [sym_case_statement] = STATE(2906),
    [sym_function_definition] = STATE(2906),
    [sym_subshell] = STATE(2906),
    [sym_pipeline] = STATE(2906),
    [sym_list] = STATE(2906),
    [sym_command] = STATE(2906),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2906),
    [sym_variable_assignment] = STATE(2907),
    [sym_declaration_command] = STATE(2906),
    [sym_unset_command] = STATE(2906),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2758),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6731),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2760] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(5904),
    [anon_sym_DQUOTE] = ACTIONS(5906),
    [anon_sym_DOLLAR] = ACTIONS(5904),
    [sym_raw_string] = ACTIONS(5906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5906),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [anon_sym_LT_LPAREN] = ACTIONS(5906),
    [anon_sym_GT_LPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5904),
  },
  [2761] = {
    [sym__special_characters] = ACTIONS(5906),
    [anon_sym_DQUOTE] = ACTIONS(5906),
    [anon_sym_DOLLAR] = ACTIONS(5904),
    [sym_raw_string] = ACTIONS(5906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5906),
    [anon_sym_BQUOTE] = ACTIONS(5906),
    [anon_sym_LT_LPAREN] = ACTIONS(5906),
    [anon_sym_GT_LPAREN] = ACTIONS(5906),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(5906),
  },
  [2762] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6733),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2763] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6733),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2764] = {
    [sym__terminated_statement] = STATE(2758),
    [sym_for_statement] = STATE(2910),
    [sym_while_statement] = STATE(2910),
    [sym_if_statement] = STATE(2910),
    [sym_case_statement] = STATE(2910),
    [sym_function_definition] = STATE(2910),
    [sym_subshell] = STATE(2910),
    [sym_pipeline] = STATE(2910),
    [sym_list] = STATE(2910),
    [sym_command] = STATE(2910),
    [sym_command_name] = STATE(26),
    [sym_bracket_command] = STATE(2910),
    [sym_variable_assignment] = STATE(2911),
    [sym_declaration_command] = STATE(2910),
    [sym_unset_command] = STATE(2910),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(31),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(18),
    [sym_simple_expansion] = STATE(18),
    [sym_string_expansion] = STATE(18),
    [sym_expansion] = STATE(18),
    [sym_command_substitution] = STATE(18),
    [sym_process_substitution] = STATE(18),
    [aux_sym_program_repeat1] = STATE(2758),
    [aux_sym_command_repeat1] = STATE(31),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(6735),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_LBRACK] = ACTIONS(26),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(28),
    [anon_sym_declare] = ACTIONS(30),
    [anon_sym_typeset] = ACTIONS(30),
    [anon_sym_export] = ACTIONS(30),
    [anon_sym_readonly] = ACTIONS(30),
    [anon_sym_local] = ACTIONS(30),
    [anon_sym_unset] = ACTIONS(32),
    [anon_sym_unsetenv] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(38),
    [anon_sym_DQUOTE] = ACTIONS(40),
    [anon_sym_DOLLAR] = ACTIONS(42),
    [sym_raw_string] = ACTIONS(44),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(46),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(48),
    [anon_sym_BQUOTE] = ACTIONS(50),
    [anon_sym_LT_LPAREN] = ACTIONS(52),
    [anon_sym_GT_LPAREN] = ACTIONS(52),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(56),
  },
  [2765] = {
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4878),
    [anon_sym_LT_LT_LT] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [2766] = {
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4882),
    [anon_sym_LT_LT_LT] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [2767] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2768] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2769] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6737),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2770] = {
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [2771] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2772] = {
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [2773] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2774] = {
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [2775] = {
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [2776] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
  },
  [2777] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
  },
  [2778] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
  },
  [2779] = {
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_PIPE_AMP] = ACTIONS(3909),
    [anon_sym_AMP_AMP] = ACTIONS(3909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3909),
    [anon_sym_LT_AMP] = ACTIONS(3909),
    [anon_sym_GT_AMP] = ACTIONS(3909),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3909),
    [anon_sym_LT_LT_LT] = ACTIONS(3909),
    [anon_sym_BQUOTE] = ACTIONS(3909),
    [sym_comment] = ACTIONS(54),
  },
  [2780] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(54),
  },
  [2781] = {
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_PIPE_AMP] = ACTIONS(4000),
    [anon_sym_AMP_AMP] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4000),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4000),
    [anon_sym_LT_AMP] = ACTIONS(4000),
    [anon_sym_GT_AMP] = ACTIONS(4000),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4000),
    [anon_sym_LT_LT_LT] = ACTIONS(4000),
    [anon_sym_BQUOTE] = ACTIONS(4000),
    [sym_comment] = ACTIONS(54),
  },
  [2782] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2783] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym_comment] = ACTIONS(54),
  },
  [2784] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6747),
    [sym_comment] = ACTIONS(54),
  },
  [2785] = {
    [anon_sym_RBRACE] = ACTIONS(6747),
    [sym_comment] = ACTIONS(54),
  },
  [2786] = {
    [sym_concatenation] = STATE(2919),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2919),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(6751),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6751),
    [anon_sym_COLON_QMARK] = ACTIONS(6751),
    [anon_sym_COLON_DASH] = ACTIONS(6751),
    [anon_sym_PERCENT] = ACTIONS(6751),
    [anon_sym_DASH] = ACTIONS(6751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2787] = {
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4016),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4016),
    [anon_sym_LT_AMP] = ACTIONS(4016),
    [anon_sym_GT_AMP] = ACTIONS(4016),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4016),
    [anon_sym_LT_LT_LT] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [sym_comment] = ACTIONS(54),
  },
  [2788] = {
    [sym_concatenation] = STATE(2921),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2921),
    [anon_sym_RBRACE] = ACTIONS(6755),
    [anon_sym_EQ] = ACTIONS(6757),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6757),
    [anon_sym_COLON_QMARK] = ACTIONS(6757),
    [anon_sym_COLON_DASH] = ACTIONS(6757),
    [anon_sym_PERCENT] = ACTIONS(6757),
    [anon_sym_DASH] = ACTIONS(6757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2789] = {
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [sym_comment] = ACTIONS(54),
  },
  [2790] = {
    [sym_concatenation] = STATE(2923),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2923),
    [anon_sym_RBRACE] = ACTIONS(6761),
    [anon_sym_EQ] = ACTIONS(6763),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6763),
    [anon_sym_COLON_QMARK] = ACTIONS(6763),
    [anon_sym_COLON_DASH] = ACTIONS(6763),
    [anon_sym_PERCENT] = ACTIONS(6763),
    [anon_sym_DASH] = ACTIONS(6763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2791] = {
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(54),
  },
  [2792] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6767),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2793] = {
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4042),
    [anon_sym_PIPE_AMP] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4042),
    [anon_sym_PIPE_PIPE] = ACTIONS(4042),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4042),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4042),
    [anon_sym_LT_AMP] = ACTIONS(4042),
    [anon_sym_GT_AMP] = ACTIONS(4042),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4042),
    [anon_sym_LT_LT_LT] = ACTIONS(4042),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(54),
  },
  [2794] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6769),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2795] = {
    [sym_file_descriptor] = ACTIONS(3373),
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_esac] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_SEMI_SEMI] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_GT_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT] = ACTIONS(3375),
    [anon_sym_AMP_GT_GT] = ACTIONS(3375),
    [anon_sym_LT_AMP] = ACTIONS(3375),
    [anon_sym_GT_AMP] = ACTIONS(3375),
    [sym__special_characters] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3375),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_LT_LPAREN] = ACTIONS(3375),
    [anon_sym_GT_LPAREN] = ACTIONS(3375),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [2796] = {
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2797] = {
    [aux_sym_concatenation_repeat1] = STATE(2797),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(6771),
    [sym_variable_name] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [sym__special_characters] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1662),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1662),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [anon_sym_LT_LPAREN] = ACTIONS(1662),
    [anon_sym_GT_LPAREN] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2798] = {
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [sym_variable_name] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [sym__special_characters] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [2799] = {
    [sym_concatenation] = STATE(2929),
    [sym_string] = STATE(2928),
    [sym_simple_expansion] = STATE(2928),
    [sym_string_expansion] = STATE(2928),
    [sym_expansion] = STATE(2928),
    [sym_command_substitution] = STATE(2928),
    [sym_process_substitution] = STATE(2928),
    [anon_sym_RBRACE] = ACTIONS(6774),
    [sym__special_characters] = ACTIONS(6776),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6778),
  },
  [2800] = {
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [sym_variable_name] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [2801] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6780),
  },
  [2802] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2803] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6784),
    [sym_comment] = ACTIONS(54),
  },
  [2804] = {
    [sym_concatenation] = STATE(2935),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2935),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_EQ] = ACTIONS(6788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6792),
    [anon_sym_COLON] = ACTIONS(6788),
    [anon_sym_COLON_QMARK] = ACTIONS(6788),
    [anon_sym_COLON_DASH] = ACTIONS(6788),
    [anon_sym_PERCENT] = ACTIONS(6788),
    [anon_sym_DASH] = ACTIONS(6788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2805] = {
    [sym_concatenation] = STATE(2938),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2938),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_EQ] = ACTIONS(6796),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6800),
    [anon_sym_COLON] = ACTIONS(6796),
    [anon_sym_COLON_QMARK] = ACTIONS(6796),
    [anon_sym_COLON_DASH] = ACTIONS(6796),
    [anon_sym_PERCENT] = ACTIONS(6796),
    [anon_sym_DASH] = ACTIONS(6796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2806] = {
    [sym_concatenation] = STATE(2940),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2940),
    [anon_sym_RBRACE] = ACTIONS(6774),
    [anon_sym_EQ] = ACTIONS(6802),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6806),
    [anon_sym_COLON] = ACTIONS(6802),
    [anon_sym_COLON_QMARK] = ACTIONS(6802),
    [anon_sym_COLON_DASH] = ACTIONS(6802),
    [anon_sym_PERCENT] = ACTIONS(6802),
    [anon_sym_DASH] = ACTIONS(6802),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2807] = {
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [sym_variable_name] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [2808] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6808),
  },
  [2809] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2810] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [sym_variable_name] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1826),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [2811] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6812),
  },
  [2812] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6774),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2813] = {
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [2814] = {
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [sym_variable_name] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [sym__special_characters] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_DOLLAR] = ACTIONS(2028),
    [sym_raw_string] = ACTIONS(2028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [2815] = {
    [sym_file_redirect] = STATE(1530),
    [sym_file_descriptor] = ACTIONS(6101),
    [anon_sym_esac] = ACTIONS(3603),
    [anon_sym_PIPE] = ACTIONS(3603),
    [anon_sym_SEMI_SEMI] = ACTIONS(3603),
    [anon_sym_PIPE_AMP] = ACTIONS(3603),
    [anon_sym_AMP_AMP] = ACTIONS(3603),
    [anon_sym_PIPE_PIPE] = ACTIONS(3603),
    [anon_sym_LT] = ACTIONS(6103),
    [anon_sym_GT] = ACTIONS(6103),
    [anon_sym_GT_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT] = ACTIONS(6103),
    [anon_sym_AMP_GT_GT] = ACTIONS(6103),
    [anon_sym_LT_AMP] = ACTIONS(6103),
    [anon_sym_GT_AMP] = ACTIONS(6103),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_LF] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3603),
  },
  [2816] = {
    [sym_concatenation] = STATE(1533),
    [sym_string] = STATE(2945),
    [sym_simple_expansion] = STATE(2945),
    [sym_string_expansion] = STATE(2945),
    [sym_expansion] = STATE(2945),
    [sym_command_substitution] = STATE(2945),
    [sym_process_substitution] = STATE(2945),
    [sym__special_characters] = ACTIONS(6814),
    [anon_sym_DQUOTE] = ACTIONS(6525),
    [anon_sym_DOLLAR] = ACTIONS(6527),
    [sym_raw_string] = ACTIONS(6816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6531),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6533),
    [anon_sym_BQUOTE] = ACTIONS(6535),
    [anon_sym_LT_LPAREN] = ACTIONS(6537),
    [anon_sym_GT_LPAREN] = ACTIONS(6537),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6816),
  },
  [2817] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__concat] = ACTIONS(6818),
    [anon_sym_esac] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [2818] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(2949),
    [anon_sym_DQUOTE] = ACTIONS(6820),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2819] = {
    [sym_string] = STATE(2951),
    [anon_sym_DQUOTE] = ACTIONS(6525),
    [anon_sym_DOLLAR] = ACTIONS(6822),
    [sym_raw_string] = ACTIONS(6824),
    [anon_sym_POUND] = ACTIONS(6822),
    [anon_sym_DASH] = ACTIONS(6822),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6826),
    [anon_sym_STAR] = ACTIONS(6822),
    [anon_sym_AT] = ACTIONS(6822),
    [anon_sym_QMARK] = ACTIONS(6822),
    [anon_sym_0] = ACTIONS(6828),
    [anon_sym__] = ACTIONS(6828),
  },
  [2820] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__concat] = ACTIONS(6818),
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [2821] = {
    [sym_subscript] = STATE(2957),
    [sym_variable_name] = ACTIONS(6830),
    [anon_sym_DOLLAR] = ACTIONS(6832),
    [anon_sym_POUND] = ACTIONS(6834),
    [anon_sym_DASH] = ACTIONS(6832),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6836),
    [anon_sym_STAR] = ACTIONS(6832),
    [anon_sym_AT] = ACTIONS(6832),
    [anon_sym_QMARK] = ACTIONS(6832),
    [anon_sym_0] = ACTIONS(6838),
    [anon_sym__] = ACTIONS(6838),
  },
  [2822] = {
    [sym_for_statement] = STATE(2958),
    [sym_while_statement] = STATE(2958),
    [sym_if_statement] = STATE(2958),
    [sym_case_statement] = STATE(2958),
    [sym_function_definition] = STATE(2958),
    [sym_subshell] = STATE(2958),
    [sym_pipeline] = STATE(2958),
    [sym_list] = STATE(2958),
    [sym_command] = STATE(2958),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2958),
    [sym_variable_assignment] = STATE(2959),
    [sym_declaration_command] = STATE(2958),
    [sym_unset_command] = STATE(2958),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2823] = {
    [sym_for_statement] = STATE(2960),
    [sym_while_statement] = STATE(2960),
    [sym_if_statement] = STATE(2960),
    [sym_case_statement] = STATE(2960),
    [sym_function_definition] = STATE(2960),
    [sym_subshell] = STATE(2960),
    [sym_pipeline] = STATE(2960),
    [sym_list] = STATE(2960),
    [sym_command] = STATE(2960),
    [sym_command_name] = STATE(174),
    [sym_bracket_command] = STATE(2960),
    [sym_variable_assignment] = STATE(2961),
    [sym_declaration_command] = STATE(2960),
    [sym_unset_command] = STATE(2960),
    [sym_subscript] = STATE(176),
    [sym_file_redirect] = STATE(177),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_string_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [aux_sym_command_repeat1] = STATE(177),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(300),
    [anon_sym_typeset] = ACTIONS(300),
    [anon_sym_export] = ACTIONS(300),
    [anon_sym_readonly] = ACTIONS(300),
    [anon_sym_local] = ACTIONS(300),
    [anon_sym_unset] = ACTIONS(302),
    [anon_sym_unsetenv] = ACTIONS(302),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(308),
  },
  [2824] = {
    [sym_for_statement] = STATE(2962),
    [sym_while_statement] = STATE(2962),
    [sym_if_statement] = STATE(2962),
    [sym_case_statement] = STATE(2962),
    [sym_function_definition] = STATE(2962),
    [sym_subshell] = STATE(2962),
    [sym_pipeline] = STATE(2962),
    [sym_list] = STATE(2962),
    [sym_command] = STATE(2962),
    [sym_command_name] = STATE(158),
    [sym_bracket_command] = STATE(2962),
    [sym_variable_assignment] = STATE(2963),
    [sym_declaration_command] = STATE(2962),
    [sym_unset_command] = STATE(2962),
    [sym_subscript] = STATE(160),
    [sym_file_redirect] = STATE(162),
    [sym_concatenation] = STATE(161),
    [sym_string] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_expansion] = STATE(151),
    [sym_command_substitution] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [aux_sym_command_repeat1] = STATE(162),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(252),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(260),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(266),
    [anon_sym_declare] = ACTIONS(268),
    [anon_sym_typeset] = ACTIONS(268),
    [anon_sym_export] = ACTIONS(268),
    [anon_sym_readonly] = ACTIONS(268),
    [anon_sym_local] = ACTIONS(268),
    [anon_sym_unset] = ACTIONS(270),
    [anon_sym_unsetenv] = ACTIONS(270),
    [anon_sym_LT] = ACTIONS(34),
    [anon_sym_GT] = ACTIONS(34),
    [anon_sym_GT_GT] = ACTIONS(36),
    [anon_sym_AMP_GT] = ACTIONS(34),
    [anon_sym_AMP_GT_GT] = ACTIONS(36),
    [anon_sym_LT_AMP] = ACTIONS(36),
    [anon_sym_GT_AMP] = ACTIONS(36),
    [sym__special_characters] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(282),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [anon_sym_LT_LPAREN] = ACTIONS(286),
    [anon_sym_GT_LPAREN] = ACTIONS(286),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(288),
  },
  [2825] = {
    [sym_concatenation] = STATE(1565),
    [sym_string] = STATE(2965),
    [sym_simple_expansion] = STATE(2965),
    [sym_string_expansion] = STATE(2965),
    [sym_expansion] = STATE(2965),
    [sym_command_substitution] = STATE(2965),
    [sym_process_substitution] = STATE(2965),
    [sym__special_characters] = ACTIONS(6840),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(6842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2504),
    [anon_sym_GT_LPAREN] = ACTIONS(2504),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6842),
  },
  [2826] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(660),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_SEMI_SEMI] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(664),
    [anon_sym_LT_AMP] = ACTIONS(664),
    [anon_sym_GT_AMP] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(664),
    [anon_sym_LT_LT_LT] = ACTIONS(664),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(664),
    [anon_sym_LF] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(664),
  },
  [2827] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(676),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_SEMI_SEMI] = ACTIONS(678),
    [anon_sym_PIPE_AMP] = ACTIONS(678),
    [anon_sym_AMP_AMP] = ACTIONS(678),
    [anon_sym_PIPE_PIPE] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_AMP_GT] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(678),
    [anon_sym_LT_AMP] = ACTIONS(678),
    [anon_sym_GT_AMP] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT_LT_DASH] = ACTIONS(678),
    [anon_sym_LT_LT_LT] = ACTIONS(678),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(678),
    [anon_sym_LF] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(678),
  },
  [2828] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(2072),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_SEMI_SEMI] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2074),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2074),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_LF] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2074),
  },
  [2829] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(2076),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_GT] = ACTIONS(2078),
    [anon_sym_GT_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT] = ACTIONS(2078),
    [anon_sym_AMP_GT_GT] = ACTIONS(2078),
    [anon_sym_LT_AMP] = ACTIONS(2078),
    [anon_sym_GT_AMP] = ACTIONS(2078),
    [anon_sym_LT_LT] = ACTIONS(2078),
    [anon_sym_LT_LT_DASH] = ACTIONS(2078),
    [anon_sym_LT_LT_LT] = ACTIONS(2078),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2830] = {
    [sym_file_redirect] = STATE(2830),
    [sym_heredoc_redirect] = STATE(2830),
    [sym_herestring_redirect] = STATE(2830),
    [aux_sym_while_statement_repeat1] = STATE(2830),
    [sym_file_descriptor] = ACTIONS(6844),
    [anon_sym_esac] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2089),
    [anon_sym_SEMI_SEMI] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6847),
    [anon_sym_GT_GT] = ACTIONS(6847),
    [anon_sym_AMP_GT] = ACTIONS(6847),
    [anon_sym_AMP_GT_GT] = ACTIONS(6847),
    [anon_sym_LT_AMP] = ACTIONS(6847),
    [anon_sym_GT_AMP] = ACTIONS(6847),
    [anon_sym_LT_LT] = ACTIONS(3707),
    [anon_sym_LT_LT_DASH] = ACTIONS(3707),
    [anon_sym_LT_LT_LT] = ACTIONS(6850),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LF] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2089),
  },
  [2831] = {
    [sym_variable_name] = ACTIONS(2145),
    [anon_sym_esac] = ACTIONS(2147),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_PIPE_AMP] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2147),
    [sym_word] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [2832] = {
    [sym_concatenation] = STATE(1005),
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_string_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [aux_sym_for_statement_repeat1] = STATE(1005),
    [anon_sym_RPAREN] = ACTIONS(6853),
    [sym__special_characters] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [anon_sym_LT_LPAREN] = ACTIONS(1117),
    [anon_sym_GT_LPAREN] = ACTIONS(1117),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(1109),
  },
  [2833] = {
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [2834] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6855),
    [sym_comment] = ACTIONS(54),
  },
  [2835] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [sym_comment] = ACTIONS(54),
  },
  [2836] = {
    [anon_sym_RBRACE] = ACTIONS(6857),
    [sym_comment] = ACTIONS(54),
  },
  [2837] = {
    [sym_concatenation] = STATE(2971),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2971),
    [anon_sym_RBRACE] = ACTIONS(6859),
    [anon_sym_EQ] = ACTIONS(6861),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6861),
    [anon_sym_COLON_QMARK] = ACTIONS(6861),
    [anon_sym_COLON_DASH] = ACTIONS(6861),
    [anon_sym_PERCENT] = ACTIONS(6861),
    [anon_sym_DASH] = ACTIONS(6861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2838] = {
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [2839] = {
    [sym_concatenation] = STATE(2974),
    [sym_string] = STATE(2973),
    [sym_simple_expansion] = STATE(2973),
    [sym_string_expansion] = STATE(2973),
    [sym_expansion] = STATE(2973),
    [sym_command_substitution] = STATE(2973),
    [sym_process_substitution] = STATE(2973),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [sym__special_characters] = ACTIONS(6865),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6867),
  },
  [2840] = {
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [2841] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6869),
  },
  [2842] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6871),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2843] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2844] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6873),
  },
  [2845] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2846] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6877),
  },
  [2847] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2848] = {
    [sym_concatenation] = STATE(2981),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2981),
    [anon_sym_RBRACE] = ACTIONS(6879),
    [anon_sym_EQ] = ACTIONS(6881),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6881),
    [anon_sym_COLON_QMARK] = ACTIONS(6881),
    [anon_sym_COLON_DASH] = ACTIONS(6881),
    [anon_sym_PERCENT] = ACTIONS(6881),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2849] = {
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [2850] = {
    [sym_concatenation] = STATE(2983),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2983),
    [anon_sym_RBRACE] = ACTIONS(6885),
    [anon_sym_EQ] = ACTIONS(6887),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6887),
    [anon_sym_COLON_QMARK] = ACTIONS(6887),
    [anon_sym_COLON_DASH] = ACTIONS(6887),
    [anon_sym_PERCENT] = ACTIONS(6887),
    [anon_sym_DASH] = ACTIONS(6887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2851] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2746),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [2852] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6891),
    [sym_comment] = ACTIONS(54),
  },
  [2853] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6893),
    [sym_comment] = ACTIONS(54),
  },
  [2854] = {
    [anon_sym_RBRACE] = ACTIONS(6893),
    [sym_comment] = ACTIONS(54),
  },
  [2855] = {
    [sym_concatenation] = STATE(2987),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2987),
    [anon_sym_RBRACE] = ACTIONS(6895),
    [anon_sym_EQ] = ACTIONS(6897),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6897),
    [anon_sym_COLON_QMARK] = ACTIONS(6897),
    [anon_sym_COLON_DASH] = ACTIONS(6897),
    [anon_sym_PERCENT] = ACTIONS(6897),
    [anon_sym_DASH] = ACTIONS(6897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2856] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [2857] = {
    [sym_concatenation] = STATE(2990),
    [sym_string] = STATE(2989),
    [sym_simple_expansion] = STATE(2989),
    [sym_string_expansion] = STATE(2989),
    [sym_expansion] = STATE(2989),
    [sym_command_substitution] = STATE(2989),
    [sym_process_substitution] = STATE(2989),
    [anon_sym_RBRACE] = ACTIONS(6893),
    [sym__special_characters] = ACTIONS(6901),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6903),
  },
  [2858] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2867),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [2859] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6905),
  },
  [2860] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6907),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2861] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2862] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6909),
  },
  [2863] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6911),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2864] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6913),
  },
  [2865] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6893),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2866] = {
    [sym_concatenation] = STATE(2997),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2997),
    [anon_sym_RBRACE] = ACTIONS(6915),
    [anon_sym_EQ] = ACTIONS(6917),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6917),
    [anon_sym_COLON_QMARK] = ACTIONS(6917),
    [anon_sym_COLON_DASH] = ACTIONS(6917),
    [anon_sym_PERCENT] = ACTIONS(6917),
    [anon_sym_DASH] = ACTIONS(6917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2867] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2891),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [2868] = {
    [sym_concatenation] = STATE(2999),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(2999),
    [anon_sym_RBRACE] = ACTIONS(6921),
    [anon_sym_EQ] = ACTIONS(6923),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6923),
    [anon_sym_COLON_QMARK] = ACTIONS(6923),
    [anon_sym_COLON_DASH] = ACTIONS(6923),
    [anon_sym_PERCENT] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2869] = {
    [sym__simple_heredoc_body] = ACTIONS(3909),
    [sym__heredoc_body_beginning] = ACTIONS(3909),
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_EQ_TILDE] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2870] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2871] = {
    [sym__simple_heredoc_body] = ACTIONS(4000),
    [sym__heredoc_body_beginning] = ACTIONS(4000),
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_EQ_TILDE] = ACTIONS(4002),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4002),
    [anon_sym_LT_LT_LT] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [2872] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6927),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2873] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6929),
    [sym_comment] = ACTIONS(54),
  },
  [2874] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(6931),
    [sym_comment] = ACTIONS(54),
  },
  [2875] = {
    [anon_sym_RBRACE] = ACTIONS(6931),
    [sym_comment] = ACTIONS(54),
  },
  [2876] = {
    [sym_concatenation] = STATE(3004),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3004),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_EQ] = ACTIONS(6935),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6935),
    [anon_sym_COLON_QMARK] = ACTIONS(6935),
    [anon_sym_COLON_DASH] = ACTIONS(6935),
    [anon_sym_PERCENT] = ACTIONS(6935),
    [anon_sym_DASH] = ACTIONS(6935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2877] = {
    [sym__simple_heredoc_body] = ACTIONS(4016),
    [sym__heredoc_body_beginning] = ACTIONS(4016),
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_EQ_TILDE] = ACTIONS(4018),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4018),
    [anon_sym_LT_LT_LT] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [2878] = {
    [sym_concatenation] = STATE(3006),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3006),
    [anon_sym_RBRACE] = ACTIONS(6939),
    [anon_sym_EQ] = ACTIONS(6941),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6941),
    [anon_sym_COLON_QMARK] = ACTIONS(6941),
    [anon_sym_COLON_DASH] = ACTIONS(6941),
    [anon_sym_PERCENT] = ACTIONS(6941),
    [anon_sym_DASH] = ACTIONS(6941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2879] = {
    [sym__simple_heredoc_body] = ACTIONS(4026),
    [sym__heredoc_body_beginning] = ACTIONS(4026),
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_EQ_TILDE] = ACTIONS(4028),
    [anon_sym_EQ_EQ] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4028),
    [anon_sym_LT_LT_LT] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [2880] = {
    [sym_concatenation] = STATE(3008),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3008),
    [anon_sym_RBRACE] = ACTIONS(6945),
    [anon_sym_EQ] = ACTIONS(6947),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(6947),
    [anon_sym_COLON_QMARK] = ACTIONS(6947),
    [anon_sym_COLON_DASH] = ACTIONS(6947),
    [anon_sym_PERCENT] = ACTIONS(6947),
    [anon_sym_DASH] = ACTIONS(6947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2881] = {
    [sym__simple_heredoc_body] = ACTIONS(4036),
    [sym__heredoc_body_beginning] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [2882] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6951),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2883] = {
    [sym__simple_heredoc_body] = ACTIONS(4042),
    [sym__heredoc_body_beginning] = ACTIONS(4042),
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [2884] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2885] = {
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2886] = {
    [aux_sym_concatenation_repeat1] = STATE(2886),
    [sym__simple_heredoc_body] = ACTIONS(1660),
    [sym__heredoc_body_beginning] = ACTIONS(1660),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(6955),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [2887] = {
    [sym__simple_heredoc_body] = ACTIONS(1709),
    [sym__heredoc_body_beginning] = ACTIONS(1709),
    [sym_file_descriptor] = ACTIONS(1709),
    [sym__concat] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT] = ACTIONS(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1711),
    [anon_sym_LT_AMP] = ACTIONS(1711),
    [anon_sym_GT_AMP] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1711),
    [anon_sym_LT_LT_DASH] = ACTIONS(1711),
    [anon_sym_LT_LT_LT] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [2888] = {
    [sym_concatenation] = STATE(3014),
    [sym_string] = STATE(3013),
    [sym_simple_expansion] = STATE(3013),
    [sym_string_expansion] = STATE(3013),
    [sym_expansion] = STATE(3013),
    [sym_command_substitution] = STATE(3013),
    [sym_process_substitution] = STATE(3013),
    [anon_sym_RBRACE] = ACTIONS(6958),
    [sym__special_characters] = ACTIONS(6960),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(6962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6962),
  },
  [2889] = {
    [sym__simple_heredoc_body] = ACTIONS(1750),
    [sym__heredoc_body_beginning] = ACTIONS(1750),
    [sym_file_descriptor] = ACTIONS(1750),
    [sym__concat] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_GT_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT] = ACTIONS(1752),
    [anon_sym_AMP_GT_GT] = ACTIONS(1752),
    [anon_sym_LT_AMP] = ACTIONS(1752),
    [anon_sym_GT_AMP] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1752),
    [anon_sym_LT_LT_DASH] = ACTIONS(1752),
    [anon_sym_LT_LT_LT] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [2890] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6964),
  },
  [2891] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6966),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2892] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(6968),
    [sym_comment] = ACTIONS(54),
  },
  [2893] = {
    [sym_concatenation] = STATE(3020),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3020),
    [anon_sym_RBRACE] = ACTIONS(6970),
    [anon_sym_EQ] = ACTIONS(6972),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6976),
    [anon_sym_COLON] = ACTIONS(6972),
    [anon_sym_COLON_QMARK] = ACTIONS(6972),
    [anon_sym_COLON_DASH] = ACTIONS(6972),
    [anon_sym_PERCENT] = ACTIONS(6972),
    [anon_sym_DASH] = ACTIONS(6972),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2894] = {
    [sym_concatenation] = STATE(3023),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3023),
    [anon_sym_RBRACE] = ACTIONS(6978),
    [anon_sym_EQ] = ACTIONS(6980),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6984),
    [anon_sym_COLON] = ACTIONS(6980),
    [anon_sym_COLON_QMARK] = ACTIONS(6980),
    [anon_sym_COLON_DASH] = ACTIONS(6980),
    [anon_sym_PERCENT] = ACTIONS(6980),
    [anon_sym_DASH] = ACTIONS(6980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2895] = {
    [sym_concatenation] = STATE(3025),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3025),
    [anon_sym_RBRACE] = ACTIONS(6958),
    [anon_sym_EQ] = ACTIONS(6986),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(6988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(6990),
    [anon_sym_COLON] = ACTIONS(6986),
    [anon_sym_COLON_QMARK] = ACTIONS(6986),
    [anon_sym_COLON_DASH] = ACTIONS(6986),
    [anon_sym_PERCENT] = ACTIONS(6986),
    [anon_sym_DASH] = ACTIONS(6986),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2896] = {
    [sym__simple_heredoc_body] = ACTIONS(1816),
    [sym__heredoc_body_beginning] = ACTIONS(1816),
    [sym_file_descriptor] = ACTIONS(1816),
    [sym__concat] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [2897] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6992),
  },
  [2898] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6994),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2899] = {
    [sym__simple_heredoc_body] = ACTIONS(1824),
    [sym__heredoc_body_beginning] = ACTIONS(1824),
    [sym_file_descriptor] = ACTIONS(1824),
    [sym__concat] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [anon_sym_LT_LT] = ACTIONS(1826),
    [anon_sym_LT_LT_DASH] = ACTIONS(1826),
    [anon_sym_LT_LT_LT] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [2900] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(6996),
  },
  [2901] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(6958),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2902] = {
    [sym__simple_heredoc_body] = ACTIONS(1962),
    [sym__heredoc_body_beginning] = ACTIONS(1962),
    [sym_file_descriptor] = ACTIONS(1962),
    [sym__concat] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [2903] = {
    [sym__simple_heredoc_body] = ACTIONS(2026),
    [sym__heredoc_body_beginning] = ACTIONS(2026),
    [sym_file_descriptor] = ACTIONS(2026),
    [sym__concat] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_GT_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT] = ACTIONS(2028),
    [anon_sym_AMP_GT_GT] = ACTIONS(2028),
    [anon_sym_LT_AMP] = ACTIONS(2028),
    [anon_sym_GT_AMP] = ACTIONS(2028),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_LT_LT_DASH] = ACTIONS(2028),
    [anon_sym_LT_LT_LT] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [2904] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6383),
    [anon_sym_DQUOTE] = ACTIONS(6385),
    [anon_sym_DOLLAR] = ACTIONS(6383),
    [sym_raw_string] = ACTIONS(6385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6385),
    [anon_sym_BQUOTE] = ACTIONS(6385),
    [anon_sym_LT_LPAREN] = ACTIONS(6385),
    [anon_sym_GT_LPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6383),
  },
  [2905] = {
    [sym__special_characters] = ACTIONS(6385),
    [anon_sym_DQUOTE] = ACTIONS(6385),
    [anon_sym_DOLLAR] = ACTIONS(6383),
    [sym_raw_string] = ACTIONS(6385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6385),
    [anon_sym_BQUOTE] = ACTIONS(6385),
    [anon_sym_LT_LPAREN] = ACTIONS(6385),
    [anon_sym_GT_LPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6385),
  },
  [2906] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6998),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2907] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(6998),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2908] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6391),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6391),
  },
  [2909] = {
    [sym__special_characters] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6393),
  },
  [2910] = {
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(7000),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2911] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_SEMI_SEMI] = ACTIONS(7000),
    [anon_sym_PIPE_AMP] = ACTIONS(314),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(356),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(356),
    [anon_sym_LT_AMP] = ACTIONS(356),
    [anon_sym_GT_AMP] = ACTIONS(356),
    [sym__special_characters] = ACTIONS(356),
    [anon_sym_DQUOTE] = ACTIONS(356),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(356),
    [anon_sym_LT_LPAREN] = ACTIONS(356),
    [anon_sym_GT_LPAREN] = ACTIONS(356),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(356),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(316),
  },
  [2912] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5534),
    [anon_sym_LT_LT_LT] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [2913] = {
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5538),
    [anon_sym_LT_LT_LT] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [2914] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2915] = {
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_RPAREN] = ACTIONS(4876),
    [anon_sym_PIPE_AMP] = ACTIONS(4876),
    [anon_sym_AMP_AMP] = ACTIONS(4876),
    [anon_sym_PIPE_PIPE] = ACTIONS(4876),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4876),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4876),
    [anon_sym_LT_AMP] = ACTIONS(4876),
    [anon_sym_GT_AMP] = ACTIONS(4876),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4876),
    [anon_sym_LT_LT_LT] = ACTIONS(4876),
    [anon_sym_BQUOTE] = ACTIONS(4876),
    [sym_comment] = ACTIONS(54),
  },
  [2916] = {
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_RPAREN] = ACTIONS(4880),
    [anon_sym_PIPE_AMP] = ACTIONS(4880),
    [anon_sym_AMP_AMP] = ACTIONS(4880),
    [anon_sym_PIPE_PIPE] = ACTIONS(4880),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4880),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4880),
    [anon_sym_LT_AMP] = ACTIONS(4880),
    [anon_sym_GT_AMP] = ACTIONS(4880),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4880),
    [anon_sym_LT_LT_LT] = ACTIONS(4880),
    [anon_sym_BQUOTE] = ACTIONS(4880),
    [sym_comment] = ACTIONS(54),
  },
  [2917] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4884),
    [anon_sym_LT_LT_LT] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(54),
  },
  [2918] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4888),
    [anon_sym_LT_LT_LT] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(54),
  },
  [2919] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7002),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2920] = {
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(54),
  },
  [2921] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7004),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2922] = {
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4900),
    [anon_sym_PIPE_AMP] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_PIPE_PIPE] = ACTIONS(4900),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4900),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4900),
    [anon_sym_LT_AMP] = ACTIONS(4900),
    [anon_sym_GT_AMP] = ACTIONS(4900),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4900),
    [anon_sym_LT_LT_LT] = ACTIONS(4900),
    [anon_sym_BQUOTE] = ACTIONS(4900),
    [sym_comment] = ACTIONS(54),
  },
  [2923] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7006),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2924] = {
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4906),
    [anon_sym_PIPE_AMP] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4906),
    [anon_sym_LT_AMP] = ACTIONS(4906),
    [anon_sym_GT_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4906),
    [anon_sym_LT_LT_LT] = ACTIONS(4906),
    [anon_sym_BQUOTE] = ACTIONS(4906),
    [sym_comment] = ACTIONS(54),
  },
  [2925] = {
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [sym_comment] = ACTIONS(54),
  },
  [2926] = {
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [sym_variable_name] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [sym__special_characters] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [sym_raw_string] = ACTIONS(2746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2746),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [anon_sym_LT_LPAREN] = ACTIONS(2746),
    [anon_sym_GT_LPAREN] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [2927] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7008),
    [sym_comment] = ACTIONS(54),
  },
  [2928] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [sym_comment] = ACTIONS(54),
  },
  [2929] = {
    [anon_sym_RBRACE] = ACTIONS(7010),
    [sym_comment] = ACTIONS(54),
  },
  [2930] = {
    [sym_concatenation] = STATE(3037),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3037),
    [anon_sym_RBRACE] = ACTIONS(7012),
    [anon_sym_EQ] = ACTIONS(7014),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7014),
    [anon_sym_COLON_QMARK] = ACTIONS(7014),
    [anon_sym_COLON_DASH] = ACTIONS(7014),
    [anon_sym_PERCENT] = ACTIONS(7014),
    [anon_sym_DASH] = ACTIONS(7014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2931] = {
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [sym_variable_name] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [sym__special_characters] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_DOLLAR] = ACTIONS(2824),
    [sym_raw_string] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2824),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_LT_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_LPAREN] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [2932] = {
    [sym_concatenation] = STATE(3040),
    [sym_string] = STATE(3039),
    [sym_simple_expansion] = STATE(3039),
    [sym_string_expansion] = STATE(3039),
    [sym_expansion] = STATE(3039),
    [sym_command_substitution] = STATE(3039),
    [sym_process_substitution] = STATE(3039),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [sym__special_characters] = ACTIONS(7018),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(7020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(7020),
  },
  [2933] = {
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [sym_variable_name] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [sym__special_characters] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [sym_raw_string] = ACTIONS(2867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2867),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [anon_sym_LT_LPAREN] = ACTIONS(2867),
    [anon_sym_GT_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [2934] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7022),
  },
  [2935] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7024),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2936] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2937] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7026),
  },
  [2938] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7028),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2939] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7030),
  },
  [2940] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2941] = {
    [sym_concatenation] = STATE(3047),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3047),
    [anon_sym_RBRACE] = ACTIONS(7032),
    [anon_sym_EQ] = ACTIONS(7034),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7034),
    [anon_sym_COLON_QMARK] = ACTIONS(7034),
    [anon_sym_COLON_DASH] = ACTIONS(7034),
    [anon_sym_PERCENT] = ACTIONS(7034),
    [anon_sym_DASH] = ACTIONS(7034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2942] = {
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [sym_variable_name] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [sym__special_characters] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2891),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [anon_sym_LT_LPAREN] = ACTIONS(2891),
    [anon_sym_GT_LPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [2943] = {
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [anon_sym_RBRACE] = ACTIONS(7038),
    [anon_sym_EQ] = ACTIONS(7040),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7040),
    [anon_sym_COLON_QMARK] = ACTIONS(7040),
    [anon_sym_COLON_DASH] = ACTIONS(7040),
    [anon_sym_PERCENT] = ACTIONS(7040),
    [anon_sym_DASH] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2944] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__concat] = ACTIONS(6818),
    [anon_sym_esac] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [2945] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__concat] = ACTIONS(6818),
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [2946] = {
    [sym_string] = STATE(3050),
    [sym_simple_expansion] = STATE(3050),
    [sym_string_expansion] = STATE(3050),
    [sym_expansion] = STATE(3050),
    [sym_command_substitution] = STATE(3050),
    [sym_process_substitution] = STATE(3050),
    [sym__special_characters] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(6525),
    [anon_sym_DOLLAR] = ACTIONS(6527),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6531),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6533),
    [anon_sym_BQUOTE] = ACTIONS(6535),
    [anon_sym_LT_LPAREN] = ACTIONS(6537),
    [anon_sym_GT_LPAREN] = ACTIONS(6537),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(7044),
  },
  [2947] = {
    [aux_sym_concatenation_repeat1] = STATE(3051),
    [sym__concat] = ACTIONS(6818),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2948] = {
    [sym__concat] = ACTIONS(696),
    [anon_sym_esac] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_SEMI_SEMI] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(698),
    [anon_sym_LF] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(698),
  },
  [2949] = {
    [sym_simple_expansion] = STATE(124),
    [sym_expansion] = STATE(124),
    [sym_command_substitution] = STATE(124),
    [aux_sym_string_repeat1] = STATE(399),
    [anon_sym_DQUOTE] = ACTIONS(7046),
    [anon_sym_DOLLAR] = ACTIONS(218),
    [sym__string_content] = ACTIONS(220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(224),
    [anon_sym_BQUOTE] = ACTIONS(226),
    [sym_comment] = ACTIONS(166),
  },
  [2950] = {
    [sym__concat] = ACTIONS(726),
    [anon_sym_esac] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_SEMI_SEMI] = ACTIONS(728),
    [anon_sym_PIPE_AMP] = ACTIONS(728),
    [anon_sym_AMP_AMP] = ACTIONS(728),
    [anon_sym_PIPE_PIPE] = ACTIONS(728),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_LF] = ACTIONS(726),
    [anon_sym_AMP] = ACTIONS(728),
  },
  [2951] = {
    [sym__concat] = ACTIONS(730),
    [anon_sym_esac] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_SEMI_SEMI] = ACTIONS(732),
    [anon_sym_PIPE_AMP] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(732),
    [anon_sym_LF] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(732),
  },
  [2952] = {
    [sym__concat] = ACTIONS(734),
    [anon_sym_esac] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(736),
    [anon_sym_PIPE_AMP] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(736),
    [anon_sym_LF] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(736),
  },
  [2953] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(7048),
    [sym_comment] = ACTIONS(54),
  },
  [2954] = {
    [sym_concatenation] = STATE(3056),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3056),
    [anon_sym_RBRACE] = ACTIONS(7050),
    [anon_sym_EQ] = ACTIONS(7052),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7056),
    [anon_sym_COLON] = ACTIONS(7052),
    [anon_sym_COLON_QMARK] = ACTIONS(7052),
    [anon_sym_COLON_DASH] = ACTIONS(7052),
    [anon_sym_PERCENT] = ACTIONS(7052),
    [anon_sym_DASH] = ACTIONS(7052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2955] = {
    [sym_subscript] = STATE(3060),
    [sym_variable_name] = ACTIONS(7058),
    [anon_sym_DOLLAR] = ACTIONS(7060),
    [anon_sym_DASH] = ACTIONS(7060),
    [sym_comment] = ACTIONS(54),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7062),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_AT] = ACTIONS(7060),
    [anon_sym_QMARK] = ACTIONS(7060),
    [anon_sym_0] = ACTIONS(7064),
    [anon_sym__] = ACTIONS(7064),
  },
  [2956] = {
    [sym_concatenation] = STATE(3063),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3063),
    [anon_sym_RBRACE] = ACTIONS(7066),
    [anon_sym_EQ] = ACTIONS(7068),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7072),
    [anon_sym_COLON] = ACTIONS(7068),
    [anon_sym_COLON_QMARK] = ACTIONS(7068),
    [anon_sym_COLON_DASH] = ACTIONS(7068),
    [anon_sym_PERCENT] = ACTIONS(7068),
    [anon_sym_DASH] = ACTIONS(7068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2957] = {
    [sym_concatenation] = STATE(3066),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3066),
    [anon_sym_RBRACE] = ACTIONS(7074),
    [anon_sym_EQ] = ACTIONS(7076),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7080),
    [anon_sym_COLON] = ACTIONS(7076),
    [anon_sym_COLON_QMARK] = ACTIONS(7076),
    [anon_sym_COLON_DASH] = ACTIONS(7076),
    [anon_sym_PERCENT] = ACTIONS(7076),
    [anon_sym_DASH] = ACTIONS(7076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2958] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2959] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2960] = {
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [sym_comment] = ACTIONS(54),
  },
  [2961] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2962] = {
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(7084),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [sym_comment] = ACTIONS(54),
  },
  [2963] = {
    [sym_file_descriptor] = ACTIONS(354),
    [sym_variable_name] = ACTIONS(354),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(7084),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(874),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(356),
    [anon_sym_GT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(354),
    [anon_sym_AMP_GT] = ACTIONS(356),
    [anon_sym_AMP_GT_GT] = ACTIONS(354),
    [anon_sym_LT_AMP] = ACTIONS(354),
    [anon_sym_GT_AMP] = ACTIONS(354),
    [sym__special_characters] = ACTIONS(354),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(356),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(354),
    [anon_sym_BQUOTE] = ACTIONS(354),
    [anon_sym_LT_LPAREN] = ACTIONS(354),
    [anon_sym_GT_LPAREN] = ACTIONS(354),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(354),
  },
  [2964] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(1079),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_SEMI_SEMI] = ACTIONS(1081),
    [anon_sym_PIPE_AMP] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT] = ACTIONS(1081),
    [anon_sym_AMP_GT_GT] = ACTIONS(1081),
    [anon_sym_LT_AMP] = ACTIONS(1081),
    [anon_sym_GT_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LT_LT_DASH] = ACTIONS(1081),
    [anon_sym_LT_LT_LT] = ACTIONS(1081),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
  },
  [2965] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym_file_descriptor] = ACTIONS(1083),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT] = ACTIONS(1085),
    [anon_sym_AMP_GT_GT] = ACTIONS(1085),
    [anon_sym_LT_AMP] = ACTIONS(1085),
    [anon_sym_GT_AMP] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(1085),
    [anon_sym_LT_LT_DASH] = ACTIONS(1085),
    [anon_sym_LT_LT_LT] = ACTIONS(1085),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [2966] = {
    [aux_sym_concatenation_repeat1] = STATE(3069),
    [sym_file_descriptor] = ACTIONS(692),
    [sym__concat] = ACTIONS(3679),
    [anon_sym_esac] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_SEMI_SEMI] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_AMP_GT] = ACTIONS(694),
    [anon_sym_AMP_GT_GT] = ACTIONS(694),
    [anon_sym_LT_AMP] = ACTIONS(694),
    [anon_sym_GT_AMP] = ACTIONS(694),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_LT_LT_DASH] = ACTIONS(694),
    [anon_sym_LT_LT_LT] = ACTIONS(694),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(694),
  },
  [2967] = {
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_esac] = ACTIONS(3375),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_SEMI_SEMI] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3375),
    [anon_sym_PIPE_PIPE] = ACTIONS(3375),
    [sym__special_characters] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_DOLLAR] = ACTIONS(3375),
    [sym_raw_string] = ACTIONS(3375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3375),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_LT_LPAREN] = ACTIONS(3375),
    [anon_sym_GT_LPAREN] = ACTIONS(3375),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3375),
    [sym_word] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3375),
  },
  [2968] = {
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2969] = {
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2970] = {
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [2971] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2972] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7088),
    [sym_comment] = ACTIONS(54),
  },
  [2973] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7090),
    [sym_comment] = ACTIONS(54),
  },
  [2974] = {
    [anon_sym_RBRACE] = ACTIONS(7090),
    [sym_comment] = ACTIONS(54),
  },
  [2975] = {
    [sym_concatenation] = STATE(3074),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3074),
    [anon_sym_RBRACE] = ACTIONS(7092),
    [anon_sym_EQ] = ACTIONS(7094),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7096),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7094),
    [anon_sym_COLON_QMARK] = ACTIONS(7094),
    [anon_sym_COLON_DASH] = ACTIONS(7094),
    [anon_sym_PERCENT] = ACTIONS(7094),
    [anon_sym_DASH] = ACTIONS(7094),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2976] = {
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [2977] = {
    [sym_concatenation] = STATE(3076),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3076),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_EQ] = ACTIONS(7100),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7100),
    [anon_sym_COLON_QMARK] = ACTIONS(7100),
    [anon_sym_COLON_DASH] = ACTIONS(7100),
    [anon_sym_PERCENT] = ACTIONS(7100),
    [anon_sym_DASH] = ACTIONS(7100),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2978] = {
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [2979] = {
    [sym_concatenation] = STATE(3078),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3078),
    [anon_sym_RBRACE] = ACTIONS(7104),
    [anon_sym_EQ] = ACTIONS(7106),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7106),
    [anon_sym_COLON_QMARK] = ACTIONS(7106),
    [anon_sym_COLON_DASH] = ACTIONS(7106),
    [anon_sym_PERCENT] = ACTIONS(7106),
    [anon_sym_DASH] = ACTIONS(7106),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2980] = {
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [2981] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7110),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2982] = {
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [2983] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2984] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3911),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [2985] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2986] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4002),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [2987] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7114),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2988] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7116),
    [sym_comment] = ACTIONS(54),
  },
  [2989] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7118),
    [sym_comment] = ACTIONS(54),
  },
  [2990] = {
    [anon_sym_RBRACE] = ACTIONS(7118),
    [sym_comment] = ACTIONS(54),
  },
  [2991] = {
    [sym_concatenation] = STATE(3085),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3085),
    [anon_sym_RBRACE] = ACTIONS(7120),
    [anon_sym_EQ] = ACTIONS(7122),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7122),
    [anon_sym_COLON_QMARK] = ACTIONS(7122),
    [anon_sym_COLON_DASH] = ACTIONS(7122),
    [anon_sym_PERCENT] = ACTIONS(7122),
    [anon_sym_DASH] = ACTIONS(7122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2992] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4018),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [2993] = {
    [sym_concatenation] = STATE(3087),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3087),
    [anon_sym_RBRACE] = ACTIONS(7126),
    [anon_sym_EQ] = ACTIONS(7128),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7128),
    [anon_sym_COLON_QMARK] = ACTIONS(7128),
    [anon_sym_COLON_DASH] = ACTIONS(7128),
    [anon_sym_PERCENT] = ACTIONS(7128),
    [anon_sym_DASH] = ACTIONS(7128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2994] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4028),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [2995] = {
    [sym_concatenation] = STATE(3089),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3089),
    [anon_sym_RBRACE] = ACTIONS(7132),
    [anon_sym_EQ] = ACTIONS(7134),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7134),
    [anon_sym_COLON_QMARK] = ACTIONS(7134),
    [anon_sym_COLON_DASH] = ACTIONS(7134),
    [anon_sym_PERCENT] = ACTIONS(7134),
    [anon_sym_DASH] = ACTIONS(7134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2996] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [2997] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7138),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [2998] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [2999] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7140),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3000] = {
    [sym__simple_heredoc_body] = ACTIONS(4876),
    [sym__heredoc_body_beginning] = ACTIONS(4876),
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_EQ_TILDE] = ACTIONS(4878),
    [anon_sym_EQ_EQ] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4878),
    [anon_sym_LT_LT_LT] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3001] = {
    [sym__simple_heredoc_body] = ACTIONS(4880),
    [sym__heredoc_body_beginning] = ACTIONS(4880),
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_EQ_TILDE] = ACTIONS(4882),
    [anon_sym_EQ_EQ] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4882),
    [anon_sym_LT_LT_LT] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3002] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3003] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3004] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3005] = {
    [sym__simple_heredoc_body] = ACTIONS(4894),
    [sym__heredoc_body_beginning] = ACTIONS(4894),
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3006] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7144),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3007] = {
    [sym__simple_heredoc_body] = ACTIONS(4900),
    [sym__heredoc_body_beginning] = ACTIONS(4900),
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3008] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7146),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3009] = {
    [sym__simple_heredoc_body] = ACTIONS(4906),
    [sym__heredoc_body_beginning] = ACTIONS(4906),
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3010] = {
    [sym__simple_heredoc_body] = ACTIONS(4910),
    [sym__heredoc_body_beginning] = ACTIONS(4910),
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_EQ_TILDE] = ACTIONS(4912),
    [anon_sym_EQ_EQ] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3011] = {
    [sym__simple_heredoc_body] = ACTIONS(2744),
    [sym__heredoc_body_beginning] = ACTIONS(2744),
    [sym_file_descriptor] = ACTIONS(2744),
    [sym__concat] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT] = ACTIONS(2746),
    [anon_sym_AMP_GT_GT] = ACTIONS(2746),
    [anon_sym_LT_AMP] = ACTIONS(2746),
    [anon_sym_GT_AMP] = ACTIONS(2746),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_DASH] = ACTIONS(2746),
    [anon_sym_LT_LT_LT] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [3012] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [sym_comment] = ACTIONS(54),
  },
  [3013] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [sym_comment] = ACTIONS(54),
  },
  [3014] = {
    [anon_sym_RBRACE] = ACTIONS(7150),
    [sym_comment] = ACTIONS(54),
  },
  [3015] = {
    [sym_concatenation] = STATE(3098),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3098),
    [anon_sym_RBRACE] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7154),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7154),
    [anon_sym_COLON_QMARK] = ACTIONS(7154),
    [anon_sym_COLON_DASH] = ACTIONS(7154),
    [anon_sym_PERCENT] = ACTIONS(7154),
    [anon_sym_DASH] = ACTIONS(7154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3016] = {
    [sym__simple_heredoc_body] = ACTIONS(2822),
    [sym__heredoc_body_beginning] = ACTIONS(2822),
    [sym_file_descriptor] = ACTIONS(2822),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT] = ACTIONS(2824),
    [anon_sym_AMP_GT_GT] = ACTIONS(2824),
    [anon_sym_LT_AMP] = ACTIONS(2824),
    [anon_sym_GT_AMP] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT_LT_DASH] = ACTIONS(2824),
    [anon_sym_LT_LT_LT] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [3017] = {
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3100),
    [sym_simple_expansion] = STATE(3100),
    [sym_string_expansion] = STATE(3100),
    [sym_expansion] = STATE(3100),
    [sym_command_substitution] = STATE(3100),
    [sym_process_substitution] = STATE(3100),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [sym__special_characters] = ACTIONS(7158),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(7160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(7160),
  },
  [3018] = {
    [sym__simple_heredoc_body] = ACTIONS(2865),
    [sym__heredoc_body_beginning] = ACTIONS(2865),
    [sym_file_descriptor] = ACTIONS(2865),
    [sym__concat] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT] = ACTIONS(2867),
    [anon_sym_AMP_GT_GT] = ACTIONS(2867),
    [anon_sym_LT_AMP] = ACTIONS(2867),
    [anon_sym_GT_AMP] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT_LT_DASH] = ACTIONS(2867),
    [anon_sym_LT_LT_LT] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [3019] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7162),
  },
  [3020] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3021] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [3022] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7166),
  },
  [3023] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7168),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3024] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7170),
  },
  [3025] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3026] = {
    [sym_concatenation] = STATE(3108),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3108),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_EQ] = ACTIONS(7174),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7174),
    [anon_sym_COLON_QMARK] = ACTIONS(7174),
    [anon_sym_COLON_DASH] = ACTIONS(7174),
    [anon_sym_PERCENT] = ACTIONS(7174),
    [anon_sym_DASH] = ACTIONS(7174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3027] = {
    [sym__simple_heredoc_body] = ACTIONS(2889),
    [sym__heredoc_body_beginning] = ACTIONS(2889),
    [sym_file_descriptor] = ACTIONS(2889),
    [sym__concat] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT] = ACTIONS(2891),
    [anon_sym_AMP_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_AMP] = ACTIONS(2891),
    [anon_sym_GT_AMP] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_LT_LT_DASH] = ACTIONS(2891),
    [anon_sym_LT_LT_LT] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [3028] = {
    [sym_concatenation] = STATE(3110),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3110),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_EQ] = ACTIONS(7180),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7180),
    [anon_sym_COLON_QMARK] = ACTIONS(7180),
    [anon_sym_COLON_DASH] = ACTIONS(7180),
    [anon_sym_PERCENT] = ACTIONS(7180),
    [anon_sym_DASH] = ACTIONS(7180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3029] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6719),
    [anon_sym_DQUOTE] = ACTIONS(6721),
    [anon_sym_DOLLAR] = ACTIONS(6719),
    [sym_raw_string] = ACTIONS(6721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6721),
    [anon_sym_BQUOTE] = ACTIONS(6721),
    [anon_sym_LT_LPAREN] = ACTIONS(6721),
    [anon_sym_GT_LPAREN] = ACTIONS(6721),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6719),
  },
  [3030] = {
    [sym_file_descriptor] = ACTIONS(950),
    [sym_variable_name] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(952),
    [anon_sym_typeset] = ACTIONS(952),
    [anon_sym_export] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_local] = ACTIONS(952),
    [anon_sym_unset] = ACTIONS(952),
    [anon_sym_unsetenv] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(950),
    [anon_sym_LT_AMP] = ACTIONS(950),
    [anon_sym_GT_AMP] = ACTIONS(950),
    [sym__special_characters] = ACTIONS(6725),
    [anon_sym_DQUOTE] = ACTIONS(6727),
    [anon_sym_DOLLAR] = ACTIONS(6725),
    [sym_raw_string] = ACTIONS(6727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6727),
    [anon_sym_BQUOTE] = ACTIONS(6727),
    [anon_sym_LT_LPAREN] = ACTIONS(6727),
    [anon_sym_GT_LPAREN] = ACTIONS(6727),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(6725),
  },
  [3031] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_PIPE_AMP] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5532),
    [anon_sym_LT_AMP] = ACTIONS(5532),
    [anon_sym_GT_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5532),
    [anon_sym_LT_LT_LT] = ACTIONS(5532),
    [anon_sym_BQUOTE] = ACTIONS(5532),
    [sym_comment] = ACTIONS(54),
  },
  [3032] = {
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5536),
    [anon_sym_PIPE_AMP] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE] = ACTIONS(5536),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5536),
    [anon_sym_LT_AMP] = ACTIONS(5536),
    [anon_sym_GT_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5536),
    [anon_sym_LT_LT_LT] = ACTIONS(5536),
    [anon_sym_BQUOTE] = ACTIONS(5536),
    [sym_comment] = ACTIONS(54),
  },
  [3033] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5540),
    [anon_sym_LT_LT_LT] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(54),
  },
  [3034] = {
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [sym__special_characters] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3911),
    [sym_raw_string] = ACTIONS(3911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3911),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LT_LPAREN] = ACTIONS(3911),
    [anon_sym_GT_LPAREN] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3911),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [3035] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [3036] = {
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [sym_variable_name] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [sym__special_characters] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(4002),
    [sym_raw_string] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4002),
    [anon_sym_BQUOTE] = ACTIONS(4002),
    [anon_sym_LT_LPAREN] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [3037] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7184),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3038] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7186),
    [sym_comment] = ACTIONS(54),
  },
  [3039] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7188),
    [sym_comment] = ACTIONS(54),
  },
  [3040] = {
    [anon_sym_RBRACE] = ACTIONS(7188),
    [sym_comment] = ACTIONS(54),
  },
  [3041] = {
    [sym_concatenation] = STATE(3115),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3115),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7192),
    [anon_sym_COLON_QMARK] = ACTIONS(7192),
    [anon_sym_COLON_DASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3042] = {
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [sym_variable_name] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [sym__special_characters] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [sym_raw_string] = ACTIONS(4018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4018),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_LT_LPAREN] = ACTIONS(4018),
    [anon_sym_GT_LPAREN] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [3043] = {
    [sym_concatenation] = STATE(3117),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3117),
    [anon_sym_RBRACE] = ACTIONS(7196),
    [anon_sym_EQ] = ACTIONS(7198),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7198),
    [anon_sym_COLON_QMARK] = ACTIONS(7198),
    [anon_sym_COLON_DASH] = ACTIONS(7198),
    [anon_sym_PERCENT] = ACTIONS(7198),
    [anon_sym_DASH] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3044] = {
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [sym_variable_name] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [sym__special_characters] = ACTIONS(4028),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(4028),
    [sym_raw_string] = ACTIONS(4028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_LT_LPAREN] = ACTIONS(4028),
    [anon_sym_GT_LPAREN] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [3045] = {
    [sym_concatenation] = STATE(3119),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3119),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7204),
    [anon_sym_COLON_QMARK] = ACTIONS(7204),
    [anon_sym_COLON_DASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3046] = {
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [sym__special_characters] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [3047] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3048] = {
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [sym_variable_name] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [3049] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7210),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3050] = {
    [sym__concat] = ACTIONS(1660),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [3051] = {
    [aux_sym_concatenation_repeat1] = STATE(3051),
    [sym__concat] = ACTIONS(7212),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [3052] = {
    [sym__concat] = ACTIONS(1709),
    [anon_sym_esac] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_SEMI_SEMI] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LF] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1711),
  },
  [3053] = {
    [sym_concatenation] = STATE(3125),
    [sym_string] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_process_substitution] = STATE(3124),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [sym__special_characters] = ACTIONS(7217),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(7219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(7219),
  },
  [3054] = {
    [sym__concat] = ACTIONS(1750),
    [anon_sym_esac] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_SEMI_SEMI] = ACTIONS(1752),
    [anon_sym_PIPE_AMP] = ACTIONS(1752),
    [anon_sym_AMP_AMP] = ACTIONS(1752),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1752),
  },
  [3055] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7221),
  },
  [3056] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7223),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3057] = {
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(7225),
    [sym_comment] = ACTIONS(54),
  },
  [3058] = {
    [sym_concatenation] = STATE(3131),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3131),
    [anon_sym_RBRACE] = ACTIONS(7227),
    [anon_sym_EQ] = ACTIONS(7229),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7233),
    [anon_sym_COLON] = ACTIONS(7229),
    [anon_sym_COLON_QMARK] = ACTIONS(7229),
    [anon_sym_COLON_DASH] = ACTIONS(7229),
    [anon_sym_PERCENT] = ACTIONS(7229),
    [anon_sym_DASH] = ACTIONS(7229),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3059] = {
    [sym_concatenation] = STATE(3134),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3134),
    [anon_sym_RBRACE] = ACTIONS(7235),
    [anon_sym_EQ] = ACTIONS(7237),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7241),
    [anon_sym_COLON] = ACTIONS(7237),
    [anon_sym_COLON_QMARK] = ACTIONS(7237),
    [anon_sym_COLON_DASH] = ACTIONS(7237),
    [anon_sym_PERCENT] = ACTIONS(7237),
    [anon_sym_DASH] = ACTIONS(7237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3060] = {
    [sym_concatenation] = STATE(3136),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3136),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [anon_sym_EQ] = ACTIONS(7243),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [aux_sym_SLASH] = ACTIONS(7247),
    [anon_sym_COLON] = ACTIONS(7243),
    [anon_sym_COLON_QMARK] = ACTIONS(7243),
    [anon_sym_COLON_DASH] = ACTIONS(7243),
    [anon_sym_PERCENT] = ACTIONS(7243),
    [anon_sym_DASH] = ACTIONS(7243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3061] = {
    [sym__concat] = ACTIONS(1816),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [3062] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7249),
  },
  [3063] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7251),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3064] = {
    [sym__concat] = ACTIONS(1824),
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [3065] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7253),
  },
  [3066] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3067] = {
    [sym__concat] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LF] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
  },
  [3068] = {
    [sym__concat] = ACTIONS(2026),
    [anon_sym_esac] = ACTIONS(2028),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_SEMI_SEMI] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(2028),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2028),
  },
  [3069] = {
    [aux_sym_concatenation_repeat1] = STATE(3069),
    [sym_file_descriptor] = ACTIONS(1660),
    [sym__concat] = ACTIONS(5391),
    [anon_sym_esac] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1662),
    [anon_sym_PIPE_AMP] = ACTIONS(1662),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT] = ACTIONS(1662),
    [anon_sym_AMP_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_AMP] = ACTIONS(1662),
    [anon_sym_GT_AMP] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_LT_LT_DASH] = ACTIONS(1662),
    [anon_sym_LT_LT_LT] = ACTIONS(1662),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LF] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1662),
  },
  [3070] = {
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3071] = {
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3072] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3073] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3074] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7255),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3075] = {
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3076] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7257),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3077] = {
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3078] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7259),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3079] = {
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3080] = {
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3081] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3082] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4882),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3083] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3084] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3085] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7261),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3086] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4896),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3087] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7263),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3088] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4902),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3089] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7265),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3090] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4908),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3091] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4912),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3092] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_EQ_TILDE] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5534),
    [anon_sym_LT_LT_LT] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3093] = {
    [sym__simple_heredoc_body] = ACTIONS(5536),
    [sym__heredoc_body_beginning] = ACTIONS(5536),
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_EQ_TILDE] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5538),
    [anon_sym_LT_LT_LT] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3094] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3095] = {
    [sym__simple_heredoc_body] = ACTIONS(3909),
    [sym__heredoc_body_beginning] = ACTIONS(3909),
    [sym_file_descriptor] = ACTIONS(3909),
    [sym__concat] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT] = ACTIONS(3911),
    [anon_sym_AMP_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_AMP] = ACTIONS(3911),
    [anon_sym_GT_AMP] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_LT_LT_DASH] = ACTIONS(3911),
    [anon_sym_LT_LT_LT] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [3096] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [3097] = {
    [sym__simple_heredoc_body] = ACTIONS(4000),
    [sym__heredoc_body_beginning] = ACTIONS(4000),
    [sym_file_descriptor] = ACTIONS(4000),
    [sym__concat] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT] = ACTIONS(4002),
    [anon_sym_AMP_GT_GT] = ACTIONS(4002),
    [anon_sym_LT_AMP] = ACTIONS(4002),
    [anon_sym_GT_AMP] = ACTIONS(4002),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_LT_LT_DASH] = ACTIONS(4002),
    [anon_sym_LT_LT_LT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [3098] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7267),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3099] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7269),
    [sym_comment] = ACTIONS(54),
  },
  [3100] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7271),
    [sym_comment] = ACTIONS(54),
  },
  [3101] = {
    [anon_sym_RBRACE] = ACTIONS(7271),
    [sym_comment] = ACTIONS(54),
  },
  [3102] = {
    [sym_concatenation] = STATE(3150),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3150),
    [anon_sym_RBRACE] = ACTIONS(7273),
    [anon_sym_EQ] = ACTIONS(7275),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7275),
    [anon_sym_COLON_QMARK] = ACTIONS(7275),
    [anon_sym_COLON_DASH] = ACTIONS(7275),
    [anon_sym_PERCENT] = ACTIONS(7275),
    [anon_sym_DASH] = ACTIONS(7275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3103] = {
    [sym__simple_heredoc_body] = ACTIONS(4016),
    [sym__heredoc_body_beginning] = ACTIONS(4016),
    [sym_file_descriptor] = ACTIONS(4016),
    [sym__concat] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT] = ACTIONS(4018),
    [anon_sym_AMP_GT_GT] = ACTIONS(4018),
    [anon_sym_LT_AMP] = ACTIONS(4018),
    [anon_sym_GT_AMP] = ACTIONS(4018),
    [anon_sym_LT_LT] = ACTIONS(4018),
    [anon_sym_LT_LT_DASH] = ACTIONS(4018),
    [anon_sym_LT_LT_LT] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [3104] = {
    [sym_concatenation] = STATE(3152),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3152),
    [anon_sym_RBRACE] = ACTIONS(7279),
    [anon_sym_EQ] = ACTIONS(7281),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7281),
    [anon_sym_COLON_QMARK] = ACTIONS(7281),
    [anon_sym_COLON_DASH] = ACTIONS(7281),
    [anon_sym_PERCENT] = ACTIONS(7281),
    [anon_sym_DASH] = ACTIONS(7281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3105] = {
    [sym__simple_heredoc_body] = ACTIONS(4026),
    [sym__heredoc_body_beginning] = ACTIONS(4026),
    [sym_file_descriptor] = ACTIONS(4026),
    [sym__concat] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4028),
    [anon_sym_GT] = ACTIONS(4028),
    [anon_sym_GT_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT] = ACTIONS(4028),
    [anon_sym_AMP_GT_GT] = ACTIONS(4028),
    [anon_sym_LT_AMP] = ACTIONS(4028),
    [anon_sym_GT_AMP] = ACTIONS(4028),
    [anon_sym_LT_LT] = ACTIONS(4028),
    [anon_sym_LT_LT_DASH] = ACTIONS(4028),
    [anon_sym_LT_LT_LT] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [3106] = {
    [sym_concatenation] = STATE(3154),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3154),
    [anon_sym_RBRACE] = ACTIONS(7285),
    [anon_sym_EQ] = ACTIONS(7287),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7287),
    [anon_sym_COLON_QMARK] = ACTIONS(7287),
    [anon_sym_COLON_DASH] = ACTIONS(7287),
    [anon_sym_PERCENT] = ACTIONS(7287),
    [anon_sym_DASH] = ACTIONS(7287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3107] = {
    [sym__simple_heredoc_body] = ACTIONS(4036),
    [sym__heredoc_body_beginning] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [3108] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7291),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3109] = {
    [sym__simple_heredoc_body] = ACTIONS(4042),
    [sym__heredoc_body_beginning] = ACTIONS(4042),
    [sym_file_descriptor] = ACTIONS(4042),
    [sym__concat] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [3110] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7293),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3111] = {
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [sym_variable_name] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [sym__special_characters] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4878),
    [anon_sym_DOLLAR] = ACTIONS(4878),
    [sym_raw_string] = ACTIONS(4878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [anon_sym_BQUOTE] = ACTIONS(4878),
    [anon_sym_LT_LPAREN] = ACTIONS(4878),
    [anon_sym_GT_LPAREN] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3112] = {
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [sym_variable_name] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [sym__special_characters] = ACTIONS(4882),
    [anon_sym_DQUOTE] = ACTIONS(4882),
    [anon_sym_DOLLAR] = ACTIONS(4882),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4882),
    [anon_sym_BQUOTE] = ACTIONS(4882),
    [anon_sym_LT_LPAREN] = ACTIONS(4882),
    [anon_sym_GT_LPAREN] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4882),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3113] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3114] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3115] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7295),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3116] = {
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [sym_variable_name] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4896),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4896),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3117] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7297),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3118] = {
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [sym_variable_name] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4902),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3119] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7299),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3120] = {
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [sym_variable_name] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4908),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3121] = {
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [sym_variable_name] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [sym__special_characters] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4912),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_LT_LPAREN] = ACTIONS(4912),
    [anon_sym_GT_LPAREN] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3122] = {
    [sym__concat] = ACTIONS(2744),
    [anon_sym_esac] = ACTIONS(2746),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_SEMI_SEMI] = ACTIONS(2746),
    [anon_sym_PIPE_AMP] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_LF] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
  },
  [3123] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7301),
    [sym_comment] = ACTIONS(54),
  },
  [3124] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7303),
    [sym_comment] = ACTIONS(54),
  },
  [3125] = {
    [anon_sym_RBRACE] = ACTIONS(7303),
    [sym_comment] = ACTIONS(54),
  },
  [3126] = {
    [sym_concatenation] = STATE(3163),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3163),
    [anon_sym_RBRACE] = ACTIONS(7305),
    [anon_sym_EQ] = ACTIONS(7307),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7307),
    [anon_sym_COLON_QMARK] = ACTIONS(7307),
    [anon_sym_COLON_DASH] = ACTIONS(7307),
    [anon_sym_PERCENT] = ACTIONS(7307),
    [anon_sym_DASH] = ACTIONS(7307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3127] = {
    [sym__concat] = ACTIONS(2822),
    [anon_sym_esac] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE_AMP] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [3128] = {
    [sym_concatenation] = STATE(3166),
    [sym_string] = STATE(3165),
    [sym_simple_expansion] = STATE(3165),
    [sym_string_expansion] = STATE(3165),
    [sym_expansion] = STATE(3165),
    [sym_command_substitution] = STATE(3165),
    [sym_process_substitution] = STATE(3165),
    [anon_sym_RBRACE] = ACTIONS(7303),
    [sym__special_characters] = ACTIONS(7311),
    [anon_sym_DQUOTE] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(1738),
    [sym_raw_string] = ACTIONS(7313),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1742),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1748),
    [anon_sym_GT_LPAREN] = ACTIONS(1748),
    [sym_comment] = ACTIONS(54),
    [sym_word] = ACTIONS(7313),
  },
  [3129] = {
    [sym__concat] = ACTIONS(2865),
    [anon_sym_esac] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_SEMI_SEMI] = ACTIONS(2867),
    [anon_sym_PIPE_AMP] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_LF] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2867),
  },
  [3130] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7315),
  },
  [3131] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7317),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3132] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [3133] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7319),
  },
  [3134] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7321),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3135] = {
    [sym_comment] = ACTIONS(166),
    [sym_regex_without_right_brace] = ACTIONS(7323),
  },
  [3136] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7303),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3137] = {
    [sym_concatenation] = STATE(3173),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3173),
    [anon_sym_RBRACE] = ACTIONS(7325),
    [anon_sym_EQ] = ACTIONS(7327),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7327),
    [anon_sym_COLON_QMARK] = ACTIONS(7327),
    [anon_sym_COLON_DASH] = ACTIONS(7327),
    [anon_sym_PERCENT] = ACTIONS(7327),
    [anon_sym_DASH] = ACTIONS(7327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3138] = {
    [sym__concat] = ACTIONS(2889),
    [anon_sym_esac] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_SEMI_SEMI] = ACTIONS(2891),
    [anon_sym_PIPE_AMP] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2891),
  },
  [3139] = {
    [sym_concatenation] = STATE(3175),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3175),
    [anon_sym_RBRACE] = ACTIONS(7331),
    [anon_sym_EQ] = ACTIONS(7333),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7333),
    [anon_sym_COLON_QMARK] = ACTIONS(7333),
    [anon_sym_COLON_DASH] = ACTIONS(7333),
    [anon_sym_PERCENT] = ACTIONS(7333),
    [anon_sym_DASH] = ACTIONS(7333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3140] = {
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3141] = {
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3142] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3143] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5534),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3144] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5538),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3145] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3146] = {
    [sym__simple_heredoc_body] = ACTIONS(4876),
    [sym__heredoc_body_beginning] = ACTIONS(4876),
    [sym_file_descriptor] = ACTIONS(4876),
    [sym__concat] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [anon_sym_LT] = ACTIONS(4878),
    [anon_sym_GT] = ACTIONS(4878),
    [anon_sym_GT_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT] = ACTIONS(4878),
    [anon_sym_AMP_GT_GT] = ACTIONS(4878),
    [anon_sym_LT_AMP] = ACTIONS(4878),
    [anon_sym_GT_AMP] = ACTIONS(4878),
    [anon_sym_LT_LT] = ACTIONS(4878),
    [anon_sym_LT_LT_DASH] = ACTIONS(4878),
    [anon_sym_LT_LT_LT] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3147] = {
    [sym__simple_heredoc_body] = ACTIONS(4880),
    [sym__heredoc_body_beginning] = ACTIONS(4880),
    [sym_file_descriptor] = ACTIONS(4880),
    [sym__concat] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [anon_sym_LT] = ACTIONS(4882),
    [anon_sym_GT] = ACTIONS(4882),
    [anon_sym_GT_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT] = ACTIONS(4882),
    [anon_sym_AMP_GT_GT] = ACTIONS(4882),
    [anon_sym_LT_AMP] = ACTIONS(4882),
    [anon_sym_GT_AMP] = ACTIONS(4882),
    [anon_sym_LT_LT] = ACTIONS(4882),
    [anon_sym_LT_LT_DASH] = ACTIONS(4882),
    [anon_sym_LT_LT_LT] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3148] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3149] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3150] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7337),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3151] = {
    [sym__simple_heredoc_body] = ACTIONS(4894),
    [sym__heredoc_body_beginning] = ACTIONS(4894),
    [sym_file_descriptor] = ACTIONS(4894),
    [sym__concat] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4896),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3152] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7339),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3153] = {
    [sym__simple_heredoc_body] = ACTIONS(4900),
    [sym__heredoc_body_beginning] = ACTIONS(4900),
    [sym_file_descriptor] = ACTIONS(4900),
    [sym__concat] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3154] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7341),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3155] = {
    [sym__simple_heredoc_body] = ACTIONS(4906),
    [sym__heredoc_body_beginning] = ACTIONS(4906),
    [sym_file_descriptor] = ACTIONS(4906),
    [sym__concat] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3156] = {
    [sym__simple_heredoc_body] = ACTIONS(4910),
    [sym__heredoc_body_beginning] = ACTIONS(4910),
    [sym_file_descriptor] = ACTIONS(4910),
    [sym__concat] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3157] = {
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [sym_variable_name] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [sym__special_characters] = ACTIONS(5534),
    [anon_sym_DQUOTE] = ACTIONS(5534),
    [anon_sym_DOLLAR] = ACTIONS(5534),
    [sym_raw_string] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5534),
    [anon_sym_BQUOTE] = ACTIONS(5534),
    [anon_sym_LT_LPAREN] = ACTIONS(5534),
    [anon_sym_GT_LPAREN] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3158] = {
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [sym_variable_name] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [sym__special_characters] = ACTIONS(5538),
    [anon_sym_DQUOTE] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(5538),
    [sym_raw_string] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5538),
    [anon_sym_BQUOTE] = ACTIONS(5538),
    [anon_sym_LT_LPAREN] = ACTIONS(5538),
    [anon_sym_GT_LPAREN] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5538),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3159] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3160] = {
    [sym__concat] = ACTIONS(3909),
    [anon_sym_esac] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3911),
    [anon_sym_SEMI_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE_AMP] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LF] = ACTIONS(3909),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [3161] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [3162] = {
    [sym__concat] = ACTIONS(4000),
    [anon_sym_esac] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4002),
    [anon_sym_SEMI_SEMI] = ACTIONS(4002),
    [anon_sym_PIPE_AMP] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym_LF] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4002),
  },
  [3163] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7343),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3164] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7345),
    [sym_comment] = ACTIONS(54),
  },
  [3165] = {
    [aux_sym_concatenation_repeat1] = STATE(1249),
    [sym__concat] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(7347),
    [sym_comment] = ACTIONS(54),
  },
  [3166] = {
    [anon_sym_RBRACE] = ACTIONS(7347),
    [sym_comment] = ACTIONS(54),
  },
  [3167] = {
    [sym_concatenation] = STATE(3183),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3183),
    [anon_sym_RBRACE] = ACTIONS(7349),
    [anon_sym_EQ] = ACTIONS(7351),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7351),
    [anon_sym_COLON_QMARK] = ACTIONS(7351),
    [anon_sym_COLON_DASH] = ACTIONS(7351),
    [anon_sym_PERCENT] = ACTIONS(7351),
    [anon_sym_DASH] = ACTIONS(7351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3168] = {
    [sym__concat] = ACTIONS(4016),
    [anon_sym_esac] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_SEMI_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE_AMP] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [3169] = {
    [sym_concatenation] = STATE(3185),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3185),
    [anon_sym_RBRACE] = ACTIONS(7355),
    [anon_sym_EQ] = ACTIONS(7357),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7357),
    [anon_sym_COLON_QMARK] = ACTIONS(7357),
    [anon_sym_COLON_DASH] = ACTIONS(7357),
    [anon_sym_PERCENT] = ACTIONS(7357),
    [anon_sym_DASH] = ACTIONS(7357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3170] = {
    [sym__concat] = ACTIONS(4026),
    [anon_sym_esac] = ACTIONS(4028),
    [anon_sym_PIPE] = ACTIONS(4028),
    [anon_sym_SEMI_SEMI] = ACTIONS(4028),
    [anon_sym_PIPE_AMP] = ACTIONS(4028),
    [anon_sym_AMP_AMP] = ACTIONS(4028),
    [anon_sym_PIPE_PIPE] = ACTIONS(4028),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4028),
  },
  [3171] = {
    [sym_concatenation] = STATE(3187),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(3187),
    [anon_sym_RBRACE] = ACTIONS(7361),
    [anon_sym_EQ] = ACTIONS(7363),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(7365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(7363),
    [anon_sym_COLON_QMARK] = ACTIONS(7363),
    [anon_sym_COLON_DASH] = ACTIONS(7363),
    [anon_sym_PERCENT] = ACTIONS(7363),
    [anon_sym_DASH] = ACTIONS(7363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3172] = {
    [sym__concat] = ACTIONS(4036),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4038),
  },
  [3173] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7367),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3174] = {
    [sym__concat] = ACTIONS(4042),
    [anon_sym_esac] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4044),
    [anon_sym_LF] = ACTIONS(4042),
    [anon_sym_AMP] = ACTIONS(4044),
  },
  [3175] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7369),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3176] = {
    [sym__simple_heredoc_body] = ACTIONS(5532),
    [sym__heredoc_body_beginning] = ACTIONS(5532),
    [sym_file_descriptor] = ACTIONS(5532),
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT] = ACTIONS(5534),
    [anon_sym_AMP_GT_GT] = ACTIONS(5534),
    [anon_sym_LT_AMP] = ACTIONS(5534),
    [anon_sym_GT_AMP] = ACTIONS(5534),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_LT_LT_DASH] = ACTIONS(5534),
    [anon_sym_LT_LT_LT] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3177] = {
    [sym__simple_heredoc_body] = ACTIONS(5536),
    [sym__heredoc_body_beginning] = ACTIONS(5536),
    [sym_file_descriptor] = ACTIONS(5536),
    [sym__concat] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT] = ACTIONS(5538),
    [anon_sym_AMP_GT_GT] = ACTIONS(5538),
    [anon_sym_LT_AMP] = ACTIONS(5538),
    [anon_sym_GT_AMP] = ACTIONS(5538),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_LT_LT_DASH] = ACTIONS(5538),
    [anon_sym_LT_LT_LT] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3178] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3179] = {
    [sym__concat] = ACTIONS(4876),
    [anon_sym_esac] = ACTIONS(4878),
    [anon_sym_PIPE] = ACTIONS(4878),
    [anon_sym_SEMI_SEMI] = ACTIONS(4878),
    [anon_sym_PIPE_AMP] = ACTIONS(4878),
    [anon_sym_AMP_AMP] = ACTIONS(4878),
    [anon_sym_PIPE_PIPE] = ACTIONS(4878),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LF] = ACTIONS(4876),
    [anon_sym_AMP] = ACTIONS(4878),
  },
  [3180] = {
    [sym__concat] = ACTIONS(4880),
    [anon_sym_esac] = ACTIONS(4882),
    [anon_sym_PIPE] = ACTIONS(4882),
    [anon_sym_SEMI_SEMI] = ACTIONS(4882),
    [anon_sym_PIPE_AMP] = ACTIONS(4882),
    [anon_sym_AMP_AMP] = ACTIONS(4882),
    [anon_sym_PIPE_PIPE] = ACTIONS(4882),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4880),
    [anon_sym_AMP] = ACTIONS(4882),
  },
  [3181] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3182] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3183] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7371),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3184] = {
    [sym__concat] = ACTIONS(4894),
    [anon_sym_esac] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4896),
    [anon_sym_LF] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
  },
  [3185] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7373),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3186] = {
    [sym__concat] = ACTIONS(4900),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4902),
    [anon_sym_LF] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4902),
  },
  [3187] = {
    [sym_concatenation] = STATE(820),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_string_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_expansion_repeat1] = STATE(820),
    [anon_sym_RBRACE] = ACTIONS(7375),
    [anon_sym_EQ] = ACTIONS(1788),
    [sym__special_characters] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [sym_raw_string] = ACTIONS(752),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(756),
    [anon_sym_COLON] = ACTIONS(1788),
    [anon_sym_COLON_QMARK] = ACTIONS(1788),
    [anon_sym_COLON_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(764),
    [anon_sym_GT_LPAREN] = ACTIONS(764),
    [sym_comment] = ACTIONS(166),
    [sym_word] = ACTIONS(766),
  },
  [3188] = {
    [sym__concat] = ACTIONS(4906),
    [anon_sym_esac] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym_LF] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4908),
  },
  [3189] = {
    [sym__concat] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4910),
    [anon_sym_AMP] = ACTIONS(4912),
  },
  [3190] = {
    [sym__concat] = ACTIONS(5532),
    [anon_sym_esac] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5534),
    [anon_sym_SEMI_SEMI] = ACTIONS(5534),
    [anon_sym_PIPE_AMP] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5534),
  },
  [3191] = {
    [sym__concat] = ACTIONS(5536),
    [anon_sym_esac] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_SEMI_SEMI] = ACTIONS(5538),
    [anon_sym_PIPE_AMP] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5538),
  },
  [3192] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym_comment] = ACTIONS(166),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 2, .reusable = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true}, SHIFT(2),
  [10] = {.count = 1, .reusable = true}, SHIFT(3),
  [12] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [14] = {.count = 1, .reusable = false}, SHIFT(4),
  [16] = {.count = 1, .reusable = false}, SHIFT(5),
  [18] = {.count = 1, .reusable = false}, SHIFT(6),
  [20] = {.count = 1, .reusable = false}, SHIFT(7),
  [22] = {.count = 1, .reusable = false}, SHIFT(8),
  [24] = {.count = 1, .reusable = true}, SHIFT(9),
  [26] = {.count = 1, .reusable = false}, SHIFT(10),
  [28] = {.count = 1, .reusable = true}, SHIFT(11),
  [30] = {.count = 1, .reusable = false}, SHIFT(12),
  [32] = {.count = 1, .reusable = false}, SHIFT(13),
  [34] = {.count = 1, .reusable = false}, SHIFT(14),
  [36] = {.count = 1, .reusable = true}, SHIFT(14),
  [38] = {.count = 1, .reusable = false}, SHIFT(15),
  [40] = {.count = 1, .reusable = true}, SHIFT(16),
  [42] = {.count = 1, .reusable = false}, SHIFT(17),
  [44] = {.count = 1, .reusable = true}, SHIFT(18),
  [46] = {.count = 1, .reusable = true}, SHIFT(19),
  [48] = {.count = 1, .reusable = true}, SHIFT(20),
  [50] = {.count = 1, .reusable = true}, SHIFT(21),
  [52] = {.count = 1, .reusable = true}, SHIFT(22),
  [54] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [56] = {.count = 1, .reusable = false}, SHIFT(23),
  [58] = {.count = 1, .reusable = false}, SHIFT(32),
  [60] = {.count = 1, .reusable = true}, SHIFT(32),
  [62] = {.count = 1, .reusable = true}, SHIFT(33),
  [64] = {.count = 1, .reusable = true}, SHIFT(34),
  [66] = {.count = 1, .reusable = true}, SHIFT(36),
  [68] = {.count = 1, .reusable = true}, SHIFT(41),
  [70] = {.count = 1, .reusable = true}, SHIFT(42),
  [72] = {.count = 1, .reusable = false}, SHIFT(43),
  [74] = {.count = 1, .reusable = true}, SHIFT(44),
  [76] = {.count = 1, .reusable = true}, SHIFT(45),
  [78] = {.count = 1, .reusable = true}, SHIFT(46),
  [80] = {.count = 1, .reusable = true}, SHIFT(47),
  [82] = {.count = 1, .reusable = true}, SHIFT(48),
  [84] = {.count = 1, .reusable = true}, SHIFT(50),
  [86] = {.count = 1, .reusable = true}, SHIFT(51),
  [88] = {.count = 1, .reusable = false}, SHIFT(52),
  [90] = {.count = 1, .reusable = false}, SHIFT(53),
  [92] = {.count = 1, .reusable = false}, SHIFT(54),
  [94] = {.count = 1, .reusable = true}, SHIFT(55),
  [96] = {.count = 1, .reusable = false}, SHIFT(56),
  [98] = {.count = 1, .reusable = false}, SHIFT(57),
  [100] = {.count = 1, .reusable = false}, SHIFT(58),
  [102] = {.count = 1, .reusable = true}, SHIFT(59),
  [104] = {.count = 1, .reusable = false}, SHIFT(60),
  [106] = {.count = 1, .reusable = false}, SHIFT(67),
  [108] = {.count = 1, .reusable = true}, SHIFT(68),
  [110] = {.count = 1, .reusable = true}, SHIFT(69),
  [112] = {.count = 1, .reusable = false}, SHIFT(70),
  [114] = {.count = 1, .reusable = true}, SHIFT(71),
  [116] = {.count = 1, .reusable = true}, SHIFT(72),
  [118] = {.count = 1, .reusable = true}, SHIFT(73),
  [120] = {.count = 1, .reusable = true}, SHIFT(74),
  [122] = {.count = 1, .reusable = true}, SHIFT(75),
  [124] = {.count = 1, .reusable = false}, SHIFT(71),
  [126] = {.count = 1, .reusable = false}, SHIFT(78),
  [128] = {.count = 1, .reusable = true}, SHIFT(79),
  [130] = {.count = 1, .reusable = true}, SHIFT(80),
  [132] = {.count = 1, .reusable = false}, SHIFT(81),
  [134] = {.count = 1, .reusable = true}, SHIFT(82),
  [136] = {.count = 1, .reusable = true}, SHIFT(83),
  [138] = {.count = 1, .reusable = true}, SHIFT(84),
  [140] = {.count = 1, .reusable = true}, SHIFT(85),
  [142] = {.count = 1, .reusable = true}, SHIFT(86),
  [144] = {.count = 1, .reusable = false}, SHIFT(82),
  [146] = {.count = 1, .reusable = true}, SHIFT(89),
  [148] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [150] = {.count = 1, .reusable = false}, SHIFT(90),
  [152] = {.count = 1, .reusable = false}, SHIFT(91),
  [154] = {.count = 1, .reusable = false}, SHIFT(92),
  [156] = {.count = 1, .reusable = false}, SHIFT(93),
  [158] = {.count = 1, .reusable = false}, SHIFT(94),
  [160] = {.count = 1, .reusable = false}, SHIFT(95),
  [162] = {.count = 1, .reusable = false}, SHIFT(96),
  [164] = {.count = 1, .reusable = false}, SHIFT(97),
  [166] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [168] = {.count = 1, .reusable = false}, SHIFT(98),
  [170] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [172] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [174] = {.count = 1, .reusable = false}, SHIFT(101),
  [176] = {.count = 1, .reusable = false}, SHIFT(102),
  [178] = {.count = 1, .reusable = false}, SHIFT(103),
  [180] = {.count = 1, .reusable = false}, SHIFT(104),
  [182] = {.count = 1, .reusable = false}, SHIFT(105),
  [184] = {.count = 1, .reusable = false}, SHIFT(106),
  [186] = {.count = 1, .reusable = false}, SHIFT(107),
  [188] = {.count = 1, .reusable = false}, SHIFT(108),
  [190] = {.count = 1, .reusable = false}, SHIFT(109),
  [192] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [194] = {.count = 1, .reusable = true}, SHIFT(111),
  [196] = {.count = 1, .reusable = true}, SHIFT(112),
  [198] = {.count = 1, .reusable = false}, SHIFT(113),
  [200] = {.count = 1, .reusable = true}, SHIFT(114),
  [202] = {.count = 1, .reusable = true}, SHIFT(115),
  [204] = {.count = 1, .reusable = true}, SHIFT(116),
  [206] = {.count = 1, .reusable = true}, SHIFT(117),
  [208] = {.count = 1, .reusable = true}, SHIFT(118),
  [210] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [212] = {.count = 1, .reusable = true}, SHIFT(120),
  [214] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [216] = {.count = 1, .reusable = false}, SHIFT(122),
  [218] = {.count = 1, .reusable = false}, SHIFT(123),
  [220] = {.count = 1, .reusable = true}, SHIFT(124),
  [222] = {.count = 1, .reusable = false}, SHIFT(125),
  [224] = {.count = 1, .reusable = false}, SHIFT(126),
  [226] = {.count = 1, .reusable = false}, SHIFT(127),
  [228] = {.count = 1, .reusable = true}, SHIFT(129),
  [230] = {.count = 1, .reusable = true}, SHIFT(130),
  [232] = {.count = 1, .reusable = false}, SHIFT(131),
  [234] = {.count = 1, .reusable = false}, SHIFT(129),
  [236] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [238] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [240] = {.count = 1, .reusable = true}, SHIFT(132),
  [242] = {.count = 1, .reusable = true}, SHIFT(133),
  [244] = {.count = 1, .reusable = true}, SHIFT(134),
  [246] = {.count = 1, .reusable = false}, SHIFT(135),
  [248] = {.count = 1, .reusable = false}, SHIFT(133),
  [250] = {.count = 1, .reusable = true}, SHIFT(137),
  [252] = {.count = 1, .reusable = false}, SHIFT(138),
  [254] = {.count = 1, .reusable = false}, SHIFT(139),
  [256] = {.count = 1, .reusable = false}, SHIFT(140),
  [258] = {.count = 1, .reusable = false}, SHIFT(141),
  [260] = {.count = 1, .reusable = false}, SHIFT(142),
  [262] = {.count = 1, .reusable = true}, SHIFT(143),
  [264] = {.count = 1, .reusable = false}, SHIFT(144),
  [266] = {.count = 1, .reusable = true}, SHIFT(145),
  [268] = {.count = 1, .reusable = false}, SHIFT(146),
  [270] = {.count = 1, .reusable = false}, SHIFT(147),
  [272] = {.count = 1, .reusable = false}, SHIFT(148),
  [274] = {.count = 1, .reusable = true}, SHIFT(149),
  [276] = {.count = 1, .reusable = false}, SHIFT(150),
  [278] = {.count = 1, .reusable = true}, SHIFT(151),
  [280] = {.count = 1, .reusable = true}, SHIFT(152),
  [282] = {.count = 1, .reusable = true}, SHIFT(153),
  [284] = {.count = 1, .reusable = true}, SHIFT(154),
  [286] = {.count = 1, .reusable = true}, SHIFT(155),
  [288] = {.count = 1, .reusable = false}, SHIFT(156),
  [290] = {.count = 1, .reusable = true}, SHIFT(163),
  [292] = {.count = 1, .reusable = false}, SHIFT(164),
  [294] = {.count = 1, .reusable = false}, SHIFT(165),
  [296] = {.count = 1, .reusable = false}, SHIFT(166),
  [298] = {.count = 1, .reusable = true}, SHIFT(167),
  [300] = {.count = 1, .reusable = false}, SHIFT(168),
  [302] = {.count = 1, .reusable = false}, SHIFT(169),
  [304] = {.count = 1, .reusable = false}, SHIFT(170),
  [306] = {.count = 1, .reusable = true}, SHIFT(171),
  [308] = {.count = 1, .reusable = false}, SHIFT(172),
  [310] = {.count = 1, .reusable = false}, SHIFT(180),
  [312] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [314] = {.count = 1, .reusable = false}, SHIFT(181),
  [316] = {.count = 1, .reusable = false}, SHIFT(182),
  [318] = {.count = 1, .reusable = false}, SHIFT(183),
  [320] = {.count = 1, .reusable = true}, SHIFT(182),
  [322] = {.count = 1, .reusable = true}, SHIFT(184),
  [324] = {.count = 1, .reusable = true}, SHIFT(185),
  [326] = {.count = 1, .reusable = true}, SHIFT(186),
  [328] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [330] = {.count = 1, .reusable = false}, SHIFT(187),
  [332] = {.count = 1, .reusable = false}, SHIFT(188),
  [334] = {.count = 1, .reusable = false}, SHIFT(189),
  [336] = {.count = 1, .reusable = false}, SHIFT(190),
  [338] = {.count = 1, .reusable = false}, SHIFT(191),
  [340] = {.count = 1, .reusable = false}, SHIFT(16),
  [342] = {.count = 1, .reusable = false}, SHIFT(192),
  [344] = {.count = 1, .reusable = false}, SHIFT(19),
  [346] = {.count = 1, .reusable = false}, SHIFT(20),
  [348] = {.count = 1, .reusable = false}, SHIFT(21),
  [350] = {.count = 1, .reusable = false}, SHIFT(22),
  [352] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [354] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [356] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [358] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [360] = {.count = 1, .reusable = true}, SHIFT(198),
  [362] = {.count = 1, .reusable = true}, SHIFT(15),
  [364] = {.count = 1, .reusable = true}, SHIFT(202),
  [366] = {.count = 1, .reusable = true}, SHIFT(203),
  [368] = {.count = 1, .reusable = true}, SHIFT(205),
  [370] = {.count = 1, .reusable = true}, SHIFT(206),
  [372] = {.count = 1, .reusable = true}, SHIFT(208),
  [374] = {.count = 1, .reusable = true}, SHIFT(209),
  [376] = {.count = 1, .reusable = true}, SHIFT(210),
  [378] = {.count = 1, .reusable = true}, SHIFT(211),
  [380] = {.count = 1, .reusable = false}, SHIFT(212),
  [382] = {.count = 1, .reusable = true}, SHIFT(213),
  [384] = {.count = 1, .reusable = true}, SHIFT(214),
  [386] = {.count = 1, .reusable = true}, SHIFT(215),
  [388] = {.count = 1, .reusable = true}, SHIFT(216),
  [390] = {.count = 1, .reusable = true}, SHIFT(217),
  [392] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 2),
  [394] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 2),
  [396] = {.count = 1, .reusable = false}, SHIFT(218),
  [398] = {.count = 1, .reusable = false}, SHIFT(219),
  [400] = {.count = 1, .reusable = true}, SHIFT(219),
  [402] = {.count = 1, .reusable = true}, SHIFT(220),
  [404] = {.count = 1, .reusable = false}, SHIFT(222),
  [406] = {.count = 1, .reusable = true}, SHIFT(222),
  [408] = {.count = 1, .reusable = true}, SHIFT(223),
  [410] = {.count = 1, .reusable = true}, SHIFT(224),
  [412] = {.count = 1, .reusable = false}, SHIFT(225),
  [414] = {.count = 1, .reusable = false}, SHIFT(226),
  [416] = {.count = 1, .reusable = true}, SHIFT(226),
  [418] = {.count = 1, .reusable = false}, SHIFT(228),
  [420] = {.count = 1, .reusable = true}, SHIFT(230),
  [422] = {.count = 1, .reusable = true}, SHIFT(231),
  [424] = {.count = 1, .reusable = false}, SHIFT(232),
  [426] = {.count = 1, .reusable = false}, SHIFT(230),
  [428] = {.count = 1, .reusable = false}, SHIFT(233),
  [430] = {.count = 1, .reusable = false}, SHIFT(234),
  [432] = {.count = 1, .reusable = true}, SHIFT(234),
  [434] = {.count = 1, .reusable = true}, SHIFT(235),
  [436] = {.count = 1, .reusable = true}, SHIFT(236),
  [438] = {.count = 1, .reusable = true}, SHIFT(237),
  [440] = {.count = 1, .reusable = false}, SHIFT(238),
  [442] = {.count = 1, .reusable = false}, SHIFT(236),
  [444] = {.count = 1, .reusable = true}, SHIFT(246),
  [446] = {.count = 1, .reusable = true}, SHIFT(247),
  [448] = {.count = 1, .reusable = true}, SHIFT(249),
  [450] = {.count = 1, .reusable = true}, SHIFT(251),
  [452] = {.count = 1, .reusable = true}, SHIFT(254),
  [454] = {.count = 1, .reusable = false}, SHIFT(255),
  [456] = {.count = 1, .reusable = false}, SHIFT(256),
  [458] = {.count = 1, .reusable = false}, SHIFT(259),
  [460] = {.count = 1, .reusable = false}, SHIFT(260),
  [462] = {.count = 1, .reusable = false}, SHIFT(263),
  [464] = {.count = 1, .reusable = false}, SHIFT(264),
  [466] = {.count = 1, .reusable = false}, SHIFT(265),
  [468] = {.count = 1, .reusable = false}, SHIFT(266),
  [470] = {.count = 1, .reusable = false}, SHIFT(267),
  [472] = {.count = 1, .reusable = true}, SHIFT(266),
  [474] = {.count = 1, .reusable = true}, SHIFT(268),
  [476] = {.count = 1, .reusable = false}, SHIFT(269),
  [478] = {.count = 1, .reusable = false}, SHIFT(270),
  [480] = {.count = 1, .reusable = false}, SHIFT(271),
  [482] = {.count = 1, .reusable = false}, SHIFT(272),
  [484] = {.count = 1, .reusable = false}, SHIFT(273),
  [486] = {.count = 1, .reusable = true}, SHIFT(58),
  [488] = {.count = 1, .reusable = false}, SHIFT(280),
  [490] = {.count = 1, .reusable = false}, SHIFT(69),
  [492] = {.count = 1, .reusable = false}, SHIFT(281),
  [494] = {.count = 1, .reusable = false}, SHIFT(72),
  [496] = {.count = 1, .reusable = false}, SHIFT(73),
  [498] = {.count = 1, .reusable = false}, SHIFT(74),
  [500] = {.count = 1, .reusable = false}, SHIFT(75),
  [502] = {.count = 1, .reusable = false}, SHIFT(282),
  [504] = {.count = 1, .reusable = true}, SHIFT(283),
  [506] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [508] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [510] = {.count = 1, .reusable = false}, SHIFT(285),
  [512] = {.count = 1, .reusable = true}, SHIFT(287),
  [514] = {.count = 1, .reusable = true}, SHIFT(288),
  [516] = {.count = 1, .reusable = false}, SHIFT(289),
  [518] = {.count = 1, .reusable = false}, SHIFT(287),
  [520] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [522] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [524] = {.count = 1, .reusable = true}, SHIFT(290),
  [526] = {.count = 1, .reusable = true}, SHIFT(291),
  [528] = {.count = 1, .reusable = true}, SHIFT(292),
  [530] = {.count = 1, .reusable = false}, SHIFT(293),
  [532] = {.count = 1, .reusable = false}, SHIFT(291),
  [534] = {.count = 1, .reusable = true}, SHIFT(301),
  [536] = {.count = 1, .reusable = false}, SHIFT(68),
  [538] = {.count = 1, .reusable = false}, SHIFT(303),
  [540] = {.count = 1, .reusable = false}, SHIFT(80),
  [542] = {.count = 1, .reusable = false}, SHIFT(304),
  [544] = {.count = 1, .reusable = false}, SHIFT(83),
  [546] = {.count = 1, .reusable = false}, SHIFT(84),
  [548] = {.count = 1, .reusable = false}, SHIFT(85),
  [550] = {.count = 1, .reusable = false}, SHIFT(86),
  [552] = {.count = 1, .reusable = false}, SHIFT(305),
  [554] = {.count = 1, .reusable = true}, SHIFT(306),
  [556] = {.count = 1, .reusable = false}, SHIFT(308),
  [558] = {.count = 1, .reusable = true}, SHIFT(310),
  [560] = {.count = 1, .reusable = true}, SHIFT(311),
  [562] = {.count = 1, .reusable = false}, SHIFT(312),
  [564] = {.count = 1, .reusable = false}, SHIFT(310),
  [566] = {.count = 1, .reusable = true}, SHIFT(313),
  [568] = {.count = 1, .reusable = true}, SHIFT(314),
  [570] = {.count = 1, .reusable = true}, SHIFT(315),
  [572] = {.count = 1, .reusable = false}, SHIFT(316),
  [574] = {.count = 1, .reusable = false}, SHIFT(314),
  [576] = {.count = 1, .reusable = false}, SHIFT(79),
  [578] = {.count = 1, .reusable = true}, SHIFT(325),
  [580] = {.count = 1, .reusable = true}, SHIFT(327),
  [582] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [584] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [586] = {.count = 1, .reusable = false}, SHIFT(329),
  [588] = {.count = 1, .reusable = true}, SHIFT(91),
  [590] = {.count = 1, .reusable = true}, SHIFT(331),
  [592] = {.count = 1, .reusable = true}, SHIFT(332),
  [594] = {.count = 1, .reusable = false}, SHIFT(333),
  [596] = {.count = 1, .reusable = false}, SHIFT(331),
  [598] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [600] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [602] = {.count = 1, .reusable = true}, SHIFT(334),
  [604] = {.count = 1, .reusable = true}, SHIFT(335),
  [606] = {.count = 1, .reusable = true}, SHIFT(336),
  [608] = {.count = 1, .reusable = false}, SHIFT(337),
  [610] = {.count = 1, .reusable = false}, SHIFT(335),
  [612] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [614] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [616] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [618] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [620] = {.count = 1, .reusable = true}, SHIFT(346),
  [622] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [624] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [626] = {.count = 1, .reusable = false}, SHIFT(348),
  [628] = {.count = 1, .reusable = true}, SHIFT(102),
  [630] = {.count = 1, .reusable = true}, SHIFT(350),
  [632] = {.count = 1, .reusable = true}, SHIFT(351),
  [634] = {.count = 1, .reusable = false}, SHIFT(352),
  [636] = {.count = 1, .reusable = false}, SHIFT(350),
  [638] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [640] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [642] = {.count = 1, .reusable = true}, SHIFT(353),
  [644] = {.count = 1, .reusable = true}, SHIFT(354),
  [646] = {.count = 1, .reusable = true}, SHIFT(355),
  [648] = {.count = 1, .reusable = false}, SHIFT(356),
  [650] = {.count = 1, .reusable = false}, SHIFT(354),
  [652] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [654] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [658] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [660] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [662] = {.count = 1, .reusable = true}, SHIFT(365),
  [664] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [666] = {.count = 1, .reusable = false}, SHIFT(367),
  [668] = {.count = 1, .reusable = true}, SHIFT(369),
  [670] = {.count = 1, .reusable = true}, SHIFT(370),
  [672] = {.count = 1, .reusable = false}, SHIFT(371),
  [674] = {.count = 1, .reusable = false}, SHIFT(369),
  [676] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [678] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [680] = {.count = 1, .reusable = true}, SHIFT(372),
  [682] = {.count = 1, .reusable = true}, SHIFT(373),
  [684] = {.count = 1, .reusable = true}, SHIFT(374),
  [686] = {.count = 1, .reusable = false}, SHIFT(375),
  [688] = {.count = 1, .reusable = false}, SHIFT(373),
  [690] = {.count = 1, .reusable = true}, SHIFT(383),
  [692] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [694] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [696] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [698] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [700] = {.count = 1, .reusable = false}, SHIFT(385),
  [702] = {.count = 1, .reusable = false}, SHIFT(386),
  [704] = {.count = 1, .reusable = true}, SHIFT(385),
  [706] = {.count = 1, .reusable = false}, SHIFT(387),
  [708] = {.count = 1, .reusable = true}, SHIFT(388),
  [710] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [712] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [714] = {.count = 1, .reusable = true}, SHIFT(389),
  [716] = {.count = 1, .reusable = true}, SHIFT(390),
  [718] = {.count = 1, .reusable = true}, SHIFT(391),
  [720] = {.count = 1, .reusable = false}, SHIFT(392),
  [722] = {.count = 1, .reusable = false}, SHIFT(390),
  [724] = {.count = 1, .reusable = false}, SHIFT(398),
  [726] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [728] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [730] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [732] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [734] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [736] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [738] = {.count = 1, .reusable = true}, SHIFT(400),
  [740] = {.count = 1, .reusable = true}, SHIFT(401),
  [742] = {.count = 1, .reusable = true}, SHIFT(402),
  [744] = {.count = 1, .reusable = false}, SHIFT(412),
  [746] = {.count = 1, .reusable = false}, SHIFT(403),
  [748] = {.count = 1, .reusable = true}, SHIFT(404),
  [750] = {.count = 1, .reusable = false}, SHIFT(405),
  [752] = {.count = 1, .reusable = true}, SHIFT(406),
  [754] = {.count = 1, .reusable = true}, SHIFT(412),
  [756] = {.count = 1, .reusable = true}, SHIFT(407),
  [758] = {.count = 1, .reusable = true}, SHIFT(408),
  [760] = {.count = 1, .reusable = true}, SHIFT(409),
  [762] = {.count = 1, .reusable = true}, SHIFT(410),
  [764] = {.count = 1, .reusable = true}, SHIFT(411),
  [766] = {.count = 1, .reusable = false}, SHIFT(406),
  [768] = {.count = 1, .reusable = true}, SHIFT(413),
  [770] = {.count = 1, .reusable = true}, SHIFT(414),
  [772] = {.count = 1, .reusable = false}, SHIFT(415),
  [774] = {.count = 1, .reusable = false}, SHIFT(414),
  [776] = {.count = 1, .reusable = true}, SHIFT(417),
  [778] = {.count = 1, .reusable = false}, SHIFT(419),
  [780] = {.count = 1, .reusable = true}, SHIFT(419),
  [782] = {.count = 1, .reusable = true}, SHIFT(418),
  [784] = {.count = 1, .reusable = true}, SHIFT(420),
  [786] = {.count = 1, .reusable = false}, SHIFT(422),
  [788] = {.count = 1, .reusable = true}, SHIFT(422),
  [790] = {.count = 1, .reusable = true}, SHIFT(421),
  [792] = {.count = 1, .reusable = true}, SHIFT(423),
  [794] = {.count = 1, .reusable = true}, SHIFT(425),
  [796] = {.count = 1, .reusable = true}, SHIFT(428),
  [798] = {.count = 1, .reusable = true}, SHIFT(429),
  [800] = {.count = 1, .reusable = true}, SHIFT(431),
  [802] = {.count = 1, .reusable = true}, SHIFT(437),
  [804] = {.count = 1, .reusable = true}, SHIFT(438),
  [806] = {.count = 1, .reusable = true}, SHIFT(439),
  [808] = {.count = 1, .reusable = false}, SHIFT(440),
  [810] = {.count = 1, .reusable = true}, SHIFT(441),
  [812] = {.count = 1, .reusable = true}, SHIFT(442),
  [814] = {.count = 1, .reusable = true}, SHIFT(443),
  [816] = {.count = 1, .reusable = true}, SHIFT(444),
  [818] = {.count = 1, .reusable = true}, SHIFT(445),
  [820] = {.count = 1, .reusable = false}, SHIFT(446),
  [822] = {.count = 1, .reusable = false}, SHIFT(441),
  [824] = {.count = 1, .reusable = true}, SHIFT(449),
  [826] = {.count = 1, .reusable = true}, SHIFT(450),
  [828] = {.count = 1, .reusable = false}, SHIFT(451),
  [830] = {.count = 1, .reusable = true}, SHIFT(452),
  [832] = {.count = 1, .reusable = true}, SHIFT(453),
  [834] = {.count = 1, .reusable = true}, SHIFT(454),
  [836] = {.count = 1, .reusable = true}, SHIFT(455),
  [838] = {.count = 1, .reusable = true}, SHIFT(456),
  [840] = {.count = 1, .reusable = false}, SHIFT(457),
  [842] = {.count = 1, .reusable = false}, SHIFT(452),
  [844] = {.count = 1, .reusable = true}, SHIFT(459),
  [846] = {.count = 1, .reusable = false}, SHIFT(461),
  [848] = {.count = 1, .reusable = true}, SHIFT(463),
  [850] = {.count = 1, .reusable = true}, SHIFT(464),
  [852] = {.count = 1, .reusable = false}, SHIFT(465),
  [854] = {.count = 1, .reusable = false}, SHIFT(463),
  [856] = {.count = 1, .reusable = true}, SHIFT(466),
  [858] = {.count = 1, .reusable = true}, SHIFT(467),
  [860] = {.count = 1, .reusable = true}, SHIFT(468),
  [862] = {.count = 1, .reusable = false}, SHIFT(469),
  [864] = {.count = 1, .reusable = false}, SHIFT(467),
  [866] = {.count = 1, .reusable = true}, SHIFT(477),
  [868] = {.count = 1, .reusable = false}, SHIFT(478),
  [870] = {.count = 1, .reusable = true}, SHIFT(479),
  [872] = {.count = 1, .reusable = true}, SHIFT(478),
  [874] = {.count = 1, .reusable = true}, SHIFT(480),
  [876] = {.count = 1, .reusable = true}, SHIFT(481),
  [878] = {.count = 1, .reusable = true}, SHIFT(482),
  [880] = {.count = 1, .reusable = true}, SHIFT(483),
  [882] = {.count = 1, .reusable = false}, SHIFT(484),
  [884] = {.count = 1, .reusable = false}, SHIFT(485),
  [886] = {.count = 1, .reusable = true}, SHIFT(485),
  [888] = {.count = 1, .reusable = false}, SHIFT(486),
  [890] = {.count = 1, .reusable = true}, SHIFT(486),
  [892] = {.count = 1, .reusable = true}, SHIFT(487),
  [894] = {.count = 1, .reusable = true}, SHIFT(488),
  [896] = {.count = 1, .reusable = true}, SHIFT(489),
  [898] = {.count = 1, .reusable = false}, SHIFT(489),
  [900] = {.count = 1, .reusable = true}, SHIFT(148),
  [902] = {.count = 1, .reusable = true}, SHIFT(495),
  [904] = {.count = 1, .reusable = true}, SHIFT(497),
  [906] = {.count = 1, .reusable = true}, SHIFT(500),
  [908] = {.count = 1, .reusable = true}, SHIFT(501),
  [910] = {.count = 1, .reusable = true}, SHIFT(502),
  [912] = {.count = 1, .reusable = false}, SHIFT(502),
  [914] = {.count = 1, .reusable = true}, SHIFT(505),
  [916] = {.count = 1, .reusable = true}, SHIFT(506),
  [918] = {.count = 1, .reusable = false}, SHIFT(506),
  [920] = {.count = 1, .reusable = true}, SHIFT(509),
  [922] = {.count = 1, .reusable = false}, SHIFT(510),
  [924] = {.count = 1, .reusable = true}, SHIFT(510),
  [926] = {.count = 1, .reusable = true}, SHIFT(511),
  [928] = {.count = 1, .reusable = true}, SHIFT(512),
  [930] = {.count = 1, .reusable = false}, SHIFT(513),
  [932] = {.count = 1, .reusable = false}, SHIFT(514),
  [934] = {.count = 1, .reusable = true}, SHIFT(514),
  [936] = {.count = 1, .reusable = true}, SHIFT(515),
  [938] = {.count = 1, .reusable = true}, SHIFT(516),
  [940] = {.count = 1, .reusable = true}, SHIFT(517),
  [942] = {.count = 1, .reusable = false}, SHIFT(517),
  [944] = {.count = 1, .reusable = true}, SHIFT(170),
  [946] = {.count = 1, .reusable = true}, SHIFT(521),
  [948] = {.count = 1, .reusable = true}, SHIFT(522),
  [950] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [952] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [954] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [956] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [958] = {.count = 1, .reusable = true}, SHIFT(527),
  [960] = {.count = 1, .reusable = true}, SHIFT(528),
  [962] = {.count = 1, .reusable = false}, SHIFT(529),
  [964] = {.count = 1, .reusable = true}, SHIFT(530),
  [966] = {.count = 1, .reusable = false}, SHIFT(532),
  [968] = {.count = 1, .reusable = true}, SHIFT(532),
  [970] = {.count = 1, .reusable = false}, SHIFT(533),
  [972] = {.count = 1, .reusable = false}, SHIFT(534),
  [974] = {.count = 1, .reusable = false}, SHIFT(535),
  [976] = {.count = 1, .reusable = true}, SHIFT(536),
  [978] = {.count = 1, .reusable = true}, SHIFT(537),
  [980] = {.count = 1, .reusable = true}, SHIFT(539),
  [982] = {.count = 1, .reusable = true}, SHIFT(540),
  [984] = {.count = 1, .reusable = true}, SHIFT(541),
  [986] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [988] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [990] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [996] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [998] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1001] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1004] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1019] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1022] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1037] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1046] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1052] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1055] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1058] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1061] = {.count = 1, .reusable = true}, SHIFT(547),
  [1063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1066] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(198),
  [1069] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(14),
  [1072] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(14),
  [1075] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1077] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1079] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1081] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1083] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1085] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1087] = {.count = 1, .reusable = true}, SHIFT(549),
  [1089] = {.count = 1, .reusable = true}, SHIFT(550),
  [1091] = {.count = 1, .reusable = true}, SHIFT(552),
  [1093] = {.count = 1, .reusable = true}, SHIFT(553),
  [1095] = {.count = 1, .reusable = true}, SHIFT(554),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym__assignment, 2),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym__assignment, 2),
  [1101] = {.count = 1, .reusable = true}, SHIFT(555),
  [1103] = {.count = 1, .reusable = true}, SHIFT(556),
  [1105] = {.count = 1, .reusable = true}, SHIFT(557),
  [1107] = {.count = 1, .reusable = false}, SHIFT(558),
  [1109] = {.count = 1, .reusable = true}, SHIFT(559),
  [1111] = {.count = 1, .reusable = true}, SHIFT(560),
  [1113] = {.count = 1, .reusable = true}, SHIFT(561),
  [1115] = {.count = 1, .reusable = true}, SHIFT(562),
  [1117] = {.count = 1, .reusable = true}, SHIFT(563),
  [1119] = {.count = 1, .reusable = true}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [1121] = {.count = 1, .reusable = true}, SHIFT(565),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [1125] = {.count = 1, .reusable = false}, SHIFT(567),
  [1127] = {.count = 1, .reusable = true}, SHIFT(569),
  [1129] = {.count = 1, .reusable = true}, SHIFT(570),
  [1131] = {.count = 1, .reusable = false}, SHIFT(571),
  [1133] = {.count = 1, .reusable = false}, SHIFT(569),
  [1135] = {.count = 1, .reusable = true}, SHIFT(572),
  [1137] = {.count = 1, .reusable = true}, SHIFT(573),
  [1139] = {.count = 1, .reusable = true}, SHIFT(574),
  [1141] = {.count = 1, .reusable = false}, SHIFT(575),
  [1143] = {.count = 1, .reusable = false}, SHIFT(573),
  [1145] = {.count = 1, .reusable = true}, SHIFT(583),
  [1147] = {.count = 1, .reusable = true}, SHIFT(584),
  [1149] = {.count = 1, .reusable = false}, SHIFT(585),
  [1151] = {.count = 1, .reusable = true}, SHIFT(586),
  [1153] = {.count = 1, .reusable = true}, SHIFT(587),
  [1155] = {.count = 1, .reusable = true}, SHIFT(588),
  [1157] = {.count = 1, .reusable = true}, SHIFT(589),
  [1159] = {.count = 1, .reusable = true}, SHIFT(590),
  [1161] = {.count = 1, .reusable = true}, SHIFT(592),
  [1163] = {.count = 1, .reusable = false}, SHIFT(594),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1169] = {.count = 1, .reusable = false}, SHIFT(600),
  [1171] = {.count = 1, .reusable = false}, SHIFT(601),
  [1173] = {.count = 1, .reusable = false}, SHIFT(602),
  [1175] = {.count = 1, .reusable = true}, SHIFT(608),
  [1177] = {.count = 1, .reusable = false}, SHIFT(609),
  [1179] = {.count = 1, .reusable = true}, SHIFT(609),
  [1181] = {.count = 1, .reusable = true}, SHIFT(610),
  [1183] = {.count = 1, .reusable = false}, SHIFT(612),
  [1185] = {.count = 1, .reusable = false}, SHIFT(613),
  [1187] = {.count = 1, .reusable = true}, SHIFT(613),
  [1189] = {.count = 1, .reusable = true}, SHIFT(614),
  [1191] = {.count = 1, .reusable = true}, SHIFT(615),
  [1193] = {.count = 1, .reusable = true}, SHIFT(616),
  [1195] = {.count = 1, .reusable = false}, SHIFT(618),
  [1197] = {.count = 1, .reusable = true}, SHIFT(618),
  [1199] = {.count = 1, .reusable = true}, SHIFT(617),
  [1201] = {.count = 1, .reusable = true}, SHIFT(619),
  [1203] = {.count = 1, .reusable = true}, SHIFT(620),
  [1205] = {.count = 1, .reusable = false}, SHIFT(621),
  [1207] = {.count = 1, .reusable = false}, SHIFT(620),
  [1209] = {.count = 1, .reusable = true}, SHIFT(623),
  [1211] = {.count = 1, .reusable = false}, SHIFT(625),
  [1213] = {.count = 1, .reusable = true}, SHIFT(625),
  [1215] = {.count = 1, .reusable = true}, SHIFT(624),
  [1217] = {.count = 1, .reusable = true}, SHIFT(626),
  [1219] = {.count = 1, .reusable = false}, SHIFT(628),
  [1221] = {.count = 1, .reusable = true}, SHIFT(628),
  [1223] = {.count = 1, .reusable = true}, SHIFT(627),
  [1225] = {.count = 1, .reusable = true}, SHIFT(629),
  [1227] = {.count = 1, .reusable = true}, SHIFT(630),
  [1229] = {.count = 1, .reusable = true}, SHIFT(631),
  [1231] = {.count = 1, .reusable = true}, SHIFT(632),
  [1233] = {.count = 1, .reusable = true}, SHIFT(636),
  [1235] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1237] = {.count = 1, .reusable = false}, SHIFT(637),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1241] = {.count = 1, .reusable = true}, SHIFT(639),
  [1243] = {.count = 1, .reusable = true}, SHIFT(640),
  [1245] = {.count = 1, .reusable = true}, SHIFT(642),
  [1247] = {.count = 1, .reusable = true}, SHIFT(644),
  [1249] = {.count = 1, .reusable = true}, SHIFT(645),
  [1251] = {.count = 1, .reusable = true}, SHIFT(651),
  [1253] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1255] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1257] = {.count = 1, .reusable = true}, SHIFT(652),
  [1259] = {.count = 1, .reusable = false}, SHIFT(655),
  [1261] = {.count = 1, .reusable = true}, SHIFT(655),
  [1263] = {.count = 1, .reusable = false}, SHIFT(656),
  [1265] = {.count = 1, .reusable = false}, SHIFT(657),
  [1267] = {.count = 1, .reusable = true}, SHIFT(658),
  [1269] = {.count = 1, .reusable = true}, SHIFT(659),
  [1271] = {.count = 1, .reusable = true}, SHIFT(660),
  [1273] = {.count = 1, .reusable = true}, SHIFT(661),
  [1275] = {.count = 1, .reusable = false}, SHIFT(652),
  [1277] = {.count = 1, .reusable = false}, SHIFT(665),
  [1279] = {.count = 1, .reusable = true}, SHIFT(665),
  [1281] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [1283] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [1285] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1287] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1289] = {.count = 1, .reusable = true}, SHIFT(667),
  [1291] = {.count = 1, .reusable = false}, SHIFT(669),
  [1293] = {.count = 1, .reusable = true}, SHIFT(670),
  [1295] = {.count = 1, .reusable = true}, SHIFT(671),
  [1297] = {.count = 1, .reusable = false}, SHIFT(673),
  [1299] = {.count = 1, .reusable = true}, SHIFT(673),
  [1301] = {.count = 1, .reusable = true}, SHIFT(672),
  [1303] = {.count = 1, .reusable = true}, SHIFT(674),
  [1305] = {.count = 1, .reusable = true}, SHIFT(675),
  [1307] = {.count = 1, .reusable = false}, SHIFT(676),
  [1309] = {.count = 1, .reusable = false}, SHIFT(675),
  [1311] = {.count = 1, .reusable = true}, SHIFT(678),
  [1313] = {.count = 1, .reusable = false}, SHIFT(680),
  [1315] = {.count = 1, .reusable = true}, SHIFT(680),
  [1317] = {.count = 1, .reusable = true}, SHIFT(679),
  [1319] = {.count = 1, .reusable = true}, SHIFT(681),
  [1321] = {.count = 1, .reusable = false}, SHIFT(683),
  [1323] = {.count = 1, .reusable = true}, SHIFT(683),
  [1325] = {.count = 1, .reusable = true}, SHIFT(682),
  [1327] = {.count = 1, .reusable = true}, SHIFT(684),
  [1329] = {.count = 1, .reusable = true}, SHIFT(685),
  [1331] = {.count = 1, .reusable = true}, SHIFT(686),
  [1333] = {.count = 1, .reusable = false}, REDUCE(sym_bracket_command, 3),
  [1335] = {.count = 1, .reusable = false}, SHIFT(687),
  [1337] = {.count = 1, .reusable = false}, SHIFT(688),
  [1339] = {.count = 1, .reusable = false}, SHIFT(689),
  [1341] = {.count = 1, .reusable = true}, REDUCE(sym_bracket_command, 3),
  [1343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(67),
  [1346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(68),
  [1349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(69),
  [1352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(70),
  [1355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(71),
  [1358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(72),
  [1361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(73),
  [1364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(74),
  [1367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(75),
  [1370] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(71),
  [1373] = {.count = 1, .reusable = true}, SHIFT(691),
  [1375] = {.count = 1, .reusable = false}, SHIFT(693),
  [1377] = {.count = 1, .reusable = true}, SHIFT(694),
  [1379] = {.count = 1, .reusable = true}, SHIFT(695),
  [1381] = {.count = 1, .reusable = false}, SHIFT(697),
  [1383] = {.count = 1, .reusable = true}, SHIFT(697),
  [1385] = {.count = 1, .reusable = true}, SHIFT(696),
  [1387] = {.count = 1, .reusable = true}, SHIFT(698),
  [1389] = {.count = 1, .reusable = true}, SHIFT(699),
  [1391] = {.count = 1, .reusable = false}, SHIFT(700),
  [1393] = {.count = 1, .reusable = false}, SHIFT(699),
  [1395] = {.count = 1, .reusable = true}, SHIFT(702),
  [1397] = {.count = 1, .reusable = false}, SHIFT(704),
  [1399] = {.count = 1, .reusable = true}, SHIFT(704),
  [1401] = {.count = 1, .reusable = true}, SHIFT(703),
  [1403] = {.count = 1, .reusable = true}, SHIFT(705),
  [1405] = {.count = 1, .reusable = false}, SHIFT(707),
  [1407] = {.count = 1, .reusable = true}, SHIFT(707),
  [1409] = {.count = 1, .reusable = true}, SHIFT(706),
  [1411] = {.count = 1, .reusable = true}, SHIFT(708),
  [1413] = {.count = 1, .reusable = true}, SHIFT(709),
  [1415] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(78),
  [1418] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(79),
  [1421] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(80),
  [1424] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(81),
  [1427] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(82),
  [1430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(83),
  [1433] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(84),
  [1436] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(85),
  [1439] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(86),
  [1442] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(82),
  [1445] = {.count = 1, .reusable = true}, SHIFT(710),
  [1447] = {.count = 1, .reusable = true}, SHIFT(711),
  [1449] = {.count = 1, .reusable = true}, SHIFT(712),
  [1451] = {.count = 1, .reusable = true}, SHIFT(713),
  [1453] = {.count = 1, .reusable = true}, SHIFT(94),
  [1455] = {.count = 1, .reusable = true}, SHIFT(95),
  [1457] = {.count = 1, .reusable = true}, SHIFT(96),
  [1459] = {.count = 1, .reusable = true}, SHIFT(97),
  [1461] = {.count = 1, .reusable = true}, SHIFT(714),
  [1463] = {.count = 1, .reusable = false}, SHIFT(716),
  [1465] = {.count = 1, .reusable = true}, SHIFT(717),
  [1467] = {.count = 1, .reusable = true}, SHIFT(718),
  [1469] = {.count = 1, .reusable = false}, SHIFT(720),
  [1471] = {.count = 1, .reusable = true}, SHIFT(720),
  [1473] = {.count = 1, .reusable = true}, SHIFT(719),
  [1475] = {.count = 1, .reusable = true}, SHIFT(721),
  [1477] = {.count = 1, .reusable = true}, SHIFT(722),
  [1479] = {.count = 1, .reusable = false}, SHIFT(723),
  [1481] = {.count = 1, .reusable = false}, SHIFT(722),
  [1483] = {.count = 1, .reusable = true}, SHIFT(725),
  [1485] = {.count = 1, .reusable = false}, SHIFT(727),
  [1487] = {.count = 1, .reusable = true}, SHIFT(727),
  [1489] = {.count = 1, .reusable = true}, SHIFT(726),
  [1491] = {.count = 1, .reusable = true}, SHIFT(728),
  [1493] = {.count = 1, .reusable = false}, SHIFT(730),
  [1495] = {.count = 1, .reusable = true}, SHIFT(730),
  [1497] = {.count = 1, .reusable = true}, SHIFT(729),
  [1499] = {.count = 1, .reusable = true}, SHIFT(731),
  [1501] = {.count = 1, .reusable = true}, SHIFT(732),
  [1503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(89),
  [1506] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(90),
  [1511] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(91),
  [1514] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(92),
  [1517] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(93),
  [1520] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(94),
  [1523] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(95),
  [1526] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(96),
  [1529] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(97),
  [1532] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(98),
  [1535] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1537] = {.count = 1, .reusable = true}, SHIFT(733),
  [1539] = {.count = 1, .reusable = true}, SHIFT(105),
  [1541] = {.count = 1, .reusable = true}, SHIFT(106),
  [1543] = {.count = 1, .reusable = true}, SHIFT(107),
  [1545] = {.count = 1, .reusable = true}, SHIFT(108),
  [1547] = {.count = 1, .reusable = false}, SHIFT(735),
  [1549] = {.count = 1, .reusable = true}, SHIFT(736),
  [1551] = {.count = 1, .reusable = true}, SHIFT(737),
  [1553] = {.count = 1, .reusable = false}, SHIFT(739),
  [1555] = {.count = 1, .reusable = true}, SHIFT(739),
  [1557] = {.count = 1, .reusable = true}, SHIFT(738),
  [1559] = {.count = 1, .reusable = true}, SHIFT(740),
  [1561] = {.count = 1, .reusable = true}, SHIFT(741),
  [1563] = {.count = 1, .reusable = false}, SHIFT(742),
  [1565] = {.count = 1, .reusable = false}, SHIFT(741),
  [1567] = {.count = 1, .reusable = true}, SHIFT(744),
  [1569] = {.count = 1, .reusable = false}, SHIFT(746),
  [1571] = {.count = 1, .reusable = true}, SHIFT(746),
  [1573] = {.count = 1, .reusable = true}, SHIFT(745),
  [1575] = {.count = 1, .reusable = true}, SHIFT(747),
  [1577] = {.count = 1, .reusable = false}, SHIFT(749),
  [1579] = {.count = 1, .reusable = true}, SHIFT(749),
  [1581] = {.count = 1, .reusable = true}, SHIFT(748),
  [1583] = {.count = 1, .reusable = true}, SHIFT(750),
  [1585] = {.count = 1, .reusable = true}, SHIFT(751),
  [1587] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1589] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(101),
  [1592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(102),
  [1595] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(103),
  [1598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(104),
  [1601] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(105),
  [1604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(106),
  [1607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(107),
  [1610] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(108),
  [1613] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(109),
  [1616] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1618] = {.count = 1, .reusable = true}, SHIFT(752),
  [1620] = {.count = 1, .reusable = false}, SHIFT(754),
  [1622] = {.count = 1, .reusable = true}, SHIFT(755),
  [1624] = {.count = 1, .reusable = true}, SHIFT(756),
  [1626] = {.count = 1, .reusable = false}, SHIFT(758),
  [1628] = {.count = 1, .reusable = true}, SHIFT(758),
  [1630] = {.count = 1, .reusable = true}, SHIFT(757),
  [1632] = {.count = 1, .reusable = true}, SHIFT(759),
  [1634] = {.count = 1, .reusable = true}, SHIFT(760),
  [1636] = {.count = 1, .reusable = false}, SHIFT(761),
  [1638] = {.count = 1, .reusable = false}, SHIFT(760),
  [1640] = {.count = 1, .reusable = true}, SHIFT(763),
  [1642] = {.count = 1, .reusable = false}, SHIFT(765),
  [1644] = {.count = 1, .reusable = true}, SHIFT(765),
  [1646] = {.count = 1, .reusable = true}, SHIFT(764),
  [1648] = {.count = 1, .reusable = true}, SHIFT(766),
  [1650] = {.count = 1, .reusable = false}, SHIFT(768),
  [1652] = {.count = 1, .reusable = true}, SHIFT(768),
  [1654] = {.count = 1, .reusable = true}, SHIFT(767),
  [1656] = {.count = 1, .reusable = true}, SHIFT(769),
  [1658] = {.count = 1, .reusable = true}, SHIFT(770),
  [1660] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1662] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(120),
  [1667] = {.count = 1, .reusable = true}, SHIFT(771),
  [1669] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1671] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1673] = {.count = 1, .reusable = true}, SHIFT(772),
  [1675] = {.count = 1, .reusable = true}, SHIFT(773),
  [1677] = {.count = 1, .reusable = false}, SHIFT(775),
  [1679] = {.count = 1, .reusable = true}, SHIFT(775),
  [1681] = {.count = 1, .reusable = true}, SHIFT(774),
  [1683] = {.count = 1, .reusable = true}, SHIFT(776),
  [1685] = {.count = 1, .reusable = true}, SHIFT(777),
  [1687] = {.count = 1, .reusable = false}, SHIFT(778),
  [1689] = {.count = 1, .reusable = false}, SHIFT(777),
  [1691] = {.count = 1, .reusable = true}, SHIFT(780),
  [1693] = {.count = 1, .reusable = false}, SHIFT(782),
  [1695] = {.count = 1, .reusable = true}, SHIFT(782),
  [1697] = {.count = 1, .reusable = true}, SHIFT(781),
  [1699] = {.count = 1, .reusable = true}, SHIFT(783),
  [1701] = {.count = 1, .reusable = false}, SHIFT(785),
  [1703] = {.count = 1, .reusable = true}, SHIFT(785),
  [1705] = {.count = 1, .reusable = true}, SHIFT(784),
  [1707] = {.count = 1, .reusable = true}, SHIFT(786),
  [1709] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1711] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(123),
  [1716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(124),
  [1719] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(125),
  [1722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(126),
  [1725] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(127),
  [1728] = {.count = 1, .reusable = true}, SHIFT(787),
  [1730] = {.count = 1, .reusable = true}, SHIFT(788),
  [1732] = {.count = 1, .reusable = true}, SHIFT(790),
  [1734] = {.count = 1, .reusable = false}, SHIFT(791),
  [1736] = {.count = 1, .reusable = true}, SHIFT(792),
  [1738] = {.count = 1, .reusable = false}, SHIFT(793),
  [1740] = {.count = 1, .reusable = true}, SHIFT(794),
  [1742] = {.count = 1, .reusable = true}, SHIFT(795),
  [1744] = {.count = 1, .reusable = true}, SHIFT(796),
  [1746] = {.count = 1, .reusable = true}, SHIFT(797),
  [1748] = {.count = 1, .reusable = true}, SHIFT(798),
  [1750] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1752] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1754] = {.count = 1, .reusable = true}, SHIFT(800),
  [1756] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1758] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1760] = {.count = 1, .reusable = false}, SHIFT(802),
  [1762] = {.count = 1, .reusable = true}, SHIFT(804),
  [1764] = {.count = 1, .reusable = true}, SHIFT(805),
  [1766] = {.count = 1, .reusable = false}, SHIFT(806),
  [1768] = {.count = 1, .reusable = false}, SHIFT(804),
  [1770] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1772] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1774] = {.count = 1, .reusable = true}, SHIFT(807),
  [1776] = {.count = 1, .reusable = true}, SHIFT(808),
  [1778] = {.count = 1, .reusable = true}, SHIFT(809),
  [1780] = {.count = 1, .reusable = false}, SHIFT(810),
  [1782] = {.count = 1, .reusable = false}, SHIFT(808),
  [1784] = {.count = 1, .reusable = true}, SHIFT(812),
  [1786] = {.count = 1, .reusable = true}, SHIFT(819),
  [1788] = {.count = 1, .reusable = false}, SHIFT(820),
  [1790] = {.count = 1, .reusable = true}, SHIFT(820),
  [1792] = {.count = 1, .reusable = true}, SHIFT(821),
  [1794] = {.count = 1, .reusable = true}, SHIFT(822),
  [1796] = {.count = 1, .reusable = false}, SHIFT(824),
  [1798] = {.count = 1, .reusable = true}, SHIFT(824),
  [1800] = {.count = 1, .reusable = true}, SHIFT(823),
  [1802] = {.count = 1, .reusable = true}, SHIFT(825),
  [1804] = {.count = 1, .reusable = false}, SHIFT(827),
  [1806] = {.count = 1, .reusable = true}, SHIFT(827),
  [1808] = {.count = 1, .reusable = true}, SHIFT(826),
  [1810] = {.count = 1, .reusable = false}, SHIFT(829),
  [1812] = {.count = 1, .reusable = true}, SHIFT(829),
  [1814] = {.count = 1, .reusable = true}, SHIFT(828),
  [1816] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1818] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1820] = {.count = 1, .reusable = true}, SHIFT(830),
  [1822] = {.count = 1, .reusable = true}, SHIFT(831),
  [1824] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1826] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1828] = {.count = 1, .reusable = true}, SHIFT(832),
  [1830] = {.count = 1, .reusable = true}, SHIFT(833),
  [1832] = {.count = 1, .reusable = true}, SHIFT(834),
  [1834] = {.count = 1, .reusable = true}, SHIFT(835),
  [1836] = {.count = 1, .reusable = true}, SHIFT(836),
  [1838] = {.count = 1, .reusable = false}, SHIFT(837),
  [1840] = {.count = 1, .reusable = false}, SHIFT(838),
  [1842] = {.count = 1, .reusable = true}, SHIFT(838),
  [1844] = {.count = 1, .reusable = true}, SHIFT(839),
  [1846] = {.count = 1, .reusable = true}, SHIFT(841),
  [1848] = {.count = 1, .reusable = false}, SHIFT(842),
  [1850] = {.count = 1, .reusable = false}, SHIFT(843),
  [1852] = {.count = 1, .reusable = true}, SHIFT(843),
  [1854] = {.count = 1, .reusable = false}, SHIFT(844),
  [1856] = {.count = 1, .reusable = false}, SHIFT(845),
  [1858] = {.count = 1, .reusable = true}, SHIFT(845),
  [1860] = {.count = 1, .reusable = true}, SHIFT(846),
  [1862] = {.count = 1, .reusable = true}, SHIFT(847),
  [1864] = {.count = 1, .reusable = false}, SHIFT(849),
  [1866] = {.count = 1, .reusable = false}, SHIFT(850),
  [1868] = {.count = 1, .reusable = true}, SHIFT(850),
  [1870] = {.count = 1, .reusable = true}, SHIFT(853),
  [1872] = {.count = 1, .reusable = true}, SHIFT(854),
  [1874] = {.count = 1, .reusable = true}, SHIFT(856),
  [1876] = {.count = 1, .reusable = false}, SHIFT(858),
  [1878] = {.count = 1, .reusable = true}, SHIFT(860),
  [1880] = {.count = 1, .reusable = true}, SHIFT(861),
  [1882] = {.count = 1, .reusable = false}, SHIFT(862),
  [1884] = {.count = 1, .reusable = false}, SHIFT(860),
  [1886] = {.count = 1, .reusable = true}, SHIFT(863),
  [1888] = {.count = 1, .reusable = true}, SHIFT(864),
  [1890] = {.count = 1, .reusable = true}, SHIFT(865),
  [1892] = {.count = 1, .reusable = false}, SHIFT(866),
  [1894] = {.count = 1, .reusable = false}, SHIFT(864),
  [1896] = {.count = 1, .reusable = true}, SHIFT(875),
  [1898] = {.count = 1, .reusable = false}, SHIFT(877),
  [1900] = {.count = 1, .reusable = true}, SHIFT(879),
  [1902] = {.count = 1, .reusable = true}, SHIFT(880),
  [1904] = {.count = 1, .reusable = false}, SHIFT(881),
  [1906] = {.count = 1, .reusable = false}, SHIFT(879),
  [1908] = {.count = 1, .reusable = true}, SHIFT(882),
  [1910] = {.count = 1, .reusable = true}, SHIFT(883),
  [1912] = {.count = 1, .reusable = true}, SHIFT(884),
  [1914] = {.count = 1, .reusable = false}, SHIFT(885),
  [1916] = {.count = 1, .reusable = false}, SHIFT(883),
  [1918] = {.count = 1, .reusable = true}, SHIFT(894),
  [1920] = {.count = 1, .reusable = false}, SHIFT(896),
  [1922] = {.count = 1, .reusable = true}, SHIFT(897),
  [1924] = {.count = 1, .reusable = true}, SHIFT(898),
  [1926] = {.count = 1, .reusable = false}, SHIFT(900),
  [1928] = {.count = 1, .reusable = true}, SHIFT(900),
  [1930] = {.count = 1, .reusable = true}, SHIFT(899),
  [1932] = {.count = 1, .reusable = true}, SHIFT(901),
  [1934] = {.count = 1, .reusable = true}, SHIFT(902),
  [1936] = {.count = 1, .reusable = false}, SHIFT(903),
  [1938] = {.count = 1, .reusable = false}, SHIFT(902),
  [1940] = {.count = 1, .reusable = true}, SHIFT(905),
  [1942] = {.count = 1, .reusable = false}, SHIFT(907),
  [1944] = {.count = 1, .reusable = true}, SHIFT(907),
  [1946] = {.count = 1, .reusable = true}, SHIFT(906),
  [1948] = {.count = 1, .reusable = true}, SHIFT(908),
  [1950] = {.count = 1, .reusable = false}, SHIFT(910),
  [1952] = {.count = 1, .reusable = true}, SHIFT(910),
  [1954] = {.count = 1, .reusable = true}, SHIFT(909),
  [1956] = {.count = 1, .reusable = true}, SHIFT(911),
  [1958] = {.count = 1, .reusable = true}, SHIFT(912),
  [1960] = {.count = 1, .reusable = true}, SHIFT(913),
  [1962] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1964] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1966] = {.count = 1, .reusable = true}, SHIFT(918),
  [1968] = {.count = 1, .reusable = false}, SHIFT(920),
  [1970] = {.count = 1, .reusable = true}, SHIFT(920),
  [1972] = {.count = 1, .reusable = false}, SHIFT(921),
  [1974] = {.count = 1, .reusable = false}, SHIFT(149),
  [1976] = {.count = 1, .reusable = false}, SHIFT(922),
  [1978] = {.count = 1, .reusable = false}, SHIFT(152),
  [1980] = {.count = 1, .reusable = false}, SHIFT(153),
  [1982] = {.count = 1, .reusable = false}, SHIFT(154),
  [1984] = {.count = 1, .reusable = false}, SHIFT(155),
  [1986] = {.count = 1, .reusable = false}, SHIFT(923),
  [1988] = {.count = 1, .reusable = true}, SHIFT(924),
  [1990] = {.count = 1, .reusable = true}, SHIFT(925),
  [1992] = {.count = 1, .reusable = true}, SHIFT(927),
  [1994] = {.count = 1, .reusable = true}, SHIFT(928),
  [1996] = {.count = 1, .reusable = true}, SHIFT(929),
  [1998] = {.count = 1, .reusable = true}, SHIFT(936),
  [2000] = {.count = 1, .reusable = true}, SHIFT(937),
  [2002] = {.count = 1, .reusable = true}, SHIFT(939),
  [2004] = {.count = 1, .reusable = true}, SHIFT(941),
  [2006] = {.count = 1, .reusable = true}, SHIFT(942),
  [2008] = {.count = 1, .reusable = true}, SHIFT(948),
  [2010] = {.count = 1, .reusable = false}, SHIFT(952),
  [2012] = {.count = 1, .reusable = true}, SHIFT(952),
  [2014] = {.count = 1, .reusable = false}, SHIFT(953),
  [2016] = {.count = 1, .reusable = false}, SHIFT(954),
  [2018] = {.count = 1, .reusable = true}, SHIFT(955),
  [2020] = {.count = 1, .reusable = true}, SHIFT(956),
  [2022] = {.count = 1, .reusable = true}, SHIFT(957),
  [2024] = {.count = 1, .reusable = true}, SHIFT(958),
  [2026] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2028] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2030] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2032] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2034] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2036] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2038] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2040] = {.count = 1, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2042] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2044] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2046] = {.count = 1, .reusable = true}, SHIFT(964),
  [2048] = {.count = 1, .reusable = false}, SHIFT(965),
  [2050] = {.count = 1, .reusable = false}, SHIFT(964),
  [2052] = {.count = 1, .reusable = true}, SHIFT(966),
  [2054] = {.count = 1, .reusable = true}, SHIFT(967),
  [2056] = {.count = 1, .reusable = true}, SHIFT(968),
  [2058] = {.count = 1, .reusable = false}, SHIFT(969),
  [2060] = {.count = 1, .reusable = false}, SHIFT(967),
  [2062] = {.count = 1, .reusable = true}, SHIFT(971),
  [2064] = {.count = 1, .reusable = true}, SHIFT(973),
  [2066] = {.count = 1, .reusable = true}, SHIFT(974),
  [2068] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2070] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2072] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2074] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2076] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2078] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2080] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2082] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2084] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(186),
  [2089] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2091] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(188),
  [2094] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(189),
  [2097] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(190),
  [2100] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(187),
  [2103] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(191),
  [2106] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(16),
  [2109] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(17),
  [2112] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(192),
  [2115] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(19),
  [2118] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2121] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(21),
  [2124] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2127] = {.count = 1, .reusable = true}, SHIFT(978),
  [2129] = {.count = 1, .reusable = true}, SHIFT(979),
  [2131] = {.count = 1, .reusable = true}, SHIFT(981),
  [2133] = {.count = 1, .reusable = false}, SHIFT(667),
  [2135] = {.count = 1, .reusable = true}, SHIFT(982),
  [2137] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [2139] = {.count = 1, .reusable = true}, SHIFT(984),
  [2141] = {.count = 1, .reusable = true}, SHIFT(985),
  [2143] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2145] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2147] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2149] = {.count = 1, .reusable = true}, SHIFT(986),
  [2151] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2153] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2155] = {.count = 1, .reusable = false}, SHIFT(988),
  [2157] = {.count = 1, .reusable = true}, SHIFT(990),
  [2159] = {.count = 1, .reusable = true}, SHIFT(991),
  [2161] = {.count = 1, .reusable = false}, SHIFT(992),
  [2163] = {.count = 1, .reusable = false}, SHIFT(990),
  [2165] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2167] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2169] = {.count = 1, .reusable = true}, SHIFT(993),
  [2171] = {.count = 1, .reusable = true}, SHIFT(994),
  [2173] = {.count = 1, .reusable = true}, SHIFT(995),
  [2175] = {.count = 1, .reusable = false}, SHIFT(996),
  [2177] = {.count = 1, .reusable = false}, SHIFT(994),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2189] = {.count = 1, .reusable = false}, SHIFT(1012),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2195] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2199] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2201] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2205] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2213] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2225] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2227] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1031),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2241] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2243] = {.count = 1, .reusable = false}, SHIFT(1033),
  [2245] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2247] = {.count = 1, .reusable = false}, SHIFT(583),
  [2249] = {.count = 1, .reusable = false}, SHIFT(584),
  [2251] = {.count = 1, .reusable = false}, SHIFT(586),
  [2253] = {.count = 1, .reusable = false}, SHIFT(587),
  [2255] = {.count = 1, .reusable = false}, SHIFT(588),
  [2257] = {.count = 1, .reusable = false}, SHIFT(589),
  [2259] = {.count = 1, .reusable = false}, SHIFT(590),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1045),
  [2265] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2267] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2269] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2271] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2273] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2277] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2279] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2281] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2283] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2285] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2287] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2291] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2293] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1056),
  [2297] = {.count = 1, .reusable = true}, SHIFT(601),
  [2299] = {.count = 1, .reusable = true}, SHIFT(602),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2307] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(224),
  [2316] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2318] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2320] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2322] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2324] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2326] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2330] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2334] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2336] = {.count = 1, .reusable = false}, SHIFT(1081),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2340] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1084),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2348] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2350] = {.count = 1, .reusable = false}, SHIFT(1086),
  [2352] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2356] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2360] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2362] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [2364] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [2366] = {.count = 1, .reusable = false}, SHIFT(1091),
  [2368] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2372] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2374] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2376] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2380] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2382] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2386] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2388] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2390] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2392] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2394] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(254),
  [2403] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(255),
  [2406] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(256),
  [2409] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(259),
  [2412] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(260),
  [2415] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2417] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2419] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(268),
  [2426] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(270),
  [2429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(271),
  [2432] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(269),
  [2435] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(272),
  [2438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(273),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2443] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(283),
  [2446] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2448] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2460] = {.count = 1, .reusable = false}, SHIFT(1126),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2468] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1131),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2486] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2490] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2494] = {.count = 1, .reusable = false}, SHIFT(1138),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2502] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2512] = {.count = 1, .reusable = false}, REDUCE(sym_bracket_command, 4),
  [2514] = {.count = 1, .reusable = true}, REDUCE(sym_bracket_command, 4),
  [2516] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(306),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2533] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2547] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(327),
  [2564] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2566] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2568] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2570] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2574] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2578] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2584] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2586] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2588] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2592] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2594] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2598] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2600] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2602] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(346),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2609] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(365),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2652] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2654] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2656] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2658] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2662] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2664] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2670] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2672] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2676] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2678] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2680] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2690] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2692] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2708] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2716] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2722] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2724] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2728] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2738] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2742] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2744] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2746] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2758] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2766] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2770] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2772] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2774] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2776] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2778] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2780] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2782] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2790] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2792] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2794] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2798] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2826] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2828] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(820),
  [2831] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(403),
  [2834] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(404),
  [2837] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(405),
  [2840] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(406),
  [2843] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(820),
  [2846] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(407),
  [2849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(409),
  [2852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(410),
  [2855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(411),
  [2858] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(406),
  [2861] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2865] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2867] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2869] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2873] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2875] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2889] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2891] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2905] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2907] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2913] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2925] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2933] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2965] = {.count = 1, .reusable = false}, SHIFT(1341),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2975] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(437),
  [3002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(438),
  [3005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(439),
  [3008] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(440),
  [3011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(441),
  [3014] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(442),
  [3017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(443),
  [3020] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(444),
  [3023] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(445),
  [3026] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(446),
  [3029] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(441),
  [3032] = {.count = 1, .reusable = true}, SHIFT(1354),
  [3034] = {.count = 1, .reusable = false}, SHIFT(1356),
  [3036] = {.count = 1, .reusable = true}, SHIFT(1357),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1358),
  [3040] = {.count = 1, .reusable = false}, SHIFT(1360),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1360),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1359),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1361),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3050] = {.count = 1, .reusable = false}, SHIFT(1363),
  [3052] = {.count = 1, .reusable = false}, SHIFT(1362),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3056] = {.count = 1, .reusable = false}, SHIFT(1367),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3064] = {.count = 1, .reusable = false}, SHIFT(1370),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3070] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3074] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(449),
  [3077] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(450),
  [3080] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(451),
  [3083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(452),
  [3086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(453),
  [3089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(454),
  [3092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(455),
  [3095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(456),
  [3098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(457),
  [3101] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(452),
  [3104] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(459),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1374),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1375),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1378),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1379),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1380),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3129] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1387),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(483),
  [3156] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(485),
  [3159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(485),
  [3162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(486),
  [3165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(486),
  [3168] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(487),
  [3171] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(484),
  [3174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(488),
  [3177] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(149),
  [3180] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(150),
  [3183] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(489),
  [3186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(152),
  [3189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(153),
  [3192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(154),
  [3195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(155),
  [3198] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(489),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3203] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3205] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1405),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3221] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(500),
  [3224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(501),
  [3227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(502),
  [3230] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(502),
  [3233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(505),
  [3236] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(506),
  [3239] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(506),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(512),
  [3249] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(514),
  [3252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(514),
  [3255] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(515),
  [3258] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(513),
  [3261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(516),
  [3264] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(517),
  [3267] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(517),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3274] = {.count = 1, .reusable = false}, SHIFT(1421),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3280] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3284] = {.count = 1, .reusable = false}, SHIFT(1424),
  [3286] = {.count = 1, .reusable = false}, SHIFT(1423),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1428),
  [3292] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3296] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3298] = {.count = 1, .reusable = false}, SHIFT(1431),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3304] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3306] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(527),
  [3311] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3313] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(529),
  [3316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(530),
  [3319] = {.count = 1, .reusable = false}, REDUCE(sym_command, 4),
  [3321] = {.count = 1, .reusable = true}, REDUCE(sym_command, 4),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3325] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3329] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3339] = {.count = 1, .reusable = false}, SHIFT(1442),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1445),
  [3351] = {.count = 1, .reusable = false}, SHIFT(1444),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3373] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3375] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3377] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(556),
  [3382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(557),
  [3385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(558),
  [3388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(559),
  [3391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(560),
  [3394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(561),
  [3397] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(562),
  [3400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(563),
  [3403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(565),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3408] = {.count = 1, .reusable = false}, SHIFT(1456),
  [3410] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3416] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3418] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3420] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3428] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3430] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3434] = {.count = 1, .reusable = false}, SHIFT(1469),
  [3436] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3438] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3440] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3444] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3446] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3448] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3452] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3454] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3460] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3464] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3478] = {.count = 1, .reusable = false}, SHIFT(1489),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3484] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3486] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3488] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3490] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(583),
  [3493] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(584),
  [3496] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(585),
  [3499] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(586),
  [3502] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(587),
  [3505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(588),
  [3508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(589),
  [3511] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(590),
  [3514] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3516] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3518] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3520] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [3522] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3524] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3528] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3530] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3532] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3534] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3536] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3540] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3542] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(601),
  [3545] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3547] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3557] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3559] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3561] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3573] = {.count = 1, .reusable = false}, SHIFT(1517),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3577] = {.count = 1, .reusable = false}, SHIFT(1518),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3593] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3599] = {.count = 1, .reusable = false}, SHIFT(1529),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3603] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3605] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3607] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3609] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3615] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3623] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3629] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3635] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3637] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3645] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3649] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1560),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3671] = {.count = 1, .reusable = false}, SHIFT(1562),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3681] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3687] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3689] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3695] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3697] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3699] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3701] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(686),
  [3704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(687),
  [3707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(688),
  [3710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(689),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3719] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3723] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3739] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3745] = {.count = 1, .reusable = false}, SHIFT(1599),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1604),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1605),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3777] = {.count = 1, .reusable = false}, SHIFT(1614),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3783] = {.count = 1, .reusable = false}, SHIFT(1616),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3793] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3819] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3829] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3833] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3837] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3849] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1648),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3865] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3867] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3869] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3881] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3885] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3891] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3893] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3899] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3903] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3905] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3909] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3911] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3913] = {.count = 1, .reusable = false}, SHIFT(1671),
  [3915] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3917] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3921] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3923] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3927] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3933] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3935] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3939] = {.count = 1, .reusable = false}, SHIFT(1682),
  [3941] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3943] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3947] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3953] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(800),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3962] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3974] = {.count = 1, .reusable = false}, SHIFT(1697),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1700),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1705),
  [4000] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4002] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1706),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1707),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1708),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1709),
  [4012] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1710),
  [4016] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4018] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1711),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1712),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4026] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4028] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1713),
  [4032] = {.count = 1, .reusable = false}, SHIFT(1714),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1714),
  [4036] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4038] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1715),
  [4042] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4044] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1716),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4050] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1719),
  [4054] = {.count = 1, .reusable = false}, SHIFT(1720),
  [4056] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1724),
  [4062] = {.count = 1, .reusable = false}, SHIFT(1727),
  [4064] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4066] = {.count = 1, .reusable = true}, SHIFT(1730),
  [4068] = {.count = 1, .reusable = false}, SHIFT(1731),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1734),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1734),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1736),
  [4076] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1737),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1738),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1741),
  [4086] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1742),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1743),
  [4092] = {.count = 1, .reusable = true}, SHIFT(1744),
  [4094] = {.count = 1, .reusable = false}, SHIFT(1745),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1746),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1747),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1748),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1749),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1750),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4114] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(856),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1764),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1766),
  [4131] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4133] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4145] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4147] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(875),
  [4160] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4162] = {.count = 1, .reusable = false}, SHIFT(1778),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4168] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4174] = {.count = 1, .reusable = false}, SHIFT(1786),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1791),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4210] = {.count = 1, .reusable = false}, SHIFT(1799),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4216] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4226] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4228] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4232] = {.count = 1, .reusable = false}, SHIFT(1810),
  [4234] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4236] = {.count = 1, .reusable = false}, SHIFT(1816),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4242] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4244] = {.count = 1, .reusable = false}, SHIFT(1819),
  [4246] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4248] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4250] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4254] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4256] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4258] = {.count = 1, .reusable = false}, SHIFT(1827),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4264] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4266] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4268] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4270] = {.count = 1, .reusable = false}, SHIFT(1835),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4276] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4278] = {.count = 1, .reusable = false}, SHIFT(1838),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1840),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4296] = {.count = 1, .reusable = false}, REDUCE(sym_command, 5),
  [4298] = {.count = 1, .reusable = true}, REDUCE(sym_command, 5),
  [4300] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4302] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(986),
  [4307] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4309] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4311] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4315] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4317] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4319] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4321] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4323] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4325] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4329] = {.count = 1, .reusable = false}, SHIFT(1856),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4333] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4335] = {.count = 1, .reusable = false}, SHIFT(1858),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4353] = {.count = 1, .reusable = false}, SHIFT(1865),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4357] = {.count = 1, .reusable = false}, SHIFT(1866),
  [4359] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4365] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4373] = {.count = 1, .reusable = false}, SHIFT(1875),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4383] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1025),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4388] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4392] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4400] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4402] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4408] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4410] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4414] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4418] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4420] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4422] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4426] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4428] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4430] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4432] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4434] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4436] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4438] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4440] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4442] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4444] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4446] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4450] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4452] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4454] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4456] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4458] = {.count = 1, .reusable = false}, SHIFT(1908),
  [4460] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4464] = {.count = 1, .reusable = false}, SHIFT(1911),
  [4466] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4472] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4474] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4476] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4480] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4482] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4484] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4486] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4488] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4492] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1934),
  [4495] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(80),
  [4498] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(81),
  [4501] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1935),
  [4504] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(83),
  [4507] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(84),
  [4510] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(85),
  [4513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(86),
  [4516] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4518] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4520] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4522] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4526] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4528] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4532] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4534] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4538] = {.count = 1, .reusable = false}, SHIFT(1944),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4544] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4550] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4558] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [4560] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1103),
  [4573] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1104),
  [4576] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1105),
  [4579] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4581] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4583] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4585] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4587] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4591] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4593] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4595] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4597] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4599] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4601] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4603] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4605] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4607] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4609] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4611] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4613] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4615] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4617] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4619] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4621] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4623] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4625] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4627] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4629] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4631] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4633] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4635] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4637] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4639] = {.count = 1, .reusable = false}, SHIFT(1985),
  [4641] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4645] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4647] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4649] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4651] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4653] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4655] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4657] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4659] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4661] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4663] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4665] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4667] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4669] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4671] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4673] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4675] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4677] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4685] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4691] = {.count = 1, .reusable = false}, SHIFT(2005),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4697] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4713] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4719] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4721] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4725] = {.count = 1, .reusable = false}, SHIFT(2018),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4741] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4747] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4749] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4753] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4755] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4769] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4773] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4775] = {.count = 1, .reusable = false}, SHIFT(2038),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4781] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4783] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4791] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4795] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1247),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4802] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4806] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4814] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4822] = {.count = 1, .reusable = false}, SHIFT(2057),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4828] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4830] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4838] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4846] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4850] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4862] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4866] = {.count = 1, .reusable = false}, SHIFT(2076),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4872] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4876] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4878] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4880] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4882] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4884] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4886] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4888] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4890] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4894] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4896] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4900] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4902] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4904] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4906] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4908] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4910] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4912] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4914] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4918] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4920] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4924] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4936] = {.count = 1, .reusable = false}, SHIFT(2104),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4942] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4944] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4946] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4952] = {.count = 1, .reusable = false}, SHIFT(2112),
  [4954] = {.count = 1, .reusable = false}, SHIFT(2110),
  [4956] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1326),
  [4959] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1327),
  [4962] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1327),
  [4965] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1328),
  [4968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1328),
  [4971] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1329),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4976] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4978] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4982] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4984] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4986] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4990] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4992] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2132),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2133),
  [5002] = {.count = 1, .reusable = false}, SHIFT(2134),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2135),
  [5008] = {.count = 1, .reusable = false}, SHIFT(2136),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2136),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2137),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5018] = {.count = 1, .reusable = false}, SHIFT(2140),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5022] = {.count = 1, .reusable = false}, SHIFT(2141),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2144),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5032] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5038] = {.count = 1, .reusable = false}, SHIFT(2150),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5042] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5044] = {.count = 1, .reusable = false}, SHIFT(2152),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5048] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2155),
  [5054] = {.count = 1, .reusable = true}, SHIFT(2156),
  [5056] = {.count = 1, .reusable = false}, SHIFT(2157),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2157),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5062] = {.count = 1, .reusable = false}, SHIFT(2159),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5066] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5068] = {.count = 1, .reusable = false}, SHIFT(2161),
  [5070] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2162),
  [5074] = {.count = 1, .reusable = true}, SHIFT(2163),
  [5076] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5080] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1404),
  [5087] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1405),
  [5090] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1405),
  [5093] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1406),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2170),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2171),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5102] = {.count = 1, .reusable = false}, SHIFT(2173),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5106] = {.count = 1, .reusable = false}, SHIFT(2174),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5122] = {.count = 1, .reusable = false}, SHIFT(2183),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5128] = {.count = 1, .reusable = false}, SHIFT(2185),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5138] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5142] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5150] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5158] = {.count = 1, .reusable = false}, SHIFT(2199),
  [5160] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5164] = {.count = 1, .reusable = false}, SHIFT(2201),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5172] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5176] = {.count = 1, .reusable = false}, SHIFT(2206),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5182] = {.count = 1, .reusable = false}, SHIFT(2208),
  [5184] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5188] = {.count = 1, .reusable = false}, SHIFT(2210),
  [5190] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5196] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5202] = {.count = 1, .reusable = false}, SHIFT(2216),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5206] = {.count = 1, .reusable = false}, SHIFT(2217),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5222] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5228] = {.count = 1, .reusable = false}, SHIFT(2228),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5232] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [5234] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [5236] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [5238] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [5240] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5244] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5246] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5248] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5252] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5254] = {.count = 1, .reusable = false}, SHIFT(2236),
  [5256] = {.count = 1, .reusable = false}, SHIFT(2237),
  [5258] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5260] = {.count = 1, .reusable = false}, SHIFT(2239),
  [5262] = {.count = 1, .reusable = false}, SHIFT(2240),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2241),
  [5266] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5268] = {.count = 1, .reusable = false}, SHIFT(2243),
  [5270] = {.count = 1, .reusable = false}, SHIFT(2244),
  [5272] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5274] = {.count = 1, .reusable = false}, SHIFT(2248),
  [5276] = {.count = 1, .reusable = false}, SHIFT(2249),
  [5278] = {.count = 1, .reusable = false}, SHIFT(2250),
  [5280] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5282] = {.count = 1, .reusable = false}, SHIFT(2252),
  [5284] = {.count = 1, .reusable = false}, SHIFT(2253),
  [5286] = {.count = 1, .reusable = false}, SHIFT(2254),
  [5288] = {.count = 1, .reusable = false}, SHIFT(2255),
  [5290] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5292] = {.count = 1, .reusable = false}, SHIFT(2259),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2263),
  [5300] = {.count = 1, .reusable = false}, SHIFT(2261),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5310] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5312] = {.count = 1, .reusable = false}, SHIFT(2275),
  [5314] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5316] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2279),
  [5322] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5326] = {.count = 1, .reusable = false}, SHIFT(2281),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2282),
  [5330] = {.count = 1, .reusable = false}, SHIFT(2283),
  [5332] = {.count = 1, .reusable = false}, SHIFT(2284),
  [5334] = {.count = 1, .reusable = false}, SHIFT(1910),
  [5336] = {.count = 1, .reusable = false}, SHIFT(2285),
  [5338] = {.count = 1, .reusable = false}, SHIFT(1913),
  [5340] = {.count = 1, .reusable = false}, SHIFT(1914),
  [5342] = {.count = 1, .reusable = false}, SHIFT(1915),
  [5344] = {.count = 1, .reusable = false}, SHIFT(1916),
  [5346] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5348] = {.count = 1, .reusable = true}, SHIFT(1909),
  [5350] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1499),
  [5353] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [5355] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [5357] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [5359] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5363] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5365] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5373] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5375] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1566),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5400] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5404] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5408] = {.count = 1, .reusable = false}, SHIFT(2323),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5416] = {.count = 1, .reusable = false}, SHIFT(2326),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5420] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5422] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5424] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5432] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5442] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5462] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5464] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [5466] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5474] = {.count = 1, .reusable = false}, SHIFT(2350),
  [5476] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5478] = {.count = 1, .reusable = false}, SHIFT(2351),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5494] = {.count = 1, .reusable = false}, SHIFT(2360),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5500] = {.count = 1, .reusable = false}, SHIFT(2362),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5504] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5508] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5510] = {.count = 1, .reusable = true}, SHIFT(2366),
  [5512] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5516] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5518] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5524] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5526] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5530] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5532] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5534] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5536] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5538] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5540] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5542] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5544] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5550] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5552] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5558] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5562] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5566] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5568] = {.count = 1, .reusable = false}, SHIFT(2389),
  [5570] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5574] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5582] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5588] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5600] = {.count = 1, .reusable = false}, SHIFT(2403),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5604] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5606] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5612] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5624] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5628] = {.count = 1, .reusable = false}, SHIFT(2414),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5634] = {.count = 1, .reusable = false}, SHIFT(2416),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5640] = {.count = 1, .reusable = false}, SHIFT(2418),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5662] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5668] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5674] = {.count = 1, .reusable = false}, SHIFT(2434),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5684] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5688] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2441),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5696] = {.count = 1, .reusable = false}, SHIFT(2443),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5702] = {.count = 1, .reusable = false}, SHIFT(2445),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5708] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5712] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5720] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5724] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5730] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5732] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5736] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2466),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5770] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5772] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2484),
  [5782] = {.count = 1, .reusable = false}, SHIFT(2482),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5790] = {.count = 1, .reusable = false}, SHIFT(2488),
  [5792] = {.count = 1, .reusable = false}, SHIFT(2486),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5796] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5800] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5806] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5812] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5814] = {.count = 1, .reusable = false}, SHIFT(2507),
  [5816] = {.count = 1, .reusable = false}, SHIFT(2505),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5820] = {.count = 1, .reusable = false}, SHIFT(2518),
  [5822] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2522),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5836] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5838] = {.count = 1, .reusable = false}, SHIFT(2524),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5842] = {.count = 1, .reusable = false}, SHIFT(2529),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5846] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5850] = {.count = 1, .reusable = false}, SHIFT(2532),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5858] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5862] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5864] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5866] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5868] = {.count = 1, .reusable = false}, SHIFT(2539),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5872] = {.count = 1, .reusable = false}, SHIFT(2540),
  [5874] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5876] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5878] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5882] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5890] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5898] = {.count = 1, .reusable = false}, SHIFT(2556),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5902] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5904] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5906] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5908] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5910] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5912] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5914] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5920] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5922] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5924] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5926] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5928] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5930] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5932] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5934] = {.count = 1, .reusable = false}, SHIFT(2580),
  [5936] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5938] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5942] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5954] = {.count = 1, .reusable = false}, SHIFT(2590),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5960] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5968] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2597),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5978] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5980] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5982] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5984] = {.count = 1, .reusable = false}, SHIFT(2601),
  [5986] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5990] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5994] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2607),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2608),
  [6002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2102),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6007] = {.count = 1, .reusable = false}, SHIFT(2610),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2611),
  [6011] = {.count = 1, .reusable = true}, SHIFT(2613),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6019] = {.count = 1, .reusable = false}, SHIFT(2618),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2618),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2617),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6027] = {.count = 1, .reusable = false}, SHIFT(2621),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2621),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2620),
  [6033] = {.count = 1, .reusable = false}, SHIFT(2623),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2623),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2622),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2624),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2626),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2627),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2633),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2637),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6079] = {.count = 1, .reusable = false}, SHIFT(2646),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6085] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6087] = {.count = 1, .reusable = false}, SHIFT(2648),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2654),
  [6097] = {.count = 1, .reusable = false}, SHIFT(2652),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6103] = {.count = 1, .reusable = false}, SHIFT(2665),
  [6105] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6107] = {.count = 1, .reusable = false}, SHIFT(2667),
  [6109] = {.count = 1, .reusable = false}, SHIFT(2668),
  [6111] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6115] = {.count = 1, .reusable = true}, SHIFT(2672),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2673),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2240),
  [6121] = {.count = 1, .reusable = true}, SHIFT(2241),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2242),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2243),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2674),
  [6129] = {.count = 1, .reusable = false}, SHIFT(2676),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2678),
  [6135] = {.count = 1, .reusable = false}, SHIFT(2680),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6145] = {.count = 1, .reusable = false}, SHIFT(2683),
  [6147] = {.count = 1, .reusable = false}, SHIFT(2682),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2685),
  [6151] = {.count = 1, .reusable = false}, SHIFT(2687),
  [6153] = {.count = 1, .reusable = true}, SHIFT(2687),
  [6155] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6157] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6159] = {.count = 1, .reusable = false}, SHIFT(2690),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6163] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6169] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2235),
  [6172] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2236),
  [6175] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2237),
  [6178] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2238),
  [6181] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2239),
  [6184] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2240),
  [6187] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2241),
  [6190] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2242),
  [6193] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2243),
  [6196] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2244),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2251),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2252),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2253),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2254),
  [6209] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6215] = {.count = 1, .reusable = false}, SHIFT(2699),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6225] = {.count = 1, .reusable = false}, SHIFT(2702),
  [6227] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6231] = {.count = 1, .reusable = false}, SHIFT(2706),
  [6233] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6235] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6239] = {.count = 1, .reusable = false}, SHIFT(2709),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6243] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6249] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2247),
  [6252] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2248),
  [6255] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2249),
  [6258] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2250),
  [6261] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2251),
  [6264] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2252),
  [6267] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2253),
  [6270] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2254),
  [6273] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2255),
  [6276] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2257),
  [6279] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6281] = {.count = 1, .reusable = false}, SHIFT(2713),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6293] = {.count = 1, .reusable = false}, SHIFT(2721),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6303] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6307] = {.count = 1, .reusable = false}, SHIFT(2726),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2735),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6331] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6333] = {.count = 1, .reusable = false}, SHIFT(2737),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6341] = {.count = 1, .reusable = false}, SHIFT(2743),
  [6343] = {.count = 1, .reusable = false}, SHIFT(2741),
  [6345] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2280),
  [6348] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2282),
  [6351] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2283),
  [6354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2281),
  [6357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2284),
  [6360] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1910),
  [6363] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1911),
  [6366] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2285),
  [6369] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1913),
  [6372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1914),
  [6375] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1915),
  [6378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1916),
  [6381] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [6383] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6385] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6387] = {.count = 1, .reusable = false}, SHIFT(2752),
  [6389] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [6391] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [6393] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [6395] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6397] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6401] = {.count = 1, .reusable = false}, SHIFT(2760),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6405] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6407] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6409] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6413] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6419] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6423] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6425] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6445] = {.count = 1, .reusable = false}, SHIFT(2782),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6449] = {.count = 1, .reusable = false}, SHIFT(2783),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6465] = {.count = 1, .reusable = false}, SHIFT(2792),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6471] = {.count = 1, .reusable = false}, SHIFT(2794),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2798),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6485] = {.count = 1, .reusable = false}, SHIFT(2802),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6495] = {.count = 1, .reusable = false}, SHIFT(2805),
  [6497] = {.count = 1, .reusable = false}, SHIFT(2804),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6501] = {.count = 1, .reusable = false}, SHIFT(2809),
  [6503] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6505] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6507] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6509] = {.count = 1, .reusable = false}, SHIFT(2812),
  [6511] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6513] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6517] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6519] = {.count = 1, .reusable = false}, SHIFT(2816),
  [6521] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6525] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6527] = {.count = 1, .reusable = false}, SHIFT(2819),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6533] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6535] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6537] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6539] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6543] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6547] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2478),
  [6556] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6558] = {.count = 1, .reusable = false}, SHIFT(2834),
  [6560] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6562] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6566] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6570] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6572] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6574] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6576] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6578] = {.count = 1, .reusable = false}, SHIFT(2845),
  [6580] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6582] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6584] = {.count = 1, .reusable = false}, SHIFT(2847),
  [6586] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6588] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6590] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6592] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6594] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6596] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2497),
  [6599] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6601] = {.count = 1, .reusable = false}, SHIFT(2852),
  [6603] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6605] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6607] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6609] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6611] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6613] = {.count = 1, .reusable = false}, SHIFT(2860),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6617] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6619] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6621] = {.count = 1, .reusable = false}, SHIFT(2863),
  [6623] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6625] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6627] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6629] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6633] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6635] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6637] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6639] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6641] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6643] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6645] = {.count = 1, .reusable = false}, SHIFT(2872),
  [6647] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6649] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6651] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6653] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6655] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6657] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6659] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6661] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6663] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6665] = {.count = 1, .reusable = false}, SHIFT(2882),
  [6667] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6669] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6671] = {.count = 1, .reusable = false}, SHIFT(2884),
  [6673] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6675] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6677] = {.count = 1, .reusable = false}, SHIFT(2887),
  [6679] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6681] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6683] = {.count = 1, .reusable = false}, SHIFT(2891),
  [6685] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6687] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6689] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6691] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6693] = {.count = 1, .reusable = false}, SHIFT(2894),
  [6695] = {.count = 1, .reusable = false}, SHIFT(2893),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6699] = {.count = 1, .reusable = false}, SHIFT(2898),
  [6701] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6705] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6707] = {.count = 1, .reusable = false}, SHIFT(2901),
  [6709] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6711] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6715] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6717] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6719] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6721] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6723] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6725] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6727] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6729] = {.count = 1, .reusable = false}, SHIFT(2904),
  [6731] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6733] = {.count = 1, .reusable = false}, SHIFT(2908),
  [6735] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6737] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6739] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6743] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6745] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6747] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6749] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6751] = {.count = 1, .reusable = false}, SHIFT(2919),
  [6753] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6755] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6757] = {.count = 1, .reusable = false}, SHIFT(2921),
  [6759] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6761] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6763] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6765] = {.count = 1, .reusable = true}, SHIFT(2923),
  [6767] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6769] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6771] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2644),
  [6774] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6776] = {.count = 1, .reusable = false}, SHIFT(2927),
  [6778] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6780] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6782] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6784] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6786] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6788] = {.count = 1, .reusable = false}, SHIFT(2935),
  [6790] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6792] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6794] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6796] = {.count = 1, .reusable = false}, SHIFT(2938),
  [6798] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6800] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6802] = {.count = 1, .reusable = false}, SHIFT(2940),
  [6804] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6806] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6808] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6810] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6812] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6814] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6816] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6818] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6820] = {.count = 1, .reusable = false}, SHIFT(2948),
  [6822] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6824] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6826] = {.count = 1, .reusable = false}, SHIFT(2952),
  [6828] = {.count = 1, .reusable = false}, SHIFT(2950),
  [6830] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6832] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6834] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6836] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6838] = {.count = 1, .reusable = false}, SHIFT(2954),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6842] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6844] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2666),
  [6847] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2667),
  [6850] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2668),
  [6853] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6855] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6857] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6859] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6861] = {.count = 1, .reusable = false}, SHIFT(2971),
  [6863] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6865] = {.count = 1, .reusable = false}, SHIFT(2972),
  [6867] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6869] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6871] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6873] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6875] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6877] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6879] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6881] = {.count = 1, .reusable = false}, SHIFT(2981),
  [6883] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6885] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6887] = {.count = 1, .reusable = false}, SHIFT(2983),
  [6889] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6891] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6893] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6895] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6897] = {.count = 1, .reusable = false}, SHIFT(2987),
  [6899] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6901] = {.count = 1, .reusable = false}, SHIFT(2988),
  [6903] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6905] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6907] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6909] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6911] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6913] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6915] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6917] = {.count = 1, .reusable = false}, SHIFT(2997),
  [6919] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6921] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6923] = {.count = 1, .reusable = false}, SHIFT(2999),
  [6925] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3001),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6933] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6935] = {.count = 1, .reusable = false}, SHIFT(3004),
  [6937] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6939] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6941] = {.count = 1, .reusable = false}, SHIFT(3006),
  [6943] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6945] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6947] = {.count = 1, .reusable = false}, SHIFT(3008),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6955] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2733),
  [6958] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6960] = {.count = 1, .reusable = false}, SHIFT(3012),
  [6962] = {.count = 1, .reusable = true}, SHIFT(3013),
  [6964] = {.count = 1, .reusable = true}, SHIFT(3015),
  [6966] = {.count = 1, .reusable = true}, SHIFT(3016),
  [6968] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6970] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6972] = {.count = 1, .reusable = false}, SHIFT(3020),
  [6974] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6976] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6978] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6980] = {.count = 1, .reusable = false}, SHIFT(3023),
  [6982] = {.count = 1, .reusable = true}, SHIFT(3023),
  [6984] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6986] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6988] = {.count = 1, .reusable = true}, SHIFT(3025),
  [6990] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6992] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6994] = {.count = 1, .reusable = true}, SHIFT(3027),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6998] = {.count = 1, .reusable = false}, SHIFT(3029),
  [7000] = {.count = 1, .reusable = false}, SHIFT(3030),
  [7002] = {.count = 1, .reusable = true}, SHIFT(3031),
  [7004] = {.count = 1, .reusable = true}, SHIFT(3032),
  [7006] = {.count = 1, .reusable = true}, SHIFT(3033),
  [7008] = {.count = 1, .reusable = true}, SHIFT(3034),
  [7010] = {.count = 1, .reusable = true}, SHIFT(3035),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3036),
  [7014] = {.count = 1, .reusable = false}, SHIFT(3037),
  [7016] = {.count = 1, .reusable = true}, SHIFT(3037),
  [7018] = {.count = 1, .reusable = false}, SHIFT(3038),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3039),
  [7022] = {.count = 1, .reusable = true}, SHIFT(3041),
  [7024] = {.count = 1, .reusable = true}, SHIFT(3042),
  [7026] = {.count = 1, .reusable = true}, SHIFT(3043),
  [7028] = {.count = 1, .reusable = true}, SHIFT(3044),
  [7030] = {.count = 1, .reusable = true}, SHIFT(3045),
  [7032] = {.count = 1, .reusable = true}, SHIFT(3046),
  [7034] = {.count = 1, .reusable = false}, SHIFT(3047),
  [7036] = {.count = 1, .reusable = true}, SHIFT(3047),
  [7038] = {.count = 1, .reusable = true}, SHIFT(3048),
  [7040] = {.count = 1, .reusable = false}, SHIFT(3049),
  [7042] = {.count = 1, .reusable = true}, SHIFT(3049),
  [7044] = {.count = 1, .reusable = true}, SHIFT(3050),
  [7046] = {.count = 1, .reusable = false}, SHIFT(3052),
  [7048] = {.count = 1, .reusable = true}, SHIFT(3053),
  [7050] = {.count = 1, .reusable = true}, SHIFT(3054),
  [7052] = {.count = 1, .reusable = false}, SHIFT(3056),
  [7054] = {.count = 1, .reusable = true}, SHIFT(3056),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3055),
  [7058] = {.count = 1, .reusable = true}, SHIFT(3057),
  [7060] = {.count = 1, .reusable = true}, SHIFT(3058),
  [7062] = {.count = 1, .reusable = false}, SHIFT(3059),
  [7064] = {.count = 1, .reusable = false}, SHIFT(3058),
  [7066] = {.count = 1, .reusable = true}, SHIFT(3061),
  [7068] = {.count = 1, .reusable = false}, SHIFT(3063),
  [7070] = {.count = 1, .reusable = true}, SHIFT(3063),
  [7072] = {.count = 1, .reusable = true}, SHIFT(3062),
  [7074] = {.count = 1, .reusable = true}, SHIFT(3064),
  [7076] = {.count = 1, .reusable = false}, SHIFT(3066),
  [7078] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3065),
  [7082] = {.count = 1, .reusable = true}, SHIFT(3067),
  [7084] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7086] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7088] = {.count = 1, .reusable = true}, SHIFT(3071),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3072),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3073),
  [7094] = {.count = 1, .reusable = false}, SHIFT(3074),
  [7096] = {.count = 1, .reusable = true}, SHIFT(3074),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7100] = {.count = 1, .reusable = false}, SHIFT(3076),
  [7102] = {.count = 1, .reusable = true}, SHIFT(3076),
  [7104] = {.count = 1, .reusable = true}, SHIFT(3077),
  [7106] = {.count = 1, .reusable = false}, SHIFT(3078),
  [7108] = {.count = 1, .reusable = true}, SHIFT(3078),
  [7110] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3080),
  [7114] = {.count = 1, .reusable = true}, SHIFT(3081),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3082),
  [7118] = {.count = 1, .reusable = true}, SHIFT(3083),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3084),
  [7122] = {.count = 1, .reusable = false}, SHIFT(3085),
  [7124] = {.count = 1, .reusable = true}, SHIFT(3085),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3086),
  [7128] = {.count = 1, .reusable = false}, SHIFT(3087),
  [7130] = {.count = 1, .reusable = true}, SHIFT(3087),
  [7132] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7134] = {.count = 1, .reusable = false}, SHIFT(3089),
  [7136] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7140] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7142] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7144] = {.count = 1, .reusable = true}, SHIFT(3093),
  [7146] = {.count = 1, .reusable = true}, SHIFT(3094),
  [7148] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7150] = {.count = 1, .reusable = true}, SHIFT(3096),
  [7152] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7154] = {.count = 1, .reusable = false}, SHIFT(3098),
  [7156] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7158] = {.count = 1, .reusable = false}, SHIFT(3099),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3100),
  [7162] = {.count = 1, .reusable = true}, SHIFT(3102),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3103),
  [7166] = {.count = 1, .reusable = true}, SHIFT(3104),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7174] = {.count = 1, .reusable = false}, SHIFT(3108),
  [7176] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7180] = {.count = 1, .reusable = false}, SHIFT(3110),
  [7182] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3112),
  [7188] = {.count = 1, .reusable = true}, SHIFT(3113),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3114),
  [7192] = {.count = 1, .reusable = false}, SHIFT(3115),
  [7194] = {.count = 1, .reusable = true}, SHIFT(3115),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3116),
  [7198] = {.count = 1, .reusable = false}, SHIFT(3117),
  [7200] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7204] = {.count = 1, .reusable = false}, SHIFT(3119),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7208] = {.count = 1, .reusable = true}, SHIFT(3120),
  [7210] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7212] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2946),
  [7215] = {.count = 1, .reusable = true}, SHIFT(3122),
  [7217] = {.count = 1, .reusable = false}, SHIFT(3123),
  [7219] = {.count = 1, .reusable = true}, SHIFT(3124),
  [7221] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3127),
  [7225] = {.count = 1, .reusable = true}, SHIFT(3128),
  [7227] = {.count = 1, .reusable = true}, SHIFT(3129),
  [7229] = {.count = 1, .reusable = false}, SHIFT(3131),
  [7231] = {.count = 1, .reusable = true}, SHIFT(3131),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3130),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3132),
  [7237] = {.count = 1, .reusable = false}, SHIFT(3134),
  [7239] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7243] = {.count = 1, .reusable = false}, SHIFT(3136),
  [7245] = {.count = 1, .reusable = true}, SHIFT(3136),
  [7247] = {.count = 1, .reusable = true}, SHIFT(3135),
  [7249] = {.count = 1, .reusable = true}, SHIFT(3137),
  [7251] = {.count = 1, .reusable = true}, SHIFT(3138),
  [7253] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7255] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7257] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7259] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7263] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7275] = {.count = 1, .reusable = false}, SHIFT(3150),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7279] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7281] = {.count = 1, .reusable = false}, SHIFT(3152),
  [7283] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7285] = {.count = 1, .reusable = true}, SHIFT(3153),
  [7287] = {.count = 1, .reusable = false}, SHIFT(3154),
  [7289] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7291] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7293] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7295] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7297] = {.count = 1, .reusable = true}, SHIFT(3158),
  [7299] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7301] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7303] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7305] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7307] = {.count = 1, .reusable = false}, SHIFT(3163),
  [7309] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7311] = {.count = 1, .reusable = false}, SHIFT(3164),
  [7313] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7315] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7317] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7319] = {.count = 1, .reusable = true}, SHIFT(3169),
  [7321] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7323] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7325] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7327] = {.count = 1, .reusable = false}, SHIFT(3173),
  [7329] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7331] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7333] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7335] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7339] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7341] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3179),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7349] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7351] = {.count = 1, .reusable = false}, SHIFT(3183),
  [7353] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7355] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7357] = {.count = 1, .reusable = false}, SHIFT(3185),
  [7359] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7361] = {.count = 1, .reusable = true}, SHIFT(3186),
  [7363] = {.count = 1, .reusable = false}, SHIFT(3187),
  [7365] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7367] = {.count = 1, .reusable = true}, SHIFT(3188),
  [7369] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7371] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7373] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7375] = {.count = 1, .reusable = true}, SHIFT(3192),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
